﻿// Generated by Construct 2, the HTML5 game and app creator :: http://www.scirra.com
//////////////////////////////////////
// COCOONJS.JS                      //
//////////////////////////////////////

(function()
{
	// There should not be a CocoonJS object when this code is executed.
	// if (typeof window.CocoonJS !== 'undefined') throw("This is strange, a CocoonJS object already exists when trying to create it.");

    /**
    * The basic object for all the CocoonJS related specific APIs === extensions.
    * @namespace
    */
    CocoonJS = window.CocoonJS ? window.CocoonJS : {};

	CocoonJS.nativeExtensionObjectAvailable = typeof window.ext !== 'undefined';

	/**
	* This type represents a 2D size structure with horizontal and vertical values.
	* @namespace
	*/
	CocoonJS.Size = {
		/**
		* The horizontal size value.
		*/
		width : 0,

		/**
		* The vertical size value.
		*/
		height : 0
	};

	/**
	* This utility function allows to create an object oriented like hierarchy between two functions using their prototypes.
	* This function adds a "superclass" and a "__super" attributes to the subclass and it's functions to reference the super class.
	* @param {function} subc The subclass function.
	* @param {function} superc The superclass function.
	*/
	CocoonJS.extend = function(subc, superc) {
	    var subcp = subc.prototype;

	    // Class pattern.
	    var CocoonJSExtendHierarchyChainClass = function() {};
	    CocoonJSExtendHierarchyChainClass.prototype = superc.prototype;

	    subc.prototype = new CocoonJSExtendHierarchyChainClass();       // chain prototypes.
	    subc.superclass = superc.prototype;
	    subc.prototype.constructor = subc;

	    // Reset constructor. See Object Oriented Javascript for an in-depth explanation of this.
	    if (superc.prototype.constructor === Object.prototype.constructor) {
	        superc.prototype.constructor = superc;
	    }

	    // Check all the elements in the subclass prototype and add them to the chain object's prototype.
	    for (var method in subcp) {
	        if (subcp.hasOwnProperty(method)) {
	            subc.prototype[method] = subcp[method];

	            // // tenemos en super un metodo con igual nombre.
	            // if ( superc.prototype[method]) 
	            // {
	            //     subc.prototype[method]= (function(fn, fnsuper) 
	            //     {
	            //         return function() 
	            //         {
	            //             var prevMethod= this.__super;

	            //             this.__super= fnsuper;

	            //             var retValue= fn.apply(
	            //                     this,
	            //                     Array.prototype.slice.call(arguments) );

	            //             this.__super= prevMethod;

	            //             return retValue;
	            //         };
	            //     })(subc.prototype[method], superc.prototype[method]);
	            // }
	        }
	    }
	}

	/**
	* IMPORTANT: This function should only be used by Ludei.
	* This function allows a call to the native extension object function reusing the same arguments object.
	* Why is interesting to use this function instead of calling the native object's function directly?
	* As the CocoonJS object functions expicitly receive parameters, if they are not present and the native call is direcly mapped,
	* undefined arguments are passed to the native side. Some native functions do not check the parameters validation
	* correctly (just check the number of parameters passed).
	* Another solution instead of using this function call is to correctly check if the parameters are valid (not undefined) to make the
	* call, but it takes more work than using this approach.
	* @static
	* @param {string} nativeExtensionObjectName The name of the native extension object name. The object that is a member of the 'ext' object.
	* @param {string} nativeFunctionName The name of the function to be called inside the native extension object.
	* @param {object} arguments The arguments object of the CocoonJS extension object function. It contains all the arguments passed to the CocoonJS extension object function and these are the ones that will be passed to the native call too.
	* @param {boolean} [async] A flag to indicate if the makeCall (false or undefined) or the makeCallAsync function should be used to perform the native call.
	* @returns Whatever the native function call returns.
	*/
	CocoonJS.makeNativeExtensionObjectFunctionCall = function(nativeExtensionObjectName, nativeFunctionName, args, async) {
		if (CocoonJS.nativeExtensionObjectAvailable) {
			var argumentsArray = Array.prototype.slice.call(args);
			argumentsArray.unshift(nativeFunctionName);
			var nativeExtensionObject = ext[nativeExtensionObjectName];
			var makeCallFunction = async ? nativeExtensionObject.makeCallAsync : nativeExtensionObject.makeCall;
			var ret = makeCallFunction.apply(nativeExtensionObject, argumentsArray);
			var finalRet = ret;
			if (typeof ret === "string") {
				try	{
					finalRet = JSON.parse(ret);
				}
				catch(error) {
				}
			}
			return finalRet;
		}
	};

	/**
	* Returns an object retrieved from a path specified by a dot specified text path starting from a given base object.
	* It could be useful to find the reference of an object from a defined base object. For example the base object could be window and the
	* path could be "CocoonJS.App" or "document.body".
	* @param {Object} baseObject The object to start from to find the object using the given text path.
	* @param {string} objectPath The path in the form of a text using the dot notation. i.e. "document.body"
	* For example:
	* var body = getObjectFromPath(window, "document.body");
	*/
	CocoonJS.getObjectFromPath = function(baseObject, objectPath) {
    	var parts = objectPath.split('.');
    	var obj = baseObject;
        for (var i = 0, len = parts.length; i < len; ++i) 
        {
            obj[parts[i]] = obj[parts[i]] || undefined;
    		obj = obj[parts[i]];
    	}
    	return obj;
 	};

 	/**
 	* Returns the key for a value in a dictionary. It looks for an specific value inside a dictionary and returns the corresponding key.
 	* @param {Object} dictionary The dictionary to look for the value in and get the corresponding key.
 	* @param {Object} value The value to look for inside the dictionary and return it's corresponding key.
 	* @return The key that corresponds to the given value it is has been found or null.
 	*/
 	CocoonJS.getKeyForValueInDictionary = function(dictionary, value) {
        var finalKey = null;
        for (var key in dictionary) {
            if (dictionary[key] === value)            {
                finalKey = key;
                break;
            }
        }
        return finalKey;
 	}

 	/**
 	* Finds a string inside a given array of strings by looking for a given substring. It can also
 	* specify if the search must be performed taking care or not of the case sensitivity.
 	* @param {Array} stringArray The array of strings in which to to look for the string.
 	* @param {string} subString The substring to look for inside all the strings of the array.
 	* @param {boolean} caseSensitive A flag to indicate if the search must be performed taking case of the 
 	* case sensitiveness (true) or not (false).
 	* @return {string} The string that has been found or null if the substring is not inside any of the string of the array.
 	*/
 	CocoonJS.findStringInStringArrayThatIsIndexOf = function(stringArray, subString, caseSensitive) {
 		var foundString = null;
 		subString = caseSensitive ? subString : subString.toUpperCase();
 		for (var i = 0; foundString == null && i < stringArray.length; i++)	{
 			foundString = caseSensitive ? stringArray[i] : stringArray[i].toUpperCase();
 			foundString = foundString.indexOf(subString) >= 0 ? stringArray[i] : null; 
 		}
 		return foundString;
 	};

	/**
	* A class that represents objects to handle events. Event handlers have always the same structure:
	* Mainly they provide the addEventListener and removeEventListener functions.
	* Both functions receive a callback function that will be added or removed. All the added callback
	* functions will be called when the event takes place.
	* Additionally they also allow the addEventListenerOnce and notifyEventListeners functions.
	* @constructor
	* @param {string} nativeExtensionObjectName The name of the native extension object (inside the ext object) to be used.
	* @param {string} cocoonJSExtensionObjectName The name of the sugarized extension object.
	* @param {string} nativeEventName The name of the native event inside the ext object.
	* @param {number} [chainFunction] An optional function used to preprocess the listener callbacks. This function, if provided,
	* will be called before any of the other listeners.
	*/
	CocoonJS.EventHandler = function(nativeExtensionObjectName, cocoonJSExtensionObjectName, nativeEventName, chainFunction) {
		this.listeners = [];
		this.listenersOnce = [];
		this.chainFunction = chainFunction;

		/**
		* Adds a callback function so it can be called when the event takes place.
		* @param {function} listener The callback function to be added to the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
		*/
		this.addEventListener = function(listener) {
			if (chainFunction) {
				var f = function() {
					chainFunction.call(this, arguments.callee.sourceListener, Array.prototype.slice.call(arguments)); 
				};
				listener.CocoonJSEventHandlerChainFunction = f;
				f.sourceListener = listener;
				listener = f;
			}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListener(nativeEventName, listener);
            }
            else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener < 0) {
                	this.listeners.push(listener);
                }
            }
		};

        this.addEventListenerOnce = function(listener)
		{
			if (chainFunction) {
				var f = function() { chainFunction(arguments.callee.sourceListener,Array.prototype.slice.call(arguments)); };
				f.sourceListener = listener;
				listener = f;
			}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListenerOnce(nativeEventName, listener);
            }
            else
            {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener < 0)
                {
                	this.listenersOnce.push(listener);
                }
            }
		};

        /**
         * Removes a callback function that was added to the event handler so it won't be called when the event takes place.
         * @param {function} listener The callback function to be removed from the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
         */
        this.removeEventListener = function (listener) {

        	if (chainFunction) {
        		listener = listener.CocoonJSEventHandlerChainFunction;
        		delete listener.CocoonJSEventHandlerChainFunction;
        	}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].removeEventListener(nativeEventName, listener);
            }
            else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener >= 0) {
                    this.listeners.splice(indexOfListener, 1);
                }
            }
        };

		this.notifyEventListeners = function() {
			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].notifyEventListeners(nativeEventName);
            } else {

                var argumentsArray= Array.prototype.slice.call(arguments);
                var listeners =     Array.prototype.slice.call(this.listeners);
                var listenersOnce = Array.prototype.slice.call(this.listenersOnce);
                var _this = this;
                // Notify listeners after a while ;) === do not block this thread.
                setTimeout(function() {
                    for (var i = 0; i < listeners.length; i++) {
                        listeners[i].apply(_this, argumentsArray);
                    }
                    for (var i = 0; i < listenersOnce.length; i++) {
                        listenersOnce[i].apply(_this, argumentsArray);
                    }
                }, 0);

                _this.listenersOnce= [];
            }
		};
		return this;
	};

	/**
	* A simple timer class. Update it every loop iteration and get values from accumulated time to elapsed time in seconds or milliseconds.
	*/
	CocoonJS.Timer = function() {
		this.reset();
		return this;
	};

	CocoonJS.Timer.prototype = {
		currentTimeInMillis : 0,
		lastTimeInMillis : 0,
		elapsedTimeInMillis : 0,
		elapsedTimeInSeconds : 0,
		accumTimeInMillis : 0,

		/**
		Resets the timer to 0.
		*/
		reset : function() {
			this.currentTimeInMillis = this.lastTimeInMillis = new Date().getTime();
			this.accumTimeInMillis = this.elapsedTimeInMillis = this.elapsedTimeInSeconds = 0;
		},

		/**
		Updates the timer calculating the elapsed time between update calls.
		*/
		update : function() {
			this.currentTimeInMillis = new Date().getTime();
			this.elapsedTimeInMillis = this.currentTimeInMillis - this.lastTimeInMillis;
			this.elapsedTimeInSeconds = this.elapsedTimeInMillis / 1000.0;
			this.lastTimeInMillis = this.currentTimeInMillis;
			this.accumTimeInMillis += this.elapsedTimeInMillis;
		}
	};

	// CocoonJS.FindAllNativeBindingsInCocoonJSExtensionObject = function(cocoonJSExtensionObject, nativeFunctionBindingCallback, nativeEventBindingCallback)
	// {
	// 	for (var cocoonJSExtensionObjectAttributeName in cocoonJSExtensionObject)
	// 	{
	// 		var cocoonJSExtensionObjectAttribute = cocoonJSExtensionObject[cocoonJSExtensionObjectAttributeName];

	// 		// Function
	// 		if (typeof cocoonJSExtensionObjectAttribute === 'function' && typeof cocoonJSExtensionObjectAttribute.nativeFunctionName !== 'undefined')
	// 		{
	// 			var nativeFunctionName = cocoonJSExtensionObjectAttribute.nativeFunctionName;
	// 			nativeFunctionBindingCallback(cocoonJSExtensionObjectAttributeName, nativeFunctionName);
	// 		}
	// 		// Event object
	// 		else if (typeof cocoonJSExtensionObjectAttribute === 'object' && cocoonJSExtensionObjectAttribute !== null && typeof cocoonJSExtensionObjectAttribute.nativeEventName !== 'undefined')
	// 		{
	// 			var nativeEventName = cocoonJSExtensionObjectAttribute.nativeEventName;
	// 			nativeEventBindingCallback(cocoonJSExtensionObjectAttributeName, nativeEventName);
	// 		}
	// 	}
	// }

	/**
	This function looks for a CocoonJS extension object that is bound to the given native ext object name.
	@returns The CocoonJS extension object that corresponds to the give native extension object name or null if it cannot be found.
	*/
	// CocoonJS.GetCocoonJSExtensionObjectForNativeExtensionObjectName = function(nativeExtensionObjectName)
	// {
	// 	var cocoonJSExtensionObject = null;
	// 	// Look in the CocoonJS object and for every object that is a CocoonJS.Extension check if it's nativeExtensionObjectName matches to the one passed as argument. If so, create an object that will represent it's documentation for the native ext object.
	// 	for (var cocoonJSAttributeName in CocoonJS)
	// 	{
	// 		var cocoonJSAttribute = CocoonJS[cocoonJSAttributeName];
	// 		if (typeof cocoonJSAttribute === 'object' && cocoonJSAttribute instanceof CocoonJS.Extension && cocoonJSAttribute.nativeExtensionObjectName === nativeExtensionObjectName)
	// 		{
	// 			// We have found the CocoonJS object that represents the native ext extension object name. 
	// 			cocoonJSExtensionObject = cocoonJSAttribute;
	// 			break;
	// 		}
	// 	}
	// 	return cocoonJSExtensionObject;
	// };

	/**
	This function adds functions to a CocoonJS extension object in order to bind them to the native makeCall function calls of the ext object.

	@param extensionObject The reference to the CocoonJS extension object where to add the new functions bound to the ext object makeCall functions calls.

	@param nativeFunctionsConfiguration An array of objects with the following structure:

		{ nativeFunctionName : "" [, functionName : "", isAsync : true/false] }

		- nativeFunctionName: Specifies the name of the function inside the ext object makeCall function call that will be bound.
		- functionName: An optional attribute that allows to specify the name of the function to be added to the CocoonJS extension object. If is not present, the name of the function will be the same
		as the nativeFunctionName.
		- isAsync: An optional attribute that allows to specify if the call should be performed using makeCall (false or missing) or makeCallAsync (true).
		- alternativeFunction: An optional attribute that allows to specify an alternative function that will be called internally when this function is called. This attribute
		allows for adding new functionalities like for example adding methods 

	@returns The CocoonJS extension object.
	*/
	// CocoonJS.AddNativeFunctionBindingsToExtensionObject = function(extensionObject, nativeFunctionsConfiguration)
	// {
	// 	if (typeof extensionObject === 'undefined' || extensionObject === null) throw("The passed extension object be a valid object.");
	// 	if (typeof nativeFunctionsConfiguration === 'undefined' || nativeFunctionsConfiguration === null) throw("The passed native functions configuration array must be a valid object.");

	// 	for (var i = 0; i < nativeFunctionsConfiguration.length; i++)
	// 	{
	// 		if (typeof nativeFunctionsConfiguration[i].nativeFunctionName === 'undefined') throw("The 'nativeFunctionName' attribute in the native function configuration object at index '" + i + "' in the native function configuration array cannot be undefined.");
	// 		var nativeFunctionName = nativeFunctionsConfiguration[i].nativeFunctionName;
	// 		var functionName = typeof nativeFunctionsConfiguration[i].functionName !== 'undefined' ? nativeFunctionsConfiguration[i].functionName : nativeFunctionName;
	// 		var makeCallFunction = null;
	// 		makeCallFunction = typeof nativeFunctionsConfiguration[i].isAsync !== 'undefined' && nativeFunctionsConfiguration[i].isAsync ? extensionObject.nativeExtensionObject.makeCallAsync : extensionObject.nativeExtensionObject.makeCall;
	// 		// Add the new function to the CocoonJS extension object
	// 		extensionObject[functionName] = function()
	// 		{
	// 			// Convert the arguments object to an array
	// 			var arguments = Array.prototype.slice.call(arguments);
	// 			// Add the native function name as the first parameter
	// 			arguments.unshift(nativeFunctionName);
	// 			// Make the native ext object call
	// 			var result = makeCallFunction.apply(extensionObject.nativeExtensionObject, arguments);
	// 			return result;
	// 		}
	// 		// Add a property to the newly added function to store the name of the original function.
	// 		extensionObject[functionName].nativeFunctionName = nativeFunctionName;
	// 	}
	// 	return extensionObject;
	// };

	/**
	This function adds objects to a CocoonJS extension object to allow event listener handling (add and remove) bound to the native ext object event listener handling.

	@param extensionObject The reference to the CocoonJS extension object where to add the new objects bound to the ext object event listener handling.

	@param nativeEventsConfiguration An array of objects with the following structure:

		{ nativeEventName : "" [, eventObjectName : ""] }

		- nativeEventName: Specifies the event in the native ext object to be bound.
		- eventObjectName: An optional attribute that allows to specify the name of the object to be added to the CocoonJS extension object. If is not present, the name of the function will be the same
		as the nativeEventName.
		- alternativeAddEventListenerFunction:
		- alternativeRemoveEventListenerFunction:

	@returns The CocoonJS extension object.
	*/
	// CocoonJS.AddNativeEventBindingsToExtensionObject = function(extensionObject, nativeEventsConfiguration)
	// {
	// 	if (typeof extensionObject === 'undefined' || extensionObject === null) throw("The passed extension object be a valid object.");
	// 	if (typeof nativeEventsConfiguration === 'undefined' || nativeEventsConfiguration === null) throw("The passed native events configuration array must be a valid object.");

	// 	for (var i = 0; i < nativeEventsConfiguration.length; i++)
	// 	{
	// 		if (typeof nativeEventsConfiguration[i].nativeEventName === 'undefined') throw("The 'nativeEventName' attribute in the native event configuration object at index '" + i + "' in the native event configuration array cannot be undefined.");
	// 		var nativeEventName = nativeEventsConfiguration[i].nativeEventName;
	// 		var eventObjectName = typeof nativeEventsConfiguration[i].eventObjectName !== 'undefined' ? nativeEventsConfiguration[i].eventObjectName : nativeEventName;
	// 		// Anonymous function call so each variable in the loop is used in the event listener handling function bindings.
	// 		(function(nativeEventName, eventObjectName)
	// 		{
	//     		extensionObject[eventObjectName] =
	//     		{
	//     			// Store the native event name
	//     			nativeEventName : nativeEventName,
	//     			// Create the event listener management functions bound to the native counterparts
	//     			addEventListener : function(callback)
	// 	    		{
	// 	    			extensionObject.nativeExtensionObject.addEventListener(nativeEventName, callback);
	//     			},
	//     			removeEventListener : function(callback)
	//     			{
	// 	    			extensionObject.nativeExtensionObject.removeEventListener(nativeEventName, callback);
	//     			}
	//     			// ,
	//     			// removeAllEventListeners : function()
	//     			// {

	//     			// }
	//     		};
	// 		})(nativeEventName, eventObjectName);
	// 	}
	// 	return extensionObject;
	// };

	/**
	The function object constructor function all the CocoonJS extensions can use to instantiate the CocoonJS extension object and add all the functionality needed bound to the native ext object.

	@param nativeExtensionObject The reference to the ext object extension object.

	@param nativeFunctionsConfiguration See CocoonJS.AddNativeFunctionBindingsToExtensionObject function's documentation for more details.

	@param nativeEventsConfiguration See CocoonJS.AddNativeEventBindingsToExtensionObject function's documentation for more details.

	@returns The new CocoonJS extension object.
	*/
	// CocoonJS.Extension = function(nativeExtensionObjectName, nativeFunctionsConfiguration, nativeEventsConfiguration)
	// {
	// 	if (typeof nativeExtensionObjectName === 'undefined' || nativeExtensionObjectName === null) throw("The native extension object name cannot be null");

	// 	if (window.ext[nativeExtensionObjectName] === 'undefined') throw("The given native extension object name '" + nativeExtensionObjectName + "' is incorrect or the native extension object is undefined.");

	// 	var nativeExtensionObject = window.ext[nativeExtensionObjectName];

	// 	// Store a reference to the native extension object and to it's name
	// 	this.nativeExtensionObject = nativeExtensionObject;
	// 	this.nativeExtensionObjectName = nativeExtensionObjectName;

	// 	// If native function configuration is passed, use it to add some functions to the new extension object.
	// 	if (typeof nativeFunctionsConfiguration !== 'undefined')
	// 	{
	// 		CocoonJS.AddNativeFunctionBindingsToExtensionObject(this, nativeFunctionsConfiguration);
	// 	}

	// 	// If native event configuration is passed, use it to add some event objects to the new extension object.
	// 	if (typeof nativeEventsConfiguration !== 'undefined')
	// 	{
	// 		CocoonJS.AddNativeEventBindingsToExtensionObject(this, nativeEventsConfiguration);
	// 	}

	// 	return this;
	// };   

})();

//////////////////////////////////////
// COCOONJS_APP.JS                  //
//////////////////////////////////////

(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents all the basic functionalities available in the CocoonJS extension API.
     * @namespace
     */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    CocoonJS.App.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_APP !== 'undefined';

    /**
     * The predefined possible layouts for the FPS overlay.
     * @namespace
     */
    CocoonJS.App.FPSLayout = {
        TOP_LEFT:'top-left',
        TOP_RIGHT:'top-right',
        BOTTOM_LEFT:'bottom-left',
        BOTTOM_RIGHT:'bottom-right'
    };

    /**
     * Contains all the possible values to specify the input keyboard type to be used when introducing text.
     * @namespace
     */
    CocoonJS.App.KeyboardType = {
        /**
         * Represents a generic text input keyboard.
         */
        TEXT:"text",

        /**
         * Represents a number like input keyboard.
         */
        NUMBER:"num",

        /**
         * Represents a phone like input keyboard.
         */
        PHONE:"phone",

        /**
         * Represents an email like input keyboard.
         */
        EMAIL:"email",

        /**
         * Represents an URL like input keyboard.
         */
        URL:"url"
    };

    /**
     * The storage types to be used with file system related operations.
     * @namespace
     */
    CocoonJS.App.StorageType = {
        /**
         * Represents the application storage. The application storage is the place where all the resources that come with the application are stored.
         */
        APP_STORAGE:"APP_STORAGE",

        /**
         * Represents the internal storage. The internal storage is a different storage space that the application storage and only the data that the application has stored
         * in it will be in this storage. It is internal to the platform/device.
         */
        INTERNAL_STORAGE:"INTERNAL_STORAGE",

        /**
         * Represents an external storage. The external storage is similar to the internal storage in the sense that it only contains information that the application has written
         * in it but it represents an external storage device like a SD-CARD. If there is no exrernal storage, it will represent the same as the internal storage.
         */
        EXTERNAL_STORAGE:"EXTERNAL_STORAGE",

        /**
         * Represents the temporal storage. Same as the internal and external storage spaces in the sense that it only contains information that the application has written
         * in it but the main difference is that the information in this storage may dissapear without notice.
         */
        TEMPORARY_STORAGE:"TEMPORARY_STORAGE"
    };

    /**
     * The capture types to capture screenshots using CocoonJS native capabilities.
     * @namespace
     */
    CocoonJS.App.CaptureType = {
        /**
         Captures everything, both the CocoonJS GL hardware accelerated surface and the system views (like the WebView).
         */
        EVERYTHING:0,

        /**
         * Captures just the CocoonJS GL hardware accelerated surface.
         */
        JUST_COCOONJS_GL_SURFACE:1,

        /**
         * Captures just the sustem views (like the webview)
         */
        JUST_SYSTEM_VIEWS:2
    };

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It waits until the code is executed and the result of it is returned === synchronous.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @return {string} The result of the execution of the passed JavaScript code in the different JavaScript environment.
     */
    CocoonJS.App.forward = function (javaScriptCode) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forward", arguments);
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                //return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                return window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It is asyncrhonous so it does not wait until the code is executed and the result of it is returned. Instead, it calls a callback function when the execution has finished to pass the result.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @param {function} [returnCallback] A function callback that will be called when the passed JavaScript code is executed in a different thread to pass the result of the execution in the different JavaScript environment.
     */
    CocoonJS.App.forwardAsync = function (javaScriptCode, returnCallback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            if (typeof returnCallback !== 'undefined') {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode, returnCallback);
            }
            else {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode);
            }
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                // window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Pops up a text dialog so the user can introduce some text and the application can get it back. It is the first approach CocoonJS has taken to be able to introduce
     * text input in a easy way. The dialog execution events are passed to the application through the {@link CocoonJS.App.onTextDialogFinished} and the {@link CocoonJS.App.onTextDialogCancelled} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [text] Default value is "". The initial text to be introduced in the text input field.
     * @param {CocoonJS.App.KeyboardType} [keyboardType] Default value is {@link CocoonJS.App.KeyboardType.TEXT}. The keyboard type to be used when the text has to be introduced.
     * @param {string} [cancelButtonText] Default value is "". The text to be displayed in the cancel button of the dialog.
     * @param {string} [okButtonText] Default value is "". The text to be displayed in the ok button of the dialog.
     * @see CocoonJS.App.onTextDialogFinished
     * @see CocoonJS.App.onTextDialogCancelled
     */
    CocoonJS.App.showTextDialog = function (title, message, text, keyboardType, cancelButtonText, okButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showTextDialog", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            if (!text) {
                text = "";
            }
            var result = prompt(message, text);
            var eventObject = result ? CocoonJS.App.onTextDialogFinished : CocoonJS.App.onTextDialogCancelled;
            eventObject.notifyEventListeners(result);
        }
    };

    /**
     * Pops up a message dialog so the user can decide between a yes or no like confirmation. The message box execution events are passed to the application through the {@link CocoonJS.App.onMessageBoxConfirmed} and the {@link CocoonJS.App.onMessageBoxDenied} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [confirmButtonText] Default value is "Yes". The text to be displayed for the confirm button.
     * @param {string} [denyButtonText] Default value is "No". The text to be displayed for the deny button.
     * @see CocoonJS.App.onMessageBoxConfirmed
     * @see CocoonJS.App.onMessageBoxDenied
     */
    CocoonJS.App.showMessageBox = function (title, message, confirmButtonText, denyButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showMessageBox", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            var result = confirm(message);
            var eventObject = result ? CocoonJS.App.onMessageBoxConfirmed : CocoonJS.App.onMessageBoxDenied;
            eventObject.notifyEventListeners();
        }
    };

    /**
     * It allows to load a new JavaScript/HTML5 resource that can be loaded either locally (inside the platform/device storage) or using a remote URL.
     * @function
     * @param {string} path A path to a resource stored in the platform or in a URL to a remote resource.
     * @param {CocoonJS.App.StorageType} [storageType] If the path argument represents a locally stored resource, the developer can specify the storage where it is stored. If no value is passes, the {@link CocoonJS.App.StorageType.APP_STORAGE} value is used by default.
     */
    CocoonJS.App.load = function (path, storageType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "loadPath", arguments);
        }
        else if (!navigator.isCocoonJS) {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function (event) {
                if (xhr.readyState === 4) {
                    if (xhr.status === 200) {
                        // TODO: As window load event is not being called (WHY???), I have decided to call the listeners directly
                        // var callback= function(event){
                        //     window.removeEventListener("load", callback);
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInCocoonJSSucceed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                        // };
                        // window.addEventListener("load", callback);
                        window.location.href = path;
                    }
                    else if (xhr.status === 404) {
                        this.onreadystatechange = null;
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInCocoonJSFailed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the current context.
     * @function
     */
    CocoonJS.App.reload = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "reload", arguments);
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.location.reload();
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.location.reload();
            }
        }
    };

    /**
     * Opens a given URL using a system service that is able to open it. For example, open a HTTP URL using the system WebBrowser.+
     * @function
     * @param {string} url The URL to be opened by a system service.
     */
    CocoonJS.App.openURL = function (url) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "openURL", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            window.open(url, '_blank');
        }
    }

    /**
     * Forces the app to be finished.
     * @function
     */
    CocoonJS.App.forceToFinish = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forceToFinish", arguments);
        }
        else if (!navigator.isCocoonJS) {
            window.close();
        }
    }

    /**
     * Enables or disables the auto lock to control if the screen keeps on after an inactivity period.
     * When the auto lock is enabled and the application has no user input for a short period, the system puts the device into a "sleepâ€ state where the screen dims or turns off.
     * When the auto lock is disabled the screen keeps on even when there is no user input for long times.
     * @param enabled A boolean value that controls whether to enable or disable the auto lock.
     */
    CocoonJS.App.setAutoLockEnabled = function (enabled) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setAutoLockEnabled", arguments);
        }
    }

    /**
     * Creates a canvas element that is automatically resized to the screen size. When the app is being executed
     * inside CocoonJS. This canvas is optimized for rendering so it is higly recommended to use it if it fits
     * your app needs. If your app uses one canvas as the main canvas where all other canvases and images are displayed, Ludei recommends to
     * call this function in order to create this main canvas. A usual 2x performance gain is achieved by doing so
     * depending on the device and the graphics card driver.
     * @function
     * @return {object} The canvas object that should be used as the main canvas and that is resized to the screen resolution.
     */
    CocoonJS.App.createScreenCanvas = function () {
        var screenCanvas;
        if (navigator.isCocoonJS) {
            screenCanvas = document.createElement("screencanvas");
        }
        else if (!navigator.isCocoonJS) {
            screenCanvas = document.createElement("canvas");
            screenCanvas.width = window.innerWidth;
            screenCanvas.height = window.innerHeight;
        }
        return screenCanvas;
    };

    /**
     * Disables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.disableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Enables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.enableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Disables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.disableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "WebView");
        }
    };

    /**
     * Enables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.enableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "WebView");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the accelerometer updates.
     * It defines the rate at which the devicemotion events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setAccelerometerUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setAccelerometerUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for accelerometer related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for accelerometer related events.
     */
    CocoonJS.App.getAccelerometerUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getAccelerometerUpdateIntervalInSeconds");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the gyroscope updates.
     * It defines the rate at which the devicemotion and deviceorientation events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setGyroscopeUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setGyroscopeUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for gyroscope related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for gyroscope related events.
     */
    CocoonJS.App.getGyroscopeUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("getGyroscopeUpdateIntervalInSeconds");
        }
    };


    /**
     * Setups a origin proxy for a given typeName. What this means is that after calling this function the environment that makes this call will suddenly
     * have a way of creating instances of the given typeName and those instances will act as a transparent proxy to counterpart instances in the destination environment.
     * Manipulating attributes, calling funcitions or handling events will all be performed in the destination environment but the developer will think they will be
     * happening in the origin environment.
     * IMPORTANT NOTE: These proxies only work with types that use attributes and function parameters and return types that are primitive like numbers, strings or arrays.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} [attributeNames] A list of the names of the attributes to be proxified.
     * @param {array} [functionNames] A list of the names of the functions to be proxified.
     * @param {array} [eventHandlerNames] A list of the names of the event handlers to be proxified (onXXXX like attributes that represent callbacks).
     * A valid typeName and at least one valid array for attribute, function or event handler names is mandatory.
     */
    CocoonJS.App.setupOriginProxyType = function (typeName, attributeNames, functionNames, eventHandlerNames) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            // Control the parameters.
            if (!typeName) throw "The given typeName must be valid.";
            if (!attributeNames && !functionNames && !eventHandlerNames) throw "There is no point on setting up a proxy for no attributes, functions nor eventHandlers.";
            attributeNames = attributeNames ? attributeNames : [];
            functionNames = functionNames ? functionNames : [];
            eventHandlerNames = eventHandlerNames ? eventHandlerNames : [];

            // The parent object will be the window. It could be another object but careful, the destination side should know about this.
            // TODO: Specify the parentObject as a parameter, obtain it's path from the window object and pass it to the destination environment so it knows about it.
            var parentObject = window;

            // Setup the destination side too.
            var jsCode = "CocoonJS.App.setupDestinationProxyType(" + JSON.stringify(typeName) + ", " + JSON.stringify(eventHandlerNames) + ");";
            CocoonJS.App.forward(jsCode);

            var originalType = parentObject[typeName];

            // Constructor. This will be the new proxified type in the origin environment. Instances of this type will be created by the developer without knowing that they are
            // internally calling to their counterparts in the destination environment.
            parentObject[typeName] = function () {
                var _this = this;

                // Each proxy object will have a origin object inside with all the necessary information to be a proxy to the destination.
                this._cocoonjs_proxy_object_data = {};
                // The id is obtained calling to the destination side to create an instance of the type.
                var jsCode = "CocoonJS.App.newDestinationProxyObject(" + JSON.stringify(typeName) + ");";
                this._cocoonjs_proxy_object_data.id = CocoonJS.App.forward(jsCode);
                // The eventHandlers dictionary contains objects of the type { eventHandlerName : string, eventHandler : function } to be able to make the callbacks when the 
                // webview makes the corresponding calls.
                this._cocoonjs_proxy_object_data.eventHandlers = {};
                // Also store the typename inside each instance.
                this._cocoonjs_proxy_object_data.typeName = typeName;
                // A dictionary to store the event handlers
                this._cocoonjs_proxy_object_data.eventListeners = {};

                // TODO: eventHandlers and eventListeners should be in the same list ;)

                // Store all the proxy instances in a list that belongs to the type itself.
                parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[this._cocoonjs_proxy_object_data.id] = this;

                // Create a setter and a getter for all the attribute names that have been specified. When the attributes are accessed (set or get) a call to the destination counterpart will be performed.
                for (var i = 0; i < attributeNames.length; i++) {
                    (function (attributeName) {
                        _this.__defineSetter__(attributeName, function (value) {
                            var jsCode = "CocoonJS.App.setDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ", " + JSON.stringify(value) + ");";
                            return CocoonJS.App.forwardAsync(jsCode);
                        });
                        _this.__defineGetter__(attributeName, function () {
                            var jsCode = "CocoonJS.App.getDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ");";
                            return CocoonJS.App.forwardAsync(jsCode);
                        });
                    })(attributeNames[i]);
                }

                // Create a function that performs a call to the destination environment counterpart for all the function names that have been specified.
                for (var i = 0; i < functionNames.length; i++) {
                    (function (functionName) {
                        _this[functionName] = function () {
                            // Get the arguments as an array and add the typeName, the proxy id and the functionName before all the other arguments before making the call to the destination counterpart.
                            var argumentsArray = Array.prototype.slice.call(arguments);
                            argumentsArray.unshift(functionName);
                            argumentsArray.unshift(this._cocoonjs_proxy_object_data.id);
                            argumentsArray.unshift(typeName);
                            // Use the array to create the correct function call.
                            var jsCode = "CocoonJS.App.callDestinationProxyObjectFunction(";
                            for (var i = 0; i < argumentsArray.length; i++) {
                                // The second argument (the id) should not be stringified
                                jsCode += (i !== 1 ? JSON.stringify(argumentsArray[i]) : argumentsArray[i]) + (i < argumentsArray.length - 1 ? ", " : "");
                            }
                            jsCode += ");";
                            // TODO: This next call should be synchronous but it seems that some customers are experiencing some crash issues. Making it async solves these crashes.
                            // Another possible solution could be to be able to specify which calls could be async and which sync in the proxification array.
                            var ret = CocoonJS.App.forwardAsync(jsCode);
                            return ret;
                        };
                    })(functionNames[i]);
                }

                // Create a setter and getter for all the event handler names that have been specified. When the event handlers are accessed, store them inside the corresponding position on the eventHandlers
                // array so they can be called when the destination environment makes the corresponding callback call.
                for (var i = 0; i < eventHandlerNames.length; i++) {
                    (function (eventHandlerName) {
                        _this.__defineSetter__(eventHandlerName, function (value) {
                            _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName] = value;
                        });
                        _this.__defineGetter__(eventHandlerName, function () {
                            return _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
                        });
                    })(eventHandlerNames[i]);
                }

                // Setup the add and remove event listeners in the proxy object
                _this.addEventListener = function (eventTypeName, eventCallback) {
                    var addEventCallback = true;
                    // Check for the eventListeners
                    var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                    if (eventListeners) {
                        // As the eventListeners were already added, check that the same callback has not been added.
                        addEventCallback = eventListeners.indexOf(eventCallback) < 0;
                    }
                    else {
                        // There are no event listeners, so add the one and add the listeners array for the specific event type name
                        eventListeners = [];
                        _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = eventListeners;

                        // Forward the call so the other end registers a event listener (only one is needed).
                        var jsCode = "CocoonJS.App.addDestinationProxyObjectEventListener(" + JSON.stringify(_this._cocoonjs_proxy_object_data.typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
                        CocoonJS.App.forwardAsync(jsCode);
                    }
                    // Only if the alforithm above specify so, add the eventcallback and notify the destination environment to do the same
                    if (addEventCallback) {
                        eventListeners.push(eventCallback);
                    }
                };

                _this.removeEventListener = function (eventTypeName, eventCallback) {
                    // Check for the eventListeners
                    var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                    if (eventListeners) {
                        var eventCallbackIndex = eventListeners.indexOf(eventCallback);
                        if (eventCallbackIndex >= 0) {
                            eventListeners.splice(eventCallbackIndex, 1);
                        }
                    }
                };

                // Return the proxy instance.
                return this;
            };

            // The type will contain a proxy data structure to store all the instances that are created so they are available when the destination environment calls back. 
            parentObject[typeName]._cocoonjs_proxy_type_data =
            {
                originalType:originalType,
                proxyObjects:[]
            };

            /**
             * Deletes a proxy instance from both the CocoonJS environment structures and also deleting it's webview environment counterpart.
             * This function should be manually called whenever a proxy instance won't be accessed anymore.
             * @param {object} object The proxy object to be deleted.
             */
            parentObject[typeName]._cocoonjs_proxy_type_data.deleteProxyObject = function (object) {
                var proxyObjectKey = CocoonJS.getKeyForValueInDictionary(this.proxyObjects, object);
                if (proxyObjectKey) {
                    var jsCode = "CocoonJS.App.deleteDestinationProxyObject(" + JSON.stringify(typeName) + ", " + object._cocoonjs_proxy_object_data.id + ");";
                    CocoonJS.App.forwardAsync(jsCode);
                    object._cocoonjs_proxy_object_data = null;
                    delete this.proxyObjects[proxyObjectKey];
                }
            };

            /**
             * Calls a event handler for the given proxy object id and eventHandlerName.
             * @param {number} id The id to be used to look for the proxy object for which to make the call to it's event handler.
             * @param {string} eventHandlerName The name of the handler to be called.
             * NOTE: Events are a complex thing in the HTML specification. This function just performs a call but at least provides a
             * structure to the event passing the target (the proxy object).
             * TODO: The destination should serialize the event object as far as it can so many parameters can be passed to the origin
             * side. Using JSON.stringify in the destination side and parse in origin side maybe? Still must add the target to the event structure though.
             */
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler = function (id, eventHandlerName) {
                var object = this.proxyObjects[id];
                var eventHandler = object._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
                if (eventHandler) {
                    eventHandler({ target:object });
                }
            };

            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners = function (id, eventTypeName) {
                var object = this.proxyObjects[id];
                var eventListeners = object._cocoonjs_proxy_object_data.eventListeners[eventTypeName].slice();
                for (var i = 0; i < eventListeners.length; i++) {
                    eventListeners[i]({ target:object });
                }
            };
        }
    };

    /**
     * Takes down the proxification of a type and restores it to it's original type. Do not worry if you pass a type name that is not proxified yet. The
     * function will handle it correctly for compativility reasons.
     * @param {string} typeName The name of the type to be deproxified (take down the proxification and restore the type to it's original state)
     */
    CocoonJS.App.takedownOriginProxyType = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (parentObject[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
                parentObject[typeName] = parentObject[typeName]._cocoonjs_proxy_type_data.originalType;
            }
        }
    };

    /**
     * Deletes everything related to a proxy object in both environments. Do not worry of you do not pass a proxified object to the
     * function. For compatibility reasons, you can still have calls to this function even when no poxification of a type has been done.
     * @param {object} object The proxified object to be deleted.
     */
    CocoonJS.App.deleteOriginProxyObject = function (object) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (object && object._cocoonjs_proxy_object_data) {
                parentObject[object._cocoonjs_proxy_object_data.typeName]._cocoonjs_proxy_type_data.deleteProxyObject(object);
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when an event handler need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventHandlerName The name of the event handler to be called.
     */
    CocoonJS.App.callOriginProxyObjectEventHandler = function (typeName, id, eventHandlerName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler(id, eventHandlerName);
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when all the event listeners related to a specific event need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventTypeName The name of the event type to call the listeners related to it.
     */
    CocoonJS.App.callOriginProxyObjectEventListeners = function (typeName, id, eventTypeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners(id, eventTypeName);
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Setups all the structures that are needed to proxify a destination type to an origin type.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} eventHandlerNames An array with al the event handlers to be proxified. Needed in order to be able to create callbacks for all the event handlers
     * and call to the CocoonJS counterparts accordingly.
     */
    CocoonJS.App.setupDestinationProxyType = function (typeName, eventHandlerNames) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;

            // Add a cocoonjs structure to the destination proxified type to store some useful information like all the proxy instances that are created, plus the id counter 
            // and the names of all the event handlers and some utility functions.
            parentObject[typeName]._cocoonjs_proxy_type_data =
            {
                nextId:0,
                proxyObjects:{},
                eventHandlerNames:eventHandlerNames
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Takes down the proxy type at the destination environment. Just removes the data structure related to proxies that was added to the type when proxification tool place.
     * @param {string} typeName The name of the type to take the proxification down.
     */
    CocoonJS.App.takedownDestinationProxyType = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (parent[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
                delete parentObject[typeName]._cocoonjs_proxy_type_data;
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Creates a new destination object instance and generates a id to reference it from the original environment.
     * @param {string} typeName The name of the type to be proxified and to generate an instance.
     * @return The id to be used from the original environment to identify the corresponding destination object instance.
     */
    CocoonJS.App.newDestinationProxyObject = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;

            var proxyObject = new parentObject[typeName]();
            // Also store some additional information in the proxy object
            proxyObject._cocoonjs_proxy_object_data = {};
            // Like the type name, that could be useful late ;)
            proxyObject._cocoonjs_proxy_object_data.typeName = typeName;
            // Caculate the id for the object. It will be returned to the origin environment so this object can be referenced later
            var proxyObjectId = parentObject[typeName]._cocoonjs_proxy_type_data.nextId;
            // Store the created object in the structure defined in the setup of proxification with an id associated to it
            parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[proxyObjectId] = proxyObject;
            // Also store the id inside the proxy object itself
            proxyObject._cocoonjs_proxy_object_data.id = proxyObjectId;
            // Calculate a new id for the next object.
            parentObject[typeName]._cocoonjs_proxy_type_data.nextId++;

            // Setup all the event handlers.
            for (var i = 0; i < parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames.length; i++) {
                (function (eventHandlerName) {
                    proxyObject[eventHandlerName] = function (event) {
                        var proxyObject = this; // event.target;
                        // var eventHandlerName = CocoonJS.getKeyForValueInDictionary(proxyObject, this); // Avoid closures ;)
                        var jsCode = "CocoonJS.App.callOriginProxyObjectEventHandler(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventHandlerName) + ");";
                        CocoonJS.App.forwardAsync(jsCode);
                    };
                })(parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames[i]);
            }

            // Add the dictionary where the event listeners (callbacks) will be added.
            proxyObject._cocoonjs_proxy_object_data.eventListeners = {};

            return proxyObjectId;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environement whenever it is needed to work with proxy objects.
     * Calls a function of a destination object idetified by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} functionName The name of the function to be called.
     * @return Whatever the function call returns.
     */
    CocoonJS.App.callDestinationProxyObjectFunction = function (typeName, id, functionName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var argumentsArray = Array.prototype.slice.call(arguments);
            argumentsArray.splice(0, 3);
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            var result = proxyObject[functionName].apply(proxyObject, argumentsArray);
            return result;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Sets a value to the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be set.
     * @param {unknown} attributeValue The value to be set to the attribute.
     */
    CocoonJS.App.setDestinationProxyObjectAttribute = function (typeName, id, attributeName, attributeValue) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            proxyObject[attributeName] = attributeValue;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Retrieves the value of the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be retrieved.
     */
    CocoonJS.App.getDestinationProxyObjectAttribute = function (typeName, id, attributeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            return proxyObject[attributeName];
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Deletes a proxy object identifying it using it's typeName and id. Deleting a proxy object mainly means to remove the instance from the global structure
     * that hold all the instances.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     */
    CocoonJS.App.deleteDestinationProxyObject = function (typeName, id) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            delete parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     */
    CocoonJS.App.addDestinationProxyObjectEventListener = function (typeName, id, eventTypeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            // Look for the proxy object
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];

            var callback = function (event) {
                var proxyObject = this; // event.target;
                // var eventTypeName = CocoonJS.getKeyForValueInDictionary(proxyObject._cocoonjs_proxy_object_data.eventListeners, this); // Avoid closures ;)
                // TODO: Is there a way to retrieve the callbackId without a closure?
                var jsCode = "CocoonJS.App.callOriginProxyObjectEventListeners(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
                CocoonJS.App.forwardAsync(jsCode);
            };

            proxyObject._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = callback;

            // Finally add the event listener callback to the proxy object
            proxyObject.addEventListener(eventTypeName, callback);
        }
    };

    // TODO: We could add a removeDestinationProxyObjectEventListener although it seems that is not completely necessary.

    /**
     * Proxifies the XMLHttpRequest type for the environment where this call is made. After calling this function, all the new objects
     * of XMLHttpRequest that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyXHR = function () {
        var ATTRIBUTE_NAMES =
            [
                "timeout",
                "withCredentials",
                "upload",
                "status",
                "statusText",
                "responseType",
                "response",
                "responseText",
                "responseXML",
                "readyState"
            ];
        var FUNCTION_NAMES =
            [
                "open",
                "setRequestHeader",
                "send",
                "abort",
                "getResponseHeader",
                "getAllResponseHeaders",
                "overrideMimeType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onloadstart",
                "onprogress",
                "onabort",
                "onerror",
                "onload",
                "ontimeout",
                "onloadend",
                "onreadystatechange"
            ];
        CocoonJS.App.setupOriginProxyType("XMLHttpRequest", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Proxifies the Audio type for the environment where this call is made. After calling this function, all the new objects
     * of Audio that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyAudio = function () {
        var ATTRIBUTE_NAMES =
            [
                "src",
                "loop",
                "volume",
                "preload"
            ];
        var FUNCTION_NAMES =
            [
                "play",
                "pause",
                "load",
                "canPlayType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onended",
                "oncanplay",
                "oncanplaythrough",
                "onerror"
            ];
        CocoonJS.App.setupOriginProxyType("Audio", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Captures a image of the screen synchronously and saves it to a file. Sync mode allows to capture the screen in the middle of a frame rendering.
     * @param {string} fileName Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} storageType The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @return The URL of the saved file.
     * @throws exception if the image fails to be stored or there is another error.
     * @see CocoonJS.App.onCaptureScreenSucceeded
     * @see CocoonJS.App.onCaptureScreenFailed
     */
    CocoonJS.App.captureScreen = function (fileName, storageType, captureType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("captureScreen", fileName, storageType, captureType);
        }
    };

    /**
     * Captures a image of the screen asynchronously and saves it to a file.
     * Async mode captures a final frame as soon as possible.
     * @param {string} Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} [storageType] The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface, 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @param {function} callback. Response callback, check the error property to monitor errors. Check the 'url' property to get the URL of the saved Image
     */
    CocoonJS.App.captureScreenAsync = function (fileName, storageType, captureType, callback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCallAsync("captureScreen", fileName, storageType, captureType, callback);
        }
    };

    /**
     * Returns the device UUID
     * @return {string} The device UUID
     */
    CocoonJS.App.getDeviceId = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceId");
        }
    };

    /**
     * Structure that defines the getDeviceInfo returned information
     */
    CocoonJS.App.DeviceInfo = {

        /**
        * The operating system name (ios, android,...)
        * @type string
        */
        os: null,

        /**
        * The operating system version (4.2.2, 5.0,...)
        * @type string
        */
        version: null,

        /**
        * The operating system screen density in dpi
        * @type string
        */
        dpi: null,

        /**
        * The device manufacturer (apple, samsung, lg,...)
        * @type string
        */
        brand: null,

        /**
        * The device model (iPhone 4S, SAMSUNG-SGH-I997, SAMSUNG-SGH-I997R, etc)
        * @type string
        */
        model: null,

        /**
        * The phone IMEI
        * Android: The phone IMEI is returned or null if the device has not telepohny
        * iOS: null is returned as we cannot get the IMEI in iOS, no public API available for that yet.
        * @type string
        */
        imei: null,

        /**
        * The platform Id
        * Android: The ANDROID_ID is used.
        * iOS: The OpenUDID is used as there is no Android ANDROID_ID equivalent in iOS
        * @type string
        */
        platformId: null,

        /**
        * The Odin generated id https://code.google.com/p/odinmobile/
        * @type string
        */
        odin: null,

        /**
        * The OpenUDID generated Id https://github.com/ylechelle/OpenUDID
        * @type string
        */
        openudid: null
    };

    /**
     * Returns the device Info
     * @return {CocoonJS.App.DeviceInfo} The device Info
     */
    CocoonJS.App.getDeviceInfo = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceInfo");
        }
    };    

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onTextDialogFinished} event calls.
     * @name OnTextDialogFinishedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} text The text that was introduced in the text dialog when it was finished.
     */
    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function's documentation is represented by {@link CocoonJS.App.OnTextDialogFinishedListener}
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogFinished = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogfinish");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogCancelled = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogcancel");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxConfirmed = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxconfirmed");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxDenied = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxdenied");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is suspended.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onSuspended = new CocoonJS.EventHandler("IDTK_APP", "App", "onsuspended");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is activated.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onActivated = new CocoonJS.EventHandler("IDTK_APP", "App", "onactivated");

})();

//////////////////////////////////////
// COCOONJS_APP_FORCOCOONJS.JS		//
//////////////////////////////////////

(function()
{
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before adding more functionalities to an extension.");
    if (typeof window.CocoonJS.App === 'undefined' || window.CocoonJS.App === null) throw("The CocoonJS.App object must exist and be valid before adding more functionalities to it.");

    /**
    * This namespace represents all the basic functionalities available in the CocoonJS extension API.
    * @namespace
    */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    if (!CocoonJS.App.nativeExtensionObjectAvailable)
    {
        (function createWebView() { 
            CocoonJS.App.EmulatedWebView = document.createElement('div'); 
            CocoonJS.App.EmulatedWebView.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewDiv'); 
            CocoonJS.App.EmulatedWebView.style.width = 0; 
            CocoonJS.App.EmulatedWebView.style.height = 0; 
            CocoonJS.App.EmulatedWebView.style.position = "absolute"; 
            CocoonJS.App.EmulatedWebView.style.left = 0; 
            CocoonJS.App.EmulatedWebView.style.top = 0;
            CocoonJS.App.EmulatedWebView.style.backgroundColor = 'transparent';
            CocoonJS.App.EmulatedWebView.style.border = "0px solid #000"; 
            CocoonJS.App.EmulatedWebViewIFrame = document.createElement("IFRAME"); 
            CocoonJS.App.EmulatedWebViewIFrame.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
            CocoonJS.App.EmulatedWebViewIFrame.setAttribute('name', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
            CocoonJS.App.EmulatedWebViewIFrame.style.width = 0; 
            CocoonJS.App.EmulatedWebViewIFrame.style.height = 0; 
            CocoonJS.App.EmulatedWebViewIFrame.frameBorder = 0;
            CocoonJS.App.EmulatedWebViewIFrame.allowtransparency = true;
            CocoonJS.App.EmulatedWebView.appendChild(CocoonJS.App.EmulatedWebViewIFrame);
            if(!document.body)
            document.body = document.createElement("body");
            document.body.appendChild(CocoonJS.App.EmulatedWebView);
        })(); 
    }

    /**
    * Pauses the CocoonJS JavaScript execution loop.
    * @function
    * @augments CocoonJS.App
    */
    CocoonJS.App.pause = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "pause", arguments);
        }
    };

    /**
    * Resumes the CocoonJS JavaScript execution loop.
    * @static
    * @function
    */
    CocoonJS.App.resume = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "resume", arguments);
        }
    };

    /**
    * Loads a resource in the WebView environment from the CocoonJS environment.
    * @function
    * @param {string} path The path to the resource. It can be a remote URL or a path to a local file.
    * @param {CocoonJS.App.StorageType} [storageType] An optional parameter to specify at which storage in the device the file path is stored. By default, APP_STORAGE is used.
    * @see CocoonJS.App.load
    * @see CocoonJS.App.onLoadInTheWebViewSucceed
    * @see CocoonJS.App.onLoadInTheWebViewFailed
    */
    CocoonJS.App.loadInTheWebView = function(path, storageType)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            // TODO: All this code should be changed to a simple call makeNativeExtensionObjectFunctionCall when the native argument control is improved.
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('loadPath'";
            if (typeof path !== 'undefined')
            {
                javaScriptCodeToForward += ", '" + path + "'";
                if (typeof storageType !== 'undefined')
                {
                    javaScriptCodeToForward += ", '" + storageType + "'";
                }
            }
            javaScriptCodeToForward += ");";

            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function(event) {
                if (xhr.readyState === 4)
                {
                    if (xhr.status === 200)
                    {
                        var callback= function(event){
                            CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners(path);
                            CocoonJS.App.EmulatedWebViewIFrame.removeEventListener("load", callback);
                        };

                        CocoonJS.App.EmulatedWebViewIFrame.addEventListener(
                            "load", 
                            callback
                        );
                        CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.href= path;
                    }
                    else if (xhr.status === 404)
                    {
                        this.onreadystatechange = null;
                        CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners(path);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the WebView context.
     * @function
     */
    CocoonJS.App.reloadWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.App.forwardAsync("ext.IDTK_APP.makeCall('reload');");
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.reload();
        }
    };

    /**
    * Shows the webview.
    * @function
    * @param {int} x The top lef x coordinate of the rectangle where the webview will be shown.
    * @param {int} y The top lef y coordinate of the rectangle where the webview will be shown.
    * @param {width} y The width of the rectangle where the webview will be shown.
    * @param {height} y The height of the rectangle where the webview will be shown.
    */
    CocoonJS.App.showTheWebView = function(x, y, width, height)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('show'";
            if (typeof x !== 'undefined' && typeof y !== 'undefined' && typeof width !== 'undefined' && typeof height !== 'undefined')
            {
                javaScriptCodeToForward += ", " + x + ", " + y + ", " + width + ", " + height;
            }
            javaScriptCodeToForward += ");";

            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebViewIFrame.style.width = (width ? width : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebViewIFrame.style.height = (height ? height : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.left = (x ? x : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.top = (y ? y : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.width = (width ? width : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebView.style.height = (height ? height : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.display = "block";
        }
    };

    /**
    * Hides the webview.
    * @function
    */
    CocoonJS.App.hideTheWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('hide');";
            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebView.style.display = "none";
        }
    };

    /**
    * Marks a audio file to be used as music by the system. CocoonJS, internally, differentiates among music files and sound files.
    * Music files are usually bigger in size and longer in duration that sound files. There can only be just one music file 
    * playing at a specific given time. The developer can mark as many files as he/she wants to be treated as music. When the corresponding
    * HTML5 audio object is used, the system will automatically know how to treat the audio resource as music or as sound.
    * Note that it is not mandatory to use this function. The system automatically tries to identify if a file is suitable to be treated as music
    * or as sound by checking file size and duration thresholds. It is recommended, though, that the developer specifies him/herself what he/she considers
    * to be music.
    * @function
    * @param {string} audioFilePath The same audio file path that will be used to create HTML5 audio objects.
    */
    CocoonJS.App.markAsMusic = function(audioFilePath)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "addForceMusic", arguments);
        }
    };

    /**
    * Activates or deactivates the antialas functionality from the CocoonJS rendering.
    * @function
    * @param {boolean} enable A flag that indicates if the antialas should be activated (true) or deactivated (false).
    */
    CocoonJS.App.setAntialias = function(enable)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultAntialias", arguments);
        }
    };

    /**
    * Sets a callback function that will be called whenever the system tries to finish the app.
    * The developer can specify how the system will react to the finish of the app by returning a
    * boolean value in the callback function: true means, close the app, false means that the developer
    * will handle the app close.
    * A common example of this is the back button in Android devices. When the back button is pressed, this
    * callback will be called and the system will react depending on the developers choice finishing, or not,
    * the application.
    * @function
    * @param {function} appShouldFinishCallback A function object that will be called when the system
    * determines that the app should be finished. This function must return a true or a false value
    * depending on what the developer wants: true === finish the app, false === do not close the app.
    */
    CocoonJS.App.setAppShouldFinishCallback = function(appShouldFinishCallback)
    {
        if (navigator.isCocoonJS)
        {
            window.onidtkappfinish = appShouldFinishCallback;
        }
    }

    /**
    * Sets the texture reduction options. The texture reduction is a process that allows big images to be reduced/scaled down when they are loaded.
    * Although the quality of the images may decrease, it can be very useful in low end devices or those with limited amount of memory.
    * The function sets the threshold on image size (width or height) that will be used in order to know if an image should be reduced or not.
    * It also allows to specify a list of strings to identify in which images file paths should be applied (when they meet the size threshold requirement) 
    * The developer will still think that the image is of the original size. CocoonJS handles all of the internals to be able to show the image correctly.
    * IMPORTANT NOTE: This function should be called when the application is initialized before any image is set to be loaded for obvious reasons ;).
    * and in which sould be forbid (even if they meet the threshold requirement).
    * @function
    * @param {number} sizeThreshold This parameter specifies the minimun size (either width or height) that an image should have in order to be reduced.
    * @param {string or array} [applyTo] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it will be reduced. This parameter can also be null.
    * @param {string or array} [forbidFor] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it won't be reduced. This parameter should be used in order to mantain the 
    * quality of some images even they meet the size threshold requirement.
    */
    CocoonJS.App.setTextureReduction = function(sizeThreshold, applyTo, forbidFor)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultTextureReducerThreshold", arguments);
        }
    };


    /**
    * Prints to the console the memory usage of the currently alive textures
    * @function
    */
    CocoonJS.App.logMemoryInfo = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "logMemoryInfo", arguments);
        }
    };

    /**
    * Enable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.enableFPSInTheWebView = function(fpsLayout, textColor)
    {
        if (!CocoonJS.App.fpsInTheWebViewEnabled)
        {
            fpsLayout = fpsLayout ? fpsLayout : CocoonJS.App.FPSLayout.TOP_RIGHT;
            textColor = textColor ? textColor : "white";
            var jsCode = "" +
                "(function()" +
                "{" +
                    "var COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES = ['js/CocoonJSExtensions/CocoonJS.js', 'js/CocoonJSExtensions/CocoonJS_App.js', 'js/CocoonJSExtensions/CocoonJS_App_ForWebView.js'];" +
                    "var loadedScriptCounter = 0;" + 
                    "var loadedScriptFunction = function() " +
                    "{ " +
                        "loadedScriptCounter++;"+
                        "if (loadedScriptCounter >= COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length)"+
                        "{"+
                            "CocoonJS.App.enableFPS(" + JSON.stringify(fpsLayout) + ", " + JSON.stringify(textColor) + ");"+
                        "}"+
                    "};"+
                    "for (var i = 0; i < COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length; i++)"+
                    "{"+
                        "var s = document.createElement('script');"+
                        "s.onload = loadedScriptFunction;"+
                        "s.src = COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES[i];"+
                        "document.body.appendChild(s);"+
                    "}" +
                "})();";
            setTimeout(function()
            {
                CocoonJS.App.forward(jsCode);
            }, 3000);
            CocoonJS.App.fpsInTheWebViewEnabled = true;
        }
    };

    /**
    * Disable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.disableFPSInTheWebView = function()
    {
        // TODO: Implement this function.
    };

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewSucceed} event calls.
     * @name OnLoadInTheWebViewSucceedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load has completed successfully.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewSucceedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    * @param {string} pageURL A string that represents the page URL loaded.
    */
    CocoonJS.App.onLoadInTheWebViewSucceed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpageload");

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewFailed} event calls.
     * @name OnLoadInTheWebViewFailedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load fails.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewFailedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    */
    CocoonJS.App.onLoadInTheWebViewFailed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpagefail");
    
})();

//////////////////////////////////////
// COCOONJS_AD.JS                   //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS Advertisement extension API.
    * @namespace
    */
    CocoonJS.Ad = {};

    CocoonJS.Ad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_AD !== 'undefined';

    /**
    * The predefined possible layouts for a banner ad.
    * @namespace 
    */
	CocoonJS.Ad.BannerLayout = 
	{
		/**
		* Specifies that the banner must be shown in the top of the screen and vertically centered.
		*/
	    TOP_CENTER      : "TOP_CENTER",

		/**
		* Specifies that the banner must be shown in the bottom of the screen and vertically centered.
		*/
	    BOTTOM_CENTER   : "BOTTOM_CENTER"
	};

	/**
    * A rectangle object that contains the banner dimensions
    * @namespace 
    * @constructor
    * @param {int} x The top lef x coordinate of the rectangle.
    * @param {int} y The top lef y coordinate of the rectangle.
    * @param {width} y The rectangle width.
    * @param {height} y The rectangle height.
    */
	CocoonJS.Ad.Rectangle = function(x, y, width, height) 
	{
		/**
		* The top lef x coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.x = x;

		/**
		* The top lef y coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.y = y;

	    /**
		* The rectangle width
		* @field 
		* @type {int}
		*/
	    this.width = width;

	    /**
		* The rectangle height
		* @field 
		* @type {int}
		*/
	    this.height = height;
	};

	CocoonJS.Ad.Banner = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
    	* The callback function does not receive any parameter.
    	* @param {number} width The banner width
    	* @param {number} height The banner height
    	* @static
    	* @event
    	*/
		this.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener(args[1], args[2]);
    		}
    	});
	};

	CocoonJS.Ad.Banner.prototype = {

		/**
		* Shows a banner ad if available.
		* @function
		*/
		showBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", [this.id], true);
			}
		},

		/**
		* Hides the banner ad if it was being shown.
		* @function
		*/
		hideBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", [this.id], true);
			}
		},

		/**
		* Refreshes the banner.
		* @function
		*/
		refreshBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", [this.id], true);
			}
		},

		/**
		* Gets the rectangle representing the banner screen position.
		* @function
		* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
		*/
		getRectangle : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", [this.id]);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* @function
		* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
		*/
		setRectangle : function(rect)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", [this.id, rect],true);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* You can use this method if you want to have better control of the banner screen positioning.
		* @function
		* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
		*/
		setBannerLayout : function(bannerLayout)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", [this.id, bannerLayout],true);
			}
		}
	};

	CocoonJS.Ad.Fullscreen = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
		this.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

    	/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});
	};

	CocoonJS.Ad.Fullscreen.prototype = {

		/**
		* Shows a full screen ad if available.
		* @function
		* @see CocoonJS.Ad.onFullScreenShown
		* @see CocoonJS.Ad.onFullScreenHidden
		*/
		showFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", [this.id], true);
			}
		},

		/**
		* Refreshes the fullscreen.
		* @function
		*/
		refreshFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", [this.id], true);
			}
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Ad.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "requestInitialization", arguments, true);
		}
	};

	/**
	* Creates a new banner ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createBanner = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createBanner", [parameters]);
			var banner = new CocoonJS.Ad.Banner(adId);

			return banner;
		}
	};

	/**
	* Releases a banner.
	* @function
	* @param {object} The banner ad object to be released.
	*/
	CocoonJS.Ad.releaseBanner = function(banner)
	{
		if (typeof banner === "undefined") {
            throw "The banner ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseBanner", [banner.id]);
		}
	};

	/**
	* Creates a new fullscreen ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createFullscreen = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createFullscreen", [parameters]);
			var fullscreen = new CocoonJS.Ad.Fullscreen(adId);

			return fullscreen;
		}
	};

	/**
	* Releases a fullscreen ad.
	* @function
	* @param {object} The fullscreen ad object to be released.
	*/
	CocoonJS.Ad.releaseFullscreen = function(fullscreen)
	{
		if (typeof fullscreen === "undefined") {
            throw "The fullscreen ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseFullscreen", [fullscreen.id]);
		}
	};

	/**
	* Shows a banner ad if available.
	* @function
	* @see CocoonJS.Ad.setBannerLayout
	* @see CocoonJS.Ad.onBannerShown
	*/
	CocoonJS.Ad.showBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", arguments, true);
		}
	};

	/**
	* Hides the banner ad if it was being shown.
	* @function
	*/
	CocoonJS.Ad.hideBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", arguments, true);
		}
	};

	/**
	* Refreshes the banner.
	* @function
	*/
	CocoonJS.Ad.refreshBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", arguments, true);
		}
	};

	/**
	* Shows a full screen ad if available.
	* @function
	* @see CocoonJS.Ad.onFullScreenShown
	* @see CocoonJS.Ad.onFullScreenHidden
	*/
	CocoonJS.Ad.showFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", arguments, true);
		}
	};

	/**
	* Refreshes the fullscreen.
	* @function
	*/
	CocoonJS.Ad.refreshFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", arguments, true);
		}
	};

	/**
	* Makes a request to preload a banner ad.
	* @function
	*/
	CocoonJS.Ad.preloadBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadBanner", arguments, true);
		}
	};

	/**
	* Makes a request to preload a full screen ad.
	* @function
	*/
	CocoonJS.Ad.preloadFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadFullScreen", arguments, true);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* @function
	* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.setRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", arguments, true);
		}
	};

	/**
	* Gets the rectangle representing the banner screen position.
	* @function
	* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.getRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", arguments);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* You can use this method if you want to have better control of the banner screen positioning.
	* @function
	* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
	*/
	CocoonJS.Ad.setBannerLayout = function(bannerLayout)
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", arguments, true);
		}
	};

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide"); 

	/**
	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
	* The callback function does not receive any parameter.
	* @param {number} width The banner width
	* @param {number} height The banner height
	* @static
	* @event
	*/
	CocoonJS.Ad.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready"); 

})();

//////////////////////////////////////
// COCOONJS_STORE.JS                //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS In-App Purchase extension.
    * @namespace
    */
    CocoonJS.Store = {};

    CocoonJS.Store.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_STORE !== 'undefined';

	/**
	* The data structure that represents the information of a product in the store.
	* @namespace
	* @constructor
	* @param {string} The id of the product.
	* @param {string} The alias of the product.
	* @param {CocoonJS.Store.ProductType} The product type @see CocoonJS.Store.ProductType.
	* @param {string} The title of the product.
	* @param {string} The description of the product.
	* @param {string} The localized price of the product.
	* @param {string} The URL of the asset to be downloaded for this purchase.
	*/
	CocoonJS.Store.ProductInfo = function(productAlias, productId, productType, title, description, price, localizedPrice, downloadURL)
	{
		/**
		* The id of the product.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The alias of the product.
		* @field
		* @type string
		*/
		this.productAlias = productAlias;

		/**
		* The product type @see CocoonJS.Store.ProductType
		* @field
		* @type CocoonJS.Store.ProductType
		*/
		this.productType = productType;

		/**
		* The title of the product.
		* @field
		* @type string
		*/
		this.title = title;

		/**
		* The description of the product.
		* @field
		* @type string
		*/
		this.description = description;

		/**
		* The price of the product.
		* @field
		* @type string
		*/
		this.price = price;

		/**
		* The localized price of the product.
		* @field
		* @type string
		*/
		this.localizedPrice = localizedPrice;

		/**
		* The URL of the asset to be downloaded for this purchase.
		* @field
		* @type string
		*/
		this.downloadURL = downloadURL;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.ProductType = 
	{
		/**
		* A consumable product. See platform documentation for further information.
		*/
	    CONSUMABLE : 0,

		/**
		* A non-cunsumable product. . See platform documentation for further information.
		*/
	    NON_CONSUMABLE : 1,

	    /**
		* An auto-renewable subscription. See platform documentation for further information.
		*/
	    AUTO_RENEWABLE_SUBSCRIPTION : 2,

	    /**
		* A free subscription. See platform documentation for further information.
		*/
	    FREE_SUBSCRIPTION : 3,

	    /**
		* A non-renewable subscription. See platform documentation for further information.
		*/
	    NON_RENEWABLE_SUBSCRIPTION : 4
	};

	/**
    * The predefined possible store types.
    * @namespace 
    */
	CocoonJS.Store.StoreType = 
	{
		/**
		* Apple AppStore
		*/
	    APP_STORE : 0,

	    /**
	    * Android Play Store
	    */
	    PLAY_STORE : 1,

		/**
		* Mock Store
		*/
		MOCK_STORE : 2,

		/**
	    * Amazon AppStore
	    */
	    CHROME_STORE : 3,

	    /**
	    * Amazon AppStore
	    */
	    AMAZON_STORE : 4,

	    /**
	    * Nook Store
	    */
	    NOOK_STORE : 5
	};

	/**
	* The data structure that represents the information of a purchase.
	* @namespace
	* @constructor
	* @param {string} The transaction id of a purchase.
	* @param {string} The time when the purchase was done in seconds since 1970.
	* @param {CocoonJS.Store.PurchaseState} The state of the purchase. @see CocoonJS.Store.PurchaseState
	* @param {string} The product id related to this purchase.
	* @param {number} The number of products of the productId kind purchased in this transaction.
	*/
	CocoonJS.Store.PurchaseInfo = function(transactionId, purchaseTime, purchaseState, productId, quantity)
	{
		/**
		* The transaction id of a purchase.
		* @field
		* @type string
		*/
		this.transactionId = transactionId;

		/**
		* The time when the purchase was done in seconds since 1970.
		* @field
		* @type string
		*/
		this.purchaseTime = purchaseTime;

		/**
		* The state of the purchase. @see CocoonJS.Store.PurchaseState
		* @field
		* @type CocoonJS.Store.PurchaseState
		*/
		this.purchaseState = purchaseState;

		/**
		* The product id related to this purchase.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The number of products of the productId kind purchased in this transaction.
		* @field
		* @type number
		*/
		this.quantity = quantity;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.PurchaseState = 
	{
		/**
		* The product has been successfully purchased. The transaction has ended successfully.
		*/
	    PURCHASED : 0,

		/**
		* The purchase has been canceled.
		*/
	    CANCELED : 1,

	    /**
		* The purchase has been refunded.
		*/
	    REFUNDED : 2,

	    /**
		* The purchase (subscriptions only) has expired and is no longer valid.
		*/
	    EXPIRED : 3
	};

	/**
	* Gets the name of the native store implementation. 
	* @return {CocoonJS.Store.StoreType} The store type
	* @function
	*/ 
	CocoonJS.Store.getStoreType = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getStoreType", arguments);
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Store.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") 
        {
            parameters = {};
        }
        else
        {
        	if (parameters['managed'] !== undefined) parameters['remote'] = parameters['managed'];
        	if (parameters['sandbox'] !== undefined) parameters['debug'] = parameters['sandbox'];
        }

		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "requestInitialization", arguments, true);
		}
	};

	/**
	* Starts the Store Service. 
	* This will make the system to initialize the Store Service and probably Store callbacks will start to be received after calling this method so you should have set your event handler before calling this method so don't lose any callback.
	* @function
	*/ 
	CocoonJS.Store.start = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "start", arguments);
		}
	};

	/**
	* This method allows you to check is the  Store service is available in this platform. 
	* Not all iOS and Android devices will have the Store service available so you should check if it is before calling any other method.
	* @function
	* @return {boolean} True if the service is available and false otherwise.
	*/ 
	CocoonJS.Store.canPurchase = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "canPurchase", arguments);
		}
	};

	/**
	* Fetches the products from the CocoonJS Cloud Compiling service store configuration. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @deprecated You should now use fetchProductsFromStore. We don't support cloud products now.
	* @function
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromServer = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromServer", arguments, true);
		}
	};

	/**
	* Fetches the products information from the Store. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @function
	* @param {array} productIds An array with the ids of the products to retrieve information from.
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromStore = function(productIds)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromStore", arguments, true);
		}
	};

	/**
	* Finish a purchase transaction and removes the transaction from the transaction queue. 
	* This method must be called after a purchase finishes successfully and the  {@link CocoonJS.Store.onProductPurchaseCompleted} callback has been received. 
	* If the purchase includes some asset to download from an external server this method must be called after the asset has been successfully downloaded. 
	* If you do not finish the transaction because the asset has not been correctly downloaded the {@link CocoonJS.Store.onProductPurchaseStarted} method will be called again later on.
	* @function
	* @param {string} transactionId The transactionId of the purchase to finish.
	*/ 
	CocoonJS.Store.finishPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "finishPurchase", arguments, true);
		}
	};

	/**
	* Consumes a purchase. This makes that product to be purchasable again. 
	* @function
	* @param {string} transactionId The transaction Id of the purchase to consume.
	* @param {string} productId The product Id of the product to be consumed.
	*/ 
	CocoonJS.Store.consumePurchase = function(transactionId, productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "consumePurchase", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeature", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id showing a modal progress dialog. 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.puchaseProductModal = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModal", arguments, true);
		}
	};

	/**
	* Request the purchase of a product given it's product id showing a dialog with a preview of the product (title and description). 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProductModalWithPreview = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModalWithPreview", arguments, true);
		}
	};

	/**
	* Returns if a product has been already purchased or not. 
	* @function
	* @param {string} productId The product id or alias of the product to be checked.
	* @returns {boolean} A flag that indicates whether the product has been already purchased (true) or not (false).
	*/
	CocoonJS.Store.isProductPurchased = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "isFeaturePurchased", arguments);
		}
	};

	/**
	* Restores all the purchases from the platform's market. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchases", arguments, true);
		}
	};

	/**
	* Restores all the purchases from the platform's market showing a modal progress dialog. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchasesModal = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchasesModal", arguments, true);
		}
	};

	/**
	* Returns all the products available to be purchased.
	* @function
	* @returns {array} An array with  all the {@link CocoonJS.Store.ProductInfo} objects available for purchase.
	*/
	CocoonJS.Store.getProducts = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getProducts", arguments);
		}
	};

	/**
	* Adds a product to the products local DB. 
	* @function
	* @param {CocoonJS.Store.ProductInfo} product The product to be added to the local products DB.
	*/
	CocoonJS.Store.addProduct = function(product)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addProduct", arguments);
		}
	};

	/**
	* Removes a product from the products local DB given its productId. 
	* @function
	* @param {string} productId The product or alias of the product to be removed from the local products DB.
	*/
	CocoonJS.Store.removeProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removeProduct", arguments);
		}
	};

	/**
	* Returns all the locally stored purchases.
	* @function
	* @returns {array} An array with all the {@link CocoonJS.Store.PurchaseInfo} completed purchases.
	*/
	CocoonJS.Store.getPurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getPurchases", arguments);
		}
	};

	/**
	* Adds a purchase to the local purchases DB. 
	* @function
	* @param {CocoonJS.Store.StorePurchase} purchase The purchase to be added.
	*/ 
	CocoonJS.Store.addPurchase = function(purchase)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addPurchase", arguments);
		}
	};

	/**
	* Removes a purchase from the local purchases DB given it's transaction id. 
	* @function
	* @param {string} transactionId The id of the transaction to be removed.
	*/ 
	CocoonJS.Store.removePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removePurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase cancel. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be canceled.
	*/
	CocoonJS.Store.cancelPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "cancelPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase refundment. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be refunded.
	*/
	CocoonJS.Store.refundPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "refundPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase expiration. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be expired.
	*/
	CocoonJS.Store.expirePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "expirePurchase", arguments);
		}
	};

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onProductsFetchStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchStarted");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has completed.
    * The callback function receives a parameter with an the valid products array.
    * @static
    * @event
    * @param {array} validProducts An array of {@link CocoonJS.Store.ProductInfo} objects representing all the valid fetched products.
    */
	CocoonJS.Store.onProductsFetchCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onProductsFetchFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product starts.
    * The callback function receives a parameters with the information of the purchased product @see CocoonJS.Store.ProductInfo.
    * @static
	* @event
    * @param {string} productId The product id of the product being purchased.
    */
	CocoonJS.Store.onProductPurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseStarted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a request for purchase verification has been received from the Store.
    * The callback function receives two parameters, one with the productId of the purchased product and another one with a JSON object containing the data to be verified.
    * In Andorid this JSON object will containt two keys: signedData and signature. You will need that information to verify the purchase against the backend server.
    * @static
    * @event
    * @param {string} productId The product id of the product to be verified.
    * @param {string} data The string with the data to be verified.
    */
	CocoonJS.Store.onProductPurchaseVerificationRequestReceived = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseVerificationRequestReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product succeeds.
    * The callback function receives as parameter the information of the purchase {@see CocoonJS.Store.PurchaseInfo}.
    * @static
    * @event
    * @param {CocoonJS.Store.PurchaseInfo} purchaseInfo The purchase info.
    */
	CocoonJS.Store.onProductPurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product fails.
    * The callback function receives a parameters with the product id and an error message.
    * @static
    * @event
    * @param {string} productId The product id.
    * @param {string} msg The error message.
    */
	CocoonJS.Store.onProductPurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has completed.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onRestorePurchasesFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesFailed");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has started.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase being consumed.
    */
	CocoonJS.Store.onConsumePurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has completed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the consumed purchase.
    */
	CocoonJS.Store.onConsumePurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has failed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase that couldn't be consumed.
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onConsumePurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseFailed");

})();

//////////////////////////////////////
// COCOONJS_SOCIAL.JS               //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

	/**
	* This type represents the access to a native Social extension API. As there can be more than
	* one service of this type, more than one instance can be created.
	* @namespace
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	*/
	CocoonJS.Social = function(nativeExtensionName, extensionName)
	{
		if (typeof nativeExtensionName !== 'string') throw "The given native extension name '" + nativeExtensionName + "' is not a string.";
		if (typeof extensionName !== 'string') throw "The given extension name '" + extensionName + "' is not a string.";

		this.nativeExtensionName = nativeExtensionName;
		this.extensionName = extensionName;
	    this.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[nativeExtensionName] !== 'undefined';

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestInitializationSucceed} event calls.
	     * @name OnRequestInitializationSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {object} initializationData The data structure passed when requestInitialization was called.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestInitializationSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
	    this.onRequestInitializationSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestInitializationSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestInitializationFailed} event calls.
	     * @name OnRequestInitializationFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {object} initializationData The data structure passed when the requestInitialization function was called.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestInitializationFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
	    this.onRequestInitializationFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestInitializationFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestLoginSucceed} event calls.
	     * @name OnRequestLoginSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.UserInfo} userInfo The structure that describes the information of the user that logged in.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user login request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestLoginSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestLoginSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestLoginSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestLoginFailed} event calls.
	     * @name OnRequestLoginFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user login request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestLoginFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestLoginFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestLoginFailed");

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user logs out.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onLogout = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLogout");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserInfoSucceed} event calls.
	     * @name OnRequestUserInfoSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.UserInfo} userInfo The structure that describes the information of the request user id.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnUserInfoRequestSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserInfoSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserInfoSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserInfoFailed} event calls.
	     * @name OnRequestUserInfoFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id used in the request.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnUserInfoRequestFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserInfoFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserInfoFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserImageURLSucceed} event calls.
	     * @name OnRequestUserImageURLSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id used in the request.
	     * @param {string} imageURL The URL of the image of the requested user. 
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user image URL request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserImageURLSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserImageURLSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserImageURLSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserImageURLFailed} event calls.
	     * @name OnRequestUserImageURLFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id of the user the request was placed for.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user image URL request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserImageURLFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserImageURLFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserImageURLFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserFriendsUserInfosSucceed} event calls.
	     * @name OnRequestUserFriendsUserInfosSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id of the user for whom the friend user infos where requested.
	     * @param {array} friendsInfo An array of {@link CocoonJS.Social.UserInfo} objects representing the information of the friends of the user.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's friends info is successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserFriendsUserInfosSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserFriendsUserInfosSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserFriendsUserInfosSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserFriendsUserInfosFailed} event calls.
	     * @name OnRequestUserFriendsUserInfosFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param 
	     * @param {string} userID The id of the user fro whom the friends infos were requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's friends info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserFriendsUserInfosFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserFriendsUserInfosFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserFriendsUserInfosFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestMessagePublicationSucceed} event calls.
	     * @name OnRequestMessagePublicationSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
 	     * @param {CocoonJS.Social.Message} message The message that has been published.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user message publication request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestMessagePublicationSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    * @param {CocoonJS.Social.Message} message The message that has been published.
	    */
		this.onRequestMessagePublicationSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestMessagePublicationSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestMessagePublicationFailed} event calls.
	     * @name OnRequestMessagePublicationFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.Message} message The message that was supposed to be published.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user message publication request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestMessagePublicationFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestMessagePublicationFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestMessagePublicationFailed");

		/**
        * @ignore
        */
        this.on= function(event, callback) {
            event= "on"+event[0].toUpperCase()+event.substr(1);
            var signal= this[event];
            if (signal) {
                signal.addEventListener(callback);
            } else {
                console.error("SocialGaming service: '"+this.extensionName+"' does not understand '"+event+' signal.');
            }

            return this;
        };

	    return this;
	};

	CocoonJS.Social.prototype = {
        userInfo : null,
        userInfoCocoonJS : null,

        /**
        * @ignore
        */
        getUserInfo : function() {
            return this.userInfo;
        },

        /**
        * Returns the information of the currently logged in user.
        * @return {@link CocoonJS.Social.UserInfo}
        */
        getLoggedInUserInfo : function() {
            if (this.nativeExtensionObjectAvailable) {
                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getLoggedInUserInfo", arguments);
            }
            else {
                return this.userInfoCocoonJS;
            }
        },

        /**
        * @ignore
        */
        setUserInfo : function( userInfo) {
            this.userInfo= userInfo;
        },

        /**
        * @ignore
        */
        setUserInfoCocoonJS : function( userInfoCocoonJS ) {
            this.userInfoCocoonJS = userInfoCocoonJS;
        },

		/**
        * Request initialization of the underlying social service.
        * @param {object} paramsObject A data structure to initialize the service. It will be dependable of the underlying service.
        * @see CocoonJS.Social.onRequestInitializationSucceed
        * @see CocoonJS.Social.onRequestInitializationFailed
        */
		requestInitialization : function(paramsObject) 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestInitialization", arguments, true);
			}
		},

		/**
        * Returns a flag to indicate if the underlying service has been initialized or not.
        * @return {boolean} If the underlying service had been initialized using the requestInitialization function call.
        */
		isInitialized : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "isInitialized", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Request to log in the social gaming application.
		* @see CocoonJS.Social.onRequestLoginSucceed
		* @see CocoonJS.Socual.onRequestLoginFailed
		*/
		requestLogin : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestLogin", arguments, true);
			}
		},

		/**
		* Request to log out of the social gaming application.
		* @see CocoonJS.Social.onRequestLoginSucceed
		* @see CocoonJS.Social.onRequestLoginFailed
		* @see CocoonJS.Social.onLogout
		*/
		requestLogout : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestLogout", arguments, true);
			}
		},

		/**
		* Check if the user is logged in.
		* @return {boolean} true if the user is still logged in, false otherwise.
		*/
		isLoggedIn : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "isLoggedIn", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Returns all the granted permissions for the current session.
		* @return {Array} An array containin the user granted permissions.
		*/
		getPermissions : function() 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getPermissions", arguments);
			}
			else
			{
				return new Array();
			}
		},

		/**
		* Check if the user has granted the publish permission for the current session.
		* @return {boolean} true if the user has granted the publish permission for the current session, false otherwise.
		*/
		hasPublishPermission : function() 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "hasPublishPermission", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Request to retrieve the current or a specific user's id. The request can be monitored using the {@link CocoonJS.Social.onUserInfoRequestSucceed} and {@link CocoonJS.Social.onUserInfoRequestFailed} event handlers.
		* @param {string} [userId] The id of the user to retireve the information from. If no userID is specified, the currently logged in user is assumed.
		* @see CocoonJS.Social.onRequestUserInfoSucceed
		* @see CocoonJS.Social.onRequestUserInfoFailed
		*/
		requestUserInfo : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserInfo", arguments, true);
			}
		},

		/**
		* Request to retrieve the Image of a user
		* @param {string} [userID] The id of the user to get the image for. If no userID is specified, the currently logged user is used.
		* @param {CocoonJS.Social.ImageSizeType} [imageSizeType] The size of the image. One of the possible values among the ones in the {@link CocoonJS.Social.ImageSizeType}. If no value is specified, SMALL is used.
		* @see CocoonJS.Social.onRequestUserImageURLSucceed;
		* @see CocoonJS.Social.onRequestUserImageURLFailed;
		*/
		requestUserImageURL : function( imageSizeType, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserImageURL", arguments, true);
			}
		},

		/**
		* Request for the information of all the friends of the currently logged user.
		* @param {string} [userID] The id of the user to get the friends infos for. If no userID is specified, the currently logged user is used.
		* @see CocoonJS.Social.onRequestUserFriendsUserInfosSucceed;
		* @see CocoonJS.Social.onRequestUserFriendsUserInfosFailed;
		*/
		requestUserFriendsUserInfos : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserFriendsUserInfos", arguments, true);
			}
		},

		/**
		* Request the publication of a message using a dialog.
		* @param {CocoonJS.Social.Message} message A object representing the information to be published.
		* @see CocoonJS.Social.onRequestMessagePublicationSucceed
		* @see CocoonJS.Social.onRequestMessagePublicationFailed
		*/
		requestMessagePublicationWithDialog : function(message)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestMessagePublicationWithDialog", arguments, true);
			}
		}
	};

	/**
	* This structure represents the possible images to be obtained for a user in the social gaming extension.
	* @namespace
	*/
	CocoonJS.Social.ImageSizeType = 
	{
		/**
		* Represent a thumbnail like image size.
		*/
	    THUMB : "thumb",

		/**
		* Represents the small image size.
		*/
	    SMALL : "small",

		/**
		* Represents the medium image size.
		*/
	    MEDIUM : "medium",

		/**
		* Represents the large image size.
		*/
	    LARGE : "large"
	};

	/**
	* The data structure that represents the information of a user inside the social gaming extension.
	* @namespace
	* @constructor
	* @param {string} userID The id of the user.
	* @param {string} userName The user name of the user.
	*/
	CocoonJS.Social.UserInfo = function(userID, userName)
	{
		/**
		* The id of the user.
		* @field
		* @type string
		*/
		this.userID = userID;

		/**
		* The user name of the user.
		* @field
		* @type string
		*/
		this.userName = userName;
	};

	/**
	* This type represents a message to be published.
	* @namespace
	* @constructor
	* @param {string} message The message to be published.
	* @param {string} mediaURL An URL to a media (image, video, ...)
	* @param {string} linkURL An URL to add to the message so the user can click on that link to get more information.
	* @param {string} linkText The text that will appear in the message link.
	* @param {string} linkCaption The text caption that will appear in the message link.
	*/
	CocoonJS.Social.Message = function(message, mediaURL, linkURL, linkText, linkCaption)
	{
		/**
		* The message to be published.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* An URL to a media (image, video, ...)
		* @field
		* @type string
		*/
		this.mediaURL = mediaURL;

		/**
		* An URL to add to the message so the user can click on that link to get more information.
		* @field
		* @type string
		*/
		this.linkURL = linkURL;

		/**
		* The text that will appear in the message link.
		* @field
		* @type string
		*/
		this.linkText = linkText;

		/**
		* The text caption that will appear in the message link.
		* @field
		* @type string
		*/
		this.linkCaption = linkCaption;

		return this;
	};

})();

//////////////////////////////////////
// COCOONJS_SOCIALGAMING.JS         //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    if (!CocoonJS.Social)
		throw("The CocoonJS.Social object must exist and be valid before creating any extension object.");

	/**
	* This type represents the access to a native Social Gamming extension API. As there can be more than
	* one service of this type, more than one instance can be created.
	* @namespace
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	*/
	CocoonJS.SocialGaming = function(nativeExtensionName, extensionName)
	{
		CocoonJS.SocialGaming.superclass.constructor.call(this, nativeExtensionName, extensionName);

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAndFriendsScoresSucceed} event calls.
	     * @name OnRequestUserAndFriendsScoresSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {array} userAndFriendsScoreInfos An array of {@link CocoonJS.SocialGaming.UserScoreInfo} objects representing the information of the user's and friends' scores.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user and friends scores request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAndFriendsScoresSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAndFriendsScoresSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAndFriendsScoresSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAndFriendsScoresFailed} event calls.
	     * @name OnRequestUserAndFriendsScoresFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score and friends scores were requested.
	     * @param {string} leadeboardID The id of the leaderboard for whom the score and friends scores were requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user and his/her friends scores request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAndFriendsScoresFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAndFriendsScoresFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAndFriendsScoresFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserScoreSucceed} event calls.
	     * @name OnRequestUserScoreSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {CocoonJS.SocialGaming.UserScoreInfo} userScoreInfo The info of the user's score.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserScoreSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserScoreSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserScoreSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserScoreFailed} event calls.
	     * @name OnRequestUserScoreFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score was requested.
	     * @param {string} leaderboardID The id of the leaderboard for whom the score was requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserScoreFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserScoreFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserScoreFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserScoreSucceed} event calls.
	     * @name OnSubmitUserScoreSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score has been submitted.
	     * @param {string} leaderboardID The id of the leaderboard for which the score has been submitted.
	     * @param {number} score The score that has been submitted.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score submit suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserScoreSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserScoreSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserScoreSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserScoreFailed} event calls.
	     * @name OnSubmitUserScoreFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score submition was requested.
	     * @param {string} leaderboadID The id of the leaderboard for which the score submition was requested.
	     * @param {number} score The score that was submitted and failed.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score submit fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserScoreFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserScoreFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserScoreFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAchievementsSucceed} event calls.
	     * @name OnRequestUserAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements where requested.
	     * @param {array} achievementsInfos An array of {@link CocoonJS.SocialGaming.AchievementInfo} objects representing the information of the user's achievements.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievements info are successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAchievementsFailed} event calls.
	     * @name OnRequestUserAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements were requested.
	   	 * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievmeents info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAchievementsFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAllAchievementsSucceed} event calls.
	     * @name OnRequestAllAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {array} achievementsInfos An array of {@link CocoonJS.SocialGaming.AchievementInfo} objects representing the information of all the achievements.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievements info are successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAllAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAllAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAllAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAllAchievementsFailed} event calls.
	     * @name OnRequestAllAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	   	 * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievmeents info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAllAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAllAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAllAchievementsFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAchievementInfoSucceed} event calls.
	     * @name OnRequestAchievementInfoSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {CocoonJS.SocialGaming.AchievementInfo} achievementInfo A {@link CocoonJS.SocialGaming.AchievementInfo} object representing the information of the achievement.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the request to retrieve the information of an achievement succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAchievementInfoSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAchievementInfoSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAchievementInfoSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAchievementInfoFailed} event calls.
	     * @name OnRequestAchievementInfoFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} achievementID The id of the achievement for which the information retrieval was requested.
	     * @param {string} errorMessage The error message.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the request to retrieve the information of an achievement fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAchievementInfoFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAchievementInfoFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAchievementInfoFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserAchievementSucceed} event calls.
	     * @name OnSubmitUserAchievementSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievement has been submitted.
	     * @param {string} achievementID The id of the achievement that has been submitted.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement submition succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserAchievementSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserAchievementSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserAchievementSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserAchievementFailed} event calls.
	     * @name OnSubmitUserAchievementFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievment was submitted.
	     * @param {string} achievementID The id of the achievement that was submitted.
	     * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement submition fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserAchievementFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserAchievementFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserAchievementFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onResetUserAchievementsSucceed} event calls.
	     * @name OnResetUserAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements were reset.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnResetUserAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onResetUserAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onResetUserAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onResetUserAchievementsFailed} event calls.
	     * @name OnResetUserAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements where tried to be reset.
	     * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnResetUserAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onResetUserAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onResetUserAchievementsFailed");

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the users closes the achievements view.
	    * The callback function does not receive any parameter.
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewClosed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewClosed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onAchievementsViewFailed} event calls.
	     * @name OnAchievementsViewFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} errorMessage The message that describes why the call failed.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the achievements view failed to show.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnAchievementsViewFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewFailed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewFailed");

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when achievements view shows successfully.
	    * The callback function does not receive any parameter.
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewClosed} event calls.
	     * @name OnLeaderboardViewClosedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewClosedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewClosed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewClosed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewFailed} event calls.
	     * @name OnLeaderboardViewFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewFailed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewSucceed} event calls.
	     * @name OnLeaderboardViewSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewSucceed");

		return this;
	};

	CocoonJS.SocialGaming.prototype = 
	{
        abstractToSocialGamingAchievementMap : null,
        abstractToSocialGamingAchievementMapInverse : null,

        /**
        * @ignore
        */
        setAbstractToSocialGamingAchievementMap : function( map ) {
            this.abstractToSocialGamingAchievementMap= map;

            // build a reciprocal map.
            this.abstractToSocialGamingAchievementMapInverse= {};
            for( var id in map ) {
                if ( map.hasOwnProperty(id) ) {
                    this.abstractToSocialGamingAchievementMapInverse[ map[id] ]= id;
                }
            }
            return this;
        },

        /**
        * @ignore
        */
        getAbstractToSocialGamingAchievementTranslation : function( achievementID ) {
            /**
             * If a translation map for abstract in-game achievements has been set, translate achievementID from
             * abstract to SocialGamingService.
             */
            if (this.abstractToSocialGamingAchievementMap) {
                var socialGamingAchievementID = this.abstractToSocialGamingAchievementMap[achievementID];
                if (socialGamingAchievementID) {
                    console.log("Abstract achieventID='" + achievementID + "' turned to '" + socialGamingAchievementID + "'");
                    achievementID = socialGamingAchievementID;
                } else {
                    console.log("Something may be wrong: abstract achievementID: '" + achievementID + "' w/o translation.")
                }
            }

            return achievementID;
        },

		/**
		* Request to retrieve the scores of all friends of a given user.
		* @param {string} [leaderboardID] The id of the leaderboard to request the scores for.
		* @param {string} [userID] The id of the user. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onRequestUserAndFriendsScoresSucceed
		* @see CocoonJS.SocialGaming.onRequestUserAndFriendsScoresFailed
		*/
		requestUserAndFriendsScores : function(leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserAndFriendsScores", arguments, true);
			}
		},

		/**
		* Request to retrieve the score of a user.
		* @param {string} [leaderboardID] The id of the scores leaderboard to retireve the score from. If null or underfined is passed, the "leadeboard" id will be used.
		* @param {string} [userID] The id of the user to retireve the score from. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onRequestUserScoreSucceed
		* @see CocoonJS.SocualGaming.onRequestUserScoreFailed
		*/
		requestUserScore : function(leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserScore", arguments, true);
			}
		},

		/**
		* Request to the server the score of a user.
		* @param {number} [score] the score to submit
		* @param {string} [leaderboardID] The id of the scores leaderboard to submit the score to. If null or underfined is passed, the "leadeboard" id will be used.
		* @param {string} [userID] The id of the user to submit the score for. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onSubmitUserScoreSucceed
		* @see CocoonJS.SocualGaming.onSubmitUserScoreFailed
		*/
		submitUserScore : function(score, leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitUserScore", arguments, true);
			}
		},
		/**
		* Shows the leaderboard using a platform dependant view.
		* @param {string} [leaderboardID] The id of the scores leaderboard to show the view for. If null or underfined is passed, the "leadeboard" id will be used.
		* @see CocoonJS.SocialGaming.onLeaderboardViewClosed
		*/
		showLeaderboardView : function(leaderboardID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showLeaderboardView", arguments, true);
			}
		},

		/**
		* Request to retrieve the user achievements. The request can be monitored using the {@link CocoonJS.SocialGaming.onRequestUserAchievementsSucceed} and {@link CocoonJS.Social.onRequestUserAchievementsFailed} event handlers.
		* @param {string} [userID] The id of the user to retireve the achievements from. if null/undefined/"" is specified, the currently logged in user is assumed.
		* @see CocoonJS.SocialGaming.onRequestUserAchievementsSucceed
		* @see CocoonJS.SocialGaming.onRequestUserAchievementsFailed
		*/
		requestUserAchievements : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserAchievements", arguments, true);
			}
		},

		/**
		* Request to retrieve all the achievements. The request can be monitored using the {@link CocoonJS.SocialGaming.onRequestAllAchievementsSucceed} and {@link CocoonJS.Social.onRequestAllAchievementsFailed} event handlers.
		* @see CocoonJS.SocialGaming.onRequestAllAchievementsSucceed
		* @see CocoonJS.SocialGaming.onRequestAllAchievementsFailed
		*/
		requestAllAchievements : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestAllAchievements", arguments, true);
			}
		},

		/**
		* Request to retrieve the information about an achievement. 
		* @param {string} achievementID The id of the achievement to get the information for.
		* @param {CocoonJS.Social.ImageSizeType} [imageSizeType] The size of the image. One of the possible values among the ones in the {@link CocoonJS.Social.ImageSizeType}
		*/
		requestAchievementInfo : function(achievementID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestAchievementInfo", arguments, true);
			}
		},

		/**
		* Submits an achievement to the server. If the process fails, the achievement is stored to submit it later.
		* @param {string} [achievementID] the achievement identifier
		* @param {number} [percentComplete] an optional number between 0 and 100 that indicates a completion percentage.
		* @see CocoonJS.SocialGaming.onSubmitAchievementSucceed
		* @see CocoonJS.SocualGaming.onSubmitAchievementFailed
		*/
        submitUserAchievement:function (achievementID, userID) {
            achievementID = this.getAbstractToSocialGamingAchievementTranslation(achievementID);

            if (this.nativeExtensionObjectAvailable) {
                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitUserAchievement", arguments, true);
            }
        },

		/**
		* Shows the achievements using a platform dependant view.
		* @see CocoonJS.SocialGaming.onAchievementsViewClosed
		*/
		showUserAchievementsView : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showUserAchievementsView", arguments, true);
			}
		},

		/**
		* Resets all the achievements of the current user
		* @param {string} [userID] The id of the user to reset the achievements for. If null/undefined/"", the logged in user is assumed.
		* @see CocoonJS.SocialGaming.onResetAchievementsSucceed
		* @see CocoonJS.SocualGaming.onResetAchievementsFailed
		*/
		resetUserAchievements : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "resetUserAchievements", arguments, true);
			}
		}
	};

	/**
    * @ignore
    */
	CocoonJS.extend(CocoonJS.SocialGaming, CocoonJS.Social);

	/**
	* The data structure that represents the information of the user score in the application.
	* @namespace
	* @constructor
	* @param {string} userID The user id.
	* @param {number} score The score of the user.
	* @param {string} userName The name of the user.
	* @param {string} imageURL The url of the user image.
	* @param {number} leaderboardID The id of the leaderboard the score belongs to.
	*/
	CocoonJS.SocialGaming.UserScoreInfo = function(userID, score, userName, imageURL, leaderboardID)
	{
		/**
		* The user id. 
		* @type string
		*/
		this.userID = userID;

		/**
		* The score of the user.
		* @type number
		*/
		this.score = score ? score : 0;

		/**
		* The name of the user.
		* @type string
		*/
        this.userName = userName;

		/**
		* The url of the user image.
		* @type string
		*/
        this.imageURL = imageURL;

        /**
		* The id of the leaderboard the score belongs to.
		* @type number
		*/
        this.leaderboardID = leaderboardID;
	};

	/**
	* The data structure that represents the information of an achievement in the application.
	* @namespace
	* @constructor
	* @param {string} achievementID The id of the achievement info.
	* @param {string} title The title of the achievement.
	* @param {string} description The description of the achievement.
	* @param {string} imageURL The url to the image representing the achievement.
	* @param {number} points The points value of the achievement
	*/
	CocoonJS.SocialGaming.AchievementInfo = function(achievementID, title, description, imageURL, points)
	{
		/**
		* The id of the achievement info.
		* @type string
		*/
		this.achievementID = achievementID;

		/**
		* The title of the achievement.
		* @type string
		*/
		this.title = title;

		/**
		* The description of the achievement.
		* @type string
		*/
		this.description = description;

		/**
		* The url to the image representing the achievement.
		* @type string
		*/
		this.imageURL = imageURL;

		/**
		* The points value of the achievement
		* @type number
		*/
		this.points = points ? points : 0;
	};

})();

/////////////////////////////////////////
// COCOONJS_SOCIALGAMING_GAMECENTER.JS //
/////////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (typeof window.CocoonJS.SocialGaming === 'undefined' || window.CocoonJS === null) throw("The CocoonJS.SocialGaming object must exist and be valid before creating a Game Center extension object.");

	/**
	* This instance represents the extension object to access GameCenter related native functionalities.
	* The data structure for initialization: None.
	* @see CocoonJS.Social
	*/
	CocoonJS.SocialGaming.GameCenter = new CocoonJS.SocialGaming("IDTK_SRV_SOCIAL_GAMECENTER", "SocialGaming.GameCenter");
})();

//////////////////////////////
// COCOONJS_GAMEPAD.JS 		//
//////////////////////////////

(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents the functionalities related to OUYA android gaming control.
     * @namespace
     */
    CocoonJS.Gamepad = {};

    CocoonJS.Gamepad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.Gamepad !== 'undefined';

    CocoonJS.Gamepad.Indices = {
        BUTTON_0                : 0, 
        BUTTON_1                : 1,
        BUTTON_2                : 2,
        BUTTON_3                : 3,
        BUTTON_LEFT_BUMPER      : 4,
        BUTTON_RIGHT_BUMPER     : 5,
        
        BUTTON_LEFT_TRIGGER     : 6,
        BUTTON_RIGHT_TRIGGER    : 7,
        
        BUTTON_LEFT_JOYSTICK    : 10,
        BUTTON_RIGHT_JOYSTICK   : 11,
        BUTTON_DPAD_UP          : 12,
        BUTTON_DPAD_DOWN        : 13,
        BUTTON_DPAD_LEFT        : 14,
        BUTTON_DPAD_RIGHT       : 15,
        BUTTON_MENU             : 16,
        
        AXE_LEFT_JOYSTICK_X     : 0,
        AXE_LEFT_JOYSTICK_Y     : 1,
        AXE_RIGHT_JOYSTICK_X    : 2,
        AXE_RIGHT_JOYSTICK_Y    : 3
    };

    // If the extension is present and the navigator does not provide the gamepad API:
    // 1.- Add the getGamepads function to the navigator object.
    // 2.- Replace the window add and remove event listener functions to call to the extension for the gamepad related events.
    var systemSupportsGamepads = navigator["getGamepads"] || navigator["webkitGetGamepads"];
    if (CocoonJS.Gamepad.nativeExtensionObjectAvailable && !systemSupportsGamepads)
    {
        navigator.getGamepads = function()
        {
            return window.ext.Gamepad.makeCall("getGamepads");
        };

        CocoonJS.Gamepad.originalWindowAddEventListener = window.addEventListener;
        CocoonJS.Gamepad.originalWindowRemoveEventListener = window.removeEventListener;

        window.addEventListener = function(eventName, callback)
        {
            console.log("The new window.addEventListener has been called.");
            if (eventName === "gamepadconnected" || eventName === "gamepaddisconnected")
            {
                window.ext.Gamepad.addEventListener(eventName, callback);
            }
            else
            {
                var argumentsArray = Array.prototype.slice.call(arguments);
                CocoonJS.Gamepad.originalWindowAddEventListener.apply(window, argumentsArray);
            }
        };
        window.removeEventListener = function(eventName, callback)
        {
            console.log("The new window.removeEventListener has been called.");
            if (eventName === "gamepadconnected" || eventName === "gamepaddisconnected")
            {
                window.ext.Gamepad.removeEventListener(eventName, callback);
            }
            else
            {
                var argumentsArray = Array.prototype.slice.call(arguments);
                CocoonJS.Gamepad.originalWindowRemoveEventListener.apply(window, argumentsArray);
            }
        };
    } 
    else if (systemSupportsGamepads) 
    {
        if (!navigator.getGamepads)
        {
            console.log("navigator.getGamepads does not exist.");
            if (navigator.webkitGetGamepads)
            {
                console.log("navigator.webkitGamepads exists, adding navigator.getGamepads to point to it.");
                navigator.getGamepads = navigator.webkitGetGamepads;
            }
            else
            {
                console.log("navigator.webkitGetGamepads does not exist either.");
            }
        }
    }
})();

//////////////////////////////
// COCOONJS_NOTIFICATION.JS //
//////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS Notification extension.
    * @namespace
    */
    CocoonJS.Notification = {};

    CocoonJS.Notification.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_NOTIFICATION !== 'undefined';

	/**
	* The data structure that represents the information of a local notification.
	* @namespace
	* @constructor
	* @param {string} message The notification message.
	* @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
	* @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
	* @param {object} userData The JSON data to attached to the notification.
	* @param {string} contentBody The body content to be showed in the expanded notification information.
	* @param {string} contentTitle The title to be showed in the expanded notification information.
	* @param {number} date Time in millisecs from 1970 when the notification will be fired.
	*/
	CocoonJS.Notification.LocalNotification = function(message, soundEnabled, badgeNumber, userData, contentBody, contentTitle, scheduleTime)
	{
		/**
		* The notification message.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* A flag that indicates if the sound should be enabled for the notification.
		* @field
		* @type boolean
		*/
		this.soundEnabled = soundEnabled;

		/**
		* (iOS only) The number that will appear in the badge of the application icon in the home screen.
		* @field
		* @type number
		*/
		this.badgeNumber = badgeNumber;

		/**
		* The JSON data to attached to the notification.
		* @field
		* @type object
		*/
		this.userData = userData;

		/**
		* (Android only) The body content to be showed in the expanded notification information.
		* @field
		* @type string
		*/
		if (contentBody !== undefined)
			this.contentBody = contentBody;
		else
			this.contentBody = "";

		/**
		* (Android only) The title to be showed in the expanded notification information.
		* @field
		* @type string
		*/
		if (contentTitle !== undefined)
			this.contentTitle = contentTitle;
		else
			this.contentTitle = "";

		/**
		* Time in millisecs from 1970 when the local notification will be fired
		* @field
		* @type number
		*/
		var currentTime = new Date().getTime();
		if (scheduleTime !== undefined){
			this.scheduleTime = scheduleTime;
		}else{
			this.scheduleTime = currentTime;
		}
	};

	/**
	* The data structure that represents the information of a push notification.
	* @namespace
	* @constructor
	* @param {string} message The notification message.
	* @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
	* @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
	* @param {object} userData The JSON data to attached to the notification.
	* @param {array} channels An array containing the channels names this notification will be delivered to.
	* @param {number} expirationTime A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
	* @param {number} expirationTimeInterval An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
	*/
	CocoonJS.Notification.PushNotification = function(message, soundEnabled, badgeNumber, userData, channels, expirationTime, expirationTimeInterval)
	{
		/**
		* The notification message.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* A flag that indicates if the sound should be enabled for the notification.
		* @field
		* @type boolean
		*/
		this.soundEnabled = soundEnabled;

		/**
		* The number that will appear in the badge of the application icon in the home screen.
		* @field
		* @type number
		*/
		this.badgeNumber = badgeNumber;

		/**
		* The JSON data to attached to the notification.
		* @field
		* @type object
		*/
		this.userData = userData

		/**
		* An array containing the channels names this notification will be delivered to.
		* @field
		* @type array
		*/
		this.channels = channels;

		/**
		* A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
		* @field
		* @type number
		*/
		if (expirationTime !== undefined)
			this.expirationTime = expirationTime;
		else
			this.expirationTime = 0;

		/**
		* An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
		* @field
		* @type number
		*/
		if (expirationTimeInterval !== undefined)
			this.expirationTimeInterval = expirationTimeInterval;
		else
			this.expirationTimeInterval = 0;
	};

	/**
	* Start processing received notifications. The user must call this method when the game is ready to process notifications. Notifications received before being prepared are stored and processed later.
	*/
	CocoonJS.Notification.start = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "start", arguments, true);
		}
	};


	/**
	* Register to be able to receive push notifications.
	* The registration process is controlled using the {@link CocoonJS.Notification.onRegisterForPushNotificationsSucceed} and {@link CocoonJS.Notification.onRegisterForPushNotificationsFailed} event handlers.
	* @function
	* @see {CocoonJS.Notification.onRegisterForPushNotificationsSucceed}
	* @see {CocoonJS.Notification.onRegisterForPushNotificationsFailed}
	*/
	CocoonJS.Notification.registerForPushNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "registerForPushNotifications", arguments, true);
		}
	};

	/**
	* Unregister from receiving push notifications.
	* The unregistration process is controlled using the {@link CocoonJS.Notification.onUnregisterForPushNotificationsSucceed} event handler.
	* @function
	* @see CocoonJS.Notification.onUnregisterForPushNotificationsSucceed
	*/
	CocoonJS.Notification.unregisterForPushNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unregisterForPushNotifications", arguments, true);
		}
	};

	/**
	* Cancel the last sent local notification.
	* The last sent local notification will be remove from the notifications bar.
	* @function
	*/
	CocoonJS.Notification.cancelLastSentLocalNotificiation = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelLocalNotification", arguments, true);
		}
	};

	/**
	* Cancel all sent local notifications.
	* All the notifications will ve removed from the notifications bar.
	* @function
	*/
	CocoonJS.Notification.cancelAllLocalNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelAllLocalNotifications", arguments, true);
		}
	};

	/**
	* Send a local notification.
	* @function
	* @param {CocoonJS.Notification.LocalNotification} localNotification The local notification to be sent.
	*/
	CocoonJS.Notification.sendLocalNotification = function(localNotification)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendLocalNotification", arguments, true);
		}
	};

	/**
	* Subscribe to a channel in order to receive notifications targeted to that channel.
	* @function
	* @param {string} channel The channel id to subscribe to.
	*/
	CocoonJS.Notification.subscribeToChannel = function(channel)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "subscribe", arguments, true);
		}
	};

	/**
	* Unsubscribe from a channel in order to stop receiving notifications targeted to it.
	* @function
	* @param {string} channel The channel id to unsubscribe from.
	*/
	CocoonJS.Notification.unsubscribeFromChannel = function(channel)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unsubscribe", arguments, true);
		}
	};

	/**
	* Send a push notification.
	* @function
	* @param {CocoonJS.Notification.PushNotification} pushNotification The push notification object to be sent.
	* @see CocoonJS.Notification.onPushNotificationDeliverySucceed
	* @see CocoonJS.Notification.onPushNotificationDeliveryFailed
	*/
	CocoonJS.Notification.sendPushNotification = function(pushNotification)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendPushNotification", arguments, true);
		}
	};

	/**
	* (iOS only) Set the badge number for this application.
	* This is useful if you want to modify the badge number set by a notification.
	* @function
	* @param {number} badgeNumber The number of the badge.
	*/
	CocoonJS.Notification.setBadgeNumber = function(badgeNumber)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "setBadgeNumber", arguments);
		}
	};

	/**
	* (iOS only) Returns the current badge number.
	* @function
	* @returns {number} The badge number.
	*/
	CocoonJS.Notification.getBadgeNumber = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getBadgeNumber", arguments);
		}
	};

	/**
	* Returns the last received user data from a Local notification.
	* @function
	* @returns {object} The last received user data from a Local notification.
	*/
	CocoonJS.Notification.getLastReceivedLocalNotificationData = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedLocalNotificationData", arguments);
		}
	};

	/**
	* Returns the last received user data from a Push notification.
	* @function
	* @returns {object} The last received user data from a Push notification.
	*/
	CocoonJS.Notification.getLastReceivedPushNotificationData = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedPushNotificationData", arguments);
		}
	};

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notification succeeds.
    * The callback function does not receive any parameter.
    * @static
    * @event
    * @param {string} token The token (apid or device token) received at registration time.
    * @memberOf CocoonJS.Notification
    */
	CocoonJS.Notification.onRegisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceRegistered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the unregistration for push notifications succeeds.
    * The callback function does not receive any parameter.
    * @static
    * @event
    * @memberOf CocoonJS.Notification
    */
	CocoonJS.Notification.onUnregisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceUnregistered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notifications fails.
    * The callback function receives a parameter with error information.
    * @static
    * @event
    * @param {string} msg The error message.
    */
	CocoonJS.Notification.onRegisterForPushNotificationsFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceFailedToRegister");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a push notification is received.
    * The callback function receives a parameter with the userData of the received notification.
    * @static
    * @event
    * @param {object} userData An object with the notification userData information.
    */
	CocoonJS.Notification.onPushNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a local notification is received.
    * The callback function receives a parameter with the userData of the received notification.
    * @static
    * @event
    * @param {object} userData An object with the notification userData information.
    */
	CocoonJS.Notification.onLocalNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "localNotificationReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a notification is successfully delivered.
    * The callback function receives a parameter with the notificationId of the delivered notification.
    * @static
    * @event
    * @param {string} userData A string with the notification userData information.
    */
	CocoonJS.Notification.onPushNotificationDeliverySucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationSuccessfullyDelivered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the delivery of push a notification fails.
    * The callback function receives a parameter with error information.
    * @static
    * @event
    * @param {string} msg The error message.
    */
	CocoonJS.Notification.onPushNotificationDeliveryFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationDeliveryError");

})();

/////////////////
// PATHFIND.JS //
/////////////////

// Pathfind.js
// Written by Ashley Gullen
// Copyright (c) 2013 Scirra Ltd.

// A* pathfinding javascript implementation

(function() {
	
	var PF_CLEAR = 0;
	var PF_OBSTACLE = 32767;
	
	function node()
	{
		this.parent = null;
		
		this.x = 0;
		this.y = 0;

		this.f = 0;
		this.g = 0;
		this.h = 0;
	};
	
	var nodeCache = [];			// for recycling nodes
	
	function allocNode()
	{
		var ret;
		
		if (nodeCache.length)
			ret = nodeCache.pop();
		else
			ret = new node();
			
		ret.parent = null;
		ret.x = 0;
		ret.y = 0;
		ret.f = 0;
		ret.g = 0;
		ret.h = 0;
		return ret;
	};
	
	function freeNode(n)
	{
		if (nodeCache.length < 64000)
			nodeCache.push(n);
	};
	
	function resultNode(x_, y_)
	{
		this.x = x_ || 0;
		this.y = y_ || 0;
	};
	
	var resultNodeCache = [];			// for recycling resultNodes
	
	function allocResultNode()
	{
		if (resultNodeCache.length)
			return resultNodeCache.pop();
		else
			return new resultNode(0, 0);
	};
	
	function freeResultNode(n)
	{
		if (resultNodeCache.length < 10000)
			resultNodeCache.push(n);
	};
	
	var workersSupported = (typeof Worker !== "undefined");
	var isInWebWorker = (typeof document === "undefined");		// no DOM in a worker
	var myInstance = null;										// single pathfinder instance for worker
	
	if (isInWebWorker)
	{
		self.addEventListener("message", function (e)
		{
			var d = e.data;
			
			if (!d)
				return;		// could be empty postMessage() to start worker
			
			if (d.cmd === "init")
			{
				if (!myInstance)
					myInstance = new pathfinder();
					
				myInstance.init(d.hcells, d.vcells, d.data, d.diagonals);
			}
			else if (d.cmd === "find")
			{
				// receive a pathfind job, process it them dispatch result
				myInstance.pathEnd.parent = null;
				myInstance.targetX = d.endX;
				myInstance.targetY = d.endY;
				
				if (myInstance.doLongFindPath(d.startX, d.startY))
				{
					self.postMessage({ cmd: "result", pathList: myInstance.pathList });
				}
				else
				{
					self.postMessage({ cmd: "result", pathList: null });
				}
			}
			else if (d.cmd === "setdiag")
			{
				// update diagonalsEnabled flag
				myInstance.diagonalsEnabled = d.diagonals;
			}
			
		}, false);
	}
	
	function pathfinder()
	{
		this.hcells = 0;
		this.vcells = 0;
		
		this.pathEnd = allocNode();
		
		this.cells = null;
		this.openList = [];
		this.closedList = [];
		this.closedCache = {};
		this.pathList = [];
		
		this.currentNode = null;
		this.targetX = 0;
		this.targetY = 0;
		this.diagonalsEnabled = true;
		
		this.worker = null;
		this.workerQueue = [];		// jobs awaiting completion from worker in order of requests made
		this.workerRecycle = [];
		
		var self = this;
		var i, len;
		
		if (workersSupported && !isInWebWorker)
		{
			// Create worker and receive results of pathfind jobs from it
			this.worker = new Worker("pathfind.js");
			
			this.worker.addEventListener("message", function (e) {
			
				if (!e || !e.data)
					return;
				
				if (e.data.cmd === "result")
				{
					if (e.data.pathList)
					{
						for (i = 0, len = self.pathList.length; i < len; i++)
							freeResultNode(self.pathList[i]);
						
						self.pathList = e.data.pathList;
						self.workerQueue[0].success();
					}
					else
						self.workerQueue[0].fail();
						
					self.workerRecycle.push(self.workerQueue.shift());
				}
			}, false);
			
			this.worker.addEventListener("error", function (e) {
				console.error(e);
			}, false);
			
			this.worker.postMessage(null);
		}
	};
	
	pathfinder.prototype.init = function (hcells_, vcells_, data_, diagonals_)
	{
		this.hcells = hcells_;
		this.vcells = vcells_;
		this.cells = data_;
		this.diagonalsEnabled = diagonals_;
		
		if (workersSupported && !isInWebWorker)
		{
			this.worker.postMessage({
				cmd: "init",
				hcells: hcells_,
				vcells: vcells_,
				diagonals: diagonals_,
				data: data_
			});
		}
	};
	
	pathfinder.prototype.isReady = function ()
	{
		return !!this.cells;
	};
	
	pathfinder.prototype.setDiagonals = function (d)
	{
		if (this.diagonalsEnabled === d)
			return;
		
		this.diagonalsEnabled = d;
		
		if (workersSupported && !isInWebWorker)
		{
			this.worker.postMessage({
				cmd: "setdiag",
				diagonals: d,
			});
		}
	};
	
	pathfinder.prototype.at = function (x_, y_)
	{
		if (x_ < 0 || y_ < 0 || x_ >= this.hcells || y_ >= this.vcells)
			return PF_OBSTACLE;
			
		return this.cells[x_][y_];
	};
	
	pathfinder.prototype.findPath = function (startX, startY, endX, endY, successCallback, failCallback)
	{
		if (!this.cells)
		{
			// not yet initialised
			failCallback();
			return;
		}
		
		startX = Math.floor(startX);
		startY = Math.floor(startY);
		endX = Math.floor(endX);
		endY = Math.floor(endY);
		
		this.targetX = endX;
		this.targetY = endY;
		this.pathEnd.parent = null;
		
		// Check the box made by the start and dest cells.
		// If the complete box is empty, allow a direct move to target.
		var minX = Math.min(startX, endX);
		var maxX = Math.max(startX, endX);
		var minY = Math.min(startY, endY);
		var maxY = Math.max(startY, endY);
		
		// Path goes out of bounds: no calculable path
		if (minX < 0 || minY < 0 || maxX >= this.hcells || maxY >= this.vcells)
		{
			failCallback();
			return;
		}
		
		var x, y, i, len, c, h, n;

		if (this.diagonalsEnabled)
		{
			var canMoveDirect = true;
			
			for (x = minX; x <= maxX; x++)
			{
				for (y = minY; y <= maxY; y++)
				{
					if (this.cells[x][y] !== 0)
					{
						canMoveDirect = false;
						
						// Break both loops
						x = maxX + 1;
						break;
					}
				}
			}

			// A "direct" path is available (box is empty)
			if (canMoveDirect)
			{
				for (i = 0, len = this.pathList.length; i < len; i++)
					freeResultNode(this.pathList[i]);
				this.pathList.length = 0;
			
				this.pathEnd.x = endX;
				this.pathEnd.y = endY;
				this.pathEnd.parent = null;
				n = allocResultNode();
				n.x = endX;
				n.y = endY;
				this.pathList.push(n);
				successCallback();
				return;
			}
		}
		
		if (workersSupported)
		{
			// recycle objects in the worker queue
			if (this.workerRecycle.length)
				h = this.workerRecycle.pop();
			else
				h = {};
			
			h.success = successCallback;
			h.fail = failCallback;
			
			// dispatch the heavy lifting to the worker thread
			this.workerQueue.push(h);

			this.worker.postMessage({
				cmd: "find",
				startX: startX,
				startY: startY,
				endX: endX,
				endY: endY
			});
		}
		else
		{
			// no web worker support, just run on main thread
			if (this.doLongFindPath(startX, startY))
				successCallback();
			else
				failCallback();
		}
	};
		
	pathfinder.prototype.doLongFindPath = function (startX, startY)
	{
		var i, len, c, n, p, lastDir = 8, curDir = -1, addNode;
		for (i = 0, len = this.openList.length; i < len; i++)
			freeNode(this.openList[i]);
		for (i = 0, len = this.closedList.length; i < len; i++)
			freeNode(this.closedList[i]);
		for (i = 0, len = this.pathList.length; i < len; i++)
			freeResultNode(this.pathList[i]);
		this.openList.length = 0;
		this.closedList.length = 0;
		this.closedCache = {};
		this.pathList.length = 0;

		// Add the start node to the open list
		var startNode = allocNode();
		startNode.x = startX;
		startNode.y = startY;

		this.openList.push(startNode);
		var obsLeft = false, obsTop = false, obsRight = false, obsBottom = false;
		var diagonals = this.diagonalsEnabled;
		
		// While there are nodes on the open list
		while (this.openList.length)
		{
			// Move the best F value to closed list
			c = this.openList.shift();
			this.closedList.unshift(c);
			this.closedCache[((c.x << 16) + c.y).toString()] = true;

			// Are we there yet?
			if (c.x === this.targetX && c.y === this.targetY)
			{
				this.pathEnd.parent = c.parent;
				this.pathEnd.x = c.x;
				this.pathEnd.y = c.y;
				
				// Link up the whole path to an indexable array
				p = this.pathEnd;
				
				while (p)
				{
					// filter redundant nodes in straight lines
					if (this.pathList.length === 0)
					{
						addNode = true;
						
						if (p.parent)
						{
							lastDir = this.nodeDirection(p, p.parent);
							curDir = lastDir;
						}
					}
					else if (!p.parent)
						addNode = false;
					else 
					{
						curDir = this.nodeDirection(p, p.parent);
						addNode = (curDir !== lastDir);
					}
					
					if (addNode)
					{
						n = allocResultNode();
						n.x = p.x;
						n.y = p.y;
						this.pathList.unshift(n);
						lastDir = curDir;
					}
					
					p = p.parent;
				}
				
				return true;
			}

			// Get current node
			this.currentNode = c;
			var x = c.x;
			var y = c.y;
			
			var obsLeft = (this.at(x - 1, y) === PF_OBSTACLE);
			var obsTop = (this.at(x, y - 1) === PF_OBSTACLE);
			var obsRight = (this.at(x + 1, y) === PF_OBSTACLE);
			var obsBottom = (this.at(x, y + 1) === PF_OBSTACLE);

			// Check adjacent 8 nodes.  No diagonals allowed if either cell being crossed is obstacle.
			if (!obsLeft)
				this.addCellToOpenList(x - 1, y, 10);

			if (diagonals && !obsLeft && !obsTop)
				this.addCellToOpenList(x - 1, y - 1, 14);

			if (!obsTop)
				this.addCellToOpenList(x, y - 1, 10);

			if (diagonals && !obsTop && !obsRight)
				this.addCellToOpenList(x + 1, y - 1, 14);

			if (!obsRight)
				this.addCellToOpenList(x + 1, y, 10);

			if (diagonals && !obsRight && !obsBottom)
				this.addCellToOpenList(x + 1, y + 1, 14);

			if (!obsBottom)
				this.addCellToOpenList(x, y + 1, 10);

			if (diagonals && !obsBottom && !obsLeft)
				this.addCellToOpenList(x - 1, y + 1, 14);
		}
		
		return false;
	};
	
	pathfinder.prototype.insertToOpenList = function (c)
	{
		var i, len;
		
		// Needs to go at end
		if (c.f >= this.openList[this.openList.length - 1].f)
		{
			this.openList.push(c);
		}
		else
		{
			for (i = 0, len = this.openList.length; i < len; i++)
			{
				if (c.f < this.openList[i].f)
				{
					this.openList.splice(i, 0, c);
					break;
				}
			}
		}
	};
	
	pathfinder.prototype.addCellToOpenList = function (x_, y_, g_)
	{
		// Ignore if cell on closed list
		if (this.closedCache.hasOwnProperty(((x_ << 16) + y_).toString()))
			return;
		
		var i, len, c;
		
		// Cell costs can be increased by changing the number in the map
		var curCellCost = this.at(x_, y_);

		// Is this cell already on the open list?
		for (i = 0, len = this.openList.length; i < len; i++)
		{
			c = this.openList[i];
			
			if (x_ === c.x && y_ === c.y)
			{
				// Is this a better path?
				if (this.currentNode.g + g_ + curCellCost < c.g)
				{
					// Update F, G and H and update parent
					c.parent = this.currentNode;
					c.g = this.currentNode.g + g_ + curCellCost;
					c.h = this.estimateH(c.x, c.y);
					c.f = c.g + c.h;

					// This node's F has changed:  Delete it then re-insert it in the right place

					if (this.openList.length === 1)
					{
						// no need to remove then re-insert same node, just leave it there
						return;
					}
					
					this.openList.splice(i, 1);
					this.insertToOpenList(c);
				}

				return;
			}
		}

		// Not on the open list; add it in the right place
		c = allocNode();
		c.x = x_;
		c.y = y_;
		c.h = this.estimateH(x_, y_);
		c.g = this.currentNode.g + g_ + curCellCost;
		c.f = c.h + c.g;
		c.parent = this.currentNode;

		// Insert this node sorted in the open list
		// The loop below won't add new largest F values
		if (!this.openList.length)
		{
			this.openList.push(c);
			return;
		}
		
		this.insertToOpenList(c);
	};
	
	function quickAbs(x)
	{
		return x < 0 ? -x : x;
	};
	
	pathfinder.prototype.estimateH = function (x_, y_)
	{
		var dx = quickAbs(x_ - this.targetX);
		var dy = quickAbs(y_ - this.targetY);

		return dx * 10 + dy * 10;
	};
	
	pathfinder.prototype.nodeDirection = function (a, b)
	{
		var ax = a.x;
		var ay = a.y;
		var bx = b.x;
		var by = b.y;

		if (ax === bx)
		{
			if (by > ay) return 6;
			if (by < ay) return 2;
			if (ay == by) return 8;
		}
		else if (ay === by)
		{
			if (bx > ax) return 4;
			if (by < ax) return 0;
		}
		else
		{
			if (bx < ax && by < ay) return 1;
			if (bx > ax && by < ay) return 3;
			if (bx < ax && by > ay) return 7;
			if (bx > ax && by > ay) return 5;
		}
		return 8;
	};
	
	if (!isInWebWorker)
	{
		window.PF_CLEAR = PF_CLEAR;
		window.PF_OBSTACLE = PF_OBSTACLE;
		window.Pathfinder = pathfinder;
		
		window.ResultNode = resultNode;
		window.allocResultNode = allocResultNode;
		window.freeResultNode = freeResultNode;
	}

})();
(function() {
'use strict';var cr={plugins_:{},behaviors:{}};"function"!==typeof Object.getPrototypeOf&&(Object.getPrototypeOf="object"===typeof"test".__proto__?function(a){return a.__proto__}:function(a){return a.constructor.prototype});
(function(){function a(g,k){this.x=g;this.y=k;cr.seal(this)}function c(g,k,a,e){this.set(g,k,a,e);cr.seal(this)}function b(){this.bly=this.blx=this.bry=this.brx=this.try_=this.trx=this.tly=this.tlx=0;cr.seal(this)}function d(g,k,a,e){g<k?a<e?(q=g<a?g:a,u=k>e?k:e):(q=g<e?g:e,u=k>a?k:a):a<e?(q=k<a?k:a,u=g>e?g:e):(q=k<e?k:e,u=g>a?g:a)}function f(){this.items=this.s=null;this.item_count=0;w&&(this.s=new Set);this.values_cache=[];this.cache_valid=!0;cr.seal(this)}function e(g){v[A++]=g}function h(){this.sum=
this.t=this.y=this.c=0;cr.seal(this)}function p(g){this.pts_cache=[];this.bboxBottom=this.bboxRight=this.bboxTop=this.bboxLeft=0;this.convexpolys=null;this.set_pts(g);cr.seal(this)}function m(g,k){this.cellwidth=g;this.cellheight=k;this.cells={}}function n(C,k,a){var e;m.prototype.totalCellCount++;return g.length?(e=g.pop(),e.grid=C,e.x=k,e.y=a,e):new cr.GridCell(C,k,a)}function l(g,k,a){this.grid=g;this.x=k;this.y=a;this.objects=new cr.ObjectSet}cr.logexport=function(g){window.console&&window.console.log&&
window.console.log(g)};cr.seal=function(g){return g};cr.freeze=function(g){return g};cr.is_undefined=function(g){return"undefined"===typeof g};cr.is_number=function(g){return"number"===typeof g};cr.is_string=function(g){return"string"===typeof g};cr.isPOT=function(g){return 0<g&&0===(g-1&g)};cr.nextHighestPowerOfTwo=function(g){--g;for(var k=1;32>k;k<<=1)g|=g>>k;return g+1};cr.abs=function(g){return 0>g?-g:g};cr.max=function(g,k){return g>k?g:k};cr.min=function(g,k){return g<k?g:k};cr.PI=Math.PI;
cr.round=function(g){return g+0.5|0};cr.floor=function(g){return 0<=g?g|0:(g|0)-1};cr.ceil=function(g){var k=g|0;return k===g?k:k+1};a.prototype.offset=function(g,k){this.x+=g;this.y+=k;return this};a.prototype.mul=function(g,k){this.x*=g;this.y*=k;return this};cr.vector2=a;cr.segments_intersect=function(g,k,a,e,b,v,c,h){var f,y,d,m;g<a?(y=g,f=a):(y=a,f=g);b<c?(m=b,d=c):(m=c,d=b);if(f<m||y>d)return!1;k<e?(y=k,f=e):(y=e,f=k);v<h?(m=v,d=h):(m=h,d=v);if(f<m||y>d)return!1;f=b-g+c-a;y=v-k+h-e;g=a-g;k=
e-k;b=c-b;v=h-v;h=cr.abs(k*b-v*g);return cr.abs(b*y-v*f)>h?!1:cr.abs(g*y-k*f)<=h};c.prototype.set=function(g,k,a,e){this.left=g;this.top=k;this.right=a;this.bottom=e};c.prototype.copy=function(g){this.left=g.left;this.top=g.top;this.right=g.right;this.bottom=g.bottom};c.prototype.width=function(){return this.right-this.left};c.prototype.height=function(){return this.bottom-this.top};c.prototype.offset=function(g,k){this.left+=g;this.top+=k;this.right+=g;this.bottom+=k;return this};c.prototype.normalize=
function(){var g=0;this.left>this.right&&(g=this.left,this.left=this.right,this.right=g);this.top>this.bottom&&(g=this.top,this.top=this.bottom,this.bottom=g)};c.prototype.intersects_rect=function(g){return!(g.right<this.left||g.bottom<this.top||g.left>this.right||g.top>this.bottom)};c.prototype.intersects_rect_off=function(g,k,a){return!(g.right+k<this.left||g.bottom+a<this.top||g.left+k>this.right||g.top+a>this.bottom)};c.prototype.contains_pt=function(g,k){return g>=this.left&&g<=this.right&&k>=
this.top&&k<=this.bottom};c.prototype.equals=function(g){return this.left===g.left&&this.top===g.top&&this.right===g.right&&this.bottom===g.bottom};cr.rect=c;b.prototype.set_from_rect=function(g){this.tlx=g.left;this.tly=g.top;this.trx=g.right;this.try_=g.top;this.brx=g.right;this.bry=g.bottom;this.blx=g.left;this.bly=g.bottom};b.prototype.set_from_rotated_rect=function(g,k){if(0===k)this.set_from_rect(g);else{var a=Math.sin(k),e=Math.cos(k),b=g.left*a,v=g.top*a,c=g.right*a,a=g.bottom*a,h=g.left*
e,f=g.top*e,y=g.right*e,e=g.bottom*e;this.tlx=h-v;this.tly=f+b;this.trx=y-v;this.try_=f+c;this.brx=y-a;this.bry=e+c;this.blx=h-a;this.bly=e+b}};b.prototype.offset=function(g,k){this.tlx+=g;this.tly+=k;this.trx+=g;this.try_+=k;this.brx+=g;this.bry+=k;this.blx+=g;this.bly+=k;return this};var q=0,u=0;b.prototype.bounding_box=function(g){d(this.tlx,this.trx,this.brx,this.blx);g.left=q;g.right=u;d(this.tly,this.try_,this.bry,this.bly);g.top=q;g.bottom=u};b.prototype.contains_pt=function(g,k){var a=this.trx-
this.tlx,e=this.try_-this.tly,b=this.brx-this.tlx,v=this.bry-this.tly,c=g-this.tlx,h=k-this.tly,f=a*a+e*e,y=a*b+e*v,e=a*c+e*h,d=b*b+v*v,m=b*c+v*h,A=1/(f*d-y*y),a=(d*e-y*m)*A,f=(f*m-y*e)*A;if(0<=a&&0<f&&1>a+f)return!0;a=this.blx-this.tlx;e=this.bly-this.tly;f=a*a+e*e;y=a*b+e*v;e=a*c+e*h;A=1/(f*d-y*y);a=(d*e-y*m)*A;f=(f*m-y*e)*A;return 0<=a&&0<f&&1>a+f};b.prototype.at=function(g,k){if(k)switch(g){case 0:return this.tlx;case 1:return this.trx;case 2:return this.brx;case 3:return this.blx;case 4:return this.tlx;
default:return this.tlx}else switch(g){case 0:return this.tly;case 1:return this.try_;case 2:return this.bry;case 3:return this.bly;case 4:return this.tly;default:return this.tly}};b.prototype.midX=function(){return(this.tlx+this.trx+this.brx+this.blx)/4};b.prototype.midY=function(){return(this.tly+this.try_+this.bry+this.bly)/4};b.prototype.intersects_segment=function(g,k,a,e){if(this.contains_pt(g,k)||this.contains_pt(a,e))return!0;var b,v,c,h,f;for(f=0;4>f;f++)if(b=this.at(f,!0),v=this.at(f,!1),
c=this.at(f+1,!0),h=this.at(f+1,!1),cr.segments_intersect(g,k,a,e,b,v,c,h))return!0;return!1};b.prototype.intersects_quad=function(g){var k=g.midX(),a=g.midY();if(this.contains_pt(k,a))return!0;k=this.midX();a=this.midY();if(g.contains_pt(k,a))return!0;var e,b,v,c,h,f,y,d;for(y=0;4>y;y++)for(d=0;4>d;d++)if(k=this.at(y,!0),a=this.at(y,!1),e=this.at(y+1,!0),b=this.at(y+1,!1),v=g.at(d,!0),c=g.at(d,!1),h=g.at(d+1,!0),f=g.at(d+1,!1),cr.segments_intersect(k,a,e,b,v,c,h,f))return!0;return!1};cr.quad=b;cr.RGB=
function(g,k,a){return Math.max(Math.min(g,255),0)|Math.max(Math.min(k,255),0)<<8|Math.max(Math.min(a,255),0)<<16};cr.GetRValue=function(g){return g&255};cr.GetGValue=function(g){return(g&65280)>>8};cr.GetBValue=function(g){return(g&16711680)>>16};cr.shallowCopy=function(g,k,a){for(var e in k)k.hasOwnProperty(e)&&(g[e]=k[e]);return g};cr.arrayRemove=function(g,k){var a,e;k=cr.floor(k);if(!(0>k||k>=g.length)){a=k;for(e=g.length-1;a<e;a++)g[a]=g[a+1];g.length=e}};cr.shallowAssignArray=function(g,k){g.length=
k.length;var a,e;a=0;for(e=k.length;a<e;a++)g[a]=k[a]};cr.appendArray=function(g,k){g.push.apply(g,k)};cr.fastIndexOf=function(g,k){var a,e;a=0;for(e=g.length;a<e;++a)if(g[a]===k)return a;return-1};cr.arrayFindRemove=function(g,k){var a=cr.fastIndexOf(g,k);-1!==a&&cr.arrayRemove(g,a)};cr.clamp=function(g,k,a){return g<k?k:g>a?a:g};cr.to_radians=function(g){return g/(180/cr.PI)};cr.to_degrees=function(g){return g*(180/cr.PI)};cr.clamp_angle_degrees=function(g){g%=360;0>g&&(g+=360);return g};cr.clamp_angle=
function(g){g%=2*cr.PI;0>g&&(g+=2*cr.PI);return g};cr.to_clamped_degrees=function(g){return cr.clamp_angle_degrees(cr.to_degrees(g))};cr.to_clamped_radians=function(g){return cr.clamp_angle(cr.to_radians(g))};cr.angleTo=function(g,k,a,e){return Math.atan2(e-k,a-g)};cr.angleDiff=function(g,k){if(g===k)return 0;var a=Math.sin(g),e=Math.cos(g),b=Math.sin(k),v=Math.cos(k),a=a*b+e*v;return 1<=a?0:-1>=a?cr.PI:Math.acos(a)};cr.angleRotate=function(g,k,a){var e=Math.sin(g),b=Math.cos(g),v=Math.sin(k),c=Math.cos(k);
return Math.acos(e*v+b*c)>a?0<b*v-e*c?cr.clamp_angle(g+a):cr.clamp_angle(g-a):cr.clamp_angle(k)};cr.angleClockwise=function(g,k){var a=Math.sin(g),e=Math.cos(g),b=Math.sin(k),v=Math.cos(k);return 0>=e*b-a*v};cr.rotatePtAround=function(g,k,a,e,b,v){if(0===a)return v?g:k;var c=Math.sin(a);a=Math.cos(a);g-=e;k-=b;var h=g*c;g=g*a-k*c;k=k*a+h;return v?g+e:k+b};cr.distanceTo=function(g,k,a,e){g=a-g;k=e-k;return Math.sqrt(g*g+k*k)};cr.xor=function(g,k){return!g!==!k};cr.lerp=function(g,k,a){return g+(k-
g)*a};cr.unlerp=function(g,k,a){return g===k?0:(a-g)/(k-g)};cr.anglelerp=function(g,k,a){var e=cr.angleDiff(g,k);return cr.angleClockwise(k,g)?g+e*a:g-e*a};cr.qarp=function(g,k,a,e){return cr.lerp(cr.lerp(g,k,e),cr.lerp(k,a,e),e)};cr.cubic=function(g,k,a,e,b){return cr.lerp(cr.qarp(g,k,a,b),cr.qarp(k,a,e,b),b)};cr.cosp=function(g,k,a){return(g+k+(g-k)*Math.cos(a*Math.PI))/2};cr.hasAnyOwnProperty=function(g){for(var k in g)if(g.hasOwnProperty(k))return!0;return!1};cr.wipe=function(g){for(var k in g)g.hasOwnProperty(k)&&
delete g[k]};var r=+new Date;cr.performance_now=function(){if("undefined"!==typeof window.performance){var g=window.performance;if("undefined"!==typeof g.now)return g.now();if("undefined"!==typeof g.webkitNow)return g.webkitNow();if("undefined"!==typeof g.mozNow)return g.mozNow();if("undefined"!==typeof g.msNow)return g.msNow()}return Date.now()-r};var t=!1,x=t=!1,s=!1;"undefined"!==typeof window&&(t=/chrome/i.test(navigator.userAgent)||/chromium/i.test(navigator.userAgent),t=!t&&/safari/i.test(navigator.userAgent),
x=/(iphone|ipod|ipad)/i.test(navigator.userAgent),s=window.c2ejecta);var w=!t&&!s&&!x&&"undefined"!==typeof Set&&"undefined"!==typeof Set.prototype.forEach;f.prototype.contains=function(g){return this.isEmpty()?!1:w?this.s.has(g):this.items&&this.items.hasOwnProperty(g)};f.prototype.add=function(g){if(w)this.s.has(g)||(this.s.add(g),this.cache_valid=!1);else{var k=g.toString(),a=this.items;a?a.hasOwnProperty(k)||(a[k]=g,this.item_count++,this.cache_valid=!1):(this.items={},this.items[k]=g,this.item_count=
1,this.cache_valid=!1)}};f.prototype.remove=function(g){if(!this.isEmpty())if(w)this.s.has(g)&&(this.s["delete"](g),this.cache_valid=!1);else if(this.items){g=g.toString();var k=this.items;k.hasOwnProperty(g)&&(delete k[g],this.item_count--,this.cache_valid=!1)}};f.prototype.clear=function(){this.isEmpty()||(w?this.s.clear():(this.items=null,this.item_count=0),this.values_cache.length=0,this.cache_valid=!0)};f.prototype.isEmpty=function(){return 0===this.count()};f.prototype.count=function(){return w?
this.s.size:this.item_count};var v=null,A=0;f.prototype.update_cache=function(){if(!this.cache_valid){if(w)this.values_cache.length=this.s.size,v=this.values_cache,A=0,this.s.forEach(e),v=null,A=0;else{var g=this.values_cache;g.length=this.item_count;var k,a=0,b=this.items;if(b)for(k in b)b.hasOwnProperty(k)&&(g[a++]=b[k])}this.cache_valid=!0}};f.prototype.valuesRef=function(){this.update_cache();return this.values_cache};cr.ObjectSet=f;var y=new cr.ObjectSet;cr.removeArrayDuplicates=function(g){var k,
a;k=0;for(a=g.length;k<a;++k)y.add(g[k]);cr.shallowAssignArray(g,y.valuesRef());y.clear()};h.prototype.add=function(g){this.y=g-this.c;this.t=this.sum+this.y;this.c=this.t-this.sum-this.y;this.sum=this.t};h.prototype.reset=function(){this.sum=this.t=this.y=this.c=0};cr.KahanAdder=h;cr.regexp_escape=function(g){return g.replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&")};p.prototype.set_pts=function(g){this.pts_array=g;this.pts_count=g.length/2;this.pts_cache.length=g.length;this.cache_height=this.cache_width=
-1;this.cache_angle=0};p.prototype.is_empty=function(){return!this.pts_array.length};p.prototype.update_bbox=function(){for(var g=this.pts_cache,k=g[0],a=k,e=g[1],b=e,v,c,h=1,f=this.pts_count;h<f;++h)c=2*h,v=g[c],c=g[c+1],v<k&&(k=v),v>a&&(a=v),c<e&&(e=c),c>b&&(b=c);this.bboxLeft=k;this.bboxRight=a;this.bboxTop=e;this.bboxBottom=b};p.prototype.set_from_rect=function(g,k,a){this.pts_cache.length=8;this.pts_count=4;var e=this.pts_cache;e[0]=g.left-k;e[1]=g.top-a;e[2]=g.right-k;e[3]=g.top-a;e[4]=g.right-
k;e[5]=g.bottom-a;e[6]=g.left-k;e[7]=g.bottom-a;this.cache_width=g.right-g.left;this.cache_height=g.bottom-g.top;this.update_bbox()};p.prototype.set_from_quad=function(g,k,a,e,b){this.pts_cache.length=8;this.pts_count=4;var v=this.pts_cache;v[0]=g.tlx-k;v[1]=g.tly-a;v[2]=g.trx-k;v[3]=g.try_-a;v[4]=g.brx-k;v[5]=g.bry-a;v[6]=g.blx-k;v[7]=g.bly-a;this.cache_width=e;this.cache_height=b;this.update_bbox()};p.prototype.set_from_poly=function(g){this.pts_count=g.pts_count;cr.shallowAssignArray(this.pts_cache,
g.pts_cache);this.bboxLeft=g.bboxLeft;this.bboxTop-g.bboxTop;this.bboxRight=g.bboxRight;this.bboxBottom=g.bboxBottom};p.prototype.cache_poly=function(g,k,a){if(this.cache_width!==g||this.cache_height!==k||this.cache_angle!==a){this.cache_width=g;this.cache_height=k;this.cache_angle=a;var e,b,v,c,h,f=0,y=1,d=this.pts_array,m=this.pts_cache;0!==a&&(f=Math.sin(a),y=Math.cos(a));a=0;for(v=this.pts_count;a<v;a++)e=2*a,b=e+1,c=d[e]*g,h=d[b]*k,m[e]=c*y-h*f,m[b]=h*y+c*f;this.update_bbox()}};p.prototype.contains_pt=
function(g,k){var a=this.pts_cache;if(g===a[0]&&k===a[1])return!0;var e,b,v,c=this.pts_count,h=this.bboxLeft-110,f=this.bboxTop-101,y=this.bboxRight+131,d=this.bboxBottom+120,m,A,p=0,q=0;for(e=0;e<c;e++)b=2*e,v=2*((e+1)%c),m=a[b],b=a[b+1],A=a[v],v=a[v+1],cr.segments_intersect(h,f,g,k,m,b,A,v)&&p++,cr.segments_intersect(y,d,g,k,m,b,A,v)&&q++;return 1===p%2||1===q%2};p.prototype.intersects_poly=function(g,k,a){var e=g.pts_cache,b=this.pts_cache;if(this.contains_pt(e[0]+k,e[1]+a)||g.contains_pt(b[0]-
k,b[1]-a))return!0;var v,c,h,f,y,d,m,A,p,q,l,n;v=0;for(f=this.pts_count;v<f;v++)for(c=2*v,h=2*((v+1)%f),A=b[c],c=b[c+1],p=b[h],q=b[h+1],h=0,m=g.pts_count;h<m;h++)if(y=2*h,d=2*((h+1)%m),l=e[y]+k,y=e[y+1]+a,n=e[d]+k,d=e[d+1]+a,cr.segments_intersect(A,c,p,q,l,y,n,d))return!0;return!1};p.prototype.intersects_segment=function(g,k,a,e,b,v){var c=this.pts_cache;if(this.contains_pt(a-g,e-k))return!0;var h,f,y,d,m,A;h=0;for(f=this.pts_count;h<f;h++)if(y=2*h,d=2*((h+1)%f),m=c[y]+g,y=c[y+1]+k,A=c[d]+g,d=c[d+
1]+k,cr.segments_intersect(a,e,b,v,m,y,A,d))return!0;return!1};p.prototype.mirror=function(g){var k,a,e;k=0;for(a=this.pts_count;k<a;++k)e=2*k,this.pts_cache[e]=2*g-this.pts_cache[e]};p.prototype.flip=function(g){var k,a,e;k=0;for(a=this.pts_count;k<a;++k)e=2*k+1,this.pts_cache[e]=2*g-this.pts_cache[e]};p.prototype.diag=function(){var g,k,a,e,b;g=0;for(k=this.pts_count;g<k;++g)a=2*g,e=a+1,b=this.pts_cache[a],this.pts_cache[a]=this.pts_cache[e],this.pts_cache[e]=b};cr.CollisionPoly=p;m.prototype.totalCellCount=
0;m.prototype.getCell=function(g,k,a){var e;e=this.cells[g];return e?(e=e[k])?e:a?(e=n(this,g,k),this.cells[g][k]=e):null:a?(e=n(this,g,k),this.cells[g]={},this.cells[g][k]=e):null};m.prototype.XToCell=function(g){return cr.floor(g/this.cellwidth)};m.prototype.YToCell=function(g){return cr.floor(g/this.cellheight)};m.prototype.update=function(k,a,e){var b,v,c,h,f;if(a)for(b=a.left,v=a.right;b<=v;++b)for(c=a.top,h=a.bottom;c<=h;++c)if(!e||!e.contains_pt(b,c))if(f=this.getCell(b,c,!1))f.remove(k),f.isEmpty()&&
(m.prototype.totalCellCount--,f.objects.clear(),1E3>g.length&&g.push(f),this.cells[b][c]=null);if(e)for(b=e.left,v=e.right;b<=v;++b)for(c=e.top,h=e.bottom;c<=h;++c)a&&a.contains_pt(b,c)||this.getCell(b,c,!0).insert(k)};m.prototype.queryRange=function(g,k){var a,e,b,v,c,h;a=this.XToCell(g.left);b=this.YToCell(g.top);e=this.XToCell(g.right);for(c=this.YToCell(g.bottom);a<=e;++a)for(v=b;v<=c;++v)(h=this.getCell(a,v,!1))&&h.dump(k)};cr.SparseGrid=m;var g=[];l.prototype.isEmpty=function(){return this.objects.isEmpty()};
l.prototype.insert=function(g){this.objects.add(g)};l.prototype.remove=function(g){this.objects.remove(g)};l.prototype.dump=function(g){cr.appendArray(g,this.objects.valuesRef())};cr.GridCell=l;var k="lighter xor copy destination-over source-in destination-in source-out destination-out source-atop destination-atop".split(" ");cr.effectToCompositeOp=function(g){return 0>=g||11<=g?"source-over":k[g-1]};cr.setGLBlend=function(g,k,a){if(a)switch(g.srcBlend=a.ONE,g.destBlend=a.ONE_MINUS_SRC_ALPHA,k){case 1:g.srcBlend=
a.ONE;g.destBlend=a.ONE;break;case 3:g.srcBlend=a.ONE;g.destBlend=a.ZERO;break;case 4:g.srcBlend=a.ONE_MINUS_DST_ALPHA;g.destBlend=a.ONE;break;case 5:g.srcBlend=a.DST_ALPHA;g.destBlend=a.ZERO;break;case 6:g.srcBlend=a.ZERO;g.destBlend=a.SRC_ALPHA;break;case 7:g.srcBlend=a.ONE_MINUS_DST_ALPHA;g.destBlend=a.ZERO;break;case 8:g.srcBlend=a.ZERO;g.destBlend=a.ONE_MINUS_SRC_ALPHA;break;case 9:g.srcBlend=a.DST_ALPHA;g.destBlend=a.ONE_MINUS_SRC_ALPHA;break;case 10:g.srcBlend=a.ONE_MINUS_DST_ALPHA,g.destBlend=
a.SRC_ALPHA}};cr.round6dp=function(g){return Math.round(1E6*g)/1E6};cr.equals_nocase=function(g,k){return"string"!==typeof g||"string"!==typeof k||g.length!==k.length?!1:g===k?!0:g.toLowerCase()===k.toLowerCase()};cr.isCanvasInputEvent=function(g){g=g.target;return!g||g===document||g===window||document&&document.body&&g===document.body||cr.equals_nocase(g.tagName,"canvas")?!0:!1}})();
var MatrixArray="undefined"!==typeof Float32Array?Float32Array:Array,glMatrixArrayType=MatrixArray,vec3={},mat3={},mat4={},quat4={};vec3.create=function(a){var c=new MatrixArray(3);a&&(c[0]=a[0],c[1]=a[1],c[2]=a[2]);return c};vec3.set=function(a,c){c[0]=a[0];c[1]=a[1];c[2]=a[2];return c};vec3.add=function(a,c,b){if(!b||a===b)return a[0]+=c[0],a[1]+=c[1],a[2]+=c[2],a;b[0]=a[0]+c[0];b[1]=a[1]+c[1];b[2]=a[2]+c[2];return b};
vec3.subtract=function(a,c,b){if(!b||a===b)return a[0]-=c[0],a[1]-=c[1],a[2]-=c[2],a;b[0]=a[0]-c[0];b[1]=a[1]-c[1];b[2]=a[2]-c[2];return b};vec3.negate=function(a,c){c||(c=a);c[0]=-a[0];c[1]=-a[1];c[2]=-a[2];return c};vec3.scale=function(a,c,b){if(!b||a===b)return a[0]*=c,a[1]*=c,a[2]*=c,a;b[0]=a[0]*c;b[1]=a[1]*c;b[2]=a[2]*c;return b};
vec3.normalize=function(a,c){c||(c=a);var b=a[0],d=a[1],f=a[2],e=Math.sqrt(b*b+d*d+f*f);if(e){if(1===e)return c[0]=b,c[1]=d,c[2]=f,c}else return c[0]=0,c[1]=0,c[2]=0,c;e=1/e;c[0]=b*e;c[1]=d*e;c[2]=f*e;return c};vec3.cross=function(a,c,b){b||(b=a);var d=a[0],f=a[1];a=a[2];var e=c[0],h=c[1];c=c[2];b[0]=f*c-a*h;b[1]=a*e-d*c;b[2]=d*h-f*e;return b};vec3.length=function(a){var c=a[0],b=a[1];a=a[2];return Math.sqrt(c*c+b*b+a*a)};vec3.dot=function(a,c){return a[0]*c[0]+a[1]*c[1]+a[2]*c[2]};
vec3.direction=function(a,c,b){b||(b=a);var d=a[0]-c[0],f=a[1]-c[1];a=a[2]-c[2];c=Math.sqrt(d*d+f*f+a*a);if(!c)return b[0]=0,b[1]=0,b[2]=0,b;c=1/c;b[0]=d*c;b[1]=f*c;b[2]=a*c;return b};vec3.lerp=function(a,c,b,d){d||(d=a);d[0]=a[0]+b*(c[0]-a[0]);d[1]=a[1]+b*(c[1]-a[1]);d[2]=a[2]+b*(c[2]-a[2]);return d};vec3.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+"]"};
mat3.create=function(a){var c=new MatrixArray(9);a&&(c[0]=a[0],c[1]=a[1],c[2]=a[2],c[3]=a[3],c[4]=a[4],c[5]=a[5],c[6]=a[6],c[7]=a[7],c[8]=a[8]);return c};mat3.set=function(a,c){c[0]=a[0];c[1]=a[1];c[2]=a[2];c[3]=a[3];c[4]=a[4];c[5]=a[5];c[6]=a[6];c[7]=a[7];c[8]=a[8];return c};mat3.identity=function(a){a[0]=1;a[1]=0;a[2]=0;a[3]=0;a[4]=1;a[5]=0;a[6]=0;a[7]=0;a[8]=1;return a};
mat3.transpose=function(a,c){if(!c||a===c){var b=a[1],d=a[2],f=a[5];a[1]=a[3];a[2]=a[6];a[3]=b;a[5]=a[7];a[6]=d;a[7]=f;return a}c[0]=a[0];c[1]=a[3];c[2]=a[6];c[3]=a[1];c[4]=a[4];c[5]=a[7];c[6]=a[2];c[7]=a[5];c[8]=a[8];return c};mat3.toMat4=function(a,c){c||(c=mat4.create());c[15]=1;c[14]=0;c[13]=0;c[12]=0;c[11]=0;c[10]=a[8];c[9]=a[7];c[8]=a[6];c[7]=0;c[6]=a[5];c[5]=a[4];c[4]=a[3];c[3]=0;c[2]=a[2];c[1]=a[1];c[0]=a[0];return c};
mat3.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+", "+a[4]+", "+a[5]+", "+a[6]+", "+a[7]+", "+a[8]+"]"};mat4.create=function(a){var c=new MatrixArray(16);a&&(c[0]=a[0],c[1]=a[1],c[2]=a[2],c[3]=a[3],c[4]=a[4],c[5]=a[5],c[6]=a[6],c[7]=a[7],c[8]=a[8],c[9]=a[9],c[10]=a[10],c[11]=a[11],c[12]=a[12],c[13]=a[13],c[14]=a[14],c[15]=a[15]);return c};
mat4.set=function(a,c){c[0]=a[0];c[1]=a[1];c[2]=a[2];c[3]=a[3];c[4]=a[4];c[5]=a[5];c[6]=a[6];c[7]=a[7];c[8]=a[8];c[9]=a[9];c[10]=a[10];c[11]=a[11];c[12]=a[12];c[13]=a[13];c[14]=a[14];c[15]=a[15];return c};mat4.identity=function(a){a[0]=1;a[1]=0;a[2]=0;a[3]=0;a[4]=0;a[5]=1;a[6]=0;a[7]=0;a[8]=0;a[9]=0;a[10]=1;a[11]=0;a[12]=0;a[13]=0;a[14]=0;a[15]=1;return a};
mat4.transpose=function(a,c){if(!c||a===c){var b=a[1],d=a[2],f=a[3],e=a[6],h=a[7],p=a[11];a[1]=a[4];a[2]=a[8];a[3]=a[12];a[4]=b;a[6]=a[9];a[7]=a[13];a[8]=d;a[9]=e;a[11]=a[14];a[12]=f;a[13]=h;a[14]=p;return a}c[0]=a[0];c[1]=a[4];c[2]=a[8];c[3]=a[12];c[4]=a[1];c[5]=a[5];c[6]=a[9];c[7]=a[13];c[8]=a[2];c[9]=a[6];c[10]=a[10];c[11]=a[14];c[12]=a[3];c[13]=a[7];c[14]=a[11];c[15]=a[15];return c};
mat4.determinant=function(a){var c=a[0],b=a[1],d=a[2],f=a[3],e=a[4],h=a[5],p=a[6],m=a[7],n=a[8],l=a[9],q=a[10],u=a[11],r=a[12],t=a[13],x=a[14];a=a[15];return r*l*p*f-n*t*p*f-r*h*q*f+e*t*q*f+n*h*x*f-e*l*x*f-r*l*d*m+n*t*d*m+r*b*q*m-c*t*q*m-n*b*x*m+c*l*x*m+r*h*d*u-e*t*d*u-r*b*p*u+c*t*p*u+e*b*x*u-c*h*x*u-n*h*d*a+e*l*d*a+n*b*p*a-c*l*p*a-e*b*q*a+c*h*q*a};
mat4.inverse=function(a,c){c||(c=a);var b=a[0],d=a[1],f=a[2],e=a[3],h=a[4],p=a[5],m=a[6],n=a[7],l=a[8],q=a[9],u=a[10],r=a[11],t=a[12],x=a[13],s=a[14],w=a[15],v=b*p-d*h,A=b*m-f*h,y=b*n-e*h,g=d*m-f*p,k=d*n-e*p,C=f*n-e*m,z=l*x-q*t,G=l*s-u*t,D=l*w-r*t,H=q*s-u*x,E=q*w-r*x,I=u*w-r*s,K=1/(v*I-A*E+y*H+g*D-k*G+C*z);c[0]=(p*I-m*E+n*H)*K;c[1]=(-d*I+f*E-e*H)*K;c[2]=(x*C-s*k+w*g)*K;c[3]=(-q*C+u*k-r*g)*K;c[4]=(-h*I+m*D-n*G)*K;c[5]=(b*I-f*D+e*G)*K;c[6]=(-t*C+s*y-w*A)*K;c[7]=(l*C-u*y+r*A)*K;c[8]=(h*E-p*D+n*z)*K;
c[9]=(-b*E+d*D-e*z)*K;c[10]=(t*k-x*y+w*v)*K;c[11]=(-l*k+q*y-r*v)*K;c[12]=(-h*H+p*G-m*z)*K;c[13]=(b*H-d*G+f*z)*K;c[14]=(-t*g+x*A-s*v)*K;c[15]=(l*g-q*A+u*v)*K;return c};mat4.toRotationMat=function(a,c){c||(c=mat4.create());c[0]=a[0];c[1]=a[1];c[2]=a[2];c[3]=a[3];c[4]=a[4];c[5]=a[5];c[6]=a[6];c[7]=a[7];c[8]=a[8];c[9]=a[9];c[10]=a[10];c[11]=a[11];c[12]=0;c[13]=0;c[14]=0;c[15]=1;return c};
mat4.toMat3=function(a,c){c||(c=mat3.create());c[0]=a[0];c[1]=a[1];c[2]=a[2];c[3]=a[4];c[4]=a[5];c[5]=a[6];c[6]=a[8];c[7]=a[9];c[8]=a[10];return c};mat4.toInverseMat3=function(a,c){var b=a[0],d=a[1],f=a[2],e=a[4],h=a[5],p=a[6],m=a[8],n=a[9],l=a[10],q=l*h-p*n,u=-l*e+p*m,r=n*e-h*m,t=b*q+d*u+f*r;if(!t)return null;t=1/t;c||(c=mat3.create());c[0]=q*t;c[1]=(-l*d+f*n)*t;c[2]=(p*d-f*h)*t;c[3]=u*t;c[4]=(l*b-f*m)*t;c[5]=(-p*b+f*e)*t;c[6]=r*t;c[7]=(-n*b+d*m)*t;c[8]=(h*b-d*e)*t;return c};
mat4.multiply=function(a,c,b){b||(b=a);var d=a[0],f=a[1],e=a[2],h=a[3],p=a[4],m=a[5],n=a[6],l=a[7],q=a[8],u=a[9],r=a[10],t=a[11],x=a[12],s=a[13],w=a[14];a=a[15];var v=c[0],A=c[1],y=c[2],g=c[3],k=c[4],C=c[5],z=c[6],G=c[7],D=c[8],H=c[9],E=c[10],I=c[11],K=c[12],N=c[13],L=c[14];c=c[15];b[0]=v*d+A*p+y*q+g*x;b[1]=v*f+A*m+y*u+g*s;b[2]=v*e+A*n+y*r+g*w;b[3]=v*h+A*l+y*t+g*a;b[4]=k*d+C*p+z*q+G*x;b[5]=k*f+C*m+z*u+G*s;b[6]=k*e+C*n+z*r+G*w;b[7]=k*h+C*l+z*t+G*a;b[8]=D*d+H*p+E*q+I*x;b[9]=D*f+H*m+E*u+I*s;b[10]=D*
e+H*n+E*r+I*w;b[11]=D*h+H*l+E*t+I*a;b[12]=K*d+N*p+L*q+c*x;b[13]=K*f+N*m+L*u+c*s;b[14]=K*e+N*n+L*r+c*w;b[15]=K*h+N*l+L*t+c*a;return b};mat4.multiplyVec3=function(a,c,b){b||(b=c);var d=c[0],f=c[1];c=c[2];b[0]=a[0]*d+a[4]*f+a[8]*c+a[12];b[1]=a[1]*d+a[5]*f+a[9]*c+a[13];b[2]=a[2]*d+a[6]*f+a[10]*c+a[14];return b};
mat4.multiplyVec4=function(a,c,b){b||(b=c);var d=c[0],f=c[1],e=c[2];c=c[3];b[0]=a[0]*d+a[4]*f+a[8]*e+a[12]*c;b[1]=a[1]*d+a[5]*f+a[9]*e+a[13]*c;b[2]=a[2]*d+a[6]*f+a[10]*e+a[14]*c;b[3]=a[3]*d+a[7]*f+a[11]*e+a[15]*c;return b};
mat4.translate=function(a,c,b){var d=c[0],f=c[1];c=c[2];var e,h,p,m,n,l,q,u,r,t,x,s;if(!b||a===b)return a[12]=a[0]*d+a[4]*f+a[8]*c+a[12],a[13]=a[1]*d+a[5]*f+a[9]*c+a[13],a[14]=a[2]*d+a[6]*f+a[10]*c+a[14],a[15]=a[3]*d+a[7]*f+a[11]*c+a[15],a;e=a[0];h=a[1];p=a[2];m=a[3];n=a[4];l=a[5];q=a[6];u=a[7];r=a[8];t=a[9];x=a[10];s=a[11];b[0]=e;b[1]=h;b[2]=p;b[3]=m;b[4]=n;b[5]=l;b[6]=q;b[7]=u;b[8]=r;b[9]=t;b[10]=x;b[11]=s;b[12]=e*d+n*f+r*c+a[12];b[13]=h*d+l*f+t*c+a[13];b[14]=p*d+q*f+x*c+a[14];b[15]=m*d+u*f+s*c+
a[15];return b};mat4.scale=function(a,c,b){var d=c[0],f=c[1];c=c[2];if(!b||a===b)return a[0]*=d,a[1]*=d,a[2]*=d,a[3]*=d,a[4]*=f,a[5]*=f,a[6]*=f,a[7]*=f,a[8]*=c,a[9]*=c,a[10]*=c,a[11]*=c,a;b[0]=a[0]*d;b[1]=a[1]*d;b[2]=a[2]*d;b[3]=a[3]*d;b[4]=a[4]*f;b[5]=a[5]*f;b[6]=a[6]*f;b[7]=a[7]*f;b[8]=a[8]*c;b[9]=a[9]*c;b[10]=a[10]*c;b[11]=a[11]*c;b[12]=a[12];b[13]=a[13];b[14]=a[14];b[15]=a[15];return b};
mat4.rotate=function(a,c,b,d){var f=b[0],e=b[1];b=b[2];var h=Math.sqrt(f*f+e*e+b*b),p,m,n,l,q,u,r,t,x,s,w,v,A,y,g,k,C,z,G,D;if(!h)return null;1!==h&&(h=1/h,f*=h,e*=h,b*=h);p=Math.sin(c);m=Math.cos(c);n=1-m;c=a[0];h=a[1];l=a[2];q=a[3];u=a[4];r=a[5];t=a[6];x=a[7];s=a[8];w=a[9];v=a[10];A=a[11];y=f*f*n+m;g=e*f*n+b*p;k=b*f*n-e*p;C=f*e*n-b*p;z=e*e*n+m;G=b*e*n+f*p;D=f*b*n+e*p;f=e*b*n-f*p;e=b*b*n+m;d?a!==d&&(d[12]=a[12],d[13]=a[13],d[14]=a[14],d[15]=a[15]):d=a;d[0]=c*y+u*g+s*k;d[1]=h*y+r*g+w*k;d[2]=l*y+t*
g+v*k;d[3]=q*y+x*g+A*k;d[4]=c*C+u*z+s*G;d[5]=h*C+r*z+w*G;d[6]=l*C+t*z+v*G;d[7]=q*C+x*z+A*G;d[8]=c*D+u*f+s*e;d[9]=h*D+r*f+w*e;d[10]=l*D+t*f+v*e;d[11]=q*D+x*f+A*e;return d};
mat4.rotateX=function(a,c,b){var d=Math.sin(c);c=Math.cos(c);var f=a[4],e=a[5],h=a[6],p=a[7],m=a[8],n=a[9],l=a[10],q=a[11];b?a!==b&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3],b[12]=a[12],b[13]=a[13],b[14]=a[14],b[15]=a[15]):b=a;b[4]=f*c+m*d;b[5]=e*c+n*d;b[6]=h*c+l*d;b[7]=p*c+q*d;b[8]=f*-d+m*c;b[9]=e*-d+n*c;b[10]=h*-d+l*c;b[11]=p*-d+q*c;return b};
mat4.rotateY=function(a,c,b){var d=Math.sin(c);c=Math.cos(c);var f=a[0],e=a[1],h=a[2],p=a[3],m=a[8],n=a[9],l=a[10],q=a[11];b?a!==b&&(b[4]=a[4],b[5]=a[5],b[6]=a[6],b[7]=a[7],b[12]=a[12],b[13]=a[13],b[14]=a[14],b[15]=a[15]):b=a;b[0]=f*c+m*-d;b[1]=e*c+n*-d;b[2]=h*c+l*-d;b[3]=p*c+q*-d;b[8]=f*d+m*c;b[9]=e*d+n*c;b[10]=h*d+l*c;b[11]=p*d+q*c;return b};
mat4.rotateZ=function(a,c,b){var d=Math.sin(c);c=Math.cos(c);var f=a[0],e=a[1],h=a[2],p=a[3],m=a[4],n=a[5],l=a[6],q=a[7];b?a!==b&&(b[8]=a[8],b[9]=a[9],b[10]=a[10],b[11]=a[11],b[12]=a[12],b[13]=a[13],b[14]=a[14],b[15]=a[15]):b=a;b[0]=f*c+m*d;b[1]=e*c+n*d;b[2]=h*c+l*d;b[3]=p*c+q*d;b[4]=f*-d+m*c;b[5]=e*-d+n*c;b[6]=h*-d+l*c;b[7]=p*-d+q*c;return b};
mat4.frustum=function(a,c,b,d,f,e,h){h||(h=mat4.create());var p=c-a,m=d-b,n=e-f;h[0]=2*f/p;h[1]=0;h[2]=0;h[3]=0;h[4]=0;h[5]=2*f/m;h[6]=0;h[7]=0;h[8]=(c+a)/p;h[9]=(d+b)/m;h[10]=-(e+f)/n;h[11]=-1;h[12]=0;h[13]=0;h[14]=-(2*e*f)/n;h[15]=0;return h};mat4.perspective=function(a,c,b,d,f){a=b*Math.tan(a*Math.PI/360);c*=a;return mat4.frustum(-c,c,-a,a,b,d,f)};
mat4.ortho=function(a,c,b,d,f,e,h){h||(h=mat4.create());var p=c-a,m=d-b,n=e-f;h[0]=2/p;h[1]=0;h[2]=0;h[3]=0;h[4]=0;h[5]=2/m;h[6]=0;h[7]=0;h[8]=0;h[9]=0;h[10]=-2/n;h[11]=0;h[12]=-(a+c)/p;h[13]=-(d+b)/m;h[14]=-(e+f)/n;h[15]=1;return h};
mat4.lookAt=function(a,c,b,d){d||(d=mat4.create());var f,e,h,p,m,n,l,q,u=a[0],r=a[1];a=a[2];e=b[0];h=b[1];f=b[2];b=c[1];n=c[2];if(u===c[0]&&r===b&&a===n)return mat4.identity(d);b=u-c[0];n=r-c[1];l=a-c[2];q=1/Math.sqrt(b*b+n*n+l*l);b*=q;n*=q;l*=q;c=h*l-f*n;f=f*b-e*l;e=e*n-h*b;(q=Math.sqrt(c*c+f*f+e*e))?(q=1/q,c*=q,f*=q,e*=q):e=f=c=0;h=n*e-l*f;p=l*c-b*e;m=b*f-n*c;(q=Math.sqrt(h*h+p*p+m*m))?(q=1/q,h*=q,p*=q,m*=q):m=p=h=0;d[0]=c;d[1]=h;d[2]=b;d[3]=0;d[4]=f;d[5]=p;d[6]=n;d[7]=0;d[8]=e;d[9]=m;d[10]=l;d[11]=
0;d[12]=-(c*u+f*r+e*a);d[13]=-(h*u+p*r+m*a);d[14]=-(b*u+n*r+l*a);d[15]=1;return d};mat4.fromRotationTranslation=function(a,c,b){b||(b=mat4.create());var d=a[0],f=a[1],e=a[2],h=a[3],p=d+d,m=f+f,n=e+e;a=d*p;var l=d*m,d=d*n,q=f*m,f=f*n,e=e*n,p=p*h,m=m*h,h=h*n;b[0]=1-(q+e);b[1]=l+h;b[2]=d-m;b[3]=0;b[4]=l-h;b[5]=1-(a+e);b[6]=f+p;b[7]=0;b[8]=d+m;b[9]=f-p;b[10]=1-(a+q);b[11]=0;b[12]=c[0];b[13]=c[1];b[14]=c[2];b[15]=1;return b};
mat4.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+", "+a[4]+", "+a[5]+", "+a[6]+", "+a[7]+", "+a[8]+", "+a[9]+", "+a[10]+", "+a[11]+", "+a[12]+", "+a[13]+", "+a[14]+", "+a[15]+"]"};quat4.create=function(a){var c=new MatrixArray(4);a&&(c[0]=a[0],c[1]=a[1],c[2]=a[2],c[3]=a[3]);return c};quat4.set=function(a,c){c[0]=a[0];c[1]=a[1];c[2]=a[2];c[3]=a[3];return c};
quat4.calculateW=function(a,c){var b=a[0],d=a[1],f=a[2];if(!c||a===c)return a[3]=-Math.sqrt(Math.abs(1-b*b-d*d-f*f)),a;c[0]=b;c[1]=d;c[2]=f;c[3]=-Math.sqrt(Math.abs(1-b*b-d*d-f*f));return c};quat4.inverse=function(a,c){if(!c||a===c)return a[0]*=-1,a[1]*=-1,a[2]*=-1,a;c[0]=-a[0];c[1]=-a[1];c[2]=-a[2];c[3]=a[3];return c};quat4.length=function(a){var c=a[0],b=a[1],d=a[2];a=a[3];return Math.sqrt(c*c+b*b+d*d+a*a)};
quat4.normalize=function(a,c){c||(c=a);var b=a[0],d=a[1],f=a[2],e=a[3],h=Math.sqrt(b*b+d*d+f*f+e*e);if(0===h)return c[0]=0,c[1]=0,c[2]=0,c[3]=0,c;h=1/h;c[0]=b*h;c[1]=d*h;c[2]=f*h;c[3]=e*h;return c};quat4.multiply=function(a,c,b){b||(b=a);var d=a[0],f=a[1],e=a[2];a=a[3];var h=c[0],p=c[1],m=c[2];c=c[3];b[0]=d*c+a*h+f*m-e*p;b[1]=f*c+a*p+e*h-d*m;b[2]=e*c+a*m+d*p-f*h;b[3]=a*c-d*h-f*p-e*m;return b};
quat4.multiplyVec3=function(a,c,b){b||(b=c);var d=c[0],f=c[1],e=c[2];c=a[0];var h=a[1],p=a[2];a=a[3];var m=a*d+h*e-p*f,n=a*f+p*d-c*e,l=a*e+c*f-h*d,d=-c*d-h*f-p*e;b[0]=m*a+d*-c+n*-p-l*-h;b[1]=n*a+d*-h+l*-c-m*-p;b[2]=l*a+d*-p+m*-h-n*-c;return b};quat4.toMat3=function(a,c){c||(c=mat3.create());var b=a[0],d=a[1],f=a[2],e=a[3],h=b+b,p=d+d,m=f+f,n=b*h,l=b*p,b=b*m,q=d*p,d=d*m,f=f*m,h=h*e,p=p*e,e=e*m;c[0]=1-(q+f);c[1]=l+e;c[2]=b-p;c[3]=l-e;c[4]=1-(n+f);c[5]=d+h;c[6]=b+p;c[7]=d-h;c[8]=1-(n+q);return c};
quat4.toMat4=function(a,c){c||(c=mat4.create());var b=a[0],d=a[1],f=a[2],e=a[3],h=b+b,p=d+d,m=f+f,n=b*h,l=b*p,b=b*m,q=d*p,d=d*m,f=f*m,h=h*e,p=p*e,e=e*m;c[0]=1-(q+f);c[1]=l+e;c[2]=b-p;c[3]=0;c[4]=l-e;c[5]=1-(n+f);c[6]=d+h;c[7]=0;c[8]=b+p;c[9]=d-h;c[10]=1-(n+q);c[11]=0;c[12]=0;c[13]=0;c[14]=0;c[15]=1;return c};
quat4.slerp=function(a,c,b,d){d||(d=a);var f=a[0]*c[0]+a[1]*c[1]+a[2]*c[2]+a[3]*c[3],e,h;if(1<=Math.abs(f))return d!==a&&(d[0]=a[0],d[1]=a[1],d[2]=a[2],d[3]=a[3]),d;e=Math.acos(f);h=Math.sqrt(1-f*f);if(0.001>Math.abs(h))return d[0]=0.5*a[0]+0.5*c[0],d[1]=0.5*a[1]+0.5*c[1],d[2]=0.5*a[2]+0.5*c[2],d[3]=0.5*a[3]+0.5*c[3],d;f=Math.sin((1-b)*e)/h;b=Math.sin(b*e)/h;d[0]=a[0]*f+c[0]*b;d[1]=a[1]*f+c[1]*b;d[2]=a[2]*f+c[2]*b;d[3]=a[3]*f+c[3]*b;return d};
quat4.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+"]"};
(function(){function a(a,b){this.isIE=/msie/i.test(navigator.userAgent)||/trident/i.test(navigator.userAgent);this.height=this.width=0;this.cam=vec3.create([0,0,100]);this.look=vec3.create([0,0,0]);this.up=vec3.create([0,1,0]);this.worldScale=vec3.create([1,1,1]);this.enable_mipmaps=!0;this.matP=mat4.create();this.matMV=mat4.create();this.lastMV=mat4.create();this.currentMV=mat4.create();this.gl=a;this.initState()}function c(a,b,c){this.gl=a;this.shaderProgram=b;this.name=c;this.locAPos=a.getAttribLocation(b,
"aPos");this.locATex=a.getAttribLocation(b,"aTex");this.locMatP=a.getUniformLocation(b,"matP");this.locMatMV=a.getUniformLocation(b,"matMV");this.locOpacity=a.getUniformLocation(b,"opacity");this.locSamplerFront=a.getUniformLocation(b,"samplerFront");this.locSamplerBack=a.getUniformLocation(b,"samplerBack");this.locDestStart=a.getUniformLocation(b,"destStart");this.locDestEnd=a.getUniformLocation(b,"destEnd");this.locSeconds=a.getUniformLocation(b,"seconds");this.locPixelWidth=a.getUniformLocation(b,
"pixelWidth");this.locPixelHeight=a.getUniformLocation(b,"pixelHeight");this.locLayerScale=a.getUniformLocation(b,"layerScale");this.locLayerAngle=a.getUniformLocation(b,"layerAngle");this.locViewOrigin=a.getUniformLocation(b,"viewOrigin");this.hasAnyOptionalUniforms=!!(this.locPixelWidth||this.locPixelHeight||this.locSeconds||this.locSamplerBack||this.locDestStart||this.locDestEnd||this.locLayerScale||this.locLayerAngle||this.locViewOrigin);this.locOpacity&&a.uniform1f(this.locOpacity,1);this.locSamplerFront&&
a.uniform1i(this.locSamplerFront,0);this.locSamplerBack&&a.uniform1i(this.locSamplerBack,1);this.locDestStart&&a.uniform2f(this.locDestStart,0,0);this.locDestEnd&&a.uniform2f(this.locDestEnd,1,1);this.locLayerScale&&a.uniform1f(this.locLayerScale,1);this.locLayerAngle&&a.uniform1f(this.locLayerAngle,0);this.locViewOrigin&&a.uniform2f(this.locViewOrigin,0,0);this.hasCurrentMatMV=!1}function b(a,b){this.type=a;this.glwrap=b;this.gl=b.gl;this.indexCount=this.startIndex=this.opacityParam=0;this.mat4param=
this.texParam=null;this.shaderParams=[];cr.seal(this)}a.prototype.initState=function(){var a=this.gl,b;this.lastOpacity=1;this.lastTexture1=this.lastTexture0=null;this.currentOpacity=1;a.clearColor(0,0,0,0);a.clear(a.COLOR_BUFFER_BIT);a.enable(a.BLEND);a.blendFunc(a.ONE,a.ONE_MINUS_SRC_ALPHA);a.disable(a.CULL_FACE);a.disable(a.DEPTH_TEST);this.maxTextureSize=a.getParameter(a.MAX_TEXTURE_SIZE);this.lastSrcBlend=a.ONE;this.lastDestBlend=a.ONE_MINUS_SRC_ALPHA;this.pointBuffer=a.createBuffer();a.bindBuffer(a.ARRAY_BUFFER,
this.pointBuffer);this.vertexBuffers=Array(4);this.texcoordBuffers=Array(4);for(b=0;4>b;b++)this.vertexBuffers[b]=a.createBuffer(),a.bindBuffer(a.ARRAY_BUFFER,this.vertexBuffers[b]),this.texcoordBuffers[b]=a.createBuffer(),a.bindBuffer(a.ARRAY_BUFFER,this.texcoordBuffers[b]);this.curBuffer=0;this.indexBuffer=a.createBuffer();a.bindBuffer(a.ELEMENT_ARRAY_BUFFER,this.indexBuffer);this.vertexData=new Float32Array(16E3);this.texcoordData=new Float32Array(16E3);this.pointData=new Float32Array(32E3);for(var c=
new Uint16Array(12E3),f=b=0;12E3>b;)c[b++]=f,c[b++]=f+1,c[b++]=f+2,c[b++]=f,c[b++]=f+2,c[b++]=f+3,f+=4;a.bufferData(a.ELEMENT_ARRAY_BUFFER,c,a.STATIC_DRAW);this.pointPtr=this.vertexPtr=0;this.shaderPrograms=[];b=this.createShaderProgram({src:"varying mediump vec2 vTex;\nuniform lowp float opacity;\nuniform lowp sampler2D samplerFront;\nvoid main(void) {\n\tgl_FragColor = texture2D(samplerFront, vTex);\n\tgl_FragColor *= opacity;\n}"},"attribute highp vec2 aPos;\nattribute mediump vec2 aTex;\nvarying mediump vec2 vTex;\nuniform highp mat4 matP;\nuniform highp mat4 matMV;\nvoid main(void) {\n\tgl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);\n\tvTex = aTex;\n}",
"<default>");this.shaderPrograms.push(b);b=this.createShaderProgram({src:"uniform mediump sampler2D samplerFront;\nvarying lowp float opacity;\nvoid main(void) {\n\tgl_FragColor = texture2D(samplerFront, gl_PointCoord);\n\tgl_FragColor *= opacity;\n}"},"attribute vec4 aPos;\nvarying float opacity;\nuniform mat4 matP;\nuniform mat4 matMV;\nvoid main(void) {\n\tgl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);\n\tgl_PointSize = aPos.z;\n\topacity = aPos.w;\n}","<point>");this.shaderPrograms.push(b);
for(var d in cr.shaders)cr.shaders.hasOwnProperty(d)&&this.shaderPrograms.push(this.createShaderProgram(cr.shaders[d],"attribute highp vec2 aPos;\nattribute mediump vec2 aTex;\nvarying mediump vec2 vTex;\nuniform highp mat4 matP;\nuniform highp mat4 matMV;\nvoid main(void) {\n\tgl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);\n\tvTex = aTex;\n}",d));a.activeTexture(a.TEXTURE0);a.bindTexture(a.TEXTURE_2D,null);this.batch=[];this.batchPtr=0;this.hasPointBatchTop=this.hasQuadBatchTop=!1;
this.currentProgram=this.lastProgram=-1;this.currentShader=null;this.fbo=a.createFramebuffer();this.renderToTex=null;this.tmpVec3=vec3.create([0,0,0]);a=a.getParameter(a.ALIASED_POINT_SIZE_RANGE);this.minPointSize=a[0];this.maxPointSize=a[1];2048<this.maxPointSize&&(this.maxPointSize=2048);this.switchProgram(0);cr.seal(this)};a.prototype.createShaderProgram=function(a,b,f){var d=this.gl,n=d.createShader(d.FRAGMENT_SHADER);d.shaderSource(n,a.src);d.compileShader(n);if(!d.getShaderParameter(n,d.COMPILE_STATUS))return d.deleteShader(n),
null;var l=d.createShader(d.VERTEX_SHADER);d.shaderSource(l,b);d.compileShader(l);if(!d.getShaderParameter(l,d.COMPILE_STATUS))return d.deleteShader(n),d.deleteShader(l),null;b=d.createProgram();d.attachShader(b,n);d.attachShader(b,l);d.linkProgram(b);if(!d.getProgramParameter(b,d.LINK_STATUS))return d.deleteShader(n),d.deleteShader(l),d.deleteProgram(b),null;d.useProgram(b);d.deleteShader(n);d.deleteShader(l);f=new c(d,b,f);f.extendBoxHorizontal=a.extendBoxHorizontal||0;f.extendBoxVertical=a.extendBoxVertical||
0;f.crossSampling=!!a.crossSampling;f.animated=!!a.animated;f.parameters=a.parameters||[];a=0;for(n=f.parameters.length;a<n;a++)f.parameters[a][1]=d.getUniformLocation(b,f.parameters[a][0]),d.uniform1f(f.parameters[a][1],0);cr.seal(f);return f};a.prototype.getShaderIndex=function(a){var b,c;b=0;for(c=this.shaderPrograms.length;b<c;b++)if(this.shaderPrograms[b].name===a)return b;return-1};a.prototype.project=function(a,b,c){var f=this.matMV,d=this.matP,l=[0,0,0,0,0,0,0,0];l[0]=f[0]*a+f[4]*b+f[12];
l[1]=f[1]*a+f[5]*b+f[13];l[2]=f[2]*a+f[6]*b+f[14];l[3]=f[3]*a+f[7]*b+f[15];l[4]=d[0]*l[0]+d[4]*l[1]+d[8]*l[2]+d[12]*l[3];l[5]=d[1]*l[0]+d[5]*l[1]+d[9]*l[2]+d[13]*l[3];l[6]=d[2]*l[0]+d[6]*l[1]+d[10]*l[2]+d[14]*l[3];l[7]=-l[2];0!==l[7]&&(l[7]=1/l[7],l[4]*=l[7],l[5]*=l[7],l[6]*=l[7],c[0]=(0.5*l[4]+0.5)*this.width,c[1]=(0.5*l[5]+0.5)*this.height)};a.prototype.setSize=function(a,b,c){if(this.width!==a||this.height!==b||c){this.endBatch();this.width=a;this.height=b;this.gl.viewport(0,0,a,b);mat4.perspective(45,
a/b,1,1E3,this.matP);mat4.lookAt(this.cam,this.look,this.up,this.matMV);a=[0,0];b=[0,0];this.project(0,0,a);this.project(1,1,b);this.worldScale[0]=1/(b[0]-a[0]);this.worldScale[1]=-1/(b[1]-a[1]);a=0;for(b=this.shaderPrograms.length;a<b;a++)c=this.shaderPrograms[a],c.hasCurrentMatMV=!1,c.locMatP&&(this.gl.useProgram(c.shaderProgram),this.gl.uniformMatrix4fv(c.locMatP,!1,this.matP));this.gl.useProgram(this.shaderPrograms[this.lastProgram].shaderProgram);this.gl.bindTexture(this.gl.TEXTURE_2D,null);
this.gl.activeTexture(this.gl.TEXTURE1);this.gl.bindTexture(this.gl.TEXTURE_2D,null);this.gl.activeTexture(this.gl.TEXTURE0);this.lastTexture1=this.lastTexture0=null}};a.prototype.resetModelView=function(){mat4.lookAt(this.cam,this.look,this.up,this.matMV);mat4.scale(this.matMV,this.worldScale)};a.prototype.translate=function(a,b){if(0!==a||0!==b)this.tmpVec3[0]=a,this.tmpVec3[1]=b,this.tmpVec3[2]=0,mat4.translate(this.matMV,this.tmpVec3)};a.prototype.scale=function(a,b){if(1!==a||1!==b)this.tmpVec3[0]=
a,this.tmpVec3[1]=b,this.tmpVec3[2]=1,mat4.scale(this.matMV,this.tmpVec3)};a.prototype.rotateZ=function(a){0!==a&&mat4.rotateZ(this.matMV,a)};a.prototype.updateModelView=function(){for(var a=!1,b=0;16>b;b++)if(this.lastMV[b]!==this.matMV[b]){a=!0;break}a&&(a=this.pushBatch(),a.type=5,a.mat4param?mat4.set(this.matMV,a.mat4param):a.mat4param=mat4.create(this.matMV),mat4.set(this.matMV,this.lastMV),this.hasPointBatchTop=this.hasQuadBatchTop=!1)};b.prototype.doSetTexture=function(){this.gl.bindTexture(this.gl.TEXTURE_2D,
this.texParam)};b.prototype.doSetTexture1=function(){var a=this.gl;a.activeTexture(a.TEXTURE1);a.bindTexture(a.TEXTURE_2D,this.texParam);a.activeTexture(a.TEXTURE0)};b.prototype.doSetOpacity=function(){var a=this.opacityParam,b=this.glwrap;b.currentOpacity=a;b=b.currentShader;b.locOpacity&&this.gl.uniform1f(b.locOpacity,a)};b.prototype.doQuad=function(){this.gl.drawElements(this.gl.TRIANGLES,this.indexCount,this.gl.UNSIGNED_SHORT,2*this.startIndex)};b.prototype.doSetBlend=function(){this.gl.blendFunc(this.startIndex,
this.indexCount)};b.prototype.doUpdateModelView=function(){var a,b,c,f=this.glwrap.shaderPrograms,d=this.glwrap.currentProgram;a=0;for(b=f.length;a<b;a++)c=f[a],a===d&&c.locMatMV?(this.gl.uniformMatrix4fv(c.locMatMV,!1,this.mat4param),c.hasCurrentMatMV=!0):c.hasCurrentMatMV=!1;mat4.set(this.mat4param,this.glwrap.currentMV)};b.prototype.doRenderToTexture=function(){var a=this.gl,b=this.glwrap;this.texParam?(b.lastTexture1===this.texParam&&(a.activeTexture(a.TEXTURE1),a.bindTexture(a.TEXTURE_2D,null),
b.lastTexture1=null,a.activeTexture(a.TEXTURE0)),a.bindFramebuffer(a.FRAMEBUFFER,b.fbo),a.framebufferTexture2D(a.FRAMEBUFFER,a.COLOR_ATTACHMENT0,a.TEXTURE_2D,this.texParam,0)):(a.framebufferTexture2D(a.FRAMEBUFFER,a.COLOR_ATTACHMENT0,a.TEXTURE_2D,null,0),a.bindFramebuffer(a.FRAMEBUFFER,null))};b.prototype.doClear=function(){var a=this.gl;0===this.startIndex?(a.clearColor(this.mat4param[0],this.mat4param[1],this.mat4param[2],this.mat4param[3]),a.clear(a.COLOR_BUFFER_BIT)):(a.enable(a.SCISSOR_TEST),
a.scissor(this.mat4param[0],this.mat4param[1],this.mat4param[2],this.mat4param[3]),a.clearColor(0,0,0,0),a.clear(this.gl.COLOR_BUFFER_BIT),a.disable(a.SCISSOR_TEST))};b.prototype.doPoints=function(){var a=this.gl,b=this.glwrap,c=b.shaderPrograms[1];a.useProgram(c.shaderProgram);!c.hasCurrentMatMV&&c.locMatMV&&(a.uniformMatrix4fv(c.locMatMV,!1,b.currentMV),c.hasCurrentMatMV=!0);a.enableVertexAttribArray(c.locAPos);a.bindBuffer(a.ARRAY_BUFFER,b.pointBuffer);a.vertexAttribPointer(c.locAPos,4,a.FLOAT,
!1,0,0);a.drawArrays(a.POINTS,this.startIndex/4,this.indexCount);c=b.currentShader;a.useProgram(c.shaderProgram);0<=c.locAPos&&(a.enableVertexAttribArray(c.locAPos),a.bindBuffer(a.ARRAY_BUFFER,b.vertexBuffers[b.curBuffer]),a.vertexAttribPointer(c.locAPos,2,a.FLOAT,!1,0,0));0<=c.locATex&&(a.enableVertexAttribArray(c.locATex),a.bindBuffer(a.ARRAY_BUFFER,b.texcoordBuffers[b.curBuffer]),a.vertexAttribPointer(c.locATex,2,a.FLOAT,!1,0,0))};b.prototype.doSetProgram=function(){var a=this.gl,b=this.glwrap,
c=b.shaderPrograms[this.startIndex];b.currentProgram=this.startIndex;b.currentShader=c;a.useProgram(c.shaderProgram);!c.hasCurrentMatMV&&c.locMatMV&&(a.uniformMatrix4fv(c.locMatMV,!1,b.currentMV),c.hasCurrentMatMV=!0);c.locOpacity&&a.uniform1f(c.locOpacity,b.currentOpacity);0<=c.locAPos&&(a.enableVertexAttribArray(c.locAPos),a.bindBuffer(a.ARRAY_BUFFER,b.vertexBuffers[b.curBuffer]),a.vertexAttribPointer(c.locAPos,2,a.FLOAT,!1,0,0));0<=c.locATex&&(a.enableVertexAttribArray(c.locATex),a.bindBuffer(a.ARRAY_BUFFER,
b.texcoordBuffers[b.curBuffer]),a.vertexAttribPointer(c.locATex,2,a.FLOAT,!1,0,0))};b.prototype.doSetProgramParameters=function(){var a,b,c=this.glwrap.currentShader,f=this.gl;a=this.mat4param;c.locSamplerBack&&this.glwrap.lastTexture1!==this.texParam&&(f.activeTexture(f.TEXTURE1),f.bindTexture(f.TEXTURE_2D,this.texParam),this.glwrap.lastTexture1=this.texParam,f.activeTexture(f.TEXTURE0));c.locPixelWidth&&f.uniform1f(c.locPixelWidth,a[0]);c.locPixelHeight&&f.uniform1f(c.locPixelHeight,a[1]);c.locDestStart&&
f.uniform2f(c.locDestStart,a[2],a[3]);c.locDestEnd&&f.uniform2f(c.locDestEnd,a[4],a[5]);c.locLayerScale&&f.uniform1f(c.locLayerScale,a[6]);c.locLayerAngle&&f.uniform1f(c.locLayerAngle,a[7]);c.locViewOrigin&&f.uniform2f(c.locViewOrigin,a[8],a[9]);c.locSeconds&&f.uniform1f(c.locSeconds,cr.performance_now()/1E3);if(c.parameters.length)for(a=0,b=c.parameters.length;a<b;a++)f.uniform1f(c.parameters[a][1],this.shaderParams[a])};a.prototype.pushBatch=function(){this.batchPtr===this.batch.length&&this.batch.push(new b(0,
this));return this.batch[this.batchPtr++]};a.prototype.endBatch=function(){if(0!==this.batchPtr&&!this.gl.isContextLost()){var a=this.gl;0<this.pointPtr&&(a.bindBuffer(a.ARRAY_BUFFER,this.pointBuffer),a.bufferData(a.ARRAY_BUFFER,this.pointData.subarray(0,this.pointPtr),a.STREAM_DRAW),b&&0<=b.locAPos&&"<point>"===b.name&&a.vertexAttribPointer(b.locAPos,4,a.FLOAT,!1,0,0));if(0<this.vertexPtr){var b=this.currentShader;a.bindBuffer(a.ARRAY_BUFFER,this.vertexBuffers[this.curBuffer]);a.bufferData(a.ARRAY_BUFFER,
this.vertexData.subarray(0,this.vertexPtr),a.STREAM_DRAW);b&&0<=b.locAPos&&"<point>"!==b.name&&a.vertexAttribPointer(b.locAPos,2,a.FLOAT,!1,0,0);a.bindBuffer(a.ARRAY_BUFFER,this.texcoordBuffers[this.curBuffer]);a.bufferData(a.ARRAY_BUFFER,this.texcoordData.subarray(0,this.vertexPtr),a.STREAM_DRAW);b&&0<=b.locATex&&"<point>"!==b.name&&a.vertexAttribPointer(b.locATex,2,a.FLOAT,!1,0,0)}for(var c,a=0,b=this.batchPtr;a<b;a++)switch(c=this.batch[a],c.type){case 1:c.doQuad();break;case 2:c.doSetTexture();
break;case 3:c.doSetOpacity();break;case 4:c.doSetBlend();break;case 5:c.doUpdateModelView();break;case 6:c.doRenderToTexture();break;case 7:c.doClear();break;case 8:c.doPoints();break;case 9:c.doSetProgram();break;case 10:c.doSetProgramParameters();break;case 11:c.doSetTexture1()}this.pointPtr=this.vertexPtr=this.batchPtr=0;this.hasPointBatchTop=this.hasQuadBatchTop=!1;this.curBuffer++;4<=this.curBuffer&&(this.curBuffer=0)}};a.prototype.setOpacity=function(a){if(a!==this.lastOpacity){var b=this.pushBatch();
b.type=3;this.lastOpacity=b.opacityParam=a;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.setTexture=function(a){if(a!==this.lastTexture0){var b=this.pushBatch();b.type=2;this.lastTexture0=b.texParam=a;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.setBlend=function(a,b){if(a!==this.lastSrcBlend||b!==this.lastDestBlend){var c=this.pushBatch();c.type=4;c.startIndex=a;c.indexCount=b;this.lastSrcBlend=a;this.lastDestBlend=b;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.isPremultipliedAlphaBlend=
function(){return this.lastSrcBlend===this.gl.ONE&&this.lastDestBlend===this.gl.ONE_MINUS_SRC_ALPHA};a.prototype.setAlphaBlend=function(){this.setBlend(this.gl.ONE,this.gl.ONE_MINUS_SRC_ALPHA)};a.prototype.setNoPremultiplyAlphaBlend=function(){this.setBlend(this.gl.SRC_ALPHA,this.gl.ONE_MINUS_SRC_ALPHA)};a.prototype.quad=function(a,b,c,f,d,l,q,u){15992<=this.vertexPtr&&this.endBatch();var r=this.vertexPtr,t=this.vertexData,x=this.texcoordData;if(this.hasQuadBatchTop)this.batch[this.batchPtr-1].indexCount+=
6;else{var s=this.pushBatch();s.type=1;s.startIndex=3*(r/4);s.indexCount=6;this.hasQuadBatchTop=!0;this.hasPointBatchTop=!1}t[r]=a;x[r++]=0;t[r]=b;x[r++]=0;t[r]=c;x[r++]=1;t[r]=f;x[r++]=0;t[r]=d;x[r++]=1;t[r]=l;x[r++]=1;t[r]=q;x[r++]=0;t[r]=u;x[r++]=1;this.vertexPtr=r};a.prototype.quadTex=function(a,b,c,f,d,l,q,u,r){15992<=this.vertexPtr&&this.endBatch();var t=this.vertexPtr,x=this.vertexData,s=this.texcoordData;if(this.hasQuadBatchTop)this.batch[this.batchPtr-1].indexCount+=6;else{var w=this.pushBatch();
w.type=1;w.startIndex=3*(t/4);w.indexCount=6;this.hasQuadBatchTop=!0;this.hasPointBatchTop=!1}var w=r.left,v=r.top,A=r.right;r=r.bottom;x[t]=a;s[t++]=w;x[t]=b;s[t++]=v;x[t]=c;s[t++]=A;x[t]=f;s[t++]=v;x[t]=d;s[t++]=A;x[t]=l;s[t++]=r;x[t]=q;s[t++]=w;x[t]=u;s[t++]=r;this.vertexPtr=t};a.prototype.quadTexUV=function(a,b,c,f,d,l,q,u,r,t,x,s,w,v,A,y){15992<=this.vertexPtr&&this.endBatch();var g=this.vertexPtr,k=this.vertexData,C=this.texcoordData;if(this.hasQuadBatchTop)this.batch[this.batchPtr-1].indexCount+=
6;else{var z=this.pushBatch();z.type=1;z.startIndex=3*(g/4);z.indexCount=6;this.hasQuadBatchTop=!0;this.hasPointBatchTop=!1}k[g]=a;C[g++]=r;k[g]=b;C[g++]=t;k[g]=c;C[g++]=x;k[g]=f;C[g++]=s;k[g]=d;C[g++]=w;k[g]=l;C[g++]=v;k[g]=q;C[g++]=A;k[g]=u;C[g++]=y;this.vertexPtr=g};a.prototype.convexPoly=function(a){var b=a.length/2-2,c=b-1,f=a[0],d=a[1],l,q,u,r,t,x,s;for(l=0;l<b;l+=2)q=2*l,u=a[q+2],r=a[q+3],t=a[q+4],x=a[q+5],l===c?this.quad(f,d,u,r,t,x,t,x):(s=a[q+6],q=a[q+7],this.quad(f,d,u,r,t,x,s,q))};a.prototype.point=
function(a,b,c,f){7996<=this.pointPtr&&this.endBatch();var d=this.pointPtr,l=this.pointData;if(this.hasPointBatchTop)this.batch[this.batchPtr-1].indexCount++;else{var q=this.pushBatch();q.type=8;q.startIndex=d;q.indexCount=1;this.hasPointBatchTop=!0;this.hasQuadBatchTop=!1}l[d++]=a;l[d++]=b;l[d++]=c;l[d++]=f;this.pointPtr=d};a.prototype.switchProgram=function(a){if(this.lastProgram!==a){if(!this.shaderPrograms[a]){if(0===this.lastProgram)return;a=0}var b=this.pushBatch();b.type=9;this.lastProgram=
b.startIndex=a;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.programUsesDest=function(a){a=this.shaderPrograms[a];return!(!a.locDestStart&&!a.locDestEnd)};a.prototype.programUsesCrossSampling=function(a){a=this.shaderPrograms[a];return!!(a.locDestStart||a.locDestEnd||a.crossSampling)};a.prototype.programExtendsBox=function(a){a=this.shaderPrograms[a];return 0!==a.extendBoxHorizontal||0!==a.extendBoxVertical};a.prototype.getProgramBoxExtendHorizontal=function(a){return this.shaderPrograms[a].extendBoxHorizontal};
a.prototype.getProgramBoxExtendVertical=function(a){return this.shaderPrograms[a].extendBoxVertical};a.prototype.getProgramParameterType=function(a,b){return this.shaderPrograms[a].parameters[b][2]};a.prototype.programIsAnimated=function(a){return this.shaderPrograms[a].animated};a.prototype.setProgramParameters=function(a,b,c,f,d,l,q,u,r,t,x,s){var w=this.shaderPrograms[this.lastProgram],v,A;if(w.hasAnyOptionalUniforms||s.length){v=this.pushBatch();v.type=10;v.mat4param?mat4.set(this.matMV,v.mat4param):
v.mat4param=mat4.create();A=v.mat4param;A[0]=b;A[1]=c;A[2]=f;A[3]=d;A[4]=l;A[5]=q;A[6]=u;A[7]=r;A[8]=t;A[9]=x;v.texParam=w.locSamplerBack?a:null;if(s.length)for(c=v.shaderParams,c.length=s.length,a=0,b=s.length;a<b;a++)c[a]=s[a];this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.clear=function(a,b,c,f){var d=this.pushBatch();d.type=7;d.startIndex=0;d.mat4param||(d.mat4param=mat4.create());d.mat4param[0]=a;d.mat4param[1]=b;d.mat4param[2]=c;d.mat4param[3]=f;this.hasPointBatchTop=this.hasQuadBatchTop=
!1};a.prototype.clearRect=function(a,b,c,f){if(!(0>c||0>f)){var d=this.pushBatch();d.type=7;d.startIndex=1;d.mat4param||(d.mat4param=mat4.create());d.mat4param[0]=a;d.mat4param[1]=b;d.mat4param[2]=c;d.mat4param[3]=f;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.present=function(){this.endBatch();this.gl.flush()};var d=[],f={};a.prototype.loadTexture=function(a,b,c,m,n,l){b=!!b;c=!!c;var q=a.src+","+b+","+c+(b?","+n:""),u=null;if("undefined"!==typeof a.src&&f.hasOwnProperty(q))return u=
f[q],u.c2refcount++,u;this.endBatch();var r=this.gl,t=cr.isPOT(a.width)&&cr.isPOT(a.height),u=r.createTexture();r.bindTexture(r.TEXTURE_2D,u);r.pixelStorei(r.UNPACK_PREMULTIPLY_ALPHA_WEBGL,!0);var x=r.RGBA,s=r.RGBA,w=r.UNSIGNED_BYTE;if(m&&!this.isIE)switch(m){case 1:s=x=r.RGB;break;case 2:w=r.UNSIGNED_SHORT_4_4_4_4;break;case 3:w=r.UNSIGNED_SHORT_5_5_5_1;break;case 4:s=x=r.RGB,w=r.UNSIGNED_SHORT_5_6_5}if(!t&&b){m=document.createElement("canvas");m.width=cr.nextHighestPowerOfTwo(a.width);m.height=
cr.nextHighestPowerOfTwo(a.height);var v=m.getContext("2d");v.webkitImageSmoothingEnabled=c;v.mozImageSmoothingEnabled=c;v.msImageSmoothingEnabled=c;v.imageSmoothingEnabled=c;v.drawImage(a,0,0,a.width,a.height,0,0,m.width,m.height);r.texImage2D(r.TEXTURE_2D,0,x,s,w,m)}else r.texImage2D(r.TEXTURE_2D,0,x,s,w,a);b?"repeat-x"===n?(r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_S,r.REPEAT),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_T,r.CLAMP_TO_EDGE)):("repeat-y"===n?r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_S,
r.CLAMP_TO_EDGE):r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_S,r.REPEAT),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_T,r.REPEAT)):(r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_S,r.CLAMP_TO_EDGE),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_T,r.CLAMP_TO_EDGE));c?(r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MAG_FILTER,r.LINEAR),t&&this.enable_mipmaps&&!l?(r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MIN_FILTER,r.LINEAR_MIPMAP_LINEAR),r.generateMipmap(r.TEXTURE_2D)):r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MIN_FILTER,
r.LINEAR)):(r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MAG_FILTER,r.NEAREST),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MIN_FILTER,r.NEAREST));r.bindTexture(r.TEXTURE_2D,null);this.lastTexture0=null;u.c2width=a.width;u.c2height=a.height;u.c2refcount=1;u.c2texkey=q;d.push(u);return f[q]=u};a.prototype.createEmptyTexture=function(a,b,c,f,n){this.endBatch();var l=this.gl;this.isIE&&(f=!1);var q=l.createTexture();l.bindTexture(l.TEXTURE_2D,q);l.texImage2D(l.TEXTURE_2D,0,l.RGBA,a,b,0,l.RGBA,f?l.UNSIGNED_SHORT_4_4_4_4:
l.UNSIGNED_BYTE,null);n?(l.texParameteri(l.TEXTURE_2D,l.TEXTURE_WRAP_S,l.REPEAT),l.texParameteri(l.TEXTURE_2D,l.TEXTURE_WRAP_T,l.REPEAT)):(l.texParameteri(l.TEXTURE_2D,l.TEXTURE_WRAP_S,l.CLAMP_TO_EDGE),l.texParameteri(l.TEXTURE_2D,l.TEXTURE_WRAP_T,l.CLAMP_TO_EDGE));l.texParameteri(l.TEXTURE_2D,l.TEXTURE_MAG_FILTER,c?l.LINEAR:l.NEAREST);l.texParameteri(l.TEXTURE_2D,l.TEXTURE_MIN_FILTER,c?l.LINEAR:l.NEAREST);l.bindTexture(l.TEXTURE_2D,null);this.lastTexture0=null;q.c2width=a;q.c2height=b;d.push(q);
return q};a.prototype.videoToTexture=function(a,b,c){this.endBatch();var f=this.gl;this.isIE&&(c=!1);f.bindTexture(f.TEXTURE_2D,b);f.pixelStorei(f.UNPACK_PREMULTIPLY_ALPHA_WEBGL,!0);f.texImage2D(f.TEXTURE_2D,0,f.RGBA,f.RGBA,c?f.UNSIGNED_SHORT_4_4_4_4:f.UNSIGNED_BYTE,a);f.bindTexture(f.TEXTURE_2D,null);this.lastTexture0=null};a.prototype.deleteTexture=function(a){a&&("undefined"!==typeof a.c2refcount&&1<a.c2refcount?a.c2refcount--:(this.endBatch(),a===this.lastTexture0&&(this.gl.bindTexture(this.gl.TEXTURE_2D,
null),this.lastTexture0=null),a===this.lastTexture1&&(this.gl.activeTexture(this.gl.TEXTURE1),this.gl.bindTexture(this.gl.TEXTURE_2D,null),this.gl.activeTexture(this.gl.TEXTURE0),this.lastTexture1=null),cr.arrayFindRemove(d,a),"undefined"!==typeof a.c2texkey&&delete f[a.c2texkey],this.gl.deleteTexture(a)))};a.prototype.estimateVRAM=function(){var a=8*this.width*this.height,b,c,f;b=0;for(c=d.length;b<c;b++)f=d[b],a+=4*f.c2width*f.c2height;return a};a.prototype.textureCount=function(){return d.length};
a.prototype.setRenderingToTexture=function(a){if(a!==this.renderToTex){var b=this.pushBatch();b.type=6;this.renderToTex=b.texParam=a;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};cr.GLWrap=a})();
(function(){function a(a){if(a&&(a.getContext||a.dc)&&!a.c2runtime){a.c2runtime=this;var b=this;this.isCrosswalk=/crosswalk/i.test(navigator.userAgent)||/xwalk/i.test(navigator.userAgent)||!("undefined"===typeof window.c2isCrosswalk||!window.c2isCrosswalk);this.isPhoneGap=!this.isCrosswalk&&"undefined"!==typeof window.device&&("undefined"!==typeof window.device.cordova||"undefined"!==typeof window.device.phonegap)||"undefined"!==typeof window.c2isphonegap&&window.c2isphonegap;this.isDirectCanvas=
!!a.dc;this.isAppMobi="undefined"!==typeof window.AppMobi||this.isDirectCanvas;this.isCocoonJs=!!window.c2cocoonjs;this.isEjecta=!!window.c2ejecta;this.isCocoonJs&&(CocoonJS.App.onSuspended.addEventListener(function(){b.setSuspended(!0)}),CocoonJS.App.onActivated.addEventListener(function(){b.setSuspended(!1)}));this.isEjecta&&(document.addEventListener("pagehide",function(){b.setSuspended(!0)}),document.addEventListener("pageshow",function(){b.setSuspended(!1)}),document.addEventListener("resize",
function(){b.setSize(window.innerWidth,window.innerHeight)}));this.isDomFree=this.isDirectCanvas||this.isCocoonJs||this.isEjecta;this.isIE=/msie/i.test(navigator.userAgent)||/trident/i.test(navigator.userAgent)||/iemobile/i.test(navigator.userAgent);this.isTizen=/tizen/i.test(navigator.userAgent);this.isAndroid=/android/i.test(navigator.userAgent)&&!this.isTizen&&!this.isIE;this.isiPhone=(/iphone/i.test(navigator.userAgent)||/ipod/i.test(navigator.userAgent))&&!this.isIE;this.isiPad=/ipad/i.test(navigator.userAgent);
this.isiOS=this.isiPhone||this.isiPad||this.isEjecta;this.isiPhoneiOS6=this.isiPhone&&/os\s6/i.test(navigator.userAgent);this.isChrome=/chrome/i.test(navigator.userAgent)||/chromium/i.test(navigator.userAgent);this.isAmazonWebApp=/amazonwebappplatform/i.test(navigator.userAgent);this.isFirefox=/firefox/i.test(navigator.userAgent);this.isSafari=/safari/i.test(navigator.userAgent)&&!this.isChrome&&!this.isIE;this.isWindows=/windows/i.test(navigator.userAgent);this.isNodeWebkit="undefined"!==typeof window.c2nodewebkit||
/nodewebkit/i.test(navigator.userAgent);this.isArcade="undefined"!==typeof window.is_scirra_arcade;this.isWindows8App=!("undefined"===typeof window.c2isWindows8||!window.c2isWindows8);this.isWindows8Capable=!("undefined"===typeof window.c2isWindows8Capable||!window.c2isWindows8Capable);this.isWindowsPhone8=!("undefined"===typeof window.c2isWindowsPhone8||!window.c2isWindowsPhone8);this.isWindowsPhone81=!("undefined"===typeof window.c2isWindowsPhone81||!window.c2isWindowsPhone81);this.isWinJS=this.isWindows8App||
this.isWindows8Capable||this.isWindowsPhone81;this.isBlackberry10=!("undefined"===typeof window.c2isBlackberry10||!window.c2isBlackberry10);this.isAndroidStockBrowser=this.isAndroid&&!this.isChrome&&!this.isFirefox&&!this.isAmazonWebApp&&!this.isDomFree;this.devicePixelRatio=1;this.isMobile=this.isPhoneGap||this.isCrosswalk||this.isAppMobi||this.isCocoonJs||this.isAndroid||this.isiOS||this.isWindowsPhone8||this.isWindowsPhone81||this.isBlackberry10||this.isTizen||this.isEjecta;this.isMobile||(this.isMobile=
/(blackberry|bb10|playbook|palm|symbian|nokia|windows\s+ce|phone|mobile|tablet|kindle|silk)/i.test(navigator.userAgent));"undefined"===typeof cr_is_preview||this.isNodeWebkit||"?nw"!==window.location.search&&!/nodewebkit/i.test(navigator.userAgent)||(this.isNodeWebkit=!0);this.isDebug="undefined"!==typeof cr_is_preview&&-1<window.location.search.indexOf("debug");this.canvas=a;this.canvasdiv=document.getElementById("c2canvasdiv");this.ctx=this.glwrap=this.gl=null;this.fullscreenOldMarginCss="";this.firstInFullscreen=
!1;this.oldHeight=this.oldWidth=0;this.canvas.oncontextmenu=function(a){a.preventDefault&&a.preventDefault();return!1};this.canvas.onselectstart=function(a){a.preventDefault&&a.preventDefault();return!1};this.isDirectCanvas&&(window.c2runtime=this);this.isNodeWebkit&&(window.ondragover=function(a){a.preventDefault();return!1},window.ondrop=function(a){a.preventDefault();return!1},require("nw.gui").App.clearCache());this.width=a.width;this.height=a.height;this.draw_width=this.width;this.draw_height=
this.height;this.cssWidth=this.width;this.cssHeight=this.height;this.lastWindowWidth=window.innerWidth;this.lastWindowHeight=window.innerHeight;this.redraw=!0;this.isSuspended=!1;Date.now||(Date.now=function(){return+new Date});this.plugins=[];this.types={};this.types_by_index=[];this.behaviors=[];this.layouts={};this.layouts_by_index=[];this.eventsheets={};this.eventsheets_by_index=[];this.wait_for_textures=[];this.triggers_to_postinit=[];this.all_global_vars=[];this.all_local_vars=[];this.shadowcasterBehavior=
this.jumpthruBehavior=this.solidBehavior=null;this.deathRow=new cr.ObjectSet;this.isInClearDeathRow=!1;this.isInOnDestroy=0;this.isRunningEvents=!1;this.createRow=[];this.isLoadingState=!1;this.lastSaveJson=this.loadFromJson=this.loadFromSlot=this.saveToSlot="";this.suspendDrawing=this.signalledContinuousPreview=!1;this.zeroDtCount=this.cpuutilisation=this.logictime=this.dt1=this.dt=0;this.timescale=1;this.kahanTime=new cr.KahanAdder;this.last_tick_time=0;this.measuring_dt=!0;this.objectcount=this.framecount=
this.execcount=this.tickcount=this.last_fps_time=this.fps=0;this.changelayout=null;this.destroycallbacks=[];this.event_stack=[];this.event_stack_index=-1;this.localvar_stack=[[]];this.trigger_depth=this.localvar_stack_index=0;this.pushEventStack(null);this.loop_stack=[];this.loop_stack_index=-1;this.next_puid=this.next_uid=0;this.layout_first_tick=!0;this.family_count=0;this.suspend_events=[];this.timeout_id=this.raf_id=-1;this.isloading=!0;this.loadingprogress=0;this.isNodeFullscreen=!1;this.stackLocalCount=
0;this.audioInstance=null;this.halfFramerateMode=!1;this.lastRafTime=0;this.isInUserInputEvent=this.had_a_click=this.ranLastRaf=!1;this.objects_to_pretick=new cr.ObjectSet;this.objects_to_tick=new cr.ObjectSet;this.objects_to_tick2=new cr.ObjectSet;this.registered_collisions=[];this.temp_poly=new cr.CollisionPoly([]);this.temp_poly2=new cr.CollisionPoly([]);this.allGroups=[];this.groups_by_name={};this.cndsBySid={};this.actsBySid={};this.varsBySid={};this.blocksBySid={};this.layout_ctx=this.layout_canvas=
this.layout_tex=this.layer_tex=this.layer_ctx=this.layer_canvas=this.running_layout=null;this.uses_background_blending=this.is_WebGL_context_lost=!1;this.fx_tex=[null,null];this.fullscreen_scaling=0;this.files_subfolder="";this.objectsByUid={};this.snapshotCanvas=this.loaderlogo=null;this.snapshotData="";this.load();this.devicePixelRatio=(this.isRetina=(!this.isDomFree||this.isEjecta)&&this.useHighDpi&&!this.isAndroidStockBrowser)?window.devicePixelRatio||window.webkitDevicePixelRatio||window.mozDevicePixelRatio||
window.msDevicePixelRatio||1:1;this.ClearDeathRow();var c,g=this.alphaBackground&&!(this.isNodeWebkit||this.isWinJS||this.isWindowsPhone8||this.isCrosswalk);0<this.fullscreen_mode&&this.setSize(window.innerWidth,window.innerHeight,!0);try{this.enableWebGL&&(this.isCocoonJs||this.isEjecta||!this.isDomFree)&&(c={alpha:g,depth:!1,antialias:!1,failIfMajorPerformanceCaveat:!0},this.gl=a.getContext("webgl",c)||a.getContext("experimental-webgl",c))}catch(k){}if(this.gl){this.isDomFree||(this.overlay_canvas=
document.createElement("canvas"),jQuery(this.overlay_canvas).appendTo(this.canvas.parentNode),this.overlay_canvas.oncontextmenu=function(a){return!1},this.overlay_canvas.onselectstart=function(a){return!1},this.overlay_canvas.width=this.cssWidth,this.overlay_canvas.height=this.cssHeight,jQuery(this.overlay_canvas).css({width:this.cssWidth+"px",height:this.cssHeight+"px"}),this.positionOverlayCanvas(),this.overlay_ctx=this.overlay_canvas.getContext("2d"));this.glwrap=new cr.GLWrap(this.gl,this.isMobile);
this.glwrap.setSize(a.width,a.height);this.glwrap.enable_mipmaps=0!==this.downscalingQuality;this.ctx=null;this.canvas.addEventListener("webglcontextlost",function(a){a.preventDefault();b.onContextLost();console.log("[Construct 2] WebGL context lost");window.cr_setSuspended(!0)},!1);this.canvas.addEventListener("webglcontextrestored",function(a){b.glwrap.initState();b.glwrap.setSize(b.glwrap.width,b.glwrap.height,!0);b.layer_tex=null;b.layout_tex=null;b.fx_tex[0]=null;b.fx_tex[1]=null;b.onContextRestored();
b.redraw=!0;console.log("[Construct 2] WebGL context restored");window.cr_setSuspended(!1)},!1);var f,e,d,h,q,l;a=0;for(c=this.types_by_index.length;a<c;a++)for(e=this.types_by_index[a],g=0,f=e.effect_types.length;g<f;g++)h=e.effect_types[g],h.shaderindex=this.glwrap.getShaderIndex(h.id),this.uses_background_blending=this.uses_background_blending||this.glwrap.programUsesDest(h.shaderindex);a=0;for(c=this.layouts_by_index.length;a<c;a++){q=this.layouts_by_index[a];g=0;for(f=q.effect_types.length;g<
f;g++)h=q.effect_types[g],h.shaderindex=this.glwrap.getShaderIndex(h.id);g=0;for(f=q.layers.length;g<f;g++)for(l=q.layers[g],e=0,d=l.effect_types.length;e<d;e++)h=l.effect_types[e],h.shaderindex=this.glwrap.getShaderIndex(h.id),this.uses_background_blending=this.uses_background_blending||this.glwrap.programUsesDest(h.shaderindex)}}else{if(0<this.fullscreen_mode&&this.isDirectCanvas){this.canvas=null;document.oncontextmenu=function(a){return!1};document.onselectstart=function(a){return!1};this.ctx=
AppMobi.canvas.getContext("2d");try{this.ctx.samplingMode=this.linearSampling?"smooth":"sharp",this.ctx.globalScale=1,this.ctx.HTML5CompatibilityMode=!0,this.ctx.imageSmoothingEnabled=this.linearSampling}catch(m){}0!==this.width&&0!==this.height&&(this.ctx.width=this.width,this.ctx.height=this.height)}this.ctx||(c=this.isCocoonJs?{antialias:!!this.linearSampling,alpha:g}:{alpha:g},this.ctx=a.getContext("2d",c),this.ctx.webkitImageSmoothingEnabled=this.linearSampling,this.ctx.mozImageSmoothingEnabled=
this.linearSampling,this.ctx.msImageSmoothingEnabled=this.linearSampling,this.ctx.imageSmoothingEnabled=this.linearSampling);this.overlay_ctx=this.overlay_canvas=null}this.tickFunc=function(){b.tick(!1)};window==window.top||this.isDomFree||this.isWinJS||this.isWindowsPhone8||(document.addEventListener("mousedown",function(){window.focus()},!0),document.addEventListener("touchstart",function(){window.focus()},!0));"undefined"!==typeof cr_is_preview&&(this.isCocoonJs&&console.log("[Construct 2] In preview-over-wifi via CocoonJS mode"),
-1<window.location.search.indexOf("continuous")&&(cr.logexport("Reloading for continuous preview"),this.loadFromSlot="__c2_continuouspreview",this.suspendDrawing=!0),this.pauseOnBlur&&!this.isMobile&&(jQuery(window).focus(function(){b.setSuspended(!1)}),jQuery(window).blur(function(){b.setSuspended(!0)})));a=function(a){cr.isCanvasInputEvent(a)&&document.activeElement&&document.activeElement.blur&&document.activeElement.blur()};window.navigator.pointerEnabled?document.addEventListener("pointerdown",
a):window.navigator.msPointerEnabled?document.addEventListener("MSPointerDown",a):document.addEventListener("touchstart",a);0===this.fullscreen_mode&&this.isRetina&&1<this.devicePixelRatio&&this.setSize(this.original_width,this.original_height,!0);this.tryLockOrientation();this.getready();this.go();this.extra={};cr.seal(this)}}function c(a){a.target.result.createObjectStore("saves",{keyPath:"slot"})}function b(a,b,f,g){var k=indexedDB.open("_C2SaveStates");k.onupgradeneeded=c;k.onerror=g;k.onsuccess=
function(k){k=k.target.result;k.onerror=g;k.transaction(["saves"],"readwrite").objectStore("saves").put({slot:a,data:b}).onsuccess=f}}function d(a,b,f){var g=indexedDB.open("_C2SaveStates");g.onupgradeneeded=c;g.onerror=f;g.onsuccess=function(g){g=g.target.result;g.onerror=f;var c=g.transaction(["saves"]).objectStore("saves").get(a);c.onsuccess=function(a){c.result?b(c.result.data):b(null)}}}function f(){cr.logexport("Reloading for continuous preview");window.c2cocoonjs?CocoonJS.App.reload():-1<window.location.search.indexOf("continuous")?
window.location.reload(!0):window.location+="?continuous"}function e(a){var b,c={};for(b in a)!a.hasOwnProperty(b)||a[b]instanceof cr.ObjectSet||a[b]&&"undefined"!==typeof a[b].c2userdata||(c[b]=a[b]);return c}a.prototype.setSize=function(a,b,c){var g=0,k=0,f=0,e=0,e=0,d=this.isiPhoneiOS6&&this.isSafari&&!navigator.standalone&&!this.isDomFree&&!this.isPhoneGap;d&&(b+=60);if(this.lastWindowWidth!==a||this.lastWindowHeight!==b||c){this.lastWindowWidth=a;this.lastWindowHeight=b;var h=this.fullscreen_mode,
q=(document.mozFullScreen||document.webkitIsFullScreen||!!document.msFullscreenElement||document.fullScreen||this.isNodeFullscreen)&&!this.isPhoneGap;if(q||0!==this.fullscreen_mode||c)q&&0<this.fullscreen_scaling&&(h=this.fullscreen_scaling),c=this.devicePixelRatio,4<=h?(f=this.original_width/this.original_height,a/b>f?(f*=b,5===h?(e=f*c/this.original_width,1<e?e=Math.floor(e):1>e&&(e=1/Math.ceil(1/e)),f=this.original_width*e/c,e=this.original_height*e/c,g=(a-f)/2,k=(b-e)/2,a=f,b=e):(g=(a-f)/2,a=
f)):(e=a/f,5===h?(e=e*c/this.original_height,1<e?e=Math.floor(e):1>e&&(e=1/Math.ceil(1/e)),f=this.original_width*e/c,e=this.original_height*e/c,g=(a-f)/2,k=(b-e)/2,a=f):k=(b-e)/2,b=e),q&&!this.isNodeWebkit&&(k=g=0)):this.isNodeWebkit&&this.isNodeFullscreen&&0===this.fullscreen_mode_set&&(g=Math.floor((a-this.original_width)/2),k=Math.floor((b-this.original_height)/2),a=this.original_width,b=this.original_height),2>h&&(this.aspect_scale=c),this.isRetina&&this.isiPad&&1<c&&(1024<=a&&(a=1023),1024<=
b&&(b=1023)),this.cssWidth=Math.round(a),this.cssHeight=Math.round(b),this.width=Math.round(a*c),this.height=Math.round(b*c),this.redraw=!0,this.wantFullscreenScalingQuality?(this.draw_width=this.width,this.draw_height=this.height,this.fullscreenScalingQuality=!0):this.width<this.original_width&&this.height<this.original_height||1===h?(this.draw_width=this.width,this.draw_height=this.height,this.fullscreenScalingQuality=!0):(this.draw_width=this.original_width,this.draw_height=this.original_height,
this.fullscreenScalingQuality=!1,2===h?(f=this.original_width/this.original_height,h=this.lastWindowWidth/this.lastWindowHeight,h<f?this.draw_width=this.draw_height*h:h>f&&(this.draw_height=this.draw_width/h)):3===h&&(f=this.original_width/this.original_height,h=this.lastWindowWidth/this.lastWindowHeight,h>f?this.draw_width=this.draw_height*h:h<f&&(this.draw_height=this.draw_width/h))),this.canvasdiv&&!this.isDomFree&&(jQuery(this.canvasdiv).css({width:Math.round(a)+"px",height:Math.round(b)+"px",
"margin-left":Math.floor(g)+"px","margin-top":Math.floor(k)+"px"}),"undefined"!==typeof cr_is_preview&&jQuery("#borderwrap").css({width:Math.round(a)+"px",height:Math.round(b)+"px"})),this.canvas&&(this.canvas.width=Math.round(a*c),this.canvas.height=Math.round(b*c),this.isEjecta?(this.canvas.style.left=Math.floor(g)+"px",this.canvas.style.top=Math.floor(k)+"px",this.canvas.style.width=Math.round(a)+"px",this.canvas.style.height=Math.round(b)+"px"):this.isRetina&&!this.isDomFree&&jQuery(this.canvas).css({width:Math.round(a)+
"px",height:Math.round(b)+"px"})),this.overlay_canvas&&(this.overlay_canvas.width=Math.round(a),this.overlay_canvas.height=Math.round(b),jQuery(this.overlay_canvas).css({width:Math.round(a)+"px",height:Math.round(b)+"px"})),this.glwrap&&this.glwrap.setSize(Math.round(a*c),Math.round(b*c)),this.isDirectCanvas&&this.ctx&&(this.ctx.width=Math.round(a),this.ctx.height=Math.round(b)),this.ctx&&(this.ctx.webkitImageSmoothingEnabled=this.linearSampling,this.ctx.mozImageSmoothingEnabled=this.linearSampling,
this.ctx.msImageSmoothingEnabled=this.linearSampling,this.ctx.imageSmoothingEnabled=this.linearSampling),this.tryLockOrientation(),this.isDomFree||!d&&!this.isiPhone||window.setTimeout(function(){window.scrollTo(0,1)},100)}};a.prototype.tryLockOrientation=function(){if(this.autoLockOrientation&&0!==this.orientations){var a="portrait";2===this.orientations&&(a="landscape");screen.lockOrientation?screen.lockOrientation(a):screen.webkitLockOrientation?screen.webkitLockOrientation(a):screen.mozLockOrientation?
screen.mozLockOrientation(a):screen.msLockOrientation&&screen.msLockOrientation(a)}};a.prototype.onContextLost=function(){this.is_WebGL_context_lost=!0;var a,b,c;a=0;for(b=this.types_by_index.length;a<b;a++)if(c=this.types_by_index[a],c.onLostWebGLContext)c.onLostWebGLContext()};a.prototype.onContextRestored=function(){this.is_WebGL_context_lost=!1;var a,b,c;a=0;for(b=this.types_by_index.length;a<b;a++)if(c=this.types_by_index[a],c.onRestoreWebGLContext)c.onRestoreWebGLContext()};a.prototype.positionOverlayCanvas=
function(){if(!this.isDomFree){var a=(document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||document.msFullscreenElement||this.isNodeFullscreen)&&!this.isPhoneGap?jQuery(this.canvas).offset():jQuery(this.canvas).position();a.position="absolute";jQuery(this.overlay_canvas).css(a)}};var h=window.cancelAnimationFrame||window.mozCancelAnimationFrame||window.webkitCancelAnimationFrame||window.msCancelAnimationFrame||window.oCancelAnimationFrame;a.prototype.setSuspended=function(a){var b;
if(a&&!this.isSuspended)for(cr.logexport("[Construct 2] Suspending"),this.isSuspended=!0,-1!==this.raf_id&&h&&h(this.raf_id),-1!==this.timeout_id&&clearTimeout(this.timeout_id),a=0,b=this.suspend_events.length;a<b;a++)this.suspend_events[a](!0);else if(!a&&this.isSuspended){cr.logexport("[Construct 2] Resuming");this.isSuspended=!1;this.last_tick_time=cr.performance_now();this.last_fps_time=cr.performance_now();a=this.logictime=this.framecount=0;for(b=this.suspend_events.length;a<b;a++)this.suspend_events[a](!1);
this.tick(!1)}};a.prototype.addSuspendCallback=function(a){this.suspend_events.push(a)};a.prototype.load=function(){var a=cr.getProjectModel();this.name=a[0];this.first_layout=a[1];this.fullscreen_mode=a[12];this.fullscreen_mode_set=a[12];this.original_width=a[10];this.original_height=a[11];this.parallax_x_origin=this.original_width/2;this.parallax_y_origin=this.original_height/2;this.isDomFree&&!this.isEjecta&&(4<=a[12]||0===a[12])&&(cr.logexport("[Construct 2] Letterbox scale fullscreen modes are not supported on this platform - falling back to 'Scale outer'"),
this.fullscreen_mode_set=this.fullscreen_mode=3);this.uses_loader_layout=a[18];this.loaderstyle=a[19];0===this.loaderstyle&&(this.loaderlogo=new Image,this.loaderlogo.src="loading-logo.png");this.next_uid=a[21];this.system=new cr.system_object(this);var b,c,g,k,f,e,d,h,q;b=0;for(c=a[2].length;b<c;b++){d=a[2][b];cr.add_common_aces(d);q=new d[0](this);q.singleglobal=d[1];q.is_world=d[2];q.must_predraw=d[9];if(q.onCreate)q.onCreate();cr.seal(q);this.plugins.push(q)}a=cr.getProjectModel();b=0;for(c=a[3].length;b<
c;b++){d=a[3][b];f=d[1];q=null;g=0;for(k=this.plugins.length;g<k;g++)if(this.plugins[g]instanceof f){q=this.plugins[g];break}var l=new q.Type(q);l.name=d[0];l.is_family=d[2];l.instvar_sids=d[3].slice(0);l.vars_count=d[3].length;l.behs_count=d[4];l.fx_count=d[5];l.sid=d[11];l.is_family?(l.members=[],l.family_index=this.family_count++,l.families=null):(l.members=null,l.family_index=-1,l.families=[]);l.family_var_map=null;l.family_beh_map=null;l.family_fx_map=null;l.is_contained=!1;l.container=null;
d[6]?(l.texture_file=d[6][0],l.texture_filesize=d[6][1],l.texture_pixelformat=d[6][2]):(l.texture_file=null,l.texture_filesize=0,l.texture_pixelformat=0);l.animations=d[7]?d[7]:null;l.index=b;l.instances=[];l.deadCache=[];l.solstack=[new cr.selection(l)];l.cur_sol=0;l.default_instance=null;l.default_layerindex=0;l.stale_iids=!0;l.updateIIDs=cr.type_updateIIDs;l.getFirstPicked=cr.type_getFirstPicked;l.getPairedInstance=cr.type_getPairedInstance;l.getCurrentSol=cr.type_getCurrentSol;l.pushCleanSol=
cr.type_pushCleanSol;l.pushCopySol=cr.type_pushCopySol;l.popSol=cr.type_popSol;l.getBehaviorByName=cr.type_getBehaviorByName;l.getBehaviorIndexByName=cr.type_getBehaviorIndexByName;l.getEffectIndexByName=cr.type_getEffectIndexByName;l.applySolToContainer=cr.type_applySolToContainer;l.getInstanceByIID=cr.type_getInstanceByIID;l.collision_grid=new cr.SparseGrid(this.original_width,this.original_height);l.any_cell_changed=!0;l.any_instance_parallaxed=!1;l.extra={};l.toString=cr.type_toString;l.behaviors=
[];g=0;for(k=d[8].length;g<k;g++){h=d[8][g];var m=h[1],p=null;f=0;for(e=this.behaviors.length;f<e;f++)if(this.behaviors[f]instanceof m){p=this.behaviors[f];break}if(!p){p=new m(this);p.my_types=[];p.my_instances=new cr.ObjectSet;if(p.onCreate)p.onCreate();cr.seal(p);this.behaviors.push(p);cr.behaviors.solid&&p instanceof cr.behaviors.solid&&(this.solidBehavior=p);cr.behaviors.jumpthru&&p instanceof cr.behaviors.jumpthru&&(this.jumpthruBehavior=p);cr.behaviors.shadowcaster&&p instanceof cr.behaviors.shadowcaster&&
(this.shadowcasterBehavior=p)}-1===p.my_types.indexOf(l)&&p.my_types.push(l);f=new p.Type(p,l);f.name=h[0];f.sid=h[2];f.onCreate();cr.seal(f);l.behaviors.push(f)}l.global=d[9];l.isOnLoaderLayout=d[10];l.effect_types=[];g=0;for(k=d[12].length;g<k;g++)l.effect_types.push({id:d[12][g][0],name:d[12][g][1],shaderindex:-1,active:!0,index:g});l.tile_poly_data=d[13];if(!this.uses_loader_layout||l.is_family||l.isOnLoaderLayout||!q.is_world)l.onCreate(),cr.seal(l);l.name&&(this.types[l.name]=l);this.types_by_index.push(l);
q.singleglobal&&(g=new q.Instance(l),g.uid=this.next_uid++,g.puid=this.next_puid++,g.iid=0,g.get_iid=cr.inst_get_iid,g.toString=cr.inst_toString,g.properties=d[14],g.onCreate(),cr.seal(g),l.instances.push(g),this.objectsByUid[g.uid.toString()]=g)}b=0;for(c=a[4].length;b<c;b++)for(f=a[4][b],e=this.types_by_index[f[0]],g=1,k=f.length;g<k;g++)d=this.types_by_index[f[g]],d.families.push(e),e.members.push(d);b=0;for(c=a[26].length;b<c;b++){f=a[26][b];e=[];g=0;for(k=f.length;g<k;g++)e.push(this.types_by_index[f[g]]);
g=0;for(k=e.length;g<k;g++)e[g].is_contained=!0,e[g].container=e}if(0<this.family_count)for(b=0,c=this.types_by_index.length;b<c;b++)if(d=this.types_by_index[b],!d.is_family&&d.families.length){d.family_var_map=Array(this.family_count);d.family_beh_map=Array(this.family_count);d.family_fx_map=Array(this.family_count);l=[];g=p=m=h=0;for(k=d.families.length;g<k;g++)for(q=d.families[g],d.family_var_map[q.family_index]=h,h+=q.vars_count,d.family_beh_map[q.family_index]=m,m+=q.behs_count,d.family_fx_map[q.family_index]=
p,p+=q.fx_count,f=0,e=q.effect_types.length;f<e;f++)l.push(cr.shallowCopy({},q.effect_types[f]));d.effect_types=l.concat(d.effect_types);g=0;for(k=d.effect_types.length;g<k;g++)d.effect_types[g].index=g}b=0;for(c=a[5].length;b<c;b++)d=a[5][b],g=new cr.layout(this,d),cr.seal(g),this.layouts[g.name]=g,this.layouts_by_index.push(g);b=0;for(c=a[6].length;b<c;b++)d=a[6][b],g=new cr.eventsheet(this,d),cr.seal(g),this.eventsheets[g.name]=g,this.eventsheets_by_index.push(g);b=0;for(c=this.eventsheets_by_index.length;b<
c;b++)this.eventsheets_by_index[b].postInit();b=0;for(c=this.eventsheets_by_index.length;b<c;b++)this.eventsheets_by_index[b].updateDeepIncludes();b=0;for(c=this.triggers_to_postinit.length;b<c;b++)this.triggers_to_postinit[b].postInit();this.triggers_to_postinit.length=0;this.audio_to_preload=a[7];this.files_subfolder=a[8];this.pixel_rounding=a[9];this.aspect_scale=1;this.enableWebGL=a[13];this.linearSampling=a[14];this.alphaBackground=a[15];this.versionstr=a[16];this.useHighDpi=a[17];this.orientations=
a[20];this.autoLockOrientation=0<this.orientations;this.pauseOnBlur=a[22];this.fullscreenScalingQuality=this.wantFullscreenScalingQuality=a[23];this.downscalingQuality=a[24];this.preloadSounds=a[25];this.start_time=Date.now()};var p=!1;a.prototype.waitForImageLoad=function(a){a.onerror=function(b){p=a.c2error=!0;console&&console.error&&console.error("Error loading image '"+a.src+"': ",b)};this.wait_for_textures.push(a)};a.prototype.findWaitingTexture=function(a){var b,c;b=0;for(c=this.wait_for_textures.length;b<
c;b++)if(this.wait_for_textures[b].cr_src===a)return this.wait_for_textures[b];return null};var m=0,n=!1;a.prototype.getready=function(){this.audioInstance&&(m=this.audioInstance.setPreloadList(this.audio_to_preload))};a.prototype.areAllTexturesAndSoundsLoaded=function(){var a=m,b=0,c=0,g=!0,k,f,c=0;for(k=this.wait_for_textures.length;c<k;c++){f=this.wait_for_textures[c];var e=f.cr_filesize;if(!e||0>=e)e=5E4;a+=e;!f.complete&&!f.loaded||f.c2error?g=!1:b+=e}g&&this.preloadSounds&&this.audioInstance&&
(n||(this.audioInstance.startPreloads(),n=!0),c=this.audioInstance.getPreloadedSize(),b+=c,c<m&&(g=!1));this.progress=0==a?0:b/a;return g};a.prototype.go=function(){if(this.ctx||this.glwrap){var a=this.ctx||this.overlay_ctx;this.overlay_canvas&&this.positionOverlayCanvas();this.progress=0;this.last_progress=-1;if(this.areAllTexturesAndSoundsLoaded())this.go_loading_finished();else{var b=Date.now()-this.start_time;if(a){var c=this.width,g=this.height,k=this.devicePixelRatio;this.overlay_canvas&&(c=
this.cssWidth,g=this.cssHeight,k=1);if(3!==this.loaderstyle&&(this.isCocoonJs||500<=b&&this.last_progress!=this.progress)){a.clearRect(0,0,c,g);var b=c/2,g=g/2,c=0===this.loaderstyle&&this.loaderlogo.complete,f=40*k,e=0,d=80*k,h;c&&(d=this.loaderlogo.width*k,h=this.loaderlogo.height*k,f=d/2,e=h/2,a.drawImage(this.loaderlogo,cr.floor(b-f),cr.floor(g-e),d,h));1>=this.loaderstyle?(g+=e+(c?12*k:0),b=cr.floor(b-f)+0.5,g=cr.floor(g)+0.5,a.fillStyle=p?"red":"DodgerBlue",a.fillRect(b,g,Math.floor(d*this.progress),
6*k),a.strokeStyle="black",a.strokeRect(b,g,d,6*k),a.strokeStyle="white",a.strokeRect(b-1*k,g-1*k,d+2*k,8*k)):2===this.loaderstyle&&(a.font=this.isEjecta?"12pt ArialMT":"12pt Arial",a.fillStyle=p?"#f00":"#999",a.textBaseLine="middle",k=Math.round(100*this.progress)+"%",c=a.measureText?a.measureText(k):null,a.fillText(k,b-(c?c.width:0)/2,g))}this.last_progress=this.progress}setTimeout(function(a){return function(){a.go()}}(this),this.isCocoonJs?10:100)}}};a.prototype.go_loading_finished=function(){this.overlay_canvas&&
(this.canvas.parentNode.removeChild(this.overlay_canvas),this.overlay_canvas=this.overlay_ctx=null);this.start_time=Date.now();this.last_fps_time=cr.performance_now();var a,b,c;if(this.uses_loader_layout)for(a=0,b=this.types_by_index.length;a<b;a++)c=this.types_by_index[a],c.is_family||c.isOnLoaderLayout||!c.plugin.is_world||(c.onCreate(),cr.seal(c));else this.isloading=!1;a=0;for(b=this.layouts_by_index.length;a<b;a++)this.layouts_by_index[a].createGlobalNonWorlds();2<=this.fullscreen_mode&&(a=this.original_width/
this.original_height,b=this.width/this.height,this.aspect_scale=2!==this.fullscreen_mode&&b>a||2===this.fullscreen_mode&&b<a?this.height/this.original_height:this.width/this.original_width);this.first_layout?this.layouts[this.first_layout].startRunning():this.layouts_by_index[0].startRunning();this.uses_loader_layout||(this.loadingprogress=1,this.trigger(cr.system_object.prototype.cnds.OnLoadFinished,null));navigator.splashscreen&&navigator.splashscreen.hide&&navigator.splashscreen.hide();a=0;for(b=
this.types_by_index.length;a<b;a++)if(c=this.types_by_index[a],c.onAppBegin)c.onAppBegin();this.tick(!1);this.isDirectCanvas&&AppMobi.webview.execute("onGameReady();")};var l=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.msRequestAnimationFrame||window.oRequestAnimationFrame;a.prototype.tick=function(a){if(this.running_layout){var b=cr.performance_now();if(this.halfFramerateMode&&this.ranLastRaf&&29>b-this.lastRafTime)this.ranLastRaf=!1,
this.lastRafTime=b,l?this.raf_id=l(this.tickFunc,this.canvas):this.timeout_id=setTimeout(this.tickFunc,this.isMobile?1:16);else{this.ranLastRaf=!0;this.lastRafTime=b;var c=this.fullscreen_mode,g=(document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||!!document.msFullscreenElement)&&!this.isPhoneGap;(g||this.isNodeFullscreen)&&0<this.fullscreen_scaling&&(c=this.fullscreen_scaling);if(0<c&&(!this.isiOS||window.self!==window.top)){var c=window.innerWidth,k=window.innerHeight;this.lastWindowWidth===
c&&this.lastWindowHeight===k||this.setSize(c,k)}this.isDomFree||(g?(this.firstInFullscreen||(this.fullscreenOldMarginCss=jQuery(this.canvas).css("margin")||"0",this.firstInFullscreen=!0),this.isChrome||this.isNodeWebkit||jQuery(this.canvas).css({"margin-left":""+Math.floor((screen.width-this.width/this.devicePixelRatio)/2)+"px","margin-top":""+Math.floor((screen.height-this.height/this.devicePixelRatio)/2)+"px"})):this.firstInFullscreen?(this.isChrome||this.isNodeWebkit||jQuery(this.canvas).css("margin",
this.fullscreenOldMarginCss),this.fullscreenOldMarginCss="",this.firstInFullscreen=!1,0===this.fullscreen_mode&&this.setSize(Math.round(this.oldWidth/this.devicePixelRatio),Math.round(this.oldHeight/this.devicePixelRatio),!0)):(this.oldWidth=this.width,this.oldHeight=this.height));this.isloading&&(g=this.areAllTexturesAndSoundsLoaded(),this.loadingprogress=this.progress,g&&(this.isloading=!1,this.progress=1,this.trigger(cr.system_object.prototype.cnds.OnLoadFinished,null)));this.logic();!this.redraw&&
!this.isCocoonJs||this.is_WebGL_context_lost||this.suspendDrawing||a||(this.redraw=!1,this.glwrap?this.drawGL():this.draw(),this.snapshotCanvas&&(this.canvas&&this.canvas.toDataURL&&(this.snapshotData=this.canvas.toDataURL(this.snapshotCanvas[0],this.snapshotCanvas[1]),this.trigger(cr.system_object.prototype.cnds.OnCanvasSnapshot,null)),this.snapshotCanvas=null));this.hit_breakpoint||(this.tickcount++,this.execcount++,this.framecount++);this.logictime+=cr.performance_now()-b;this.isSuspended||a||
(l?this.raf_id=l(this.tickFunc,this.canvas):this.timeout_id=setTimeout(this.tickFunc,this.isMobile?1:16))}}};a.prototype.logic=function(){var a,b,c,g,k,f,e,d,h;a=cr.performance_now();1E3<=a-this.last_fps_time&&(this.last_fps_time+=1E3,this.fps=this.framecount,this.framecount=0,this.cpuutilisation=this.logictime,this.logictime=0);this.measuring_dt&&(0!==this.last_tick_time&&(b=a-this.last_tick_time,0!==b||this.isDebug?(this.dt1=b/1E3,0.5<this.dt1?this.dt1=0:0.1<this.dt1&&(this.dt1=0.1)):(this.zeroDtCount++,
10<=this.zeroDtCout&&(this.measuring_dt=!1),this.dt1=1/60)),this.last_tick_time=a);this.dt=this.dt1*this.timescale;this.kahanTime.add(this.dt);a=(document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||!!document.msFullscreenElement||this.isNodeFullscreen)&&!this.isPhoneGap;2<=this.fullscreen_mode||a&&0<this.fullscreen_scaling?(b=this.original_width/this.original_height,c=this.width/this.height,g=this.fullscreen_mode,a&&0<this.fullscreen_scaling&&(g=this.fullscreen_scaling),this.aspect_scale=
2!==g&&c>b||2===g&&c<b?this.height/this.original_height:this.width/this.original_width,this.running_layout&&(this.running_layout.scrollToX(this.running_layout.scrollX),this.running_layout.scrollToY(this.running_layout.scrollY))):this.aspect_scale=this.isRetina?this.devicePixelRatio:1;this.ClearDeathRow();this.isInOnDestroy++;this.system.runWaits();this.isInOnDestroy--;this.ClearDeathRow();this.isInOnDestroy++;c=this.objects_to_pretick.valuesRef();a=0;for(b=c.length;a<b;a++)c[a].pretick();a=0;for(b=
this.types_by_index.length;a<b;a++)if(e=this.types_by_index[a],!e.is_family&&(e.behaviors.length||e.families.length))for(c=0,g=e.instances.length;c<g;c++)for(d=e.instances[c],k=0,f=d.behavior_insts.length;k<f;k++)d.behavior_insts[k].tick();a=0;for(b=this.types_by_index.length;a<b;a++)if(e=this.types_by_index[a],!e.is_family&&(e.behaviors.length||e.families.length))for(c=0,g=e.instances.length;c<g;c++)for(d=e.instances[c],k=0,f=d.behavior_insts.length;k<f;k++)h=d.behavior_insts[k],h.posttick&&h.posttick();
c=this.objects_to_tick.valuesRef();a=0;for(b=c.length;a<b;a++)c[a].tick();this.isInOnDestroy--;this.handleSaveLoad();for(a=0;this.changelayout&&10>a++;)this.doChangeLayout(this.changelayout);a=0;for(b=this.eventsheets_by_index.length;a<b;a++)this.eventsheets_by_index[a].hasRun=!1;this.running_layout.event_sheet&&this.running_layout.event_sheet.run();this.registered_collisions.length=0;this.layout_first_tick=!1;this.isInOnDestroy++;a=0;for(b=this.types_by_index.length;a<b;a++)if(e=this.types_by_index[a],
!e.is_family&&(e.behaviors.length||e.families.length))for(c=0,g=e.instances.length;c<g;c++)for(d=e.instances[c],k=0,f=d.behavior_insts.length;k<f;k++)h=d.behavior_insts[k],h.tick2&&h.tick2();c=this.objects_to_tick2.valuesRef();a=0;for(b=c.length;a<b;a++)c[a].tick2();this.isInOnDestroy--};a.prototype.doChangeLayout=function(a){var b=this.running_layout;this.running_layout.stopRunning();var c,g,k,f,e,d,h;if(this.glwrap)for(c=0,g=this.types_by_index.length;c<g;c++)e=this.types_by_index[c],e.is_family||
!e.unloadTextures||e.global&&0!==e.instances.length||-1!==a.initial_types.indexOf(e)||e.unloadTextures();b==a&&(this.system.waits.length=0);a.startRunning();c=0;for(g=this.types_by_index.length;c<g;c++)if(e=this.types_by_index[c],e.global||e.plugin.singleglobal)for(a=0,b=e.instances.length;a<b;a++){d=e.instances[a];if(d.onLayoutChange)d.onLayoutChange();if(d.behavior_insts)for(k=0,f=d.behavior_insts.length;k<f;k++)if(h=d.behavior_insts[k],h.onLayoutChange)h.onLayoutChange()}this.layout_first_tick=
this.redraw=!0;this.ClearDeathRow()};a.prototype.pretickMe=function(a){this.objects_to_pretick.add(a)};a.prototype.unpretickMe=function(a){this.objects_to_pretick.remove(a)};a.prototype.tickMe=function(a){this.objects_to_tick.add(a)};a.prototype.untickMe=function(a){this.objects_to_tick.remove(a)};a.prototype.tick2Me=function(a){this.objects_to_tick2.add(a)};a.prototype.untick2Me=function(a){this.objects_to_tick2.remove(a)};a.prototype.getDt=function(a){return a&&-1!==a.my_timescale?this.dt1*a.my_timescale:
this.dt};a.prototype.draw=function(){this.running_layout.draw(this.ctx);this.isDirectCanvas&&this.ctx.present()};a.prototype.drawGL=function(){this.running_layout.drawGL(this.glwrap);this.glwrap.present()};a.prototype.addDestroyCallback=function(a){a&&this.destroycallbacks.push(a)};a.prototype.removeDestroyCallback=function(a){cr.arrayFindRemove(this.destroycallbacks,a)};a.prototype.getObjectByUID=function(a){a=a.toString();return this.objectsByUid.hasOwnProperty(a)?this.objectsByUid[a]:null};a.prototype.DestroyInstance=
function(a){var b,c;if(!this.deathRow.contains(a)){this.deathRow.add(a);if(a.is_contained)for(b=0,c=a.siblings.length;b<c;b++)this.DestroyInstance(a.siblings[b]);this.isInClearDeathRow&&this.deathRow.values_cache.push(a);this.isInOnDestroy++;this.trigger(Object.getPrototypeOf(a.type.plugin).cnds.OnDestroyed,a);this.isInOnDestroy--}};a.prototype.ClearDeathRow=function(){var a,b,c,g,k,f,e,d,h,l;this.isInClearDeathRow=!0;g=0;for(f=this.createRow.length;g<f;g++)for(a=this.createRow[g],b=a.type,b.instances.push(a),
k=0,e=b.families.length;k<e;k++)b.families[k].instances.push(a),b.families[k].stale_iids=!0;this.createRow.length=0;f=this.deathRow.valuesRef();for(g=0;g<f.length;g++){a=f[g];b=a.type;c=b.instances;k=0;for(e=this.destroycallbacks.length;k<e;k++)this.destroycallbacks[k](a);cr.arrayFindRemove(c,a);0===c.length&&(b.any_instance_parallaxed=!1);a.collcells&&b.collision_grid.update(a,a.collcells,null);a.layer&&(cr.arrayRemove(a.layer.instances,a.get_zindex()),a.layer.zindices_stale=!0);k=0;for(e=b.families.length;k<
e;k++)cr.arrayFindRemove(b.families[k].instances,a),b.families[k].stale_iids=!0;if(a.behavior_insts)for(k=0,e=a.behavior_insts.length;k<e;k++){c=a.behavior_insts[k];if(c.onDestroy)c.onDestroy();c.behavior.my_instances.remove(a)}this.objects_to_pretick.remove(a);this.objects_to_tick.remove(a);this.objects_to_tick2.remove(a);k=0;for(e=this.system.waits.length;k<e;k++)if(h=this.system.waits[k],h.sols.hasOwnProperty(b.index)&&cr.arrayFindRemove(h.sols[b.index].insts,a),!b.is_family)for(c=0,d=b.families.length;c<
d;c++)l=b.families[c],h.sols.hasOwnProperty(l.index)&&cr.arrayFindRemove(h.sols[l.index].insts,a);if(a.onDestroy)a.onDestroy();this.objectsByUid.hasOwnProperty(a.uid.toString())&&delete this.objectsByUid[a.uid.toString()];this.objectcount--;64>b.deadCache.length&&b.deadCache.push(a);b.stale_iids=!0}this.deathRow.isEmpty()||(this.redraw=!0);this.deathRow.clear();this.isInClearDeathRow=!1};a.prototype.createInstance=function(a,b,c,g){if(a.is_family){var k=cr.floor(Math.random()*a.members.length);return this.createInstance(a.members[k],
b,c,g)}return a.default_instance?this.createInstanceFromInit(a.default_instance,b,!1,c,g,!1):null};var q=[];a.prototype.createInstanceFromInit=function(a,b,c,g,k,f){var e,d,h,l;if(!a)return null;var m=this.types_by_index[a[1]],p=m.plugin.is_world;if(this.isloading&&p&&!m.isOnLoaderLayout||p&&!this.glwrap&&11===a[0][11])return null;var n=b;p||(b=null);var s;m.deadCache.length?(s=m.deadCache.pop(),s.recycled=!0,m.plugin.Instance.call(s,m)):(s=new m.plugin.Instance(m),s.recycled=!1);s.uid=c&&!f?a[2]:
this.next_uid++;this.objectsByUid[s.uid.toString()]=s;s.puid=this.next_puid++;s.iid=m.instances.length;e=0;for(d=this.createRow.length;e<d;++e)this.createRow[e].type===m&&s.iid++;s.get_iid=cr.inst_get_iid;h=a[3];if(s.recycled)cr.wipe(s.extra);else{s.extra={};if("undefined"!==typeof cr_is_preview)for(s.instance_var_names=[],s.instance_var_names.length=h.length,e=0,d=h.length;e<d;e++)s.instance_var_names[e]=h[e][1];s.instance_vars=[];s.instance_vars.length=h.length}e=0;for(d=h.length;e<d;e++)s.instance_vars[e]=
h[e][0];if(p){var w=a[0];s.x=cr.is_undefined(g)?w[0]:g;s.y=cr.is_undefined(k)?w[1]:k;s.z=w[2];s.width=w[3];s.height=w[4];s.depth=w[5];s.angle=w[6];s.opacity=w[7];s.hotspotX=w[8];s.hotspotY=w[9];s.blend_mode=w[10];e=w[11];!this.glwrap&&m.effect_types.length&&(s.blend_mode=e);s.compositeOp=cr.effectToCompositeOp(s.blend_mode);this.gl&&cr.setGLBlend(s,s.blend_mode,this.gl);if(s.recycled){e=0;for(d=w[12].length;e<d;e++)for(h=0,l=w[12][e].length;h<l;h++)s.effect_params[e][h]=w[12][e][h];s.bbox.set(0,0,
0,0);s.collcells.set(0,0,-1,-1);s.bquad.set_from_rect(s.bbox);s.bbox_changed_callbacks.length=0}else{s.effect_params=w[12].slice(0);e=0;for(d=s.effect_params.length;e<d;e++)s.effect_params[e]=w[12][e].slice(0);s.active_effect_types=[];s.active_effect_flags=[];s.active_effect_flags.length=m.effect_types.length;s.bbox=new cr.rect(0,0,0,0);s.collcells=new cr.rect(0,0,-1,-1);s.bquad=new cr.quad;s.bbox_changed_callbacks=[];s.set_bbox_changed=cr.set_bbox_changed;s.add_bbox_changed_callback=cr.add_bbox_changed_callback;
s.contains_pt=cr.inst_contains_pt;s.update_bbox=cr.update_bbox;s.update_collision_cell=cr.update_collision_cell;s.get_zindex=cr.inst_get_zindex}s.tilemap_exists=!1;s.tilemap_width=0;s.tilemap_height=0;s.tilemap_data=null;14===w.length&&(s.tilemap_exists=!0,s.tilemap_width=w[13][0],s.tilemap_height=w[13][1],s.tilemap_data=w[13][2]);e=0;for(d=m.effect_types.length;e<d;e++)s.active_effect_flags[e]=!0;s.updateActiveEffects=cr.inst_updateActiveEffects;s.updateActiveEffects();s.uses_shaders=!!s.active_effect_types.length;
s.bbox_changed=!0;s.cell_changed=!0;m.any_cell_changed=!0;s.visible=!0;s.my_timescale=-1;s.layer=b;s.zindex=b.instances.length;"undefined"===typeof s.collision_poly&&(s.collision_poly=null);this.redraw=s.collisionsEnabled=!0}s.toString=cr.inst_toString;var r;e=q.length=0;for(d=m.families.length;e<d;e++)q.push.apply(q,m.families[e].behaviors);q.push.apply(q,m.behaviors);if(s.recycled)for(e=0,d=q.length;e<d;e++){var u=q[e];r=s.behavior_insts[e];r.recycled=!0;u.behavior.Instance.call(r,u,s);w=a[4][e];
h=0;for(l=w.length;h<l;h++)r.properties[h]=w[h];r.onCreate();u.behavior.my_instances.add(s)}else for(s.behavior_insts=[],e=0,d=q.length;e<d;e++)u=q[e],r=new u.behavior.Instance(u,s),r.recycled=!1,r.properties=a[4][e].slice(0),r.onCreate(),cr.seal(r),s.behavior_insts.push(r),u.behavior.my_instances.add(s);w=a[5];if(s.recycled)for(e=0,d=w.length;e<d;e++)s.properties[e]=w[e];else s.properties=w.slice(0);this.createRow.push(s);b&&(b.instances.push(s),1!==b.parallaxX||1!==b.parallaxY)&&(m.any_instance_parallaxed=
!0);this.objectcount++;if(m.is_contained){if(s.is_contained=!0,s.recycled?s.siblings.length=0:s.siblings=[],!c&&!f){e=0;for(d=m.container.length;e<d;e++)if(m.container[e]!==m){if(!m.container[e].default_instance)return null;s.siblings.push(this.createInstanceFromInit(m.container[e].default_instance,n,!1,p?s.x:g,p?s.y:k,!0))}e=0;for(d=s.siblings.length;e<d;e++)for(s.siblings[e].siblings.push(s),h=0;h<d;h++)e!==h&&s.siblings[e].siblings.push(s.siblings[h])}}else s.is_contained=!1,s.siblings=null;s.onCreate();
s.recycled||cr.seal(s);e=0;for(d=s.behavior_insts.length;e<d;e++)s.behavior_insts[e].postCreate&&s.behavior_insts[e].postCreate();return s};a.prototype.getLayerByName=function(a){var b,c;b=0;for(c=this.running_layout.layers.length;b<c;b++){var g=this.running_layout.layers[b];if(cr.equals_nocase(g.name,a))return g}return null};a.prototype.getLayerByNumber=function(a){a=cr.floor(a);0>a&&(a=0);a>=this.running_layout.layers.length&&(a=this.running_layout.layers.length-1);return this.running_layout.layers[a]};
a.prototype.getLayer=function(a){return cr.is_number(a)?this.getLayerByNumber(a):this.getLayerByName(a.toString())};a.prototype.clearSol=function(a){var b,c;b=0;for(c=a.length;b<c;b++)a[b].getCurrentSol().select_all=!0};a.prototype.pushCleanSol=function(a){var b,c;b=0;for(c=a.length;b<c;b++)a[b].pushCleanSol()};a.prototype.pushCopySol=function(a){var b,c;b=0;for(c=a.length;b<c;b++)a[b].pushCopySol()};a.prototype.popSol=function(a){var b,c;b=0;for(c=a.length;b<c;b++)a[b].popSol()};a.prototype.updateAllCells=
function(a){if(a.any_cell_changed){var b,c,g=a.instances;b=0;for(c=g.length;b<c;++b)g[b].update_collision_cell();g=this.createRow;b=0;for(c=g.length;b<c;++b)g[b].type===a&&g[b].update_collision_cell();a.any_cell_changed=!1}};a.prototype.getCollisionCandidates=function(a,b,c,g){var k,f,e=a?1!==a.parallaxX||1!==a.parallaxY:!1;if(b.is_family)for(a=0,k=b.members.length;a<k;++a)f=b.members[a],e||f.any_instance_parallaxed?cr.appendArray(g,f.instances):(this.updateAllCells(f),f.collision_grid.queryRange(c,
g));else e||b.any_instance_parallaxed?cr.appendArray(g,b.instances):(this.updateAllCells(b),b.collision_grid.queryRange(c,g))};a.prototype.getTypesCollisionCandidates=function(a,b,c,g){var k,f;k=0;for(f=b.length;k<f;++k)this.getCollisionCandidates(a,b[k],c,g)};a.prototype.getSolidCollisionCandidates=function(a,b,c){var g=this.getSolidBehavior();if(!g)return null;this.getTypesCollisionCandidates(a,g.my_types,b,c)};a.prototype.getJumpthruCollisionCandidates=function(a,b,c){var g=this.getJumpthruBehavior();
if(!g)return null;this.getTypesCollisionCandidates(a,g.my_types,b,c)};a.prototype.testAndSelectCanvasPointOverlap=function(a,b,c,g){var k=a.getCurrentSol(),f,e,d,h,l,q;if(k.select_all)for(g||(k.select_all=!1,k.instances.length=0),f=0,h=a.instances.length;f<h;f++){if(d=a.instances[f],d.update_bbox(),l=d.layer.canvasToLayer(b,c,!0),q=d.layer.canvasToLayer(b,c,!1),d.contains_pt(l,q)){if(g)return!1;k.instances.push(d)}}else{f=e=0;for(h=k.instances.length;f<h;f++)if(d=k.instances[f],d.update_bbox(),l=
d.layer.canvasToLayer(b,c,!0),q=d.layer.canvasToLayer(b,c,!1),d.contains_pt(l,q)){if(g)return!1;k.instances[e]=k.instances[f];e++}g||(k.instances.length=e)}a.applySolToContainer();return g?!0:k.hasObjects()};a.prototype.testOverlap=function(a,b){if(!(a&&b&&a!==b&&a.collisionsEnabled&&b.collisionsEnabled))return!1;a.update_bbox();b.update_bbox();var c=a.layer,g=b.layer,k,f,e,d,h,l,q,m;if(c===g||c.parallaxX===g.parallaxX&&g.parallaxY===g.parallaxY&&c.scale===g.scale&&c.angle===g.angle&&c.zoomRate===
g.zoomRate){if(!a.bbox.intersects_rect(b.bbox)||!a.bquad.intersects_quad(b.bquad)||a.tilemap_exists&&b.tilemap_exists)return!1;if(a.tilemap_exists)return this.testTilemapOverlap(a,b);if(b.tilemap_exists)return this.testTilemapOverlap(b,a);q=a.collision_poly&&!a.collision_poly.is_empty();k=b.collision_poly&&!b.collision_poly.is_empty();if(!q&&!k)return!0;q?(a.collision_poly.cache_poly(a.width,a.height,a.angle),q=a.collision_poly):(this.temp_poly.set_from_quad(a.bquad,a.x,a.y,a.width,a.height),q=this.temp_poly);
k?(b.collision_poly.cache_poly(b.width,b.height,b.angle),m=b.collision_poly):(this.temp_poly.set_from_quad(b.bquad,b.x,b.y,b.width,b.height),m=this.temp_poly);return q.intersects_poly(m,b.x-a.x,b.y-a.y)}q=a.collision_poly&&!a.collision_poly.is_empty();k=b.collision_poly&&!b.collision_poly.is_empty();q?(a.collision_poly.cache_poly(a.width,a.height,a.angle),this.temp_poly.set_from_poly(a.collision_poly)):this.temp_poly.set_from_quad(a.bquad,a.x,a.y,a.width,a.height);q=this.temp_poly;k?(b.collision_poly.cache_poly(b.width,
b.height,b.angle),this.temp_poly2.set_from_poly(b.collision_poly)):this.temp_poly2.set_from_quad(b.bquad,b.x,b.y,b.width,b.height);m=this.temp_poly2;k=0;for(f=q.pts_count;k<f;k++)e=2*k,d=e+1,h=q.pts_cache[e],l=q.pts_cache[d],q.pts_cache[e]=c.layerToCanvas(h+a.x,l+a.y,!0),q.pts_cache[d]=c.layerToCanvas(h+a.x,l+a.y,!1);q.update_bbox();k=0;for(f=m.pts_count;k<f;k++)e=2*k,d=e+1,h=m.pts_cache[e],l=m.pts_cache[d],m.pts_cache[e]=g.layerToCanvas(h+b.x,l+b.y,!0),m.pts_cache[d]=g.layerToCanvas(h+b.x,l+b.y,
!1);m.update_bbox();return q.intersects_poly(m,0,0)};var u=new cr.quad,r=new cr.rect(0,0,0,0),t=[];a.prototype.testTilemapOverlap=function(a,b){var c,g,k,f,e=b.bbox,d=a.x,h=a.y;a.getCollisionRectCandidates(e,t);var l=b.collision_poly&&!b.collision_poly.is_empty();c=0;for(g=t.length;c<g;++c)if(k=t[c],f=k.rc,e.intersects_rect_off(f,d,h)&&(u.set_from_rect(f),u.offset(d,h),u.intersects_quad(b.bquad)))if(l)if(b.collision_poly.cache_poly(b.width,b.height,b.angle),k.poly){if(k.poly.intersects_poly(b.collision_poly,
b.x-(d+f.left),b.y-(h+f.top)))return t.length=0,!0}else{if(this.temp_poly.set_from_quad(u,0,0,f.right-f.left,f.bottom-f.top),this.temp_poly.intersects_poly(b.collision_poly,b.x,b.y))return t.length=0,!0}else if(k.poly){if(this.temp_poly.set_from_quad(b.bquad,0,0,b.width,b.height),k.poly.intersects_poly(this.temp_poly,-(d+f.left),-(h+f.top)))return t.length=0,!0}else return t.length=0,!0;t.length=0;return!1};a.prototype.testRectOverlap=function(a,b){if(!b||!b.collisionsEnabled)return!1;b.update_bbox();
if(!b.bbox.intersects_rect(a))return!1;if(b.tilemap_exists){b.getCollisionRectCandidates(a,t);var c,g,k,f,e=b.x,d=b.y;c=0;for(g=t.length;c<g;++c)if(k=t[c],f=k.rc,a.intersects_rect_off(f,e,d))if(k.poly){if(this.temp_poly.set_from_rect(a,0,0),k.poly.intersects_poly(this.temp_poly,-(e+f.left),-(d+f.top)))return t.length=0,!0}else return t.length=0,!0;t.length=0;return!1}u.set_from_rect(a);if(!b.bquad.intersects_quad(u))return!1;if(!b.collision_poly||b.collision_poly.is_empty())return!0;b.collision_poly.cache_poly(b.width,
b.height,b.angle);u.offset(-a.left,-a.top);this.temp_poly.set_from_quad(u,0,0,1,1);return b.collision_poly.intersects_poly(this.temp_poly,a.left-b.x,a.top-b.y)};a.prototype.testSegmentOverlap=function(a,b,c,g,k){if(!k||!k.collisionsEnabled)return!1;k.update_bbox();r.set(cr.min(a,c),cr.min(b,g),cr.max(a,c),cr.max(b,g));if(!k.bbox.intersects_rect(r))return!1;if(k.tilemap_exists){k.getCollisionRectCandidates(r,t);var f,e,d,h=k.x,l=k.y;k=0;for(f=t.length;k<f;++k)if(e=t[k],d=e.rc,r.intersects_rect_off(d,
h,l)&&(u.set_from_rect(d),u.offset(h,l),u.intersects_segment(a,b,c,g)))if(e.poly){if(e.poly.intersects_segment(h+d.left,l+d.top,a,b,c,g))return t.length=0,!0}else return t.length=0,!0;t.length=0;return!1}if(!k.bquad.intersects_segment(a,b,c,g))return!1;if(!k.collision_poly||k.collision_poly.is_empty())return!0;k.collision_poly.cache_poly(k.width,k.height,k.angle);return k.collision_poly.intersects_segment(k.x,k.y,a,b,c,g)};a.prototype.typeHasBehavior=function(a,b){if(!b)return!1;var c,g,k,f,e;c=0;
for(g=a.behaviors.length;c<g;c++)if(a.behaviors[c].behavior instanceof b)return!0;if(!a.is_family)for(c=0,g=a.families.length;c<g;c++)for(e=a.families[c],k=0,f=e.behaviors.length;k<f;k++)if(e.behaviors[k].behavior instanceof b)return!0;return!1};a.prototype.typeHasNoSaveBehavior=function(a){return this.typeHasBehavior(a,cr.behaviors.NoSave)};a.prototype.typeHasPersistBehavior=function(a){return this.typeHasBehavior(a,cr.behaviors.Persist)};a.prototype.getSolidBehavior=function(){return this.solidBehavior};
a.prototype.getJumpthruBehavior=function(){return this.jumpthruBehavior};var x=[];a.prototype.testOverlapSolid=function(a){var b,c,g;a.update_bbox();this.getSolidCollisionCandidates(a.layer,a.bbox,x);b=0;for(c=x.length;b<c;++b)if(g=x[b],g.extra.solidEnabled&&this.testOverlap(a,g))return x.length=0,g;x.length=0;return null};a.prototype.testRectOverlapSolid=function(a){var b,c,g;this.getSolidCollisionCandidates(null,a,x);b=0;for(c=x.length;b<c;++b)if(g=x[b],g.extra.solidEnabled&&this.testRectOverlap(a,
g))return x.length=0,g;x.length=0;return null};var s=[];a.prototype.testOverlapJumpThru=function(a,b){var c=null;b&&(c=s,c.length=0);a.update_bbox();this.getJumpthruCollisionCandidates(a.layer,a.bbox,x);var g,k,f;g=0;for(k=x.length;g<k;++g)if(f=x[g],f.extra.jumpthruEnabled&&this.testOverlap(a,f))if(b)c.push(f);else return x.length=0,f;x.length=0;return c};a.prototype.pushOutSolid=function(a,b,c,g,k,f){g=g||50;var e=a.x,d=a.y,h,l=null,q=null;for(h=0;h<g;h++)if(a.x=e+b*h,a.y=d+c*h,a.set_bbox_changed(),
!this.testOverlap(a,l)&&((l=this.testOverlapSolid(a))&&(q=l),!l&&(k&&(l=f?this.testOverlap(a,f)?f:null:this.testOverlapJumpThru(a))&&(q=l),!l)))return q&&this.pushInFractional(a,b,c,q,16),!0;a.x=e;a.y=d;a.set_bbox_changed();return!1};a.prototype.pushOut=function(a,b,c,g,k){g=g||50;var f=a.x,e=a.y,d;for(d=0;d<g;d++)if(a.x=f+b*d,a.y=e+c*d,a.set_bbox_changed(),!this.testOverlap(a,k))return!0;a.x=f;a.y=e;a.set_bbox_changed();return!1};a.prototype.pushInFractional=function(a,b,c,g,k){var f=2,e,d=!1;e=
!1;for(var h=a.x,l=a.y;f<=k;)e=1/f,f*=2,a.x+=b*e*(d?1:-1),a.y+=c*e*(d?1:-1),a.set_bbox_changed(),this.testOverlap(a,g)?e=d=!0:(e=d=!1,h=a.x,l=a.y);e&&(a.x=h,a.y=l,a.set_bbox_changed())};a.prototype.pushOutSolidNearest=function(a,b){var c=cr.is_undefined(b)?100:b,g=0,k=a.x,f=a.y,e=0,d=0,h=0,l=this.testOverlapSolid(a);if(!l)return!0;for(;g<=c;){switch(e){case 0:d=0;h=-1;g++;break;case 1:d=1;h=-1;break;case 2:d=1;h=0;break;case 3:h=d=1;break;case 4:d=0;h=1;break;case 5:d=-1;h=1;break;case 6:d=-1;h=0;
break;case 7:h=d=-1}e=(e+1)%8;a.x=cr.floor(k+d*g);a.y=cr.floor(f+h*g);a.set_bbox_changed();if(!this.testOverlap(a,l)&&(l=this.testOverlapSolid(a),!l))return!0}a.x=k;a.y=f;a.set_bbox_changed();return!1};a.prototype.registerCollision=function(a,b){a.collisionsEnabled&&b.collisionsEnabled&&this.registered_collisions.push([a,b])};a.prototype.checkRegisteredCollision=function(a,b){var c,g,k;c=0;for(g=this.registered_collisions.length;c<g;c++)if(k=this.registered_collisions[c],k[0]==a&&k[1]==b||k[0]==b&&
k[1]==a)return!0;return!1};a.prototype.calculateSolidBounceAngle=function(a,b,c,g){var k=a.x,f=a.y,e=cr.max(10,cr.distanceTo(b,c,k,f)),d=cr.angleTo(b,c,k,f),h=g||this.testOverlapSolid(a);if(!h)return cr.clamp_angle(d+cr.PI);var l=h,q,m,s,p,n=cr.to_radians(5);for(q=1;36>q;q++)if(m=d-q*n,a.x=b+Math.cos(m)*e,a.y=c+Math.sin(m)*e,a.set_bbox_changed(),!this.testOverlap(a,l)&&(l=g?null:this.testOverlapSolid(a),!l)){s=m;break}36===q&&(s=cr.clamp_angle(d+cr.PI));l=h;for(q=1;36>q;q++)if(m=d+q*n,a.x=b+Math.cos(m)*
e,a.y=c+Math.sin(m)*e,a.set_bbox_changed(),!this.testOverlap(a,l)&&(l=g?null:this.testOverlapSolid(a),!l)){p=m;break}36===q&&(p=cr.clamp_angle(d+cr.PI));a.x=k;a.y=f;a.set_bbox_changed();if(p===s)return p;a=cr.angleDiff(p,s)/2;a=cr.angleClockwise(p,s)?cr.clamp_angle(s+a+cr.PI):cr.clamp_angle(p+a);s=Math.cos(d);d=Math.sin(d);p=Math.cos(a);a=Math.sin(a);b=s*p+d*a;return cr.angleTo(0,0,s-2*b*p,d-2*b*a)};var w=-1;a.prototype.trigger=function(a,b,c){if(!this.running_layout)return!1;var g=this.running_layout.event_sheet;
if(!g)return!1;var k=!1,f,e,d;w++;var h=g.deep_includes;e=0;for(d=h.length;e<d;++e)f=this.triggerOnSheet(a,b,h[e],c),k=k||f;f=this.triggerOnSheet(a,b,g,c);w--;return k||f};a.prototype.triggerOnSheet=function(a,b,c,g){var k=!1,f,e,d,h;if(b)for(d=this.triggerOnSheetForTypeName(a,b,b.type.name,c,g),k=k||d,h=b.type.families,f=0,e=h.length;f<e;++f)d=this.triggerOnSheetForTypeName(a,b,h[f].name,c,g),k=k||d;else d=this.triggerOnSheetForTypeName(a,b,"system",c,g),k=k||d;return k};a.prototype.triggerOnSheetForTypeName=
function(a,b,c,g,k){var f,e=!1,d=!1,d="undefined"!==typeof k,h=(d?g.fasttriggers:g.triggers)[c];if(!h)return e;var l=null;g=0;for(f=h.length;g<f;++g)if(h[g].method==a){l=h[g].evs;break}if(!l)return e;a=d?l[k]:l;if(!a)return null;g=0;for(f=a.length;g<f;g++)k=a[g][0],d=a[g][1],d=this.executeSingleTrigger(b,c,k,d),e=e||d;return e};a.prototype.executeSingleTrigger=function(a,b,c,g){var k,f,e=!1;this.trigger_depth++;var d=this.getCurrentEventStack().current_event;d&&this.pushCleanSol(d.solModifiersIncludingParents);
var h=1<this.trigger_depth;this.pushCleanSol(c.solModifiersIncludingParents);h&&this.pushLocalVarStack();var l=this.pushEventStack(c);l.current_event=c;a&&(k=this.types[b].getCurrentSol(),k.select_all=!1,k.instances.length=1,k.instances[0]=a,this.types[b].applySolToContainer());a=!0;if(c.parent){b=l.temp_parents_arr;for(k=c.parent;k;)b.push(k),k=k.parent;b.reverse();k=0;for(f=b.length;k<f;k++)if(!b[k].run_pretrigger()){a=!1;break}}a&&(this.execcount++,c.orblock?c.run_orblocktrigger(g):c.run(),e=e||
l.last_event_true);this.popEventStack();h&&this.popLocalVarStack();this.popSol(c.solModifiersIncludingParents);d&&this.popSol(d.solModifiersIncludingParents);0!==this.isInOnDestroy||0!==w||this.isRunningEvents||this.deathRow.isEmpty()&&!this.createRow.length||this.ClearDeathRow();this.trigger_depth--;return e};a.prototype.getCurrentCondition=function(){var a=this.getCurrentEventStack();return a.current_event.conditions[a.cndindex]};a.prototype.getCurrentAction=function(){var a=this.getCurrentEventStack();
return a.current_event.actions[a.actindex]};a.prototype.pushLocalVarStack=function(){this.localvar_stack_index++;this.localvar_stack_index>=this.localvar_stack.length&&this.localvar_stack.push([])};a.prototype.popLocalVarStack=function(){this.localvar_stack_index--};a.prototype.getCurrentLocalVarStack=function(){return this.localvar_stack[this.localvar_stack_index]};a.prototype.pushEventStack=function(a){this.event_stack_index++;this.event_stack_index>=this.event_stack.length&&this.event_stack.push(new cr.eventStackFrame);
var b=this.getCurrentEventStack();b.reset(a);return b};a.prototype.popEventStack=function(){this.event_stack_index--};a.prototype.getCurrentEventStack=function(){return this.event_stack[this.event_stack_index]};a.prototype.pushLoopStack=function(a){this.loop_stack_index++;this.loop_stack_index>=this.loop_stack.length&&this.loop_stack.push(cr.seal({name:a,index:0,stopped:!1}));var b=this.getCurrentLoop();b.name=a;b.index=0;b.stopped=!1;return b};a.prototype.popLoopStack=function(){this.loop_stack_index--};
a.prototype.getCurrentLoop=function(){return this.loop_stack[this.loop_stack_index]};a.prototype.getEventVariableByName=function(a,b){for(var c,g,k,f,e,d;b;){c=0;for(g=b.subevents.length;c<g;c++)if(d=b.subevents[c],d instanceof cr.eventvariable&&cr.equals_nocase(a,d.name))return d;b=b.parent}c=0;for(g=this.eventsheets_by_index.length;c<g;c++)for(e=this.eventsheets_by_index[c],k=0,f=e.events.length;k<f;k++)if(d=e.events[k],d instanceof cr.eventvariable&&cr.equals_nocase(a,d.name))return d;return null};
a.prototype.getLayoutBySid=function(a){var b,c;b=0;for(c=this.layouts_by_index.length;b<c;b++)if(this.layouts_by_index[b].sid===a)return this.layouts_by_index[b];return null};a.prototype.getObjectTypeBySid=function(a){var b,c;b=0;for(c=this.types_by_index.length;b<c;b++)if(this.types_by_index[b].sid===a)return this.types_by_index[b];return null};a.prototype.getGroupBySid=function(a){var b,c;b=0;for(c=this.allGroups.length;b<c;b++)if(this.allGroups[b].sid===a)return this.allGroups[b];return null};
a.prototype.signalContinuousPreview=function(){this.signalledContinuousPreview=!0};a.prototype.handleSaveLoad=function(){var a=this,c=this.saveToSlot,e=this.lastSaveJson,g=this.loadFromSlot,k=!1;this.signalledContinuousPreview&&(k=!0,c="__c2_continuouspreview",this.signalledContinuousPreview=!1);if(c.length){this.ClearDeathRow();e=this.saveToJSONString();if(window.indexedDB&&!this.isCocoonJs)b(c,e,function(){cr.logexport("Saved state to IndexedDB storage ("+e.length+" bytes)");a.lastSaveJson=e;a.trigger(cr.system_object.prototype.cnds.OnSaveComplete,
null);a.lastSaveJson="";k&&f()},function(g){try{localStorage.setItem("__c2save_"+c,e),cr.logexport("Saved state to WebStorage ("+e.length+" bytes)"),a.lastSaveJson=e,a.trigger(cr.system_object.prototype.cnds.OnSaveComplete,null),a.lastSaveJson="",k&&f()}catch(b){cr.logexport("Failed to save game state: "+g+"; "+b)}});else try{localStorage.setItem("__c2save_"+c,e),cr.logexport("Saved state to WebStorage ("+e.length+" bytes)"),a.lastSaveJson=e,this.trigger(cr.system_object.prototype.cnds.OnSaveComplete,
null),a.lastSaveJson="",k&&f()}catch(h){cr.logexport("Error saving to WebStorage: "+h)}this.loadFromJson=this.loadFromSlot=this.saveToSlot=""}g.length&&(window.indexedDB&&!this.isCocoonJs?d(g,function(b){b?(a.loadFromJson=b,cr.logexport("Loaded state from IndexedDB storage ("+a.loadFromJson.length+" bytes)")):(a.loadFromJson=localStorage.getItem("__c2save_"+g)||"",cr.logexport("Loaded state from WebStorage ("+a.loadFromJson.length+" bytes)"));a.suspendDrawing=!1;a.loadFromJson.length||a.trigger(cr.system_object.prototype.cnds.OnLoadFailed,
null)},function(b){a.loadFromJson=localStorage.getItem("__c2save_"+g)||"";cr.logexport("Loaded state from WebStorage ("+a.loadFromJson.length+" bytes)");a.suspendDrawing=!1;a.loadFromJson.length||a.trigger(cr.system_object.prototype.cnds.OnLoadFailed,null)}):(this.loadFromJson=localStorage.getItem("__c2save_"+g)||"",cr.logexport("Loaded state from WebStorage ("+this.loadFromJson.length+" bytes)"),this.suspendDrawing=!1,a.loadFromJson.length||a.trigger(cr.system_object.prototype.cnds.OnLoadFailed,
null)),this.saveToSlot=this.loadFromSlot="");this.loadFromJson.length&&(this.ClearDeathRow(),this.loadFromJSONString(this.loadFromJson),this.lastSaveJson=this.loadFromJson,this.trigger(cr.system_object.prototype.cnds.OnLoadComplete,null),this.loadFromJson=this.lastSaveJson="")};a.prototype.saveToJSONString=function(){var a,b,c,g,k,f,d,h={c2save:!0,version:1,rt:{time:this.kahanTime.sum,timescale:this.timescale,tickcount:this.tickcount,execcount:this.execcount,next_uid:this.next_uid,running_layout:this.running_layout.sid,
start_time_offset:Date.now()-this.start_time},types:{},layouts:{},events:{groups:{},cnds:{},acts:{},vars:{}}};a=0;for(b=this.types_by_index.length;a<b;a++)if(k=this.types_by_index[a],!k.is_family&&!this.typeHasNoSaveBehavior(k)){f={instances:[]};cr.hasAnyOwnProperty(k.extra)&&(f.ex=e(k.extra));c=0;for(g=k.instances.length;c<g;c++)f.instances.push(this.saveInstanceToJSON(k.instances[c]));h.types[k.sid.toString()]=f}a=0;for(b=this.layouts_by_index.length;a<b;a++)c=this.layouts_by_index[a],h.layouts[c.sid.toString()]=
c.saveToJSON();g=h.events.groups;a=0;for(b=this.allGroups.length;a<b;a++)c=this.allGroups[a],g[c.sid.toString()]=this.groups_by_name[c.group_name].group_active;b=h.events.cnds;for(d in this.cndsBySid)this.cndsBySid.hasOwnProperty(d)&&(a=this.cndsBySid[d],cr.hasAnyOwnProperty(a.extra)&&(b[d]={ex:e(a.extra)}));b=h.events.acts;for(d in this.actsBySid)this.actsBySid.hasOwnProperty(d)&&(a=this.actsBySid[d],cr.hasAnyOwnProperty(a.extra)&&(b[d]={ex:a.extra}));b=h.events.vars;for(d in this.varsBySid)this.varsBySid.hasOwnProperty(d)&&
(a=this.varsBySid[d],a.is_constant||a.parent&&!a.is_static||(b[d]=a.data));h.system=this.system.saveToJSON();return JSON.stringify(h)};a.prototype.refreshUidMap=function(){var a,b,c,g,k,f;this.objectsByUid={};a=0;for(b=this.types_by_index.length;a<b;a++)if(c=this.types_by_index[a],!c.is_family)for(g=0,k=c.instances.length;g<k;g++)f=c.instances[g],this.objectsByUid[f.uid.toString()]=f};a.prototype.loadFromJSONString=function(a){a=JSON.parse(a);if(a.c2save&&!(1<a.version)){var b=a.rt;this.kahanTime.reset();
this.kahanTime.sum=b.time;this.timescale=b.timescale;this.tickcount=b.tickcount;this.start_time=Date.now()-b.start_time_offset;var c=b.running_layout;if(c!==this.running_layout.sid)if(c=this.getLayoutBySid(c))this.doChangeLayout(c);else return;this.isLoadingState=!0;var g,k,f,e,d,h,l;h=a.types;for(k in h)if(h.hasOwnProperty(k)&&(e=this.getObjectTypeBySid(parseInt(k,10)))&&!e.is_family&&!this.typeHasNoSaveBehavior(e)){h[k].ex?e.extra=h[k].ex:cr.wipe(e.extra);d=e.instances;f=h[k].instances;c=0;for(g=
cr.min(d.length,f.length);c<g;c++)this.loadInstanceFromJSON(d[c],f[c]);c=f.length;for(g=d.length;c<g;c++)this.DestroyInstance(d[c]);c=d.length;for(g=f.length;c<g;c++){d=null;if(e.plugin.is_world&&(d=this.running_layout.getLayerBySid(f[c].w.l),!d))continue;d=this.createInstanceFromInit(e.default_instance,d,!1,0,0,!0);this.loadInstanceFromJSON(d,f[c])}e.stale_iids=!0}this.ClearDeathRow();this.refreshUidMap();g=a.layouts;for(k in g)g.hasOwnProperty(k)&&(c=this.getLayoutBySid(parseInt(k,10)))&&c.loadFromJSON(g[k]);
g=a.events.groups;for(k in g)g.hasOwnProperty(k)&&(c=this.getGroupBySid(parseInt(k,10)))&&this.groups_by_name[c.group_name]&&(this.groups_by_name[c.group_name].group_active=g[k]);c=a.events.cnds;for(k in c)c.hasOwnProperty(k)&&this.cndsBySid.hasOwnProperty(k)&&(this.cndsBySid[k].extra=c[k].ex);c=a.events.acts;for(k in c)c.hasOwnProperty(k)&&this.actsBySid.hasOwnProperty(k)&&(this.actsBySid[k].extra=c[k].ex);c=a.events.vars;for(k in c)c.hasOwnProperty(k)&&this.varsBySid.hasOwnProperty(k)&&(this.varsBySid[k].data=
c[k]);this.next_uid=b.next_uid;this.isLoadingState=!1;this.system.loadFromJSON(a.system);c=0;for(g=this.types_by_index.length;c<g;c++)if(e=this.types_by_index[c],!e.is_family)for(k=0,a=e.instances.length;k<a;k++){d=e.instances[k];if(e.is_contained)for(h=d.get_iid(),b=d.siblings.length=0,f=e.container.length;b<f;b++)l=e.container[b],e!==l&&d.siblings.push(l.instances[h]);d.afterLoad&&d.afterLoad();if(d.behavior_insts)for(b=0,f=d.behavior_insts.length;b<f;b++)h=d.behavior_insts[b],h.afterLoad&&h.afterLoad()}this.redraw=
!0}};a.prototype.saveInstanceToJSON=function(a,b){var c,g,k,f,d;f=a.type;k=f.plugin;var h={};b?h.c2=!0:h.uid=a.uid;cr.hasAnyOwnProperty(a.extra)&&(h.ex=e(a.extra));if(a.instance_vars&&a.instance_vars.length)for(h.ivs={},c=0,g=a.instance_vars.length;c<g;c++)h.ivs[a.type.instvar_sids[c].toString()]=a.instance_vars[c];if(k.is_world){k={x:a.x,y:a.y,w:a.width,h:a.height,l:a.layer.sid,zi:a.get_zindex()};0!==a.angle&&(k.a=a.angle);1!==a.opacity&&(k.o=a.opacity);0.5!==a.hotspotX&&(k.hX=a.hotspotX);0.5!==
a.hotspotY&&(k.hY=a.hotspotY);0!==a.blend_mode&&(k.bm=a.blend_mode);a.visible||(k.v=a.visible);a.collisionsEnabled||(k.ce=a.collisionsEnabled);-1!==a.my_timescale&&(k.mts=a.my_timescale);if(f.effect_types.length)for(k.fx=[],c=0,g=f.effect_types.length;c<g;c++)d=f.effect_types[c],k.fx.push({name:d.name,active:a.active_effect_flags[d.index],params:a.effect_params[d.index]});h.w=k}if(a.behavior_insts&&a.behavior_insts.length)for(h.behs={},c=0,g=a.behavior_insts.length;c<g;c++)f=a.behavior_insts[c],f.saveToJSON&&
(h.behs[f.type.sid.toString()]=f.saveToJSON());a.saveToJSON&&(h.data=a.saveToJSON());return h};a.prototype.getInstanceVarIndexBySid=function(a,b){var c,g;c=0;for(g=a.instvar_sids.length;c<g;c++)if(a.instvar_sids[c]===b)return c;return-1};a.prototype.getBehaviorIndexBySid=function(a,b){var c,g;c=0;for(g=a.behavior_insts.length;c<g;c++)if(a.behavior_insts[c].type.sid===b)return c;return-1};a.prototype.loadInstanceFromJSON=function(a,b,c){var g,k,f,e,d;d=a.type;f=d.plugin;if(c){if(!b.c2)return}else a.uid=
b.uid;b.ex?a.extra=b.ex:cr.wipe(a.extra);if(k=b.ivs)for(g in k)k.hasOwnProperty(g)&&(c=this.getInstanceVarIndexBySid(d,parseInt(g,10)),0>c||c>=a.instance_vars.length||(a.instance_vars[c]=k[g]));if(f.is_world){f=b.w;a.layer.sid!==f.l&&(c=a.layer,a.layer=this.running_layout.getLayerBySid(f.l),a.layer?(a.layer.instances.push(a),a.layer.zindices_stale=!0,cr.arrayFindRemove(c.instances,a),c.zindices_stale=!0):(a.layer=c,this.DestroyInstance(a)));a.x=f.x;a.y=f.y;a.width=f.w;a.height=f.h;a.zindex=f.zi;a.angle=
f.hasOwnProperty("a")?f.a:0;a.opacity=f.hasOwnProperty("o")?f.o:1;a.hotspotX=f.hasOwnProperty("hX")?f.hX:0.5;a.hotspotY=f.hasOwnProperty("hY")?f.hY:0.5;a.visible=f.hasOwnProperty("v")?f.v:!0;a.collisionsEnabled=f.hasOwnProperty("ce")?f.ce:!0;a.my_timescale=f.hasOwnProperty("mts")?f.mts:-1;a.blend_mode=f.hasOwnProperty("bm")?f.bm:0;a.compositeOp=cr.effectToCompositeOp(a.blend_mode);this.gl&&cr.setGLBlend(a,a.blend_mode,this.gl);a.set_bbox_changed();if(f.hasOwnProperty("fx"))for(c=0,k=f.fx.length;c<
k;c++)e=d.getEffectIndexByName(f.fx[c].name),0>e||(a.active_effect_flags[e]=f.fx[c].active,a.effect_params[e]=f.fx[c].params);a.updateActiveEffects()}if(d=b.behs)for(g in d)d.hasOwnProperty(g)&&(f=this.getBehaviorIndexBySid(a,parseInt(g,10)),0>f||a.behavior_insts[f].loadFromJSON(d[g]));b.data&&a.loadFromJSON(b.data)};cr.runtime=a;cr.createRuntime=function(b){return new a(document.getElementById(b))};cr.createDCRuntime=function(b,c){return new a({dc:!0,width:b,height:c})};window.cr_createRuntime=cr.createRuntime;
window.cr_createDCRuntime=cr.createDCRuntime;window.createCocoonJSRuntime=function(){window.c2cocoonjs=!0;var b=document.createElement("screencanvas")||document.createElement("canvas");b.screencanvas=!0;document.body.appendChild(b);b=new a(b);window.c2runtime=b;window.addEventListener("orientationchange",function(){window.c2runtime.setSize(window.innerWidth,window.innerHeight)});window.c2runtime.setSize(window.innerWidth,window.innerHeight);return b};window.createEjectaRuntime=function(){var b=document.getElementById("canvas"),
b=new a(b);window.c2runtime=b;window.c2runtime.setSize(window.innerWidth,window.innerHeight);return b}})();window.cr_getC2Runtime=function(){var a=document.getElementById("c2canvas");return a?a.c2runtime:window.c2runtime?window.c2runtime:null};window.cr_sizeCanvas=function(a,c){if(0!==a&&0!==c){var b=window.cr_getC2Runtime();b&&b.setSize(a,c)}};window.cr_setSuspended=function(a){var c=window.cr_getC2Runtime();c&&c.setSuspended(a)};
(function(){function a(a,b){this.runtime=a;this.event_sheet=null;this.scrollX=this.runtime.original_width/2;this.scrollY=this.runtime.original_height/2;this.scale=1;this.angle=0;this.first_visit=!0;this.name=b[0];this.width=b[1];this.height=b[2];this.unbounded_scrolling=b[3];this.sheetname=b[4];this.sid=b[5];var c=b[6],d,m;this.layers=[];this.initial_types=[];d=0;for(m=c.length;d<m;d++){var n=new cr.layer(this,c[d]);n.number=d;cr.seal(n);this.layers.push(n)}c=b[7];this.initial_nonworld=[];d=0;for(m=
c.length;d<m;d++){var n=c[d],l=this.runtime.types_by_index[n[1]];l.default_instance||(l.default_instance=n);this.initial_nonworld.push(n);-1===this.initial_types.indexOf(l)&&this.initial_types.push(l)}this.effect_types=[];this.active_effect_types=[];this.effect_params=[];d=0;for(m=b[8].length;d<m;d++)this.effect_types.push({id:b[8][d][0],name:b[8][d][1],shaderindex:-1,active:!0,index:d}),this.effect_params.push(b[8][d][2].slice(0));this.updateActiveEffects();this.rcTex=new cr.rect(0,0,1,1);this.rcTex2=
new cr.rect(0,0,1,1);this.persist_data={}}function c(a,b){this.layout=a;this.runtime=a.runtime;this.instances=[];this.scale=1;this.angle=0;this.disableAngle=!1;this.tmprect=new cr.rect(0,0,0,0);this.tmpquad=new cr.quad;this.viewBottom=this.viewTop=this.viewRight=this.viewLeft=0;this.zindices_stale=!1;this.name=b[0];this.index=b[1];this.sid=b[2];this.visible=b[3];this.background_color=b[4];this.transparent=b[5];this.parallaxX=b[6];this.parallaxY=b[7];this.opacity=b[8];this.forceOwnTexture=b[9];this.zoomRate=
b[10];this.blend_mode=b[11];this.effect_fallback=b[12];this.compositeOp="source-over";this.destBlend=this.srcBlend=0;this.render_offscreen=!1;var c=b[13],d,m;this.initial_instances=[];d=0;for(m=c.length;d<m;d++){var n=c[d],l=this.runtime.types_by_index[n[1]];l.default_instance||(l.default_instance=n,l.default_layerindex=this.index);this.initial_instances.push(n);-1===this.layout.initial_types.indexOf(l)&&this.layout.initial_types.push(l)}this.effect_types=[];this.active_effect_types=[];this.effect_params=
[];d=0;for(m=b[14].length;d<m;d++)this.effect_types.push({id:b[14][d][0],name:b[14][d][1],shaderindex:-1,active:!0,index:d}),this.effect_params.push(b[14][d][2].slice(0));this.updateActiveEffects();this.rcTex=new cr.rect(0,0,1,1);this.rcTex2=new cr.rect(0,0,1,1)}function b(a,b){return a.zindex-b.zindex}a.prototype.saveObjectToPersist=function(a){var b=a.type.sid.toString();this.persist_data.hasOwnProperty(b)||(this.persist_data[b]=[]);this.persist_data[b].push(this.runtime.saveInstanceToJSON(a))};
a.prototype.hasOpaqueBottomLayer=function(){var a=this.layers[0];return!a.transparent&&1===a.opacity&&!a.forceOwnTexture&&a.visible};a.prototype.updateActiveEffects=function(){this.active_effect_types.length=0;var a,b,c;a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],c.active&&this.active_effect_types.push(c)};a.prototype.getEffectByName=function(a){var b,c,d;b=0;for(c=this.effect_types.length;b<c;b++)if(d=this.effect_types[b],d.name===a)return d;return null};var d=[];a.prototype.startRunning=
function(){this.sheetname&&(this.event_sheet=this.runtime.eventsheets[this.sheetname],this.event_sheet.updateDeepIncludes());this.runtime.running_layout=this;this.scrollX=this.runtime.original_width/2;this.scrollY=this.runtime.original_height/2;var a,c,h,p,m,n,l;a=0;for(h=this.runtime.types_by_index.length;a<h;a++)if(c=this.runtime.types_by_index[a],!c.is_family)for(m=c.instances,c=0,p=m.length;c<p;c++)if(n=m[c],n.layer){var q=n.layer.number;q>=this.layers.length&&(q=this.layers.length-1);n.layer=
this.layers[q];-1===n.layer.instances.indexOf(n)&&n.layer.instances.push(n);n.layer.zindices_stale=!0}d.length=0;this.boundScrolling();a=0;for(h=this.layers.length;a<h;a++)n=this.layers[a],n.createInitialInstances(),n.disableAngle=!0,c=n.canvasToLayer(0,0,!0,!0),p=n.canvasToLayer(0,0,!1,!0),n.disableAngle=!1,this.runtime.pixel_rounding&&(c=c+0.5|0,p=p+0.5|0),n.rotateViewport(c,p,null);m=!1;if(!this.first_visit){for(l in this.persist_data)if(this.persist_data.hasOwnProperty(l)&&(c=this.runtime.getObjectTypeBySid(parseInt(l,
10)))&&!c.is_family&&this.runtime.typeHasPersistBehavior(c)){p=this.persist_data[l];a=0;for(h=p.length;a<h;a++){n=null;if(c.plugin.is_world&&(n=this.getLayerBySid(p[a].w.l),!n))continue;n=this.runtime.createInstanceFromInit(c.default_instance,n,!1,0,0,!0);this.runtime.loadInstanceFromJSON(n,p[a]);m=!0;d.push(n)}p.length=0}a=0;for(h=this.layers.length;a<h;a++)this.layers[a].instances.sort(b),this.layers[a].zindices_stale=!0}m&&(this.runtime.ClearDeathRow(),this.runtime.refreshUidMap());for(a=0;a<d.length;a++)if(n=
d[a],n.type.is_contained)for(h=n.get_iid(),c=0,p=n.type.container.length;c<p;c++)l=n.type.container[c],n.type!==l&&(l.instances.length>h?n.siblings.push(l.instances[h]):l.default_instance&&(m=this.runtime.createInstanceFromInit(l.default_instance,n.layer,!0,n.x,n.y,!0),this.runtime.ClearDeathRow(),l.updateIIDs(),n.siblings.push(m),d.push(m)));a=0;for(h=this.initial_nonworld.length;a<h;a++)this.runtime.createInstanceFromInit(this.initial_nonworld[a],null,!0);this.runtime.changelayout=null;this.runtime.ClearDeathRow();
if(this.runtime.ctx&&!this.runtime.isDomFree)for(a=0,h=this.runtime.types_by_index.length;a<h;a++)l=this.runtime.types_by_index[a],!l.is_family&&l.instances.length&&l.preloadCanvas2D&&l.preloadCanvas2D(this.runtime.ctx);a=0;for(h=d.length;a<h;a++)n=d[a],this.runtime.trigger(Object.getPrototypeOf(n.type.plugin).cnds.OnCreated,n);d.length=0;this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutStart,null);this.first_visit=!1};a.prototype.createGlobalNonWorlds=function(){var a,b,c,d,m;b=a=0;for(c=
this.initial_nonworld.length;a<c;a++)d=this.initial_nonworld[a],m=this.runtime.types_by_index[d[1]],m.global?this.runtime.createInstanceFromInit(d,null,!0):(this.initial_nonworld[b]=d,b++);this.initial_nonworld.length=b};a.prototype.stopRunning=function(){this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutEnd,null);this.runtime.system.waits.length=0;var a,b,c,d,m,n;a=0;for(b=this.layers.length;a<b;a++){m=this.layers[a].instances;c=0;for(d=m.length;c<d;c++)n=m[c],n.type.global||(this.runtime.typeHasPersistBehavior(n.type)&&
this.saveObjectToPersist(n),this.runtime.DestroyInstance(n));this.runtime.ClearDeathRow();m.length=0;this.layers[a].zindices_stale=!0}a=0;for(b=this.runtime.types_by_index.length;a<b;a++)if(m=this.runtime.types_by_index[a],!(m.global||m.plugin.is_world||m.plugin.singleglobal||m.is_family)){c=0;for(d=m.instances.length;c<d;c++)this.runtime.DestroyInstance(m.instances[c]);this.runtime.ClearDeathRow()}};a.prototype.draw=function(a){var b,c=a,d=!1,m=!this.runtime.fullscreenScalingQuality;m&&(this.runtime.layout_canvas||
(this.runtime.layout_canvas=document.createElement("canvas"),b=this.runtime.layout_canvas,b.width=this.runtime.draw_width,b.height=this.runtime.draw_height,this.runtime.layout_ctx=b.getContext("2d"),d=!0),b=this.runtime.layout_canvas,c=this.runtime.layout_ctx,b.width!==this.runtime.draw_width&&(b.width=this.runtime.draw_width,d=!0),b.height!==this.runtime.draw_height&&(b.height=this.runtime.draw_height,d=!0),d&&(c.webkitImageSmoothingEnabled=this.runtime.linearSampling,c.mozImageSmoothingEnabled=
this.runtime.linearSampling,c.msImageSmoothingEnabled=this.runtime.linearSampling,c.imageSmoothingEnabled=this.runtime.linearSampling));c.globalAlpha=1;c.globalCompositeOperation="source-over";this.runtime.alphaBackground&&!this.hasOpaqueBottomLayer()&&c.clearRect(0,0,this.runtime.draw_width,this.runtime.draw_height);var n,l,d=0;for(n=this.layers.length;d<n;d++)l=this.layers[d],l.visible&&0<l.opacity&&11!==l.blend_mode&&l.draw(c);m&&a.drawImage(b,0,0,this.runtime.width,this.runtime.height)};a.prototype.drawGL=
function(a){var b=0<this.active_effect_types.length||this.runtime.uses_background_blending||!this.runtime.fullscreenScalingQuality;if(b){this.runtime.layout_tex||(this.runtime.layout_tex=a.createEmptyTexture(this.runtime.draw_width,this.runtime.draw_height,this.runtime.linearSampling));if(this.runtime.layout_tex.c2width!==this.runtime.draw_width||this.runtime.layout_tex.c2height!==this.runtime.draw_height)a.deleteTexture(this.runtime.layout_tex),this.runtime.layout_tex=a.createEmptyTexture(this.runtime.draw_width,
this.runtime.draw_height,this.runtime.linearSampling);a.setRenderingToTexture(this.runtime.layout_tex);this.runtime.fullscreenScalingQuality||a.setSize(this.runtime.draw_width,this.runtime.draw_height)}else this.runtime.layout_tex&&(a.setRenderingToTexture(null),a.deleteTexture(this.runtime.layout_tex),this.runtime.layout_tex=null);this.runtime.alphaBackground&&!this.hasOpaqueBottomLayer()&&a.clear(0,0,0,0);var c,d;c=0;for(d=this.layers.length;c<d;c++)this.layers[c].visible&&0<this.layers[c].opacity&&
this.layers[c].drawGL(a);b&&(0===this.active_effect_types.length||1===this.active_effect_types.length&&this.runtime.fullscreenScalingQuality?(1===this.active_effect_types.length?(b=this.active_effect_types[0].index,a.switchProgram(this.active_effect_types[0].shaderindex),a.setProgramParameters(null,1/this.runtime.draw_width,1/this.runtime.draw_height,0,0,1,1,this.scale,this.angle,0,0,this.effect_params[b]),a.programIsAnimated(this.active_effect_types[0].shaderindex)&&(this.runtime.redraw=!0)):a.switchProgram(0),
this.runtime.fullscreenScalingQuality||a.setSize(this.runtime.width,this.runtime.height),a.setRenderingToTexture(null),a.setOpacity(1),a.setTexture(this.runtime.layout_tex),a.setAlphaBlend(),a.resetModelView(),a.updateModelView(),b=this.runtime.width/2,c=this.runtime.height/2,a.quad(-b,c,b,c,b,-c,-b,-c),a.setTexture(null)):this.renderEffectChain(a,null,null,null))};a.prototype.getRenderTarget=function(){return 0<this.active_effect_types.length||this.runtime.uses_background_blending||!this.runtime.fullscreenScalingQuality?
this.runtime.layout_tex:null};a.prototype.getMinLayerScale=function(){var a=this.layers[0].getScale(),b,c,d;b=1;for(c=this.layers.length;b<c;b++)d=this.layers[b],(0!==d.parallaxX||0!==d.parallaxY)&&d.getScale()<a&&(a=d.getScale());return a};a.prototype.scrollToX=function(a){if(!this.unbounded_scrolling){var b=this.runtime.draw_width*(1/this.getMinLayerScale())/2;a>this.width-b&&(a=this.width-b);a<b&&(a=b)}this.scrollX!==a&&(this.scrollX=a,this.runtime.redraw=!0)};a.prototype.scrollToY=function(a){if(!this.unbounded_scrolling){var b=
this.runtime.draw_height*(1/this.getMinLayerScale())/2;a>this.height-b&&(a=this.height-b);a<b&&(a=b)}this.scrollY!==a&&(this.scrollY=a,this.runtime.redraw=!0)};a.prototype.boundScrolling=function(){this.scrollToX(this.scrollX);this.scrollToY(this.scrollY)};a.prototype.renderEffectChain=function(a,b,c,d){var m=c?c.active_effect_types:b?b.active_effect_types:this.active_effect_types,n=1,l=0,q=0,u=0;c?(n=c.layer.getScale(),l=c.layer.getAngle(),q=c.layer.viewLeft,u=c.layer.viewTop):b&&(n=b.getScale(),
l=b.getAngle(),q=b.viewLeft,u=b.viewTop);var r=this.runtime.fx_tex,t,x,s,w,v=0,A=1,y,g=this.runtime.draw_width,k=this.runtime.draw_height,C=g/2,z=k/2,G=b?b.rcTex:this.rcTex,D=b?b.rcTex2:this.rcTex2,H=0,E=0,I=0,K=0,N=g,L=g,P=k,T=k,U=s=0,J=c?c.layer.getAngle():0;if(c){t=0;for(x=m.length;t<x;t++)s+=a.getProgramBoxExtendHorizontal(m[t].shaderindex),U+=a.getProgramBoxExtendVertical(m[t].shaderindex);w=c.bbox;H=b.layerToCanvas(w.left,w.top,!0,!0);I=b.layerToCanvas(w.left,w.top,!1,!0);N=b.layerToCanvas(w.right,
w.bottom,!0,!0);P=b.layerToCanvas(w.right,w.bottom,!1,!0);0!==J&&(t=b.layerToCanvas(w.right,w.top,!0,!0),x=b.layerToCanvas(w.right,w.top,!1,!0),E=b.layerToCanvas(w.left,w.bottom,!0,!0),K=b.layerToCanvas(w.left,w.bottom,!1,!0),w=Math.min(H,N,t,E),N=Math.max(H,N,t,E),H=w,w=Math.min(I,P,x,K),P=Math.max(I,P,x,K),I=w);H-=s;I-=U;N+=s;P+=U;D.left=H/g;D.top=1-I/k;D.right=N/g;D.bottom=1-P/k;E=H=cr.floor(H);K=I=cr.floor(I);L=N=cr.ceil(N);T=P=cr.ceil(P);E-=s;K-=U;L+=s;T+=U;0>H&&(H=0);0>I&&(I=0);N>g&&(N=g);P>
k&&(P=k);0>E&&(E=0);0>K&&(K=0);L>g&&(L=g);T>k&&(T=k);G.left=H/g;G.top=1-I/k;G.right=N/g;G.bottom=1-P/k}else G.left=D.left=0,G.top=D.top=0,G.right=D.right=1,G.bottom=D.bottom=1;U=c&&((c.angle||J)&&a.programUsesDest(m[0].shaderindex)||0!==s||0!==U||1!==c.opacity||c.type.plugin.must_predraw)||b&&!c&&1!==b.opacity;a.setAlphaBlend();if(U){r[v]||(r[v]=a.createEmptyTexture(g,k,this.runtime.linearSampling));if(r[v].c2width!==g||r[v].c2height!==k)a.deleteTexture(r[v]),r[v]=a.createEmptyTexture(g,k,this.runtime.linearSampling);
a.switchProgram(0);a.setRenderingToTexture(r[v]);y=T-K;a.clearRect(E,k-K-y,L-E,y);c?c.drawGL(a):(a.setTexture(this.runtime.layer_tex),a.setOpacity(b.opacity),a.resetModelView(),a.translate(-C,-z),a.updateModelView(),a.quadTex(H,P,N,P,N,I,H,I,G));D.left=D.top=0;D.right=D.bottom=1;c&&(w=G.top,G.top=G.bottom,G.bottom=w);v=1;A=0}a.setOpacity(1);s=m.length-1;var J=a.programUsesCrossSampling(m[s].shaderindex)||!b&&!c&&!this.runtime.fullscreenScalingQuality,B=0;t=0;for(x=m.length;t<x;t++){r[v]||(r[v]=a.createEmptyTexture(g,
k,this.runtime.linearSampling));if(r[v].c2width!==g||r[v].c2height!==k)a.deleteTexture(r[v]),r[v]=a.createEmptyTexture(g,k,this.runtime.linearSampling);a.switchProgram(m[t].shaderindex);B=m[t].index;a.programIsAnimated(m[t].shaderindex)&&(this.runtime.redraw=!0);0!=t||U?(a.setProgramParameters(d,1/g,1/k,D.left,D.top,D.right,D.bottom,n,l,q,u,c?c.effect_params[B]:b?b.effect_params[B]:this.effect_params[B]),a.setTexture(null),t!==s||J?(a.setRenderingToTexture(r[v]),y=T-K,w=k-K-y,a.clearRect(E,w,L-E,
y)):(c?a.setBlend(c.srcBlend,c.destBlend):b&&a.setBlend(b.srcBlend,b.destBlend),a.setRenderingToTexture(d)),a.setTexture(r[A]),a.resetModelView(),a.translate(-C,-z),a.updateModelView(),a.quadTex(H,P,N,P,N,I,H,I,G),t!==s||J||a.setTexture(null)):(a.setRenderingToTexture(r[v]),y=T-K,w=k-K-y,a.clearRect(E,w,L-E,y),c?(a.setProgramParameters(d,1/c.width,1/c.height,D.left,D.top,D.right,D.bottom,n,l,q,u,c.effect_params[B]),c.drawGL(a)):(a.setProgramParameters(d,1/g,1/k,0,0,1,1,n,l,q,u,b?b.effect_params[B]:
this.effect_params[B]),a.setTexture(b?this.runtime.layer_tex:this.runtime.layout_tex),a.resetModelView(),a.translate(-C,-z),a.updateModelView(),a.quadTex(H,P,N,P,N,I,H,I,G)),D.left=D.top=0,D.right=D.bottom=1,c&&!J&&(w=P,P=I,I=w));v=0===v?1:0;A=0===v?1:0}J&&(a.switchProgram(0),c?a.setBlend(c.srcBlend,c.destBlend):b?a.setBlend(b.srcBlend,b.destBlend):this.runtime.fullscreenScalingQuality||(a.setSize(this.runtime.width,this.runtime.height),C=this.runtime.width/2,z=this.runtime.height/2,I=H=0,N=this.runtime.width,
P=this.runtime.height),a.setRenderingToTexture(d),a.setTexture(r[A]),a.resetModelView(),a.translate(-C,-z),a.updateModelView(),c&&1===m.length&&!U?a.quadTex(H,I,N,I,N,P,H,P,G):a.quadTex(H,P,N,P,N,I,H,I,G),a.setTexture(null))};a.prototype.getLayerBySid=function(a){var b,c;b=0;for(c=this.layers.length;b<c;b++)if(this.layers[b].sid===a)return this.layers[b];return null};a.prototype.saveToJSON=function(){var a,b,c,d={sx:this.scrollX,sy:this.scrollY,s:this.scale,a:this.angle,w:this.width,h:this.height,
fv:this.first_visit,persist:this.persist_data,fx:[],layers:{}};a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],d.fx.push({name:c.name,active:c.active,params:this.effect_params[c.index]});a=0;for(b=this.layers.length;a<b;a++)c=this.layers[a],d.layers[c.sid.toString()]=c.saveToJSON();return d};a.prototype.loadFromJSON=function(a){var b,c,d,m;this.scrollX=a.sx;this.scrollY=a.sy;this.scale=a.s;this.angle=a.a;this.width=a.w;this.height=a.h;this.persist_data=a.persist;"undefined"!==typeof a.fv&&
(this.first_visit=a.fv);var n=a.fx;b=0;for(c=n.length;b<c;b++)if(d=this.getEffectByName(n[b].name))d.active=n[b].active,this.effect_params[d.index]=n[b].params;this.updateActiveEffects();b=a.layers;for(m in b)b.hasOwnProperty(m)&&(a=this.getLayerBySid(parseInt(m,10)))&&a.loadFromJSON(b[m])};cr.layout=a;c.prototype.updateActiveEffects=function(){this.active_effect_types.length=0;var a,b,c;a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],c.active&&this.active_effect_types.push(c)};
c.prototype.getEffectByName=function(a){var b,c,d;b=0;for(c=this.effect_types.length;b<c;b++)if(d=this.effect_types[b],d.name===a)return d;return null};c.prototype.createInitialInstances=function(){var a,b,c,p,m,n;b=a=0;for(c=this.initial_instances.length;a<c;a++){p=this.initial_instances[a];m=this.runtime.types_by_index[p[1]];n=this.runtime.typeHasPersistBehavior(m);m=!0;if(!n||this.layout.first_visit)p=this.runtime.createInstanceFromInit(p,this,!0),d.push(p),p.type.global&&(m=!1);m&&(this.initial_instances[b]=
this.initial_instances[a],b++)}this.initial_instances.length=b;this.runtime.ClearDeathRow();!this.runtime.glwrap&&this.effect_types.length&&(this.blend_mode=this.effect_fallback);this.compositeOp=cr.effectToCompositeOp(this.blend_mode);this.runtime.gl&&cr.setGLBlend(this,this.blend_mode,this.runtime.gl)};c.prototype.updateZIndices=function(){if(this.zindices_stale){var a,b;a=0;for(b=this.instances.length;a<b;a++)this.instances[a].zindex=a;this.zindices_stale=!1}};c.prototype.getScale=function(a){return this.getNormalScale()*
(this.runtime.fullscreenScalingQuality||a?this.runtime.aspect_scale:1)};c.prototype.getNormalScale=function(){return(this.scale*this.layout.scale-1)*this.zoomRate+1};c.prototype.getAngle=function(){return this.disableAngle?0:cr.clamp_angle(this.layout.angle+this.angle)};c.prototype.draw=function(a){this.render_offscreen=this.forceOwnTexture||1!==this.opacity||0!==this.blend_mode;var b=this.runtime.canvas,c=a,d=!1;this.render_offscreen&&(this.runtime.layer_canvas||(this.runtime.layer_canvas=document.createElement("canvas"),
b=this.runtime.layer_canvas,b.width=this.runtime.draw_width,b.height=this.runtime.draw_height,this.runtime.layer_ctx=b.getContext("2d"),d=!0),b=this.runtime.layer_canvas,c=this.runtime.layer_ctx,b.width!==this.runtime.draw_width&&(b.width=this.runtime.draw_width,d=!0),b.height!==this.runtime.draw_height&&(b.height=this.runtime.draw_height,d=!0),d&&(c.webkitImageSmoothingEnabled=this.runtime.linearSampling,c.mozImageSmoothingEnabled=this.runtime.linearSampling,c.msImageSmoothingEnabled=this.runtime.linearSampling,
c.imageSmoothingEnabled=this.runtime.linearSampling),this.transparent&&c.clearRect(0,0,this.runtime.draw_width,this.runtime.draw_height));c.globalAlpha=1;c.globalCompositeOperation="source-over";this.transparent||(c.fillStyle="rgb("+this.background_color[0]+","+this.background_color[1]+","+this.background_color[2]+")",c.fillRect(0,0,this.runtime.draw_width,this.runtime.draw_height));c.save();this.disableAngle=!0;var d=this.canvasToLayer(0,0,!0,!0),m=this.canvasToLayer(0,0,!1,!0);this.disableAngle=
!1;this.runtime.pixel_rounding&&(d=d+0.5|0,m=m+0.5|0);this.rotateViewport(d,m,c);var n=this.getScale();c.scale(n,n);c.translate(-d,-m);for(var l,d=0,m=this.instances.length;d<m;d++)n=this.instances[d],n.visible&&0!==n.width&&0!==n.height&&(n.update_bbox(),l=n.bbox,l.right<this.viewLeft||l.bottom<this.viewTop||l.left>this.viewRight||l.top>this.viewBottom||(c.globalCompositeOperation=n.compositeOp,n.draw(c)));c.restore();this.render_offscreen&&(a.globalCompositeOperation=this.compositeOp,a.globalAlpha=
this.opacity,a.drawImage(b,0,0))};c.prototype.rotateViewport=function(a,b,c){var d=this.getScale();this.viewLeft=a;this.viewTop=b;this.viewRight=a+this.runtime.draw_width*(1/d);this.viewBottom=b+this.runtime.draw_height*(1/d);a=this.getAngle();0!==a&&(c&&(c.translate(this.runtime.draw_width/2,this.runtime.draw_height/2),c.rotate(-a),c.translate(this.runtime.draw_width/-2,this.runtime.draw_height/-2)),this.tmprect.set(this.viewLeft,this.viewTop,this.viewRight,this.viewBottom),this.tmprect.offset((this.viewLeft+
this.viewRight)/-2,(this.viewTop+this.viewBottom)/-2),this.tmpquad.set_from_rotated_rect(this.tmprect,a),this.tmpquad.bounding_box(this.tmprect),this.tmprect.offset((this.viewLeft+this.viewRight)/2,(this.viewTop+this.viewBottom)/2),this.viewLeft=this.tmprect.left,this.viewTop=this.tmprect.top,this.viewRight=this.tmprect.right,this.viewBottom=this.tmprect.bottom)};c.prototype.drawGL=function(a){var b=this.runtime.draw_width,c=this.runtime.draw_height,d=0,m=0;if(this.render_offscreen=this.forceOwnTexture||
1!==this.opacity||0<this.active_effect_types.length||0!==this.blend_mode){this.runtime.layer_tex||(this.runtime.layer_tex=a.createEmptyTexture(this.runtime.draw_width,this.runtime.draw_height,this.runtime.linearSampling));if(this.runtime.layer_tex.c2width!==this.runtime.draw_width||this.runtime.layer_tex.c2height!==this.runtime.draw_height)a.deleteTexture(this.runtime.layer_tex),this.runtime.layer_tex=a.createEmptyTexture(this.runtime.draw_width,this.runtime.draw_height,this.runtime.linearSampling);
a.setRenderingToTexture(this.runtime.layer_tex);this.transparent&&a.clear(0,0,0,0)}this.transparent||a.clear(this.background_color[0]/255,this.background_color[1]/255,this.background_color[2]/255,1);this.disableAngle=!0;var m=this.canvasToLayer(0,0,!0,!0),n=this.canvasToLayer(0,0,!1,!0);this.disableAngle=!1;this.runtime.pixel_rounding&&(m=m+0.5|0,n=n+0.5|0);this.rotateViewport(m,n,null);n=this.getScale();a.resetModelView();a.scale(n,n);a.rotateZ(-this.getAngle());a.translate((this.viewLeft+this.viewRight)/
-2,(this.viewTop+this.viewBottom)/-2);a.updateModelView();var l,q,u;l=0;for(q=this.instances.length;l<q;l++)if(u=this.instances[l],u.visible&&0!==u.width&&0!==u.height&&(u.update_bbox(),d=u.bbox,!(d.right<this.viewLeft||d.bottom<this.viewTop||d.left>this.viewRight||d.top>this.viewBottom)))if(u.uses_shaders)if(d=u.active_effect_types[0].shaderindex,m=u.active_effect_types[0].index,1!==u.active_effect_types.length||a.programUsesCrossSampling(d)||a.programExtendsBox(d)||(u.angle||u.layer.getAngle())&&
a.programUsesDest(d)||1!==u.opacity||u.type.plugin.must_predraw)this.layout.renderEffectChain(a,this,u,this.render_offscreen?this.runtime.layer_tex:this.layout.getRenderTarget()),a.resetModelView(),a.scale(n,n),a.rotateZ(-this.getAngle()),a.translate((this.viewLeft+this.viewRight)/-2,(this.viewTop+this.viewBottom)/-2),a.updateModelView();else{a.switchProgram(d);a.setBlend(u.srcBlend,u.destBlend);a.programIsAnimated(d)&&(this.runtime.redraw=!0);var r=0,t=0,x=0,s=0;a.programUsesDest(d)&&(d=u.bbox,r=
this.layerToCanvas(d.left,d.top,!0,!0),t=this.layerToCanvas(d.left,d.top,!1,!0),x=this.layerToCanvas(d.right,d.bottom,!0,!0),d=this.layerToCanvas(d.right,d.bottom,!1,!0),r/=b,t=1-t/c,x/=b,s=1-d/c);a.setProgramParameters(this.render_offscreen?this.runtime.layer_tex:this.layout.getRenderTarget(),1/u.width,1/u.height,r,t,x,s,this.getScale(),this.getAngle(),this.viewLeft,this.viewTop,u.effect_params[m]);u.drawGL(a)}else a.switchProgram(0),a.setBlend(u.srcBlend,u.destBlend),u.drawGL(a);this.render_offscreen&&
(d=this.active_effect_types.length?this.active_effect_types[0].shaderindex:0,m=this.active_effect_types.length?this.active_effect_types[0].index:0,0===this.active_effect_types.length||1===this.active_effect_types.length&&!a.programUsesCrossSampling(d)&&1===this.opacity?(1===this.active_effect_types.length?(a.switchProgram(d),a.setProgramParameters(this.layout.getRenderTarget(),1/this.runtime.draw_width,1/this.runtime.draw_height,0,0,1,1,this.getScale(),this.getAngle(),this.viewLeft,this.viewTop,this.effect_params[m]),
a.programIsAnimated(d)&&(this.runtime.redraw=!0)):a.switchProgram(0),a.setRenderingToTexture(this.layout.getRenderTarget()),a.setOpacity(this.opacity),a.setTexture(this.runtime.layer_tex),a.setBlend(this.srcBlend,this.destBlend),a.resetModelView(),a.updateModelView(),b=this.runtime.draw_width/2,c=this.runtime.draw_height/2,a.quad(-b,c,b,c,b,-c,-b,-c),a.setTexture(null)):this.layout.renderEffectChain(a,this,null,this.layout.getRenderTarget()))};c.prototype.canvasToLayer=function(a,b,c,d){var m=this.runtime.devicePixelRatio;
this.runtime.isRetina&&(a*=m,b*=m);var m=this.runtime.parallax_x_origin,n=this.runtime.parallax_y_origin,m=(this.layout.scrollX-m)*this.parallaxX+m,n=(this.layout.scrollY-n)*this.parallaxY+n,l=1/this.getScale(!d);d?(m-=this.runtime.draw_width*l/2,n-=this.runtime.draw_height*l/2):(m-=this.runtime.width*l/2,n-=this.runtime.height*l/2);m+=a*l;n+=b*l;b=this.getAngle();0!==b&&(m-=this.layout.scrollX,n-=this.layout.scrollY,a=Math.cos(b),b=Math.sin(b),d=m*a-n*b,n=n*a+m*b,m=d+this.layout.scrollX,n+=this.layout.scrollY);
return c?m:n};c.prototype.layerToCanvas=function(a,b,c,d){var m=this.getAngle();if(0!==m){a-=this.layout.scrollX;b-=this.layout.scrollY;var n=Math.cos(-m),m=Math.sin(-m),l=a*n-b*m;b=b*n+a*m;a=l+this.layout.scrollX;b+=this.layout.scrollY}n=this.runtime.parallax_x_origin;m=this.runtime.parallax_y_origin;n=(this.layout.scrollX-n)*this.parallaxX+n;m=(this.layout.scrollY-m)*this.parallaxY+m;l=1/this.getScale(!d);d?(n-=this.runtime.draw_width*l/2,m-=this.runtime.draw_height*l/2):(n-=this.runtime.width*
l/2,m-=this.runtime.height*l/2);n=(a-n)/l;m=(b-m)/l;a=this.runtime.devicePixelRatio;this.runtime.isRetina&&!d&&(n/=a,m/=a);return c?n:m};c.prototype.rotatePt=function(a,b,c){if(0===this.getAngle())return c?a:b;var d=this.layerToCanvas(a,b,!0);b=this.layerToCanvas(a,b,!1);this.disableAngle=!0;a=this.canvasToLayer(d,b,!0);d=this.canvasToLayer(d,b,!0);this.disableAngle=!1;return c?a:d};c.prototype.saveToJSON=function(){var a,b,c,d={s:this.scale,a:this.angle,vl:this.viewLeft,vt:this.viewTop,vr:this.viewRight,
vb:this.viewBottom,v:this.visible,bc:this.background_color,t:this.transparent,px:this.parallaxX,py:this.parallaxY,o:this.opacity,zr:this.zoomRate,fx:[],instances:[]};a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],d.fx.push({name:c.name,active:c.active,params:this.effect_params[c.index]});return d};c.prototype.loadFromJSON=function(a){var c,d;this.scale=a.s;this.angle=a.a;this.viewLeft=a.vl;this.viewTop=a.vt;this.viewRight=a.vr;this.viewBottom=a.vb;this.visible=a.v;this.background_color=
a.bc;this.transparent=a.t;this.parallaxX=a.px;this.parallaxY=a.py;this.opacity=a.o;this.zoomRate=a.zr;var p=a.fx;a=0;for(c=p.length;a<c;a++)if(d=this.getEffectByName(p[a].name))d.active=p[a].active,this.effect_params[d.index]=p[a].params;this.updateActiveEffects();this.instances.sort(b);this.zindices_stale=!0};cr.layer=c})();
(function(){function a(a,b){var c,d=a.length;switch(d){case 0:return!0;case 1:return a[0]===b[0];case 2:return a[0]===b[0]&&a[1]===b[1];default:for(c=0;c<d;c++)if(a[c]!==b[c])return!1;return!0}}function c(a,b){return a.index-b.index}function b(b){var d,e,f,h;2===b.length?b[0].index>b[1].index&&(d=b[0],b[0]=b[1],b[1]=d):2<b.length&&b.sort(c);b.length>=r.length&&(r.length=b.length+1);r[b.length]||(r[b.length]=[]);h=r[b.length];d=0;for(e=h.length;d<e;d++)if(f=h[d],a(b,f))return f;h.push(b);return b}
function d(a,b){this.runtime=a;this.triggers={};this.fasttriggers={};this.hasRun=!1;this.includes=new cr.ObjectSet;this.deep_includes=[];this.already_included_sheets=[];this.name=b[0];var c=b[1];this.events=[];var d,e;d=0;for(e=c.length;d<e;d++)this.init_event(c[d],null,this.events)}function f(a){this.type=a;this.instances=[];this.else_instances=[];this.select_all=!0}function e(a,b,c){this.sheet=a;this.parent=b;this.runtime=a.runtime;this.solModifiers=[];this.solModifiersIncludingParents=[];this.has_else_block=
this.toplevelgroup=this.toplevelevent=this.initially_activated=this.group=this.solWriterAfterCnds=!1;this.conditions=[];this.actions=[];this.subevents=[];this.group_name="";this.group_active=this.initially_activated=this.group=!1;this.contained_includes=null;c[1]&&(this.group_name=c[1][1].toLowerCase(),this.group=!0,this.initially_activated=!!c[1][0],this.contained_includes=[],this.group_active=this.initially_activated,this.runtime.allGroups.push(this),this.runtime.groups_by_name[this.group_name]=
this);this.orblock=c[2];this.sid=c[4];this.group||(this.runtime.blocksBySid[this.sid.toString()]=this);var d=c[5];a=0;for(b=d.length;a<b;a++){var e=new cr.condition(this,d[a]);e.index=a;cr.seal(e);this.conditions.push(e);this.addSolModifier(e.type)}d=c[6];a=0;for(b=d.length;a<b;a++)e=new cr.action(this,d[a]),e.index=a,cr.seal(e),this.actions.push(e);if(8===c.length)for(c=c[7],a=0,b=c.length;a<b;a++)this.sheet.init_event(c[a],this,this.subevents);this.is_else_block=!1;this.conditions.length&&(this.is_else_block=
null==this.conditions[0].type&&this.conditions[0].func==cr.system_object.prototype.cnds.Else)}function h(a,b){var c,d,e;if(a&&(-1===b.indexOf(a)&&b.push(a),a.is_contained))for(c=0,d=a.container.length;c<d;c++)e=a.container[c],a!==e&&-1===b.indexOf(e)&&b.push(e)}function p(a,b){this.block=a;this.sheet=a.sheet;this.runtime=a.runtime;this.parameters=[];this.results=[];this.extra={};this.index=-1;this.anyParamVariesPerInstance=!1;this.func=b[1];this.trigger=0<b[3];this.fasttrigger=2===b[3];this.looping=
b[4];this.inverted=b[5];this.isstatic=b[6];this.sid=b[7];this.runtime.cndsBySid[this.sid.toString()]=this;-1===b[0]?(this.type=null,this.run=this.run_system,this.behaviortype=null,this.beh_index=-1):(this.type=this.runtime.types_by_index[b[0]],this.run=this.isstatic?this.run_static:this.run_object,b[2]?(this.behaviortype=this.type.getBehaviorByName(b[2]),this.beh_index=this.type.getBehaviorIndexByName(b[2])):(this.behaviortype=null,this.beh_index=-1),this.block.parent&&this.block.parent.setSolWriterAfterCnds());
this.fasttrigger&&(this.run=this.run_true);if(10===b.length){var c,d,e=b[9];c=0;for(d=e.length;c<d;c++){var g=new cr.parameter(this,e[c]);cr.seal(g);this.parameters.push(g)}this.results.length=e.length}}function m(a,b){this.block=a;this.sheet=a.sheet;this.runtime=a.runtime;this.parameters=[];this.results=[];this.extra={};this.index=-1;this.anyParamVariesPerInstance=!1;this.func=b[1];-1===b[0]?(this.type=null,this.run=this.run_system,this.behaviortype=null,this.beh_index=-1):(this.type=this.runtime.types_by_index[b[0]],
this.run=this.run_object,b[2]?(this.behaviortype=this.type.getBehaviorByName(b[2]),this.beh_index=this.type.getBehaviorIndexByName(b[2])):(this.behaviortype=null,this.beh_index=-1));this.sid=b[3];this.runtime.actsBySid[this.sid.toString()]=this;if(6===b.length){var c,d,e=b[5];c=0;for(d=e.length;c<d;c++){var g=new cr.parameter(this,e[c]);cr.seal(g);this.parameters.push(g)}this.results.length=e.length}}function n(a,b){this.owner=a;this.block=a.block;this.sheet=a.sheet;this.runtime=a.runtime;this.type=
b[0];this.expression=null;this.solindex=0;this.get=null;this.combosel=0;this.layout=null;this.key=0;this.object=null;this.index=0;this.variadicret=this.subparams=this.variadicret=this.subparams=this.fileinfo=this.eventvar=this.varname=null;this.variesPerInstance=!1;var c,d,e;switch(b[0]){case 0:case 7:this.expression=new cr.expNode(this,b[1]);this.solindex=0;this.get=this.get_exp;break;case 1:this.expression=new cr.expNode(this,b[1]);this.solindex=0;this.get=this.get_exp_str;break;case 5:this.expression=
new cr.expNode(this,b[1]);this.solindex=0;this.get=this.get_layer;break;case 3:case 8:this.combosel=b[1];this.get=this.get_combosel;break;case 6:this.layout=this.runtime.layouts[b[1]];this.get=this.get_layout;break;case 9:this.key=b[1];this.get=this.get_key;break;case 4:this.object=this.runtime.types_by_index[b[1]];this.get=this.get_object;this.block.addSolModifier(this.object);this.owner instanceof cr.action?this.block.setSolWriterAfterCnds():this.block.parent&&this.block.parent.setSolWriterAfterCnds();
break;case 10:this.index=b[1];a.type.is_family?(this.get=this.get_familyvar,this.variesPerInstance=!0):this.get=this.get_instvar;break;case 11:this.varname=b[1];this.eventvar=null;this.get=this.get_eventvar;break;case 2:case 12:this.fileinfo=b[1];this.get=this.get_audiofile;break;case 13:for(this.get=this.get_variadic,this.subparams=[],this.variadicret=[],c=1,d=b.length;c<d;c++)e=new cr.parameter(this.owner,b[c]),cr.seal(e),this.subparams.push(e),this.variadicret.push(0)}}function l(a,b,c){this.sheet=
a;this.parent=b;this.runtime=a.runtime;this.solModifiers=[];this.name=c[1];this.vartype=c[2];this.initial=c[3];this.is_static=!!c[4];this.is_constant=!!c[5];this.sid=c[6];this.runtime.varsBySid[this.sid.toString()]=this;this.data=this.initial;this.parent?(this.localIndex=this.is_static||this.is_constant?-1:this.runtime.stackLocalCount++,this.runtime.all_local_vars.push(this)):(this.localIndex=-1,this.runtime.all_global_vars.push(this))}function q(a,b,c){this.sheet=a;this.parent=b;this.runtime=a.runtime;
this.solModifiers=[];this.include_sheet=null;this.include_sheet_name=c[1];this.active=!0}function u(){this.temp_parents_arr=[];this.reset(null);cr.seal(this)}var r=[];d.prototype.toString=function(){return this.name};d.prototype.init_event=function(a,b,c){switch(a[0]){case 0:a=new cr.eventblock(this,b,a);cr.seal(a);if(a.orblock)for(c.push(a),c=0,b=a.conditions.length;c<b;c++)a.conditions[c].trigger&&this.init_trigger(a,c);else a.is_trigger()?this.init_trigger(a,0):c.push(a);break;case 1:a=new cr.eventvariable(this,
b,a);cr.seal(a);c.push(a);break;case 2:a=new cr.eventinclude(this,b,a),cr.seal(a),c.push(a)}};d.prototype.postInit=function(){var a,b;a=0;for(b=this.events.length;a<b;a++)this.events[a].postInit(a<b-1&&this.events[a+1].is_else_block)};d.prototype.updateDeepIncludes=function(){this.deep_includes.length=0;this.already_included_sheets.length=0;this.addDeepIncludes(this);this.already_included_sheets.length=0};d.prototype.addDeepIncludes=function(a){var b,c,d,e,g=a.deep_includes,k=a.already_included_sheets,
f=this.includes.valuesRef();b=0;for(c=f.length;b<c;++b)d=f[b],e=d.include_sheet,!d.isActive()||a===e||-1<k.indexOf(e)||(k.push(e),e.addDeepIncludes(a),g.push(e))};d.prototype.run=function(a){this.runtime.resuming_breakpoint||(this.hasRun=!0,a||(this.runtime.isRunningEvents=!0));var b,c;b=0;for(c=this.events.length;b<c;b++){var d=this.events[b];d.run();this.runtime.clearSol(d.solModifiers);this.runtime.deathRow.isEmpty()&&!this.runtime.createRow.length||this.runtime.ClearDeathRow()}a||(this.runtime.isRunningEvents=
!1)};d.prototype.init_trigger=function(a,b){a.orblock||this.runtime.triggers_to_postinit.push(a);var c,d,e=a.conditions[b],g;g=e.type?e.type.name:"system";var k=(c=e.fasttrigger)?this.fasttriggers:this.triggers;k[g]||(k[g]=[]);g=k[g];k=e.func;if(c){if(e.parameters.length&&(e=e.parameters[0],1===e.type&&2===e.expression.type)){e=e.expression.value.toLowerCase();c=0;for(d=g.length;c<d;c++)if(g[c].method==k){c=g[c].evs;c[e]?c[e].push([a,b]):c[e]=[[a,b]];return}c={};c[e]=[[a,b]];g.push({method:k,evs:c})}}else{c=
0;for(d=g.length;c<d;c++)if(g[c].method==k){g[c].evs.push([a,b]);return}e=cr.plugins_.Sprite&&k===cr.plugins_.Sprite.prototype.cnds.OnFrameChanged?!0:!1;e?g.unshift({method:k,evs:[[a,b]]}):g.push({method:k,evs:[[a,b]]})}};cr.eventsheet=d;f.prototype.hasObjects=function(){return this.select_all?this.type.instances.length:this.instances.length};f.prototype.getObjects=function(){return this.select_all?this.type.instances:this.instances};f.prototype.pick_one=function(a){a&&(a.runtime.getCurrentEventStack().current_event.orblock?
(this.select_all&&(this.instances.length=0,cr.shallowAssignArray(this.else_instances,a.type.instances),this.select_all=!1),a=this.else_instances.indexOf(a),-1!==a&&(this.instances.push(this.else_instances[a]),this.else_instances.splice(a,1))):(this.select_all=!1,this.instances.length=1,this.instances[0]=a))};cr.selection=f;window._c2hh_="3F2616BC32EB9D47C8173CE217E5B6DEB4E996E5";e.prototype.postInit=function(a){var c,d=this.parent;if(this.group)for(this.toplevelgroup=!0;d;){if(!d.group){this.toplevelgroup=
!1;break}d=d.parent}this.toplevelevent=!this.is_trigger()&&(!this.parent||this.parent.group&&this.parent.toplevelgroup);this.has_else_block=!!a;this.solModifiersIncludingParents=this.solModifiers.slice(0);for(d=this.parent;d;){a=0;for(c=d.solModifiers.length;a<c;a++)this.addParentSolModifier(d.solModifiers[a]);d=d.parent}this.solModifiers=b(this.solModifiers);this.solModifiersIncludingParents=b(this.solModifiersIncludingParents);a=0;for(c=this.conditions.length;a<c;a++)this.conditions[a].postInit();
a=0;for(c=this.actions.length;a<c;a++)this.actions[a].postInit();a=0;for(c=this.subevents.length;a<c;a++)this.subevents[a].postInit(a<c-1&&this.subevents[a+1].is_else_block)};e.prototype.setGroupActive=function(a){if(this.group_active!==!!a){this.group_active=!!a;var b;a=0;for(b=this.contained_includes.length;a<b;++a)this.contained_includes[a].updateActive();0<b&&this.runtime.running_layout.event_sheet&&this.runtime.running_layout.event_sheet.updateDeepIncludes()}};e.prototype.addSolModifier=function(a){h(a,
this.solModifiers)};e.prototype.addParentSolModifier=function(a){h(a,this.solModifiersIncludingParents)};e.prototype.setSolWriterAfterCnds=function(){this.solWriterAfterCnds=!0;this.parent&&this.parent.setSolWriterAfterCnds()};e.prototype.is_trigger=function(){return this.conditions.length?this.conditions[0].trigger:!1};e.prototype.run=function(){var a,b=!1,c,d=this.runtime,e=this.runtime.getCurrentEventStack();e.current_event=this;var g=this.conditions;this.is_else_block||(e.else_branch_ran=!1);
if(this.orblock){0===g.length&&(b=!0);e.cndindex=0;for(a=g.length;e.cndindex<a;e.cndindex++)g[e.cndindex].trigger||(c=g[e.cndindex].run())&&(b=!0);(e.last_event_true=b)&&this.run_actions_and_subevents()}else{e.cndindex=0;for(a=g.length;e.cndindex<a;e.cndindex++)if(c=g[e.cndindex].run(),!c){e.last_event_true=!1;!this.toplevelevent||d.deathRow.isEmpty()&&!d.createRow.length||d.ClearDeathRow();return}e.last_event_true=!0;this.run_actions_and_subevents()}this.end_run(e)};e.prototype.end_run=function(a){a.last_event_true&&
this.has_else_block&&(a.else_branch_ran=!0);!this.toplevelevent||this.runtime.deathRow.isEmpty()&&!this.runtime.createRow.length||this.runtime.ClearDeathRow()};e.prototype.run_orblocktrigger=function(a){this.runtime.getCurrentEventStack().current_event=this;this.conditions[a].run()&&(this.run_actions_and_subevents(),this.runtime.getCurrentEventStack().last_event_true=!0)};e.prototype.run_actions_and_subevents=function(){var a=this.runtime.getCurrentEventStack(),b;a.actindex=0;for(b=this.actions.length;a.actindex<
b;a.actindex++)if(this.actions[a.actindex].run())return;this.run_subevents()};e.prototype.resume_actions_and_subevents=function(){var a=this.runtime.getCurrentEventStack(),b;for(b=this.actions.length;a.actindex<b;a.actindex++)if(this.actions[a.actindex].run())return;this.run_subevents()};e.prototype.run_subevents=function(){if(this.subevents.length){var a,b,c,d,e=this.subevents.length-1;this.runtime.pushEventStack(this);if(this.solWriterAfterCnds)for(a=0,b=this.subevents.length;a<b;a++)c=this.subevents[a],
(d=!this.toplevelgroup||!this.group&&a<e)&&this.runtime.pushCopySol(c.solModifiers),c.run(),d?this.runtime.popSol(c.solModifiers):this.runtime.clearSol(c.solModifiers);else for(a=0,b=this.subevents.length;a<b;a++)this.subevents[a].run();this.runtime.popEventStack()}};e.prototype.run_pretrigger=function(){var a=this.runtime.getCurrentEventStack();a.current_event=this;var b=!1,c;a.cndindex=0;for(c=this.conditions.length;a.cndindex<c;a.cndindex++)if(this.conditions[a.cndindex].run())b=!0;else if(!this.orblock)return!1;
return this.orblock?b:!0};e.prototype.retrigger=function(){this.runtime.execcount++;var a=this.runtime.getCurrentEventStack().cndindex,b=this.runtime.pushEventStack(this);if(!this.orblock)for(b.cndindex=a+1,a=this.conditions.length;b.cndindex<a;b.cndindex++)if(!this.conditions[b.cndindex].run())return this.runtime.popEventStack(),!1;this.run_actions_and_subevents();this.runtime.popEventStack();return!0};e.prototype.isFirstConditionOfType=function(a){var b=a.index;if(0===b)return!0;for(--b;0<=b;--b)if(this.conditions[b].type===
a.type)return!1;return!0};cr.eventblock=e;p.prototype.postInit=function(){var a,b,c;a=0;for(b=this.parameters.length;a<b;a++)c=this.parameters[a],c.postInit(),c.variesPerInstance&&(this.anyParamVariesPerInstance=!0)};p.prototype.run_true=function(){return!0};p.prototype.run_system=function(){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.results[a]=this.parameters[a].get();return cr.xor(this.func.apply(this.runtime.system,this.results),this.inverted)};p.prototype.run_static=function(){var a,
b;a=0;for(b=this.parameters.length;a<b;a++)this.results[a]=this.parameters[a].get();a=this.func.apply(this.behaviortype?this.behaviortype:this.type,this.results);this.type.applySolToContainer();return a};p.prototype.run_object=function(){var a,b,c,d,e,g,k,f,h=this.type,l=h.getCurrentSol(),q=this.block.orblock&&!this.trigger;b=0;var m=h.is_contained,n=h.is_family,p=h.family_index,r=this.beh_index,u=-1<r,t=this.anyParamVariesPerInstance,x=this.parameters,T=this.results,U=this.inverted,J=this.func,B;
if(t)for(b=0,e=x.length;b<e;++b)g=x[b],g.variesPerInstance||(T[b]=g.get(0));else for(b=0,e=x.length;b<e;++b)T[b]=x[b].get(0);if(l.select_all){l.instances.length=0;l.else_instances.length=0;B=h.instances;a=0;for(d=B.length;a<d;++a){f=B[a];if(t)for(b=0,e=x.length;b<e;++b)g=x[b],g.variesPerInstance&&(T[b]=g.get(a));u?(b=0,n&&(b=f.type.family_beh_map[p]),b=J.apply(f.behavior_insts[r+b],T)):b=J.apply(f,T);(k=cr.xor(b,U))?l.instances.push(f):q&&l.else_instances.push(f)}h.finish&&h.finish(!0);l.select_all=
!1;h.applySolToContainer();return l.hasObjects()}c=0;B=(k=q&&!this.block.isFirstConditionOfType(this))?l.else_instances:l.instances;var W=!1;a=0;for(d=B.length;a<d;++a){f=B[a];if(t)for(b=0,e=x.length;b<e;++b)g=x[b],g.variesPerInstance&&(T[b]=g.get(a));u?(b=0,n&&(b=f.type.family_beh_map[p]),b=J.apply(f.behavior_insts[r+b],T)):b=J.apply(f,T);if(cr.xor(b,U))if(W=!0,k){if(l.instances.push(f),m)for(b=0,e=f.siblings.length;b<e;b++)g=f.siblings[b],g.type.getCurrentSol().instances.push(g)}else{B[c]=f;if(m)for(b=
0,e=f.siblings.length;b<e;b++)g=f.siblings[b],g.type.getCurrentSol().instances[c]=g;c++}else if(k){B[c]=f;if(m)for(b=0,e=f.siblings.length;b<e;b++)g=f.siblings[b],g.type.getCurrentSol().else_instances[c]=g;c++}else if(q&&(l.else_instances.push(f),m))for(b=0,e=f.siblings.length;b<e;b++)g=f.siblings[b],g.type.getCurrentSol().else_instances.push(g)}B.length=c;if(m)for(n=h.container,a=0,d=n.length;a<d;a++)f=n[a].getCurrentSol(),k?f.else_instances.length=c:f.instances.length=c;c=W;if(k&&!W)for(a=0,d=l.instances.length;a<
d;a++){f=l.instances[a];if(t)for(b=0,e=x.length;b<e;b++)g=x[b],g.variesPerInstance&&(T[b]=g.get(a));b=u?J.apply(f.behavior_insts[r],T):J.apply(f,T);if(cr.xor(b,U)){W=!0;break}}h.finish&&h.finish(c||q);return q?W:l.hasObjects()};cr.condition=p;m.prototype.postInit=function(){var a,b,c;a=0;for(b=this.parameters.length;a<b;a++)c=this.parameters[a],c.postInit(),c.variesPerInstance&&(this.anyParamVariesPerInstance=!0)};m.prototype.run_system=function(){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.results[a]=
this.parameters[a].get();return this.func.apply(this.runtime.system,this.results)};m.prototype.run_object=function(){var a=this.type.getCurrentSol().getObjects(),b=this.type.is_family,c=this.type.family_index,d=this.beh_index,e=-1<d,g=this.anyParamVariesPerInstance,k=this.parameters,f=this.results,h=this.func,l,q,m,n,p,r;if(g)for(q=0,n=k.length;q<n;++q)p=k[q],p.variesPerInstance||(f[q]=p.get(0));else for(q=0,n=k.length;q<n;++q)f[q]=k[q].get(0);l=0;for(m=a.length;l<m;++l){r=a[l];if(g)for(q=0,n=k.length;q<
n;++q)p=k[q],p.variesPerInstance&&(f[q]=p.get(l));e?(q=0,b&&(q=r.type.family_beh_map[c]),h.apply(r.behavior_insts[d+q],f)):h.apply(r,f)}return!1};cr.action=m;var t=[],x=-1;n.prototype.postInit=function(){var a,b;if(11===this.type)this.eventvar=this.runtime.getEventVariableByName(this.varname,this.block.parent);else if(13===this.type)for(a=0,b=this.subparams.length;a<b;a++)this.subparams[a].postInit();this.expression&&this.expression.postInit()};n.prototype.maybeVaryForType=function(a){this.variesPerInstance||
!a||a.plugin.singleglobal||(this.variesPerInstance=!0)};n.prototype.setVaries=function(){this.variesPerInstance=!0};n.prototype.pushTempValue=function(){x++;t.length===x&&t.push(new cr.expvalue);return t[x]};n.prototype.popTempValue=function(){x--};n.prototype.get_exp=function(a){this.solindex=a||0;a=this.pushTempValue();this.expression.get(a);this.popTempValue();return a.data};n.prototype.get_exp_str=function(a){this.solindex=a||0;a=this.pushTempValue();this.expression.get(a);this.popTempValue();
return cr.is_string(a.data)?a.data:""};n.prototype.get_object=function(){return this.object};n.prototype.get_combosel=function(){return this.combosel};n.prototype.get_layer=function(a){this.solindex=a||0;a=this.pushTempValue();this.expression.get(a);this.popTempValue();return a.is_number()?this.runtime.getLayerByNumber(a.data):this.runtime.getLayerByName(a.data)};n.prototype.get_layout=function(){return this.layout};n.prototype.get_key=function(){return this.key};n.prototype.get_instvar=function(){return this.index};
n.prototype.get_familyvar=function(a){a=a||0;var b=this.owner.type,c=null,c=b.getCurrentSol(),d=c.getObjects();if(d.length)c=d[a%d.length].type;else if(c.else_instances.length)c=c.else_instances[a%c.else_instances.length].type;else if(b.instances.length)c=b.instances[a%b.instances.length].type;else return 0;return this.index+c.family_var_map[b.family_index]};n.prototype.get_eventvar=function(){return this.eventvar};n.prototype.get_audiofile=function(){return this.fileinfo};n.prototype.get_variadic=
function(){var a,b;a=0;for(b=this.subparams.length;a<b;a++)this.variadicret[a]=this.subparams[a].get();return this.variadicret};cr.parameter=n;l.prototype.postInit=function(){this.solModifiers=b(this.solModifiers)};l.prototype.setValue=function(a){var b=this.runtime.getCurrentLocalVarStack();this.parent&&!this.is_static&&b?(this.localIndex>=b.length&&(b.length=this.localIndex+1),b[this.localIndex]=a):this.data=a};l.prototype.getValue=function(){var a=this.runtime.getCurrentLocalVarStack();return!this.parent||
this.is_static||!a||this.is_constant?this.data:this.localIndex>=a.length||"undefined"===typeof a[this.localIndex]?this.initial:a[this.localIndex]};l.prototype.run=function(){!this.parent||this.is_static||this.is_constant||this.setValue(this.initial)};cr.eventvariable=l;q.prototype.toString=function(){return"include:"+this.include_sheet.toString()};q.prototype.postInit=function(){this.include_sheet=this.runtime.eventsheets[this.include_sheet_name];this.sheet.includes.add(this);this.solModifiers=b(this.solModifiers);
for(var a=this.parent;a;)a.group&&a.contained_includes.push(this),a=a.parent;this.updateActive()};q.prototype.run=function(){this.parent&&this.runtime.pushCleanSol(this.runtime.types_by_index);this.include_sheet.hasRun||this.include_sheet.run(!0);this.parent&&this.runtime.popSol(this.runtime.types_by_index)};q.prototype.updateActive=function(){for(var a=this.parent;a;){if(a.group&&!a.group_active){this.active=!1;return}a=a.parent}this.active=!0};q.prototype.isActive=function(){return this.active};
cr.eventinclude=q;u.prototype.reset=function(a){this.current_event=a;this.actindex=this.cndindex=0;this.temp_parents_arr.length=0;this.any_true_state=this.else_branch_ran=this.last_event_true=!1};u.prototype.isModifierAfterCnds=function(){return this.current_event.solWriterAfterCnds?!0:this.cndindex<this.current_event.conditions.length-1?!!this.current_event.solModifiers.length:!1};cr.eventStackFrame=u})();
(function(){function a(a,c){this.owner=a;this.runtime=a.runtime;this.type=c[0];this.get=[this.eval_int,this.eval_float,this.eval_string,this.eval_unaryminus,this.eval_add,this.eval_subtract,this.eval_multiply,this.eval_divide,this.eval_mod,this.eval_power,this.eval_and,this.eval_or,this.eval_equal,this.eval_notequal,this.eval_less,this.eval_lessequal,this.eval_greater,this.eval_greaterequal,this.eval_conditional,this.eval_system_exp,this.eval_object_behavior_exp,this.eval_instvar_exp,this.eval_object_behavior_exp,
this.eval_eventvar_exp][this.type];var f=null;this.object_type=this.parameters=this.results=this.func=this.third=this.second=this.first=this.value=null;this.beh_index=-1;this.instance_expr=null;this.varindex=-1;this.eventvar=this.varname=this.behavior_type=null;this.return_string=!1;switch(this.type){case 0:case 1:case 2:this.value=c[1];break;case 3:this.first=new cr.expNode(a,c[1]);break;case 18:this.first=new cr.expNode(a,c[1]);this.second=new cr.expNode(a,c[2]);this.third=new cr.expNode(a,c[3]);
break;case 19:this.func=c[1];this.func!==cr.system_object.prototype.exps.random&&this.func!==cr.system_object.prototype.exps.choose||this.owner.setVaries();this.results=[];this.parameters=[];3===c.length?(f=c[2],this.results.length=f.length+1):this.results.length=1;break;case 20:this.object_type=this.runtime.types_by_index[c[1]];this.beh_index=-1;this.func=c[2];this.return_string=c[3];cr.plugins_.Function&&this.func===cr.plugins_.Function.prototype.exps.Call&&this.owner.setVaries();this.instance_expr=
c[4]?new cr.expNode(a,c[4]):null;this.results=[];this.parameters=[];6===c.length?(f=c[5],this.results.length=f.length+1):this.results.length=1;break;case 21:this.object_type=this.runtime.types_by_index[c[1]];this.return_string=c[2];this.instance_expr=c[3]?new cr.expNode(a,c[3]):null;this.varindex=c[4];break;case 22:this.object_type=this.runtime.types_by_index[c[1]];this.behavior_type=this.object_type.getBehaviorByName(c[2]);this.beh_index=this.object_type.getBehaviorIndexByName(c[2]);this.func=c[3];
this.return_string=c[4];this.instance_expr=c[5]?new cr.expNode(a,c[5]):null;this.results=[];this.parameters=[];7===c.length?(f=c[6],this.results.length=f.length+1):this.results.length=1;break;case 23:this.varname=c[1],this.eventvar=null}this.owner.maybeVaryForType(this.object_type);4<=this.type&&17>=this.type&&(this.first=new cr.expNode(a,c[1]),this.second=new cr.expNode(a,c[2]));if(f){var e,h;e=0;for(h=f.length;e<h;e++)this.parameters.push(new cr.expNode(a,f[e]))}cr.seal(this)}function c(a,c){this.type=
a||cr.exptype.Integer;this.data=c||0;this.object_class=null;this.type==cr.exptype.Integer&&(this.data=Math.floor(this.data));cr.seal(this)}a.prototype.postInit=function(){23===this.type&&(this.eventvar=this.owner.runtime.getEventVariableByName(this.varname,this.owner.block.parent));this.first&&this.first.postInit();this.second&&this.second.postInit();this.third&&this.third.postInit();this.instance_expr&&this.instance_expr.postInit();if(this.parameters){var a,c;a=0;for(c=this.parameters.length;a<c;a++)this.parameters[a].postInit()}};
a.prototype.eval_system_exp=function(a){this.results[0]=a;a=this.owner.pushTempValue();var c,f;c=0;for(f=this.parameters.length;c<f;c++)this.parameters[c].get(a),this.results[c+1]=a.data;this.owner.popTempValue();this.func.apply(this.runtime.system,this.results)};a.prototype.eval_object_behavior_exp=function(a){var c=this.object_type.getCurrentSol(),f=c.getObjects();if(!f.length)if(c.else_instances.length)f=c.else_instances;else{this.return_string?a.set_string(""):a.set_int(0);return}this.results[0]=
a;a.object_class=this.object_type;a=this.owner.pushTempValue();var e,c=0;for(e=this.parameters.length;c<e;c++)this.parameters[c].get(a),this.results[c+1]=a.data;c=this.owner.solindex;this.instance_expr&&(this.instance_expr.get(a),a.is_number()&&(c=a.data,f=this.object_type.instances));this.owner.popTempValue();c%=f.length;0>c&&(c+=f.length);f=f[c];-1<this.beh_index?(a=0,this.object_type.is_family&&(a=f.type.family_beh_map[this.object_type.family_index]),this.func.apply(f.behavior_insts[this.beh_index+
a],this.results)):this.func.apply(f,this.results)};a.prototype.eval_instvar_exp=function(a){var c=this.object_type.getCurrentSol(),f=c.getObjects();if(!f.length)if(c.else_instances.length)f=c.else_instances;else{this.return_string?a.set_string(""):a.set_int(0);return}c=this.owner.solindex;if(this.instance_expr){var e=this.owner.pushTempValue();this.instance_expr.get(e);if(e.is_number()){c=e.data;f=this.object_type.instances;c%=f.length;0>c&&(c+=f.length);f=f[c].instance_vars[this.varindex];cr.is_string(f)?
a.set_string(f):a.set_float(f);this.owner.popTempValue();return}this.owner.popTempValue()}c%=f.length;0>c&&(c+=f.length);f=f[c];c=0;this.object_type.is_family&&(c=f.type.family_var_map[this.object_type.family_index]);f=f.instance_vars[this.varindex+c];cr.is_string(f)?a.set_string(f):a.set_float(f)};a.prototype.eval_int=function(a){a.type=cr.exptype.Integer;a.data=this.value};a.prototype.eval_float=function(a){a.type=cr.exptype.Float;a.data=this.value};a.prototype.eval_string=function(a){a.type=cr.exptype.String;
a.data=this.value};a.prototype.eval_unaryminus=function(a){this.first.get(a);a.is_number()&&(a.data=-a.data)};a.prototype.eval_add=function(a){this.first.get(a);var c=this.owner.pushTempValue();this.second.get(c);a.is_number()&&c.is_number()&&(a.data+=c.data,c.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_subtract=function(a){this.first.get(a);var c=this.owner.pushTempValue();this.second.get(c);a.is_number()&&c.is_number()&&(a.data-=c.data,c.is_float()&&a.make_float());this.owner.popTempValue()};
a.prototype.eval_multiply=function(a){this.first.get(a);var c=this.owner.pushTempValue();this.second.get(c);a.is_number()&&c.is_number()&&(a.data*=c.data,c.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_divide=function(a){this.first.get(a);var c=this.owner.pushTempValue();this.second.get(c);a.is_number()&&c.is_number()&&(a.data/=c.data,a.make_float());this.owner.popTempValue()};a.prototype.eval_mod=function(a){this.first.get(a);var c=this.owner.pushTempValue();this.second.get(c);
a.is_number()&&c.is_number()&&(a.data%=c.data,c.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_power=function(a){this.first.get(a);var c=this.owner.pushTempValue();this.second.get(c);a.is_number()&&c.is_number()&&(a.data=Math.pow(a.data,c.data),c.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_and=function(a){this.first.get(a);var c=this.owner.pushTempValue();this.second.get(c);a.is_number()?c.is_string()?a.set_string(a.data.toString()+c.data):a.data&&
c.data?a.set_int(1):a.set_int(0):a.is_string()&&(c.is_string()?a.data+=c.data:a.data+=(Math.round(1E10*c.data)/1E10).toString());this.owner.popTempValue()};a.prototype.eval_or=function(a){this.first.get(a);var c=this.owner.pushTempValue();this.second.get(c);a.is_number()&&c.is_number()&&(a.data||c.data?a.set_int(1):a.set_int(0));this.owner.popTempValue()};a.prototype.eval_conditional=function(a){this.first.get(a);a.data?this.second.get(a):this.third.get(a)};a.prototype.eval_equal=function(a){this.first.get(a);
var c=this.owner.pushTempValue();this.second.get(c);a.set_int(a.data===c.data?1:0);this.owner.popTempValue()};a.prototype.eval_notequal=function(a){this.first.get(a);var c=this.owner.pushTempValue();this.second.get(c);a.set_int(a.data!==c.data?1:0);this.owner.popTempValue()};a.prototype.eval_less=function(a){this.first.get(a);var c=this.owner.pushTempValue();this.second.get(c);a.set_int(a.data<c.data?1:0);this.owner.popTempValue()};a.prototype.eval_lessequal=function(a){this.first.get(a);var c=this.owner.pushTempValue();
this.second.get(c);a.set_int(a.data<=c.data?1:0);this.owner.popTempValue()};a.prototype.eval_greater=function(a){this.first.get(a);var c=this.owner.pushTempValue();this.second.get(c);a.set_int(a.data>c.data?1:0);this.owner.popTempValue()};a.prototype.eval_greaterequal=function(a){this.first.get(a);var c=this.owner.pushTempValue();this.second.get(c);a.set_int(a.data>=c.data?1:0);this.owner.popTempValue()};a.prototype.eval_eventvar_exp=function(a){var c=this.eventvar.getValue();cr.is_number(c)?a.set_float(c):
a.set_string(c)};cr.expNode=a;c.prototype.is_int=function(){return this.type===cr.exptype.Integer};c.prototype.is_float=function(){return this.type===cr.exptype.Float};c.prototype.is_number=function(){return this.type===cr.exptype.Integer||this.type===cr.exptype.Float};c.prototype.is_string=function(){return this.type===cr.exptype.String};c.prototype.make_int=function(){this.is_int()||(this.is_float()?this.data=Math.floor(this.data):this.is_string()&&(this.data=parseInt(this.data,10)),this.type=cr.exptype.Integer)};
c.prototype.make_float=function(){this.is_float()||(this.is_string()&&(this.data=parseFloat(this.data)),this.type=cr.exptype.Float)};c.prototype.make_string=function(){this.is_string()||(this.data=this.data.toString(),this.type=cr.exptype.String)};c.prototype.set_int=function(a){this.type=cr.exptype.Integer;this.data=Math.floor(a)};c.prototype.set_float=function(a){this.type=cr.exptype.Float;this.data=a};c.prototype.set_string=function(a){this.type=cr.exptype.String;this.data=a};c.prototype.set_any=
function(a){cr.is_number(a)?(this.type=cr.exptype.Float,this.data=a):cr.is_string(a)?(this.type=cr.exptype.String,this.data=a.toString()):(this.type=cr.exptype.Integer,this.data=0)};cr.expvalue=c;cr.exptype={Integer:0,Float:1,String:2}})();cr.system_object=function(a){this.runtime=a;this.waits=[]};
cr.system_object.prototype.saveToJSON=function(){var a={},c,b,d,f,e,h,p,m;a.waits=[];var n=a.waits,l;c=0;for(b=this.waits.length;c<b;c++){h=this.waits[c];l={t:h.time,st:h.signaltag,s:h.signalled,ev:h.ev.sid,sm:[],sols:{}};h.ev.actions[h.actindex]&&(l.act=h.ev.actions[h.actindex].sid);d=0;for(f=h.solModifiers.length;d<f;d++)l.sm.push(h.solModifiers[d].sid);for(e in h.sols)if(h.sols.hasOwnProperty(e)){p=this.runtime.types_by_index[parseInt(e,10)];m={sa:h.sols[e].sa,insts:[]};d=0;for(f=h.sols[e].insts.length;d<
f;d++)m.insts.push(h.sols[e].insts[d].uid);l.sols[p.sid.toString()]=m}n.push(l)}return a};
cr.system_object.prototype.loadFromJSON=function(a){a=a.waits;var c,b,d,f,e,h,p,m,n,l,q;c=this.waits.length=0;for(b=a.length;c<b;c++)if(h=a[c],m=this.runtime.blocksBySid[h.ev.toString()]){n=-1;d=0;for(f=m.actions.length;d<f;d++)if(m.actions[d].sid===h.act){n=d;break}if(-1!==n){p={sols:{},solModifiers:[],deleteme:!1};p.time=h.t;p.signaltag=h.st||"";p.signalled=!!h.s;p.ev=m;p.actindex=n;d=0;for(f=h.sm.length;d<f;d++)(m=this.runtime.getObjectTypeBySid(h.sm[d]))&&p.solModifiers.push(m);for(e in h.sols)if(h.sols.hasOwnProperty(e)&&
(m=this.runtime.getObjectTypeBySid(parseInt(e,10)))){n=h.sols[e];l={sa:n.sa,insts:[]};d=0;for(f=n.insts.length;d<f;d++)(q=this.runtime.getObjectByUID(n.insts[d]))&&l.insts.push(q);p.sols[m.index.toString()]=l}this.waits.push(p)}}};
(function(){function a(){}function c(a,b){var c=a.extra.c2_foreachordered_val,d=b.extra.c2_foreachordered_val;if(cr.is_number(c)&&cr.is_number(d))return c-d;c=""+c;d=""+d;return c<d?-1:c>d?1:0}function b(a,b){q&&a===u&&b===r||(q=RegExp(a,b),u=a,r=b);q.lastIndex=0;return q}function d(){}function f(){var a;a=x.length?x.pop():{sols:{},solModifiers:[]};a.deleteme=!1;return a}function e(){var a;a=s.length?s.pop():{insts:[]};a.sa=!1;return a}function h(){}function p(a,c,d){if(a!==v||c!==A||d!==y){var e=
b(c,d);w=a.match(e);v=a;A=c;y=d}}var m=cr.system_object.prototype;a.prototype.EveryTick=function(){return!0};a.prototype.OnLayoutStart=function(){return!0};a.prototype.OnLayoutEnd=function(){return!0};a.prototype.Compare=function(a,b,c){return cr.do_cmp(a,b,c)};a.prototype.CompareTime=function(a,b){var c=this.runtime.kahanTime.sum;if(0===a){var d=this.runtime.getCurrentCondition();return!d.extra.CompareTime_executed&&c>=b?d.extra.CompareTime_executed=!0:!1}return cr.do_cmp(c,a,b)};a.prototype.LayerVisible=
function(a){return a?a.visible:!1};a.prototype.LayerCmpOpacity=function(a,b,c){return a?cr.do_cmp(100*a.opacity,b,c):!1};a.prototype.Repeat=function(a){var b=this.runtime.getCurrentEventStack(),c=b.current_event,d=b.isModifierAfterCnds(),b=this.runtime.pushLoopStack();if(d)for(d=0;d<a&&!b.stopped;d++)this.runtime.pushCopySol(c.solModifiers),b.index=d,c.retrigger(),this.runtime.popSol(c.solModifiers);else for(d=0;d<a&&!b.stopped;d++)b.index=d,c.retrigger();this.runtime.popLoopStack();return!1};a.prototype.While=
function(a){var b=this.runtime.getCurrentEventStack();a=b.current_event;var c=b.isModifierAfterCnds(),b=this.runtime.pushLoopStack();if(c)for(c=0;!b.stopped;c++)this.runtime.pushCopySol(a.solModifiers),b.index=c,a.retrigger()||(b.stopped=!0),this.runtime.popSol(a.solModifiers);else for(c=0;!b.stopped;c++)b.index=c,a.retrigger()||(b.stopped=!0);this.runtime.popLoopStack();return!1};a.prototype.For=function(a,b,c){var d=this.runtime.getCurrentEventStack(),e=d.current_event,d=d.isModifierAfterCnds();
a=this.runtime.pushLoopStack(a);if(c<b)if(d)for(;b>=c&&!a.stopped;--b)this.runtime.pushCopySol(e.solModifiers),a.index=b,e.retrigger(),this.runtime.popSol(e.solModifiers);else for(;b>=c&&!a.stopped;--b)a.index=b,e.retrigger();else if(d)for(;b<=c&&!a.stopped;++b)this.runtime.pushCopySol(e.solModifiers),a.index=b,e.retrigger(),this.runtime.popSol(e.solModifiers);else for(;b<=c&&!a.stopped;++b)a.index=b,e.retrigger();this.runtime.popLoopStack();return!1};var n=[],l=-1;a.prototype.ForEach=function(a){var b=
a.getCurrentSol();l++;n.length===l&&n.push([]);var c=n[l];cr.shallowAssignArray(c,b.getObjects());var d=this.runtime.getCurrentEventStack(),e=d.current_event,f=d.isModifierAfterCnds(),d=this.runtime.pushLoopStack(),h,q,m,p,r,u,y=a.is_contained;if(f)for(f=0,h=c.length;f<h&&!d.stopped;f++){this.runtime.pushCopySol(e.solModifiers);p=c[f];b=a.getCurrentSol();b.select_all=!1;b.instances.length=1;b.instances[0]=p;if(y)for(q=0,m=p.siblings.length;q<m;q++)r=p.siblings[q],u=r.type.getCurrentSol(),u.select_all=
!1,u.instances.length=1,u.instances[0]=r;d.index=f;e.retrigger();this.runtime.popSol(e.solModifiers)}else for(b.select_all=!1,b.instances.length=1,f=0,h=c.length;f<h&&!d.stopped;f++){p=c[f];b.instances[0]=p;if(y)for(q=0,m=p.siblings.length;q<m;q++)r=p.siblings[q],u=r.type.getCurrentSol(),u.select_all=!1,u.instances.length=1,u.instances[0]=r;d.index=f;e.retrigger()}c.length=0;this.runtime.popLoopStack();l--;return!1};a.prototype.ForEachOrdered=function(a,b,d){b=a.getCurrentSol();l++;n.length===l&&
n.push([]);var e=n[l];cr.shallowAssignArray(e,b.getObjects());var f=this.runtime.getCurrentEventStack(),h=f.current_event,q=this.runtime.getCurrentCondition(),m=f.isModifierAfterCnds(),f=this.runtime.pushLoopStack(),p,r,u,y,t;p=0;for(r=e.length;p<r;p++)e[p].extra.c2_foreachordered_val=q.parameters[1].get(p);e.sort(c);1===d&&e.reverse();d=a.is_contained;if(m)for(p=0,r=e.length;p<r&&!f.stopped;p++){this.runtime.pushCopySol(h.solModifiers);u=e[p];b=a.getCurrentSol();b.select_all=!1;b.instances.length=
1;b.instances[0]=u;if(d)for(q=0,m=u.siblings.length;q<m;q++)y=u.siblings[q],t=y.type.getCurrentSol(),t.select_all=!1,t.instances.length=1,t.instances[0]=y;f.index=p;h.retrigger();this.runtime.popSol(h.solModifiers)}else for(b.select_all=!1,b.instances.length=1,p=0,r=e.length;p<r&&!f.stopped;p++){u=e[p];b.instances[0]=u;if(d)for(q=0,m=u.siblings.length;q<m;q++)y=u.siblings[q],t=y.type.getCurrentSol(),t.select_all=!1,t.instances.length=1,t.instances[0]=y;f.index=p;h.retrigger()}e.length=0;this.runtime.popLoopStack();
l--;return!1};a.prototype.PickByComparison=function(a,b,c,d){var e,f,h,q;if(a){l++;n.length===l&&n.push([]);var m=n[l],p=a.getCurrentSol();cr.shallowAssignArray(m,p.getObjects());p.select_all&&(p.else_instances.length=0);var r=this.runtime.getCurrentCondition();h=e=0;for(f=m.length;e<f;e++)q=m[e],m[h]=q,b=r.parameters[1].get(e),d=r.parameters[3].get(e),cr.do_cmp(b,c,d)?h++:p.else_instances.push(q);m.length=h;p.select_all=!1;cr.shallowAssignArray(p.instances,m);m.length=0;l--;a.applySolToContainer();
return!!p.instances.length}};a.prototype.PickByEvaluate=function(a,b){var c,d,e,f;if(a){l++;n.length===l&&n.push([]);var h=n[l],q=a.getCurrentSol();cr.shallowAssignArray(h,q.getObjects());q.select_all&&(q.else_instances.length=0);var m=this.runtime.getCurrentCondition();e=c=0;for(d=h.length;c<d;c++)f=h[c],h[e]=f,(b=m.parameters[1].get(c))?e++:q.else_instances.push(f);h.length=e;q.select_all=!1;cr.shallowAssignArray(q.instances,h);h.length=0;l--;a.applySolToContainer();return!!q.instances.length}};
a.prototype.TriggerOnce=function(){var a=this.runtime.getCurrentCondition().extra;"undefined"===typeof a.TriggerOnce_lastTick&&(a.TriggerOnce_lastTick=-1);var b=a.TriggerOnce_lastTick,c=this.runtime.tickcount;a.TriggerOnce_lastTick=c;return this.runtime.layout_first_tick||b!==c-1};a.prototype.Every=function(a){var b=this.runtime.getCurrentCondition(),c=b.extra.Every_lastTime||0,d=this.runtime.kahanTime.sum;"undefined"===typeof b.extra.Every_seconds&&(b.extra.Every_seconds=a);var e=b.extra.Every_seconds;
if(d>=c+e)return b.extra.Every_lastTime=c+e,d>=b.extra.Every_lastTime+0.04&&(b.extra.Every_lastTime=d),b.extra.Every_seconds=a,!0;d<c-0.1&&(b.extra.Every_lastTime=d);return!1};a.prototype.PickNth=function(a,b){if(!a)return!1;var c=a.getCurrentSol(),d=c.getObjects();b=cr.floor(b);if(0>b||b>=d.length)return!1;c.pick_one(d[b]);a.applySolToContainer();return!0};a.prototype.PickRandom=function(a){if(!a)return!1;var b=a.getCurrentSol(),c=b.getObjects(),d=cr.floor(Math.random()*c.length);if(d>=c.length)return!1;
b.pick_one(c[d]);a.applySolToContainer();return!0};a.prototype.CompareVar=function(a,b,c){return cr.do_cmp(a.getValue(),b,c)};a.prototype.IsGroupActive=function(a){return(a=this.runtime.groups_by_name[a.toLowerCase()])&&a.group_active};a.prototype.IsPreview=function(){return"undefined"!==typeof cr_is_preview};a.prototype.PickAll=function(a){if(!a||!a.instances.length)return!1;a.getCurrentSol().select_all=!0;a.applySolToContainer();return!0};a.prototype.IsMobile=function(){return this.runtime.isMobile};
a.prototype.CompareBetween=function(a,b,c){return a>=b&&a<=c};a.prototype.Else=function(){var a=this.runtime.getCurrentEventStack();return a.else_branch_ran?!1:!a.last_event_true};a.prototype.OnLoadFinished=function(){return!0};a.prototype.OnCanvasSnapshot=function(){return!0};a.prototype.EffectsSupported=function(){return!!this.runtime.glwrap};a.prototype.OnSaveComplete=function(){return!0};a.prototype.OnLoadComplete=function(){return!0};a.prototype.OnLoadFailed=function(){return!0};a.prototype.ObjectUIDExists=
function(a){return!!this.runtime.getObjectByUID(a)};a.prototype.IsOnPlatform=function(a){var b=this.runtime;switch(a){case 0:return!b.isDomFree&&!b.isNodeWebkit&&!b.isPhoneGap&&!b.isCrosswalk&&!b.isWinJS&&!b.isWindowsPhone8&&!b.isBlackberry10&&!b.isAmazonWebApp;case 1:return b.isiOS;case 2:return b.isAndroid;case 3:return b.isWindows8App;case 4:return b.isWindowsPhone8;case 5:return b.isBlackberry10;case 6:return b.isTizen;case 7:return b.isCocoonJs;case 8:return b.isPhoneGap;case 9:return b.isArcade;
case 10:return b.isNodeWebkit;case 11:return b.isCrosswalk;case 12:return b.isAmazonWebApp;default:return!1}};var q=null,u="",r="";a.prototype.RegexTest=function(a,c,d){return b(c,d).test(a)};var t=[];a.prototype.PickOverlappingPoint=function(a,b,c){if(!a)return!1;var d=a.getCurrentSol(),e=d.getObjects(),f=this.runtime.getCurrentEventStack().current_event.orblock,h=this.runtime.getCurrentCondition(),q,l;d.select_all?(cr.shallowAssignArray(t,e),d.else_instances.length=0,d.select_all=!1,d.instances.length=
0):f?(cr.shallowAssignArray(t,d.else_instances),d.else_instances.length=0):(cr.shallowAssignArray(t,e),d.instances.length=0);e=0;for(f=t.length;e<f;++e)q=t[e],q.update_bbox(),(l=cr.xor(q.contains_pt(b,c),h.inverted))?d.instances.push(q):d.else_instances.push(q);a.applySolToContainer();return cr.xor(!!d.instances.length,h.inverted)};m.cnds=new a;d.prototype.GoToLayout=function(a){this.runtime.isloading||this.runtime.changelayout||(this.runtime.changelayout=a)};d.prototype.NextPrevLayout=function(a){if(!this.runtime.isloading&&
!this.runtime.changelayout){var b=this.runtime.layouts_by_index.indexOf(this.runtime.running_layout);if(!a||0!==b)if(a||b!==this.runtime.layouts_by_index.length-1)this.runtime.changelayout=this.runtime.layouts_by_index[b+(a?-1:1)]}};d.prototype.CreateObject=function(a,b,c,d){if(b&&a&&(b=this.runtime.createInstance(a,b,c,d))){this.runtime.isInOnDestroy++;var e;this.runtime.trigger(Object.getPrototypeOf(a.plugin).cnds.OnCreated,b);if(b.is_contained)for(c=0,d=b.siblings.length;c<d;c++)e=b.siblings[c],
this.runtime.trigger(Object.getPrototypeOf(e.type.plugin).cnds.OnCreated,e);this.runtime.isInOnDestroy--;a=a.getCurrentSol();a.select_all=!1;a.instances.length=1;a.instances[0]=b;if(b.is_contained)for(c=0,d=b.siblings.length;c<d;c++)e=b.siblings[c],a=e.type.getCurrentSol(),a.select_all=!1,a.instances.length=1,a.instances[0]=e}};d.prototype.SetLayerVisible=function(a,b){a&&a.visible!==b&&(a.visible=b,this.runtime.redraw=!0)};d.prototype.SetLayerOpacity=function(a,b){a&&(b=cr.clamp(b/100,0,1),a.opacity!==
b&&(a.opacity=b,this.runtime.redraw=!0))};d.prototype.SetLayerScaleRate=function(a,b){a&&a.zoomRate!==b&&(a.zoomRate=b,this.runtime.redraw=!0)};d.prototype.SetLayoutScale=function(a){this.runtime.running_layout&&this.runtime.running_layout.scale!==a&&(this.runtime.running_layout.scale=a,this.runtime.running_layout.boundScrolling(),this.runtime.redraw=!0)};d.prototype.ScrollX=function(a){this.runtime.running_layout.scrollToX(a)};d.prototype.ScrollY=function(a){this.runtime.running_layout.scrollToY(a)};
d.prototype.Scroll=function(a,b){this.runtime.running_layout.scrollToX(a);this.runtime.running_layout.scrollToY(b)};d.prototype.ScrollToObject=function(a){if(a=a.getFirstPicked())this.runtime.running_layout.scrollToX(a.x),this.runtime.running_layout.scrollToY(a.y)};d.prototype.SetVar=function(a,b){0===a.vartype?cr.is_number(b)?a.setValue(b):a.setValue(parseFloat(b)):1===a.vartype&&a.setValue(b.toString())};d.prototype.AddVar=function(a,b){0===a.vartype?cr.is_number(b)?a.setValue(a.getValue()+b):a.setValue(a.getValue()+
parseFloat(b)):1===a.vartype&&a.setValue(a.getValue()+b.toString())};d.prototype.SubVar=function(a,b){0===a.vartype&&(cr.is_number(b)?a.setValue(a.getValue()-b):a.setValue(a.getValue()-parseFloat(b)))};d.prototype.SetGroupActive=function(a,b){var c=this.runtime.groups_by_name[a.toLowerCase()];if(c)switch(b){case 0:c.setGroupActive(!1);break;case 1:c.setGroupActive(!0);break;case 2:c.setGroupActive(!c.group_active)}};d.prototype.SetTimescale=function(a){0>a&&(a=0);this.runtime.timescale=a};d.prototype.SetObjectTimescale=
function(a,b){var c=b;0>c&&(c=0);if(a){var d=a.getCurrentSol().getObjects(),e,f;e=0;for(f=d.length;e<f;e++)d[e].my_timescale=c}};d.prototype.RestoreObjectTimescale=function(a){if(!a)return!1;a=a.getCurrentSol().getObjects();var b,c;b=0;for(c=a.length;b<c;b++)a[b].my_timescale=-1};var x=[],s=[];d.prototype.Wait=function(a){if(!(0>a)){var b,c,d,h=this.runtime.getCurrentEventStack(),q=f();q.time=this.runtime.kahanTime.sum+a;q.signaltag="";q.signalled=!1;q.ev=h.current_event;q.actindex=h.actindex+1;a=
0;for(b=this.runtime.types_by_index.length;a<b;a++)d=this.runtime.types_by_index[a],c=d.getCurrentSol(),c.select_all&&-1===h.current_event.solModifiers.indexOf(d)||(q.solModifiers.push(d),d=e(),d.sa=c.select_all,cr.shallowAssignArray(d.insts,c.instances),q.sols[a.toString()]=d);this.waits.push(q);return!0}};d.prototype.WaitForSignal=function(a){var b,c,d,h=this.runtime.getCurrentEventStack(),q=f();q.time=-1;q.signaltag=a.toLowerCase();q.signalled=!1;q.ev=h.current_event;q.actindex=h.actindex+1;a=
0;for(b=this.runtime.types_by_index.length;a<b;a++)d=this.runtime.types_by_index[a],c=d.getCurrentSol(),c.select_all&&-1===h.current_event.solModifiers.indexOf(d)||(q.solModifiers.push(d),d=e(),d.sa=c.select_all,cr.shallowAssignArray(d.insts,c.instances),q.sols[a.toString()]=d);this.waits.push(q);return!0};d.prototype.Signal=function(a){a=a.toLowerCase();var b,c,d;b=0;for(c=this.waits.length;b<c;++b)d=this.waits[b],-1===d.time&&d.signaltag===a&&(d.signalled=!0)};d.prototype.SetLayerScale=function(a,
b){a&&a.scale!==b&&(a.scale=b,this.runtime.redraw=!0)};d.prototype.ResetGlobals=function(){var a,b,c;a=0;for(b=this.runtime.all_global_vars.length;a<b;a++)c=this.runtime.all_global_vars[a],c.data=c.initial};d.prototype.SetLayoutAngle=function(a){a=cr.to_radians(a);a=cr.clamp_angle(a);this.runtime.running_layout&&this.runtime.running_layout.angle!==a&&(this.runtime.running_layout.angle=a,this.runtime.redraw=!0)};d.prototype.SetLayerAngle=function(a,b){a&&(b=cr.to_radians(b),b=cr.clamp_angle(b),a.angle!==
b&&(a.angle=b,this.runtime.redraw=!0))};d.prototype.SetLayerParallax=function(a,b,c){if(a&&(a.parallaxX!==b/100||a.parallaxY!==c/100)){a.parallaxX=b/100;a.parallaxY=c/100;if(1!==a.parallaxX||1!==a.parallaxY)for(c=a.instances,a=0,b=c.length;a<b;++a)c[a].type.any_instance_parallaxed=!0;this.runtime.redraw=!0}};d.prototype.SetLayerBackground=function(a,b){if(a){var c=cr.GetRValue(b),d=cr.GetGValue(b),e=cr.GetBValue(b);if(a.background_color[0]!==c||a.background_color[1]!==d||a.background_color[2]!==e)a.background_color[0]=
c,a.background_color[1]=d,a.background_color[2]=e,this.runtime.redraw=!0}};d.prototype.SetLayerTransparent=function(a,b){a&&!!b!==!!a.transparent&&(a.transparent=!!b,this.runtime.redraw=!0)};d.prototype.StopLoop=function(){0>this.runtime.loop_stack_index||(this.runtime.getCurrentLoop().stopped=!0)};d.prototype.GoToLayoutByName=function(a){if(!this.runtime.isloading&&!this.runtime.changelayout)for(var b in this.runtime.layouts)if(this.runtime.layouts.hasOwnProperty(b)&&cr.equals_nocase(b,a)){this.runtime.changelayout=
this.runtime.layouts[b];break}};d.prototype.RestartLayout=function(a){if(!this.runtime.isloading&&!this.runtime.changelayout&&this.runtime.running_layout){this.runtime.changelayout=this.runtime.running_layout;var b,c;a=0;for(b=this.runtime.allGroups.length;a<b;a++)c=this.runtime.allGroups[a],c.setGroupActive(c.initially_activated)}};d.prototype.SnapshotCanvas=function(a,b){this.runtime.snapshotCanvas=[0===a?"image/png":"image/jpeg",b/100];this.runtime.redraw=!0};d.prototype.SetCanvasSize=function(a,
b){if(!(0>=a||0>=b)){var c=this.runtime.fullscreen_mode;(document.mozFullScreen||document.webkitIsFullScreen||document.msFullscreenElement||document.fullScreen||this.runtime.isNodeFullscreen)&&0<this.runtime.fullscreen_scaling&&(c=this.runtime.fullscreen_scaling);0===c?this.runtime.setSize(a,b,!0):(this.runtime.original_width=a,this.runtime.original_height=b,this.runtime.setSize(this.runtime.lastWindowWidth,this.runtime.lastWindowHeight,!0))}};d.prototype.SetLayoutEffectEnabled=function(a,b){if(this.runtime.running_layout&&
this.runtime.glwrap){var c=this.runtime.running_layout.getEffectByName(b);if(c){var d=1===a;c.active!=d&&(c.active=d,this.runtime.running_layout.updateActiveEffects(),this.runtime.redraw=!0)}}};d.prototype.SetLayerEffectEnabled=function(a,b,c){a&&this.runtime.glwrap&&(c=a.getEffectByName(c))&&(b=1===b,c.active!=b&&(c.active=b,a.updateActiveEffects(),this.runtime.redraw=!0))};d.prototype.SetLayoutEffectParam=function(a,b,c){if(this.runtime.running_layout&&this.runtime.glwrap&&(a=this.runtime.running_layout.getEffectByName(a))){var d=
this.runtime.running_layout.effect_params[a.index];b=Math.floor(b);0>b||b>=d.length||(1===this.runtime.glwrap.getProgramParameterType(a.shaderindex,b)&&(c/=100),d[b]!==c&&(d[b]=c,a.active&&(this.runtime.redraw=!0)))}};d.prototype.SetLayerEffectParam=function(a,b,c,d){a&&this.runtime.glwrap&&(b=a.getEffectByName(b))&&(a=a.effect_params[b.index],c=Math.floor(c),0>c||c>=a.length||(1===this.runtime.glwrap.getProgramParameterType(b.shaderindex,c)&&(d/=100),a[c]!==d&&(a[c]=d,b.active&&(this.runtime.redraw=
!0))))};d.prototype.SaveState=function(a){this.runtime.saveToSlot=a};d.prototype.LoadState=function(a){this.runtime.loadFromSlot=a};d.prototype.LoadStateJSON=function(a){this.runtime.loadFromJson=a};d.prototype.SetHalfFramerateMode=function(a){this.runtime.halfFramerateMode=0!==a};d.prototype.SetFullscreenQuality=function(a){if(document.mozFullScreen||document.webkitIsFullScreen||document.msFullscreenElement||document.fullScreen||this.isNodeFullscreen||0!==this.runtime.fullscreen_mode)this.runtime.wantFullscreenScalingQuality=
0!==a,this.runtime.setSize(this.runtime.lastWindowWidth,this.runtime.lastWindowHeight,!0)};m.acts=new d;h.prototype["int"]=function(a,b){cr.is_string(b)?(a.set_int(parseInt(b,10)),isNaN(a.data)&&(a.data=0)):a.set_int(b)};h.prototype["float"]=function(a,b){cr.is_string(b)?(a.set_float(parseFloat(b)),isNaN(a.data)&&(a.data=0)):a.set_float(b)};h.prototype.str=function(a,b){cr.is_string(b)?a.set_string(b):a.set_string(b.toString())};h.prototype.len=function(a,b){a.set_int(b.length||0)};h.prototype.random=
function(a,b,c){void 0===c?a.set_float(Math.random()*b):a.set_float(Math.random()*(c-b)+b)};h.prototype.sqrt=function(a,b){a.set_float(Math.sqrt(b))};h.prototype.abs=function(a,b){a.set_float(Math.abs(b))};h.prototype.round=function(a,b){a.set_int(Math.round(b))};h.prototype.floor=function(a,b){a.set_int(Math.floor(b))};h.prototype.ceil=function(a,b){a.set_int(Math.ceil(b))};h.prototype.sin=function(a,b){a.set_float(Math.sin(cr.to_radians(b)))};h.prototype.cos=function(a,b){a.set_float(Math.cos(cr.to_radians(b)))};
h.prototype.tan=function(a,b){a.set_float(Math.tan(cr.to_radians(b)))};h.prototype.asin=function(a,b){a.set_float(cr.to_degrees(Math.asin(b)))};h.prototype.acos=function(a,b){a.set_float(cr.to_degrees(Math.acos(b)))};h.prototype.atan=function(a,b){a.set_float(cr.to_degrees(Math.atan(b)))};h.prototype.exp=function(a,b){a.set_float(Math.exp(b))};h.prototype.ln=function(a,b){a.set_float(Math.log(b))};h.prototype.log10=function(a,b){a.set_float(Math.log(b)/Math.LN10)};h.prototype.max=function(a){var b=
arguments[1];"number"!==typeof b&&(b=0);var c,d,e;c=2;for(d=arguments.length;c<d;c++)e=arguments[c],"number"===typeof e&&b<e&&(b=e);a.set_float(b)};h.prototype.min=function(a){var b=arguments[1];"number"!==typeof b&&(b=0);var c,d,e;c=2;for(d=arguments.length;c<d;c++)e=arguments[c],"number"===typeof e&&b>e&&(b=e);a.set_float(b)};h.prototype.dt=function(a){a.set_float(this.runtime.dt)};h.prototype.timescale=function(a){a.set_float(this.runtime.timescale)};h.prototype.wallclocktime=function(a){a.set_float((Date.now()-
this.runtime.start_time)/1E3)};h.prototype.time=function(a){a.set_float(this.runtime.kahanTime.sum)};h.prototype.tickcount=function(a){a.set_int(this.runtime.tickcount)};h.prototype.objectcount=function(a){a.set_int(this.runtime.objectcount)};h.prototype.fps=function(a){a.set_int(this.runtime.fps)};h.prototype.loopindex=function(a,b){var c,d,e;if(this.runtime.loop_stack.length)if(b){d=0;for(e=this.runtime.loop_stack.length;d<e;d++)if(c=this.runtime.loop_stack[d],c.name===b){a.set_int(c.index);return}a.set_int(0)}else c=
this.runtime.getCurrentLoop(),a.set_int(c?c.index:-1);else a.set_int(0)};h.prototype.distance=function(a,b,c,d,e){a.set_float(cr.distanceTo(b,c,d,e))};h.prototype.angle=function(a,b,c,d,e){a.set_float(cr.to_degrees(cr.angleTo(b,c,d,e)))};h.prototype.scrollx=function(a){a.set_float(this.runtime.running_layout.scrollX)};h.prototype.scrolly=function(a){a.set_float(this.runtime.running_layout.scrollY)};h.prototype.newline=function(a){a.set_string("\n")};h.prototype.lerp=function(a,b,c,d){a.set_float(cr.lerp(b,
c,d))};h.prototype.qarp=function(a,b,c,d,e){a.set_float(cr.qarp(b,c,d,e))};h.prototype.cubic=function(a,b,c,d,e,f){a.set_float(cr.cubic(b,c,d,e,f))};h.prototype.cosp=function(a,b,c,d){a.set_float(cr.cosp(b,c,d))};h.prototype.windowwidth=function(a){a.set_int(this.runtime.width)};h.prototype.windowheight=function(a){a.set_int(this.runtime.height)};h.prototype.uppercase=function(a,b){a.set_string(cr.is_string(b)?b.toUpperCase():"")};h.prototype.lowercase=function(a,b){a.set_string(cr.is_string(b)?b.toLowerCase():
"")};h.prototype.clamp=function(a,b,c,d){b<c?a.set_float(c):b>d?a.set_float(d):a.set_float(b)};h.prototype.layerscale=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(c.scale):a.set_float(0)};h.prototype.layeropacity=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(100*c.opacity):a.set_float(0)};h.prototype.layerscalerate=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(c.zoomRate):a.set_float(0)};h.prototype.layerparallaxx=function(a,b){var c=this.runtime.getLayer(b);
c?a.set_float(100*c.parallaxX):a.set_float(0)};h.prototype.layerparallaxy=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(100*c.parallaxY):a.set_float(0)};h.prototype.layoutscale=function(a){this.runtime.running_layout?a.set_float(this.runtime.running_layout.scale):a.set_float(0)};h.prototype.layoutangle=function(a){a.set_float(cr.to_degrees(this.runtime.running_layout.angle))};h.prototype.layerangle=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(cr.to_degrees(c.angle)):a.set_float(0)};
h.prototype.layoutwidth=function(a){a.set_int(this.runtime.running_layout.width)};h.prototype.layoutheight=function(a){a.set_int(this.runtime.running_layout.height)};h.prototype.find=function(a,b,c){cr.is_string(b)&&cr.is_string(c)?a.set_int(b.search(RegExp(cr.regexp_escape(c),"i"))):a.set_int(-1)};h.prototype.left=function(a,b,c){a.set_string(cr.is_string(b)?b.substr(0,c):"")};h.prototype.right=function(a,b,c){a.set_string(cr.is_string(b)?b.substr(b.length-c):"")};h.prototype.mid=function(a,b,c,
d){a.set_string(cr.is_string(b)?b.substr(c,d):"")};h.prototype.tokenat=function(a,b,c,d){cr.is_string(b)&&cr.is_string(d)?(b=b.split(d),c=cr.floor(c),0>c||c>=b.length?a.set_string(""):a.set_string(b[c])):a.set_string("")};h.prototype.tokencount=function(a,b,c){cr.is_string(b)&&b.length?a.set_int(b.split(c).length):a.set_int(0)};h.prototype.replace=function(a,b,c,d){cr.is_string(b)&&cr.is_string(c)&&cr.is_string(d)?a.set_string(b.replace(RegExp(cr.regexp_escape(c),"gi"),d)):a.set_string(cr.is_string(b)?
b:"")};h.prototype.trim=function(a,b){a.set_string(cr.is_string(b)?b.trim():"")};h.prototype.pi=function(a){a.set_float(cr.PI)};h.prototype.layoutname=function(a){this.runtime.running_layout?a.set_string(this.runtime.running_layout.name):a.set_string("")};h.prototype.renderer=function(a){a.set_string(this.runtime.gl?"webgl":"canvas2d")};h.prototype.anglediff=function(a,b,c){a.set_float(cr.to_degrees(cr.angleDiff(cr.to_radians(b),cr.to_radians(c))))};h.prototype.choose=function(a){var b=cr.floor(Math.random()*
(arguments.length-1));a.set_any(arguments[b+1])};h.prototype.rgb=function(a,b,c,d){a.set_int(cr.RGB(b,c,d))};h.prototype.projectversion=function(a){a.set_string(this.runtime.versionstr)};h.prototype.anglelerp=function(a,b,c,d){b=cr.to_radians(b);c=cr.to_radians(c);var e=cr.angleDiff(b,c);cr.angleClockwise(c,b)?a.set_float(cr.to_clamped_degrees(b+e*d)):a.set_float(cr.to_clamped_degrees(b-e*d))};h.prototype.anglerotate=function(a,b,c,d){b=cr.to_radians(b);c=cr.to_radians(c);d=cr.to_radians(d);a.set_float(cr.to_clamped_degrees(cr.angleRotate(b,
c,d)))};h.prototype.zeropad=function(a,b,c){var d=0>b?"-":"";0>b&&(b=-b);c-=b.toString().length;for(var e=0;e<c;e++)d+="0";a.set_string(d+b.toString())};h.prototype.cpuutilisation=function(a){a.set_float(this.runtime.cpuutilisation/1E3)};h.prototype.viewportleft=function(a,b){var c=this.runtime.getLayer(b);a.set_float(c?c.viewLeft:0)};h.prototype.viewporttop=function(a,b){var c=this.runtime.getLayer(b);a.set_float(c?c.viewTop:0)};h.prototype.viewportright=function(a,b){var c=this.runtime.getLayer(b);
a.set_float(c?c.viewRight:0)};h.prototype.viewportbottom=function(a,b){var c=this.runtime.getLayer(b);a.set_float(c?c.viewBottom:0)};h.prototype.loadingprogress=function(a){a.set_float(this.runtime.loadingprogress)};h.prototype.unlerp=function(a,b,c,d){a.set_float(cr.unlerp(b,c,d))};h.prototype.canvassnapshot=function(a){a.set_string(this.runtime.snapshotData)};h.prototype.urlencode=function(a,b){a.set_string(encodeURIComponent(b))};h.prototype.urldecode=function(a,b){a.set_string(decodeURIComponent(b))};
h.prototype.canvastolayerx=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.canvasToLayer(c,d,!0):0)};h.prototype.canvastolayery=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.canvasToLayer(c,d,!1):0)};h.prototype.layertocanvasx=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.layerToCanvas(c,d,!0):0)};h.prototype.layertocanvasy=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.layerToCanvas(c,d,!1):0)};h.prototype.savestatejson=function(a){a.set_string(this.runtime.lastSaveJson)};
h.prototype.imagememoryusage=function(a){this.runtime.glwrap?a.set_float(Math.round(100*this.runtime.glwrap.estimateVRAM()/1048576)/100):a.set_float(0)};h.prototype.regexsearch=function(a,c,d,e){d=b(d,e);a.set_int(c?c.search(d):-1)};h.prototype.regexreplace=function(a,c,d,e,f){d=b(d,e);a.set_string(c?c.replace(d,f):"")};var w=[],v="",A="",y="";h.prototype.regexmatchcount=function(a,c,d,e){b(d,e);p(c,d,e);a.set_int(w?w.length:0)};h.prototype.regexmatchat=function(a,c,d,e,f){f=Math.floor(f);b(d,e);
p(c,d,e);!w||0>f||f>=w.length?a.set_string(""):a.set_string(w[f])};h.prototype.infinity=function(a){a.set_float(Infinity)};h.prototype.setbit=function(a,b,c,d){c|=0;a.set_int((b|0)&~(1<<c)|(0!==d?1:0)<<c)};h.prototype.togglebit=function(a,b,c){a.set_int((b|0)^1<<(c|0))};h.prototype.getbit=function(a,b,c){a.set_int((b|0)&1<<(c|0)?1:0)};m.exps=new h;m.runWaits=function(){var a,b,c,d,e,f,h=this.runtime.getCurrentEventStack();a=0;for(c=this.waits.length;a<c;a++){d=this.waits[a];if(-1===d.time){if(!d.signalled)continue}else if(d.time>
this.runtime.kahanTime.sum)continue;h.current_event=d.ev;h.actindex=d.actindex;h.cndindex=0;for(b in d.sols)d.sols.hasOwnProperty(b)&&(e=this.runtime.types_by_index[parseInt(b,10)].getCurrentSol(),f=d.sols[b],e.select_all=f.sa,cr.shallowAssignArray(e.instances,f.insts),e=f,e.insts.length=0,s.push(e));d.ev.resume_actions_and_subevents();this.runtime.clearSol(d.solModifiers);d.deleteme=!0}b=a=0;for(c=this.waits.length;a<c;a++)d=this.waits[a],this.waits[b]=d,d.deleteme?(cr.wipe(d.sols),d.solModifiers.length=
0,x.push(d)):b++;this.waits.length=b}})();
(function(){cr.add_common_aces=function(a){var b=a[0].prototype,d=a[1],f=a[3],e=a[4],h=a[5],p=a[6],m=a[7];a=a[8];b.cnds||(b.cnds={});b.acts||(b.acts={});b.exps||(b.exps={});var n=b.cnds,l=b.acts,b=b.exps;f&&(n.CompareX=function(a,b){return cr.do_cmp(this.x,a,b)},n.CompareY=function(a,b){return cr.do_cmp(this.y,a,b)},n.IsOnScreen=function(){var a=this.layer;this.update_bbox();var b=this.bbox;return!(b.right<a.viewLeft||b.bottom<a.viewTop||b.left>a.viewRight||b.top>a.viewBottom)},n.IsOutsideLayout=
function(){this.update_bbox();var a=this.bbox,b=this.runtime.running_layout;return 0>a.right||0>a.bottom||a.left>b.width||a.top>b.height},n.PickDistance=function(a,b,c){var d=this.getCurrentSol(),e=d.getObjects();if(!e.length)return!1;var f=e[0],h=f,l=cr.distanceTo(f.x,f.y,b,c),m,n,g;m=1;for(n=e.length;m<n;m++)if(f=e[m],g=cr.distanceTo(f.x,f.y,b,c),0===a&&g<l||1===a&&g>l)l=g,h=f;d.pick_one(h);return!0},l.SetX=function(a){this.x!==a&&(this.x=a,this.set_bbox_changed())},l.SetY=function(a){this.y!==
a&&(this.y=a,this.set_bbox_changed())},l.SetPos=function(a,b){if(this.x!==a||this.y!==b)this.x=a,this.y=b,this.set_bbox_changed()},l.SetPosToObject=function(a,b){var c=a.getPairedInstance(this);if(c){var d;c.getImagePoint?(d=c.getImagePoint(b,!0),c=c.getImagePoint(b,!1)):(d=c.x,c=c.y);if(this.x!==d||this.y!==c)this.x=d,this.y=c,this.set_bbox_changed()}},l.MoveForward=function(a){0!==a&&(this.x+=Math.cos(this.angle)*a,this.y+=Math.sin(this.angle)*a,this.set_bbox_changed())},l.MoveAtAngle=function(a,
b){0!==b&&(this.x+=Math.cos(cr.to_radians(a))*b,this.y+=Math.sin(cr.to_radians(a))*b,this.set_bbox_changed())},b.X=function(a){a.set_float(this.x)},b.Y=function(a){a.set_float(this.y)},b.dt=function(a){a.set_float(this.runtime.getDt(this))});e&&(n.CompareWidth=function(a,b){return cr.do_cmp(this.width,a,b)},n.CompareHeight=function(a,b){return cr.do_cmp(this.height,a,b)},l.SetWidth=function(a){this.width!==a&&(this.width=a,this.set_bbox_changed())},l.SetHeight=function(a){this.height!==a&&(this.height=
a,this.set_bbox_changed())},l.SetSize=function(a,b){if(this.width!==a||this.height!==b)this.width=a,this.height=b,this.set_bbox_changed()},b.Width=function(a){a.set_float(this.width)},b.Height=function(a){a.set_float(this.height)},b.BBoxLeft=function(a){this.update_bbox();a.set_float(this.bbox.left)},b.BBoxTop=function(a){this.update_bbox();a.set_float(this.bbox.top)},b.BBoxRight=function(a){this.update_bbox();a.set_float(this.bbox.right)},b.BBoxBottom=function(a){this.update_bbox();a.set_float(this.bbox.bottom)});
h&&(n.AngleWithin=function(a,b){return cr.angleDiff(this.angle,cr.to_radians(b))<=cr.to_radians(a)},n.IsClockwiseFrom=function(a){return cr.angleClockwise(this.angle,cr.to_radians(a))},n.IsBetweenAngles=function(a,b){var c=cr.to_clamped_radians(a),d=cr.to_clamped_radians(b),e=cr.clamp_angle(this.angle);return cr.angleClockwise(d,c)?cr.angleClockwise(e,c)&&!cr.angleClockwise(e,d):!(!cr.angleClockwise(e,c)&&cr.angleClockwise(e,d))},l.SetAngle=function(a){a=cr.to_radians(cr.clamp_angle_degrees(a));isNaN(a)||
this.angle===a||(this.angle=a,this.set_bbox_changed())},l.RotateClockwise=function(a){0===a||isNaN(a)||(this.angle+=cr.to_radians(a),this.angle=cr.clamp_angle(this.angle),this.set_bbox_changed())},l.RotateCounterclockwise=function(a){0===a||isNaN(a)||(this.angle-=cr.to_radians(a),this.angle=cr.clamp_angle(this.angle),this.set_bbox_changed())},l.RotateTowardAngle=function(a,b){var c=cr.angleRotate(this.angle,cr.to_radians(b),cr.to_radians(a));isNaN(c)||this.angle===c||(this.angle=c,this.set_bbox_changed())},
l.RotateTowardPosition=function(a,b,c){b=Math.atan2(c-this.y,b-this.x);a=cr.angleRotate(this.angle,b,cr.to_radians(a));isNaN(a)||this.angle===a||(this.angle=a,this.set_bbox_changed())},l.SetTowardPosition=function(a,b){var c=Math.atan2(b-this.y,a-this.x);isNaN(c)||this.angle===c||(this.angle=c,this.set_bbox_changed())},b.Angle=function(a){a.set_float(cr.to_clamped_degrees(this.angle))});d||(n.CompareInstanceVar=function(a,b,c){return cr.do_cmp(this.instance_vars[a],b,c)},n.IsBoolInstanceVarSet=function(a){return this.instance_vars[a]},
n.PickInstVarHiLow=function(a,b){var c=this.getCurrentSol(),d=c.getObjects();if(!d.length)return!1;var e=d[0],f=e,h=e.instance_vars[b],l,m,n;l=1;for(m=d.length;l<m;l++)if(e=d[l],n=e.instance_vars[b],0===a&&n<h||1===a&&n>h)h=n,f=e;c.pick_one(f);return!0},n.PickByUID=function(a){var b,c,d,e,f;if(this.runtime.getCurrentCondition().inverted){f=this.getCurrentSol();if(f.select_all)for(f.select_all=!1,f.instances.length=0,f.else_instances.length=0,d=this.instances,b=0,c=d.length;b<c;b++)e=d[b],e.uid===
a?f.else_instances.push(e):f.instances.push(e);else{d=b=0;for(c=f.instances.length;b<c;b++)e=f.instances[b],f.instances[d]=e,e.uid===a?f.else_instances.push(e):d++;f.instances.length=d}this.applySolToContainer();return!!f.instances.length}e=this.runtime.getObjectByUID(a);if(!e)return!1;f=this.getCurrentSol();if(!f.select_all&&-1===f.instances.indexOf(e))return!1;if(this.is_family)for(a=e.type.families,b=0,c=a.length;b<c;b++){if(a[b]===this)return f.pick_one(e),this.applySolToContainer(),!0}else if(e.type===
this)return f.pick_one(e),this.applySolToContainer(),!0;return!1},n.OnCreated=function(){return!0},n.OnDestroyed=function(){return!0},l.SetInstanceVar=function(a,b){var c=this.instance_vars;cr.is_number(c[a])?cr.is_number(b)?c[a]=b:c[a]=parseFloat(b):cr.is_string(c[a])&&(cr.is_string(b)?c[a]=b:c[a]=b.toString())},l.AddInstanceVar=function(a,b){var c=this.instance_vars;cr.is_number(c[a])?cr.is_number(b)?c[a]+=b:c[a]+=parseFloat(b):cr.is_string(c[a])&&(cr.is_string(b)?c[a]+=b:c[a]+=b.toString())},l.SubInstanceVar=
function(a,b){var c=this.instance_vars;cr.is_number(c[a])&&(cr.is_number(b)?c[a]-=b:c[a]-=parseFloat(b))},l.SetBoolInstanceVar=function(a,b){this.instance_vars[a]=b?1:0},l.ToggleBoolInstanceVar=function(a){this.instance_vars[a]=1-this.instance_vars[a]},l.Destroy=function(){this.runtime.DestroyInstance(this)},l.LoadFromJsonString||(l.LoadFromJsonString=function(a){var b,c;try{b=JSON.parse(a)}catch(d){return}this.runtime.loadInstanceFromJSON(this,b,!0);this.afterLoad&&this.afterLoad();if(this.behavior_insts)for(a=
0,b=this.behavior_insts.length;a<b;++a)c=this.behavior_insts[a],c.afterLoad&&c.afterLoad()}),b.Count=function(a){var b=a.object_class.instances.length,c,d,e;c=0;for(d=this.runtime.createRow.length;c<d;c++)e=this.runtime.createRow[c],a.object_class.is_family?0<=e.type.families.indexOf(a.object_class)&&b++:e.type===a.object_class&&b++;a.set_int(b)},b.PickedCount=function(a){a.set_int(a.object_class.getCurrentSol().getObjects().length)},b.UID=function(a){a.set_int(this.uid)},b.IID=function(a){a.set_int(this.get_iid())},
b.AsJSON||(b.AsJSON=function(a){a.set_string(JSON.stringify(this.runtime.saveInstanceToJSON(this,!0)))}));p&&(n.IsVisible=function(){return this.visible},l.SetVisible=function(a){!a!==!this.visible&&(this.visible=a,this.runtime.redraw=!0)},n.CompareOpacity=function(a,b){return cr.do_cmp(cr.round6dp(100*this.opacity),a,b)},l.SetOpacity=function(a){a/=100;0>a?a=0:1<a&&(a=1);a!==this.opacity&&(this.opacity=a,this.runtime.redraw=!0)},b.Opacity=function(a){a.set_float(cr.round6dp(100*this.opacity))});
m&&(n.IsOnLayer=function(a){return a?this.layer===a:!1},n.PickTopBottom=function(a){var b=this.getCurrentSol(),c=b.getObjects();if(!c.length)return!1;var d=c[0],e=d,f,h;f=1;for(h=c.length;f<h;f++)if(d=c[f],0===a){if(d.layer.index>e.layer.index||d.layer.index===e.layer.index&&d.get_zindex()>e.get_zindex())e=d}else if(d.layer.index<e.layer.index||d.layer.index===e.layer.index&&d.get_zindex()<e.get_zindex())e=d;b.pick_one(e);return!0},l.MoveToTop=function(){var a=this.get_zindex();a!==this.layer.instances.length-
1&&(cr.arrayRemove(this.layer.instances,a),this.layer.instances.push(this),this.runtime.redraw=!0,this.layer.zindices_stale=!0)},l.MoveToBottom=function(){var a=this.get_zindex();0!==a&&(cr.arrayRemove(this.layer.instances,a),this.layer.instances.unshift(this),this.runtime.redraw=!0,this.layer.zindices_stale=!0)},l.MoveToLayer=function(a){a&&a!=this.layer&&(cr.arrayRemove(this.layer.instances,this.get_zindex()),this.layer.zindices_stale=!0,this.layer=a,this.zindex=a.instances.length,a.instances.push(this),
this.runtime.redraw=!0)},l.ZMoveToObject=function(a,b){var c=0===a;if(b){var d=b.getFirstPicked(this);if(d&&d.uid!==this.uid){this.layer.index!==d.layer.index&&(cr.arrayRemove(this.layer.instances,this.get_zindex()),this.layer.zindices_stale=!0,this.layer=d.layer,this.zindex=d.layer.instances.length,d.layer.instances.push(this));var e=this.get_zindex(),d=d.get_zindex();cr.arrayRemove(this.layer.instances,e);e<d&&d--;c&&d++;d===this.layer.instances.length?this.layer.instances.push(this):this.layer.instances.splice(d,
0,this);this.layer.zindices_stale=!0;this.runtime.redraw=!0}}},b.LayerNumber=function(a){a.set_int(this.layer.number)},b.LayerName=function(a){a.set_string(this.layer.name)},b.ZIndex=function(a){a.set_int(this.get_zindex())});a&&(l.SetEffectEnabled=function(a,b){if(this.runtime.glwrap){var c=this.type.getEffectIndexByName(b);if(!(0>c)){var d=1===a;this.active_effect_flags[c]!==d&&(this.active_effect_flags[c]=d,this.updateActiveEffects(),this.runtime.redraw=!0)}}},l.SetEffectParam=function(a,b,c){if(this.runtime.glwrap){var d=
this.type.getEffectIndexByName(a);0>d||(a=this.type.effect_types[d],d=this.effect_params[d],b=Math.floor(b),0>b||b>=d.length||(1===this.runtime.glwrap.getProgramParameterType(a.shaderindex,b)&&(c/=100),d[b]!==c&&(d[b]=c,a.active&&(this.runtime.redraw=!0))))}})};cr.set_bbox_changed=function(){this.cell_changed=this.bbox_changed=!0;this.type.any_cell_changed=!0;this.runtime.redraw=!0;var a,b,d=this.bbox_changed_callbacks;a=0;for(b=d.length;a<b;++a)d[a](this)};cr.add_bbox_changed_callback=function(a){a&&
this.bbox_changed_callbacks.push(a)};cr.update_bbox=function(){if(this.bbox_changed){var a=this.bbox,b=this.bquad;a.set(this.x,this.y,this.x+this.width,this.y+this.height);a.offset(-this.hotspotX*this.width,-this.hotspotY*this.height);this.angle?(a.offset(-this.x,-this.y),b.set_from_rotated_rect(a,this.angle),b.offset(this.x,this.y),b.bounding_box(a)):b.set_from_rect(a);a.normalize();this.bbox_changed=!1}};var a=new cr.rect(0,0,0,0);cr.update_collision_cell=function(){if(this.cell_changed&&this.collisionsEnabled){this.update_bbox();
var c=this.type.collision_grid,b=this.collcells,d=this.bbox;a.set(c.XToCell(d.left),c.YToCell(d.top),c.XToCell(d.right),c.YToCell(d.bottom));b.equals(a)||(b.right<b.left?c.update(this,null,a):c.update(this,b,a),b.copy(a),this.cell_changed=!1)}};cr.inst_contains_pt=function(a,b){return this.bbox.contains_pt(a,b)&&this.bquad.contains_pt(a,b)?this.collision_poly&&!this.collision_poly.is_empty()?(this.collision_poly.cache_poly(this.width,this.height,this.angle),this.collision_poly.contains_pt(a-this.x,
b-this.y)):!0:!1};cr.inst_get_iid=function(){this.type.updateIIDs();return this.iid};cr.inst_get_zindex=function(){this.layer.updateZIndices();return this.zindex};cr.inst_updateActiveEffects=function(){this.active_effect_types.length=0;var a,b;a=0;for(b=this.active_effect_flags.length;a<b;a++)this.active_effect_flags[a]&&this.active_effect_types.push(this.type.effect_types[a]);this.uses_shaders=!!this.active_effect_types.length};cr.inst_toString=function(){return"Inst"+this.puid};cr.type_getFirstPicked=
function(a){if(a&&a.is_contained&&a.type!=this){var b,d,f;b=0;for(d=a.siblings.length;b<d;b++)if(f=a.siblings[b],f.type==this)return f}a=this.getCurrentSol().getObjects();return a.length?a[0]:null};cr.type_getPairedInstance=function(a){var b=this.getCurrentSol().getObjects();return b.length?b[a.get_iid()%b.length]:null};cr.type_updateIIDs=function(){if(this.stale_iids&&!this.is_family){var a,b;a=0;for(b=this.instances.length;a<b;a++)this.instances[a].iid=a;var d=a,f=this.runtime.createRow;a=0;for(b=
f.length;a<b;++a)f[a].type===this&&(f[a].iid=d++);this.stale_iids=!1}};cr.type_getInstanceByIID=function(a){if(a<this.instances.length)return this.instances[a];a-=this.instances.length;var b=this.runtime.createRow,d,f;d=0;for(f=b.length;d<f;++d)if(b[d].type===this){if(0===a)return b[d];--a}return null};cr.type_getCurrentSol=function(){return this.solstack[this.cur_sol]};cr.type_pushCleanSol=function(){this.cur_sol++;this.cur_sol===this.solstack.length?this.solstack.push(new cr.selection(this)):this.solstack[this.cur_sol].select_all=
!0};cr.type_pushCopySol=function(){this.cur_sol++;this.cur_sol===this.solstack.length&&this.solstack.push(new cr.selection(this));var a=this.solstack[this.cur_sol],b=this.solstack[this.cur_sol-1];b.select_all?a.select_all=!0:(a.select_all=!1,cr.shallowAssignArray(a.instances,b.instances),cr.shallowAssignArray(a.else_instances,b.else_instances))};cr.type_popSol=function(){this.cur_sol--};cr.type_getBehaviorByName=function(a){var b,d,f,e,h,p=0;if(!this.is_family)for(b=0,d=this.families.length;b<d;b++)for(h=
this.families[b],f=0,e=h.behaviors.length;f<e;f++){if(a===h.behaviors[f].name)return this.extra.lastBehIndex=p,h.behaviors[f];p++}b=0;for(d=this.behaviors.length;b<d;b++){if(a===this.behaviors[b].name)return this.extra.lastBehIndex=p,this.behaviors[b];p++}return null};cr.type_getBehaviorIndexByName=function(a){return this.getBehaviorByName(a)?this.extra.lastBehIndex:-1};cr.type_getEffectIndexByName=function(a){var b,d;b=0;for(d=this.effect_types.length;b<d;b++)if(this.effect_types[b].name===a)return b;
return-1};cr.type_applySolToContainer=function(){if(this.is_contained&&!this.is_family){var a,b,d,f,e,h,p;this.updateIIDs();h=this.getCurrentSol();var m=h.select_all,n=(a=this.runtime.getCurrentEventStack())&&a.current_event&&a.current_event.orblock;a=0;for(b=this.container.length;a<b;a++)if(e=this.container[a],e!==this&&(e.updateIIDs(),p=e.getCurrentSol(),p.select_all=m,!m)){p.instances.length=h.instances.length;d=0;for(f=h.instances.length;d<f;d++)p.instances[d]=e.getInstanceByIID(h.instances[d].iid);
if(n)for(p.else_instances.length=h.else_instances.length,d=0,f=h.else_instances.length;d<f;d++)p.else_instances[d]=e.getInstanceByIID(h.else_instances[d].iid)}}};cr.type_toString=function(){return"Type"+this.sid};cr.do_cmp=function(a,b,d){if("undefined"===typeof a||"undefined"===typeof d)return!1;switch(b){case 0:return a===d;case 1:return a!==d;case 2:return a<d;case 3:return a<=d;case 4:return a>d;case 5:return a>=d;default:return!1}}})();cr.shaders={};
cr.plugins_.Audio=function(a){this.runtime=a};
(function(){function a(a){a=Math.pow(10,a/20);0>a&&(a=0);1<a&&(a=1);return a}function c(a){0>a&&(a=0);1<a&&(a=1);return 20*(Math.log(a)/Math.log(10))}function b(a){a=a.toLowerCase();return R.hasOwnProperty(a)&&R[a].length?R[a][0].getInputNode():F.destination}function d(){return F.createGain?F.createGain():F.createGainNode()}function f(a){return F.createDelay?F.createDelay(a):F.createDelayNode(a)}function e(a){a.start?a.start(0):a.noteOn(0)}function h(a,b,c){a.start?a.start(0,b):a.noteGrainOn(0,b,
c-b)}function p(a){try{a.stop?a.stop(0):a.noteOff(0)}catch(b){}}function m(a,b,c,d){if(a)if(a.cancelScheduledValues(0),0===d)a.value=b;else{var g=F.currentTime;d+=g;switch(c){case 0:a.setValueAtTime(b,d);break;case 1:a.setValueAtTime(a.value,g);a.linearRampToValueAtTime(b,d);break;case 2:a.setValueAtTime(a.value,g),a.exponentialRampToValueAtTime(b,d)}}}function n(a,b,c,g,e,f){this.type="filter";this.params=[a,b,c,g,e,f];this.inputNode=d();this.wetNode=d();this.wetNode.gain.value=f;this.dryNode=d();
this.dryNode.gain.value=1-f;this.filterNode=F.createBiquadFilter();this.filterNode.type="number"===typeof this.filterNode.type?a:na[a];this.filterNode.frequency.value=b;this.filterNode.detune&&(this.filterNode.detune.value=c);this.filterNode.Q.value=g;this.filterNode.gain.value=e;this.inputNode.connect(this.filterNode);this.inputNode.connect(this.dryNode);this.filterNode.connect(this.wetNode)}function l(a,b,c){this.type="delay";this.params=[a,b,c];this.inputNode=d();this.wetNode=d();this.wetNode.gain.value=
c;this.dryNode=d();this.dryNode.gain.value=1-c;this.mainNode=d();this.delayNode=f(a);this.delayNode.delayTime.value=a;this.delayGainNode=d();this.delayGainNode.gain.value=b;this.inputNode.connect(this.mainNode);this.inputNode.connect(this.dryNode);this.mainNode.connect(this.wetNode);this.mainNode.connect(this.delayNode);this.delayNode.connect(this.delayGainNode);this.delayGainNode.connect(this.mainNode)}function q(a,b,c,g){this.type="convolve";this.params=[b,c,g];this.inputNode=d();this.wetNode=d();
this.wetNode.gain.value=c;this.dryNode=d();this.dryNode.gain.value=1-c;this.convolveNode=F.createConvolver();a&&(this.convolveNode.normalize=b,this.convolveNode.buffer=a);this.inputNode.connect(this.convolveNode);this.inputNode.connect(this.dryNode);this.convolveNode.connect(this.wetNode)}function u(a,b,c,g,k){this.type="flanger";this.params=[a,b,c,g,k];this.inputNode=d();this.dryNode=d();this.dryNode.gain.value=1-k/2;this.wetNode=d();this.wetNode.gain.value=k/2;this.feedbackNode=d();this.feedbackNode.gain.value=
g;this.delayNode=f(a+b);this.delayNode.delayTime.value=a;this.oscNode=F.createOscillator();this.oscNode.frequency.value=c;this.oscGainNode=d();this.oscGainNode.gain.value=b;this.inputNode.connect(this.delayNode);this.inputNode.connect(this.dryNode);this.delayNode.connect(this.wetNode);this.delayNode.connect(this.feedbackNode);this.feedbackNode.connect(this.delayNode);this.oscNode.connect(this.oscGainNode);this.oscGainNode.connect(this.delayNode.delayTime);e(this.oscNode)}function r(a,b,c,g,f,k){this.type=
"phaser";this.params=[a,b,c,g,f,k];this.inputNode=d();this.dryNode=d();this.dryNode.gain.value=1-k/2;this.wetNode=d();this.wetNode.gain.value=k/2;this.filterNode=F.createBiquadFilter();this.filterNode.type="number"===typeof this.filterNode.type?7:"allpass";this.filterNode.frequency.value=a;this.filterNode.detune&&(this.filterNode.detune.value=b);this.filterNode.Q.value=c;this.oscNode=F.createOscillator();this.oscNode.frequency.value=f;this.oscGainNode=d();this.oscGainNode.gain.value=g;this.inputNode.connect(this.filterNode);
this.inputNode.connect(this.dryNode);this.filterNode.connect(this.wetNode);this.oscNode.connect(this.oscGainNode);this.oscGainNode.connect(this.filterNode.frequency);e(this.oscNode)}function t(a){this.type="gain";this.params=[a];this.node=d();this.node.gain.value=a}function x(a,b){this.type="tremolo";this.params=[a,b];this.node=d();this.node.gain.value=1-b/2;this.oscNode=F.createOscillator();this.oscNode.frequency.value=a;this.oscGainNode=d();this.oscGainNode.gain.value=b/2;this.oscNode.connect(this.oscGainNode);
this.oscGainNode.connect(this.node.gain);e(this.oscNode)}function s(a,b){this.type="ringmod";this.params=[a,b];this.inputNode=d();this.wetNode=d();this.wetNode.gain.value=b;this.dryNode=d();this.dryNode.gain.value=1-b;this.ringNode=d();this.ringNode.gain.value=0;this.oscNode=F.createOscillator();this.oscNode.frequency.value=a;this.oscNode.connect(this.ringNode.gain);e(this.oscNode);this.inputNode.connect(this.ringNode);this.inputNode.connect(this.dryNode);this.ringNode.connect(this.wetNode)}function w(a,
b,c,g,e){this.type="distortion";this.params=[a,b,c,g,e];this.inputNode=d();this.preGain=d();this.postGain=d();this.setDrive(c,Math.pow(10,g/20));this.wetNode=d();this.wetNode.gain.value=e;this.dryNode=d();this.dryNode.gain.value=1-e;this.waveShaper=F.createWaveShaper();this.curve=new Float32Array(65536);this.generateColortouchCurve(a,b);this.waveShaper.curve=this.curve;this.inputNode.connect(this.preGain);this.inputNode.connect(this.dryNode);this.preGain.connect(this.waveShaper);this.waveShaper.connect(this.postGain);
this.postGain.connect(this.wetNode)}function v(a,b,c,d,g){this.type="compressor";this.params=[a,b,c,d,g];this.node=F.createDynamicsCompressor();try{this.node.threshold.value=a,this.node.knee.value=b,this.node.ratio.value=c,this.node.attack.value=d,this.node.release.value=g}catch(e){}}function A(a,b){this.type="analyser";this.params=[a,b];this.node=F.createAnalyser();this.node.fftSize=a;this.node.smoothingTimeConstant=b;this.freqBins=new Float32Array(this.node.frequencyBinCount);this.signal=new Uint8Array(a);
this.rms=this.peak=0}function y(){this.obj=null;this.loadUid=0;this.speeds=[];this.moveAngle=this.lastY=this.lastX=0}function g(a,b){this.src=a;this.myapi=M;this.is_music=b;this.added_end_listener=!1;var c=this;this.mediaSourceNode=this.outNode=null;this.panWhenReady=[];this.seekWhenReady=0;this.failedToLoad=this.supportWebAudioAPI=this.pauseWhenReady=!1;M===B&&b&&(this.myapi=J,this.outNode=d());this.audioData=this.bufferObject=null;var g;switch(this.myapi){case J:this.bufferObject=new Audio;M!==
B||!F.createMediaElementSource||L.isFirefox||/wiiu/i.test(navigator.userAgent)||(this.supportWebAudioAPI=!0,this.bufferObject.addEventListener("canplay",function(){c.mediaSourceNode||(c.mediaSourceNode=F.createMediaElementSource(c.bufferObject),c.mediaSourceNode.connect(c.outNode))}));this.bufferObject.autoplay=!1;this.bufferObject.preload="auto";this.bufferObject.src=a;break;case B:g=new XMLHttpRequest;g.open("GET",a,!0);g.responseType="arraybuffer";g.onload=function(){c.audioData=g.response;c.decodeAudioBuffer()};
g.onerror=function(){c.failedToLoad=!0};g.send();break;case W:this.bufferObject=!0;break;case X:this.bufferObject=!0}}function k(a,c){var g=this;this.tag=c;this.stopped=this.fresh=!0;this.src=a.src;this.buffer=a;this.myapi=M;this.is_music=a.is_music;this.playbackRate=1;this.pgended=!0;this.is_paused=this.resume_me=!1;this.resume_position=0;this.is_silent=this.is_muted=this.looping=!1;this.mutevol=this.volume=1;this.startTime=L.kahanTime.sum;this.pannerNode=this.gainNode=null;this.pannerEnabled=!1;
this.objectTracker=null;this.panConeOuterGain=this.panConeOuter=this.panConeInner=this.panAngle=this.panY=this.panX=0;this.instanceObject=null;var e=!1;this.myapi!==B||this.buffer.myapi!==J||this.buffer.supportWebAudioAPI||(this.myapi=J);switch(this.myapi){case J:this.is_music?(this.instanceObject=a.bufferObject,e=!a.added_end_listener,a.added_end_listener=!0):(this.instanceObject=new Audio,this.instanceObject.autoplay=!1,this.instanceObject.src=a.bufferObject.src,e=!0);e&&this.instanceObject.addEventListener("ended",
function(){T=g.tag;g.stopped=!0;L.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded,P)});break;case B:this.gainNode=d();this.gainNode.connect(b(c));this.buffer.myapi===B?a.bufferObject&&(this.instanceObject=F.createBufferSource(),this.instanceObject.buffer=a.bufferObject,this.instanceObject.connect(this.gainNode)):(this.instanceObject=this.buffer.bufferObject,this.buffer.outNode.connect(this.gainNode));break;case W:this.instanceObject=new window.Media(U+this.src,null,null,function(a){a===window.Media.MEDIA_STOPPED&&
(g.pgended=!0,g.stopped=!0,T=g.tag,L.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded,P))});break;case X:this.instanceObject=!0}}function C(a,b){var c=a.isPlaying()?1:0,d=b.isPlaying()?1:0;return c===d?0:c<d?1:-1}function z(a,b){Q.length=0;if(a.length){var c,d,g;c=0;for(d=O.length;c<d;c++)g=O[c],cr.equals_nocase(a,g.tag)&&Q.push(g);b&&Q.sort(C)}else S&&!S.hasEnded()&&(Q.length=1,Q[0]=S)}function G(a){var b,c,d,g,e=F.destination;if(R.hasOwnProperty(a)&&(d=R[a],d.length))for(e=d[0].getInputNode(),b=
0,c=d.length;b<c;b++)g=d[b],b+1===c?g.connectTo(F.destination):g.connectTo(d[b+1].getInputNode());z(a);b=0;for(c=Q.length;b<c;b++)Q[b].reconnect(e);da&&ka===a&&(da.disconnect(),da.connect(e))}function D(a,b){R.hasOwnProperty(a)?R[a].push(b):R[a]=[b];G(a)}function H(){}function E(){}function I(){}function K(a,b){var c=null;R.hasOwnProperty(a)&&(c=R[a]);return c&&0<=b&&b<c.length&&c[b].freqBins?c[b]:null}var N=cr.plugins_.Audio.prototype;N.Type=function(a){this.plugin=a;this.runtime=a.runtime};N.Type.prototype.onCreate=
function(){};var L=null,P=null,T="",U="",J=0,B=1,W=2,X=3,M=J,F=null,ea=[],O=[],S=null,Y=!1,ja=0,V=!1,Z=1,ba=0,ca=0,la=1,ma=1,oa=10,pa=1E4,qa=1,da=null,ka="",fa=!1,ga=[],R={},na="lowpass highpass bandpass lowshelf highshelf peaking notch allpass".split(" ");n.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};n.prototype.remove=function(){this.inputNode.disconnect();this.filterNode.disconnect();this.wetNode.disconnect();
this.dryNode.disconnect()};n.prototype.getInputNode=function(){return this.inputNode};n.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[5]=b;m(this.wetNode.gain,b,c,d);m(this.dryNode.gain,1-b,c,d);break;case 1:this.params[1]=b;m(this.filterNode.frequency,b,c,d);break;case 2:this.params[2]=b;m(this.filterNode.detune,b,c,d);break;case 3:this.params[3]=b;m(this.filterNode.Q,b,c,d);break;case 4:this.params[4]=b,m(this.filterNode.gain,b,c,d)}};l.prototype.connectTo=
function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};l.prototype.remove=function(){this.inputNode.disconnect();this.mainNode.disconnect();this.delayNode.disconnect();this.delayGainNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};l.prototype.getInputNode=function(){return this.inputNode};l.prototype.setParam=function(b,c,d,g){switch(b){case 0:c/=100;0>c&&(c=0);1<c&&(c=1);this.params[2]=c;m(this.wetNode.gain,c,d,g);m(this.dryNode.gain,
1-c,d,g);break;case 4:this.params[1]=a(c);m(this.delayGainNode.gain,a(c),d,g);break;case 5:this.params[0]=c,m(this.delayNode.delayTime,c,d,g)}};q.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};q.prototype.remove=function(){this.inputNode.disconnect();this.convolveNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};q.prototype.getInputNode=function(){return this.inputNode};q.prototype.setParam=
function(a,b,c,d){switch(a){case 0:b/=100,0>b&&(b=0),1<b&&(b=1),this.params[1]=b,m(this.wetNode.gain,b,c,d),m(this.dryNode.gain,1-b,c,d)}};u.prototype.connectTo=function(a){this.dryNode.disconnect();this.dryNode.connect(a);this.wetNode.disconnect();this.wetNode.connect(a)};u.prototype.remove=function(){this.inputNode.disconnect();this.delayNode.disconnect();this.oscNode.disconnect();this.oscGainNode.disconnect();this.dryNode.disconnect();this.wetNode.disconnect();this.feedbackNode.disconnect()};u.prototype.getInputNode=
function(){return this.inputNode};u.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[4]=b;m(this.wetNode.gain,b/2,c,d);m(this.dryNode.gain,1-b/2,c,d);break;case 6:this.params[1]=b/1E3;m(this.oscGainNode.gain,b/1E3,c,d);break;case 7:this.params[2]=b;m(this.oscNode.frequency,b,c,d);break;case 8:this.params[3]=b/100,m(this.feedbackNode.gain,b/100,c,d)}};r.prototype.connectTo=function(a){this.dryNode.disconnect();this.dryNode.connect(a);this.wetNode.disconnect();
this.wetNode.connect(a)};r.prototype.remove=function(){this.inputNode.disconnect();this.filterNode.disconnect();this.oscNode.disconnect();this.oscGainNode.disconnect();this.dryNode.disconnect();this.wetNode.disconnect()};r.prototype.getInputNode=function(){return this.inputNode};r.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[5]=b;m(this.wetNode.gain,b/2,c,d);m(this.dryNode.gain,1-b/2,c,d);break;case 1:this.params[0]=b;m(this.filterNode.frequency,b,
c,d);break;case 2:this.params[1]=b;m(this.filterNode.detune,b,c,d);break;case 3:this.params[2]=b;m(this.filterNode.Q,b,c,d);break;case 6:this.params[3]=b;m(this.oscGainNode.gain,b,c,d);break;case 7:this.params[4]=b,m(this.oscNode.frequency,b,c,d)}};t.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};t.prototype.remove=function(){this.node.disconnect()};t.prototype.getInputNode=function(){return this.node};t.prototype.setParam=function(b,c,d,g){switch(b){case 4:this.params[0]=
a(c),m(this.node.gain,a(c),d,g)}};x.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};x.prototype.remove=function(){this.oscNode.disconnect();this.oscGainNode.disconnect();this.node.disconnect()};x.prototype.getInputNode=function(){return this.node};x.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[1]=b;m(this.node.gain.value,1-b/2,c,d);m(this.oscGainNode.gain.value,b/2,c,d);break;case 7:this.params[0]=b,m(this.oscNode.frequency,
b,c,d)}};s.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};s.prototype.remove=function(){this.oscNode.disconnect();this.ringNode.disconnect();this.inputNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};s.prototype.getInputNode=function(){return this.inputNode};s.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[1]=b;m(this.wetNode.gain,b,c,d);m(this.dryNode.gain,
1-b,c,d);break;case 7:this.params[0]=b,m(this.oscNode.frequency,b,c,d)}};w.prototype.setDrive=function(a,b){0.01>a&&(a=0.01);this.preGain.gain.value=a;this.postGain.gain.value=Math.pow(1/a,0.6)*b};w.prototype.shape=function(a,b,c){var d=1.05*c*b-b;c=0>a?-1:1;a=0>a?-a:a;b=a<b?a:b+d*(1-Math.exp(-(1/d)*(a-b)));return b*c};w.prototype.generateColortouchCurve=function(a,b){for(var c=Math.pow(10,a/20),d=Math.pow(10,b/20),g=0,e=0;32768>e;++e)g=e/32768,g=this.shape(g,c,d),this.curve[32768+e]=g,this.curve[32768-
e-1]=-g};w.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};w.prototype.remove=function(){this.inputNode.disconnect();this.preGain.disconnect();this.waveShaper.disconnect();this.postGain.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};w.prototype.getInputNode=function(){return this.inputNode};w.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100,0>b&&(b=0),1<b&&(b=1),this.params[4]=b,m(this.wetNode.gain,
b,c,d),m(this.dryNode.gain,1-b,c,d)}};v.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};v.prototype.remove=function(){this.node.disconnect()};v.prototype.getInputNode=function(){return this.node};v.prototype.setParam=function(a,b,c,d){};A.prototype.tick=function(){this.node.getFloatFrequencyData(this.freqBins);this.node.getByteTimeDomainData(this.signal);for(var a=this.node.fftSize,b=0,d=this.peak=0,g=0;b<a;b++)g=(this.signal[b]-128)/128,0>g&&(g=-g),this.peak<g&&(this.peak=
g),d+=g*g;this.peak=c(this.peak);this.rms=c(Math.sqrt(d/a))};A.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};A.prototype.remove=function(){this.node.disconnect()};A.prototype.getInputNode=function(){return this.node};A.prototype.setParam=function(a,b,c,d){};y.prototype.setObject=function(a){if(this.obj=a)this.lastX=this.obj.x,this.lastY=this.obj.y;this.speeds.length=0};y.prototype.hasObject=function(){return!!this.obj};y.prototype.tick=function(a){this.obj&&0!==a&&(this.moveAngle=
cr.angleTo(this.lastX,this.lastY,this.obj.x,this.obj.y),a=cr.distanceTo(this.lastX,this.lastY,this.obj.x,this.obj.y)/a,4>this.speeds.length||this.speeds.shift(),this.speeds.push(a),this.lastX=this.obj.x,this.lastY=this.obj.y)};y.prototype.getSpeed=function(){if(!this.speeds.length)return 0;var a,b,c=0;a=0;for(b=this.speeds.length;a<b;a++)c+=this.speeds[a];return c/this.speeds.length};y.prototype.getVelocityX=function(){return Math.cos(this.moveAngle)*this.getSpeed()};y.prototype.getVelocityY=function(){return Math.sin(this.moveAngle)*
this.getSpeed()};var ra=!1;g.prototype.decodeAudioBuffer=function(){if(!this.bufferObject&&this.audioData){var a=this;if(F.decodeAudioData)F.decodeAudioData(this.audioData,function(b){a.bufferObject=b;var c,d,g;if(cr.is_undefined(a.playTagWhenReady)||V)cr.is_undefined(a.convolveWhenReady)||(c=a.convolveWhenReady.convolveNode,c.normalize=a.normalizeWhenReady,c.buffer=b);else if(a.panWhenReady.length){c=0;for(d=a.panWhenReady.length;c<d;c++){b=a.panWhenReady[c];g=new k(a,b.thistag);g.setPannerEnabled(!0);
if("undefined"!==typeof b.objUid&&(b.obj=L.getObjectByUID(b.objUid),!b.obj))continue;if(b.obj){var e=cr.rotatePtAround(b.obj.x,b.obj.y,-b.obj.layer.getAngle(),ba,ca,!0),f=cr.rotatePtAround(b.obj.x,b.obj.y,-b.obj.layer.getAngle(),ba,ca,!1);g.setPan(e,f,cr.to_degrees(b.obj.angle-b.obj.layer.getAngle()),b.ia,b.oa,b.og);g.setObject(b.obj)}else g.setPan(b.x,b.y,b.a,b.ia,b.oa,b.og);g.play(a.loopWhenReady,a.volumeWhenReady,a.seekWhenReady);a.pauseWhenReady&&g.pause();O.push(g)}a.panWhenReady.length=0}else g=
new k(a,a.playTagWhenReady),g.play(a.loopWhenReady,a.volumeWhenReady,a.seekWhenReady),a.pauseWhenReady&&g.pause(),O.push(g)},function(b){a.failedToLoad=!0});else if(this.bufferObject=F.createBuffer(this.audioData,!1),cr.is_undefined(this.playTagWhenReady)||V)cr.is_undefined(this.convolveWhenReady)||(b=this.convolveWhenReady.convolveNode,b.normalize=this.normalizeWhenReady,b.buffer=this.bufferObject);else{var b=new k(this,this.playTagWhenReady);b.play(this.loopWhenReady,this.volumeWhenReady,this.seekWhenReady);
this.pauseWhenReady&&b.pause();O.push(b)}}};g.prototype.isLoaded=function(){switch(this.myapi){case J:return 4<=this.bufferObject.readyState;case B:return!!this.audioData;case W:return!0;case X:return!0}return!1};g.prototype.isLoadedAndDecoded=function(){switch(this.myapi){case J:return 4<=this.bufferObject.readyState;case B:return!!this.audioData&&!!this.bufferObject;case W:return!0;case X:return!0}return!1};g.prototype.hasFailedToLoad=function(){switch(this.myapi){case J:return!!this.bufferObject.error;
case B:return this.failedToLoad}return!1};k.prototype.hasEnded=function(){switch(this.myapi){case J:return this.instanceObject.ended;case B:return this.buffer.myapi===B?!this.fresh&&!this.stopped&&this.instanceObject.loop||this.is_paused?!1:L.kahanTime.sum-this.startTime>this.buffer.bufferObject.duration:this.instanceObject.ended;case W:return this.pgended;case X:!0}return!0};k.prototype.canBeRecycled=function(){return this.fresh||this.stopped?!0:this.hasEnded()};k.prototype.setPannerEnabled=function(a){M===
B&&(!this.pannerEnabled&&a?this.gainNode&&(this.pannerNode||(this.pannerNode=F.createPanner(),this.pannerNode.panningModel="number"===typeof this.pannerNode.panningModel?la:["equalpower","HRTF","soundfield"][la],this.pannerNode.distanceModel="number"===typeof this.pannerNode.distanceModel?ma:["linear","inverse","exponential"][ma],this.pannerNode.refDistance=oa,this.pannerNode.maxDistance=pa,this.pannerNode.rolloffFactor=qa),this.gainNode.disconnect(),this.gainNode.connect(this.pannerNode),this.pannerNode.connect(b(this.tag)),
this.pannerEnabled=!0):this.pannerEnabled&&!a&&this.gainNode&&(this.pannerNode.disconnect(),this.gainNode.disconnect(),this.gainNode.connect(b(this.tag)),this.pannerEnabled=!1))};k.prototype.setPan=function(a,b,c,d,g,e){this.pannerEnabled&&M===B&&(this.pannerNode.setPosition(a,b,0),this.pannerNode.setOrientation(Math.cos(cr.to_radians(c)),Math.sin(cr.to_radians(c)),0),this.pannerNode.coneInnerAngle=d,this.pannerNode.coneOuterAngle=g,this.pannerNode.coneOuterGain=e,this.panX=a,this.panY=b,this.panAngle=
c,this.panConeInner=d,this.panConeOuter=g,this.panConeOuterGain=e)};k.prototype.setObject=function(a){this.pannerEnabled&&M===B&&(this.objectTracker||(this.objectTracker=new y),this.objectTracker.setObject(a))};k.prototype.tick=function(a){if(this.pannerEnabled&&M===B&&this.objectTracker&&this.objectTracker.hasObject()&&this.isPlaying()){this.objectTracker.tick(a);a=this.objectTracker.obj;var b=cr.rotatePtAround(a.x,a.y,-a.layer.getAngle(),ba,ca,!0),c=cr.rotatePtAround(a.x,a.y,-a.layer.getAngle(),
ba,ca,!1);this.pannerNode.setPosition(b,c,0);b=0;"undefined"!==typeof this.objectTracker.obj.angle&&(b=a.angle-a.layer.getAngle(),this.pannerNode.setOrientation(Math.cos(b),Math.sin(b),0));b=cr.rotatePtAround(this.objectTracker.getVelocityX(),this.objectTracker.getVelocityY(),-a.layer.getAngle(),0,0,!0);c=cr.rotatePtAround(this.objectTracker.getVelocityX(),this.objectTracker.getVelocityY(),-a.layer.getAngle(),0,0,!1);this.pannerNode.setVelocity(b,c,0)}};k.prototype.play=function(a,b,c){var d=this.instanceObject;
this.looping=a;this.volume=b;c=c||0;switch(this.myapi){case J:1!==d.playbackRate&&(d.playbackRate=1);d.volume!==b*Z&&(d.volume=b*Z);d.loop!==a&&(d.loop=a);d.muted&&(d.muted=!1);if(d.currentTime!==c)try{d.currentTime=c}catch(g){}if(this.is_music&&fa&&!L.isInUserInputEvent)ga.push(this);else try{this.instanceObject.play()}catch(f){}break;case B:this.muted=!1;this.mutevol=1;if(this.buffer.myapi===B)this.fresh||(this.instanceObject=F.createBufferSource(),this.instanceObject.buffer=this.buffer.bufferObject,
this.instanceObject.connect(this.gainNode)),this.instanceObject.loop=a,this.gainNode.gain.value=b*Z,0===c?e(this.instanceObject):h(this.instanceObject,c,this.getDuration());else{1!==d.playbackRate&&(d.playbackRate=1);d.loop!==a&&(d.loop=a);this.gainNode.gain.value=b*Z;if(d.currentTime!==c)try{d.currentTime=c}catch(k){}this.is_music&&fa&&!L.isInUserInputEvent?ga.push(this):d.play()}break;case W:(!this.fresh&&this.stopped||0!==c)&&d.seekTo(c);d.play();this.pgended=!1;break;case X:L.isDirectCanvas?AppMobi.context.playSound(this.src,
a):AppMobi.player.playSound(this.src,a)}this.playbackRate=1;this.startTime=L.kahanTime.sum-c;this.is_paused=this.stopped=this.fresh=!1};k.prototype.stop=function(){switch(this.myapi){case J:this.instanceObject.paused||this.instanceObject.pause();break;case B:this.buffer.myapi===B?p(this.instanceObject):this.instanceObject.paused||this.instanceObject.pause();break;case W:this.instanceObject.stop();break;case X:L.isDirectCanvas&&AppMobi.context.stopSound(this.src)}this.stopped=!0;this.is_paused=!1};
k.prototype.pause=function(){if(!(this.fresh||this.stopped||this.hasEnded()||this.is_paused)){switch(this.myapi){case J:this.instanceObject.paused||this.instanceObject.pause();break;case B:this.buffer.myapi===B?(this.resume_position=this.getPlaybackTime(),this.looping&&(this.resume_position%=this.getDuration()),p(this.instanceObject)):this.instanceObject.paused||this.instanceObject.pause();break;case W:this.instanceObject.pause();break;case X:L.isDirectCanvas&&AppMobi.context.stopSound(this.src)}this.is_paused=
!0}};k.prototype.resume=function(){if(!this.fresh&&!this.stopped&&!this.hasEnded()&&this.is_paused){switch(this.myapi){case J:this.instanceObject.play();break;case B:this.buffer.myapi===B?(this.instanceObject=F.createBufferSource(),this.instanceObject.buffer=this.buffer.bufferObject,this.instanceObject.connect(this.gainNode),this.instanceObject.loop=this.looping,this.gainNode.gain.value=Z*this.volume*this.mutevol,this.startTime=L.kahanTime.sum-this.resume_position,h(this.instanceObject,this.resume_position,
this.getDuration())):this.instanceObject.play();break;case W:this.instanceObject.play();break;case X:L.isDirectCanvas&&AppMobi.context.resumeSound(this.src)}this.is_paused=!1}};k.prototype.seek=function(a){if(!(this.fresh||this.stopped||this.hasEnded()))switch(this.myapi){case J:try{this.instanceObject.currentTime=a}catch(b){}break;case B:if(this.buffer.myapi===B)this.is_paused?this.resume_position=a:(this.pause(),this.resume_position=a,this.resume());else try{this.instanceObject.currentTime=a}catch(c){}break;
case X:L.isDirectCanvas&&AppMobi.context.seekSound(this.src,a)}};k.prototype.reconnect=function(a){this.myapi===B&&(this.pannerEnabled?(this.pannerNode.disconnect(),this.pannerNode.connect(a)):(this.gainNode.disconnect(),this.gainNode.connect(a)))};k.prototype.getDuration=function(){switch(this.myapi){case J:if("undefined"!==typeof this.instanceObject.duration)return this.instanceObject.duration;break;case B:return this.buffer.bufferObject.duration;case W:return this.instanceObject.getDuration();
case X:if(L.isDirectCanvas)return AppMobi.context.getDurationSound(this.src)}return 0};k.prototype.getPlaybackTime=function(){var a=this.getDuration(),b=0;switch(this.myapi){case J:"undefined"!==typeof this.instanceObject.currentTime&&(b=this.instanceObject.currentTime);break;case B:if(this.buffer.myapi===B){if(this.is_paused)return this.resume_position;b=L.kahanTime.sum-this.startTime}else"undefined"!==typeof this.instanceObject.currentTime&&(b=this.instanceObject.currentTime);break;case X:L.isDirectCanvas&&
(b=AppMobi.context.getPlaybackTimeSound(this.src))}!this.looping&&b>a&&(b=a);return b};k.prototype.isPlaying=function(){return!this.is_paused&&!this.fresh&&!this.stopped&&!this.hasEnded()};k.prototype.setVolume=function(a){this.volume=a;this.updateVolume()};k.prototype.updateVolume=function(){var a=this.volume*Z;switch(this.myapi){case J:this.instanceObject.volume&&this.instanceObject.volume!==a&&(this.instanceObject.volume=a);break;case B:this.gainNode.gain.value=a*this.mutevol}};k.prototype.getVolume=
function(){return this.volume};k.prototype.doSetMuted=function(a){switch(this.myapi){case J:this.instanceObject.muted!==!!a&&(this.instanceObject.muted=!!a);break;case B:this.mutevol=a?0:1,this.gainNode.gain.value=Z*this.volume*this.mutevol}};k.prototype.setMuted=function(a){this.is_muted=!!a;this.doSetMuted(this.is_muted||this.is_silent)};k.prototype.setSilent=function(a){this.is_silent=!!a;this.doSetMuted(this.is_muted||this.is_silent)};k.prototype.setLooping=function(a){this.looping=a;switch(this.myapi){case J:this.instanceObject.loop!==
!!a&&(this.instanceObject.loop=!!a);break;case B:this.instanceObject.loop!==!!a&&(this.instanceObject.loop=!!a);break;case X:L.isDirectCanvas&&AppMobi.context.setLoopingSound(this.src,a)}};k.prototype.setPlaybackRate=function(a){this.playbackRate=a;this.updatePlaybackRate()};k.prototype.updatePlaybackRate=function(){var a=this.playbackRate;if(1===ja&&!this.is_music||2===ja)a*=L.timescale;switch(this.myapi){case J:this.instanceObject.playbackRate!==a&&(this.instanceObject.playbackRate=a);break;case B:this.buffer.myapi===
B?this.instanceObject.playbackRate.value!==a&&(this.instanceObject.playbackRate.value=a):this.instanceObject.playbackRate!==a&&(this.instanceObject.playbackRate=a)}};k.prototype.setSuspended=function(a){switch(this.myapi){case J:a?this.isPlaying()?(this.instanceObject.pause(),this.resume_me=!0):this.resume_me=!1:this.resume_me&&this.instanceObject.play();break;case B:a?this.isPlaying()?(this.buffer.myapi===B?(this.resume_position=this.getPlaybackTime(),this.looping&&(this.resume_position%=this.getDuration()),
p(this.instanceObject)):this.instanceObject.pause(),this.resume_me=!0):this.resume_me=!1:this.resume_me&&(this.buffer.myapi===B?(this.instanceObject=F.createBufferSource(),this.instanceObject.buffer=this.buffer.bufferObject,this.instanceObject.connect(this.gainNode),this.instanceObject.loop=this.looping,this.gainNode.gain.value=Z*this.volume*this.mutevol,this.startTime=L.kahanTime.sum-this.resume_position,h(this.instanceObject,this.resume_position,this.getDuration())):this.instanceObject.play());
break;case W:a?this.isPlaying()?(this.instanceObject.pause(),this.resume_me=!0):this.resume_me=!1:this.resume_me&&this.instanceObject.play()}};N.Instance=function(a){this.type=a;L=this.runtime=a.runtime;P=this;this.listenerTracker=null;this.listenerZ=-600;!(this.runtime.isiOS||this.runtime.isAndroid&&(this.runtime.isChrome||this.runtime.isAndroidStockBrowser))||this.runtime.isCrosswalk||this.runtime.isDomFree||(fa=!0);F=null;"undefined"!==typeof AudioContext?(M=B,F=new AudioContext):"undefined"!==
typeof webkitAudioContext&&(M=B,F=new webkitAudioContext);(this.runtime.isiOS&&M===B||fa)&&document.addEventListener("touchstart",function(){var a,b,c;!ra&&F&&(a=F.createBuffer(1,1,22050),b=F.createBufferSource(),b.buffer=a,b.connect(F.destination),e(b),ra=!0);if(fa){if(!V)for(a=0,b=ga.length;a<b;++a)c=ga[a],c.stopped||c.is_paused||c.instanceObject.play();ga.length=0}},!0);M!==B&&(this.runtime.isPhoneGap&&"undefined"!==typeof window.Media?M=W:this.runtime.isAppMobi&&(M=X));M===W&&(U=location.href,
a=U.lastIndexOf("/"),-1<a&&(U=U.substr(0,a+1)),U=U.replace("file://",""));if(this.runtime.isSafari&&this.runtime.isWindows&&"undefined"===typeof Audio)alert("It looks like you're using Safari for Windows without Quicktime.  Audio cannot be played until Quicktime is installed."),this.runtime.DestroyInstance(this);else{if(this.runtime.isDirectCanvas)Y=this.runtime.isAndroid;else try{Y=!!(new Audio).canPlayType('audio/ogg; codecs="vorbis"')}catch(b){Y=!1}this.runtime.tickMe(this)}};var aa=N.Instance.prototype;
aa.onCreate=function(){this.runtime.audioInstance=this;ja=this.properties[0];this.saveload=this.properties[1];la=this.properties[2];ma=this.properties[3];this.listenerZ=-this.properties[4];oa=this.properties[5];pa=this.properties[6];qa=this.properties[7];this.listenerTracker=new y;M===B&&(F.listener.speedOfSound=this.properties[8],F.listener.dopplerFactor=this.properties[9],F.listener.setPosition(this.runtime.draw_width/2,this.runtime.draw_height/2,this.listenerZ),F.listener.setOrientation(0,0,1,
0,-1,0),window.c2OnAudioMicStream=function(a,c){da&&da.disconnect();ka=c.toLowerCase();da=F.createMediaStreamSource(a);da.connect(b(ka))});this.runtime.addSuspendCallback(function(a){P.onSuspend(a)});var a=this;this.runtime.addDestroyCallback(function(b){a.onInstanceDestroyed(b)})};aa.onInstanceDestroyed=function(a){var b,c,d;b=0;for(c=O.length;b<c;b++)d=O[b],d.objectTracker&&d.objectTracker.obj===a&&(d.objectTracker.obj=null,d.pannerEnabled&&d.isPlaying()&&d.looping&&d.stop());this.listenerTracker.obj===
a&&(this.listenerTracker.obj=null)};aa.saveToJSON=function(){var a={silent:V,masterVolume:Z,listenerZ:this.listenerZ,listenerUid:this.listenerTracker.hasObject()?this.listenerTracker.obj.uid:-1,playing:[],effects:{}},b=a.playing,c,d,g,e,f,k;c=0;for(d=O.length;c<d;c++)g=O[c],!g.isPlaying()||3===this.saveload||g.is_music&&1===this.saveload||!g.is_music&&2===this.saveload||(e=g.getPlaybackTime(),g.looping&&(e%=g.getDuration()),e={tag:g.tag,buffersrc:g.buffer.src,is_music:g.is_music,playbackTime:e,volume:g.volume,
looping:g.looping,muted:g.is_muted,playbackRate:g.playbackRate,paused:g.is_paused,resume_position:g.resume_position},g.pannerEnabled&&(e.pan={},k=e.pan,g.objectTracker&&g.objectTracker.hasObject()?k.objUid=g.objectTracker.obj.uid:(k.x=g.panX,k.y=g.panY,k.a=g.panAngle),k.ia=g.panConeInner,k.oa=g.panConeOuter,k.og=g.panConeOuterGain),b.push(e));b=a.effects;for(f in R)if(R.hasOwnProperty(f)){g=[];c=0;for(d=R[f].length;c<d;c++)g.push({type:R[f][c].type,params:R[f][c].params});b[f]=g}return a};var ha=
[];aa.loadFromJSON=function(a){var b=a.silent;Z=a.masterVolume;this.listenerZ=a.listenerZ;this.listenerTracker.setObject(null);var c=a.listenerUid;-1!==c&&(this.listenerTracker.loadUid=c,ha.push(this.listenerTracker));var c=a.playing,d,g,e,f,k,h,m,p,C,z,G;if(3!==this.saveload)for(d=0,g=O.length;d<g;d++)C=O[d],C.is_music&&1===this.saveload||(C.is_music||2!==this.saveload)&&C.stop();for(k in R)if(R.hasOwnProperty(k))for(d=0,g=R[k].length;d<g;d++)R[k][d].remove();cr.wipe(R);for(k in a.effects)if(a.effects.hasOwnProperty(k))for(h=
a.effects[k],d=0,g=h.length;d<g;d++)switch(e=h[d].type,z=h[d].params,e){case "filter":D(k,new n(z[0],z[1],z[2],z[3],z[4],z[5]));break;case "delay":D(k,new l(z[0],z[1],z[2]));break;case "convolve":e=z[2];C=this.getAudioBuffer(e,!1);C.bufferObject?e=new q(C.bufferObject,z[0],z[1],e):(e=new q(null,z[0],z[1],e),C.normalizeWhenReady=z[0],C.convolveWhenReady=e);D(k,e);break;case "flanger":D(k,new u(z[0],z[1],z[2],z[3],z[4]));break;case "phaser":D(k,new r(z[0],z[1],z[2],z[3],z[4],z[5]));break;case "gain":D(k,
new t(z[0]));break;case "tremolo":D(k,new x(z[0],z[1]));break;case "ringmod":D(k,new s(z[0],z[1]));break;case "distortion":D(k,new w(z[0],z[1],z[2],z[3],z[4]));break;case "compressor":D(k,new v(z[0],z[1],z[2],z[3],z[4]));break;case "analyser":D(k,new A(z[0],z[1]))}d=0;for(g=c.length;d<g;d++)3===this.saveload||(a=c[d],e=a.buffersrc,f=a.is_music,k=a.tag,h=a.playbackTime,m=a.looping,p=a.volume,G=(z=a.pan)&&z.hasOwnProperty("objUid")?z.objUid:-1,f&&1===this.saveload)||!f&&2===this.saveload||((C=this.getAudioInstance(e,
k,f,m,p))?(C.resume_position=a.resume_position,C.setPannerEnabled(!!z),C.play(m,p,h),C.updatePlaybackRate(),C.updateVolume(),C.doSetMuted(C.is_muted||C.is_silent),a.paused&&C.pause(),a.muted&&C.setMuted(!0),C.doSetMuted(C.is_muted||C.is_silent),z&&(-1!==G?(C.objectTracker=C.objectTracker||new y,C.objectTracker.loadUid=G,ha.push(C.objectTracker)):C.setPan(z.x,z.y,z.a,z.ia,z.oa,z.og))):(C=this.getAudioBuffer(e,f),C.seekWhenReady=h,C.pauseWhenReady=a.paused,z&&(-1!==G?C.panWhenReady.push({objUid:G,ia:z.ia,
oa:z.oa,og:z.og,thistag:k}):C.panWhenReady.push({x:z.x,y:z.y,a:z.a,ia:z.ia,oa:z.oa,og:z.og,thistag:k}))));if(b&&!V){d=0;for(g=O.length;d<g;d++)O[d].setSilent(!0);V=!0}else if(!b&&V){d=0;for(g=O.length;d<g;d++)O[d].setSilent(!1);V=!1}};aa.afterLoad=function(){var a,b,c,d;a=0;for(b=ha.length;a<b;a++)c=ha[a],d=this.runtime.getObjectByUID(c.loadUid),c.setObject(d),c.loadUid=-1,d&&(ba=d.x,ca=d.y);ha.length=0};aa.onSuspend=function(a){var b,c;b=0;for(c=O.length;b<c;b++)O[b].setSuspended(a)};aa.tick=function(){var a=
this.runtime.dt,b,c,d;b=0;for(c=O.length;b<c;b++)d=O[b],d.tick(a),d.myapi===J||d.myapi===X||d.fresh||d.stopped||!d.hasEnded()||(d.stopped=!0,T=d.tag,L.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded,P)),0!==ja&&d.updatePlaybackRate();var g,e;for(g in R)if(R.hasOwnProperty(g))for(d=R[g],b=0,c=d.length;b<c;b++)e=d[b],e.tick&&e.tick();M===B&&this.listenerTracker.hasObject()&&(this.listenerTracker.tick(a),ba=this.listenerTracker.obj.x,ca=this.listenerTracker.obj.y,F.listener.setPosition(this.listenerTracker.obj.x,
this.listenerTracker.obj.y,this.listenerZ),F.listener.setVelocity(this.listenerTracker.getVelocityX(),this.listenerTracker.getVelocityY(),0))};var ia=[];aa.setPreloadList=function(a){var b,c,d,g,e,f=0;b=0;for(c=a.length;b<c;++b)if(d=a[b],g=d[0],d=2*d[1],(e=4<g.length&&".ogg"===g.substr(g.length-4))&&Y||!e&&!Y)ia.push({filename:g,size:d,obj:null}),f+=d;return f};aa.startPreloads=function(){var a,b,c,d;a=0;for(b=ia.length;a<b;++a)c=ia[a],d=this.runtime.files_subfolder+c.filename,c.obj=this.getAudioBuffer(d,
!1)};aa.getPreloadedSize=function(){var a=0,b,c,d;b=0;for(c=ia.length;b<c;++b)d=ia[b],d.obj.isLoadedAndDecoded()||d.obj.hasFailedToLoad()||this.runtime.isDomFree?a+=d.size:d.obj.isLoaded()&&(a+=Math.floor(d.size/2));return a};aa.getAudioBuffer=function(a,b){var c,d,e,f=null;c=0;for(d=ea.length;c<d;c++)if(e=ea[c],e.src===a){f=e;break}f||(f=new g(a,b),ea.push(f));return f};aa.getAudioInstance=function(a,b,c,d,g){var e,f,h;e=0;for(f=O.length;e<f;e++)if(h=O[e],h.src===a&&(h.canBeRecycled()||c))return h.tag=
b,h;a=this.getAudioBuffer(a,c);if(!a.bufferObject)return"<preload>"!==b&&(a.playTagWhenReady=b,a.loopWhenReady=d,a.volumeWhenReady=g),null;h=new k(a,b);O.push(h);return h};var Q=[];H.prototype.OnEnded=function(a){return cr.equals_nocase(T,a)};H.prototype.PreloadsComplete=function(){var a,b;a=0;for(b=ea.length;a<b;a++)if(!ea[a].isLoaded()&&!ea[a].hasFailedToLoad())return!1;return!0};H.prototype.AdvancedAudioSupported=function(){return M===B};H.prototype.IsSilent=function(){return V};H.prototype.IsAnyPlaying=
function(){var a,b;a=0;for(b=O.length;a<b;a++)if(O[a].isPlaying())return!0;return!1};H.prototype.IsTagPlaying=function(a){z(a);var b;a=0;for(b=Q.length;a<b;a++)if(Q[a].isPlaying())return!0;return!1};N.cnds=new H;E.prototype.Play=function(b,c,d,g){!V&&(d=a(d),S=this.getAudioInstance(this.runtime.files_subfolder+b[0]+(Y?".ogg":".m4a"),g,b[1],0!==c,d))&&(S.setPannerEnabled(!1),S.play(0!==c,d))};E.prototype.PlayAtPosition=function(b,c,d,g,e,f,k,h,l,m){if(!V){d=a(d);var q=b[1];b=this.runtime.files_subfolder+
b[0]+(Y?".ogg":".m4a");(S=this.getAudioInstance(b,m,q,0!==c,d))?(S.setPannerEnabled(!0),S.setPan(g,e,f,k,h,a(l)),S.play(0!==c,d)):this.getAudioBuffer(b,q).panWhenReady.push({x:g,y:e,a:f,ia:k,oa:h,og:a(l),thistag:m})}};E.prototype.PlayAtObject=function(b,c,d,g,e,f,k,h){if(!V&&g&&(g=g.getFirstPicked())){d=a(d);var l=b[1];b=this.runtime.files_subfolder+b[0]+(Y?".ogg":".m4a");(S=this.getAudioInstance(b,h,l,0!==c,d))?(S.setPannerEnabled(!0),h=cr.rotatePtAround(g.x,g.y,-g.layer.getAngle(),ba,ca,!0),b=cr.rotatePtAround(g.x,
g.y,-g.layer.getAngle(),ba,ca,!1),S.setPan(h,b,cr.to_degrees(g.angle-g.layer.getAngle()),e,f,a(k)),S.setObject(g),S.play(0!==c,d)):this.getAudioBuffer(b,l).panWhenReady.push({obj:g,ia:e,oa:f,og:a(k),thistag:h})}};E.prototype.PlayByName=function(b,c,d,g,e){!V&&(g=a(g),b=1===b,c=this.runtime.files_subfolder+c.toLowerCase()+(Y?".ogg":".m4a"),S=this.getAudioInstance(c,e,b,0!==d,g))&&(S.setPannerEnabled(!1),S.play(0!==d,g))};E.prototype.PlayAtPositionByName=function(b,c,d,g,e,f,k,h,l,m,q){V||(g=a(g),b=
1===b,c=this.runtime.files_subfolder+c.toLowerCase()+(Y?".ogg":".m4a"),(S=this.getAudioInstance(c,q,b,0!==d,g))?(S.setPannerEnabled(!0),S.setPan(e,f,k,h,l,a(m)),S.play(0!==d,g)):this.getAudioBuffer(c,b).panWhenReady.push({x:e,y:f,a:k,ia:h,oa:l,og:a(m),thistag:q}))};E.prototype.PlayAtObjectByName=function(b,c,d,g,e,f,k,h,l){!V&&e&&(e=e.getFirstPicked())&&(g=a(g),b=1===b,c=this.runtime.files_subfolder+c.toLowerCase()+(Y?".ogg":".m4a"),(S=this.getAudioInstance(c,l,b,0!==d,g))?(S.setPannerEnabled(!0),
l=cr.rotatePtAround(e.x,e.y,-e.layer.getAngle(),ba,ca,!0),c=cr.rotatePtAround(e.x,e.y,-e.layer.getAngle(),ba,ca,!1),S.setPan(l,c,cr.to_degrees(e.angle-e.layer.getAngle()),f,k,a(h)),S.setObject(e),S.play(0!==d,g)):this.getAudioBuffer(c,b).panWhenReady.push({obj:e,ia:f,oa:k,og:a(h),thistag:l}))};E.prototype.SetLooping=function(a,b){z(a);var c,d;c=0;for(d=Q.length;c<d;c++)Q[c].setLooping(0===b)};E.prototype.SetMuted=function(a,b){z(a);var c,d;c=0;for(d=Q.length;c<d;c++)Q[c].setMuted(0===b)};E.prototype.SetVolume=
function(b,c){z(b);var d=a(c),g,e;g=0;for(e=Q.length;g<e;g++)Q[g].setVolume(d)};E.prototype.Preload=function(a){if(!V){var b=a[1];a=this.runtime.files_subfolder+a[0]+(Y?".ogg":".m4a");M===X?this.runtime.isDirectCanvas?AppMobi.context.loadSound(a):AppMobi.player.loadSound(a):M!==W&&this.getAudioInstance(a,"<preload>",b,!1)}};E.prototype.PreloadByName=function(a,b){if(!V){var c=1===a,d=this.runtime.files_subfolder+b.toLowerCase()+(Y?".ogg":".m4a");M===X?this.runtime.isDirectCanvas?AppMobi.context.loadSound(d):
AppMobi.player.loadSound(d):M!==W&&this.getAudioInstance(d,"<preload>",c,!1)}};E.prototype.SetPlaybackRate=function(a,b){z(a);0>b&&(b=0);var c,d;c=0;for(d=Q.length;c<d;c++)Q[c].setPlaybackRate(b)};E.prototype.Stop=function(a){z(a);var b;a=0;for(b=Q.length;a<b;a++)Q[a].stop()};E.prototype.StopAll=function(){var a,b;a=0;for(b=O.length;a<b;a++)O[a].stop()};E.prototype.SetPaused=function(a,b){z(a);var c,d;c=0;for(d=Q.length;c<d;c++)0===b?Q[c].pause():Q[c].resume()};E.prototype.Seek=function(a,b){z(a);
var c,d;c=0;for(d=Q.length;c<d;c++)Q[c].seek(b)};E.prototype.SetSilent=function(a){var b;2===a&&(a=V?1:0);if(0===a&&!V){a=0;for(b=O.length;a<b;a++)O[a].setSilent(!0);V=!0}else if(1===a&&V){a=0;for(b=O.length;a<b;a++)O[a].setSilent(!1);V=!1}};E.prototype.SetMasterVolume=function(b){Z=a(b);var c;b=0;for(c=O.length;b<c;b++)O[b].updateVolume()};E.prototype.AddFilterEffect=function(a,b,c,d,g,e,f){M!==B||0>b||b>=na.length||!F.createBiquadFilter||(a=a.toLowerCase(),f/=100,0>f&&(f=0),1<f&&(f=1),D(a,new n(b,
c,d,g,e,f)))};E.prototype.AddDelayEffect=function(b,c,d,g){M===B&&(b=b.toLowerCase(),g/=100,0>g&&(g=0),1<g&&(g=1),D(b,new l(c,a(d),g)))};E.prototype.AddFlangerEffect=function(a,b,c,d,g,e){M===B&&F.createOscillator&&(a=a.toLowerCase(),e/=100,0>e&&(e=0),1<e&&(e=1),D(a,new u(b/1E3,c/1E3,d,g/100,e)))};E.prototype.AddPhaserEffect=function(a,b,c,d,g,e,f){M===B&&F.createOscillator&&(a=a.toLowerCase(),f/=100,0>f&&(f=0),1<f&&(f=1),D(a,new r(b,c,d,g,e,f)))};E.prototype.AddConvolutionEffect=function(a,b,c,d){if(M===
B&&F.createConvolver){c=0===c;var g=this.runtime.files_subfolder+b[0]+(Y?".ogg":".m4a");b=this.getAudioBuffer(g,!1);a=a.toLowerCase();d/=100;0>d&&(d=0);1<d&&(d=1);b.bufferObject?d=new q(b.bufferObject,c,d,g):(d=new q(null,c,d,g),b.normalizeWhenReady=c,b.convolveWhenReady=d);D(a,d)}};E.prototype.AddGainEffect=function(b,c){M===B&&(b=b.toLowerCase(),D(b,new t(a(c))))};E.prototype.AddMuteEffect=function(a){M===B&&(a=a.toLowerCase(),D(a,new t(0)))};E.prototype.AddTremoloEffect=function(a,b,c){M===B&&
F.createOscillator&&(a=a.toLowerCase(),c/=100,0>c&&(c=0),1<c&&(c=1),D(a,new x(b,c)))};E.prototype.AddRingModEffect=function(a,b,c){M===B&&F.createOscillator&&(a=a.toLowerCase(),c/=100,0>c&&(c=0),1<c&&(c=1),D(a,new s(b,c)))};E.prototype.AddDistortionEffect=function(a,b,c,d,g,e){M===B&&F.createWaveShaper&&(a=a.toLowerCase(),e/=100,0>e&&(e=0),1<e&&(e=1),D(a,new w(b,c,d,g,e)))};E.prototype.AddCompressorEffect=function(a,b,c,d,g,e){M===B&&F.createDynamicsCompressor&&(a=a.toLowerCase(),D(a,new v(b,c,d,
g/1E3,e/1E3)))};E.prototype.AddAnalyserEffect=function(a,b,c){M===B&&(a=a.toLowerCase(),D(a,new A(b,c)))};E.prototype.RemoveEffects=function(a){if(M===B){a=a.toLowerCase();var b,c,d;if(R.hasOwnProperty(a)&&(d=R[a],d.length)){b=0;for(c=d.length;b<c;b++)d[b].remove();d.length=0;G(a)}}};E.prototype.SetEffectParameter=function(a,b,c,d,g,e){M===B&&(a=a.toLowerCase(),b=Math.floor(b),R.hasOwnProperty(a)&&(a=R[a],0>b||b>=a.length||a[b].setParam(c,d,g,e)))};E.prototype.SetListenerObject=function(a){a&&M===
B&&(a=a.getFirstPicked())&&(this.listenerTracker.setObject(a),ba=a.x,ca=a.y)};E.prototype.SetListenerZ=function(a){this.listenerZ=a};N.acts=new E;I.prototype.Duration=function(a,b){z(b,!0);Q.length?a.set_float(Q[0].getDuration()):a.set_float(0)};I.prototype.PlaybackTime=function(a,b){z(b,!0);Q.length?a.set_float(Q[0].getPlaybackTime()):a.set_float(0)};I.prototype.Volume=function(a,b){z(b,!0);if(Q.length){var d=Q[0].getVolume();a.set_float(c(d))}else a.set_float(0)};I.prototype.MasterVolume=function(a){a.set_float(Z)};
I.prototype.EffectCount=function(a,b){b=b.toLowerCase();var c=null;R.hasOwnProperty(b)&&(c=R[b]);a.set_int(c?c.length:0)};I.prototype.AnalyserFreqBinCount=function(a,b,c){b=b.toLowerCase();c=Math.floor(c);b=K(b,c);a.set_int(b?b.node.frequencyBinCount:0)};I.prototype.AnalyserFreqBinAt=function(a,b,c,d){b=b.toLowerCase();c=Math.floor(c);d=Math.floor(d);(b=K(b,c))?0>d||d>=b.node.frequencyBinCount?a.set_float(0):a.set_float(b.freqBins[d]):a.set_float(0)};I.prototype.AnalyserPeakLevel=function(a,b,c){b=
b.toLowerCase();c=Math.floor(c);(b=K(b,c))?a.set_float(b.peak):a.set_float(0)};I.prototype.AnalyserRMSLevel=function(a,b,c){b=b.toLowerCase();c=Math.floor(c);(b=K(b,c))?a.set_float(b.rms):a.set_float(0)};N.exps=new I})();cr.plugins_.Browser=function(a){this.runtime=a};
(function(){function a(){}function c(){}function b(){"undefined"!==typeof jQuery&&h.setSize(jQuery(window).width(),jQuery(window).height())}function d(){}var f=cr.plugins_.Browser.prototype;f.Type=function(a){this.plugin=a;this.runtime=a.runtime};f.Type.prototype.onCreate=function(){};f.Instance=function(a){this.type=a;this.runtime=a.runtime};f.Instance.prototype.onCreate=function(){var a=this;window.addEventListener("resize",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnResize,
a)});"undefined"!==typeof navigator.onLine&&(window.addEventListener("online",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOnline,a)}),window.addEventListener("offline",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOffline,a)}));"undefined"!==typeof window.applicationCache&&(window.applicationCache.addEventListener("updateready",function(){a.runtime.loadingprogress=1;a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady,a)}),window.applicationCache.addEventListener("progress",
function(b){a.runtime.loadingprogress=b.loaded/b.total}));this.runtime.isDirectCanvas||(document.addEventListener("appMobi.device.update.available",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady,a)}),document.addEventListener("backbutton",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton,a)}),document.addEventListener("menubutton",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton,a)}),document.addEventListener("searchbutton",
function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnSearchButton,a)}),document.addEventListener("tizenhwkey",function(b){var c;switch(b.keyName){case "back":c=a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton,a);!c&&window.tizen&&window.tizen.application.getCurrentApplication().exit();break;case "menu":(c=a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton,a))||b.preventDefault()}}));this.runtime.isWindowsPhone81&&(WinJS.Application.onbackclick=function(b){return!!a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton,
a)});this.runtime.addSuspendCallback(function(b){b?a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageHidden,a):a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageVisible,a)});this.is_arcade="undefined"!==typeof window.is_scirra_arcade};a.prototype.CookiesEnabled=function(){return navigator?navigator.cookieEnabled:!1};a.prototype.IsOnline=function(){return navigator?navigator.onLine:!1};a.prototype.HasJava=function(){return navigator?navigator.javaEnabled():!1};a.prototype.OnOnline=
function(){return!0};a.prototype.OnOffline=function(){return!0};a.prototype.IsDownloadingUpdate=function(){return"undefined"===typeof window.applicationCache?!1:window.applicationCache.status===window.applicationCache.DOWNLOADING};a.prototype.OnUpdateReady=function(){return!0};a.prototype.PageVisible=function(){return!this.runtime.isSuspended};a.prototype.OnPageVisible=function(){return!0};a.prototype.OnPageHidden=function(){return!0};a.prototype.OnResize=function(){return!0};a.prototype.IsFullscreen=
function(){return!!(document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||this.runtime.isNodeFullscreen)};a.prototype.OnBackButton=function(){return!0};a.prototype.OnMenuButton=function(){return!0};a.prototype.OnSearchButton=function(){return!0};a.prototype.IsMetered=function(){var a=navigator.connection||navigator.mozConnection||navigator.webkitConnection;return a?a.metered:!1};a.prototype.IsCharging=function(){var a=navigator.battery||navigator.mozBattery||navigator.webkitBattery;
return a?a.charging:!0};a.prototype.IsPortraitLandscape=function(a){return(window.innerWidth<=window.innerHeight?0:1)===a};f.cnds=new a;c.prototype.Alert=function(a){this.runtime.isDomFree||alert(a.toString())};c.prototype.Close=function(){this.runtime.isCocoonJs?CocoonJS.App.forceToFinish():window.tizen?window.tizen.application.getCurrentApplication().exit():navigator.app&&navigator.app.exitApp?navigator.app.exitApp():navigator.device&&navigator.device.exitApp?navigator.device.exitApp():this.is_arcade||
this.runtime.isDomFree||window.close()};c.prototype.Focus=function(){this.runtime.isNodeWebkit?window.nwgui.Window.get().focus():this.is_arcade||this.runtime.isDomFree||window.focus()};c.prototype.Blur=function(){this.runtime.isNodeWebkit?window.nwgui.Window.get().blur():this.is_arcade||this.runtime.isDomFree||window.blur()};c.prototype.GoBack=function(){navigator.app&&navigator.app.backHistory?navigator.app.backHistory():this.is_arcade||this.runtime.isDomFree||!window.back||window.back()};c.prototype.GoForward=
function(){this.is_arcade||this.runtime.isDomFree||!window.forward||window.forward()};c.prototype.GoHome=function(){this.is_arcade||this.runtime.isDomFree||!window.home||window.home()};c.prototype.GoToURL=function(a,b){this.runtime.isCocoonJs?CocoonJS.App.openURL(a):this.runtime.isEjecta?ejecta.openURL(a):this.runtime.isWinJS?Windows.System.Launcher.launchUriAsync(new Windows.Foundation.Uri(a)):navigator.app&&navigator.app.loadUrl?navigator.app.loadUrl(a,{openExternal:!0}):this.is_arcade||this.runtime.isDomFree||
(2!==b||this.is_arcade?1!==b||this.is_arcade?window.location=a:window.parent.location=a:window.top.location=a)};c.prototype.GoToURLWindow=function(a,b){this.runtime.isCocoonJs?CocoonJS.App.openURL(a):this.runtime.isEjecta?ejecta.openURL(a):this.runtime.isWinJS?Windows.System.Launcher.launchUriAsync(new Windows.Foundation.Uri(a)):navigator.app&&navigator.app.loadUrl?navigator.app.loadUrl(a,{openExternal:!0}):this.is_arcade||this.runtime.isDomFree||window.open(a,b)};c.prototype.Reload=function(){this.is_arcade||
this.runtime.isDomFree||window.location.reload()};var e=!0,h=null;c.prototype.RequestFullScreen=function(a){this.runtime.isDomFree?cr.logexport("[Construct 2] Requesting fullscreen is not supported on this platform - the request has been ignored"):(2<=a&&(a+=1),6===a&&(a=2),this.runtime.isNodeWebkit?this.runtime.isNodeFullscreen||(window.nwgui.Window.get().enterFullscreen(),this.runtime.isNodeFullscreen=!0,this.runtime.fullscreen_scaling=2<=a?a:0):document.mozFullScreen||document.webkitIsFullScreen||
document.msFullscreenElement||document.fullScreen||(this.runtime.fullscreen_scaling=2<=a?a:0,a=this.runtime.canvasdiv||this.runtime.canvas,e&&(e=!1,h=this.runtime,a.addEventListener("mozfullscreenerror",b),a.addEventListener("webkitfullscreenerror",b),a.addEventListener("msfullscreenerror",b),a.addEventListener("fullscreenerror",b)),cr.is_undefined(a.requestFullscreen)?cr.is_undefined(a.webkitRequestFullScreen)?cr.is_undefined(a.mozRequestFullScreen)?cr.is_undefined(a.msRequestFullscreen)||a.msRequestFullscreen():
a.mozRequestFullScreen():"undefined"!==typeof Element&&"undefined"!==typeof Element.ALLOW_KEYBOARD_INPUT?a.webkitRequestFullScreen(Element.ALLOW_KEYBOARD_INPUT):a.webkitRequestFullScreen():a.requestFullscreen()))};c.prototype.CancelFullScreen=function(){this.runtime.isDomFree?cr.logexport("[Construct 2] Exiting fullscreen is not supported on this platform - the request has been ignored"):this.runtime.isNodeWebkit?this.runtime.isNodeFullscreen&&(window.nwgui.Window.get().leaveFullscreen(),this.runtime.isNodeFullscreen=
!1):cr.is_undefined(document.exitFullscreen)?cr.is_undefined(document.webkitCancelFullScreen)?cr.is_undefined(document.mozCancelFullScreen)?cr.is_undefined(document.msExitFullscreen)||document.msExitFullscreen():document.mozCancelFullScreen():document.webkitCancelFullScreen():document.exitFullscreen()};c.prototype.Vibrate=function(a){try{var b=a.split(","),c,d;c=0;for(d=b.length;c<d;c++)b[c]=parseInt(b[c],10);navigator.vibrate?navigator.vibrate(b):navigator.mozVibrate?navigator.mozVibrate(b):navigator.webkitVibrate?
navigator.webkitVibrate(b):navigator.msVibrate&&navigator.msVibrate(b)}catch(e){}};c.prototype.InvokeDownload=function(a,b){var c=document.createElement("a");if("undefined"===typeof c.download)window.open(a);else{var d=document.getElementsByTagName("body")[0];c.textContent=b;c.href=a;c.download=b;d.appendChild(c);var e=document.createEvent("MouseEvent");e.initMouseEvent("click",!0,!0,window,0,0,0,0,0,!1,!1,!1,!1,0,null);c.dispatchEvent(e);d.removeChild(c)}};c.prototype.InvokeDownloadString=function(a,
b,c){var d="data:"+b+","+encodeURIComponent(a);a=document.createElement("a");"undefined"===typeof a.download?window.open(d):(b=document.getElementsByTagName("body")[0],a.textContent=c,a.href=d,a.download=c,b.appendChild(a),c=document.createEvent("MouseEvent"),c.initMouseEvent("click",!0,!0,window,0,0,0,0,0,!1,!1,!1,!1,0,null),a.dispatchEvent(c),b.removeChild(a))};c.prototype.ConsoleLog=function(a,b){"undefined"!==typeof console&&(0===a&&console.log&&console.log(b.toString()),1===a&&console.warn&&
console.warn(b.toString()),2===a&&console.error&&console.error(b.toString()))};c.prototype.ConsoleGroup=function(a){console&&console.group&&console.group(a)};c.prototype.ConsoleGroupEnd=function(){console&&console.groupEnd&&console.groupEnd()};c.prototype.ExecJs=function(a){try{eval&&eval(a)}catch(b){console&&console.error&&console.error("Error executing Javascript: ",b)}};var p="portrait landscape portrait-primary portrait-secondary landscape-primary landscape-secondary".split(" ");c.prototype.LockOrientation=
function(a){a=Math.floor(a);0>a||a>=p.length||(this.runtime.autoLockOrientation=!1,a=p[a],screen.lockOrientation?screen.lockOrientation(a):screen.webkitLockOrientation?screen.webkitLockOrientation(a):screen.mozLockOrientation?screen.mozLockOrientation(a):screen.msLockOrientation&&screen.msLockOrientation(a))};c.prototype.UnlockOrientation=function(){this.runtime.autoLockOrientation=!1;screen.unlockOrientation?screen.unlockOrientation():screen.webkitUnlockOrientation?screen.webkitUnlockOrientation():
screen.mozUnlockOrientation?screen.mozUnlockOrientation():screen.msUnlockOrientation&&screen.msUnlockOrientation()};f.acts=new c;d.prototype.URL=function(a){a.set_string(this.runtime.isDomFree?"":window.location.toString())};d.prototype.Protocol=function(a){a.set_string(this.runtime.isDomFree?"":window.location.protocol)};d.prototype.Domain=function(a){a.set_string(this.runtime.isDomFree?"":window.location.hostname)};d.prototype.PathName=function(a){a.set_string(this.runtime.isDomFree?"":window.location.pathname)};
d.prototype.Hash=function(a){a.set_string(this.runtime.isDomFree?"":window.location.hash)};d.prototype.Referrer=function(a){a.set_string(this.runtime.isDomFree?"":document.referrer)};d.prototype.Title=function(a){a.set_string(this.runtime.isDomFree?"":document.title)};d.prototype.Name=function(a){a.set_string(this.runtime.isDomFree?"":navigator.appName)};d.prototype.Version=function(a){a.set_string(this.runtime.isDomFree?"":navigator.appVersion)};d.prototype.Language=function(a){navigator&&navigator.language?
a.set_string(navigator.language):a.set_string("")};d.prototype.Platform=function(a){a.set_string(this.runtime.isDomFree?"":navigator.platform)};d.prototype.Product=function(a){navigator&&navigator.product?a.set_string(navigator.product):a.set_string("")};d.prototype.Vendor=function(a){navigator&&navigator.vendor?a.set_string(navigator.vendor):a.set_string("")};d.prototype.UserAgent=function(a){a.set_string(this.runtime.isDomFree?"":navigator.userAgent)};d.prototype.QueryString=function(a){a.set_string(this.runtime.isDomFree?
"":window.location.search)};d.prototype.QueryParam=function(a,b){if(this.runtime.isDomFree)a.set_string("");else{var c=RegExp("[?&]"+b+"=([^&]*)").exec(window.location.search);c?a.set_string(decodeURIComponent(c[1].replace(/\+/g," "))):a.set_string("")}};d.prototype.Bandwidth=function(a){var b=navigator.connection||navigator.mozConnection||navigator.webkitConnection;b?a.set_float(b.bandwidth):a.set_float(Number.POSITIVE_INFINITY)};d.prototype.BatteryLevel=function(a){var b=navigator.battery||navigator.mozBattery||
navigator.webkitBattery;b?a.set_float(b.level):a.set_float(1)};d.prototype.BatteryTimeLeft=function(a){var b=navigator.battery||navigator.mozBattery||navigator.webkitBattery;b?a.set_float(b.dischargingTime):a.set_float(Number.POSITIVE_INFINITY)};d.prototype.ExecJS=function(a,b){if(eval){var c=0;try{c=eval(b)}catch(d){console&&console.error&&console.error("Error executing Javascript: ",d)}"number"===typeof c?a.set_any(c):"string"===typeof c?a.set_any(c):"boolean"===typeof c?a.set_any(c?1:0):a.set_any(0)}else a.set_any(0)};
d.prototype.ScreenWidth=function(a){a.set_int(screen.width)};d.prototype.ScreenHeight=function(a){a.set_int(screen.height)};d.prototype.DevicePixelRatio=function(a){a.set_float(this.runtime.devicePixelRatio)};f.exps=new d})();cr.plugins_.CJSAds=function(a){this.runtime=a};
(function(){function a(){}function c(){}function b(){}var d="",f=[],e=0,h=0,p=!1,m=!1,n=!1,l=cr.plugins_.CJSAds.prototype;l.Type=function(a){this.plugin=a;this.runtime=a.runtime};l.Type.prototype.onCreate=function(){};l.Instance=function(a){this.type=a;this.runtime=a.runtime};l.Instance.prototype.onCreate=function(){this.isShowingFullscreen=this.isShowingBanner=!1;this.triggerProduct="";this.socialService=null;this.socialServiceAvailable=!1;this.storeServiceAvailable=this.runtime.isCocoonJs&&"undefined"!==
typeof CocoonJS.Store.nativeExtensionObjectAvailable;this.storeManaged=1!==this.properties[0];this.storeSandboxed=0!==this.properties[1];this.onConsumePurchaseCompleted=this.onConsumePurchaseFailedTransactionId="";var a=this;this.runtime.isCocoonJs&&(CocoonJS.App.onTextDialogFinished.addEventListener(function(b){d=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardOK,a)}),CocoonJS.App.onTextDialogCancelled.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardCancelled,
a)}),CocoonJS.Ad.onBannerShown.addEventListener(function(){a.isShowingBanner=!0;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnBannerShown,a)}),CocoonJS.Ad.onBannerReady.addEventListener(function(){m=!0;p||(CocoonJS.Ad.setBannerLayout(h),CocoonJS.Ad.showBanner())}),CocoonJS.Ad.onFullScreenShown.addEventListener(function(){a.isShowingFullscreen=!0;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenShown,a)}),CocoonJS.Ad.onFullScreenHidden.addEventListener(function(){a.isShowingFullscreen=
!1;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenHidden,a)}),CocoonJS.Ad.onFullScreenReady.addEventListener(function(){n=!0;preloadFullScreen||CocoonJS.Ad.showFullScreen()}),this.storeServiceAvailable&&(CocoonJS.Store.onProductPurchaseCompleted.addEventListener(function(b){a.triggerProduct=b.productId;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete,a);CocoonJS.Store.addPurchase(b);CocoonJS.Store.consumePurchase(b.transactionId,b.productId);CocoonJS.Store.finishPurchase(b.transactionId)}),
CocoonJS.Store.onConsumePurchaseFailed.addEventListener(function(b,c){this.onConsumePurchaseFailedTransactionId=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseFailed,a)}),CocoonJS.Store.onConsumePurchaseCompleted.addEventListener(function(b){this.onConsumePurchaseCompleted=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseCompleted,a)}),CocoonJS.Store.onProductPurchaseFailed.addEventListener(function(b,c){a.triggerProduct=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail,
a)}),CocoonJS.Store.onProductPurchaseStarted.addEventListener(function(b){a.triggerProduct=b.productId;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseStart,a)}),CocoonJS.Store.onProductsFetchStarted.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchStarted,a)}),CocoonJS.Store.onProductsFetchFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchFailed,a)}),CocoonJS.Store.onProductsFetchCompleted.addEventListener(function(b){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchCompleted,
a)}),CocoonJS.Store.requestInitialization({managed:this.storeManaged,sandbox:this.storeSandboxed}),CocoonJS.Store.start()),this.socialService=CocoonJS.SocialGaming.GameCenter,this.socialServiceAvailable=!!this.socialService.nativeExtensionObjectAvailable,this.socialService.onRequestLoginSucceed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLoginSuccess,a)}),this.socialService.onRequestLoginFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLoginFail,
a)}),this.socialService.onLogout.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLogout,a)}),this.socialService.onRequestUserScoreSucceed.addEventListener(function(b){e=b.score||0;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreReceived,a)}),this.socialService.onRequestUserScoreFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreUnavailable,a)}),this.socialService.onSubmitUserScoreSucceed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreSubmitSuccess,
a)}),this.socialService.onSubmitUserScoreFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreSubmitFail,a)}),this.socialService.onLeaderboardViewSucceed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLeaderboardOpen,a)}),this.socialService.onLeaderboardViewClosed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLeaderboardClose,a)}))};a.prototype.IsShowingBanner=function(){return this.isShowingBanner};
a.prototype.IsCocoonJS=function(){return this.runtime.isCocoonJs};a.prototype.OnBannerShown=function(){return!0};a.prototype.OnFullscreenShown=function(){return!0};a.prototype.OnFullscreenHidden=function(){return!0};a.prototype.IsShowingFullscreen=function(){return this.isShowingFullscreen};a.prototype.IsStoreAvailable=function(){return this.runtime.isCocoonJs?this.storeServiceAvailable&&CocoonJS.Store.canPurchase():!1};a.prototype.OnPurchaseStart=function(a){return this.triggerProduct===a};a.prototype.OnPurchaseComplete=
function(a){return this.triggerProduct===a};a.prototype.OnPurchaseFail=function(a){return this.triggerProduct===a};a.prototype.onProductsFetchStarted=function(){return!0};a.prototype.onConsumePurchaseFailed=function(){return!0};a.prototype.onProductsFetchCompleted=function(){return!0};a.prototype.onProductsFetchFailed=function(){return!0};a.prototype.IsProductPurchased=function(a){return this.runtime.isCocoonJs?CocoonJS.Store.isProductPurchased(a):!1};a.prototype.OnKeyboardCancelled=function(){return!0};
a.prototype.OnKeyboardOK=function(){return!0};a.prototype.IsGCAvailable=function(){return this.socialServiceAvailable};a.prototype.IsGCLoggedIn=function(){return this.socialServiceAvailable?this.socialService.isLoggedIn():!1};a.prototype.OnGCLoginSuccess=function(){return!0};a.prototype.OnGCLoginFail=function(){return!0};a.prototype.OnGCLogout=function(){return!0};a.prototype.OnGCScoreReceived=function(){return!0};a.prototype.OnGCScoreUnavailable=function(){return!0};a.prototype.OnGCScoreSubmitSuccess=
function(){return!0};a.prototype.OnGCScoreSubmitFail=function(){return!0};a.prototype.OnGCLeaderboardOpen=function(){return!0};a.prototype.OnGCLeaderboardClose=function(){return!0};l.cnds=new a;c.prototype.ShowBanner=function(a){this.runtime.isCocoonJs&&(h=0===a?CocoonJS.Ad.BannerLayout.TOP_CENTER:CocoonJS.Ad.BannerLayout.BOTTOM_CENTER,p=!1,m?(CocoonJS.Ad.setBannerLayout(h),CocoonJS.Ad.showBanner()):CocoonJS.Ad.preloadBanner())};c.prototype.ShowFullscreen=function(){this.runtime.isCocoonJs&&(n?CocoonJS.Ad.showFullScreen():
CocoonJS.Ad.preloadFullScreen())};c.prototype.HideBanner=function(){this.runtime.isCocoonJs&&(CocoonJS.Ad.hideBanner(),this.isShowingBanner=!1)};c.prototype.PreloadBanner=function(){this.runtime.isCocoonJs&&(p=!0,CocoonJS.Ad.preloadBanner())};c.prototype.PreloadFullscreen=function(){this.runtime.isCocoonJs&&CocoonJS.Ad.preloadFullScreen()};c.prototype.RefreshBanner=function(){this.runtime.isCocoonJs&&CocoonJS.Ad.refreshBanner()};c.prototype.RefreshFullscreen=function(){this.runtime.isCocoonJs&&CocoonJS.Ad.refreshFullScreen()};
c.prototype.Purchase=function(a){this.runtime.isCocoonJs&&CocoonJS.Store.purchaseProduct(a)};c.prototype.fetchProductsFromStore=function(a){this.runtime.isCocoonJs&&CocoonJS.Store.fetchProductsFromStore(a.split(","))};c.prototype.restorePurchases=function(){if(this.runtime.isCocoonJs)return CocoonJS.Store.restorePurchases()};c.prototype.PurchasePreview=function(a){this.runtime.isCocoonJs&&CocoonJS.Store.purchaseProductModalWithPreview(a)};c.prototype.RestorePurchases=function(){this.runtime.isCocoonJs&&
CocoonJS.Store.restorePurchases()};c.prototype.PromptKeyboard=function(a,b,c,d,e,f){this.runtime.isCocoonJs&&CocoonJS.App.showTextDialog(a,b,c,["text","num","phone","email","url"][d],e,f)};c.prototype.UpdateProductsList=function(){this.runtime.isCocoonJs&&CocoonJS.Store.canPurchase()&&(f=CocoonJS.Store.getProducts())};c.prototype.GCLogin=function(){this.socialServiceAvailable&&!this.socialService.isLoggedIn()&&this.socialService.requestLogin()};c.prototype.GCLogout=function(){this.socialServiceAvailable&&
this.socialService.isLoggedIn()&&this.socialService.requestLogout()};c.prototype.GCSubmitScore=function(a,b){this.socialServiceAvailable&&this.socialService.isLoggedIn()&&this.socialService.submitUserScore(a,b)};c.prototype.GCRequestScore=function(a){this.socialServiceAvailable&&this.socialService.isLoggedIn()&&this.socialService.requestUserScore(a)};c.prototype.GCOpenLeaderboard=function(a){this.socialServiceAvailable&&this.socialService.isLoggedIn()&&this.socialService.showLeaderboardView(a)};l.acts=
new c;b.prototype.InputText=function(a){a.set_string(d)};b.prototype.ProductCount=function(a){a.set_int(f.length)};b.prototype.ProductDescription=function(a,b){b=Math.floor(b);0>b||b>=f.length?a.set_string(""):a.set_string(f[b].description)};b.prototype.ProductLocalizedPrice=function(a,b){b=Math.floor(b);0>b||b>=f.length?a.set_string(""):a.set_string(f[b].localizedPrice)};b.prototype.ProductPrice=function(a,b){b=Math.floor(b);0>b||b>=f.length?a.set_string(""):a.set_string(f[b].price)};b.prototype.ProductAlias=
function(a,b){b=Math.floor(b);0>b||b>=f.length?a.set_string(""):a.set_string(f[b].productAlias)};b.prototype.ProductID=function(a,b){b=Math.floor(b);0>b||b>=f.length?a.set_string(""):a.set_string(f[b].productId)};b.prototype.ProductTitle=function(a,b){b=Math.floor(b);0>b||b>=f.length?a.set_string(""):a.set_string(f[b].title)};b.prototype.GameCenterScore=function(a){a.set_float(e)};l.exps=new b})();cr.plugins_.Function=function(a){this.runtime=a};
(function(){function a(){this.name="";this.retVal=0;this.params=[]}function c(){m++;m===p.length&&p.push(new a);return p[m]}function b(){return 0>m?null:p[m]}function d(){}function f(){}function e(){}var h=cr.plugins_.Function.prototype;h.Type=function(a){this.plugin=a;this.runtime=a.runtime};h.Type.prototype.onCreate=function(){};h.Instance=function(a){this.type=a;this.runtime=a.runtime};var p=[],m=-1;h.Instance.prototype.onCreate=function(){var a=this;window.c2_callFunction=function(b,d){var e,
f,h,p=c();p.name=b.toLowerCase();p.retVal=0;if(d)for(p.params.length=d.length,e=0,f=d.length;e<f;++e)h=d[e],p.params[e]="number"===typeof h||"string"===typeof h?h:"boolean"===typeof h?h?1:0:0;else p.params.length=0;a.runtime.trigger(cr.plugins_.Function.prototype.cnds.OnFunction,a,p.name);m--;return p.retVal}};d.prototype.OnFunction=function(a){var c=b();return c?cr.equals_nocase(a,c.name):!1};d.prototype.CompareParam=function(a,c,d){var e=b();if(!e)return!1;a=cr.floor(a);return 0>a||a>=e.params.length?
!1:cr.do_cmp(e.params[a],c,d)};h.cnds=new d;f.prototype.CallFunction=function(a,b){var d=c();d.name=a.toLowerCase();d.retVal=0;cr.shallowAssignArray(d.params,b);this.runtime.trigger(cr.plugins_.Function.prototype.cnds.OnFunction,this,d.name);m--};f.prototype.SetReturnValue=function(a){var c=b();c&&(c.retVal=a)};h.acts=new f;e.prototype.ReturnValue=function(a){var b;p.length?(b=m+1,b>=p.length&&(b=p.length-1),b=p[b]):b=null;b?a.set_any(b.retVal):a.set_int(0)};e.prototype.ParamCount=function(a){var c=
b();c?a.set_int(c.params.length):a.set_int(0)};e.prototype.Param=function(a,c){c=cr.floor(c);var d=b();d?0<=c&&c<d.params.length?a.set_any(d.params[c]):a.set_int(0):a.set_int(0)};e.prototype.Call=function(a,b){var d=c();d.name=b.toLowerCase();d.retVal=0;d.params.length=0;var e,f;e=2;for(f=arguments.length;e<f;e++)d.params.push(arguments[e]);this.runtime.trigger(cr.plugins_.Function.prototype.cnds.OnFunction,this,d.name);m--;a.set_any(d.retVal)};h.exps=new e})();
cr.plugins_.Keyboard=function(a){this.runtime=a};
(function(){function a(){}function c(){}function b(a){a=Math.floor(a);switch(a){case 8:return"backspace";case 9:return"tab";case 13:return"enter";case 16:return"shift";case 17:return"control";case 18:return"alt";case 19:return"pause";case 20:return"capslock";case 27:return"esc";case 33:return"pageup";case 34:return"pagedown";case 35:return"end";case 36:return"home";case 37:return"\u2190";case 38:return"\u2191";case 39:return"\u2192";case 40:return"\u2193";case 45:return"insert";case 46:return"del";
case 91:return"left window key";case 92:return"right window key";case 93:return"select";case 96:return"numpad 0";case 97:return"numpad 1";case 98:return"numpad 2";case 99:return"numpad 3";case 100:return"numpad 4";case 101:return"numpad 5";case 102:return"numpad 6";case 103:return"numpad 7";case 104:return"numpad 8";case 105:return"numpad 9";case 106:return"numpad *";case 107:return"numpad +";case 109:return"numpad -";case 110:return"numpad .";case 111:return"numpad /";case 112:return"F1";case 113:return"F2";
case 114:return"F3";case 115:return"F4";case 116:return"F5";case 117:return"F6";case 118:return"F7";case 119:return"F8";case 120:return"F9";case 121:return"F10";case 122:return"F11";case 123:return"F12";case 144:return"numlock";case 145:return"scroll lock";case 186:return";";case 187:return"=";case 188:return",";case 189:return"-";case 190:return".";case 191:return"/";case 192:return"'";case 219:return"[";case 220:return"\\";case 221:return"]";case 222:return"#";case 223:return"`";default:return String.fromCharCode(a)}}
var d=cr.plugins_.Keyboard.prototype;d.Type=function(a){this.plugin=a;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){};d.Instance=function(a){this.type=a;this.runtime=a.runtime;this.keyMap=Array(256);this.usedKeys=Array(256);this.triggerKey=0};var f=d.Instance.prototype;f.onCreate=function(){var a=this;this.runtime.isDomFree||(jQuery(document).keydown(function(b){a.onKeyDown(b)}),jQuery(document).keyup(function(b){a.onKeyUp(b)}))};var e=[32,33,34,35,36,37,38,39,40,44];f.onKeyDown=function(a){var b=
!1;window!=window.top&&-1<e.indexOf(a.which)&&(a.preventDefault(),b=!0,a.stopPropagation());if(this.keyMap[a.which])this.usedKeys[a.which]&&!b&&a.preventDefault();else{this.keyMap[a.which]=!0;this.triggerKey=a.which;this.runtime.isInUserInputEvent=!0;this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnAnyKey,this);var c=this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnKey,this),d=this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnKeyCode,this);this.runtime.isInUserInputEvent=
!1;if(c||d)this.usedKeys[a.which]=!0,b||a.preventDefault()}};f.onKeyUp=function(a){this.keyMap[a.which]=!1;this.triggerKey=a.which;this.runtime.isInUserInputEvent=!0;this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnAnyKeyReleased,this);var b=this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnKeyReleased,this),c=this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnKeyCodeReleased,this);this.runtime.isInUserInputEvent=!1;if(b||c||this.usedKeys[a.which])this.usedKeys[a.which]=
!0,a.preventDefault()};f.saveToJSON=function(){return{triggerKey:this.triggerKey}};f.loadFromJSON=function(a){this.triggerKey=a.triggerKey};a.prototype.IsKeyDown=function(a){return this.keyMap[a]};a.prototype.OnKey=function(a){return a===this.triggerKey};a.prototype.OnAnyKey=function(a){return!0};a.prototype.OnAnyKeyReleased=function(a){return!0};a.prototype.OnKeyReleased=function(a){return a===this.triggerKey};a.prototype.IsKeyCodeDown=function(a){a=Math.floor(a);return 0>a||a>=this.keyMap.length?
!1:this.keyMap[a]};a.prototype.OnKeyCode=function(a){return a===this.triggerKey};a.prototype.OnKeyCodeReleased=function(a){return a===this.triggerKey};d.cnds=new a;d.acts=new function(){};c.prototype.LastKeyCode=function(a){a.set_int(this.triggerKey)};c.prototype.StringFromKeyCode=function(a,c){a.set_string(b(c))};d.exps=new c})();cr.plugins_.Sprite=function(a){this.runtime=a};
(function(){function a(){if(0===this.datauri.length){var a=document.createElement("canvas");a.width=this.width;a.height=this.height;var b=a.getContext("2d");this.spritesheeted?b.drawImage(this.texture_img,this.offx,this.offy,this.width,this.height,0,0,this.width,this.height):b.drawImage(this.texture_img,0,0,this.width,this.height);this.datauri=a.toDataURL("image/png")}return this.datauri}function c(){}function b(a){a[0]=0;a[1]=0;a[2]=0;t.push(a)}function d(a,b){return a<b?""+a+","+b:""+b+","+a}function f(a,
b,c,e){b=b.uid;c=c.uid;var f=d(b,c);if(a.hasOwnProperty(f))a[f][2]=e;else{var h;h=t.length?t.pop():[0,0,0];h[0]=b;h[1]=c;h[2]=e;a[f]=h}}function e(a,c,e){c=d(c.uid,e.uid);a.hasOwnProperty(c)&&(b(a[c]),delete a[c])}function h(a,b,c){b=d(b.uid,c.uid);if(a.hasOwnProperty(b))return x=a[b][2],!0;x=-2;return!1}function p(a,b,c){if(!a)return!1;var d=0!==b||0!==c,e,f,h=!1,l,m=this.runtime.getCurrentCondition(),p=m.type,m=m.inverted,q=a.getCurrentSol();l=this.runtime.getCurrentEventStack().current_event.orblock;
q.select_all?(this.update_bbox(),this.runtime.getCollisionCandidates(this.layer,a,this.bbox,y),q=y):q=l?q.else_instances:q.instances;w=a;A=p!==a&&!m;d&&(e=this.x,f=this.y,this.x+=b,this.y+=c,this.set_bbox_changed());b=0;for(c=q.length;b<c;b++)if(l=q[b],this.runtime.testOverlap(this,l)){h=!0;if(m)break;p!==a&&v.add(l)}d&&(this.x=e,this.y=f,this.set_bbox_changed());y.length=0;return h}function m(){}function n(){}var l=cr.plugins_.Sprite.prototype;l.Type=function(a){this.plugin=a;this.runtime=a.runtime};
var q=l.Type.prototype;q.onCreate=function(){if(!this.is_family){var b,c,d,e,f,h,l,m,q;this.all_frames=[];this.has_loaded_textures=!1;b=0;for(c=this.animations.length;b<c;b++){f=this.animations[b];l={};l.name=f[0];l.speed=f[1];l.loop=f[2];l.repeatcount=f[3];l.repeatto=f[4];l.pingpong=f[5];l.sid=f[6];l.frames=[];d=0;for(e=f[7].length;d<e;d++)h=f[7][d],m={},m.texture_file=h[0],m.texture_filesize=h[1],m.offx=h[2],m.offy=h[3],m.width=h[4],m.height=h[5],m.duration=h[6],m.hotspotX=h[7],m.hotspotY=h[8],
m.image_points=h[9],m.poly_pts=h[10],m.pixelformat=h[11],m.spritesheeted=0!==m.width,m.datauri="",m.getDataUri=a,q={left:0,top:0,right:1,bottom:1},m.sheetTex=q,m.webGL_texture=null,(q=this.runtime.findWaitingTexture(h[0]))?m.texture_img=q:(m.texture_img=new Image,m.texture_img.idtkLoadDisposed=!0,m.texture_img.src=h[0],m.texture_img.cr_src=h[0],m.texture_img.cr_filesize=h[1],m.texture_img.c2webGL_texture=null,this.runtime.waitForImageLoad(m.texture_img)),cr.seal(m),l.frames.push(m),this.all_frames.push(m);
cr.seal(l);this.animations[b]=l}}};q.updateAllCurrentTexture=function(){var a,b,c;a=0;for(b=this.instances.length;a<b;a++)c=this.instances[a],c.curWebGLTexture=c.curFrame.webGL_texture};q.onLostWebGLContext=function(){if(!this.is_family){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],c.texture_img.c2webGL_texture=null,c.webGL_texture=null}};q.onRestoreWebGLContext=function(){if(!this.is_family&&this.instances.length){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],
c.webGL_texture=this.runtime.glwrap.loadTexture(c.texture_img,!1,this.runtime.linearSampling,c.pixelformat);this.updateAllCurrentTexture()}};q.loadTextures=function(){if(!this.is_family&&!this.has_loaded_textures&&this.runtime.glwrap){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],c.webGL_texture=this.runtime.glwrap.loadTexture(c.texture_img,!1,this.runtime.linearSampling,c.pixelformat);this.has_loaded_textures=!0}};q.unloadTextures=function(){if(!this.is_family&&!this.instances.length&&
this.has_loaded_textures){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],this.runtime.glwrap.deleteTexture(c.webGL_texture),c.webGL_texture=null;this.has_loaded_textures=!1}};var u=[];q.preloadCanvas2D=function(a){var b,c,d;b=u.length=0;for(c=this.all_frames.length;b<c;++b)d=this.all_frames[b].texture_img,-1===u.indexOf(d)&&(a.drawImage(d,0,0),u.push(d))};l.Instance=function(a){this.type=a;this.runtime=a.runtime;a=this.type.animations[0].frames[0].poly_pts;this.recycled?this.collision_poly.set_pts(a):
this.collision_poly=new cr.CollisionPoly(a)};var r=l.Instance.prototype;r.onCreate=function(){this.visible=0===this.properties[0];this.inAnimTrigger=this.isTicking=!1;this.collisionsEnabled=0!==this.properties[3];1===this.type.animations.length&&1===this.type.animations[0].frames.length||0===this.type.animations[0].speed||(this.runtime.tickMe(this),this.isTicking=!0);this.cur_animation=this.getAnimationByName(this.properties[1])||this.type.animations[0];this.cur_frame=this.properties[2];0>this.cur_frame&&
(this.cur_frame=0);this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1);var a=this.cur_animation.frames[this.cur_frame];this.collision_poly.set_pts(a.poly_pts);this.hotspotX=a.hotspotX;this.hotspotY=a.hotspotY;this.cur_anim_speed=this.cur_animation.speed;this.recycled?this.animTimer.reset():this.animTimer=new cr.KahanAdder;this.frameStart=this.getNowTime();this.animPlaying=!0;this.animRepeats=0;this.animForwards=!0;this.changeAnimName=this.animTriggerName=
"";this.changeAnimFrom=0;this.changeAnimFrame=-1;this.type.loadTextures();var b,c,d,e,f,h,l,a=0;for(b=this.type.animations.length;a<b;a++)for(e=this.type.animations[a],c=0,d=e.frames.length;c<d;c++)f=e.frames[c],0===f.width&&(f.width=f.texture_img.width,f.height=f.texture_img.height),f.spritesheeted&&(l=f.texture_img,h=f.sheetTex,h.left=f.offx/l.width,h.top=f.offy/l.height,h.right=(f.offx+f.width)/l.width,h.bottom=(f.offy+f.height)/l.height,0===f.offx&&0===f.offy&&f.width===l.width&&f.height===l.height&&
(f.spritesheeted=!1));this.curFrame=this.cur_animation.frames[this.cur_frame];this.curWebGLTexture=this.curFrame.webGL_texture};r.saveToJSON=function(){var a={a:this.cur_animation.sid,f:this.cur_frame,cas:this.cur_anim_speed,fs:this.frameStart,ar:this.animRepeats,at:this.animTimer.sum};this.animPlaying||(a.ap=this.animPlaying);this.animForwards||(a.af=this.animForwards);return a};r.loadFromJSON=function(a){var b=this.getAnimationBySid(a.a);b&&(this.cur_animation=b);this.cur_frame=a.f;0>this.cur_frame&&
(this.cur_frame=0);this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1);this.cur_anim_speed=a.cas;this.frameStart=a.fs;this.animRepeats=a.ar;this.animTimer.reset();this.animTimer.sum=a.at;this.animPlaying=a.hasOwnProperty("ap")?a.ap:!0;this.animForwards=a.hasOwnProperty("af")?a.af:!0;this.curFrame=this.cur_animation.frames[this.cur_frame];this.curWebGLTexture=this.curFrame.webGL_texture;this.collision_poly.set_pts(this.curFrame.poly_pts);this.hotspotX=
this.curFrame.hotspotX;this.hotspotY=this.curFrame.hotspotY};r.animationFinish=function(a){this.cur_frame=a?0:this.cur_animation.frames.length-1;this.animPlaying=!1;this.animTriggerName=this.cur_animation.name;this.inAnimTrigger=!0;this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,this);this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,this);this.inAnimTrigger=!1;this.animRepeats=0};r.getNowTime=function(){return this.animTimer.sum};r.tick=function(){this.animTimer.add(this.runtime.getDt(this));
this.changeAnimName.length&&this.doChangeAnim();0<=this.changeAnimFrame&&this.doChangeAnimFrame();var a=this.getNowTime(),b=this.cur_animation,c=b.frames[this.cur_frame],d=c.duration/this.cur_anim_speed;this.animPlaying&&a>=this.frameStart+d&&(this.animForwards?this.cur_frame++:this.cur_frame--,this.frameStart+=d,this.cur_frame>=b.frames.length&&(b.pingpong?(this.animForwards=!1,this.cur_frame=b.frames.length-2):b.loop?this.cur_frame=b.repeatto:(this.animRepeats++,this.animRepeats>=b.repeatcount?
this.animationFinish(!1):this.cur_frame=b.repeatto)),0>this.cur_frame&&(b.pingpong?(this.cur_frame=1,this.animForwards=!0,b.loop||(this.animRepeats++,this.animRepeats>=b.repeatcount&&this.animationFinish(!0))):b.loop?this.cur_frame=b.repeatto:(this.animRepeats++,this.animRepeats>=b.repeatcount?this.animationFinish(!0):this.cur_frame=b.repeatto)),0>this.cur_frame?this.cur_frame=0:this.cur_frame>=b.frames.length&&(this.cur_frame=b.frames.length-1),a>this.frameStart+b.frames[this.cur_frame].duration/
this.cur_anim_speed&&(this.frameStart=a),a=b.frames[this.cur_frame],this.OnFrameChanged(c,a),this.runtime.redraw=!0)};r.getAnimationByName=function(a){var b,c,d;b=0;for(c=this.type.animations.length;b<c;b++)if(d=this.type.animations[b],cr.equals_nocase(d.name,a))return d;return null};r.getAnimationBySid=function(a){var b,c,d;b=0;for(c=this.type.animations.length;b<c;b++)if(d=this.type.animations[b],d.sid===a)return d;return null};r.doChangeAnim=function(){var a=this.cur_animation.frames[this.cur_frame],
b=this.getAnimationByName(this.changeAnimName);this.changeAnimName="";!b||cr.equals_nocase(b.name,this.cur_animation.name)&&this.animPlaying||(this.cur_animation=b,this.cur_anim_speed=b.speed,0>this.cur_frame&&(this.cur_frame=0),this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1),1===this.changeAnimFrom&&(this.cur_frame=0),this.animPlaying=!0,this.frameStart=this.getNowTime(),this.animForwards=!0,this.OnFrameChanged(a,this.cur_animation.frames[this.cur_frame]),
this.runtime.redraw=!0)};r.doChangeAnimFrame=function(){var a=this.cur_animation.frames[this.cur_frame],b=this.cur_frame;this.cur_frame=cr.floor(this.changeAnimFrame);0>this.cur_frame&&(this.cur_frame=0);this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1);b!==this.cur_frame&&(this.OnFrameChanged(a,this.cur_animation.frames[this.cur_frame]),this.frameStart=this.getNowTime(),this.runtime.redraw=!0);this.changeAnimFrame=-1};r.OnFrameChanged=function(a,
b){var c=a.width,d=a.height,e=b.width,f=b.height;c!=e&&(this.width*=e/c);d!=f&&(this.height*=f/d);this.hotspotX=b.hotspotX;this.hotspotY=b.hotspotY;this.collision_poly.set_pts(b.poly_pts);this.set_bbox_changed();this.curFrame=b;this.curWebGLTexture=b.webGL_texture;c=0;for(d=this.behavior_insts.length;c<d;c++)if(e=this.behavior_insts[c],e.onSpriteFrameChanged)e.onSpriteFrameChanged(a,b);this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnFrameChanged,this)};r.draw=function(a){a.globalAlpha=this.opacity;
var b=this.curFrame,c=b.spritesheeted,d=b.texture_img,e=this.x,f=this.y,h=this.width,l=this.height;if(0===this.angle&&0<=h&&0<=l)e-=this.hotspotX*h,f-=this.hotspotY*l,this.runtime.pixel_rounding&&(e=e+0.5|0,f=f+0.5|0),c?a.drawImage(d,b.offx,b.offy,b.width,b.height,e,f,h,l):a.drawImage(d,e,f,h,l);else{this.runtime.pixel_rounding&&(e=e+0.5|0,f=f+0.5|0);a.save();var m=0<h?1:-1,q=0<l?1:-1;a.translate(e,f);1===m&&1===q||a.scale(m,q);a.rotate(this.angle*m*q);e=0-this.hotspotX*cr.abs(h);f=0-this.hotspotY*
cr.abs(l);c?a.drawImage(d,b.offx,b.offy,b.width,b.height,e,f,cr.abs(h),cr.abs(l)):a.drawImage(d,e,f,cr.abs(h),cr.abs(l));a.restore()}};r.drawGL=function(a){a.setTexture(this.curWebGLTexture);a.setOpacity(this.opacity);var b=this.curFrame,c=this.bquad;if(this.runtime.pixel_rounding){var d=(this.x+0.5|0)-this.x,e=(this.y+0.5|0)-this.y;b.spritesheeted?a.quadTex(c.tlx+d,c.tly+e,c.trx+d,c.try_+e,c.brx+d,c.bry+e,c.blx+d,c.bly+e,b.sheetTex):a.quad(c.tlx+d,c.tly+e,c.trx+d,c.try_+e,c.brx+d,c.bry+e,c.blx+d,
c.bly+e)}else b.spritesheeted?a.quadTex(c.tlx,c.tly,c.trx,c.try_,c.brx,c.bry,c.blx,c.bly,b.sheetTex):a.quad(c.tlx,c.tly,c.trx,c.try_,c.brx,c.bry,c.blx,c.bly)};r.getImagePointIndexByName=function(a){var b=this.curFrame,c,d;c=0;for(d=b.image_points.length;c<d;c++)if(cr.equals_nocase(a,b.image_points[c][0]))return c;return-1};r.getImagePoint=function(a,b){var c=this.curFrame,d=c.image_points,e;e=cr.is_string(a)?this.getImagePointIndexByName(a):a-1;e=cr.floor(e);if(0>e||e>=d.length)return b?this.x:this.y;
var f=(d[e][1]-c.hotspotX)*this.width,d=d[e][2],d=(d-c.hotspotY)*this.height,c=Math.cos(this.angle);e=Math.sin(this.angle);var h=f*c-d*e,d=d*c+f*e,f=h+this.x,d=d+this.y;return b?f:d};var t=[],x=-2,s=[];c.prototype.OnCollision=function(a){if(!a)return!1;var c=this.runtime,d=c.getCurrentCondition(),l=d.type;d.extra.collmemory||(d.extra.collmemory={},c.addDestroyCallback(function(a){return function(c){c=c.uid;var d,e;for(d in a)a.hasOwnProperty(d)&&(e=a[d],e[0]===c||e[1]===c)&&(b(a[d]),delete a[d])}}(d.extra.collmemory)));
var d=d.extra.collmemory,m=l.getCurrentSol(),q=a.getCurrentSol(),m=m.getObjects(),p,n,y,r,u,t,w,v=this.runtime.tickcount,A=v-1,J=c.getCurrentEventStack().current_event;for(n=0;n<m.length;n++){y=m[n];q.select_all?(y.update_bbox(),this.runtime.getCollisionCandidates(y.layer,a,y.bbox,s),p=s):p=q.getObjects();for(r=0;r<p.length;r++)u=p[r],c.testOverlap(y,u)||c.checkRegisteredCollision(y,u)?(t=h(d,y,u),t=!t||x<A,f(d,y,u,v),t&&(c.pushCopySol(J.solModifiers),t=l.getCurrentSol(),w=a.getCurrentSol(),t.select_all=
!1,w.select_all=!1,l===a?(t.instances.length=2,t.instances[0]=y,t.instances[1]=u,l.applySolToContainer()):(t.instances.length=1,w.instances.length=1,t.instances[0]=y,w.instances[0]=u,l.applySolToContainer(),a.applySolToContainer()),J.retrigger(),c.popSol(J.solModifiers))):e(d,y,u);s.length=0}return!1};var w=null,v=new cr.ObjectSet,A=!1,y=[];q.finish=function(a){if(A){if(a){var b=this.runtime.getCurrentEventStack().current_event.orblock;a=w.getCurrentSol();var c=v.valuesRef(),d,e;if(a.select_all){a.select_all=
!1;a.instances.length=c.length;d=0;for(e=c.length;d<e;d++)a.instances[d]=c[d];if(b)for(d=a.else_instances.length=0,e=w.instances.length;d<e;d++)c=w.instances[d],v.contains(c)||a.else_instances.push(c)}else if(b)for(b=a.instances.length,a.instances.length=b+c.length,d=0,e=c.length;d<e;d++)a.instances[b+d]=c[d],cr.arrayFindRemove(a.else_instances,c[d]);else cr.shallowAssignArray(a.instances,c);w.applySolToContainer()}v.clear();A=!1}};c.prototype.IsOverlapping=function(a){return p.call(this,a,0,0)};
c.prototype.IsOverlappingOffset=function(a,b,c){return p.call(this,a,b,c)};c.prototype.IsAnimPlaying=function(a){return this.changeAnimName.length?cr.equals_nocase(this.changeAnimName,a):cr.equals_nocase(this.cur_animation.name,a)};c.prototype.CompareFrame=function(a,b){return cr.do_cmp(this.cur_frame,a,b)};c.prototype.CompareAnimSpeed=function(a,b){return cr.do_cmp(this.animForwards?this.cur_anim_speed:-this.cur_anim_speed,a,b)};c.prototype.OnAnimFinished=function(a){return cr.equals_nocase(this.animTriggerName,
a)};c.prototype.OnAnyAnimFinished=function(){return!0};c.prototype.OnFrameChanged=function(){return!0};c.prototype.IsMirrored=function(){return 0>this.width};c.prototype.IsFlipped=function(){return 0>this.height};c.prototype.OnURLLoaded=function(){return!0};c.prototype.IsCollisionEnabled=function(){return this.collisionsEnabled};l.cnds=new c;m.prototype.Spawn=function(a,b,c){if(a&&b&&(b=this.runtime.createInstance(a,b,this.getImagePoint(c,!0),this.getImagePoint(c,!1)))){"undefined"!==typeof b.angle&&
(b.angle=this.angle,b.set_bbox_changed());this.runtime.isInOnDestroy++;var d,e,f;this.runtime.trigger(Object.getPrototypeOf(a.plugin).cnds.OnCreated,b);if(b.is_contained)for(d=0,e=b.siblings.length;d<e;d++)f=b.siblings[d],this.runtime.trigger(Object.getPrototypeOf(f.type.plugin).cnds.OnCreated,f);this.runtime.isInOnDestroy--;d=this.runtime.getCurrentAction();c=!1;if(cr.is_undefined(d.extra.Spawn_LastExec)||d.extra.Spawn_LastExec<this.runtime.execcount)c=!0,d.extra.Spawn_LastExec=this.runtime.execcount;
if(a!=this.type&&(a=a.getCurrentSol(),a.select_all=!1,c?(a.instances.length=1,a.instances[0]=b):a.instances.push(b),b.is_contained))for(d=0,e=b.siblings.length;d<e;d++)f=b.siblings[d],a=f.type.getCurrentSol(),a.select_all=!1,c?(a.instances.length=1,a.instances[0]=f):a.instances.push(f)}};m.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);this.runtime.redraw=!0};m.prototype.StopAnim=function(){this.animPlaying=!1};m.prototype.StartAnim=
function(a){this.animPlaying=!0;this.frameStart=this.getNowTime();1===a&&0!==this.cur_frame&&(this.changeAnimFrame=0,this.inAnimTrigger||this.doChangeAnimFrame());this.isTicking||(this.runtime.tickMe(this),this.isTicking=!0)};m.prototype.SetAnim=function(a,b){this.changeAnimName=a;this.changeAnimFrom=b;this.isTicking||(this.runtime.tickMe(this),this.isTicking=!0);this.inAnimTrigger||this.doChangeAnim()};m.prototype.SetAnimFrame=function(a){this.changeAnimFrame=a;this.isTicking||(this.runtime.tickMe(this),
this.isTicking=!0);this.inAnimTrigger||this.doChangeAnimFrame()};m.prototype.SetAnimSpeed=function(a){this.cur_anim_speed=cr.abs(a);this.animForwards=0<=a;this.isTicking||(this.runtime.tickMe(this),this.isTicking=!0)};m.prototype.SetMirrored=function(a){a=cr.abs(this.width)*(0===a?-1:1);this.width!==a&&(this.width=a,this.set_bbox_changed())};m.prototype.SetFlipped=function(a){a=cr.abs(this.height)*(0===a?-1:1);this.height!==a&&(this.height=a,this.set_bbox_changed())};m.prototype.SetScale=function(a){var b=
this.curFrame,c=b.width*a*(0>this.width?-1:1);a=b.height*a*(0>this.height?-1:1);if(this.width!==c||this.height!==a)this.width=c,this.height=a,this.set_bbox_changed()};m.prototype.LoadURL=function(a,b){var c=new Image,d=this,e=this.curFrame;c.onload=function(){e.texture_img.src===c.src?d.runtime.glwrap&&d.curFrame===e&&(d.curWebGLTexture=e.webGL_texture):(e.texture_img=c,e.offx=0,e.offy=0,e.width=c.width,e.height=c.height,e.spritesheeted=!1,e.datauri="",d.runtime.glwrap&&(e.webGL_texture&&d.runtime.glwrap.deleteTexture(e.webGL_texture),
e.webGL_texture=d.runtime.glwrap.loadTexture(c,!1,d.runtime.linearSampling),d.curFrame===e&&(d.curWebGLTexture=e.webGL_texture),d.type.updateAllCurrentTexture()),0===b&&(d.width=c.width,d.height=c.height,d.set_bbox_changed()));d.runtime.redraw=!0;d.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnURLLoaded,d)};"data:"!==a.substr(0,5)&&(c.crossOrigin="anonymous");c.src=a};m.prototype.SetCollisions=function(a){this.collisionsEnabled!==(0!==a)&&((this.collisionsEnabled=0!==a)?this.set_bbox_changed():
(this.collcells.right>=this.collcells.left&&this.type.collision_grid.update(this,this.collcells,null),this.collcells.set(0,0,-1,-1)))};l.acts=new m;n.prototype.AnimationFrame=function(a){a.set_int(this.cur_frame)};n.prototype.AnimationFrameCount=function(a){a.set_int(this.cur_animation.frames.length)};n.prototype.AnimationName=function(a){a.set_string(this.cur_animation.name)};n.prototype.AnimationSpeed=function(a){a.set_float(this.animForwards?this.cur_anim_speed:-this.cur_anim_speed)};n.prototype.ImagePointX=
function(a,b){a.set_float(this.getImagePoint(b,!0))};n.prototype.ImagePointY=function(a,b){a.set_float(this.getImagePoint(b,!1))};n.prototype.ImagePointCount=function(a){a.set_int(this.curFrame.image_points.length)};n.prototype.ImageWidth=function(a){a.set_float(this.curFrame.width)};n.prototype.ImageHeight=function(a){a.set_float(this.curFrame.height)};l.exps=new n})();cr.plugins_.Text=function(a){this.runtime=a};
(function(){function a(){return n.length?n.pop():{}}function c(a){var b,c;b=0;for(c=a.length;b<c;b++)n.push(a[b]);a.length=0}function b(){}function d(){}function f(){}var e=cr.plugins_.Text.prototype;e.onCreate=function(){e.acts.SetWidth=function(a){this.width!==a&&(this.width=a,this.text_changed=!0,this.set_bbox_changed())}};e.Type=function(a){this.plugin=a;this.runtime=a.runtime};var h=e.Type.prototype;h.onCreate=function(){};h.onLostWebGLContext=function(){if(!this.is_family){var a,b,c;a=0;for(b=
this.instances.length;a<b;a++)c=this.instances[a],c.mycanvas=null,c.myctx=null,c.mytex=null}};e.Instance=function(a){this.type=a;this.runtime=a.runtime;this.recycled?this.lines.length=0:this.lines=[];this.text_changed=!0};var h=e.Instance.prototype,p={};h.onCreate=function(){this.text=this.properties[0];this.visible=0===this.properties[1];this.font=this.properties[2];this.color=this.properties[3];this.halign=this.properties[4];this.valign=this.properties[5];this.wrapbyword=0===this.properties[7];
this.lastwrapwidth=this.lastwidth=this.width;this.lastheight=this.height;this.line_height_offset=this.properties[8];this.fontstyle=this.facename="";this.textHeight=this.textWidth=this.ptSize=0;this.parseFont();this.mytex=this.myctx=this.mycanvas=null;this.need_text_redraw=!1;this.last_render_tick=this.runtime.tickcount;this.recycled?this.rcTex.set(0,0,1,1):this.rcTex=new cr.rect(0,0,1,1);this.runtime.glwrap&&this.runtime.tickMe(this)};h.parseFont=function(){var a=this.font.split(" "),b;for(b=0;b<
a.length;b++)if("pt"===a[b].substr(a[b].length-2,2)){this.ptSize=parseInt(a[b].substr(0,a[b].length-2));this.pxHeight=Math.ceil(96*(this.ptSize/72))+4;0<b&&(this.fontstyle=a[b-1]);this.facename=a[b+1];for(b+=2;b<a.length;b++)this.facename+=" "+a[b];break}};h.saveToJSON=function(){return{t:this.text,f:this.font,c:this.color,ha:this.halign,va:this.valign,wr:this.wrapbyword,lho:this.line_height_offset,fn:this.facename,fs:this.fontstyle,ps:this.ptSize,pxh:this.pxHeight,tw:this.textWidth,th:this.textHeight,
lrt:this.last_render_tick}};h.loadFromJSON=function(a){this.text=a.t;this.font=a.f;this.color=a.c;this.halign=a.ha;this.valign=a.va;this.wrapbyword=a.wr;this.line_height_offset=a.lho;this.facename=a.fn;this.fontstyle=a.fs;this.ptSize=a.ps;this.pxHeight=a.pxh;this.textWidth=a.tw;this.textHeight=a.th;this.last_render_tick=a.lrt;this.text_changed=!0;this.lastwrapwidth=this.lastwidth=this.width;this.lastheight=this.height};h.tick=function(){if(this.runtime.glwrap&&this.mytex&&300<=this.runtime.tickcount-
this.last_render_tick){var a=this.layer;this.update_bbox();var b=this.bbox;if(b.right<a.viewLeft||b.bottom<a.viewTop||b.left>a.viewRight||b.top>a.viewBottom)this.runtime.glwrap.deleteTexture(this.mytex),this.mycanvas=this.myctx=this.mytex=null}};h.onDestroy=function(){this.mycanvas=this.myctx=null;this.runtime.glwrap&&this.mytex&&this.runtime.glwrap.deleteTexture(this.mytex);this.mytex=null};h.updateFont=function(){this.font=this.fontstyle+" "+this.ptSize.toString()+"pt "+this.facename;this.text_changed=
!0;this.runtime.redraw=!0};h.draw=function(a,b){a.font=this.font;a.textBaseline="top";a.fillStyle=this.color;a.globalAlpha=b?1:this.opacity;var c=1;b&&(c=this.layer.getScale(),a.save(),a.scale(c,c));if(this.text_changed||this.width!==this.lastwrapwidth)this.type.plugin.WordWrap(this.text,this.lines,a,this.width,this.wrapbyword),this.text_changed=!1,this.lastwrapwidth=this.width;this.update_bbox();var c=b?0:this.bquad.tlx,d=b?0:this.bquad.tly;this.runtime.pixel_rounding&&(c=c+0.5|0,d=d+0.5|0);0===
this.angle||b||(a.save(),a.translate(c,d),a.rotate(this.angle),d=c=0);var e=d+this.height,f=this.pxHeight,f=f+this.line_height_offset,h,m;1===this.valign?d+=Math.max(this.height/2-this.lines.length*f/2,0):2===this.valign&&(d+=Math.max(this.height-this.lines.length*f-2,0));for(m=0;m<this.lines.length&&!(h=c,1===this.halign?h=c+(this.width-this.lines[m].width)/2:2===this.halign&&(h=c+(this.width-this.lines[m].width)),a.fillText(this.lines[m].text,h,d),d+=f,d>=e-f);m++);(0!==this.angle||b)&&a.restore();
this.last_render_tick=this.runtime.tickcount};h.drawGL=function(a){if(!(1>this.width||1>this.height)){var b=this.text_changed||this.need_text_redraw;this.need_text_redraw=!1;var c=this.layer.getScale(),d=this.layer.getAngle(),e=this.rcTex,f=c*this.width,h=c*this.height,m=Math.ceil(f),p=Math.ceil(h),n=this.runtime.draw_width/2,y=this.runtime.draw_height/2;this.myctx||(this.mycanvas=document.createElement("canvas"),this.mycanvas.width=m,this.mycanvas.height=p,this.lastwidth=m,this.lastheight=p,b=!0,
this.myctx=this.mycanvas.getContext("2d"));if(m!==this.lastwidth||p!==this.lastheight)this.mycanvas.width=m,this.mycanvas.height=p,this.mytex&&(a.deleteTexture(this.mytex),this.mytex=null),b=!0;b&&(this.myctx.clearRect(0,0,m,p),this.draw(this.myctx,!0),this.mytex||(this.mytex=a.createEmptyTexture(m,p,this.runtime.linearSampling,this.runtime.isMobile)),a.videoToTexture(this.mycanvas,this.mytex,this.runtime.isMobile));this.lastwidth=m;this.lastheight=p;a.setTexture(this.mytex);a.setOpacity(this.opacity);
a.resetModelView();a.translate(-n,-y);a.updateModelView();var g=this.bquad,b=this.layer.layerToCanvas(g.tlx,g.tly,!0,!0),n=this.layer.layerToCanvas(g.tlx,g.tly,!1,!0),y=this.layer.layerToCanvas(g.trx,g.try_,!0,!0),k=this.layer.layerToCanvas(g.trx,g.try_,!1,!0),C=this.layer.layerToCanvas(g.brx,g.bry,!0,!0),z=this.layer.layerToCanvas(g.brx,g.bry,!1,!0),G=this.layer.layerToCanvas(g.blx,g.bly,!0,!0),g=this.layer.layerToCanvas(g.blx,g.bly,!1,!0);if(this.runtime.pixel_rounding||0===this.angle&&0===d)var D=
(b+0.5|0)-b,H=(n+0.5|0)-n,b=b+D,n=n+H,y=y+D,k=k+H,C=C+D,z=z+H,G=G+D,g=g+H;0===this.angle&&0===d?(y=b+m,k=n,C=y,z=n+p,G=b,g=z,e.right=1,e.bottom=1):(e.right=f/m,e.bottom=h/p);a.quadTex(b,n,y,k,C,z,G,g,e);a.resetModelView();a.scale(c,c);a.rotateZ(-this.layer.getAngle());a.translate((this.layer.viewLeft+this.layer.viewRight)/-2,(this.layer.viewTop+this.layer.viewBottom)/-2);a.updateModelView();this.last_render_tick=this.runtime.tickcount}};var m=[];e.TokeniseWords=function(a){m.length=0;for(var b="",
c,d=0;d<a.length;)if(c=a.charAt(d),"\n"===c)b.length&&(m.push(b),b=""),m.push("\n"),++d;else if(" "===c||"\t"===c||"-"===c){do b+=a.charAt(d),d++;while(d<a.length&&(" "===a.charAt(d)||"\t"===a.charAt(d)));m.push(b);b=""}else d<a.length&&(b+=c,d++);b.length&&m.push(b)};var n=[];e.WordWrap=function(b,d,e,f,h){if(b&&b.length)if(2>=f)c(d);else{if(100>=b.length&&-1===b.indexOf("\n")){var m=e.measureText(b).width;if(m<=f){c(d);d.push(a());d[0].text=b;d[0].width=m;return}}this.WrapText(b,d,e,f,h)}else c(d)};
e.WrapText=function(b,c,d,e,f){f&&(this.TokeniseWords(b),b=m);var h="",p,w,v,A=0;for(v=0;v<b.length;v++)"\n"===b[v]?(A>=c.length&&c.push(a()),w=c[A],w.text=h,w.width=d.measureText(h).width,A++,h=""):(p=h,h+=b[v],w=d.measureText(h).width,w>=e&&(A>=c.length&&c.push(a()),w=c[A],w.text=p,w.width=d.measureText(p).width,A++,h=b[v],f||" "!==h||(h="")));h.length&&(A>=c.length&&c.push(a()),w=c[A],w.text=h,w.width=d.measureText(h).width,A++);for(v=A;v<c.length;v++)n.push(c[v]);c.length=A};b.prototype.CompareText=
function(a,b){return b?this.text==a:cr.equals_nocase(this.text,a)};e.cnds=new b;d.prototype.SetText=function(a){cr.is_number(a)&&1E9>a&&(a=Math.round(1E10*a)/1E10);a=a.toString();this.text!==a&&(this.text=a,this.text_changed=!0,this.runtime.redraw=!0)};d.prototype.AppendText=function(a){cr.is_number(a)&&(a=Math.round(1E10*a)/1E10);if(a=a.toString())this.text+=a,this.text_changed=!0,this.runtime.redraw=!0};d.prototype.SetFontFace=function(a,b){var c="";switch(b){case 1:c="bold";break;case 2:c="italic";
break;case 3:c="bold italic"}if(a!==this.facename||c!==this.fontstyle)this.facename=a,this.fontstyle=c,this.updateFont()};d.prototype.SetFontSize=function(a){this.ptSize!==a&&(this.ptSize=a,this.pxHeight=Math.ceil(96*(this.ptSize/72))+4,this.updateFont())};d.prototype.SetFontColor=function(a){a="rgb("+cr.GetRValue(a).toString()+","+cr.GetGValue(a).toString()+","+cr.GetBValue(a).toString()+")";a!==this.color&&(this.color=a,this.need_text_redraw=!0,this.runtime.redraw=!0)};d.prototype.SetWebFont=function(a,
b){if(this.runtime.isDomFree)cr.logexport("[Construct 2] Text plugin: 'Set web font' not supported on this platform - the action has been ignored");else{var c=this,d=function(){c.runtime.redraw=!0;c.text_changed=!0};if(p.hasOwnProperty(b)){var e="'"+a+"'";if(this.facename!==e)for(this.facename=e,this.updateFont(),e=1;10>e;e++)setTimeout(d,100*e),setTimeout(d,1E3*e)}else for(e=document.createElement("link"),e.href=b,e.rel="stylesheet",e.type="text/css",e.onload=d,document.getElementsByTagName("head")[0].appendChild(e),
p[b]=!0,this.facename="'"+a+"'",this.updateFont(),e=1;10>e;e++)setTimeout(d,100*e),setTimeout(d,1E3*e)}};d.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);this.runtime.redraw=!0};e.acts=new d;f.prototype.Text=function(a){a.set_string(this.text)};f.prototype.FaceName=function(a){a.set_string(this.facename)};f.prototype.FaceSize=function(a){a.set_int(this.ptSize)};f.prototype.TextWidth=function(a){var b=0,c,d,e;c=0;for(d=this.lines.length;c<
d;c++)e=this.lines[c].width,b<e&&(b=e);a.set_int(b)};f.prototype.TextHeight=function(a){a.set_int(this.lines.length*(this.pxHeight+this.line_height_offset)-this.line_height_offset)};e.exps=new f})();cr.plugins_.TiledBg=function(a){this.runtime=a};
(function(){function a(){}function c(){}function b(){}var d=cr.plugins_.TiledBg.prototype;d.Type=function(a){this.plugin=a;this.runtime=a.runtime};var f=d.Type.prototype;f.onCreate=function(){this.is_family||(this.texture_img=new Image,this.texture_img.idtkLoadDisposed=!0,this.texture_img.src=this.texture_file,this.texture_img.cr_filesize=this.texture_filesize,this.runtime.waitForImageLoad(this.texture_img),this.webGL_texture=this.pattern=null)};f.onLostWebGLContext=function(){this.is_family||(this.webGL_texture=
null)};f.onRestoreWebGLContext=function(){if(!this.is_family&&this.instances.length){this.webGL_texture||(this.webGL_texture=this.runtime.glwrap.loadTexture(this.texture_img,!0,this.runtime.linearSampling,this.texture_pixelformat));var a,b;a=0;for(b=this.instances.length;a<b;a++)this.instances[a].webGL_texture=this.webGL_texture}};f.loadTextures=function(){this.is_family||this.webGL_texture||!this.runtime.glwrap||(this.webGL_texture=this.runtime.glwrap.loadTexture(this.texture_img,!0,this.runtime.linearSampling,
this.texture_pixelformat))};f.unloadTextures=function(){this.is_family||this.instances.length||!this.webGL_texture||(this.runtime.glwrap.deleteTexture(this.webGL_texture),this.webGL_texture=null)};f.preloadCanvas2D=function(a){a.drawImage(this.texture_img,0,0)};d.Instance=function(a){this.type=a;this.runtime=a.runtime};f=d.Instance.prototype;f.onCreate=function(){this.visible=0===this.properties[0];this.rcTex=new cr.rect(0,0,0,0);this.has_own_texture=!1;this.texture_img=this.type.texture_img;this.runtime.glwrap?
(this.type.loadTextures(),this.webGL_texture=this.type.webGL_texture):(this.type.pattern||(this.type.pattern=this.runtime.ctx.createPattern(this.type.texture_img,"repeat")),this.pattern=this.type.pattern)};f.afterLoad=function(){this.has_own_texture=!1;this.texture_img=this.type.texture_img};f.onDestroy=function(){this.runtime.glwrap&&this.has_own_texture&&this.webGL_texture&&(this.runtime.glwrap.deleteTexture(this.webGL_texture),this.webGL_texture=null)};f.draw=function(a){a.globalAlpha=this.opacity;
a.save();a.fillStyle=this.pattern;var b=this.x,c=this.y;this.runtime.pixel_rounding&&(b=b+0.5|0,c=c+0.5|0);var d=-(this.hotspotX*this.width),f=-(this.hotspotY*this.height),l=d%this.texture_img.width,q=f%this.texture_img.height;0>l&&(l+=this.texture_img.width);0>q&&(q+=this.texture_img.height);a.translate(b,c);a.rotate(this.angle);a.translate(l,q);a.fillRect(d-l,f-q,this.width,this.height);a.restore()};f.drawGL=function(a){a.setTexture(this.webGL_texture);a.setOpacity(this.opacity);var b=this.rcTex;
b.right=this.width/this.texture_img.width;b.bottom=this.height/this.texture_img.height;var c=this.bquad;if(this.runtime.pixel_rounding){var d=(this.x+0.5|0)-this.x,f=(this.y+0.5|0)-this.y;a.quadTex(c.tlx+d,c.tly+f,c.trx+d,c.try_+f,c.brx+d,c.bry+f,c.blx+d,c.bly+f,b)}else a.quadTex(c.tlx,c.tly,c.trx,c.try_,c.brx,c.bry,c.blx,c.bly,b)};a.prototype.OnURLLoaded=function(){return!0};d.cnds=new a;c.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);
this.runtime.redraw=!0};c.prototype.LoadURL=function(a){var b=new Image,c=this;b.onload=function(){c.texture_img=b;c.runtime.glwrap?(c.has_own_texture&&c.webGL_texture&&c.runtime.glwrap.deleteTexture(c.webGL_texture),c.webGL_texture=c.runtime.glwrap.loadTexture(b,!0,c.runtime.linearSampling)):c.pattern=c.runtime.ctx.createPattern(b,"repeat");c.has_own_texture=!0;c.runtime.redraw=!0;c.runtime.trigger(cr.plugins_.TiledBg.prototype.cnds.OnURLLoaded,c)};"data:"!==a.substr(0,5)&&(b.crossOrigin="anonymous");
b.src=a};d.acts=new c;b.prototype.ImageWidth=function(a){a.set_float(this.texture_img.width)};b.prototype.ImageHeight=function(a){a.set_float(this.texture_img.height)};d.exps=new b})();cr.plugins_.Touch=function(a){this.runtime=a};
(function(){function a(a){n=a.x;l=a.y;q=a.z}function c(a){u=a.x;r=a.y;t=a.z}function b(a,b,c,e){var f;f=x.length?x.pop():new d;f.init(a,b,c,e);return f}function d(){this.startindex=this.id=this.lasty=this.lastx=this.y=this.x=this.starty=this.startx=this.lasttime=this.time=this.starttime=0;this.tooFarForHold=this.triggeredHold=!1}function f(){}function e(){}var h=cr.plugins_.Touch.prototype;h.Type=function(a){this.plugin=a;this.runtime=a.runtime};h.Type.prototype.onCreate=function(){};h.Instance=function(a){this.type=
a;this.runtime=a.runtime;this.touches=[];this.mouseDown=!1};var p=h.Instance.prototype,m={left:0,top:0};p.findTouch=function(a){var b,c;b=0;for(c=this.touches.length;b<c;b++)if(this.touches[b].id===a)return b;return-1};var n=0,l=0,q=0,u=0,r=0,t=0,x=[];d.prototype.init=function(a,b,c,d){var e=cr.performance_now();this.starttime=this.lasttime=this.time=e;this.startx=a;this.starty=b;this.x=a;this.y=b;this.lastx=a;this.lasty=b;this.id=c;this.startindex=d;this.tooFarForHold=this.triggeredHold=!1};d.prototype.update=
function(a,b,c){this.lasttime=this.time;this.time=a;this.lastx=this.x;this.lasty=this.y;this.x=b;this.y=c;!this.tooFarForHold&&15<=cr.distanceTo(this.startx,this.starty,this.x,this.y)&&(this.tooFarForHold=!0)};d.prototype.maybeTriggerHold=function(a,b){!this.triggeredHold&&500<=cr.performance_now()-this.starttime&&!this.tooFarForHold&&15>cr.distanceTo(this.startx,this.starty,this.x,this.y)&&(this.triggeredHold=!0,a.trigger_index=this.startindex,a.trigger_id=this.id,a.getTouchIndex=b,a.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnHoldGesture,
a),a.curTouchX=this.x,a.curTouchY=this.y,a.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnHoldGestureObject,a),a.getTouchIndex=0)};var s=-1E3,w=-1E3,v=-1E4;d.prototype.maybeTriggerTap=function(a,b){if(!this.triggeredHold){var c=cr.performance_now();333>=c-this.starttime&&!this.tooFarForHold&&15>cr.distanceTo(this.startx,this.starty,this.x,this.y)&&(a.trigger_index=this.startindex,a.trigger_id=this.id,a.getTouchIndex=b,666>=c-v&&25>cr.distanceTo(s,w,this.x,this.y)?(a.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnDoubleTapGesture,
a),a.curTouchX=this.x,a.curTouchY=this.y,a.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnDoubleTapGestureObject,a),w=s=-1E3,v=-1E4):(a.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTapGesture,a),a.curTouchX=this.x,a.curTouchY=this.y,a.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTapGestureObject,a),s=this.x,w=this.y,v=c),a.getTouchIndex=0)}};p.onCreate=function(){this.isWindows8=!("undefined"===typeof window.c2isWindows8||!window.c2isWindows8);this.getTouchIndex=this.trigger_id=this.trigger_index=
this.curTouchY=this.curTouchX=this.acc_z=this.acc_y=this.acc_x=this.acc_g_z=this.acc_g_y=this.acc_g_x=this.orient_gamma=this.orient_beta=this.orient_alpha=0;this.useMouseInput=0!==this.properties[0];var b=0<this.runtime.fullscreen_mode?document:this.runtime.canvas,d=document;this.runtime.isDirectCanvas?d=b=window.Canvas:this.runtime.isCocoonJs&&(d=b=window);var e=this;window.navigator.pointerEnabled?(b.addEventListener("pointerdown",function(a){e.onPointerStart(a)},!1),b.addEventListener("pointermove",
function(a){e.onPointerMove(a)},!1),d.addEventListener("pointerup",function(a){e.onPointerEnd(a,!1)},!1),d.addEventListener("pointercancel",function(a){e.onPointerEnd(a,!0)},!1),this.runtime.canvas&&(this.runtime.canvas.addEventListener("MSGestureHold",function(a){a.preventDefault()},!1),document.addEventListener("MSGestureHold",function(a){a.preventDefault()},!1),this.runtime.canvas.addEventListener("gesturehold",function(a){a.preventDefault()},!1),document.addEventListener("gesturehold",function(a){a.preventDefault()},
!1))):window.navigator.msPointerEnabled?(b.addEventListener("MSPointerDown",function(a){e.onPointerStart(a)},!1),b.addEventListener("MSPointerMove",function(a){e.onPointerMove(a)},!1),d.addEventListener("MSPointerUp",function(a){e.onPointerEnd(a,!1)},!1),d.addEventListener("MSPointerCancel",function(a){e.onPointerEnd(a,!0)},!1),this.runtime.canvas&&(this.runtime.canvas.addEventListener("MSGestureHold",function(a){a.preventDefault()},!1),document.addEventListener("MSGestureHold",function(a){a.preventDefault()},
!1))):(b.addEventListener("touchstart",function(a){e.onTouchStart(a)},!1),b.addEventListener("touchmove",function(a){e.onTouchMove(a)},!1),d.addEventListener("touchend",function(a){e.onTouchEnd(a,!1)},!1),d.addEventListener("touchcancel",function(a){e.onTouchEnd(a,!0)},!1));if(this.isWindows8){var f=function(a){a=a.reading;e.acc_x=a.accelerationX;e.acc_y=a.accelerationY;e.acc_z=a.accelerationZ},h=function(a){a=a.reading;e.orient_alpha=a.yawDegrees;e.orient_beta=a.pitchDegrees;e.orient_gamma=a.rollDegrees},
l=Windows.Devices.Sensors.Accelerometer.getDefault();l&&(l.reportInterval=Math.max(l.minimumReportInterval,16),l.addEventListener("readingchanged",f));var m=Windows.Devices.Sensors.Inclinometer.getDefault();m&&(m.reportInterval=Math.max(m.minimumReportInterval,16),m.addEventListener("readingchanged",h));document.addEventListener("visibilitychange",function(a){document.hidden||document.msHidden?(l&&l.removeEventListener("readingchanged",f),m&&m.removeEventListener("readingchanged",h)):(l&&l.addEventListener("readingchanged",
f),m&&m.addEventListener("readingchanged",h))},!1)}else window.addEventListener("deviceorientation",function(a){e.orient_alpha=a.alpha||0;e.orient_beta=a.beta||0;e.orient_gamma=a.gamma||0},!1),window.addEventListener("devicemotion",function(a){a.accelerationIncludingGravity&&(e.acc_g_x=a.accelerationIncludingGravity.x||0,e.acc_g_y=a.accelerationIncludingGravity.y||0,e.acc_g_z=a.accelerationIncludingGravity.z||0);a.acceleration&&(e.acc_x=a.acceleration.x||0,e.acc_y=a.acceleration.y||0,e.acc_z=a.acceleration.z||
0)},!1);this.useMouseInput&&!this.runtime.isDomFree&&(jQuery(document).mousemove(function(a){e.onMouseMove(a)}),jQuery(document).mousedown(function(a){e.onMouseDown(a)}),jQuery(document).mouseup(function(a){e.onMouseUp(a)}));this.runtime.isAppMobi&&!this.runtime.isDirectCanvas&&AppMobi.accelerometer.watchAcceleration(a,{frequency:40,adjustForRotation:!0});this.runtime.isPhoneGap&&navigator.accelerometer&&navigator.accelerometer.watchAcceleration&&navigator.accelerometer.watchAcceleration(c,null,{frequency:40});
this.runtime.tick2Me(this)};p.onPointerMove=function(a){if(a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType){a.preventDefault&&a.preventDefault();var b=this.findTouch(a.pointerId),c=cr.performance_now();if(0<=b){var d=this.runtime.isDomFree?m:jQuery(this.runtime.canvas).offset(),b=this.touches[b];2>c-b.time||b.update(c,a.pageX-d.left,a.pageY-d.top)}}};p.onPointerStart=function(a){if(a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType){a.preventDefault&&cr.isCanvasInputEvent(a)&&
a.preventDefault();var c=this.runtime.isDomFree?m:jQuery(this.runtime.canvas).offset(),d=a.pageX-c.left,c=a.pageY-c.top;cr.performance_now();this.trigger_index=this.touches.length;this.trigger_id=a.pointerId;this.touches.push(b(d,c,a.pointerId,this.trigger_index));this.runtime.isInUserInputEvent=!0;this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,this);this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart,this);this.curTouchX=d;this.curTouchY=c;this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject,
this);this.runtime.isInUserInputEvent=!1}};p.onPointerEnd=function(a,b){if(a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType){a.preventDefault&&cr.isCanvasInputEvent(a)&&a.preventDefault();var c=this.findTouch(a.pointerId);this.trigger_index=0<=c?this.touches[c].startindex:-1;this.trigger_id=0<=c?this.touches[c].id:-1;this.runtime.isInUserInputEvent=!0;this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,this);this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd,
this);0<=c&&(b||this.touches[c].maybeTriggerTap(this,c),100>x.length&&x.push(this.touches[c]),this.touches.splice(c,1));this.runtime.isInUserInputEvent=!1}};p.onTouchMove=function(a){a.preventDefault&&a.preventDefault();var b=cr.performance_now(),c,d,e,f;c=0;for(d=a.changedTouches.length;c<d;c++)if(e=a.changedTouches[c],f=this.findTouch(e.identifier),0<=f){var h=this.runtime.isDomFree?m:jQuery(this.runtime.canvas).offset();f=this.touches[f];2>b-f.time||f.update(b,e.pageX-h.left,e.pageY-h.top)}};p.onTouchStart=
function(a){a.preventDefault&&cr.isCanvasInputEvent(a)&&a.preventDefault();var c=this.runtime.isDomFree?m:jQuery(this.runtime.canvas).offset();cr.performance_now();this.runtime.isInUserInputEvent=!0;var d,e,f,h;d=0;for(e=a.changedTouches.length;d<e;d++)if(f=a.changedTouches[d],h=this.findTouch(f.identifier),-1===h){h=f.pageX-c.left;var l=f.pageY-c.top;this.trigger_index=this.touches.length;this.trigger_id=f.identifier;this.touches.push(b(h,l,f.identifier,this.trigger_index));this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,
this);this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart,this);this.curTouchX=h;this.curTouchY=l;this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject,this)}this.runtime.isInUserInputEvent=!1};p.onTouchEnd=function(a,b){a.preventDefault&&cr.isCanvasInputEvent(a)&&a.preventDefault();this.runtime.isInUserInputEvent=!0;var c,d,e;c=0;for(d=a.changedTouches.length;c<d;c++)e=a.changedTouches[c],e=this.findTouch(e.identifier),0<=e&&(this.trigger_index=this.touches[e].startindex,
this.trigger_id=this.touches[e].id,this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,this),this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd,this),b||this.touches[e].maybeTriggerTap(this,e),100>x.length&&x.push(this.touches[e]),this.touches.splice(e,1));this.runtime.isInUserInputEvent=!1};p.getAlpha=function(){return this.runtime.isAppMobi&&0===this.orient_alpha&&0!==q?90*q:this.runtime.isPhoneGap&&0===this.orient_alpha&&0!==t?90*t:this.orient_alpha};p.getBeta=function(){return this.runtime.isAppMobi&&
0===this.orient_beta&&0!==l?-90*l:this.runtime.isPhoneGap&&0===this.orient_beta&&0!==r?-90*r:this.orient_beta};p.getGamma=function(){return this.runtime.isAppMobi&&0===this.orient_gamma&&0!==n?90*n:this.runtime.isPhoneGap&&0===this.orient_gamma&&0!==u?90*u:this.orient_gamma};p.onMouseDown=function(a){a.preventDefault&&this.runtime.had_a_click&&!this.runtime.isMobile&&a.preventDefault();this.onTouchStart({changedTouches:[{pageX:a.pageX,pageY:a.pageY,identifier:0}]});this.mouseDown=!0};p.onMouseMove=
function(a){if(this.mouseDown)this.onTouchMove({changedTouches:[{pageX:a.pageX,pageY:a.pageY,identifier:0}]})};p.onMouseUp=function(a){a.preventDefault&&this.runtime.had_a_click&&!this.runtime.isMobile&&a.preventDefault();this.runtime.had_a_click=!0;this.onTouchEnd({changedTouches:[{pageX:a.pageX,pageY:a.pageY,identifier:0}]});this.mouseDown=!1};p.tick2=function(){var a,b,c,d=cr.performance_now();a=0;for(b=this.touches.length;a<b;++a)c=this.touches[a],c.time<=d-50&&(c.lasttime=d),c.maybeTriggerHold(this,
a)};f.prototype.OnTouchStart=function(){return!0};f.prototype.OnTouchEnd=function(){return!0};f.prototype.IsInTouch=function(){return this.touches.length};f.prototype.OnTouchObject=function(a){return a?this.runtime.testAndSelectCanvasPointOverlap(a,this.curTouchX,this.curTouchY,!1):!1};var A=[];f.prototype.IsTouchingObject=function(a){if(!a)return!1;var b=a.getCurrentSol(),c=b.getObjects(),d,e,f,h,l,m;f=0;for(h=c.length;f<h;f++){var n=c[f];n.update_bbox();l=0;for(m=this.touches.length;l<m;l++)if(e=
this.touches[l],d=n.layer.canvasToLayer(e.x,e.y,!0),e=n.layer.canvasToLayer(e.x,e.y,!1),n.contains_pt(d,e)){A.push(n);break}}return A.length?(b.select_all=!1,cr.shallowAssignArray(b.instances,A),a.applySolToContainer(),A.length=0,!0):!1};f.prototype.CompareTouchSpeed=function(a,b,c){a=Math.floor(a);if(0>a||a>=this.touches.length)return!1;var d=this.touches[a];a=cr.distanceTo(d.x,d.y,d.lastx,d.lasty);var d=(d.time-d.lasttime)/1E3,e=0;0<d&&(e=a/d);return cr.do_cmp(e,b,c)};f.prototype.OrientationSupported=
function(){return"undefined"!==typeof window.DeviceOrientationEvent};f.prototype.MotionSupported=function(){return"undefined"!==typeof window.DeviceMotionEvent};f.prototype.CompareOrientation=function(a,b,c){var d=0,d=0===a?this.getAlpha():1===a?this.getBeta():this.getGamma();return cr.do_cmp(d,b,c)};f.prototype.CompareAcceleration=function(a,b,c){var d=0;0===a?d=this.acc_g_x:1===a?d=this.acc_g_y:2===a?d=this.acc_g_z:3===a?d=this.acc_x:4===a?d=this.acc_y:5===a&&(d=this.acc_z);return cr.do_cmp(d,b,
c)};f.prototype.OnNthTouchStart=function(a){a=Math.floor(a);return a===this.trigger_index};f.prototype.OnNthTouchEnd=function(a){a=Math.floor(a);return a===this.trigger_index};f.prototype.HasNthTouch=function(a){a=Math.floor(a);return this.touches.length>=a+1};f.prototype.OnHoldGesture=function(){return!0};f.prototype.OnTapGesture=function(){return!0};f.prototype.OnDoubleTapGesture=function(){return!0};f.prototype.OnHoldGestureObject=function(a){return a?this.runtime.testAndSelectCanvasPointOverlap(a,
this.curTouchX,this.curTouchY,!1):!1};f.prototype.OnTapGestureObject=function(a){return a?this.runtime.testAndSelectCanvasPointOverlap(a,this.curTouchX,this.curTouchY,!1):!1};f.prototype.OnDoubleTapGestureObject=function(a){return a?this.runtime.testAndSelectCanvasPointOverlap(a,this.curTouchX,this.curTouchY,!1):!1};h.cnds=new f;e.prototype.TouchCount=function(a){a.set_int(this.touches.length)};e.prototype.X=function(a,b){var c=this.getTouchIndex;if(0>c||c>=this.touches.length)a.set_float(0);else{var d,
e,f,h,l;cr.is_undefined(b)?(d=this.runtime.getLayerByNumber(0),e=d.scale,f=d.zoomRate,h=d.parallaxX,l=d.angle,d.scale=this.runtime.running_layout.scale,d.zoomRate=1,d.parallaxX=1,d.angle=this.runtime.running_layout.angle,a.set_float(d.canvasToLayer(this.touches[c].x,this.touches[c].y,!0)),d.scale=e,d.zoomRate=f,d.parallaxX=h,d.angle=l):(d=cr.is_number(b)?this.runtime.getLayerByNumber(b):this.runtime.getLayerByName(b))?a.set_float(d.canvasToLayer(this.touches[c].x,this.touches[c].y,!0)):a.set_float(0)}};
e.prototype.XAt=function(a,b,c){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var d,e,f,h;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,f=c.parallaxX,h=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxX=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!0)),c.scale=d,c.zoomRate=e,c.parallaxX=f,c.angle=h):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?
a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!0)):a.set_float(0)}};e.prototype.XForID=function(a,b,c){b=this.findTouch(b);if(0>b)a.set_float(0);else{b=this.touches[b];var d,e,f,h;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,f=c.parallaxX,h=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxX=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(b.x,b.y,!0)),c.scale=d,c.zoomRate=e,c.parallaxX=f,c.angle=h):(c=
cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(b.x,b.y,!0)):a.set_float(0)}};e.prototype.Y=function(a,b){var c=this.getTouchIndex;if(0>c||c>=this.touches.length)a.set_float(0);else{var d,e,f,h,l;cr.is_undefined(b)?(d=this.runtime.getLayerByNumber(0),e=d.scale,f=d.zoomRate,h=d.parallaxY,l=d.angle,d.scale=this.runtime.running_layout.scale,d.zoomRate=1,d.parallaxY=1,d.angle=this.runtime.running_layout.angle,a.set_float(d.canvasToLayer(this.touches[c].x,
this.touches[c].y,!1)),d.scale=e,d.zoomRate=f,d.parallaxY=h,d.angle=l):(d=cr.is_number(b)?this.runtime.getLayerByNumber(b):this.runtime.getLayerByName(b))?a.set_float(d.canvasToLayer(this.touches[c].x,this.touches[c].y,!1)):a.set_float(0)}};e.prototype.YAt=function(a,b,c){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var d,e,f,h;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,f=c.parallaxY,h=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=
1,c.parallaxY=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!1)),c.scale=d,c.zoomRate=e,c.parallaxY=f,c.angle=h):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!1)):a.set_float(0)}};e.prototype.YForID=function(a,b,c){b=this.findTouch(b);if(0>b)a.set_float(0);else{b=this.touches[b];var d,e,f,h;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),
d=c.scale,e=c.zoomRate,f=c.parallaxY,h=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxY=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(b.x,b.y,!1)),c.scale=d,c.zoomRate=e,c.parallaxY=f,c.angle=h):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(b.x,b.y,!1)):a.set_float(0)}};e.prototype.AbsoluteX=function(a){this.touches.length?a.set_float(this.touches[0].x):a.set_float(0)};e.prototype.AbsoluteXAt=
function(a,b){b=Math.floor(b);0>b||b>=this.touches.length?a.set_float(0):a.set_float(this.touches[b].x)};e.prototype.AbsoluteXForID=function(a,b){var c=this.findTouch(b);0>c?a.set_float(0):a.set_float(this.touches[c].x)};e.prototype.AbsoluteY=function(a){this.touches.length?a.set_float(this.touches[0].y):a.set_float(0)};e.prototype.AbsoluteYAt=function(a,b){b=Math.floor(b);0>b||b>=this.touches.length?a.set_float(0):a.set_float(this.touches[b].y)};e.prototype.AbsoluteYForID=function(a,b){var c=this.findTouch(b);
0>c?a.set_float(0):a.set_float(this.touches[c].y)};e.prototype.SpeedAt=function(a,b){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var c=this.touches[b],d=cr.distanceTo(c.x,c.y,c.lastx,c.lasty),c=(c.time-c.lasttime)/1E3;0===c?a.set_float(0):a.set_float(d/c)}};e.prototype.SpeedForID=function(a,b){var c=this.findTouch(b);if(0>c)a.set_float(0);else{var d=this.touches[c],c=cr.distanceTo(d.x,d.y,d.lastx,d.lasty),d=(d.time-d.lasttime)/1E3;0===d?a.set_float(0):a.set_float(c/d)}};e.prototype.AngleAt=
function(a,b){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var c=this.touches[b];a.set_float(cr.to_degrees(cr.angleTo(c.lastx,c.lasty,c.x,c.y)))}};e.prototype.AngleForID=function(a,b){var c=this.findTouch(b);0>c?a.set_float(0):(c=this.touches[c],a.set_float(cr.to_degrees(cr.angleTo(c.lastx,c.lasty,c.x,c.y))))};e.prototype.Alpha=function(a){a.set_float(this.getAlpha())};e.prototype.Beta=function(a){a.set_float(this.getBeta())};e.prototype.Gamma=function(a){a.set_float(this.getGamma())};
e.prototype.AccelerationXWithG=function(a){a.set_float(this.acc_g_x)};e.prototype.AccelerationYWithG=function(a){a.set_float(this.acc_g_y)};e.prototype.AccelerationZWithG=function(a){a.set_float(this.acc_g_z)};e.prototype.AccelerationX=function(a){a.set_float(this.acc_x)};e.prototype.AccelerationY=function(a){a.set_float(this.acc_y)};e.prototype.AccelerationZ=function(a){a.set_float(this.acc_z)};e.prototype.TouchIndex=function(a){a.set_int(this.trigger_index)};e.prototype.TouchID=function(a){a.set_float(this.trigger_id)};
h.exps=new e})();cr.plugins_.WebStorage=function(a){this.runtime=a};
(function(){function a(){m||(cr.logexport("[Construct 2] Webstorage plugin: session storage is not supported on this platform. Try using local storage or global variables instead."),m=!0)}function c(){}function b(){}function d(){}var f=cr.plugins_.WebStorage.prototype;f.Type=function(a){this.plugin=a;this.runtime=a.runtime};f.Type.prototype.onCreate=function(){};f.Instance=function(a){this.type=a;this.runtime=a.runtime};var e=f.Instance.prototype,h="",p="undefined"!==typeof window.is_scirra_arcade;
p&&(h="arcade"+window.scirra_arcade_id);var m=!1;e.onCreate=function(){};c.prototype.LocalStorageEnabled=function(){return!0};c.prototype.SessionStorageEnabled=function(){return!0};c.prototype.LocalStorageExists=function(a){return null!=localStorage.getItem(h+a)};c.prototype.SessionStorageExists=function(b){return this.runtime.isCocoonJs||!sessionStorage?(a(),!1):null!=sessionStorage.getItem(h+b)};c.prototype.OnQuotaExceeded=function(){return!0};c.prototype.CompareKeyText=function(a,b,c){a=localStorage.getItem(h+
a)||"";return c?a==b:cr.equals_nocase(a,b)};c.prototype.CompareKeyNumber=function(a,b,c){a=localStorage.getItem(h+a)||"";return cr.do_cmp(parseFloat(a),b,c)};f.cnds=new c;b.prototype.StoreLocal=function(a,b){try{localStorage.setItem(h+a,b)}catch(c){this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded,this)}};b.prototype.StoreSession=function(b,c){if(this.runtime.isCocoonJs||!sessionStorage)a();else try{sessionStorage.setItem(h+b,c)}catch(d){this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded,
this)}};b.prototype.RemoveLocal=function(a){localStorage.removeItem(h+a)};b.prototype.RemoveSession=function(b){this.runtime.isCocoonJs||!sessionStorage?a():sessionStorage.removeItem(h+b)};b.prototype.ClearLocal=function(){p||localStorage.clear()};b.prototype.ClearSession=function(){this.runtime.isCocoonJs||!sessionStorage?a():p||sessionStorage.clear()};b.prototype.JSONLoad=function(a,b){var c;try{c=JSON.parse(a)}catch(d){return}if(c.c2dictionary){c=c.data;0!==b||p||localStorage.clear();for(var e in c)if(c.hasOwnProperty(e))try{localStorage.setItem(h+
e,c[e])}catch(f){this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded,this);break}}};f.acts=new b;d.prototype.LocalValue=function(a,b){a.set_string(localStorage.getItem(h+b)||"")};d.prototype.SessionValue=function(b,c){this.runtime.isCocoonJs||!sessionStorage?(a(),b.set_string("")):b.set_string(sessionStorage.getItem(h+c)||"")};d.prototype.LocalCount=function(a){a.set_int(p?0:localStorage.length)};d.prototype.SessionCount=function(b){this.runtime.isCocoonJs||!sessionStorage?
(a(),b.set_int(0)):b.set_int(p?0:sessionStorage.length)};d.prototype.LocalAt=function(a,b){p?a.set_string(""):a.set_string(localStorage.getItem(localStorage.key(b))||"")};d.prototype.SessionAt=function(b,c){this.runtime.isCocoonJs||!sessionStorage?(a(),b.set_string("")):p?b.set_string(""):b.set_string(sessionStorage.getItem(sessionStorage.key(c))||"")};d.prototype.LocalKeyAt=function(a,b){p?a.set_string(""):a.set_string(localStorage.key(b)||"")};d.prototype.SessionKeyAt=function(b,c){this.runtime.isCocoonJs||
!sessionStorage?(a(),b.set_string("")):p?b.set_string(""):b.set_string(sessionStorage.key(c)||"")};d.prototype.AsJSON=function(a){var b={},c,d,e;c=0;for(d=localStorage.length;c<d;c++)e=localStorage.key(c),p?e.substr(0,h.length)===h&&(b[e.substr(h.length)]=localStorage.getItem(e)):b[e]=localStorage.getItem(e);a.set_string(JSON.stringify({c2dictionary:!0,data:b}))};f.exps=new d})();cr.behaviors.Bullet=function(a){this.runtime=a};
(function(){function a(){}function c(){}function b(){}var d=cr.behaviors.Bullet.prototype;d.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){};d.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var f=d.Instance.prototype;f.onCreate=function(){var a=this.properties[0];this.acc=this.properties[1];this.g=this.properties[2];this.bounceOffSolid=0!==this.properties[3];this.setAngle=0!==this.properties[4];
this.dx=Math.cos(this.inst.angle)*a;this.dy=Math.sin(this.inst.angle)*a;this.lastx=this.inst.x;this.lasty=this.inst.y;this.lastKnownAngle=this.inst.angle;this.travelled=0;this.enabled=0!==this.properties[5]};f.saveToJSON=function(){return{acc:this.acc,g:this.g,dx:this.dx,dy:this.dy,lx:this.lastx,ly:this.lasty,lka:this.lastKnownAngle,t:this.travelled,e:this.enabled}};f.loadFromJSON=function(a){this.acc=a.acc;this.g=a.g;this.dx=a.dx;this.dy=a.dy;this.lastx=a.lx;this.lasty=a.ly;this.lastKnownAngle=a.lka;
this.travelled=a.t;this.enabled=a.e};f.tick=function(){if(this.enabled){var a=this.runtime.getDt(this.inst),b,c;this.inst.angle!==this.lastKnownAngle&&(this.setAngle&&(b=cr.distanceTo(0,0,this.dx,this.dy),this.dx=Math.cos(this.inst.angle)*b,this.dy=Math.sin(this.inst.angle)*b),this.lastKnownAngle=this.inst.angle);0!==this.acc&&(b=cr.distanceTo(0,0,this.dx,this.dy),c=0===this.dx&&0===this.dy?this.inst.angle:cr.angleTo(0,0,this.dx,this.dy),b+=this.acc*a,0>b&&(b=0),this.dx=Math.cos(c)*b,this.dy=Math.sin(c)*
b);0!==this.g&&(this.dy+=this.g*a);this.lastx=this.inst.x;this.lasty=this.inst.y;if(0!==this.dx||0!==this.dy)if(this.inst.x+=this.dx*a,this.inst.y+=this.dy*a,this.travelled+=cr.distanceTo(0,0,this.dx*a,this.dy*a),this.setAngle&&(this.inst.angle=cr.angleTo(0,0,this.dx,this.dy),this.inst.set_bbox_changed(),this.lastKnownAngle=this.inst.angle),this.inst.set_bbox_changed(),this.bounceOffSolid&&(b=this.runtime.testOverlapSolid(this.inst)))this.runtime.registerCollision(this.inst,b),b=cr.distanceTo(0,0,
this.dx,this.dy),c=this.runtime.calculateSolidBounceAngle(this.inst,this.lastx,this.lasty),this.dx=Math.cos(c)*b,this.dy=Math.sin(c)*b,this.inst.x+=this.dx*a,this.inst.y+=this.dy*a,this.inst.set_bbox_changed(),this.setAngle&&(this.lastKnownAngle=this.inst.angle=c,this.inst.set_bbox_changed()),this.runtime.pushOutSolid(this.inst,this.dx/b,this.dy/b,Math.max(2.5*b*a,30))||this.runtime.pushOutSolidNearest(this.inst,100)}};a.prototype.CompareSpeed=function(a,b){return cr.do_cmp(cr.distanceTo(0,0,this.dx,
this.dy),a,b)};a.prototype.CompareTravelled=function(a,b){return cr.do_cmp(this.travelled,a,b)};d.cnds=new a;c.prototype.SetSpeed=function(a){var b=cr.angleTo(0,0,this.dx,this.dy);this.dx=Math.cos(b)*a;this.dy=Math.sin(b)*a};c.prototype.SetAcceleration=function(a){this.acc=a};c.prototype.SetGravity=function(a){this.g=a};c.prototype.SetAngleOfMotion=function(a){a=cr.to_radians(a);var b=cr.distanceTo(0,0,this.dx,this.dy);this.dx=Math.cos(a)*b;this.dy=Math.sin(a)*b};c.prototype.Bounce=function(a){if(a&&
(a=a.getFirstPicked(this.inst))){var b=this.runtime.getDt(this.inst),c=cr.distanceTo(0,0,this.dx,this.dy),d=this.runtime.calculateSolidBounceAngle(this.inst,this.lastx,this.lasty,a);this.dx=Math.cos(d)*c;this.dy=Math.sin(d)*c;this.inst.x+=this.dx*b;this.inst.y+=this.dy*b;this.inst.set_bbox_changed();this.setAngle&&(this.lastKnownAngle=this.inst.angle=d,this.inst.set_bbox_changed());this.bounceOffSolid?this.runtime.pushOutSolid(this.inst,this.dx/c,this.dy/c,Math.max(2.5*c*b,30))||this.runtime.pushOutSolidNearest(this.inst,
100):this.runtime.pushOut(this.inst,this.dx/c,this.dy/c,Math.max(2.5*c*b,30),a)}};c.prototype.SetEnabled=function(a){this.enabled=1===a};d.acts=new c;b.prototype.Speed=function(a){var b=cr.distanceTo(0,0,this.dx,this.dy),b=cr.round6dp(b);a.set_float(b)};b.prototype.Acceleration=function(a){a.set_float(this.acc)};b.prototype.AngleOfMotion=function(a){a.set_float(cr.to_degrees(cr.angleTo(0,0,this.dx,this.dy)))};b.prototype.DistanceTravelled=function(a){a.set_float(this.travelled)};d.exps=new b})();
cr.behaviors.Platform=function(a){this.runtime=a};
(function(){function a(){}function c(){}function b(){}var d=cr.behaviors.Platform.prototype;d.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){};d.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime;this.simjump=this.simright=this.simleft=this.ignoreInput=this.jumped=this.jumpkey=this.rightkey=this.leftkey=!1;this.lastFloorObject=null;this.loadFloorObject=-1;this.lastFloorY=this.lastFloorX=0;this.floorIsJumpthru=
!1;this.fallthrough=this.animMode=0;this.firstTick=!0;this.dy=this.dx=0};var f=d.Instance.prototype;f.updateGravity=function(){this.downx=Math.cos(this.ga);this.downy=Math.sin(this.ga);this.rightx=Math.cos(this.ga-Math.PI/2);this.righty=Math.sin(this.ga-Math.PI/2);this.downx=cr.round6dp(this.downx);this.downy=cr.round6dp(this.downy);this.rightx=cr.round6dp(this.rightx);this.righty=cr.round6dp(this.righty);this.g1=this.g;0>this.g&&(this.downx*=-1,this.downy*=-1,this.g=Math.abs(this.g))};f.onCreate=
function(){this.maxspeed=this.properties[0];this.acc=this.properties[1];this.dec=this.properties[2];this.jumpStrength=this.properties[3];this.g1=this.g=this.properties[4];this.maxFall=this.properties[5];this.defaultControls=1===this.properties[6];this.enabled=0!==this.properties[7];this.wasOnFloor=!1;this.wasOverJumpthru=this.runtime.testOverlapJumpThru(this.inst);this.loadOverJumpthru=-1;this.ga=cr.to_radians(90);this.updateGravity();var a=this;this.defaultControls&&!this.runtime.isDomFree&&(jQuery(document).keydown(function(b){a.onKeyDown(b)}),
jQuery(document).keyup(function(b){a.onKeyUp(b)}));this.recycled||(this.myDestroyCallback=function(b){a.onInstanceDestroyed(b)});this.runtime.addDestroyCallback(this.myDestroyCallback);this.inst.extra.isPlatformBehavior=!0};f.saveToJSON=function(){return{ii:this.ignoreInput,lfx:this.lastFloorX,lfy:this.lastFloorY,lfo:this.lastFloorObject?this.lastFloorObject.uid:-1,am:this.animMode,en:this.enabled,fall:this.fallthrough,ft:this.firstTick,dx:this.dx,dy:this.dy,ms:this.maxspeed,acc:this.acc,dec:this.dec,
js:this.jumpStrength,g:this.g,g1:this.g1,mf:this.maxFall,wof:this.wasOnFloor,woj:this.wasOverJumpthru?this.wasOverJumpthru.uid:-1,ga:this.ga}};f.loadFromJSON=function(a){this.ignoreInput=a.ii;this.lastFloorX=a.lfx;this.lastFloorY=a.lfy;this.loadFloorObject=a.lfo;this.animMode=a.am;this.enabled=a.en;this.fallthrough=a.fall;this.firstTick=a.ft;this.dx=a.dx;this.dy=a.dy;this.maxspeed=a.ms;this.acc=a.acc;this.dec=a.dec;this.jumpStrength=a.js;this.g=a.g;this.g1=a.g1;this.maxFall=a.mf;this.wasOnFloor=a.wof;
this.loadOverJumpthru=a.woj;this.ga=a.ga;this.simjump=this.simright=this.simleft=this.jumped=this.jumpkey=this.rightkey=this.leftkey=!1;this.updateGravity()};f.afterLoad=function(){this.lastFloorObject=-1===this.loadFloorObject?null:this.runtime.getObjectByUID(this.loadFloorObject);this.wasOverJumpthru=-1===this.loadOverJumpthru?null:this.runtime.getObjectByUID(this.loadOverJumpthru)};f.onInstanceDestroyed=function(a){this.lastFloorObject==a&&(this.lastFloorObject=null)};f.onDestroy=function(){this.lastFloorObject=
null;this.runtime.removeDestroyCallback(this.myDestroyCallback)};f.onKeyDown=function(a){switch(a.which){case 38:a.preventDefault();this.jumpkey=!0;break;case 37:a.preventDefault();this.leftkey=!0;break;case 39:a.preventDefault(),this.rightkey=!0}};f.onKeyUp=function(a){switch(a.which){case 38:a.preventDefault();this.jumped=this.jumpkey=!1;break;case 37:a.preventDefault();this.leftkey=!1;break;case 39:a.preventDefault(),this.rightkey=!1}};f.getGDir=function(){return 0>this.g?-1:1};f.isOnFloor=function(){var a=
null,b=null,c,d;c=this.inst.x;d=this.inst.y;this.inst.x+=this.downx;this.inst.y+=this.downy;this.inst.set_bbox_changed();if(this.lastFloorObject&&this.runtime.testOverlap(this.inst,this.lastFloorObject))return this.inst.x=c,this.inst.y=d,this.inst.set_bbox_changed(),this.lastFloorObject;(a=this.runtime.testOverlapSolid(this.inst))||0!==this.fallthrough||(b=this.runtime.testOverlapJumpThru(this.inst,!0));this.inst.x=c;this.inst.y=d;this.inst.set_bbox_changed();if(a){if(this.runtime.testOverlap(this.inst,
a))return null;this.floorIsJumpthru=!1;return a}if(b&&b.length){d=a=0;for(c=b.length;a<c;a++)b[d]=b[a],this.runtime.testOverlap(this.inst,b[a])||d++;if(1<=d)return this.floorIsJumpthru=!0,b[0]}return null};f.tick=function(){};f.posttick=function(){var a=this.runtime.getDt(this.inst),b,c,d,f,l,q,u,r,t;this.jumpkey||this.simjump||(this.jumped=!1);var x=this.leftkey||this.simleft;d=this.rightkey||this.simright;var s=(this.jumpkey||this.simjump)&&!this.jumped;this.simjump=this.simright=this.simleft=!1;
if(this.enabled){this.ignoreInput&&(s=d=x=!1);r=this.lastFloorObject;t=!1;this.firstTick&&((this.runtime.testOverlapSolid(this.inst)||this.runtime.testOverlapJumpThru(this.inst))&&this.runtime.pushOutSolid(this.inst,-this.downx,-this.downy,4,!0),this.firstTick=!1);!r||0!==this.dy||r.y===this.lastFloorY&&r.x===this.lastFloorX||(b=r.x-this.lastFloorX,c=r.y-this.lastFloorY,this.inst.x+=b,this.inst.y+=c,this.inst.set_bbox_changed(),this.lastFloorX=r.x,this.lastFloorY=r.y,t=!0,this.runtime.testOverlapSolid(this.inst)&&
this.runtime.pushOutSolid(this.inst,-b,-c,2.5*Math.sqrt(b*b+c*c)));var w=this.isOnFloor();if(c=this.runtime.testOverlapSolid(this.inst))if(this.inst.extra.inputPredicted)this.runtime.pushOutSolid(this.inst,-this.downx,-this.downy,10,!1);else if(this.runtime.pushOutSolidNearest(this.inst,Math.max(this.inst.width,this.inst.height)/2))this.runtime.registerCollision(this.inst,c);else return;w?(0<this.dy&&(this.wasOnFloor||(this.runtime.pushInFractional(this.inst,-this.downx,-this.downy,w,16),this.wasOnFloor=
!0),this.dy=0),r!=w?(this.lastFloorObject=w,this.lastFloorX=w.x,this.lastFloorY=w.y,this.runtime.registerCollision(this.inst,w)):t&&(c=this.runtime.testOverlapSolid(this.inst))&&(this.runtime.registerCollision(this.inst,c),0!==b&&(0<b?this.runtime.pushOutSolid(this.inst,-this.rightx,-this.righty):this.runtime.pushOutSolid(this.inst,this.rightx,this.righty)),this.runtime.pushOutSolid(this.inst,-this.downx,-this.downy)),s&&(r=this.inst.x,t=this.inst.y,this.inst.x-=this.downx,this.inst.y-=this.downy,
this.inst.set_bbox_changed(),this.runtime.testOverlapSolid(this.inst)?s=!1:(this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnJump,this.inst),this.animMode=2,this.dy=-this.jumpStrength,this.jumped=!0),this.inst.x=r,this.inst.y=t,this.inst.set_bbox_changed())):(this.lastFloorObject=null,this.dy+=this.g*a,this.dy>this.maxFall&&(this.dy=this.maxFall),s&&(this.jumped=!0));this.wasOnFloor=!!w;x==d&&(0>this.dx?(this.dx+=this.dec*a,0<this.dx&&(this.dx=0)):0<this.dx&&(this.dx-=this.dec*a,0>this.dx&&
(this.dx=0)));x&&!d&&(this.dx=0<this.dx?this.dx-(this.acc+this.dec)*a:this.dx-this.acc*a);d&&!x&&(this.dx=0>this.dx?this.dx+(this.acc+this.dec)*a:this.dx+this.acc*a);this.dx>this.maxspeed?this.dx=this.maxspeed:this.dx<-this.maxspeed&&(this.dx=-this.maxspeed);x=!1;0!==this.dx&&(r=this.inst.x,t=this.inst.y,b=this.dx*a*this.rightx,c=this.dx*a*this.righty,this.inst.x+=this.rightx*(1<this.dx?1:-1)-this.downx,this.inst.y+=this.righty*(1<this.dx?1:-1)-this.downy,this.inst.set_bbox_changed(),f=!1,l=this.runtime.testOverlapSolid(this.inst),
this.inst.x=r+b,this.inst.y=t+c,this.inst.set_bbox_changed(),d=this.runtime.testOverlapSolid(this.inst),!d&&w&&(d=this.runtime.testOverlapJumpThru(this.inst))&&(this.inst.x=r,this.inst.y=t,this.inst.set_bbox_changed(),this.runtime.testOverlap(this.inst,d)?(d=null,f=!1):f=!0,this.inst.x=r+b,this.inst.y=t+c,this.inst.set_bbox_changed()),d?(b=Math.abs(this.dx*a)+2,l||!this.runtime.pushOutSolid(this.inst,-this.downx,-this.downy,b,f,d))?(this.runtime.registerCollision(this.inst,d),b=Math.max(Math.abs(2.5*
this.dx*a),30),this.runtime.pushOutSolid(this.inst,this.rightx*(0>this.dx?1:-1),this.righty*(0>this.dx?1:-1),b,!1)?!w||f||this.floorIsJumpthru||(r=this.inst.x,t=this.inst.y,this.inst.x+=this.downx,this.inst.y+=this.downy,this.runtime.testOverlapSolid(this.inst)?this.runtime.pushOutSolid(this.inst,-this.downx,-this.downy,3,!1)||(this.inst.x=r,this.inst.y=t,this.inst.set_bbox_changed()):(this.inst.x=r,this.inst.y=t,this.inst.set_bbox_changed())):(this.inst.x=r,this.inst.y=t,this.inst.set_bbox_changed()),
f||(this.dx=0)):!l&&!s&&Math.abs(this.dy)<Math.abs(this.jumpStrength/4)&&(this.dy=0,w||(x=!0)):(r=this.isOnFloor(),w&&!r?(c=Math.ceil(Math.abs(this.dx*a))+2,r=this.inst.x,t=this.inst.y,this.inst.x+=this.downx*c,this.inst.y+=this.downy*c,this.inst.set_bbox_changed(),this.runtime.testOverlapSolid(this.inst)||this.runtime.testOverlapJumpThru(this.inst)?this.runtime.pushOutSolid(this.inst,-this.downx,-this.downy,c+2,!0):(this.inst.x=r,this.inst.y=t,this.inst.set_bbox_changed())):r&&0===this.dy&&this.runtime.pushInFractional(this.inst,
-this.downx,-this.downy,r,16)));if(0!==this.dy){r=this.inst.x;t=this.inst.y;this.inst.x+=this.dy*a*this.downx;this.inst.y+=this.dy*a*this.downy;b=this.inst.x;d=this.inst.y;this.inst.set_bbox_changed();c=this.runtime.testOverlapSolid(this.inst);f=!1;if(!c&&0<this.dy&&!w){if((f=0<this.fallthrough?null:this.runtime.testOverlapJumpThru(this.inst,!0))&&f.length){if(this.wasOverJumpthru){this.inst.x=r;this.inst.y=t;this.inst.set_bbox_changed();u=l=0;for(q=f.length;l<q;l++)f[u]=f[l],this.runtime.testOverlap(this.inst,
f[l])||u++;f.length=u;this.inst.x=b;this.inst.y=d;this.inst.set_bbox_changed()}1<=f.length&&(c=f[0])}f=!!c}c&&(this.runtime.registerCollision(this.inst,c),b=f?Math.abs(2.5*this.dy*a+10):Math.max(Math.abs(2.5*this.dy*a+10),30),this.runtime.pushOutSolid(this.inst,this.downx*(0>this.dy?1:-1),this.downy*(0>this.dy?1:-1),b,f,c)?(this.lastFloorObject=c,this.lastFloorX=c.x,this.lastFloorY=c.y,(this.floorIsJumpthru=f)&&(x=!0),this.dy=0):(this.inst.x=r,this.inst.y=t,this.inst.set_bbox_changed(),this.wasOnFloor=
!0,f||(this.dy=0)))}3!==this.animMode&&0<this.dy&&!w&&(this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnFall,this.inst),this.animMode=3);if(w||x)3===this.animMode||x||s&&0===this.dy?(this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnLand,this.inst),this.animMode=0===this.dx&&0===this.dy?0:1):(0!==this.animMode&&0===this.dx&&0===this.dy&&(this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnStop,this.inst),this.animMode=0),1===this.animMode||0===this.dx&&0===this.dy||s||
(this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnMove,this.inst),this.animMode=1));0<this.fallthrough&&this.fallthrough--;this.wasOverJumpthru=this.runtime.testOverlapJumpThru(this.inst)}};a.prototype.IsMoving=function(){return 0!==this.dx||0!==this.dy};a.prototype.CompareSpeed=function(a,b){var c=Math.sqrt(this.dx*this.dx+this.dy*this.dy);return cr.do_cmp(c,a,b)};a.prototype.IsOnFloor=function(){if(0!==this.dy)return!1;var a=null,b=null,c,d;c=this.inst.x;d=this.inst.y;this.inst.x+=this.downx;
this.inst.y+=this.downy;this.inst.set_bbox_changed();(a=this.runtime.testOverlapSolid(this.inst))||0!==this.fallthrough||(b=this.runtime.testOverlapJumpThru(this.inst,!0));this.inst.x=c;this.inst.y=d;this.inst.set_bbox_changed();if(a)return!this.runtime.testOverlap(this.inst,a);if(b&&b.length){d=a=0;for(c=b.length;a<c;a++)b[d]=b[a],this.runtime.testOverlap(this.inst,b[a])||d++;if(1<=d)return!0}return!1};a.prototype.IsByWall=function(a){var b=!1,c=this.inst.x,d=this.inst.y;this.inst.x-=3*this.downx;
this.inst.y-=3*this.downy;this.inst.set_bbox_changed();if(this.runtime.testOverlapSolid(this.inst))return this.inst.x=c,this.inst.y=d,this.inst.set_bbox_changed(),!1;0===a?(this.inst.x-=2*this.rightx,this.inst.y-=2*this.righty):(this.inst.x+=2*this.rightx,this.inst.y+=2*this.righty);this.inst.set_bbox_changed();b=this.runtime.testOverlapSolid(this.inst);this.inst.x=c;this.inst.y=d;this.inst.set_bbox_changed();return b};a.prototype.IsJumping=function(){return 0>this.dy};a.prototype.IsFalling=function(){return 0<
this.dy};a.prototype.OnJump=function(){return!0};a.prototype.OnFall=function(){return!0};a.prototype.OnStop=function(){return!0};a.prototype.OnMove=function(){return!0};a.prototype.OnLand=function(){return!0};d.cnds=new a;c.prototype.SetIgnoreInput=function(a){this.ignoreInput=a};c.prototype.SetMaxSpeed=function(a){this.maxspeed=a;0>this.maxspeed&&(this.maxspeed=0)};c.prototype.SetAcceleration=function(a){this.acc=a;0>this.acc&&(this.acc=0)};c.prototype.SetDeceleration=function(a){this.dec=a;0>this.dec&&
(this.dec=0)};c.prototype.SetJumpStrength=function(a){this.jumpStrength=a;0>this.jumpStrength&&(this.jumpStrength=0)};c.prototype.SetGravity=function(a){this.g1!==a&&(this.g=a,this.updateGravity(),this.runtime.testOverlapSolid(this.inst)&&(this.runtime.pushOutSolid(this.inst,this.downx,this.downy,10),this.inst.x+=2*this.downx,this.inst.y+=2*this.downy,this.inst.set_bbox_changed()),this.lastFloorObject=null)};c.prototype.SetMaxFallSpeed=function(a){this.maxFall=a;0>this.maxFall&&(this.maxFall=0)};
c.prototype.SimulateControl=function(a){switch(a){case 0:this.simleft=!0;break;case 1:this.simright=!0;break;case 2:this.simjump=!0}};c.prototype.SetVectorX=function(a){this.dx=a};c.prototype.SetVectorY=function(a){this.dy=a};c.prototype.SetGravityAngle=function(a){a=cr.to_radians(a);a=cr.clamp_angle(a);this.ga!==a&&(this.ga=a,this.updateGravity(),this.lastFloorObject=null)};c.prototype.SetEnabled=function(a){this.enabled!==(1===a)&&(this.enabled=1===a,this.enabled||(this.lastFloorObject=null))};
c.prototype.FallThrough=function(){var a=this.inst.x,b=this.inst.y;this.inst.x+=this.downx;this.inst.y+=this.downy;this.inst.set_bbox_changed();var c=this.runtime.testOverlapJumpThru(this.inst,!1);this.inst.x=a;this.inst.y=b;this.inst.set_bbox_changed();c&&(this.fallthrough=3,this.lastFloorObject=null)};d.acts=new c;b.prototype.Speed=function(a){a.set_float(Math.sqrt(this.dx*this.dx+this.dy*this.dy))};b.prototype.MaxSpeed=function(a){a.set_float(this.maxspeed)};b.prototype.Acceleration=function(a){a.set_float(this.acc)};
b.prototype.Deceleration=function(a){a.set_float(this.dec)};b.prototype.JumpStrength=function(a){a.set_float(this.jumpStrength)};b.prototype.Gravity=function(a){a.set_float(this.g)};b.prototype.GravityAngle=function(a){a.set_float(cr.to_degrees(this.ga))};b.prototype.MaxFallSpeed=function(a){a.set_float(this.maxFall)};b.prototype.MovingAngle=function(a){a.set_float(cr.to_degrees(Math.atan2(this.dy,this.dx)))};b.prototype.VectorX=function(a){a.set_float(this.dx)};b.prototype.VectorY=function(a){a.set_float(this.dy)};
d.exps=new b})();cr.behaviors.destroy=function(a){this.runtime=a};
(function(){var a=cr.behaviors.destroy.prototype;a.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};a.Type.prototype.onCreate=function(){};a.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};a=a.Instance.prototype;a.onCreate=function(){};a.tick=function(){this.inst.update_bbox();var a=this.inst.bbox,b=this.inst.layer.layout;(0>a.right||0>a.bottom||a.left>b.width||a.top>b.height)&&this.runtime.DestroyInstance(this.inst)}})();
var easeOutBounceArray=[],easeInElasticArray=[],easeOutElasticArray=[],easeInOutElasticArray=[],easeInCircle=[],easeOutCircle=[],easeInOutCircle=[],easeOutBack=[],easeInOutBack=[],litetween_precision=1E4,updateLimit=0;function easeOutBounce(a,c,b,d){return(a/=d)<1/2.75?7.5625*b*a*a+c:a<2/2.75?b*(7.5625*(a-=1.5/2.75)*a+0.75)+c:a<2.5/2.75?b*(7.5625*(a-=2.25/2.75)*a+0.9375)+c:b*(7.5625*(a-=2.625/2.75)*a+0.984375)+c}function integerize(a,c){return Math.round(a/c*litetween_precision)}
function easeFunc(a,c,b,d,f){switch(a){case 0:return d*c/f+b;case 1:return d*(c/=f)*c+b;case 2:return-d*(c/=f)*(c-2)+b;case 3:return 1>(c/=f/2)?d/2*c*c+b:-d/2*(--c*(c-2)-1)+b;case 4:return d*(c/=f)*c*c+b;case 5:return d*((c=c/f-1)*c*c+1)+b;case 6:return 1>(c/=f/2)?d/2*c*c*c+b:d/2*((c-=2)*c*c+2)+b;case 7:return d*(c/=f)*c*c*c+b;case 8:return-d*((c=c/f-1)*c*c*c-1)+b;case 9:return 1>(c/=f/2)?d/2*c*c*c*c+b:-d/2*((c-=2)*c*c*c-2)+b;case 10:return d*(c/=f)*c*c*c*c+b;case 11:return d*((c=c/f-1)*c*c*c*c+1)+
b;case 12:return 1>(c/=f/2)?d/2*c*c*c*c*c+b:d/2*((c-=2)*c*c*c*c+2)+b;case 13:return easeInCircle[integerize(c,f)];case 14:return easeOutCircle[integerize(c,f)];case 15:return easeInOutCircle[integerize(c,f)];case 16:return a=0,0==a&&(a=1.70158),d*(c/=f)*c*((a+1)*c-a)+b;case 17:return easeOutBack[integerize(c,f)];case 18:return easeInOutBack[integerize(c,f)];case 19:return easeInElasticArray[integerize(c,f)];case 20:return easeOutElasticArray[integerize(c,f)];case 21:return easeInOutElasticArray[integerize(c,
f)];case 22:return d-easeOutBounceArray[integerize(f-c,f)]+b;case 23:return easeOutBounceArray[integerize(c,f)];case 24:return c<f/2?0.5*(d-easeOutBounceArray[integerize(f-2*c,f)]+b)+b:0.5*easeOutBounceArray[integerize(2*c-f,f)]+0.5*d+b;case 25:return c=c/f/2,2*c*c*(3-2*c);case 26:return c=(c/f+1)/2,2*c*c*(3-2*c)-1;case 27:return c/=f,c*c*(3-2*c)}return 0}
(function(){for(var a=0,c=a=0,b=0,d=0,f=0;f<=litetween_precision;f++)easeOutBounceArray[f]=easeOutBounce(f/litetween_precision,0,1,1),b=f/litetween_precision,c=a=0,b/=1,0==c&&(c=0.3),0==a||a<Math.abs(1)?(a=1,d=c/4):d=c/(2*Math.PI)*Math.asin(1/a),a=-(a*Math.pow(2,10*(b-=1))*Math.sin(2*(1*b-d)*Math.PI/c))+0,easeInElasticArray[f]=a,b=f/litetween_precision,c=a=0,b/=1,0==c&&(c=0.3),0==a||a<Math.abs(1)?(a=1,d=c/4):d=c/(2*Math.PI)*Math.asin(1/a),a=a*Math.pow(2,-10*b)*Math.sin(2*(1*b-d)*Math.PI/c)+1,easeOutElasticArray[f]=
a,b=f/litetween_precision,c=a=0,b/=0.5,0==c&&(c=0.3*1.5),0==a||a<Math.abs(1)?(a=1,d=c/4):d=c/(2*Math.PI)*Math.asin(1/a),a=1>b?-0.5*a*Math.pow(2,10*(b-=1))*Math.sin(2*(1*b-d)*Math.PI/c)+0:0.5*a*Math.pow(2,-10*(b-=1))*Math.sin(2*(1*b-d)*Math.PI/c)+1,easeInOutElasticArray[f]=a,b=f/litetween_precision,easeInCircle[f]=-(Math.sqrt(1-b*b)-1),b=f/litetween_precision,easeOutCircle[f]=Math.sqrt(1-(b-1)*(b-1)),b=f/litetween_precision,a=1>(b/=0.5)?-0.5*(Math.sqrt(1-b*b)-1)+0:0.5*(Math.sqrt(1-(b-=2)*b)+1)+0,easeInOutCircle[f]=
a,b=f/litetween_precision,d=0,0==d&&(d=1.70158),a=1*((b=b/1-1)*b*((d+1)*b+d)+1)+0,easeOutBack[f]=a,b=f/litetween_precision,d=0,0==d&&(d=1.70158),a=1>(b/=0.5)?0.5*b*b*(((d*=1.525)+1)*b-d)+0:0.5*((b-=2)*b*(((d*=1.525)+1)*b+d)+2)+0,easeInOutBack[f]=a})();
var TweenObject=function(){return function(a,c,b,d,f,e,h){this.name=a;this.value=0;this.setInitial(d);this.setTarget(f);this.easefunc=b;this.tweened=c;this.duration=e;this.state=this.progress=0;this.onReverseEnd=this.onReverseStart=this.onEnd=this.onStart=!1;this.lastKnownValue2=this.lastKnownValue=0;this.enforce=h;this.pingpong=1}}();
(function(){TweenObject.prototype={};TweenObject.prototype.setInitial=function(a){this.initialparam1=parseFloat(a.split(",")[0]);this.initialparam2=parseFloat(a.split(",")[1]);this.lastKnownValue2=this.lastKnownValue=0};TweenObject.prototype.setTarget=function(a){this.targetparam1=parseFloat(a.split(",")[0]);this.targetparam2=parseFloat(a.split(",")[1]);isNaN(this.targetparam2)&&(this.targetparam2=this.targetparam1)};TweenObject.prototype.OnTick=function(a){if(0===this.state)return-1;1===this.state&&
(this.progress+=a);2===this.state&&(this.progress-=a);3===this.state&&(this.state=0);4===this.state&&(this.progress+=a*this.pingpong);5===this.state&&(this.progress+=a*this.pingpong);return 0>this.progress?(this.progress=0,4!==this.state?this.state=0:this.pingpong=1,this.onReverseEnd=!0,0):this.progress>this.duration?(this.progress=this.duration,4===this.state?this.pingpong=-1:5===this.state?this.progress=0:this.state=0,this.onEnd=!0,1):easeFunc(this.easefunc,this.progress,0,1,this.duration)}})();
function trim(a){return a.replace(/^\s\s*/,"").replace(/\s\s*$/,"")}cr.behaviors.lunarray_LiteTween=function(a){this.runtime=a};
(function(){var a=cr.behaviors.lunarray_LiteTween.prototype;a.Type=function(a,c){this.behavior=a;this.objtype=c;this.runtime=a.runtime};a.Type.prototype.onCreate=function(){};a.Instance=function(a,c){this.type=a;this.behavior=a.behavior;this.inst=c;this.runtime=a.runtime;this.i=0};var c=a.Instance.prototype;c.onCreate=function(){this.playmode=this.properties[0];this.active=1==this.playmode||2==this.playmode||4==this.playmode||5==this.playmode;this.tweened=this.properties[1];this.easing=this.properties[2];
this.target=this.properties[3];this.targetmode=this.properties[4];1===this.targetmode&&(this.target="relative("+this.target+")");this.duration=this.properties[5];this.enforce=1===this.properties[6];this.value=0;this.tween_list={};this.addToTweenList("default",this.tweened,this.easing,"current",this.target,this.duration,this.enforce);1===this.properties[0]&&this.startTween(0);2===this.properties[0]&&this.startTween(2);3===this.properties[0]&&this.startTween(3)};c.parseCurrent=function(a,c){void 0===
c&&(c="current");var f=trim(c);c=trim(c);var e=this.value;if("current"===c)switch(a){case 0:f=this.inst.x+","+this.inst.y;break;case 1:f=this.inst.width+","+this.inst.height;break;case 2:f=this.inst.width+","+this.inst.height;break;case 3:f=this.inst.width+","+this.inst.height;break;case 4:f=cr.to_degrees(this.inst.angle)+","+cr.to_degrees(this.inst.angle);break;case 5:f=100*this.inst.opacity+","+100*this.inst.opacity;break;case 6:f=e+","+e;break;case 7:f=this.inst.x+","+this.inst.y;break;case 8:f=
this.inst.x+","+this.inst.y}if("relative"===c.substring(0,8)){var h=c.match(/\((.*?)\)/);if(h)var p=parseFloat(h[1].split(",")[0]),m=parseFloat(h[1].split(",")[1]);isNaN(p)&&(p=0);isNaN(m)&&(m=0);switch(a){case 0:f=this.inst.x+p+","+(this.inst.y+m);break;case 1:f=this.inst.width+p+","+(this.inst.height+m);break;case 2:f=this.inst.width+p+","+(this.inst.height+m);break;case 3:f=this.inst.width+p+","+(this.inst.height+m);break;case 4:f=cr.to_degrees(this.inst.angle)+p+","+(cr.to_degrees(this.inst.angle)+
m);break;case 5:f=100*this.inst.opacity+p+","+(100*this.inst.opacity+m);break;case 6:f=e+p+","+e+p;break;case 7:f=this.inst.x+p+","+this.inst.y;break;case 8:f=this.inst.x+","+(this.inst.y+p)}}return f};c.addToTweenList=function(a,c,f,e,h,p,m){e=this.parseCurrent(c,e);h=this.parseCurrent(c,h);void 0!==this.tween_list[a]&&delete this.tween_list[a];this.tween_list[a]=new TweenObject(a,c,f,e,h,p,m)};c.saveToJSON=function(){};c.loadFromJSON=function(a){};c.setProgressTo=function(a){1<a&&(a=1);0>a&&(a=
0);for(var c in this.tween_list){var f=this.tween_list[c];f.lastKnownValue=0;f.lastKnownValue2=0;f.state=3;f.progress=a*f.duration;var e=f.OnTick(0);this.updateTween(f,e)}};c.startTween=function(a){for(var c in this.tween_list){var f=this.tween_list[c];0===a&&(f.progress=1E-6,f.lastKnownValue=0,f.lastKnownValue2=0,f.onStart=!0,f.state=1);1===a&&(f.state=1);2===a&&(f.progress=1E-6,f.lastKnownValue=0,f.lastKnownValue2=0,f.onStart=!0,f.state=4);3===a&&(f.progress=1E-6,f.lastKnownValue=0,f.lastKnownValue2=
0,f.onStart=!0,f.state=5)}};c.stopTween=function(a){for(var c in this.tween_list){var f=this.tween_list[c];1===a&&(f.progress=0);2===a&&(f.progress=f.duration);f.state=3;var e=f.OnTick(0);this.updateTween(f,e)}};c.reverseTween=function(a){for(var c in this.tween_list){var f=this.tween_list[c];1===a&&(f.progress=f.duration,f.lastKnownValue=0,f.lastKnownValue2=0,f.onReverseStart=!0);f.state=2}};c.updateTween=function(a,c){if(0===a.tweened)a.enforce?(this.inst.x=a.initialparam1+(a.targetparam1-a.initialparam1)*
c,this.inst.y=a.initialparam2+(a.targetparam2-a.initialparam2)*c):(this.inst.x+=(a.targetparam1-a.initialparam1)*c-a.lastKnownValue,this.inst.y+=(a.targetparam2-a.initialparam2)*c-a.lastKnownValue2,a.lastKnownValue=(a.targetparam1-a.initialparam1)*c,a.lastKnownValue2=(a.targetparam2-a.initialparam2)*c);else if(1===a.tweened)a.enforce?(this.inst.width=a.initialparam1+(a.targetparam1-a.initialparam1)*c,this.inst.height=a.initialparam2+(a.targetparam2-a.initialparam2)*c):(this.inst.width+=(a.targetparam1-
a.initialparam1)*c-a.lastKnownValue,this.inst.height+=(a.targetparam2-a.initialparam2)*c-a.lastKnownValue2,a.lastKnownValue=(a.targetparam1-a.initialparam1)*c,a.lastKnownValue2=(a.targetparam2-a.initialparam2)*c);else if(2===a.tweened)a.enforce?this.inst.width=a.initialparam1+(a.targetparam1-a.initialparam1)*c:(this.inst.width+=(a.targetparam1-a.initialparam1)*c-a.lastKnownValue,a.lastKnownValue=(a.targetparam1-a.initialparam1)*c);else if(3===a.tweened)a.enforce?this.inst.height=a.initialparam2+(a.targetparam2-
a.initialparam2)*c:(this.inst.height+=(a.targetparam2-a.initialparam2)*c-a.lastKnownValue2,a.lastKnownValue2=(a.targetparam2-a.initialparam2)*c);else if(4===a.tweened)if(a.enforce){var f=a.initialparam1+(a.targetparam1-a.initialparam1)*c;this.inst.angle=cr.clamp_angle(cr.to_radians(f))}else f=(a.targetparam1-a.initialparam1)*c-a.lastKnownValue,this.inst.angle=cr.clamp_angle(this.inst.angle+cr.to_radians(f)),a.lastKnownValue=(a.targetparam1-a.initialparam1)*c;else 5===a.tweened?a.enforce?this.inst.opacity=
(a.initialparam1+(a.targetparam1-a.initialparam1)*c)/100:(this.inst.opacity+=((a.targetparam1-a.initialparam1)*c-a.lastKnownValue)/100,a.lastKnownValue=(a.targetparam1-a.initialparam1)*c):6===a.tweened?a.enforce?this.value=a.initialparam1+(a.targetparam1-a.initialparam1)*c:(this.value+=(a.targetparam1-a.initialparam1)*c-a.lastKnownValue,a.lastKnownValue=(a.targetparam1-a.initialparam1)*c):7===a.tweened?a.enforce?this.inst.x=a.initialparam1+(a.targetparam1-a.initialparam1)*c:(this.inst.x+=(a.targetparam1-
a.initialparam1)*c-a.lastKnownValue,a.lastKnownValue=(a.targetparam1-a.initialparam1)*c):8===a.tweened&&(a.enforce?this.inst.y=a.initialparam2+(a.targetparam2-a.initialparam2)*c:(this.inst.y+=(a.targetparam2-a.initialparam2)*c-a.lastKnownValue2,a.lastKnownValue2=(a.targetparam2-a.initialparam2)*c));this.inst.set_bbox_changed()};c.tick=function(){var a=this.runtime.getDt(this.inst),c=this.tween_list["default"];0!==c.state&&(c.onStart&&(this.runtime.trigger(cr.behaviors.lunarray_LiteTween.prototype.cnds.OnStart,
this.inst),c.onStart=!1),c.onReverseStart&&(this.runtime.trigger(cr.behaviors.lunarray_LiteTween.prototype.cnds.OnReverseStart,this.inst),c.onReverseStart=!1),this.active=1==c.state||2==c.state||4==c.state||5==c.state,a=c.OnTick(a),this.updateTween(c,a),c.onEnd&&(this.runtime.trigger(cr.behaviors.lunarray_LiteTween.prototype.cnds.OnEnd,this.inst),c.onEnd=!1),c.onReverseEnd&&(this.runtime.trigger(cr.behaviors.lunarray_LiteTween.prototype.cnds.OnReverseEnd,this.inst),c.onReverseEnd=!1))};a.cnds={};
c=a.cnds;c.IsActive=function(){return 0!==this.tween_list["default"].state};c.CompareProgress=function(a,c){var f=this.tween_list["default"];return cr.do_cmp(f.progress/f.duration,a,c)};c.OnStart=function(){return void 0===this.tween_list["default"]?!1:this.tween_list["default"].onStart};c.OnReverseStart=function(){return void 0===this.tween_list["default"]?!1:this.tween_list["default"].onReverseStart};c.OnEnd=function(){return void 0===this.tween_list["default"]?!1:this.tween_list["default"].onEnd};
c.OnReverseEnd=function(){return void 0===this.tween_list["default"]?!1:this.tween_list["default"].onReverseEnd};a.acts={};c=a.acts;c.Start=function(a){this.startTween(a)};c.Stop=function(a){this.stopTween(a)};c.Reverse=function(a){this.reverseTween(a)};c.ProgressTo=function(a){this.setProgressTo(a)};c.SetDuration=function(a){isNaN(a)||0>a||void 0===this.tween_list["default"]||(this.tween_list["default"].duration=a)};c.SetEnforce=function(a){void 0!==this.tween_list["default"]&&(this.tween_list["default"].enforce=
1===a)};c.SetInitial=function(a){void 0!==this.tween_list["default"]&&(a=this.parseCurrent(this.tween_list["default"].tweened,a),this.tween_list["default"].setInitial(a))};c.SetTarget=function(a,c,f){if(void 0!==this.tween_list["default"]&&!isNaN(f)){var e=f+"",h=this.tween_list["default"];this.targetmode=c;if(1===c)switch(a){case 0:e=this.inst.x+f+","+h.targetparam2;break;case 1:e=h.targetparam1+","+(this.inst.y+f);break;case 2:e=""+cr.to_degrees(this.inst.angle+cr.to_radians(f));break;case 3:e=
""+100*this.inst.opacity+f;break;case 4:e=this.inst.width+f+","+h.targetparam2;break;case 5:e=h.targetparam1+","+(this.inst.height+f);break;case 6:e=f+","+f}else switch(a){case 0:e=f+","+h.targetparam2;break;case 1:e=h.targetparam1+","+f;break;case 2:e=f+","+f;break;case 3:e=f+","+f;break;case 4:e=f+","+h.targetparam2;break;case 5:e=h.targetparam1+","+f;break;case 6:e=f+","+f}a=this.parseCurrent(this.tween_list["default"].tweened,"current");e=this.parseCurrent(this.tween_list["default"].tweened,e);
h.setInitial(a);h.setTarget(e)}};c.SetTweenedProperty=function(a){void 0!==this.tween_list["default"]&&(this.tween_list["default"].tweened=a)};c.SetEasing=function(a){void 0!==this.tween_list["default"]&&(this.tween_list["default"].easefunc=a)};c.SetValue=function(a){var c=this.tween_list["default"];this.value=a;6===c.tweened&&c.setInitial(this.parseCurrent(c.tweened,"current"))};c.SetParameter=function(a,c,f,e,h){if(void 0===this.tween_list["default"])this.addToTweenList("default",a,c,initial,f,
e,h);else{var p=this.tween_list["default"];p.tweened=a;p.easefunc=c;p.setInitial(this.parseCurrent(a,"current"));p.setTarget(this.parseCurrent(a,f));p.duration=e;p.enforce=1===h}};a.exps={};a=a.exps;a.Progress=function(a){a.set_float(this.tween_list["default"].progress/this.tween_list["default"].duration)};a.Duration=function(a){a.set_float(this.tween_list["default"].duration)};a.Target=function(a){var c=this.tween_list["default"],f="N/A";switch(c.tweened){case 0:f=c.targetparam1;break;case 1:f=c.targetparam2;
break;case 2:f=c.targetparam1;break;case 3:f=c.targetparam1;break;case 4:f=c.targetparam1;break;case 5:f=c.targetparam2;break;case 6:f=c.targetparam1}a.set_float(f)};a.Value=function(a){a.set_float(this.value)}})();cr.behaviors.solid=function(a){this.runtime=a};
(function(){function a(){}function c(){}var b=cr.behaviors.solid.prototype;b.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};b.Type.prototype.onCreate=function(){};b.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var d=b.Instance.prototype;d.onCreate=function(){this.inst.extra.solidEnabled=0!==this.properties[0]};d.tick=function(){};a.prototype.IsEnabled=function(){return this.inst.extra.solidEnabled};b.cnds=new a;c.prototype.SetEnabled=
function(a){this.inst.extra.solidEnabled=!!a};b.acts=new c})();
cr.getProjectModel=function(){return[null,"splash",[[cr.plugins_.CJSAds,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Audio,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Function,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Browser,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Keyboard,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Sprite,!1,!0,!0,!0,!0,!0,!0,!0,!1],[cr.plugins_.Text,!1,!0,!0,!0,!0,!0,!0,!0,!1],[cr.plugins_.TiledBg,!1,!0,!0,!0,!0,!0,!0,!0,!0],[cr.plugins_.Touch,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.WebStorage,
!0,!1,!1,!1,!1,!1,!1,!1,!1]],[["t0",cr.plugins_.TiledBg,!1,[],1,0,["bg1.png",147246,0],null,[["Bullet",cr.behaviors.Bullet,5806375470932684]],!1,!1,8219711791564281,[],null],["t1",cr.plugins_.Touch,!1,[],0,0,null,null,[],!1,!1,6577715741799261,[],null,[1]],["t2",cr.plugins_.Keyboard,!1,[],0,0,null,null,[],!1,!1,8081288980757465,[],null,[]],["t3",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0x6cec904d60b99,[],null],["t4",cr.plugins_.Sprite,!1,[6223017669342045],2,0,null,[["run",10,!0,0,0,!1,0x67b28a051235d,
[["player-sheet0.png",78601,1,1,250,258,1,0.8759999871253967,0.4418604671955109,[],[-0.457196980714798,-0.1118944585323334,-0.3759999871253967,-0.3374834656715393,-0.1580510139465332,-0.219638466835022,-0.05976098775863648,0.05645552277565002,-0.2606149911880493,0.2551095187664032,-0.3289909958839417,0.5547724962234497,-0.4358289837837219,0.5581395626068115,-0.4999319911003113,0.05645552277565002],0],["player-sheet0.png",78601,253,1,250,258,1,0.871999979019165,0.4573643505573273,[],[-0.4619999825954437,
-0.1226703524589539,-0.371999979019165,-0.3553233444690704,-0.2519999742507935,-0.1471603512763977,-0.0769999623298645,0.04059463739395142,-0.2820000052452087,0.5426356792449951,-0.5119999647140503,0.5426356792449951,-0.496999979019165,0.04059463739395142],0],["player-sheet1.png",55217,1,1,250,258,1,0.8960000276565552,0.4496124088764191,[],[-0.3960000276565552,-0.3598164916038513,-0.08600002527236938,0.04834657907485962,-0.3560000061988831,0.5503876209259033,-0.5609999895095825,0.5503876209259033,
-0.5210000276565552,0.04834657907485962],0],["player-sheet1.png",55217,253,1,250,258,1,0.9200000166893005,0.4496124088764191,[],[-0.4800000190734863,-0.0904284119606018,-0.4200000166893005,-0.3557348251342773,-0.09500002861022949,0.04834657907485962,-0.2599999904632568,0.2728365957736969,-0.4050000309944153,0.5503876209259033,-0.625,0.5503876209259033,-0.5550000071525574,0.04834657907485962],0]]],["jump",5,!1,1,0,!1,0x7ecc4bf9d5447,[["player-sheet0.png",78601,1,261,250,220,1,0.8759999871253967,0.449999988079071,
[],[-0.4509999752044678,-0.09435099363327026,-0.3759999871253967,-0.3579497933387756,-0.2260000109672546,-0.1571129858493805,-0.05099999904632568,0.0479080080986023,-0.01099997758865356,0.4370290040969849,-0.3759999871253967,0.2236400246620178,-0.656000018119812,0.3658999800682068,-0.5059999823570251,0.0479080080986023],0]]]],[["Platform",cr.behaviors.Platform,0x6e7daee929851],["Bullet",cr.behaviors.Bullet,4948356483507679]],!1,!1,0x99d2c0e29a2a6,[],null],["t5",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",
5,!1,1,0,!1,8403234812922191,[["sprite-sheet0.png",146,0,0,200,200,1,0.5,0.5,[],[],3]]]],[["Solid",cr.behaviors.solid,0x601abcd4443f5]],!1,!1,6203439888534993,[],null],["t6",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",10,!0,0,0,!1,4824294577588534,[["coin1-sheet0.png",29172,1,1,85,92,1,0.4941176474094391,0.489130437374115,[],[0.2941173613071442,0.3152175545692444,0.01176437735557556,0.4347825646400452,-0.2941176295280457,0.3260865807533264,-0.4235296547412872,0.01086956262588501,-0.2823526263237,
-0.2934784293174744,0.01176437735557556,-0.3913044333457947,0.2823533713817596,-0.2826084494590759,0.4117643535137177,0.01086956262588501],0],["coin1-sheet0.png",29172,88,1,85,92,1,0.5058823823928833,0.5,[],[-0.2941173911094666,-0.3043479919433594,-0.01176437735557556,-0.4239130020141602,0.2941176295280457,-0.3152170181274414,0.4235296249389648,0,0.2823526263237,0.3043479919433594,-0.01176437735557556,0.3913040161132813,-0.2705883979797363,0.2826089859008789,-0.4117648005485535,0],0],["coin1-sheet0.png",
29172,1,95,85,92,1,0.5058823823928833,0.5,[],[-0.1882353723049164,-0.2065219879150391,-0.01176437735557556,-0.4239130020141602,0.1999996304512024,-0.2282609939575195,0.2235296368598938,0,0.1882356405258179,0.2173910140991211,-0.01176437735557556,0.3913040161132813,-0.1882353723049164,0.2065219879150391,-0.2235293686389923,0],0],["coin1-sheet0.png",29172,88,95,85,92,1,0.5058823823928833,0.5,[],[-0.04705837368965149,-0.07608699798583984,-0.01176437735557556,-0.4239130020141602,0.05882364511489868,-0.09782600402832031,
0.05882364511489868,0.09782600402832031,-0.01176437735557556,0.4021739959716797,-0.04705837368965149,0.07608699798583984],0],["coin1-sheet1.png",15594,1,1,85,92,1,0.5058823823928833,0.5,[],[-0.1882353723049164,-0.2065219879150391,-0.01176437735557556,-0.4239130020141602,0.1999996304512024,-0.2282609939575195,0.2235296368598938,0,0.1882356405258179,0.2173910140991211,-0.01176437735557556,0.3913040161132813,-0.1882353723049164,0.2065219879150391,-0.2235293686389923,0],0],["coin1-sheet1.png",15594,88,
1,85,92,1,0.5058823823928833,0.5,[],[-0.282353401184082,-0.2934780120849609,-0.01176437735557556,-0.4239130020141602,0.2823526263237,-0.3043479919433594,0.3882356286048889,0,0.2588236331939697,0.2826089859008789,-0.01176437735557556,0.3913040161132813,-0.2588233947753906,0.2717390060424805,-0.3647063970565796,0],0]]]],[["Bullet",cr.behaviors.Bullet,0xc7ee608103333],["DestroyOutsideLayout",cr.behaviors.destroy,9890256209271368]],!1,!1,8100630695593122,[],null],["t7",cr.plugins_.Sprite,!1,[],1,0,null,
[["Default",5,!1,1,0,!1,742552259301413,[["sprite2-sheet0.png",1624,0,0,162,237,1,0.5,0.502109706401825,[],[-0.30246901512146,-0.3670887053012848,0,-0.4430380165576935,0.4012349843978882,-0.4345992207527161,0,-0.1898736953735352],0],["sprite2-sheet0.png",1624,0,0,162,237,1,0.5,0.502109706401825,[],[-0.30246901512146,-0.3670887053012848,0,-0.4430380165576935,0.4012349843978882,-0.4345992207527161,0,-0.1898736953735352],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,7202780523204799]],!1,!1,6942115757692197,
[],null],["t8",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,8468815437139132,[],null],["t9",cr.plugins_.Sprite,!1,[0x4f761cfa352d8],2,0,null,[["Default",10,!0,0,0,!1,6354763593400335,[["animal1-sheet0.png",36861,1,1,105,161,1,0.4952380955219269,0.4968944191932678,[],[0.4531489312648773,0.2307655811309815,0.1950848996639252,0.4945945739746094,-0.05007711052894592,0.4860845804214478,-0.1274960935115814,0.2307655811309815,-0.4113670885562897,0.2392755746841431,-0.2049151062965393,-0.2500864267349243,
0.1370199024677277,-0.2543414235115051,0.2725038826465607,-0.1564684212207794],0],["animal1-sheet0.png",36861,108,1,105,161,1,0.4952380955219269,0.4968944191932678,[],[0.5047619342803955,0.5031055808067322,-0.4952380955219269,0.5031055808067322,-0.4952380955219269,-0.4968944191932678,0.5047619342803955,-0.4968944191932678],0],["animal1-sheet1.png",35159,1,1,105,161,1,0.4952380955219269,0.4968944191932678,[],[0.5047619342803955,0.5031055808067322,-0.4952380955219269,0.5031055808067322,-0.4952380955219269,
-0.4968944191932678,0.5047619342803955,-0.4968944191932678],0],["animal1-sheet1.png",35159,108,1,105,161,1,0.4952380955219269,0.4968944191932678,[],[0.5047619342803955,0.5031055808067322,-0.4952380955219269,0.5031055808067322,-0.4952380955219269,-0.4968944191932678,0.5047619342803955,-0.4968944191932678],0],["animal1-sheet2.png",22024,0,0,105,161,1,0.4952380955219269,0.4968944191932678,[],[0.5047619342803955,0.5031055808067322,-0.4952380955219269,0.5031055808067322,-0.4952380955219269,-0.4968944191932678,
0.5047619342803955,-0.4968944191932678],0],["animal1-sheet1.png",35159,108,1,105,161,1,0.4952380955219269,0.4968944191932678,[],[0.5047619342803955,0.5031055808067322,-0.4952380955219269,0.5031055808067322,-0.4952380955219269,-0.4968944191932678,0.5047619342803955,-0.4968944191932678],0],["animal1-sheet1.png",35159,1,1,105,161,1,0.5047619342803955,0.5031055808067322,[],[-0.3619049191474915,-0.4099378883838654,-0.009523928165435791,-0.4161490797996521,0.009524047374725342,-0.1863355934619904,0.0476190447807312,
-0.006211578845977783,0.3333330750465393,0.3913044333457947,-0.009523928165435791,0.4223604202270508,-0.3619049191474915,0.4037263989448547,-0.2761909365653992,-0.006211578845977783],0],["animal1-sheet0.png",36861,108,1,105,161,1,0.5047619342803955,0.5031055808067322,[],[-0.3619049191474915,-0.4099378883838654,-0.009523928165435791,-0.4285713732242584,0.1809520721435547,-0.2981365919113159,0.0476190447807312,-0.006211578845977783,0.3333330750465393,0.3913044333457947,-0.009523928165435791,0.4223604202270508,
-0.3619049191474915,0.4037263989448547,-0.2761909365653992,-0.006211578845977783],0]]]],[["Bullet",cr.behaviors.Bullet,6173931315680951],["DestroyOutsideLayout",cr.behaviors.destroy,9786240699397316]],!1,!1,9539277195170576,[],null],["t10",cr.plugins_.Sprite,!1,[627742361989458],2,0,null,[["Default",8,!0,0,0,!1,6446679612887518,[["animal2-sheet0.png",142754,1,1,155,235,1,0.5032258033752441,0.4936170279979706,[],[-0.2969757914543152,0.006382972002029419,-0.3719758093357086,-0.4031000137329102,-0.003225803375244141,
-0.4246520400047302,0.4342741370201111,-0.2996520400047302,-0.02822580933570862,-0.07551401853561401,0.3530241847038269,0.2563829720020294,-0.1657257974147797,0.4718999564647675,-0.3344758152961731,0.3900039494037628],0],["animal2-sheet0.png",142754,158,1,155,235,1,0.5032258033752441,0.4978723526000977,[],[-0.3354837894439697,0.00425565242767334,-0.2258068025112152,-0.314893364906311,-0.006451815366744995,-0.4893617033958435,0.1290321946144104,-0.255319356918335,0.4193552136421204,0.00425565242767334,
0.2322582006454468,0.3276596665382385,-0.006451815366744995,0.3531916737556458,-0.1806448101997376,0.2893616557121277],0],["animal2-sheet0.png",142754,315,1,155,235,1,0.5032258033752441,0.4978723526000977,[],[-0.4258064925670624,0.00425565242767334,-0.4645161032676697,-0.47234046459198,-0.006451815366744995,-0.4893617033958435,0.4580641984939575,-0.47234046459198,0.451613187789917,0.00425565242767334,0.2129032015800476,0.3148936629295349,-0.006451815366744995,0.4851066470146179,-0.2322578132152557,
0.3234046697616577],0],["animal2-sheet0.png",142754,1,238,155,235,1,0.5032258033752441,0.4978723526000977,[],[-0.3612908124923706,0.00425565242767334,-0.2451608180999756,-0.3276593685150147,-0.006451815366744995,-0.4893617033958435,0.0516132116317749,-0.2042553424835205,0.4451612234115601,0.00425565242767334,0.2580642104148865,0.344680666923523,-0.006451815366744995,0.3787236213684082,-0.1870968043804169,0.2936166524887085],0]]]],[["Bullet",cr.behaviors.Bullet,7323946540619471],["DestroyOutsideLayout",
cr.behaviors.destroy,5104579631772064]],!1,!1,8949517151787467,[],null],["t11",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",8,!0,0,0,!1,6835399893296102,[["bombpower-sheet0.png",21267,0,0,240,223,1,0.5,0.4932735562324524,[],[0.34375,0.3400594592094421,0,0.5000594258308411,-0.3499999940395355,0.3467264175415039,-0.4937499761581421,0.006726443767547607,-0.3499999940395355,-0.3332735598087311,0,-0.4799405634403229,0.3374999761581421,-0.3199405670166016,0.4750000238418579,0.006726443767547607],0],["bombpower-sheet0.png",
21267,0,0,240,223,1,0.5,0.4932735562324524,[],[0.34375,0.3400594592094421,0,0.5000594258308411,-0.3499999940395355,0.3467264175415039,-0.4937499761581421,0.006726443767547607,-0.3499999940395355,-0.3332735598087311,0,-0.4799405634403229,0.3374999761581421,-0.3199405670166016,0.4750000238418579,0.006726443767547607],0]]]],[["Bullet",cr.behaviors.Bullet,4925844507043949],["DestroyOutsideLayout",cr.behaviors.destroy,0xfb2a2684bd0cf]],!1,!1,7340375905839453,[],null],["t12",cr.plugins_.Sprite,!1,[],1,
0,null,[["Default",3,!1,1,0,!1,5882182444383477,[["scoreadd-sheet0.png",1816,0,0,180,295,1,0.5,0.508474588394165,[],[0,0.2542374134063721,0.3333330154418945,0.3898304104804993,0,0.4542374014854431,-0.3611109852790833,0.406779408454895],0],["scoreadd-sheet0.png",1816,0,0,180,295,1,0.5,0.508474588394165,[],[0,0.2542374134063721,0.3333330154418945,0.3898304104804993,0,0.4542374014854431,-0.3611109852790833,0.406779408454895],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,7147443706926412]],!1,!1,
0x3eda079eda626,[],null],["t13",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x7419758b25cab,[["sprite8-sheet0.png",1963,0,0,210,283,1,0.5047619342803955,0.5017668008804321,[],[-0.3619049191474915,-0.395759791135788,-0.004761934280395508,-0.3498238027095795,0.3761900663375855,-0.4134275913238525,-0.004761934280395508,-0.2367488145828247],0],["sprite8-sheet0.png",1963,0,0,210,283,1,0.5047619342803955,0.5017668008804321,[],[-0.3619049191474915,-0.395759791135788,-0.004761934280395508,-0.3498238027095795,
0.3761900663375855,-0.4134275913238525,-0.004761934280395508,-0.2367488145828247],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,9756590366853668]],!1,!1,9607709043990408,[],null],["t14",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",10,!0,0,0,!1,0x6127d81c160ab,[["horsepower-sheet0.png",21458,0,0,245,223,1,0.4979591965675354,0.4887892305850983,[],[0.3220407962799072,0.3312107622623444,0.0020408034324646,0.4712107479572296,-0.3279591798782349,0.3412107527256012,-0.4679591953754425,0.01121076941490173,
-0.3279591798782349,-0.3187892436981201,0.0020408034324646,-0.4487892389297485,0.3220407962799072,-0.3087892234325409,0.4520407915115356,0.01121076941490173],0]]]],[["Bullet",cr.behaviors.Bullet,0x65fe84e80de4d],["DestroyOutsideLayout",cr.behaviors.destroy,9460418011092436]],!1,!1,0xd061db49adfd7,[],null],["t15",cr.plugins_.Sprite,!1,[5746718916705882],1,0,null,[["Default",11,!0,0,0,!1,775798311237416,[["playeranim-sheet0.png",213621,1,1,509,385,1,0.5009823441505432,0.5038961172103882,[],[-0.1768173575401306,
-0.0530761182308197,-0.001964330673217773,-0.05580911040306091,0.102160632610321,-0.4355901181697846,0.1935166716575623,-0.1773931086063385,0.3870336413383484,-0.1732951104640961,0.2612966299057007,0.4906389117240906,-0.1886053383350372,0.490639865398407,-0.1473473310470581,0.004300892353057861,-0.3673873543739319,-0.003896117210388184],0],["playeranim-sheet0.png",213621,512,1,509,385,1,0.5009823441505432,0.5038961172103882,[],[0.007858633995056152,-0.06127312779426575,0.1178786754608154,-0.4219289124011993,
0.3398826718330383,-0.2334041297435761,0.3045186400413513,-0.003896117210388184,0.326129674911499,0.4961038827896118,-0.01768133044242859,0.4961038827896118,-0.1532413363456726,0.01249688863754273,-0.392927348613739,-0.003896117210388184],0],["playeranim-sheet0.png",213621,1,388,509,385,1,0.5009823441505432,0.501298725605011,[],[-0.3202353417873383,-0.1215177178382874,0.02946966886520386,-0.07780173420906067,0.09430265426635742,-0.4876375198364258,0.3320236802101135,-0.2144137322902679,0.2829076647758484,
-0.001298725605010986,0.2495086789131165,0.498701274394989,-0.01178735494613648,0.498701274394989,-0.1512773334980011,0.01236230134963989,-0.3870333433151245,-0.001298725605010986],0],["playeranim-sheet0.png",213621,512,388,509,385,1,0.5009823441505432,0.501298725605011,[],[-0.3968563377857208,-0.1379107236862183,-0.001964330673217773,-0.07780173420906067,0.1218076348304749,-0.4821730256080627,0.4282906651496887,-0.1652327179908752,0.3045186400413513,0.490504264831543,-0.1787823438644409,0.495969295501709,
-0.1532413363456726,0.01509428024291992,-0.3104123473167419,-0.001298725605010986],0],["playeranim-sheet1.png",200013,1,1,509,385,1,0.5009823441505432,0.501298725605011,[],[-0.1493123471736908,-0.02268871665000916,-0.001964330673217773,-0.05210071802139282,0.324164628982544,-0.2633307278156281,0.326129674911499,-0.001298725605010986,0.1571706533432007,0.498701274394989,-0.1650293469429016,0.498701274394989,-0.1434183418750763,0.01207029819488525,-0.4263261556625366,-0.001298725605010986],0],["playeranim-sheet1.png",
200013,512,1,509,385,1,0.5009823441505432,0.501298725605011,[],[-0.1571713387966156,-0.02315673232078552,-0.009823352098464966,-0.09965971112251282,0.078585684299469,-0.4671457409858704,0.1984286308288574,-0.2308067381381989,0.4027506709098816,0.2377722859382629,0.2691556811332703,0.498701274394989,-0.2829073369503021,0.498701274394989,-0.2554023265838623,0.2118162512779236,-0.4774067401885986,-0.001298725605010986],0],["playeranim-sheet1.png",200013,1,388,509,385,1,0.5009823441505432,0.501298725605011,
[],[-0.1748523414134979,-0.04774671792984009,0.02357566356658936,-0.07780173420906067,0.04616868495941162,-0.4384572207927704,0.3280946612358093,-0.2062167227268219,0.2966596484184265,-0.001298725605010986,0.255402684211731,0.4932372570037842,-0.1728883385658264,0.498701274394989,-0.1591353416442871,0.02329128980636597,-0.3516703248023987,-0.001298725605010986],0],["playeranim-sheet1.png",200013,512,388,509,385,1,0.5009823441505432,0.501298725605011,[],[-0.1886053383350372,-0.06687271595001221,-0.001964330673217773,
-0.0805337131023407,0.102160632610321,-0.4247960150241852,0.4459726810455322,-0.1433757245540619,0.2220036387443543,0.1790292859077454,0.2337916493415833,0.495969295501709,-0.1060903370380402,0.498701274394989,-0.1434183418750763,0.09706228971481323,-0.4557957351207733,-0.001298725605010986],0]]]],[["Platform",cr.behaviors.Platform,0xc3ce86815508d]],!1,!1,0x9453e9cb15bd6,[],null],["t16",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xcf27fae47a23f,[["sprite12-sheet0.png",589109,0,0,1260,
720,1,0.5,0.5,[],[],1]]]],[],!1,!1,9140721647561488,[],null],["t17",cr.plugins_.CJSAds,!1,[],0,0,null,null,[],!1,!1,9707446203723022,[],null,[1,1]],["t18",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5580412878218309,[["sprite17-sheet0.png",24829,0,0,434,131,1,0.5,0.5038167834281921,[],[-0.4285714030265808,-0.2671757936477661,0.4285709857940674,-0.2671757936477661,0.5,-0.007633775472640991,0.4792630076408386,0.4274812340736389,0,0.4274812340736389,-0.394008994102478,0.1450381875038147,
-0.394008994102478,-0.007633775472640991],0]]]],[],!1,!1,712342939768303,[],null],["t19",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8423059418651216,[["bg22-sheet0.png",214374,0,0,1260,720,1,0.5,0.5,[],[],1]]]],[],!1,!1,0xbcde9a8a1a6d,[],null],["t20",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,357484105162538,[["pause-sheet0.png",4904,0,0,75,75,1,0.5199999809265137,0.5066666603088379,[],[-0.4901492893695831,-0.5066666603088379,0.00238800048828125,-0.5066666603088379,0.4800000190734863,
-0.5066666603088379,0.4576120376586914,0.4840743541717529,0.1665670275688171,0.4933333396911621,-0.5199999809265137,0.4840743541717529,-0.5199999809265137,-0.1270366609096527],0]]]],[],!1,!1,0x7121c4a3032b3,[],null],["t21",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xa6e032752d8e0,[["exit-sheet0.png",7891,0,0,200,69,1,0.5,0.5072463750839233,[],[-0.4830507934093475,-0.5072463750839233,0,-0.5072463750839233,0.4618639945983887,-0.5072463750839233,0.45762699842453,0.4927536249160767,0.03813600540161133,
0.482227623462677,-0.4406780004501343,0.4717006087303162],0]]]],[],!1,!1,5803435891217034,[],null],["t22",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xc2685edcc094c,[["play-sheet0.png",3437,0,0,186,203,1,0.5,0.5024630427360535,[],[-0.45033860206604,-0.4568009376525879,0.4683970212936401,-0.002463042736053467,0.1930019855499268,0.1756189465522766,-0.4390518963336945,0.4358929395675659,-0.4458239078521729,-0.002463042736053467],0]]]],[],!1,!1,5392517595984175,[],null],["t23",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",5,!1,1,0,!1,55409700732644,[["play-sheet0.png",3437,0,0,186,203,1,0.5,0.5024630427360535,[],[-0.4525958895683289,-0.4522347450256348,0.5,0.004385948181152344,0.1952599883079529,0.1733359694480896,-0.4390518963336945,0.4358929395675659,-0.4458239078521729,-0.002463042736053467],0]]]],[],!1,!1,5433286514131067,[],null],["t24",cr.plugins_.Function,!1,[],0,0,null,null,[],!1,!1,6838713169362246,[],null,[]],["t25",cr.plugins_.Browser,!1,[],0,0,null,null,[],!1,!1,70686883879884,
[],null,[]],["t26",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",8,!1,0,0,!1,9205784737216998,[["pldt-sheet0.png",54050,379,1,375,297,1,0.5013333559036255,0.5050504803657532,[],[-0.002666354179382324,0.08417552709579468,0.1439996361732483,-0.05723947286605835,0.1573336720466614,-0.006734490394592285,0.2586666345596314,0.1919195055961609,-0.002666354179382324,0.08754253387451172,0.03199964761734009,-0.1784514784812927,0.03466665744781494,-0.006734490394592285],0],["pldt-sheet0.png",54050,379,300,375,
297,1,0.5013333559036255,0.5050504803657532,[],[0.1679996252059937,-0.08754247426986694,0.1893336176872253,-0.006734490394592285,0.2639996409416199,0.198653519153595,0.03466665744781494,-0.1818184852600098,0.06133365631103516,-0.006734490394592285],0],["pldt-sheet0.png",54050,1,301,375,297,1,0.5013333559036255,0.5050504803657532,[],[0.1306666731834412,-0.04040446877479553,0.175999641418457,-0.006734490394592285,0.2533336281776428,0.1851854920387268,0.005333662033081055,-0.006734490394592285],0],["pldt-sheet0.png",
54050,1,1,376,298,1,0.5026595592498779,0.5033556818962097,[],[-0.00265955924987793,-0.2382546961307526,0.138297438621521,-0.05033567547798157,0.09574443101882935,-0.003355681896209717,0.2021274566650391,0.1241613030433655,-0.00265955924987793,0.04026830196380615,-0.01329755783081055,-0.003355681896209717],0],["pldt-sheet0.png",54050,378,599,375,297,1,0.5013333559036255,0.5050504803657532,[],[-0.1146663427352905,-0.1828284859657288,-0.003555357456207275,-0.2902354598045349,-0.01688936352729797,-0.07542046904563904,
-0.1146663427352905,-0.0161614716053009,-0.003555357456207275,-0.2754204869270325,0.2764446139335632,-0.1531984806060791],0],["pldt-sheet0.png",54050,1,600,375,297,1,0.5013333559036255,0.5050504803657532,[],[-0.2924443483352661,-0.3309764862060547,-0.003555357456207275,-0.2902354598045349,-0.003555357456207275,-0.2606064677238464],0],["pldt-sheet1.png",195,0,0,400,225,1,0.5,0.5022222399711609,[],[],3]]]],[],!1,!1,856685658610852,[],null],["t27",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",12,!1,
0,0,!1,6095353661910309,[["enem1d-sheet0.png",435154,1,1,325,233,1,0.6584615111351013,0.3605150282382965,[],[-0.1571285128593445,0.05025896430015564,-0.3037945032119751,0.1916739642620087,-0.3171285092830658,0.1411689817905426,-0.4184615015983582,-0.05748501420021057,-0.1571285128593445,0.0468919575214386,-0.1917945146560669,0.312885969877243,-0.1944615244865418,0.1411689817905426],0],["enem1d-sheet0.png",435154,328,1,325,233,1,0.6584615111351013,0.3605150282382965,[],[0.3415384888648987,0.6394850015640259,
-0.6584615111351013,0.6394850015640259,-0.6584615111351013,-0.3605150282382965,0.3415384888648987,-0.3605150282382965],0],["enem1d-sheet0.png",435154,655,1,325,233,1,0.6584615111351013,0.3605150282382965,[],[0.3415384888648987,0.6394850015640259,-0.6584615111351013,0.6394850015640259,-0.6584615111351013,-0.3605150282382965,0.3415384888648987,-0.3605150282382965],0],["enem1d-sheet0.png",435154,1,236,325,233,1,0.6584615111351013,0.3605150282382965,[],[0.3415384888648987,0.6394850015640259,-0.6584615111351013,
0.6394850015640259,-0.6584615111351013,-0.3605150282382965,0.3415384888648987,-0.3605150282382965],0],["enem1d-sheet0.png",435154,328,236,325,233,1,0.6584615111351013,0.3605150282382965,[],[0.3415384888648987,0.6394850015640259,-0.6584615111351013,0.6394850015640259,-0.6584615111351013,-0.3605150282382965,0.3415384888648987,-0.3605150282382965],0],["enem1d-sheet0.png",435154,655,236,325,233,1,0.6584615111351013,0.3605150282382965,[],[0.3415384888648987,0.6394850015640259,-0.6584615111351013,0.6394850015640259,
-0.6584615111351013,-0.3605150282382965,0.3415384888648987,-0.3605150282382965],0],["enem1d-sheet0.png",435154,1,471,325,233,1,0.6584615111351013,0.3605150282382965,[],[0.3415384888648987,0.6394850015640259,-0.6584615111351013,0.6394850015640259,-0.6584615111351013,-0.3605150282382965,0.3415384888648987,-0.3605150282382965],0],["enem1d-sheet0.png",435154,328,471,325,233,1,0.6584615111351013,0.3605150282382965,[],[0.3415384888648987,0.6394850015640259,-0.6584615111351013,0.6394850015640259,-0.6584615111351013,
-0.3605150282382965,0.3415384888648987,-0.3605150282382965],0],["enem1d-sheet0.png",435154,655,471,325,233,1,0.6584615111351013,0.3605150282382965,[],[0.3415384888648987,0.6394850015640259,-0.6584615111351013,0.6394850015640259,-0.6584615111351013,-0.3605150282382965,0.3415384888648987,-0.3605150282382965],0],["enem1d-sheet0.png",435154,1,706,325,233,1,0.6584615111351013,0.3605150282382965,[],[0.3415384888648987,0.6394850015640259,-0.6584615111351013,0.6394850015640259,-0.6584615111351013,-0.3605150282382965,
0.3415384888648987,-0.3605150282382965],0],["enem1d-sheet0.png",435154,328,706,325,233,1,0.6584615111351013,0.3605150282382965,[],[0.3415384888648987,0.6394850015640259,-0.6584615111351013,0.6394850015640259,-0.6584615111351013,-0.3605150282382965,0.3415384888648987,-0.3605150282382965],0],["enem1d-sheet0.png",435154,655,706,325,233,1,0.6584615111351013,0.3605150282382965,[],[0.3415384888648987,0.6394850015640259,-0.6584615111351013,0.6394850015640259,-0.6584615111351013,-0.3605150282382965,0.3415384888648987,
-0.3605150282382965],0],["enem1d-sheet1.png",23372,0,0,325,233,1,0.6584615111351013,0.3605150282382965,[],[0.3415384888648987,0.6394850015640259,-0.6584615111351013,0.6394850015640259,-0.6584615111351013,-0.3605150282382965,0.3415384888648987,-0.3605150282382965],0]]]],[["Bullet",cr.behaviors.Bullet,0x7a59917969e89],["DestroyOutsideLayout",cr.behaviors.destroy,7878069710699186]],!1,!1,9002012224607532,[],null],["t28",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xffb545d3930c9,[["score1-sheet0.png",
6302,0,0,150,44,1,0.5,0.5,[],[-0.453125,-0.3846150040626526,0,-0.4134615063667297,0.4492189884185791,-0.375,0.4414060115814209,0.3557689785957336,0,0.3942310214042664,-0.4179686903953552,0.4519230127334595],0]]]],[],!1,!1,0x89e32a9eddd3f,[],null],["t29",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7123464177617237,[["sprite7-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,0xf4a0b83297355,[],null],["t30",cr.plugins_.Audio,!1,[],0,0,null,null,[],!1,!1,5159947792363041,[],null,
[0,0,1,1,600,600,1E4,1,5E3,1]],["t31",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,8055139136248786,[["sprite15-sheet0.png",1428,0,0,36,17,1,0.5277777910232544,0.529411792755127,[],[-0.3611108064651489,-0.1764707863330841,-0.0277777910232544,-0.3529407978057861,0.3055552244186401,-0.1764707863330841,0.3333331942558289,-0.05882379412651062,0.3055552244186401,0.1176472306251526,-0.0277777910232544,0.2941172122955322,-0.3611108064651489,0.1176472306251526,-0.444444477558136,-0.05882379412651062],
0]]]],[["Bullet",cr.behaviors.Bullet,9438054515706316],["DestroyOutsideLayout",cr.behaviors.destroy,378491185482265]],!1,!1,6706251954700354,[],null],["t32",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5827781947408108,[["jump-sheet0.png",9073,0,0,150,149,1,0.5066666603088379,0.5100671052932739,[],[-0.5066666603088379,-0.5100671052932739,-0.02666667103767395,-0.5100671052932739,0.4933333396911621,-0.5100671052932739,0.4933333396911621,-0.03149610757827759,0.4933333396911621,0.4756469130516052,
0.1733333468437195,0.4899328947067261,-0.4933333694934845,0.4899328947067261,-0.5066666603088379,0.03278988599777222],0]]]],[],!1,!1,4838228945459008,[],null],["t33",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,481063504563853,[["shoot-sheet0.png",9320,0,0,150,149,1,0.5,0.5033556818962097,[],[-0.3266670107841492,-0.3176416754722595,0,-0.4533556699752808,0.3333330154418945,-0.3247846961021423,0.4866669774055481,-0.003355681896209717,0.3333330154418945,0.3180733323097229,0,0.4466443061828613,
-0.3266670107841492,0.3109303116798401,-0.4733332991600037,-0.003355681896209717],0]]]],[],!1,!1,9437207756784992,[],null],["t34",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x9d217562fc021,[["bulletlight-sheet0.png",5514,0,0,200,234,1,0.9350000023841858,0.4145299196243286,[],[],0]]]],[],!1,!1,9271287819695588,[],null],["t35",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5179403842129789,[["sprite21-sheet0.png",9317,0,0,150,149,1,0.5,0.5033556818962097,[],[-0.4866667091846466,
-0.5033556818962097,-0.06000000238418579,-0.5033556818962097,0.5,-0.5033556818962097,0.5,-0.01049867272377014,0.5,0.4966443181037903,-0.03333300352096558,0.4966443181037903,-0.5,0.4966443181037903,-0.5,-0.003355681896209717],0]]]],[],!1,!1,8702776148266757,[],null],["t36",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x6ff77c25b21d6,[["sprite23-sheet0.png",9388,0,0,150,149,1,0.5,0.5033556818962097,[],[-0.5,-0.5033556818962097,0,-0.5033556818962097,0.5,-0.5033556818962097,0.4866669774055481,
-0.003355681896209717,0.5,0.4966443181037903,-0.03333300352096558,0.4966443181037903,-0.5,0.4966443181037903,-0.5,-0.01049867272377014],0]]]],[],!1,!1,0x3e9401697dab9,[],null],["t37",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6491704152447296,[["sprite7-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,7120534250073251,[],null],["t38",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground2.png",169,3],null,[],!1,!1,423647045556217,[],null],["t39",cr.plugins_.TiledBg,!1,[],1,0,["runhere2.png",
77880,0],null,[["Bullet",cr.behaviors.Bullet,4715331367008658]],!1,!1,0x3a250a72bdcad,[],null],["t40",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!0,0,0,!1,4928780050623547,[["firejump-sheet0.png",111863,1,1,1150,283,1,0.5008695721626282,0.5017668008804321,[],[-0.4713043570518494,-0.3816258013248444,0.4652174115180969,-0.3639578223228455,0.4591304063796997,0.3356891870498657,-0.4660869836807251,0.3568902015686035],0],["firejump-sheet0.png",111863,1,1,1150,283,1,0.5008695721626282,0.5017668008804321,
[],[-0.4713043570518494,-0.3816258013248444,0.4652174115180969,-0.3639578223228455,0.4591304063796997,0.3356891870498657,-0.4660869836807251,0.3568902015686035],0],["firejump-sheet0.png",111863,1,1,1150,283,1,0.5008695721626282,0.5017668008804321,[],[-0.4713043570518494,-0.3816258013248444,0.4652174115180969,-0.3639578223228455,0.4591304063796997,0.3356891870498657,-0.4660869836807251,0.3568902015686035],0],["firejump-sheet0.png",111863,1,286,939,109,1,0.5005325078964233,0.5045871734619141,[],[],
0],["firejump-sheet0.png",111863,1,1,1150,283,1,0.5008695721626282,0.5017668008804321,[],[-0.4713043570518494,-0.3816258013248444,0.4652174115180969,-0.3639578223228455,0.4591304063796997,0.3356891870498657,-0.4660869836807251,0.3568902015686035],0],["firejump-sheet0.png",111863,1,1,1150,283,1,0.5008695721626282,0.5017668008804321,[],[-0.4713043570518494,-0.3816258013248444,0.4652174115180969,-0.3639578223228455,0.4591304063796997,0.3356891870498657,-0.4660869836807251,0.3568902015686035],0],["firejump-sheet0.png",
111863,1,1,1150,283,1,0.5008695721626282,0.5017668008804321,[],[-0.4713043570518494,-0.3816258013248444,0.4652174115180969,-0.3639578223228455,0.4591304063796997,0.3356891870498657,-0.4660869836807251,0.3568902015686035],0],["firejump-sheet0.png",111863,1,286,939,109,1,0.5005325078964233,0.5045871734619141,[],[],0]]]],[],!1,!1,0x926bf661f6f15,[],null],["t41",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xcdccadc28f3ad,[["characterscreen-sheet0.png",71480,0,0,655,557,1,0.5007633566856384,
0.5008976459503174,[],[-0.4244274497032166,-0.391488641500473,-0.001526355743408203,-0.5008976459503174,0.4152676463127136,-0.3805476427078247,0.4778626561164856,-0.00199165940284729,0.4396946430206299,0.4137633442878723,-0.4427480697631836,0.4159513711929321,-0.4839694499969482,-0.00199165940284729],0]]]],[["LiteTween",cr.behaviors.lunarray_LiteTween,6253569491668073]],!1,!1,8193273200238148,[],null],["t42",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",10,!0,0,0,!1,656652083633598,[["player-sheet0.png",
78601,1,1,250,258,1,0.5,0.5,[],[-0.3387100100517273,-0.425000011920929,0,-0.5,0.2473120093345642,-0.3824999928474426,0.1397849917411804,0,0.3870970010757446,0.4474999904632568,0,0.1949999928474426,-0.2204299867153168,0.3700000047683716,-0.456989198923111,0],0],["charac1-sheet0.png",51379,1,1,250,258,1,0.5,0.5,[],[],0],["charac1-sheet0.png",51379,253,1,250,258,1,0.5,0.5,[],[],0],["charac1-sheet1.png",33996,0,0,250,258,1,0.5,0.5,[],[],0]]]],[["LiteTween",cr.behaviors.lunarray_LiteTween,9134023048998144]],
!1,!1,6601405202036132,[],null],["t43",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",10,!0,0,0,!1,867718049573181,[["charac2-sheet0.png",96354,1,1,200,239,1,0.5,0.5020920634269714,[],[-0.4556961953639984,-0.4845920503139496,0,-0.4845920503139496,0.3417720198631287,-0.4395920634269714,0.3164560198783875,-0.002092063426971436,0.1898729801177979,0.3754079341888428,0,0.4979079365730286,-0.3417720198631287,0.4354078769683838,-0.3037970066070557,-0.002092063426971436],0],["charac2-sheet0.png",96354,203,
1,200,239,1,0.5,0.5020920634269714,[],[],0],["charac2-sheet0.png",96354,1,242,200,239,1,0.5,0.5020920634269714,[],[],0],["charac2-sheet0.png",96354,203,242,200,239,1,0.5,0.5020920634269714,[],[],0]]]],[["LiteTween",cr.behaviors.lunarray_LiteTween,5166575911822763]],!1,!1,8253207540808329,[],null],["t44",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xf9ddbb40f89db,[["select1-sheet0.png",6558,0,0,165,54,1,0.5030303001403809,0.5,[],[-0.4727272987365723,-0.4074074029922485,-0.006060302257537842,
-0.4814814925193787,0.4666666984558106,-0.4074074029922485,0.490908682346344,0,0.4545456767082214,0.3703699707984924,-0.006060302257537842,0.4444440007209778,-0.4666666984558106,0.3888890147209168,-0.4969696998596191,0],0]]]],[],!1,!1,0xd52326b2d0f18,[],null],["t45",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9987354804506460,[["select1-sheet0.png",6558,0,0,165,54,1,0.5030303001403809,0.5,[],[-0.4727272987365723,-0.4074074029922485,-0.006060302257537842,-0.4814814925193787,0.4666666984558106,
-0.4074074029922485,0.490908682346344,0,0.4545456767082214,0.3703699707984924,-0.006060302257537842,0.4444440007209778,-0.4666666984558106,0.3888890147209168,-0.4969696998596191,0],0]]]],[],!1,!1,9029795542353598,[],null],["t46",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,6027919239828104,[["levelbox-sheet0.png",120604,0,0,778,582,1,0.5,0.5,[],[-0.4241645038127899,-0.3986250162124634,0,-0.5,0.4164519906044006,-0.3883160054683685,0.4730079770088196,0,0.4845759868621826,0.4793810248374939,
0,0.5,-0.4845758080482483,0.4793810248374939,-0.4845758080482483,0],0]]]],[["LiteTween",cr.behaviors.lunarray_LiteTween,7925726606681685]],!1,!1,0x94324d6181279,[],null],["t47",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,5862732396237131,[["level1-sheet0.png",16616,0,0,137,204,1,0.5036496520042419,0.5,[],[-0.4598540663719177,-0.4705882072448731,-0.007299661636352539,-0.4950980544090271,0.4452553391456604,-0.4656862914562225,0.4817513227462769,0,0.3722623586654663,0.4166669845581055,
-0.007299661636352539,0.4754899740219116,-0.394160658121109,0.4264709949493408,-0.4890511631965637,0],0]]]],[["LiteTween",cr.behaviors.lunarray_LiteTween,0xef3eb957847fa]],!1,!1,30214121935034,[],null],["t48",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,6940262932980836,[["level2locked-sheet0.png",19347,0,0,137,204,1,0.5036496520042419,0.5,[],[-0.4598540663719177,-0.4705882072448731,-0.007299661636352539,-0.4950980544090271,0.4452553391456604,-0.4656862914562225,0.4817513227462769,0,
0.3795623183250427,0.4215689897537231,-0.007299661636352539,0.485293984413147,-0.4233576655387878,0.4460780024528503,-0.4890511631965637,0],0]]]],[["LiteTween",cr.behaviors.lunarray_LiteTween,8131514593786565]],!1,!1,7115934864712431,[],null],["t49",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,4562442294295032,[["level3locked-sheet0.png",21238,0,0,137,204,1,0.5036496520042419,0.5,[],[-0.4598540663719177,-0.4705882072448731,-0.007299661636352539,-0.4950980544090271,0.4452553391456604,
-0.4656862914562225,0.4817513227462769,0,0.3795623183250427,0.4215689897537231,-0.007299661636352539,0.485293984413147,-0.4233576655387878,0.4460780024528503,-0.4890511631965637,0],0]]]],[["LiteTween",cr.behaviors.lunarray_LiteTween,4953120604782043]],!1,!1,4657429821830697,[],null],["t50",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x3ddf78b57b10c,[["level4locked-sheet0.png",19844,0,0,137,204,1,0.5036496520042419,0.5,[],[-0.4595320522785187,-0.4705882072448731,-0.003649652004241943,
-0.4950980544090271,0.4448793530464172,-0.4656862914562225,0.4889973402023315,0,0.4007623195648193,0.4362750053405762,-0.003649652004241943,0.4803919792175293,-0.4080614447593689,0.4362750053405762,-0.4889437556266785,0],0]]]],[["LiteTween",cr.behaviors.lunarray_LiteTween,0x639d2491e7670]],!1,!1,9767829544776516,[],null],["t51",cr.plugins_.Sprite,!1,[0x85f2fb41a6d81],0,0,null,[["Default",5,!1,1,0,!1,9278217065562476,[["level2unlocked-sheet0.png",19498,0,0,137,204,1,0.5036496520042419,0.5,[],[-0.4598540663719177,
-0.4705882072448731,-0.007299661636352539,-0.4950980544090271,0.4452553391456604,-0.4656862914562225,0.4890513420104981,0,0.408759355545044,0.4411759972572327,-0.007299661636352539,0.4754899740219116,-0.4014596343040466,0.4313730001449585,-0.4890511631965637,0],0]]]],[],!1,!1,6383551690017584,[],null],["t52",cr.plugins_.Sprite,!1,[0x54f9f4a6e2e68],0,0,null,[["Default",5,!1,1,0,!1,5738033040294553,[["level3unlocked-sheet0.png",24363,0,0,137,204,1,0.5036496520042419,0.5,[],[-0.4598540663719177,-0.4705882072448731,
-0.007299661636352539,-0.4950980544090271,0.4452553391456604,-0.4656862914562225,0.4890513420104981,0,0.408759355545044,0.4411759972572327,-0.007299661636352539,0.4754899740219116,-0.4014596343040466,0.4313730001449585,-0.4890511631965637,0],0]]]],[],!1,!1,4584682204148243,[],null],["t53",cr.plugins_.Sprite,!1,[7487371669973046],0,0,null,[["Default",5,!1,1,0,!1,0xa5ad013bacdc5,[["level4unlocked-sheet0.png",20865,0,0,137,204,1,0.5036496520042419,0.5,[],[-0.4598540663719177,-0.4705882072448731,-0.007299661636352539,
-0.4950980544090271,0.4452553391456604,-0.4656862914562225,0.4890513420104981,0,0.4014593362808228,0.4362750053405762,-0.007299661636352539,0.4754899740219116,-0.4014596343040466,0.4313730001449585,-0.4890511631965637,0],0]]]],[],!1,!1,0xb8ef2414500d4,[],null],["t54",cr.plugins_.TiledBg,!1,[],1,0,["bg1back.png",71543,1],null,[["Bullet",cr.behaviors.Bullet,0xc44563db0a8b9]],!1,!1,8780695717728805,[],null],["t55",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,0,0,!1,8023914195845953,[["shadow-sheet0.png",
1749,1,1,201,15,1,0.5024875402450562,0.5333333611488342,[],[-0.4726368486881256,-0.1333333551883698,-0.00497552752494812,-0.4666666686534882,0.467661440372467,-0.1333333551883698,0.4925374388694763,-0.0666663646697998,0.467661440372467,0.06666666269302368,-0.00497552752494812,0.3999996185302734,-0.4726368486881256,0.06666666269302368,-0.4975124299526215,-0.0666663646697998],0],["shadow-sheet0.png",1749,1,18,201,15,1,0.5024875402450562,0.5333333611488342,[],[-0.00497552752494812,-0.4666666686534882,
0.2686564326286316,-0.0666663646697998,-0.00497552752494812,0.3999996185302734,-0.2587065398693085,-0.0666663646697998],0],["shadow-sheet0.png",1749,1,35,201,15,1,0.5024875402450562,0.5333333611488342,[],[-0.00497552752494812,-0.4666666686534882,0.2238804697990418,-0.0666663646697998,-0.00497552752494812,0.3999996185302734,-0.2288555502891541,-0.0666663646697998],0],["shadow-sheet0.png",1749,1,18,201,15,1,0.5024875402450562,0.5333333611488342,[],[-0.00497552752494812,-0.4666666686534882,0.3731344342231751,
-0.0666663646697998,-0.00497552752494812,0.3999996185302734,-0.3681595325469971,-0.0666663646697998],0],["shadow-sheet0.png",1749,1,1,201,15,1,0.5024875402450562,0.5333333611488342,[],[-0.00497552752494812,-0.4666666686534882,0.4328354597091675,-0.0666663646697998,-0.00497552752494812,0.3999996185302734,-0.4328358471393585,-0.0666663646697998],0],["shadow-sheet0.png",1749,1,1,201,15,1,0.5024875402450562,0.5333333611488342,[],[-0.00497552752494812,-0.4666666686534882,0.4328354597091675,-0.0666663646697998,
-0.00497552752494812,0.3999996185302734,-0.4328358471393585,-0.0666663646697998],0]]]],[],!1,!1,0xf8f1e10eb6434,[],null],["t56",cr.plugins_.Sprite,!1,[0xfe00dbe47d20d],2,0,null,[["Default",10,!0,0,0,!1,5440193614681117,[["animal3-sheet0.png",51137,1,1,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.3002434968948364,0.003875970840454102,-0.3752435147762299,-0.4056070446968079,-0.006493508815765381,-0.4271590113639832,0.4310064315795898,-0.3021590113639832,-0.03149351477622986,-0.07802101969718933,
0.3497564792633057,0.2538759708404541,-0.1689935028553009,0.4693929553031921,-0.3377435207366943,0.3874969482421875],0],["animal3-sheet0.png",51137,80,1,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.2077925205230713,0.007751941680908203,-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2597404718399048,0.007751941680908203,0.2987014651298523,0.3875969648361206,-0.01298749446868897,0.4186049699783325,-0.06493550539016724,
0.2403099536895752],0],["animal3-sheet0.png",51137,159,1,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.2077925205230713,0.007751941680908203,-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2597404718399048,0.007751941680908203,0.2467535138130188,0.3565889596939087,-0.01298749446868897,0.4108529686927795,-0.06493550539016724,0.2403099536895752],0],["animal3-sheet0.png",51137,238,1,77,129,1,0.5064935088157654,0.4961240291595459,
[],[-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2727274894714356,0.007751941680908203,0.233766496181488,0.3488369584083557,-0.01298749446868897,0.4031009674072266,-0.05194851756095886,0.2325579524040222],0],["animal3-sheet0.png",51137,317,1,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.1688314974308014,0.007751941680908203,-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,
-0.4728682339191437,0.2727274894714356,0.007751941680908203,0.233766496181488,0.3488369584083557,-0.01298749446868897,0.3953489661216736,-0.06493550539016724,0.2403099536895752],0],["animal3-sheet0.png",51137,396,1,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2857145071029663,0.007751941680908203,0.233766496181488,0.3488369584083557,-0.01298749446868897,0.3953489661216736,
-0.0389614999294281,0.2248059511184692],0],["animal3-sheet0.png",51137,1,132,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2987014651298523,0.007751941680908203,0.2857145071029663,0.3798449635505676,-0.01298749446868897,0.3798449635505676,-0.0389614999294281,0.2248059511184692],0],["animal3-sheet0.png",51137,80,132,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.4675323963165283,
-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2987014651298523,0.007751941680908203,0.233766496181488,0.3488369584083557,-0.01298749446868897,0.3875969648361206,-0.0389614999294281,0.2248059511184692],0],["animal3-sheet0.png",51137,159,132,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.1688314974308014,0.007751941680908203,-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,
0.2857145071029663,0.007751941680908203,0.2207794785499573,0.3410849571228027,-0.01298749446868897,0.3875969648361206,-0.05194851756095886,0.2325579524040222],0],["animal3-sheet0.png",51137,238,132,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.1688314974308014,0.007751941680908203,-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2857145071029663,0.007751941680908203,0.233766496181488,0.3488369584083557,-0.01298749446868897,
0.3875969648361206,-0.05194851756095886,0.2325579524040222],0],["animal3-sheet0.png",51137,317,132,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.1688314974308014,0.007751941680908203,-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2727274894714356,0.007751941680908203,0.233766496181488,0.3488369584083557,-0.01298749446868897,0.3953489661216736,-0.06493550539016724,0.2403099536895752],0],["animal3-sheet0.png",51137,238,
1,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2727274894714356,0.007751941680908203,0.233766496181488,0.3488369584083557,-0.01298749446868897,0.4031009674072266,-0.05194851756095886,0.2325579524040222],0],["animal3-sheet0.png",51137,159,1,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.2077925205230713,0.007751941680908203,-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,
-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2597404718399048,0.007751941680908203,0.2467535138130188,0.3565889596939087,-0.01298749446868897,0.4108529686927795,-0.06493550539016724,0.2403099536895752],0],["animal3-sheet0.png",51137,80,1,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.2077925205230713,0.007751941680908203,-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2597404718399048,0.007751941680908203,
0.2987014651298523,0.3875969648361206,-0.01298749446868897,0.4186049699783325,-0.06493550539016724,0.2403099536895752],0]]]],[["Bullet",cr.behaviors.Bullet,5389846328024087],["DestroyOutsideLayout",cr.behaviors.destroy,0xe7004754e14a9]],!1,!1,5667719688443023,[],null],["t57",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8582352423244841,[["sprite7-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,7747194047392945,[],null],["t58",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",10,
!0,0,0,!1,9169736045095508,[["coin1-sheet0.png",29172,1,1,85,92,1,0.5058823823928833,0.510869562625885,[],[-0.2941173911094666,-0.3152175545692444,-0.01176437735557556,-0.4347825646400452,0.2941176295280457,-0.3260865807533264,0.4235296249389648,-0.01086956262588501,0.2823526263237,0.2934784293174744,-0.01176437735557556,0.3913044333457947,-0.282353401184082,0.2826084494590759,-0.41176438331604,-0.01086956262588501],0],["coin1-sheet0.png",29172,88,1,85,92,1,0.5058823823928833,0.5,[],[-0.2941173911094666,
-0.3043479919433594,-0.01176437735557556,-0.4239130020141602,0.2941176295280457,-0.3152170181274414,0.4235296249389648,0,0.2823526263237,0.3043479919433594,-0.01176437735557556,0.3913040161132813,-0.2705883979797363,0.2826089859008789,-0.4117648005485535,0],0],["coin1-sheet0.png",29172,1,95,85,92,1,0.5058823823928833,0.5,[],[-0.1882353723049164,-0.2065219879150391,-0.01176437735557556,-0.4239130020141602,0.1999996304512024,-0.2282609939575195,0.2235296368598938,0,0.1882356405258179,0.2173910140991211,
-0.01176437735557556,0.3913040161132813,-0.1882353723049164,0.2065219879150391,-0.2235293686389923,0],0],["coin1-sheet0.png",29172,88,95,85,92,1,0.5058823823928833,0.5,[],[-0.04705837368965149,-0.07608699798583984,-0.01176437735557556,-0.4239130020141602,0.05882364511489868,-0.09782600402832031,0.05882364511489868,0.09782600402832031,-0.01176437735557556,0.4021739959716797,-0.04705837368965149,0.07608699798583984],0],["coin1-sheet1.png",15594,1,1,85,92,1,0.5058823823928833,0.5,[],[-0.04705837368965149,
-0.07608699798583984,-0.01176437735557556,-0.4239130020141602,0.05882364511489868,-0.09782600402832031,0.05882364511489868,0.09782600402832031,-0.01176437735557556,0.4021739959716797,-0.04705837368965149,0.07608699798583984],0],["coin1-sheet1.png",15594,88,1,85,92,1,0.5058823823928833,0.5,[],[-0.282353401184082,-0.2934780120849609,-0.01176437735557556,-0.4239130020141602,0.2823526263237,-0.3043479919433594,0.3882356286048889,0,0.2588236331939697,0.2826089859008789,-0.01176437735557556,0.3913040161132813,
-0.2588233947753906,0.2717390060424805,-0.3647063970565796,0],0]]]],[["Bullet",cr.behaviors.Bullet,4850929907087625],["DestroyOutsideLayout",cr.behaviors.destroy,0xe3ba8268e3d0a]],!1,!1,0xf7ea6772b15cc,[],null],["t59",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",10,!0,0,0,!1,9800421680535812,[["coin1-sheet0.png",29172,1,1,85,92,1,0.4941176474094391,0.489130437374115,[],[0.2941173613071442,0.3152175545692444,0.01176437735557556,0.4347825646400452,-0.2941176295280457,0.3260865807533264,-0.4235296547412872,
0.01086956262588501,-0.2823526263237,-0.2934784293174744,0.01176437735557556,-0.3913044333457947,0.2823533713817596,-0.2826084494590759,0.4117643535137177,0.01086956262588501],0],["coin1-sheet0.png",29172,88,1,85,92,1,0.5058823823928833,0.5,[],[-0.2941173911094666,-0.3043479919433594,-0.01176437735557556,-0.4239130020141602,0.2941176295280457,-0.3152170181274414,0.4235296249389648,0,0.2823526263237,0.3043479919433594,-0.01176437735557556,0.3913040161132813,-0.2705883979797363,0.2826089859008789,-0.4117648005485535,
0],0],["coin1-sheet0.png",29172,1,95,85,92,1,0.5058823823928833,0.5,[],[-0.1882353723049164,-0.2065219879150391,-0.01176437735557556,-0.4239130020141602,0.1999996304512024,-0.2282609939575195,0.2235296368598938,0,0.1882356405258179,0.2173910140991211,-0.01176437735557556,0.3913040161132813,-0.1882353723049164,0.2065219879150391,-0.2235293686389923,0],0],["coin1-sheet0.png",29172,88,95,85,92,1,0.5058823823928833,0.5,[],[-0.04705837368965149,-0.07608699798583984,-0.01176437735557556,-0.4239130020141602,
0.05882364511489868,-0.09782600402832031,0.05882364511489868,0.09782600402832031,-0.01176437735557556,0.4021739959716797,-0.04705837368965149,0.07608699798583984],0],["coin1-sheet1.png",15594,1,1,85,92,1,0.5058823823928833,0.5,[],[-0.1882353723049164,-0.2065219879150391,-0.01176437735557556,-0.4239130020141602,0.1999996304512024,-0.2282609939575195,0.2235296368598938,0,0.1882356405258179,0.2173910140991211,-0.01176437735557556,0.3913040161132813,-0.1882353723049164,0.2065219879150391,-0.2235293686389923,
0],0],["coin1-sheet1.png",15594,88,1,85,92,1,0.5058823823928833,0.5,[],[-0.282353401184082,-0.2934780120849609,-0.01176437735557556,-0.4239130020141602,0.2823526263237,-0.3043479919433594,0.3882356286048889,0,0.2588236331939697,0.2826089859008789,-0.01176437735557556,0.3913040161132813,-0.2588233947753906,0.2717390060424805,-0.3647063970565796,0],0]]]],[["Bullet",cr.behaviors.Bullet,7362347633030415],["DestroyOutsideLayout",cr.behaviors.destroy,8355821487929461]],!1,!1,4973481541609577,[],null],["t60",
cr.plugins_.Sprite,!1,[],2,0,null,[["Default",10,!0,0,0,!1,0x8500dac6d7ade,[["coin1-sheet0.png",29172,1,1,85,92,1,0.4941176474094391,0.489130437374115,[],[0.2941173613071442,0.3152175545692444,0.01176437735557556,0.4347825646400452,-0.2941176295280457,0.3260865807533264,-0.4235296547412872,0.01086956262588501,-0.2823526263237,-0.2934784293174744,0.01176437735557556,-0.3913044333457947,0.2823533713817596,-0.2826084494590759,0.4117643535137177,0.01086956262588501],0],["coin1-sheet0.png",29172,88,1,
85,92,1,0.5058823823928833,0.5,[],[-0.2941173911094666,-0.3043479919433594,-0.01176437735557556,-0.4239130020141602,0.2941176295280457,-0.3152170181274414,0.4235296249389648,0,0.2823526263237,0.3043479919433594,-0.01176437735557556,0.3913040161132813,-0.2705883979797363,0.2826089859008789,-0.4117648005485535,0],0],["coin1-sheet0.png",29172,1,95,85,92,1,0.5058823823928833,0.5,[],[-0.1882353723049164,-0.2065219879150391,-0.01176437735557556,-0.4239130020141602,0.1999996304512024,-0.2282609939575195,
0.2235296368598938,0,0.1882356405258179,0.2173910140991211,-0.01176437735557556,0.3913040161132813,-0.1882353723049164,0.2065219879150391,-0.2235293686389923,0],0],["coin1-sheet0.png",29172,88,95,85,92,1,0.5058823823928833,0.5,[],[-0.04705837368965149,-0.07608699798583984,-0.01176437735557556,-0.4239130020141602,0.05882364511489868,-0.09782600402832031,0.05882364511489868,0.09782600402832031,-0.01176437735557556,0.4021739959716797,-0.04705837368965149,0.07608699798583984],0],["coin1-sheet1.png",15594,
1,1,85,92,1,0.5058823823928833,0.5,[],[-0.1882353723049164,-0.2065219879150391,-0.01176437735557556,-0.4239130020141602,0.1999996304512024,-0.2282609939575195,0.2235296368598938,0,0.1882356405258179,0.2173910140991211,-0.01176437735557556,0.3913040161132813,-0.1882353723049164,0.2065219879150391,-0.2235293686389923,0],0],["coin1-sheet1.png",15594,88,1,85,92,1,0.5058823823928833,0.5,[],[-0.282353401184082,-0.2934780120849609,-0.01176437735557556,-0.4239130020141602,0.2823526263237,-0.3043479919433594,
0.3882356286048889,0,0.2588236331939697,0.2826089859008789,-0.01176437735557556,0.3913040161132813,-0.2588233947753906,0.2717390060424805,-0.3647063970565796,0],0]]]],[["Bullet",cr.behaviors.Bullet,6399659348031139],["DestroyOutsideLayout",cr.behaviors.destroy,4762646638649623]],!1,!1,0x559e760c84913,[],null],["t61",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",10,!0,0,0,!1,7974915756797223,[["coin1-sheet0.png",29172,1,1,85,92,1,0.5058823823928833,0.510869562625885,[],[-0.2941173911094666,-0.3152175545692444,
-0.01176437735557556,-0.4347825646400452,0.2941176295280457,-0.3260865807533264,0.4235296249389648,-0.01086956262588501,0.2823526263237,0.2934784293174744,-0.01176437735557556,0.3913044333457947,-0.282353401184082,0.2826084494590759,-0.41176438331604,-0.01086956262588501],0],["coin1-sheet0.png",29172,88,1,85,92,1,0.5058823823928833,0.5,[],[-0.2941173911094666,-0.3043479919433594,-0.01176437735557556,-0.4239130020141602,0.2941176295280457,-0.3152170181274414,0.4235296249389648,0,0.2823526263237,0.3043479919433594,
-0.01176437735557556,0.3913040161132813,-0.2705883979797363,0.2826089859008789,-0.4117648005485535,0],0],["coin1-sheet0.png",29172,1,95,85,92,1,0.5058823823928833,0.5,[],[-0.1882353723049164,-0.2065219879150391,-0.01176437735557556,-0.4239130020141602,0.1999996304512024,-0.2282609939575195,0.2235296368598938,0,0.1882356405258179,0.2173910140991211,-0.01176437735557556,0.3913040161132813,-0.1882353723049164,0.2065219879150391,-0.2235293686389923,0],0],["coin1-sheet0.png",29172,88,95,85,92,1,0.5058823823928833,
0.5,[],[-0.04705837368965149,-0.07608699798583984,-0.01176437735557556,-0.4239130020141602,0.05882364511489868,-0.09782600402832031,0.05882364511489868,0.09782600402832031,-0.01176437735557556,0.4021739959716797,-0.04705837368965149,0.07608699798583984],0],["coin1-sheet1.png",15594,1,1,85,92,1,0.5058823823928833,0.5,[],[-0.1882353723049164,-0.2065219879150391,-0.01176437735557556,-0.4239130020141602,0.1999996304512024,-0.2282609939575195,0.2235296368598938,0,0.1882356405258179,0.2173910140991211,
-0.01176437735557556,0.3913040161132813,-0.1882353723049164,0.2065219879150391,-0.2235293686389923,0],0],["coin1-sheet1.png",15594,88,1,85,92,1,0.5058823823928833,0.5,[],[-0.282353401184082,-0.2934780120849609,-0.01176437735557556,-0.4239130020141602,0.2823526263237,-0.3043479919433594,0.3882356286048889,0,0.2588236331939697,0.2826089859008789,-0.01176437735557556,0.3913040161132813,-0.2588233947753906,0.2717390060424805,-0.3647063970565796,0],0]]]],[["Bullet",cr.behaviors.Bullet,0x4da4e53e777df],
["DestroyOutsideLayout",cr.behaviors.destroy,5456332876770177]],!1,!1,6792060029761406,[],null],["t62",cr.plugins_.Sprite,!1,[8364830527179072],2,0,null,[["run",10,!0,0,0,!1,0x7375bedfea6df,[["charac2-sheet0.png",96354,1,1,200,239,1,0.8650000095367432,0.4225941300392151,[],[-0.6349999904632568,-0.2243181318044663,-0.3650000095367432,-0.3277665376663208,-0.2450000047683716,-0.09500813484191895,-0.3500000238418579,0.07740586996078491,-0.300000011920929,0.2024058699607849,-0.1700000762939453,0.5774058699607849,
-0.5900000333786011,0.5774058699607849,-0.5299999713897705,0.07740586996078491],0],["player2-sheet0.png",73765,1,1,200,239,1,0.8650000095367432,0.4435146450996399,[],[-0.5,-0.1864066421985626,-0.3650000095367432,-0.3414736390113831,-0.2100000381469727,-0.288482666015625,-0.04000002145767212,-0.01883164048194885,-0.2450000047683716,0.5564853549003601,-0.5450000166893005,0.5564853549003601,-0.4900000095367432,0.05444434285163879],0],["player2-sheet0.png",73765,203,1,200,239,1,0.9049999713897705,0.4351464509963989,
[],[-0.4049999713897705,-0.3453505635261536,-0.09499996900558472,0.06281253695487976,-0.2499999403953552,0.5648535490036011,-0.6249999403953552,0.5648535490036011,-0.5299999713897705,0.06281253695487976],0],["player2-sheet0.png",73765,1,242,200,239,1,0.8799999952316284,0.4518828392028809,[],[-0.4399999976158142,-0.0926988422870636,-0.2649999856948853,-0.4011086225509644,-0.07499998807907104,0.002973169088363648,-0.1100000143051148,0.2722551822662354,-0.1499999761581421,0.5481171607971191,-0.6399999856948853,
0.5481171607971191,-0.5149999856948853,0.04607614874839783],0]]],["jump",5,!1,1,0,!1,0xe56d326b30d9b,[["player2-sheet0.png",73765,203,242,200,225,1,0.875,0.4533333480358124,[],[-0.449999988079071,-0.0976843535900116,-0.375,-0.361283153295517,-0.2250000238418579,-0.1604463458061218,-0.05000001192092896,0.04457464814186096,-0.009999990463256836,0.4336956441402435,-0.375,0.2203066647052765,-0.6549999713897705,0.3625666201114655,-0.5049999952316284,0.04457464814186096],0]]]],[["Platform",cr.behaviors.Platform,
8107668386777258],["Bullet",cr.behaviors.Bullet,9650997297478434]],!1,!1,0xfc82ddc495ef5,[],null],["t63",cr.plugins_.Sprite,!1,[7013204006724826],1,0,null,[["Default",11,!0,0,0,!1,0x7ffcbb883b9b1,[["playeranim2-sheet0.png",187958,1,1,509,366,1,0.5009823441505432,0.5027322173118591,[],[-0.1768173575401306,-0.05191221833229065,-0.001964330673217773,-0.05464521050453186,0.102160632610321,-0.4344262182712555,0.1935166716575623,-0.1762292087078095,0.3870336413383484,-0.172131210565567,0.2612966299057007,
0.4918028116226196,-0.1886053383350372,0.491803765296936,-0.1473473310470581,0.005464792251586914,-0.3673873543739319,-0.002732217311859131],0],["playeranim2-sheet0.png",187958,512,1,509,366,1,0.5009823441505432,0.5027322173118591,[],[0.007858633995056152,-0.06010922789573669,0.1178786754608154,-0.4207650125026703,0.3398826718330383,-0.232240229845047,0.3045186400413513,-0.002732217311859131,0.326129674911499,0.4972677826881409,-0.01768133044242859,0.4972677826881409,-0.1532413363456726,0.01366078853607178,
-0.392927348613739,-0.002732217311859131],0],["playeranim2-sheet0.png",187958,1,369,509,366,1,0.5009823441505432,0.5,[],[-0.3202353417873383,-0.1202189922332764,0.02946966886520386,-0.07650300860404968,0.09430265426635742,-0.4863387942314148,0.3320236802101135,-0.213115006685257,0.2829076647758484,0,0.2495086789131165,0.5,-0.01178735494613648,0.5,-0.1512773334980011,0.01366102695465088,-0.3870333433151245,0],0],["playeranim2-sheet0.png",187958,512,369,509,366,1,0.5009823441505432,0.5,[],[-0.3968563377857208,
-0.1366119980812073,-0.001964330673217773,-0.07650300860404968,0.1218076348304749,-0.4808743000030518,0.4282906651496887,-0.1639339923858643,0.3123776316642761,0.5,-0.1787823438644409,0.49726802110672,-0.1532413363456726,0.01639300584793091,-0.3104123473167419,0],0],["playeranim2-sheet1.png",190477,1,1,509,366,1,0.5009823441505432,0.5,[],[0.02554064989089966,-0.07376998662948608,0.09626764059066772,-0.4754098057746887,0.406679630279541,-0.1967209875583649,0.3222006559371948,0,0.3889976739883423,0.5,
-0.121807336807251,0.5,-0.1669943332672119,0.04371601343154907,-0.4115914404392242,0.0450819730758667,-0.3713163435459137,-0.1475409865379334],0],["playeranim2-sheet1.png",190477,512,1,509,366,1,0.5009823441505432,0.5,[],[-0.1571713387966156,-0.02185800671577454,-0.009823352098464966,-0.09836098551750183,0.078585684299469,-0.4658470153808594,0.1984286308288574,-0.2295080125331879,0.4027506709098816,0.2390710115432739,0.2691556811332703,0.5,-0.2829073369503021,0.5,-0.2554023265838623,0.2131149768829346,
-0.4774067401885986,0],0],["playeranim2-sheet1.png",190477,1,369,509,366,1,0.5009823441505432,0.5,[],[-0.1748523414134979,-0.0464479923248291,0.02357566356658936,-0.07650300860404968,0.04616868495941162,-0.4371584951877594,0.3280946612358093,-0.2049179971218109,0.2966596484184265,0,0.255402684211731,0.4945359826087952,-0.1728883385658264,0.5,-0.1591353416442871,0.02459001541137695,-0.3516703248023987,0],0],["playeranim2-sheet1.png",190477,512,369,509,366,1,0.5009823441505432,0.5,[],[-0.1886053383350372,
-0.06557399034500122,-0.001964330673217773,-0.07923498749732971,0.102160632610321,-0.4234972894191742,0.4459726810455322,-0.1420769989490509,0.2220036387443543,0.1803280115127564,0.2337916493415833,0.49726802110672,-0.1060903370380402,0.5,-0.1434183418750763,0.09836101531982422,-0.4557957351207733,0],0]]]],[["Platform",cr.behaviors.Platform,9158534690662864]],!1,!1,5204086171738686,[],null],["t64",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9792338867553820,[["bulletlight-sheet0.png",
5514,0,0,200,234,1,1,0.3461538553237915,[],[],0]]]],[],!1,!1,0x877aae767b253,[],null],["t65",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",8,!1,0,0,!1,0xc58da9bc412a9,[["pldt-sheet0.png",54050,379,1,375,297,1,0.5013333559036255,0.5050504803657532,[],[-0.002666354179382324,0.08417552709579468,0.1439996361732483,-0.05723947286605835,0.1573336720466614,-0.006734490394592285,0.2586666345596314,0.1919195055961609,-0.002666354179382324,0.08754253387451172,0.03199964761734009,-0.1784514784812927,0.03466665744781494,
-0.006734490394592285],0],["pldt-sheet0.png",54050,379,300,375,297,1,0.5013333559036255,0.5050504803657532,[],[0.1679996252059937,-0.08754247426986694,0.1893336176872253,-0.006734490394592285,0.2639996409416199,0.198653519153595,0.03466665744781494,-0.1818184852600098,0.06133365631103516,-0.006734490394592285],0],["pldt-sheet0.png",54050,1,301,375,297,1,0.5013333559036255,0.5050504803657532,[],[0.1306666731834412,-0.04040446877479553,0.175999641418457,-0.006734490394592285,0.2533336281776428,0.1851854920387268,
0.005333662033081055,-0.006734490394592285],0],["pldt-sheet0.png",54050,1,1,376,298,1,0.5026595592498779,0.5033556818962097,[],[-0.00265955924987793,-0.2382546961307526,0.138297438621521,-0.05033567547798157,0.09574443101882935,-0.003355681896209717,0.2021274566650391,0.1241613030433655,-0.00265955924987793,0.04026830196380615,-0.01329755783081055,-0.003355681896209717],0],["pldt-sheet0.png",54050,378,599,375,297,1,0.5013333559036255,0.5050504803657532,[],[-0.1146663427352905,-0.1828284859657288,
-0.003555357456207275,-0.2902354598045349,-0.01688936352729797,-0.07542046904563904,-0.1146663427352905,-0.0161614716053009,-0.003555357456207275,-0.2754204869270325,0.2764446139335632,-0.1531984806060791],0],["pldt-sheet0.png",54050,1,600,375,297,1,0.5013333559036255,0.5050504803657532,[],[-0.2924443483352661,-0.3309764862060547,-0.003555357456207275,-0.2902354598045349,-0.003555357456207275,-0.2606064677238464],0],["pldt-sheet1.png",195,0,0,400,225,1,0.5,0.5022222399711609,[],[],3]]]],[],!1,!1,
8243888759689509,[],null],["t66",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x6d64ff2d3e994,[["levelend-sheet0.png",67600,0,0,635,428,1,0.5007873773574829,0.5023364424705505,[],[-0.4262418746948242,-0.4060923457145691,-7.873773574829102E-4,-0.5023364424705505,0.4264855980873108,-0.4084397554397583,0.475576639175415,-0.002336442470550537,0.4246675968170166,0.4014195799827576,-7.873773574829102E-4,0.488273561000824,-0.422605574131012,0.3967245817184448,-0.4716964662075043,-0.002336442470550537],
0]]]],[["LiteTween",cr.behaviors.lunarray_LiteTween,9581960415981256]],!1,!1,8234755498260212,[],null],["t67",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,7197833998580247,[["nextlevel-sheet0.png",19874,0,0,126,131,1,0.5,0.5038167834281921,[],[-0.3412699997425079,-0.3511447906494141,0,-0.5038167834281921,0.3333330154418945,-0.3435117900371552,0.4841269850730896,-0.007633775472640991,0.3333330154418945,0.3358781933784485,0,0.4580152034759522,-0.3333330154418945,0.3358781933784485,-0.4841269850730896,
-0.007633775472640991],0]]]],[["LiteTween",cr.behaviors.lunarray_LiteTween,7119362751512265]],!1,!1,866811333968346,[],null],["t68",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,4543819671467393,[["restartlevel-sheet0.png",22154,0,0,128,132,1,0.5,0.5,[],[-0.328125,-0.3333330154418945,0,-0.5,0.3359379768371582,-0.3409090042114258,0.484375,0,0.3359379768371582,0.3409090042114258,0,0.4545450210571289,-0.328125,0.3333330154418945,-0.46875,0],0]]]],[["LiteTween",cr.behaviors.lunarray_LiteTween,
0x919415d022c89]],!1,!1,8592355685410433,[],null],["t69",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,6821480293394714,[["twitter-sheet0.png",10429,0,0,239,47,1,0.5020920634269714,0.5106382966041565,[],[-0.4853556752204895,-0.4255318939685822,-0.004184067249298096,-0.5106382966041565,0.4811719655990601,-0.4255318939685822,0.4937239289283752,-0.02127629518508911,0.4728029370307922,0.3617017269134522,-0.004184067249298096,0.4468086957931519,-0.4811715483665466,0.3829786777496338,-0.497907966375351,
-0.02127629518508911],0]]]],[["LiteTween",cr.behaviors.lunarray_LiteTween,0x576f116ebb5c1]],!1,!1,9641225440459096,[],null],["t70",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,8214675997246388,[["facebook-sheet0.png",12381,0,0,239,48,1,0.5020920634269714,0.5,[],[-0.4811715483665466,-0.3958330154418945,-0.004184067249298096,-0.4791666865348816,0.4769869446754456,-0.3958330154418945,0.4937239289283752,0,0.4728029370307922,0.375,-0.004184067249298096,0.4374999403953552,-0.4811715483665466,
0.3958330154418945,-0.497907966375351,0],0]]]],[["LiteTween",cr.behaviors.lunarray_LiteTween,6100775529764513]],!1,!1,6130891109810784,[],null],["t71",cr.plugins_.TiledBg,!1,[],1,0,["bg2back.png",53246,1],null,[["Bullet",cr.behaviors.Bullet,6338988171976082]],!1,!1,4599602667974504,[],null],["t72",cr.plugins_.TiledBg,!1,[],1,0,["bg2front.png",190232,0],null,[["Bullet",cr.behaviors.Bullet,0xe418b4f43a19d]],!1,!1,7046656937825437,[],null],["t73",cr.plugins_.TiledBg,!1,[],1,0,["runhere3.png",42609,0],
null,[["Bullet",cr.behaviors.Bullet,942789474518595]],!1,!1,9526550209768906,[],null],["t74",cr.plugins_.Sprite,!1,[9026139323567024],2,0,null,[["Default",8,!0,0,0,!1,0xda3021e5bbd23,[["alien1-sheet0.png",51256,1,1,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4548805058002472,-0.2315359711647034,-0.1968165040016174,-0.4953649640083313,0.04834550619125366,-0.4868549704551697,0.1257644891738892,-0.2315359711647034,0.4096354842185974,-0.240045964717865,0.0881834626197815,0.4961240291595459,
-0.3237515091896057,0.4922930002212524,-0.2742354869842529,0.1556980013847351],0],["alien1-sheet0.png",51256,80,1,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.3014935255050659,-0.003875970840454102,-0.2264935076236725,-0.2645599842071533,-0.006493508815765381,-0.07225197553634644,-0.02149349451065064,-0.0637049674987793,0.2535064816474915,-0.003875970840454102,-0.08149349689483643,0.004671037197113037,-0.006493508815765381,0.4021070003509522,-0.3164935111999512,0.3337310552597046],0],["alien1-sheet0.png",
51256,159,1,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.3064935207366943,-0.003875970840454102,-0.2664934992790222,-0.2987479567527771,-0.006493508815765381,-0.4397733807563782,0.008506476879119873,-0.08934596180915833,0.2835065126419067,-0.003875970840454102,-0.08649352192878723,3.980398178100586E-4,-0.006493508815765381,0.3892860412597656,-0.3214935064315796,0.3380040526390076],0],["alien1-sheet0.png",51256,238,1,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.2964935302734375,-0.003875970840454102,
-0.3964934945106506,-0.4098588824272156,-0.006493508815765381,-0.4611409604549408,-0.01649349927902222,-0.06797897815704346,0.2585064768791199,-0.003875970840454102,-0.08149349689483643,0.004671037197113037,-0.006493508815765381,0.3935600519180298,-0.3164935111999512,0.3337310552597046],0],["alien1-sheet0.png",51256,317,1,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.3364934921264648,-0.003875970840454102,-0.1964935064315796,-0.2389189600944519,-0.006493508815765381,-0.08507296442985535,0.008506476879119873,
-0.08934596180915833,0.2835065126419067,-0.003875970840454102,-0.08649352192878723,3.980398178100586E-4,-0.006493508815765381,0.3892860412597656,-0.3214935064315796,0.3380040526390076],0],["alien1-sheet0.png",51256,396,1,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4675325155258179,-0.4806201756000519,-0.01298749446868897,-0.5038759708404541,0.4675325155258179,-0.4883720576763153,0.2857145071029663,-0.007751971483230591,0.2857145071029663,0.3720930218696594,-0.01298749446868897,0.3798450231552124,
-0.05194851756095886,0.224806010723114,-0.1688314974308014,-0.007751971483230591],0],["alien1-sheet0.png",51256,1,132,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4675325155258179,-0.4806201756000519,-0.01298749446868897,-0.5038759708404541,0.4675325155258179,-0.4883720576763153,0.2987014651298523,-0.007751971483230591,0.2207794785499573,0.3333330154418945,-0.01298749446868897,0.3643410205841065,-0.0389614999294281,0.217054009437561],0],["alien1-sheet0.png",51256,80,132,77,129,1,0.5064935088157654,
0.5038759708404541,[],[-0.4675325155258179,-0.4806201756000519,-0.01298749446868897,-0.5038759708404541,0.4675325155258179,-0.4883720576763153,0.2987014651298523,-0.007751971483230591,0.233766496181488,0.3410850167274475,-0.01298749446868897,0.3720930218696594,-0.0389614999294281,0.217054009437561],0],["alien1-sheet0.png",51256,159,132,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4675325155258179,-0.4806201756000519,-0.01298749446868897,-0.5038759708404541,0.4675325155258179,-0.4883720576763153,
0.2857145071029663,-0.007751971483230591,0.2207794785499573,0.3333330154418945,-0.01298749446868897,0.3720930218696594,-0.05194851756095886,0.224806010723114,-0.1688314974308014,-0.007751971483230591],0],["alien1-sheet0.png",51256,238,132,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4675325155258179,-0.4806201756000519,-0.01298749446868897,-0.5038759708404541,0.4675325155258179,-0.4883720576763153,0.2857145071029663,-0.007751971483230591,0.2207794785499573,0.3333330154418945,-0.01298749446868897,
0.3720930218696594,-0.05194851756095886,0.224806010723114,-0.1688314974308014,-0.007751971483230591],0],["alien1-sheet0.png",51256,317,132,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4675325155258179,-0.4806201756000519,-0.01298749446868897,-0.5038759708404541,0.4675325155258179,-0.4883720576763153,0.2727274894714356,-0.007751971483230591,0.2207794785499573,0.3333330154418945,-0.01298749446868897,0.3798450231552124,-0.06493550539016724,0.232558012008667,-0.1688314974308014,-0.007751971483230591],
0],["alien1-sheet0.png",51256,238,1,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4675325155258179,-0.4806201756000519,-0.01298749446868897,-0.5038759708404541,0.4675325155258179,-0.4883720576763153,0.2727274894714356,-0.007751971483230591,0.233766496181488,0.3410850167274475,-0.01298749446868897,0.3875970244407654,-0.06493550539016724,0.232558012008667,-0.1688314974308014,-0.007751971483230591],0],["alien1-sheet0.png",51256,159,1,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4675325155258179,
-0.4806201756000519,-0.01298749446868897,-0.5038759708404541,0.4675325155258179,-0.4883720576763153,0.2727274894714356,-0.007751971483230591,0.233766496181488,0.3410850167274475,-0.01298749446868897,0.3953490257263184,-0.06493550539016724,0.232558012008667],0],["sprite7-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[["Bullet",cr.behaviors.Bullet,0xb3b46b535813a],["DestroyOutsideLayout",cr.behaviors.destroy,0x7d3975393f75f]],!1,!1,0x9267bc9f2e9b1,[],null],["t75",cr.plugins_.Sprite,!1,[0xc109fab1fe64f],
2,0,null,[["Default",20,!0,0,0,!1,0x91897a6b82d35,[["animal3-sheet0.png",51137,1,1,77,129,1,0.5064935088157654,0.5038759708404541,[],[0.2872564792633057,-0.003875970840454102,0.3622564673423767,0.4056070446968079,-0.006493508815765381,0.4271590113639832,-0.4439934194087982,0.3021590113639832,0.01850646734237671,0.07802104949951172,-0.3627434968948364,-0.2538759708404541,0.1560065150260925,-0.4693929553031921,0.3247565031051636,-0.3874969780445099],0],["animal3-sheet0.png",51137,80,1,77,129,1,0.5064935088157654,
0.4961240291595459,[],[-0.2077925205230713,0.007751941680908203,-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2597404718399048,0.007751941680908203,0.2987014651298523,0.3875969648361206,-0.01298749446868897,0.4186049699783325,-0.06493550539016724,0.2403099536895752],0],["animal3-sheet0.png",51137,159,1,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.2077925205230713,0.007751941680908203,-0.4675323963165283,-0.4728682339191437,
-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2597404718399048,0.007751941680908203,0.2467535138130188,0.3565889596939087,-0.01298749446868897,0.4108529686927795,-0.06493550539016724,0.2403099536895752],0],["animal3-sheet0.png",51137,238,1,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2727274894714356,0.007751941680908203,0.233766496181488,
0.3488369584083557,-0.01298749446868897,0.4031009674072266,-0.05194851756095886,0.2325579524040222],0],["animal3-sheet0.png",51137,317,1,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.1688314974308014,0.007751941680908203,-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2727274894714356,0.007751941680908203,0.233766496181488,0.3488369584083557,-0.01298749446868897,0.3953489661216736,-0.06493550539016724,0.2403099536895752],
0],["animal3-sheet0.png",51137,396,1,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2857145071029663,0.007751941680908203,0.233766496181488,0.3488369584083557,-0.01298749446868897,0.3953489661216736,-0.0389614999294281,0.2248059511184692],0],["animal3-sheet0.png",51137,1,132,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,
-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2987014651298523,0.007751941680908203,0.2857145071029663,0.3798449635505676,-0.01298749446868897,0.3798449635505676,-0.0389614999294281,0.2248059511184692],0],["animal3-sheet0.png",51137,80,132,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2987014651298523,0.007751941680908203,0.233766496181488,0.3488369584083557,
-0.01298749446868897,0.3875969648361206,-0.0389614999294281,0.2248059511184692],0],["animal3-sheet0.png",51137,159,132,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.1688314974308014,0.007751941680908203,-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2857145071029663,0.007751941680908203,0.2207794785499573,0.3410849571228027,-0.01298749446868897,0.3875969648361206,-0.05194851756095886,0.2325579524040222],0],["animal3-sheet0.png",
51137,238,132,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.1688314974308014,0.007751941680908203,-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2857145071029663,0.007751941680908203,0.233766496181488,0.3488369584083557,-0.01298749446868897,0.3875969648361206,-0.05194851756095886,0.2325579524040222],0],["animal3-sheet0.png",51137,317,132,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.1688314974308014,0.007751941680908203,
-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2727274894714356,0.007751941680908203,0.233766496181488,0.3488369584083557,-0.01298749446868897,0.3953489661216736,-0.06493550539016724,0.2403099536895752],0],["animal3-sheet0.png",51137,238,1,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2727274894714356,
0.007751941680908203,0.233766496181488,0.3488369584083557,-0.01298749446868897,0.4031009674072266,-0.05194851756095886,0.2325579524040222],0],["animal3-sheet0.png",51137,159,1,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.2077925205230713,0.007751941680908203,-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2597404718399048,0.007751941680908203,0.2467535138130188,0.3565889596939087,-0.01298749446868897,0.4108529686927795,
-0.06493550539016724,0.2403099536895752],0],["animal3-sheet0.png",51137,80,1,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.2077925205230713,0.007751941680908203,-0.4675323963165283,-0.4728682339191437,-0.01298749446868897,-0.4883720874786377,0.4545454978942871,-0.4728682339191437,0.2597404718399048,0.007751941680908203,0.2987014651298523,0.3875969648361206,-0.01298749446868897,0.4186049699783325,-0.06493550539016724,0.2403099536895752],0]]]],[["Bullet",cr.behaviors.Bullet,0x5aaab63130157],
["DestroyOutsideLayout",cr.behaviors.destroy,7426879659695366]],!1,!1,9887344352075616,[],null],["t76",cr.plugins_.Sprite,!1,[4943599385852659],2,0,null,[["Default",7,!0,0,0,!1,5514756044730159,[["animal1-sheet0.png",36861,1,1,105,161,1,0.5047619342803955,0.5031055808067322,[],[0.3264880776405335,0.3805153965950012,0.1577380895614624,0.4624114036560059,-0.3610119223594666,0.2468944191932678,0.02023804187774658,-0.08500257134437561,-0.4422618448734283,-0.3091405630111694,-0.004761934280395508,-0.4341405630111694,
0.3639880418777466,-0.4125885963439941,0.2889880537986755,-0.003105580806732178],0],["animal1-sheet0.png",36861,108,1,105,161,1,0.5047619342803955,0.5031055808067322,[],[0.3472380638122559,0.2740024328231812,-0.004761934280395508,0.4246054291725159,-0.3447619378566742,0.2559304237365723,-0.4447619318962097,-0.003105580806732178,-0.3487619161605835,-0.2681655883789063,-0.004761934280395508,-0.4428645968437195,0.3432380557060242,-0.2741895914077759,0.4632380604743958,-0.003105580806732178],0],["animal1-sheet1.png",
35159,1,1,105,161,1,0.5047619342803955,0.5031055808067322,[],[0.3432380557060242,0.2679784297943115,-0.004761934280395508,0.4125574231147766,-0.3407619297504425,0.2499064207077026,-0.4447619318962097,-0.003105580806732178,-0.3567619323730469,-0.2802135944366455,-0.004761934280395508,-0.4549127817153931,0.3512380719184876,-0.2862385809421539,0.4592380523681641,-0.003105580806732178],0],["animal1-sheet1.png",35159,108,1,105,161,1,0.5047619342803955,0.5031055808067322,[],[0.3392380475997925,0.2619544267654419,
-0.004761934280395508,0.4005084037780762,-0.3287619352340698,0.2318344116210938,-0.4447619318962097,-0.003105580806732178,-0.3647619485855103,-0.2922625839710236,-0.004761934280395508,-0.4669609665870667,0.3552380800247192,-0.2922625839710236,0.4592380523681641,-0.003105580806732178],0],["animal1-sheet2.png",22024,0,0,105,161,1,0.5047619342803955,0.5031055808067322,[],[0.3432380557060242,0.2679784297943115,-0.004761934280395508,0.4125574231147766,-0.3407619297504425,0.2499064207077026,-0.4447619318962097,
-0.003105580806732178,-0.3567619323730469,-0.2802135944366455,-0.004761934280395508,-0.4549127817153931,0.3512380719184876,-0.2862385809421539,0.4592380523681641,-0.003105580806732178],0],["animal1-sheet1.png",35159,108,1,105,161,1,0.5047619342803955,0.5031055808067322,[],[0.3472380638122559,0.2740024328231812,-0.004761934280395508,0.4246054291725159,-0.3447619378566742,0.2559304237365723,-0.4447619318962097,-0.003105580806732178,-0.3487619161605835,-0.2681655883789063,-0.004761934280395508,-0.4428645968437195,
0.3432380557060242,-0.2741895914077759,0.4632380604743958,-0.003105580806732178],0],["animal1-sheet1.png",35159,1,1,105,161,1,0.5047619342803955,0.5031055808067322,[],[-0.3619049191474915,-0.4099378883838654,-0.009523928165435791,-0.4161490797996521,0.009524047374725342,-0.1863355934619904,0.0476190447807312,-0.006211578845977783,0.3333330750465393,0.3913044333457947,-0.009523928165435791,0.4223604202270508,-0.3619049191474915,0.4037263989448547,-0.2761909365653992,-0.006211578845977783],0],["animal1-sheet0.png",
36861,108,1,105,161,1,0.5047619342803955,0.5031055808067322,[],[-0.3619049191474915,-0.4099378883838654,-0.009523928165435791,-0.4285713732242584,0.1809520721435547,-0.2981365919113159,0.0476190447807312,-0.006211578845977783,0.3333330750465393,0.3913044333457947,-0.009523928165435791,0.4223604202270508,-0.3619049191474915,0.4037263989448547,-0.2761909365653992,-0.006211578845977783],0]]]],[["Bullet",cr.behaviors.Bullet,9789613540693872],["DestroyOutsideLayout",cr.behaviors.destroy,9053344738772254]],
!1,!1,9331249264941296,[],null],["t77",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5810796905032006,[["sprite7-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,815697574051547,[],null],["t78",cr.plugins_.TiledBg,!1,[],1,0,["bg3back.png",354805,1],null,[["Bullet",cr.behaviors.Bullet,4564212998272841]],!1,!1,9041508784103834,[],null],["t79",cr.plugins_.TiledBg,!1,[],1,0,["bg3front.png",278452,0],null,[["Bullet",cr.behaviors.Bullet,0x7d81817113284]],!1,!1,6730552175160591,[],
null],["t80",cr.plugins_.TiledBg,!1,[],1,0,["runhere4.png",5568,1],null,[["Bullet",cr.behaviors.Bullet,6674030230956306]],!1,!1,9693852342131988,[],null],["t81",cr.plugins_.Sprite,!1,[0xcf20dfba9c20b],2,0,null,[["Default",12,!0,0,0,!1,9591007342124888,[["alien1-sheet0.png",51256,1,1,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4275249242782593,-0.07389998435974121,-0.02660351991653442,-0.3328039646148682,0.04834550619125366,-0.4868549704551697,0.1652784943580627,-0.2118319571018219,0.3458054661750794,
0.001333057880401611,0.4802805185317993,0.4616410136222839,0.007555484771728516,0.310027003288269,-0.4262112081050873,0.4364860057830811],0],["alien1-sheet0.png",51256,80,1,77,129,1,0.5064935088157654,0.4961240291595459,[],[-0.427466094493866,0.006338953971862793,-0.4669798016548157,-0.4320846199989319,-0.008013516664505005,-0.3286360502243042,0.4570325016975403,-0.4370107352733612,0.2503454685211182,0.006338953971862793,0.2928984761238098,0.1787529587745667,-0.008013516664505005,0.484171986579895,
-0.1721464991569519,-0.03799602389335632],0],["alien1-sheet0.png",51256,159,1,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4675325155258179,-0.4806201756000519,-0.01298749446868897,-0.5038759708404541,0.4675325155258179,-0.4883720576763153,0.2727274894714356,-0.007751971483230591,0.233766496181488,0.3410850167274475,-0.01298749446868897,0.3953490257263184,-0.06493550539016724,0.232558012008667],0],["alien1-sheet0.png",51256,238,1,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4675325155258179,
-0.4806201756000519,-0.01298749446868897,-0.5038759708404541,0.4675325155258179,-0.4883720576763153,0.2727274894714356,-0.007751971483230591,0.233766496181488,0.3410850167274475,-0.01298749446868897,0.3875970244407654,-0.06493550539016724,0.232558012008667,-0.1688314974308014,-0.007751971483230591],0],["alien1-sheet0.png",51256,317,1,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4675325155258179,-0.4806201756000519,-0.01298749446868897,-0.5038759708404541,0.4675325155258179,-0.4883720576763153,
0.2727274894714356,-0.007751971483230591,0.2207794785499573,0.3333330154418945,-0.01298749446868897,0.3798450231552124,-0.06493550539016724,0.232558012008667,-0.1688314974308014,-0.007751971483230591],0],["alien1-sheet0.png",51256,396,1,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4675325155258179,-0.4806201756000519,-0.01298749446868897,-0.5038759708404541,0.4675325155258179,-0.4883720576763153,0.2857145071029663,-0.007751971483230591,0.2857145071029663,0.3720930218696594,-0.01298749446868897,
0.3798450231552124,-0.05194851756095886,0.224806010723114,-0.1688314974308014,-0.007751971483230591],0],["alien1-sheet0.png",51256,1,132,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4675325155258179,-0.4806201756000519,-0.01298749446868897,-0.5038759708404541,0.4675325155258179,-0.4883720576763153,0.2857145071029663,-0.007751971483230591,0.2857145071029663,0.3720930218696594,-0.01298749446868897,0.3798450231552124,-0.05194851756095886,0.224806010723114,-0.1688314974308014,-0.007751971483230591],
0],["alien1-sheet0.png",51256,80,132,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4675325155258179,-0.4806201756000519,-0.01298749446868897,-0.5038759708404541,0.4675325155258179,-0.4883720576763153,0.2987014651298523,-0.007751971483230591,0.233766496181488,0.3410850167274475,-0.01298749446868897,0.3720930218696594,-0.0389614999294281,0.217054009437561],0],["alien1-sheet0.png",51256,159,132,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4675325155258179,-0.4806201756000519,-0.01298749446868897,
-0.5038759708404541,0.4675325155258179,-0.4883720576763153,0.2857145071029663,-0.007751971483230591,0.2207794785499573,0.3333330154418945,-0.01298749446868897,0.3720930218696594,-0.05194851756095886,0.224806010723114,-0.1688314974308014,-0.007751971483230591],0],["alien1-sheet0.png",51256,238,132,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4675325155258179,-0.4806201756000519,-0.01298749446868897,-0.5038759708404541,0.4675325155258179,-0.4883720576763153,0.2857145071029663,-0.007751971483230591,
0.2207794785499573,0.3333330154418945,-0.01298749446868897,0.3720930218696594,-0.05194851756095886,0.224806010723114,-0.1688314974308014,-0.007751971483230591],0],["alien1-sheet0.png",51256,317,132,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4675325155258179,-0.4806201756000519,-0.01298749446868897,-0.5038759708404541,0.4675325155258179,-0.4883720576763153,0.2727274894714356,-0.007751971483230591,0.2207794785499573,0.3333330154418945,-0.01298749446868897,0.3798450231552124,-0.06493550539016724,
0.232558012008667,-0.1688314974308014,-0.007751971483230591],0],["alien1-sheet0.png",51256,238,1,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4675325155258179,-0.4806201756000519,-0.01298749446868897,-0.5038759708404541,0.4675325155258179,-0.4883720576763153,0.2727274894714356,-0.007751971483230591,0.233766496181488,0.3410850167274475,-0.01298749446868897,0.3875970244407654,-0.06493550539016724,0.232558012008667,-0.1688314974308014,-0.007751971483230591],0],["alien1-sheet0.png",51256,159,
1,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4675325155258179,-0.4806201756000519,-0.01298749446868897,-0.5038759708404541,0.4675325155258179,-0.4883720576763153,0.2727274894714356,-0.007751971483230591,0.233766496181488,0.3410850167274475,-0.01298749446868897,0.3953490257263184,-0.06493550539016724,0.232558012008667],0],["alien1-sheet0.png",51256,80,1,77,129,1,0.5064935088157654,0.5038759708404541,[],[-0.4675325155258179,-0.4806201756000519,-0.01298749446868897,-0.5038759708404541,0.4675325155258179,
-0.4883720576763153,0.2597404718399048,-0.007751971483230591,0.2467535138130188,0.3488370180130005,-0.01298749446868897,0.4031010270118713,-0.06493550539016724,0.232558012008667],0]]]],[["Bullet",cr.behaviors.Bullet,9732787485203372],["DestroyOutsideLayout",cr.behaviors.destroy,4817100584219931]],!1,!1,5333644459569726,[],null],["t82",cr.plugins_.WebStorage,!1,[],0,0,null,null,[],!1,!1,4956924802313422,[],null,[]],["t83",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x7a78ebe577d49,[["sprite7-sheet0.png",
168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,7071368520152297,[],null],["t84",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,716567824316452,[["selected1-sheet0.png",7005,0,0,165,54,1,0.5030303001403809,0.5,[],[-0.4727272987365723,-0.4074074029922485,-0.006060302257537842,-0.4814814925193787,0.4666666984558106,-0.4074074029922485,0.490908682346344,0,0.4545456767082214,0.3703699707984924,-0.006060302257537842,0.4444440007209778,-0.4666666984558106,0.3888890147209168,-0.4969696998596191,
0],0]]]],[],!1,!1,0xa4b2623d9e00f,[],null],["t85",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xc90893fe9216f,[["selected1-sheet0.png",7005,0,0,165,54,1,0.5030303001403809,0.5,[],[-0.4727272987365723,-0.4074074029922485,-0.006060302257537842,-0.4814814925193787,0.4666666984558106,-0.4074074029922485,0.490908682346344,0,0.4545456767082214,0.3703699707984924,-0.006060302257537842,0.4444440007209778,-0.4666666984558106,0.3888890147209168,-0.4969696998596191,0],0]]]],[],!1,!1,0x5f2becc3a2b54,
[],null],["t86",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6962833004114046,[["back2-sheet0.png",6232,0,0,69,71,1,0.4927536249160767,0.5070422291755676,[],[0.4927533864974976,-0.01408421993255615,0.3333333730697632,0.3239437937736511,0.01449239253997803,0.4507047533988953,-0.3333336114883423,0.3380277752876282,-0.4782606363296509,-0.01408421993255615,-0.3333336114883423,-0.3521122336387634,0.01449239253997803,-0.5070422291755676,0.347826361656189,-0.3521122336387634],0]]]],[],!1,!1,
6619463221064,[],null],["t87",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",12,!1,0,0,!1,0x998f064b5909,[["animal2anim-sheet0.png",413424,1,1,325,233,1,0.6676923036575317,0.3433476388454437,[],[-0.09230732917785645,0.1587983667850494,0.138461709022522,-0.07296162843704224,0.04307669401168823,0.1587983667850494,0.046153724193573,0.2575103342533112,-0.1446152925491333,-0.07296162843704224],0],["animal2anim-sheet0.png",413424,328,1,325,233,1,0.6676923036575317,0.3433476388454437,[],[],0],["animal2anim-sheet0.png",
413424,655,1,325,233,1,0.6676923036575317,0.3433476388454437,[],[],0],["animal2anim-sheet0.png",413424,1,236,325,233,1,0.6676923036575317,0.3433476388454437,[],[],0],["animal2anim-sheet0.png",413424,328,236,325,233,1,0.6676923036575317,0.3433476388454437,[],[],0],["animal2anim-sheet0.png",413424,655,236,325,233,1,0.6676923036575317,0.3433476388454437,[],[],0],["animal2anim-sheet0.png",413424,1,471,325,233,1,0.6676923036575317,0.3433476388454437,[],[],0],["animal2anim-sheet0.png",413424,328,471,325,
233,1,0.6676923036575317,0.3433476388454437,[],[],0],["animal2anim-sheet0.png",413424,655,471,325,233,1,0.6676923036575317,0.3433476388454437,[],[],0],["animal2anim-sheet0.png",413424,1,706,325,233,1,0.6676923036575317,0.3433476388454437,[],[],0],["animal2anim-sheet0.png",413424,328,706,325,233,1,0.6676923036575317,0.3433476388454437,[],[],0],["animal2anim-sheet0.png",413424,655,706,325,233,1,0.6676923036575317,0.3433476388454437,[],[],0],["animal2anim-sheet1.png",22699,1,1,325,233,1,0.6676923036575317,
0.3433476388454437,[],[],0],["animal2anim-sheet1.png",22699,1,236,325,233,1,0.6676923036575317,0.3433476388454437,[],[],0]]]],[],!1,!1,6843439765608657,[],null],["t88",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",12,!1,0,0,!1,0x852b49f82a25b,[["animal3anim-sheet0.png",353747,1,1,325,233,1,0.6676923036575317,0.3175965547561646,[],[-0.02153831720352173,0.1845494508743286,0.06769269704818726,0.05150243639945984,0.07076966762542725,0.1845494508743286,0.01230770349502564,0.2360514402389526,-0.0707693099975586,
-0.1502145528793335],0],["animal3anim-sheet0.png",353747,328,1,325,233,1,0.6676923036575317,0.3175965547561646,[],[],0],["animal3anim-sheet0.png",353747,655,1,325,233,1,0.6676923036575317,0.3175965547561646,[],[],0],["animal3anim-sheet0.png",353747,1,236,325,233,1,0.6676923036575317,0.3175965547561646,[],[],0],["animal3anim-sheet0.png",353747,328,236,325,233,1,0.6676923036575317,0.3175965547561646,[],[],0],["animal3anim-sheet0.png",353747,655,236,325,233,1,0.6676923036575317,0.3175965547561646,[],
[],0],["animal3anim-sheet0.png",353747,1,471,325,233,1,0.6676923036575317,0.3175965547561646,[],[],0],["animal3anim-sheet0.png",353747,328,471,325,233,1,0.6676923036575317,0.3175965547561646,[],[],0],["animal3anim-sheet0.png",353747,655,471,325,233,1,0.6676923036575317,0.3175965547561646,[],[],0],["animal3anim-sheet0.png",353747,1,706,325,233,1,0.6676923036575317,0.3175965547561646,[],[],0],["animal3anim-sheet0.png",353747,328,706,325,233,1,0.6676923036575317,0.3175965547561646,[],[],0],["animal3anim-sheet0.png",
353747,655,706,325,233,1,0.6676923036575317,0.3175965547561646,[],[],0],["animal3anim-sheet1.png",19611,0,0,325,233,1,0.6676923036575317,0.3175965547561646,[],[],0]]]],[],!1,!1,9509275225737684,[],null],["t89",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,8153357455693675,[["score5000-sheet0.png",36845,0,0,359,204,1,0.5013927817344666,0.5,[],[-0.07799479365348816,0.200980007648468,0.002785205841064453,0.1421570181846619,0.111420214176178,0.2107840180397034,0.1058492064476013,0.4411759972572327,
-0.002785772085189819,0.4754899740219116,-0.0807797908782959,0.3872550129890442],0]]]],[["LiteTween",cr.behaviors.lunarray_LiteTween,0xbf29a0446b749]],!1,!1,8593706818965687,[],null],["t90",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x929f1d7566364,[["score10000-sheet0.png",36761,0,0,359,204,1,0.5013927817344666,0.5,[],[-0.01114177703857422,0.1176469922065735,0.07520920038223267,0.1617649793624878,0.1169912219047546,0.4166669845581055,2.384185791015625E-7,0.5,-0.09470778703689575,0.3235290050506592],
0]]]],[["LiteTween",cr.behaviors.lunarray_LiteTween,0xe415e1a8a70ac]],!1,!1,4901765996967932,[],null],["t91",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",12,!1,0,0,!1,0xda2ce6e1eae4b,[["animal4anim-sheet0.png",354366,1,1,325,233,1,0.6800000071525574,0.3133047223091126,[],[-0.3261539936065674,0.1845492720603943,-0.4153850078582764,0.3175962567329407,-0.4184620082378388,0.1845492720603943,-0.3600000143051148,0.1330472826957703,-0.2769230008125305,0.5193132758140564],0],["animal4anim-sheet0.png",354366,
328,1,325,233,1,0.6800000071525574,0.3133047223091126,[],[0.02769201993942261,0.2789703011512756,-0.178462028503418,0.175965279340744,-0.2184620201587677,0.04291826486587524,0.02461498975753784,0.1888412833213806,-0.178462028503418,-0.1459227204322815,0.1107689738273621,-0.02145871520042419,0.1784619688987732,0.1888412833213806],0],["animal4anim-sheet0.png",354366,655,1,325,233,1,0.6800000071525574,0.3133047223091126,[],[0.0615379810333252,0.3261802792549133,-0.178462028503418,0.4506442546844482,
-0.35384601354599,0.231759250164032,-0.1876920163631439,0.1888412833213806,-0.3076920211315155,0.20600825548172,-0.178462028503418,-0.2575107216835022,0.1076920032501221,-0.01716771721839905,0.08923101425170898,0.1888412833213806],0],["animal4anim-sheet0.png",354366,1,236,325,233,1,0.6800000071525574,0.3133047223091126,[],[0.06461501121520996,0.3304722905158997,-0.178462028503418,0.5536482930183411,-0.412308007478714,0.3133043050765991,-0.4307690262794495,0.1888412833213806,-0.3753850162029266,0.1115882694721222,
-0.178462028503418,-0.2575107216835022,0.1107689738273621,-0.02145871520042419,0.03692299127578735,0.1888412833213806],0],["animal4anim-sheet0.png",354366,328,236,325,233,1,0.6800000071525574,0.3133047223091126,[],[-0.01538503170013428,0.218884289264679,-0.178462028503418,0.6008582711219788,-0.5230770111083984,0.4678112864494324,-0.4830769896507263,0.1888412833213806,-0.4061540067195892,0.06866928935050964,-0.178462028503418,0.20600825548172,0.1446149945259094,-0.06866972148418427,-0.01538503170013428,
0.1888412833213806],0],["animal4anim-sheet0.png",354366,655,236,325,233,1,0.6800000071525574,0.3133047223091126,[],[-0.0307689905166626,0.1974253058433533,-0.178462028503418,0.38626629114151,-0.4492310285568237,0.3648072481155396,-0.5753849744796753,0.1888412833213806,-0.6307691931724548,-0.2446351200342178,-0.178462028503418,-0.2575107216835022,-0.02461498975753784,0.1673822700977325,-0.01846200227737427,0.1888412833213806],0],["animal4anim-sheet0.png",354366,1,471,325,233,1,0.6800000071525574,0.3133047223091126,
[],[-0.0307689905166626,0.1974253058433533,-0.178462028503418,0.2532193064689636,-0.4923080205917358,0.4248923063278198,-0.6492308378219604,0.1888412833213806,-0.6307691931724548,-0.2446351200342178,-0.178462028503418,-0.2575107216835022,-0.0307689905166626,0.1888412833213806],0],["animal4anim-sheet0.png",354366,328,471,325,233,1,0.6800000071525574,0.3090128898620606,[],[-0.153846025466919,0.0300430953502655,-0.178462028503418,0.03862711787223816,-0.3076920211315155,0.1716741025447846,-0.6246154308319092,
0.1931331157684326,-0.6307691931724548,-0.2403432875871658,-0.178462028503418,-0.2532188892364502,-0.2430770099163055,0.1931331157684326],0],["animal4anim-sheet0.png",354366,655,471,325,233,1,0.6800000071525574,0.3133047223091126,[],[-0.3199999928474426,-0.2060087323188782,-0.178462028503418,-0.07725372910499573,-0.3600000143051148,0.2403432726860046,-0.5169230103492737,0.1888412833213806,-0.6307691931724548,-0.2446351200342178,-0.178462028503418,-0.274678111076355,-0.4399999976158142,0.1888412833213806],
0],["animal4anim-sheet0.png",354366,1,706,325,233,1,0.6800000071525574,0.3133047223091126,[],[-0.2676919996738434,-0.1330477297306061,-0.178462028503418,-0.2188841253519058,-0.1230770349502564,-0.09012871980667114,-0.6307691931724548,-0.2446351200342178,-0.178462028503418,-0.274678111076355],0],["animal4anim-sheet0.png",354366,328,706,325,233,1,0.6800000071525574,0.3133047223091126,[],[-0.2676919996738434,-0.1330477297306061,-0.178462028503418,-0.2188841253519058,-0.1230770349502564,-0.09012871980667114,
-0.6307691931724548,-0.2446351200342178,-0.178462028503418,-0.274678111076355],0],["animal4anim-sheet0.png",354366,655,706,325,233,1,0.6800000071525574,0.3133047223091126,[],[-0.2676919996738434,-0.1330477297306061,-0.178462028503418,-0.2188841253519058,-0.1230770349502564,-0.09012871980667114,-0.6307691931724548,-0.2446351200342178,-0.178462028503418,-0.274678111076355],0],["animal4anim-sheet1.png",19719,0,0,325,233,1,0.3199999928474426,0.6866952776908875,[],[0.6800000071525574,0.3133047223091126,
-0.3199999928474426,0.3133047223091126,-0.3199999928474426,-0.6866952776908875,0.6800000071525574,-0.6866952776908875],0]]]],[],!1,!1,5768788366076228,[],null],["t92",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,7504738138219977,[["score15000-sheet0.png",36904,0,0,359,204,1,0.5013927817344666,0.5,[],[-0.01114177703857422,0.1176469922065735,0.07520920038223267,0.1617649793624878,0.1169912219047546,0.4166669845581055,2.384185791015625E-7,0.5,-0.09470778703689575,0.3235290050506592],0]]]],
[["LiteTween",cr.behaviors.lunarray_LiteTween,6155823391629196]],!1,!1,0xac3c0abb0fa0c,[],null],["t93",cr.plugins_.TiledBg,!1,[],1,0,["bg4back.png",13016,1],null,[["Bullet",cr.behaviors.Bullet,0x95c1eac6dfc3e]],!1,!1,7489447767501642,[],null],["t94",cr.plugins_.TiledBg,!1,[],1,0,["bg4front.png",218924,0],null,[["Bullet",cr.behaviors.Bullet,0xc53406943dab3]],!1,!1,9020620652158716,[],null],["t95",cr.plugins_.TiledBg,!1,[],1,0,["runhere5.png",5411,1],null,[["Bullet",cr.behaviors.Bullet,96919119939269]],
!1,!1,0x8a80a3ffde649,[],null],["t96",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x6886bcae4440e,[["score20000-sheet0.png",36929,0,0,359,204,1,0.5013927817344666,0.5,[],[-0.01114177703857422,0.1176469922065735,0.07520920038223267,0.1617649793624878,0.1169912219047546,0.4166669845581055,2.384185791015625E-7,0.5,-0.09470778703689575,0.3235290050506592],0]]]],[["LiteTween",cr.behaviors.lunarray_LiteTween,0xc37b32cd04f50]],!1,!1,0xf90949d6f96db,[],null]],[],[["Level1",1260,720,!1,"Level1",
0xef3a84029980c,[["Background",0,8974075406105744,!0,[0,0,0],!1,0.5,0.5,1,!1,1,0,0,[[[0,0,0,2520,720,0,0,1,0,0,0,0,[]],54,62,[],[[100,0,0,0,0,1]],[0,0]],[[-2,1,0,2520,720,0,0,1,0,0,0,0,[]],0,0,[],[[300,0,0,0,0,1]],[0,0]],[[1,642,0,2520,78,0,0,1,0,0,0,0,[]],39,46,[],[[450,0,0,0,0,1]],[0,0]]],[]],["Game",1,5052098693953938,!0,[0,0,0],!0,0.5,0.5,1,!1,1,0,0,[[[384,-89,0,85,92,0,3.141592741012573,1,0.4941176474094391,0.489130437374115,0,0,[]],6,7,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[351,573,0,
250,258,0,0,1,0.8759999871253967,0.4418604671955109,0,0,[]],4,6,[[1]],[[300,0,0,1350,3E3,800,0,1],[400,0,0,0,0,0]],[0,"Default",0,1]],[[1196,741,0,2452,48,0,0,1,0.5,0.5,0,0,[]],5,1,[],[[1]],[0,"Default",0,1]],[[756,-336,0,155,235,0,3.141592741012573,1,0.5032258033752441,0.4936170279979706,0,0,[]],10,12,[[1]],[[500,0,0,0,0,1],[]],[0,"Default",0,1]],[[401,-322,0,125,192,0,3.141592741012573,1,0.4952380955219269,0.4968944191932678,0,0,[]],9,11,[[1]],[[500,0,0,0,0,1],[]],[0,"Default",0,1]],[[-65,-287,
0,509,385,0,0,1,0.5009823441505432,0.5038961172103882,0,0,[]],15,18,[[100]],[[300,0,0,1350,3E3,450,0,1]],[1,"Default",0,0]],[[1195,-213,0,200,182,0,3.141592741012573,1,0.4979591965675354,0.4887892305850983,0,0,[]],14,17,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[1461,-210,0,200,186,0,3.141592741012573,1,0.5,0.4932735562324524,0,0,[]],11,14,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[259,704,0,201,15,0,0,1,0.5024875402450562,0.5333333611488342,0,0,[]],55,63,[],[],[1,"Default",0,1]],[[502,-98,0,
85,92,0,3.141592741012573,1,0.5058823823928833,0.510869562625885,0,0,[]],58,66,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[604,-90,0,85,92,0,3.141592741012573,1,0.4941176474094391,0.489130437374115,0,0,[]],59,65,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[717,-93,0,85,92,0,3.141592741012573,1,0.4941176474094391,0.489130437374115,0,0,[]],60,67,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[848,-97,0,85,92,0,3.141592741012573,1,0.5058823823928833,0.510869562625885,0,0,[]],61,68,[],[[400,0,0,0,0,1],
[]],[0,"Default",0,1]],[[346,578,0,200,239,0,0,1,0.8650000095367432,0.4225941300392151,0,0,[]],62,69,[[1]],[[300,0,0,1350,3E3,800,0,1],[400,0,0,0,0,0]],[0,"Default",0,1]],[[-383,438,0,509,366,0,0,1,0.5009823441505432,0.5027322173118591,0,0,[]],63,70,[[100]],[[300,0,0,1350,3E3,450,0,1]],[1,"Default",0,0]],[[-502,1009,0,444,318,0,3.141592741012573,1,0.6584615111351013,0.3605150282382965,0,0,[]],27,9,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[214,-517,0,375,297,0,0,1,0.5013333559036255,0.5050504803657532,
0,0,[]],26,8,[],[],[0,"Default",0,1]],[[749,-618,0,375,297,0,0,1,0.5013333559036255,0.5050504803657532,0,0,[]],65,72,[],[],[0,"Default",0,1]],[[-184,858,0,444,318,0,0,1,0.6676923036575317,0.3433476388454437,0,0,[]],87,167,[],[],[0,"Default",0,1]],[[480,956,0,444,318,0,0,1,0.6676923036575317,0.3175965547561646,0,0,[]],88,168,[],[],[0,"Default",0,1]]],[]],["UI",2,0xc1af2475ee921,!0,[0,0,0],!0,0,0,1,!1,1,0,0,[[[673,-677,0,635,428,0,0,1,0.5007873773574829,0.5023364424705505,0,0,[]],66,73,[],[[0,0,2,"628, 304",
0,0.7,1]],[0,"Default",0,1]],[[1994,-385,0,239,267,0,0,1,0.9350000023841858,0.4145299196243286,0,0,[]],34,43,[],[],[1,"Default",0,1]],[[1217,42,0,75,75,0,0,1,0.5199999809265137,0.5066666603088379,0,0,[]],20,32,[],[],[0,"Default",0,1]],[[153,8,0,361,119,0,0,1,0,0,0,0,[]],3,3,[],[],[" : 0",0,"bold 36pt Arial","rgb(255,255,255)",0,0,0,0,0]],[[-110,-139,0,120,197,0,0,1,0.5,0.508474588394165,0,0,[]],12,15,[],[[]],[0,"Default",0,1]],[[1066,40,0,200,69,0,0,1,0.5,0.5072463750839233,0,0,[]],21,33,[],[],[0,
"Default",0,1]],[[639,300,0,186,203,0,0,1,0.5,0.5024630427360535,0,0,[]],22,34,[],[],[1,"Default",0,0]],[[639,300,0,186,203,0,0,1,0.5,0.5024630427360535,0,0,[]],23,35,[],[],[1,"Default",0,0]],[[78,30,0,150,44,0,0,1,0.5,0.5,0,0,[]],28,27,[],[],[0,"Default",0,1]],[[-148,326,0,100,146,0,0,1,0.5,0.502109706401825,0,0,[]],7,10,[],[[]],[0,"Default",0,1]],[[-278,50,0,150,202,0,0,1,0.5047619342803955,0.5017668008804321,0,0,[]],13,16,[],[[]],[0,"Default",0,1]],[[-179,-399,0,36,17,0,0,1,0.5277777910232544,
0.529411792755127,0,0,[]],31,13,[],[[2200,0,0,0,1,1],[]],[0,"Default",0,1]],[[91,636,0,150,149,0,0,1,0.5,0.5033556818962097,0,0,[]],35,44,[],[],[0,"Default",0,1]],[[91,636,0,150,149,0,0,1,0.5066666603088379,0.5100671052932739,0,0,[]],32,41,[],[],[0,"Default",0,1]],[[1169,639,0,150,149,0,0,1,0.5,0.5033556818962097,0,0,[]],36,45,[],[],[0,"Default",0,1]],[[1169,639,0,150,149,0,0,1,0.5,0.5033556818962097,0,0,[]],33,42,[],[],[0,"Default",0,1]],[[646,421,0,1150,283,0,0,1,0.5008695721626282,0.5017668008804321,
0,0,[]],40,47,[],[],[0,"Default",0,1]],[[1017,-295,0,110,184,0,3.141592741012573,1,0.5064935088157654,0.4961240291595459,0,0,[]],56,64,[[1]],[[500,0,0,0,0,1],[]],[0,"Default",0,1]],[[1770,-540,0,200,234,0,0,1,1,0.3461538553237915,0,0,[]],64,71,[],[],[1,"Default",0,1]],[[586,-680,0,128,132,0,0,1,0.5,0.5,0,0,[]],68,74,[],[[0,0,2,"548, 312",0,0.7,1]],[0,"Default",0,1]],[[750,-680,0,126,131,0,0,1,0.5,0.5038167834281921,0,0,[]],67,75,[],[[0,0,2,"712, 312",0,0.7,1]],[0,"Default",0,1]],[[821,-555,0,239,
47,0,0,1,0.5020920634269714,0.5106382966041565,0,0,[]],69,76,[],[[0,0,3,"783, 437",0,0.7,1]],[0,"Default",0,1]],[[545,-555,0,239,48,0,0,1,0.5020920634269714,0.5,0,0,[]],70,77,[],[[0,0,3,"507, 437",0,0.7,1]],[0,"Default",0,1]],[[586,-301,0,359,204,0,0,1,0.5013927817344666,0.5,0,0,[]],89,24,[],[[1,0,3,"625, 337",0,0.7,1]],[0,"Default",0,1]]],[]]],[],[]],["Level2",1260,720,!1,"Level2",0x47672195a296e,[["Background",0,9809233307737284,!0,[0,0,0],!1,0.5,0.5,1,!1,1,0,0,[[[2,591,0,2520,151,0,0,1,0,0,0,0,
[]],39,78,[],[[450,0,0,0,0,1]],[0,0]],[[0,0,0,2520,720,0,0,1,0,0,0,0,[]],71,120,[],[[100,0,0,0,0,1]],[0,0]],[[0,0,0,2520,720,0,0,1,0,0,0,0,[]],72,121,[],[[300,0,0,0,0,1]],[0,0]],[[-1,616,0,2520,151,0,0,1,0,0,0,0,[]],73,122,[],[[450,0,0,0,0,1]],[0,0]],[[616,-325,0,359,204,0,0,1,0.5013927817344666,0.5,0,0,[]],90,25,[],[[1,0,3,"625, 337",0,0.7,1]],[0,"Default",0,1]],[[-902,149,0,444,318,0,0,1,0.6676923036575317,0.3175965547561646,0,0,[]],88,26,[],[],[0,"Default",0,1]],[[-786,661,0,444,318,0,0,1,0.6800000071525574,
0.3133047223091126,0,0,[]],91,28,[],[],[0,"Default",0,1]]],[]],["Game",1,6711399241814964,!0,[0,0,0],!0,0.5,0.5,1,!1,1,0,0,[[[384,-89,0,48.16666793823242,52.13333511352539,0,3.141592741012573,1,0.4941176474094391,0.489130437374115,0,0,[]],6,79,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[405,499,0,250,258,0,0,1,0.8759999871253967,0.4418604671955109,0,0,[]],4,80,[[1]],[[300,0,0,1350,3E3,800,0,1],[400,0,0,0,0,0]],[0,"Default",0,1]],[[1225,667,0,2452,48,0,0,1,0.5,0.5,0,0,[]],5,81,[],[[1]],[0,"Default",
0,1]],[[114,-253,0,509,385,0,0,1,0.5009823441505432,0.5038961172103882,0,0,[]],15,84,[[100]],[[300,0,0,1350,3E3,450,0,1]],[1,"Default",0,0]],[[1195,-213,0,245,223,0,3.141592741012573,1,0.4979591965675354,0.4887892305850983,0,0,[]],14,85,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[1363,-120,0,240,223,0,3.141592741012573,1,0.5,0.4932735562324524,0,0,[]],11,86,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[283,631,0,201,15,0,0,1,0.5024875402450562,0.5333333611488342,0,0,[]],55,87,[],[],[1,"Default",0,
1]],[[502,-98,0,48.16666793823242,52.13333511352539,0,3.141592741012573,1,0.5058823823928833,0.510869562625885,0,0,[]],58,88,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[604,-90,0,48.16666793823242,52.13333511352539,0,3.141592741012573,1,0.4941176474094391,0.489130437374115,0,0,[]],59,89,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[717,-93,0,48.16666793823242,52.13333511352539,0,3.141592741012573,1,0.4941176474094391,0.489130437374115,0,0,[]],60,90,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[848,
-97,0,48.16666793823242,52.13333511352539,0,3.141592741012573,1,0.5058823823928833,0.510869562625885,0,0,[]],61,91,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[380,499,0,200,239,0,0,1,0.8650000095367432,0.4225941300392151,0,0,[]],62,92,[[1]],[[300,0,0,1350,3E3,800,0,1],[400,0,0,0,0,0]],[0,"Default",0,1]],[[-465,539,0,509,366,0,0,1,0.5009823441505432,0.5027322173118591,0,0,[]],63,93,[[100]],[[300,0,0,1350,3E3,450,0,1]],[1,"Default",0,0]],[[-503,-582,0,444,318,0,3.141592741012573,1,0.6584615111351013,
0.3605150282382965,0,0,[]],27,94,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[214,-517,0,375,297,0,0,1,0.5013333559036255,0.5050504803657532,0,0,[]],26,95,[],[],[0,"Default",0,1]],[[749,-618,0,375,297,0,0,1,0.5013333559036255,0.5050504803657532,0,0,[]],65,96,[],[],[0,"Default",0,1]],[[-487,-211,0,110,184,0,3.141592741012573,1,0.5064935088157654,0.5038759708404541,0,0,[]],75,19,[[1]],[[500,0,0,0,0,1],[]],[0,"Default",0,1]],[[-760,-302,0,110,184,0,3.141592741012573,1,0.5064935088157654,0.5038759708404541,
0,0,[]],74,2,[[1]],[[500,0,0,0,0,1],[]],[0,"Default",0,1]],[[-441,137,0,125,192,0,3.141592741012573,1,0.5047619342803955,0.5031055808067322,0,0,[]],76,20,[[1]],[[500,0,0,0,0,1],[]],[0,"Default",0,1]]],[]],["UI",2,5410586104492812,!0,[0,0,0],!0,0,0,1,!1,1,0,0,[[[673,-677,0,635,428,0,0,1,0.5007873773574829,0.5023364424705505,0,0,[]],66,97,[],[[0,0,2,"628, 304",0,0.7,1]],[0,"Default",0,1]],[[1920,-266,0,239,267,0,0,1,0.9350000023841858,0.4145299196243286,0,0,[]],34,98,[],[],[1,"Default",0,1]],[[1217,
42,0,75,75,0,0,1,0.5199999809265137,0.5066666603088379,0,0,[]],20,99,[],[],[0,"Default",0,1]],[[143,8,0,361,119,0,0,1,0,0,0,0,[]],3,100,[],[],[" : 0",0,"bold 36pt Arial","rgb(255,255,255)",0,0,0,0,0]],[[-110,-139,0,120,197,0,0,1,0.5,0.508474588394165,0,0,[]],12,101,[],[[]],[0,"Default",0,1]],[[1066,40,0,200,69,0,0,1,0.5,0.5072463750839233,0,0,[]],21,102,[],[],[0,"Default",0,1]],[[639,300,0,186,203,0,0,1,0.5,0.5024630427360535,0,0,[]],22,103,[],[],[1,"Default",0,0]],[[638,302,0,186,203,0,0,1,0.5,0.5024630427360535,
0,0,[]],23,104,[],[],[1,"Default",0,0]],[[78,30,0,150,44,0,0,1,0.5,0.5,0,0,[]],28,105,[],[],[0,"Default",0,1]],[[-148,326,0,100,146,0,0,1,0.5,0.502109706401825,0,0,[]],7,106,[],[[]],[0,"Default",0,1]],[[-278,50,0,150,202,0,0,1,0.5047619342803955,0.5017668008804321,0,0,[]],13,107,[],[[]],[0,"Default",0,1]],[[-179,-399,0,36,17,0,0,1,0.5277777910232544,0.529411792755127,0,0,[]],31,108,[],[[2200,0,0,0,1,1],[]],[0,"Default",0,1]],[[91,636,0,150,149,0,0,1,0.5,0.5033556818962097,0,0,[]],35,109,[],[],[0,
"Default",0,1]],[[91,636,0,150,149,0,0,1,0.5066666603088379,0.5100671052932739,0,0,[]],32,110,[],[],[0,"Default",0,1]],[[1169,639,0,150,149,0,0,1,0.5,0.5033556818962097,0,0,[]],36,111,[],[],[0,"Default",0,1]],[[1169,639,0,150,149,0,0,1,0.5,0.5033556818962097,0,0,[]],33,112,[],[],[0,"Default",0,1]],[[1655,-422,0,200,234,0,0,1,1,0.3461538553237915,0,0,[]],64,115,[],[],[1,"Default",0,1]],[[586,-680,0,128,132,0,0,1,0.5,0.5,0,0,[]],68,116,[],[[0,0,2,"548, 312",0,0.7,1]],[0,"Default",0,1]],[[750,-680,0,
126,131,0,0,1,0.5,0.5038167834281921,0,0,[]],67,117,[],[[0,0,2,"712, 312",0,0.7,1]],[0,"Default",0,1]],[[821,-555,0,239,47,0,0,1,0.5020920634269714,0.5106382966041565,0,0,[]],69,118,[],[[0,0,3,"783, 437",0,0.7,1]],[0,"Default",0,1]],[[545,-555,0,239,48,0,0,1,0.5020920634269714,0.5,0,0,[]],70,119,[],[[0,0,3,"507, 437",0,0.7,1]],[0,"Default",0,1]]],[]]],[],[]],["Level3",1260,720,!1,"Level3",4774644068743127,[["Background",0,4604504747272321,!0,[0,0,0],!1,0.5,0.5,1,!1,1,0,0,[[[1,1,0,2520,720,0,0,1,0,
0,0,0,[]],78,158,[],[[100,0,0,0,0,1]],[0,0]],[[1,0,0,2520,720,0,0,1,0,0,0,0,[]],79,159,[],[[300,0,0,0,0,1]],[0,0]],[[2,656,0,2520,64,0,0,1,0,0,0,0,[]],80,160,[],[[450,0,0,0,0,1]],[0,0]],[[618,-316,0,359,204,0,0,1,0.5013927817344666,0.5,0,0,[]],92,164,[],[[1,0,3,"625, 337",0,0.7,1]],[0,"Default",0,1]]],[]],["Game",1,0x7e204468c4b9c,!0,[0,0,0],!0,0.5,0.5,1,!1,1,0,0,[[[384,-89,0,48.16666793823242,52.13333511352539,0,3.141592741012573,1,0.4941176474094391,0.489130437374115,0,0,[]],6,39,[],[[400,0,0,0,
0,1],[]],[0,"Default",0,1]],[[415,527,0,250,258,0,0,1,0.8759999871253967,0.4418604671955109,0,0,[]],4,82,[[1]],[[300,0,0,1350,3E3,800,0,1],[400,0,0,0,0,0]],[0,"Default",0,1]],[[1210,702,0,2452,48,0,0,1,0.5,0.5,0,0,[]],5,83,[],[[1]],[0,"Default",0,1]],[[-12,-260,0,509,385,0,0,1,0.5009823441505432,0.5038961172103882,0,0,[]],15,113,[[100]],[[300,0,0,1350,3E3,450,0,1]],[1,"Default",0,0]],[[1195,-213,0,245,223,0,3.141592741012573,1,0.4979591965675354,0.4887892305850983,0,0,[]],14,114,[],[[400,0,0,0,0,
1],[]],[0,"Default",0,1]],[[1363,-120,0,240,223,0,3.141592741012573,1,0.5,0.4932735562324524,0,0,[]],11,123,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[298,663,0,201,15,0,0,1,0.5024875402450562,0.5333333611488342,0,0,[]],55,124,[],[],[1,"Default",0,1]],[[502,-98,0,48.16666793823242,52.13333511352539,0,3.141592741012573,1,0.5058823823928833,0.510869562625885,0,0,[]],58,125,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[604,-90,0,48.16666793823242,52.13333511352539,0,3.141592741012573,1,0.4941176474094391,
0.489130437374115,0,0,[]],59,126,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[717,-93,0,48.16666793823242,52.13333511352539,0,3.141592741012573,1,0.4941176474094391,0.489130437374115,0,0,[]],60,127,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[848,-97,0,48.16666793823242,52.13333511352539,0,3.141592741012573,1,0.5058823823928833,0.510869562625885,0,0,[]],61,128,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[398,533,0,200,239,0,0,1,0.8650000095367432,0.4225941300392151,0,0,[]],62,129,[[1]],[[300,0,0,
1350,3E3,800,0,1],[400,0,0,0,0,0]],[0,"Default",0,1]],[[-608,448,0,509,366,0,0,1,0.5009823441505432,0.5027322173118591,0,0,[]],63,130,[[100]],[[300,0,0,1350,3E3,450,0,1]],[1,"Default",0,0]],[[-323,-483,0,444,318,0,3.141592741012573,1,0.6584615111351013,0.3605150282382965,0,0,[]],27,131,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[214,-517,0,375,297,0,0,1,0.5013333559036255,0.5050504803657532,0,0,[]],26,132,[],[],[0,"Default",0,1]],[[749,-618,0,375,297,0,0,1,0.5013333559036255,0.5050504803657532,0,
0,[]],65,133,[],[],[0,"Default",0,1]],[[-441.0000305175781,136.9999847412109,0,125,192,0,3.141592741012573,1,0.5047619342803955,0.5031055808067322,0,0,[]],76,136,[[1]],[[500,0,0,0,0,1],[]],[0,"Default",0,1]],[[-599,-476,0,110,184,0,3.141592741012573,1,0.5064935088157654,0.5038759708404541,0,0,[]],81,29,[[1]],[[500,0,0,0,0,1],[]],[0,"Default",0,1]],[[-567,-139,0,155,235,0,3.141592741012573,1,0.5032258033752441,0.4936170279979706,0,0,[]],10,30,[[1]],[[500,0,0,0,0,1],[]],[0,"Default",0,1]],[[-995,438,
0,444,318,0,0,1,0.6676923036575317,0.3433476388454437,0,0,[]],87,38,[],[],[0,"Default",0,1]],[[-966,-25,0,444,318,0,0,1,0.6800000071525574,0.3133047223091126,0,0,[]],91,162,[],[],[0,"Default",0,1]]],[]],["UI",2,6994120321924424,!0,[0,0,0],!0,0,0,1,!1,1,0,0,[[[673,-677,0,635,428,0,0,1,0.5007873773574829,0.5023364424705505,0,0,[]],66,137,[],[[0,0,2,"628, 304",0,0.7,1]],[0,"Default",0,1]],[[1920,-266,0,239,267,0,0,1,0.9350000023841858,0.4145299196243286,0,0,[]],34,138,[],[],[1,"Default",0,1]],[[1217,
42,0,75,75,0,0,1,0.5199999809265137,0.5066666603088379,0,0,[]],20,139,[],[],[0,"Default",0,1]],[[143,8,0,361,119,0,0,1,0,0,0,0,[]],3,140,[],[],[" : 0",0,"bold 36pt Arial","rgb(0,0,0)",0,0,0,0,0]],[[-110,-139,0,120,197,0,0,1,0.5,0.508474588394165,0,0,[]],12,141,[],[[]],[0,"Default",0,1]],[[1066,40,0,200,69,0,0,1,0.5,0.5072463750839233,0,0,[]],21,142,[],[],[0,"Default",0,1]],[[639,300,0,186,203,0,0,1,0.5,0.5024630427360535,0,0,[]],22,143,[],[],[1,"Default",0,0]],[[652,300,0,186,203,0,0,1,0.5,0.5024630427360535,
0,0,[]],23,144,[],[],[1,"Default",0,0]],[[78,30,0,150,44,0,0,1,0.5,0.5,0,0,[]],28,145,[],[],[0,"Default",0,1]],[[-148,326,0,100,146,0,0,1,0.5,0.502109706401825,0,0,[]],7,146,[],[[]],[0,"Default",0,1]],[[-278,50,0,150,202,0,0,1,0.5047619342803955,0.5017668008804321,0,0,[]],13,147,[],[[]],[0,"Default",0,1]],[[-179,-399,0,36,17,0,0,1,0.5277777910232544,0.529411792755127,0,0,[]],31,148,[],[[2200,0,0,0,1,1],[]],[0,"Default",0,1]],[[91,636,0,150,149,0,0,1,0.5,0.5033556818962097,0,0,[]],35,149,[],[],[0,
"Default",0,1]],[[91,636,0,150,149,0,0,1,0.5066666603088379,0.5100671052932739,0,0,[]],32,150,[],[],[0,"Default",0,1]],[[1169,639,0,150,149,0,0,1,0.5,0.5033556818962097,0,0,[]],36,151,[],[],[0,"Default",0,1]],[[1169,639,0,150,149,0,0,1,0.5,0.5033556818962097,0,0,[]],33,152,[],[],[0,"Default",0,1]],[[1647,-422,0,200,234,0,0,1,1,0.3461538553237915,0,0,[]],64,153,[],[],[1,"Default",0,1]],[[586,-680,0,128,132,0,0,1,0.5,0.5,0,0,[]],68,154,[],[[0,0,2,"548, 312",0,0.7,1]],[0,"Default",0,1]],[[750,-680,0,
126,131,0,0,1,0.5,0.5038167834281921,0,0,[]],67,155,[],[[0,0,2,"712, 312",0,0.7,1]],[0,"Default",0,1]],[[821,-555,0,239,47,0,0,1,0.5020920634269714,0.5106382966041565,0,0,[]],69,156,[],[[0,0,3,"783, 437",0,0.7,1]],[0,"Default",0,1]],[[545,-555,0,239,48,0,0,1,0.5020920634269714,0.5,0,0,[]],70,157,[],[[0,0,3,"507, 437",0,0.7,1]],[0,"Default",0,1]]],[]]],[],[]],["Level4",1260,720,!1,"Level4",6482667137424195,[["Background",0,5732183552780983,!0,[0,0,0],!1,0.5,0.5,1,!1,1,0,0,[[[0,0,0,2520,720,0,0,1,0,
0,0,0,[]],93,212,[],[[100,0,0,0,0,1]],[0,0]],[[0,0,0,2520,720,0,0,1,0,0,0,0,[]],94,213,[],[[300,0,0,0,0,1]],[0,0]],[[0,655,0,2520,64,0,0,1,0,0,0,0,[]],95,214,[],[[450,0,0,0,0,1]],[0,0]]],[]],["Game",1,0x5c1edd6d073a3,!0,[0,0,0],!0,0.5,0.5,1,!1,1,0,0,[[[384,-89,0,48.16666793823242,52.13333511352539,0,3.141592741012573,1,0.4941176474094391,0.489130437374115,0,0,[]],6,170,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[415,527,0,250,258,0,0,1,0.8759999871253967,0.4418604671955109,0,0,[]],4,171,[[1]],[[300,
0,0,1350,3E3,800,0,1],[400,0,0,0,0,0]],[0,"Default",0,1]],[[1210,702,0,2452,48,0,0,1,0.5,0.5,0,0,[]],5,172,[],[[1]],[0,"Default",0,1]],[[-12,-260,0,509,385,0,0,1,0.5009823441505432,0.5038961172103882,0,0,[]],15,173,[[100]],[[300,0,0,1350,3E3,450,0,1]],[1,"Default",0,0]],[[1184,-274,0,245,223,0,3.141592741012573,1,0.4979591965675354,0.4887892305850983,0,0,[]],14,174,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[1431,-276,0,240,223,0,3.141592741012573,1,0.5,0.4932735562324524,0,0,[]],11,175,[],[[400,
0,0,0,0,1],[]],[0,"Default",0,1]],[[298,663,0,201,15,0,0,1,0.5024875402450562,0.5333333611488342,0,0,[]],55,176,[],[],[1,"Default",0,1]],[[502,-98,0,48.16666793823242,52.13333511352539,0,3.141592741012573,1,0.5058823823928833,0.510869562625885,0,0,[]],58,177,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[604,-90,0,48.16666793823242,52.13333511352539,0,3.141592741012573,1,0.4941176474094391,0.489130437374115,0,0,[]],59,178,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[717,-93,0,48.16666793823242,52.13333511352539,
0,3.141592741012573,1,0.4941176474094391,0.489130437374115,0,0,[]],60,179,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[848,-97,0,48.16666793823242,52.13333511352539,0,3.141592741012573,1,0.5058823823928833,0.510869562625885,0,0,[]],61,180,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[398,533,0,200,239,0,0,1,0.8650000095367432,0.4225941300392151,0,0,[]],62,181,[[1]],[[300,0,0,1350,3E3,800,0,1],[400,0,0,0,0,0]],[0,"Default",0,1]],[[-608,448,0,509,366,0,0,1,0.5009823441505432,0.5027322173118591,0,0,[]],
63,182,[[100]],[[300,0,0,1350,3E3,450,0,1]],[1,"Default",0,0]],[[-323,-483,0,444,318,0,3.141592741012573,1,0.6584615111351013,0.3605150282382965,0,0,[]],27,183,[],[[400,0,0,0,0,1],[]],[0,"Default",0,1]],[[214,-517,0,375,297,0,0,1,0.5013333559036255,0.5050504803657532,0,0,[]],26,184,[],[],[0,"Default",0,1]],[[749,-618,0,375,297,0,0,1,0.5013333559036255,0.5050504803657532,0,0,[]],65,185,[],[],[0,"Default",0,1]],[[-441.0000305175781,136.9999847412109,0,125,192,0,3.141592741012573,1,0.5047619342803955,
0.5031055808067322,0,0,[]],76,186,[[1]],[[500,0,0,0,0,1],[]],[0,"Default",0,1]],[[-599,-476,0,110,184,0,3.141592741012573,1,0.5064935088157654,0.5038759708404541,0,0,[]],81,187,[[1]],[[500,0,0,0,0,1],[]],[0,"Default",0,1]],[[-567,-139,0,155,235,0,3.141592741012573,1,0.5032258033752441,0.4936170279979706,0,0,[]],10,188,[[1]],[[500,0,0,0,0,1],[]],[0,"Default",0,1]],[[-995,438,0,444,318,0,0,1,0.6676923036575317,0.3433476388454437,0,0,[]],87,189,[],[],[0,"Default",0,1]],[[-966,-25,0,444,318,0,0,1,0.6800000071525574,
0.3133047223091126,0,0,[]],91,190,[],[],[0,"Default",0,1]]],[]],["UI",2,7586154217850059,!0,[0,0,0],!0,0,0,1,!1,1,0,0,[[[673,-677,0,635,428,0,0,1,0.5007873773574829,0.5023364424705505,0,0,[]],66,191,[],[[0,0,2,"628, 304",0,0.7,1]],[0,"Default",0,1]],[[1920,-266,0,239,267,0,0,1,0.9350000023841858,0.4145299196243286,0,0,[]],34,192,[],[],[1,"Default",0,1]],[[1217,42,0,75,75,0,0,1,0.5199999809265137,0.5066666603088379,0,0,[]],20,193,[],[],[0,"Default",0,1]],[[143,8,0,361,119,0,0,1,0,0,0,0,[]],3,194,[],
[],[" : 0",0,"bold 36pt Arial","rgb(0,0,0)",0,0,0,0,0]],[[-110,-139,0,120,197,0,0,1,0.5,0.508474588394165,0,0,[]],12,195,[],[[]],[0,"Default",0,1]],[[1066,40,0,200,69,0,0,1,0.5,0.5072463750839233,0,0,[]],21,196,[],[],[0,"Default",0,1]],[[639,300,0,186,203,0,0,1,0.5,0.5024630427360535,0,0,[]],22,197,[],[],[1,"Default",0,0]],[[652,300,0,186,203,0,0,1,0.5,0.5024630427360535,0,0,[]],23,198,[],[],[1,"Default",0,0]],[[78,30,0,150,44,0,0,1,0.5,0.5,0,0,[]],28,199,[],[],[0,"Default",0,1]],[[-148,326,0,100,
146,0,0,1,0.5,0.502109706401825,0,0,[]],7,200,[],[[]],[0,"Default",0,1]],[[-278,50,0,150,202,0,0,1,0.5047619342803955,0.5017668008804321,0,0,[]],13,201,[],[[]],[0,"Default",0,1]],[[-179,-399,0,36,17,0,0,1,0.5277777910232544,0.529411792755127,0,0,[]],31,202,[],[[2200,0,0,0,1,1],[]],[0,"Default",0,1]],[[91,636,0,150,149,0,0,1,0.5,0.5033556818962097,0,0,[]],35,203,[],[],[0,"Default",0,1]],[[91,636,0,150,149,0,0,1,0.5066666603088379,0.5100671052932739,0,0,[]],32,204,[],[],[0,"Default",0,1]],[[1169,639,
0,150,149,0,0,1,0.5,0.5033556818962097,0,0,[]],36,205,[],[],[0,"Default",0,1]],[[1169,639,0,150,149,0,0,1,0.5,0.5033556818962097,0,0,[]],33,206,[],[],[0,"Default",0,1]],[[1647,-422,0,200,234,0,0,1,1,0.3461538553237915,0,0,[]],64,207,[],[],[1,"Default",0,1]],[[586,-680,0,128,132,0,0,1,0.5,0.5,0,0,[]],68,208,[],[[0,0,2,"548, 312",0,0.7,1]],[0,"Default",0,1]],[[750,-680,0,126,131,0,0,1,0.5,0.5038167834281921,0,0,[]],67,209,[],[[0,0,2,"712, 312",0,0.7,1]],[0,"Default",0,1]],[[821,-555,0,239,47,0,0,1,
0.5020920634269714,0.5106382966041565,0,0,[]],69,210,[],[[0,0,3,"783, 437",0,0.7,1]],[0,"Default",0,1]],[[545,-555,0,239,48,0,0,1,0.5020920634269714,0.5,0,0,[]],70,211,[],[[0,0,3,"507, 437",0,0.7,1]],[0,"Default",0,1]],[[633,-311,0,359,204,0,0,1,0.5013927817344666,0.5,0,0,[]],96,163,[],[[1,0,3,"625, 337",0,0.7,1]],[0,"Default",0,1]]],[]]],[],[]],["splash",1260,720,!1,"splash",4797076732387015,[["Layer 0",0,0x7f40c06a2af19,!0,[0,0,0],!1,1,1,1,!1,1,0,0,[[[631,361,0,1260,720,0,0,1,0.5,0.5,0,0,[]],16,
21,[],[],[0,"Default",0,1]]],[]]],[],[]],["character-screen",1260,720,!1,"character-screen",9777074725278288,[["Layer 0",0,7203672513188424,!0,[0,0,0],!1,1,1,1,!1,1,0,0,[[[633,361,0,1260,720,0,0,1,0.5,0.5,0,0,[]],19,48,[],[],[0,"Default",0,1]],[[667,-349,0,800,680.1006469726562,0,0,1,0.5007633566856384,0.5008976459503174,0,0,[]],41,23,[],[[1,0,3,"630, 405",0,0.7,1]],[0,"Default",0,1]],[[510,-418,0,250,258,0,0,1,0.5,0.5,0,0,[]],42,49,[],[[1,0,3,"473, 336",0,0.7,1]],[0,"Default",0,1]],[[840,-414,0,
200,239,0,0,1,0.5,0.5020920634269714,0,0,[]],43,50,[],[[1,0,3,"803, 340",0,0.7,1]],[0,"Default",0,1]],[[480,504,0,165,54,0,0,1,0.5030303001403809,0.5,0,0,[]],44,51,[],[],[0,"Default",0,1]],[[799,504,0,165,54,0,0,1,0.5030303001403809,0.5,0,0,[]],45,52,[],[],[0,"Default",0,1]],[[530,797,0,165,54,0,0,1,0.5030303001403809,0.5,0,0,[]],84,134,[],[],[0,"Default",0,1]],[[827,807,0,165,54,0,0,1,0.5030303001403809,0.5,0,0,[]],85,135,[],[],[0,"Default",0,1]]],[]]],[],[]],["menu",1260,720,!1,"menu",9242243234903916,
[["Layer 0",0,0x881dead565e42,!0,[0,0,0],!1,1,1,1,!1,1,0,0,[[[633,361,0,1260,720,0,0,1,0.5,0.5,0,0,[]],19,53,[],[],[0,"Default",0,1]],[[579,-464,0,778,582,0,0,1,0.5,0.5,0,0,[]],46,54,[],[[1,0,2,"608, 371",0,0.5,1]],[0,"Default",0,1]],[[328,-455,0,137,204,0,0,1,0.5036496520042419,0.5,0,0,[]],47,55,[],[[1,0,2,"357, 380",0,0.5,1]],[0,"Default",0,1]],[[493,-455,0,137,204,0,0,1,0.5036496520042419,0.5,0,0,[]],48,56,[],[[1,0,2,"522, 380",0,0.5,1]],[0,"Default",0,1]],[[655,-455,0,137,204,0,0,1,0.5036496520042419,
0.5,0,0,[]],49,57,[],[[1,0,2,"684, 380",0,0.5,1]],[0,"Default",0,1]],[[818,-455,0,138.0073547363281,204,0,0,1,0.5036496520042419,0.5,0,0,[]],50,58,[],[[1,0,2,"847, 380",0,0.5,1]],[0,"Default",0,1]],[[1127,-354,0,137,204,0,0,1,0.5036496520042419,0.5,0,0,[]],51,59,[[0]],[],[0,"Default",0,1]],[[1331,-371,0,137,204,0,0,1,0.5036496520042419,0.5,0,0,[]],52,60,[[0]],[],[0,"Default",0,1]],[[1579,-362,0,138.0073547363281,204,0,0,1,0.5036496520042419,0.5,0,0,[]],53,61,[[0]],[],[0,"Default",0,1]],[[976,487,
0,69,71,0,0,1,0.4927536249160767,0.5070422291755676,0,0,[]],86,161,[],[],[0,"Default",0,1]]],[]]],[],[]]],[["Level1",[[1,"gamepause",0,0,!1,!1,949407898434551,!1],[1,"playerchoose",0,2,!1,!1,8826032822917714,!1],[1,"gamespeed",0,0,!1,!1,0xa947dbaa99d2c,!1],[1,"levels",0,0,!1,!1,8897421695493437,!1],[1,"Score",0,0,!1,!1,8819852021756661,!1],[1,"timer",0,0,!1,!1,8803220164721475,!1],[0,null,!1,null,0x6e1cae0fb3a4f,[[24,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,7310249463732097,
!1,[[1,[2,"Spause"]]]]],[[23,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7798314985235137,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,9503941277289104,!1,[[0,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.SetPaused,null,0x77f2ac9a29a46,!1,[[1,[2,"main"]],[3,0]]]]],[0,null,!1,null,5419616882353703,[[24,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,8922019317586659,!1,[[1,[2,"Splay"]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,8417770602513038,
!1,[[0,[1,1]]]],[23,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xa4c57fc964445,!1,[[3,0]]],[30,cr.plugins_.Audio.prototype.acts.SetPaused,null,0x8f60d4f863a5b,!1,[[1,[2,"main"]],[3,1]]]]],[0,null,!1,null,9415167648478508,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,9187283068717520,!1]],[]],[0,null,!1,null,765125766225987,[[25,cr.plugins_.Browser.prototype.cnds.OnPageHidden,null,1,!1,!1,!1,8607991802397909,!1]],[[24,cr.plugins_.Function.prototype.acts.CallFunction,null,7408186953851865,
!1,[[1,[2,"Spause"]],[13]]]]],[0,null,!1,null,804869594698926,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6860222491323561,!1,[[4,23]]]],[[24,cr.plugins_.Function.prototype.acts.CallFunction,null,0x6cbcc2c85db01,!1,[[1,[2,"Splay"]],[13]]]]],[0,null,!1,null,0x4a9064b9428aa,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x3dbcd0b5a2252,!1,[[4,21]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0x99d0b96e60f20,!1,[[6,"menu"]]],[17,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,
null,0xae6bf0b53cbf7,!1],[30,cr.plugins_.Audio.prototype.acts.Stop,null,5955309237686269,!1,[[1,[2,"main"]]]]]],[0,null,!1,null,0xeb5ceff037c0b,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xc0bae1f71c5fa,!1,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0xc01f045623e2,!1,[[0,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.SetPaused,null,0x9f5c0a6aec04,!1,[[1,[2,"main"]],[3,0]]],[22,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0xd0ee4cca9d639,!1,[[3,
1]]],[22,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xabcf76a2fdf6a,!1,[[3,1]]]]],[0,null,!1,null,0x649edf637759a,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7878195938416307,!1,[[4,22]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,8460401423775484,!1,[[0,[0,1]]]],[30,cr.plugins_.Audio.prototype.acts.SetPaused,null,8460951401388204,!1,[[1,[2,"main"]],[3,1]]],[22,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0x7d5058fa59de9,!1,[[3,0]]],[22,cr.plugins_.Sprite.prototype.acts.SetVisible,
null,5042038021567295,!1,[[3,0]]]]],[0,null,!1,null,8782061301266574,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,7222727551628182,!1]],[[17,cr.plugins_.CJSAds.prototype.acts.PreloadFullscreen,null,7362235101043478,!1],[0,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9154349482836406,!1,[[0,[0,180]]]],[39,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x4e74d7527fd83,!1,[[0,[0,180]]]],[54,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",
9313133007231934,!1,[[0,[0,180]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xd21f43581e607,!1,[[11,"Score"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xde585fabcaf25,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5988753236224644,!1,[[11,"gamepause"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8455350209892214,!1,[[11,"gamespeed"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,826835414451367,!1,[[0,[1,0.7]]]],[-1,cr.system_object.prototype.acts.SetTimescale,
null,6518153369850285,!1,[[0,[0,0]]]]]],[0,null,!1,null,4867867440695578,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,981359851242842,!1,[[4,89]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0x899ff938b964,!1,[[0,[1,1]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xae8ae191288d,!1,[[2,["game-shoot",!1]],[3,1],[0,[0,-20]],[1,[2,"main"]]]],[89,cr.behaviors.lunarray_LiteTween.prototype.acts.Reverse,"LiteTween",5379950338183133,!1,[[3,0]]]]],[0,null,!1,null,7676301460018232,
[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7506088825346574,!1,[[11,"playerchoose"],[8,0],[7,[0,1]]]]],[[62,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xfc5298bea5922,!1]]],[0,null,!1,null,0x76f55b40a6c92,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x7e50367ce76a2,!1,[[11,"playerchoose"],[8,0],[7,[0,2]]]]],[[4,cr.plugins_.Sprite.prototype.acts.Destroy,null,6919918724142777,!1]]],[0,null,!1,null,92313698087194,[[0,cr.plugins_.TiledBg.prototype.cnds.CompareX,
null,0,!1,!1,!1,472138588152307,!1,[[8,3],[0,[7,[3,[20,0,cr.plugins_.TiledBg.prototype.exps.Width,!1,null]],[0,2]]]]]],[[0,cr.plugins_.TiledBg.prototype.acts.SetX,null,9739163761710594,!1,[[0,[4,[20,0,cr.plugins_.TiledBg.prototype.exps.X,!1,null],[7,[20,0,cr.plugins_.TiledBg.prototype.exps.Width,!1,null],[0,2]]]]]]]],[0,null,!1,null,4907980204037102,[[54,cr.plugins_.TiledBg.prototype.cnds.CompareX,null,0,!1,!1,!1,0x6280b1823f0e7,!1,[[8,3],[0,[7,[3,[20,54,cr.plugins_.TiledBg.prototype.exps.Width,!1,
null]],[0,2]]]]]],[[54,cr.plugins_.TiledBg.prototype.acts.SetX,null,8278946460968605,!1,[[0,[4,[20,54,cr.plugins_.TiledBg.prototype.exps.X,!1,null],[7,[20,54,cr.plugins_.TiledBg.prototype.exps.Width,!1,null],[0,2]]]]]]]],[0,null,!1,null,88502037301681,[[39,cr.plugins_.TiledBg.prototype.cnds.CompareX,null,0,!1,!1,!1,7362439573698249,!1,[[8,3],[0,[7,[3,[20,39,cr.plugins_.TiledBg.prototype.exps.Width,!1,null]],[0,2]]]]]],[[39,cr.plugins_.TiledBg.prototype.acts.SetX,null,8370011233355641,!1,[[0,[4,[20,
39,cr.plugins_.TiledBg.prototype.exps.X,!1,null],[7,[20,39,cr.plugins_.TiledBg.prototype.exps.Width,!1,null],[0,2]]]]]]]],[0,null,!1,null,6809936344196724,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,5374522565869359,!1]],[[-1,cr.system_object.prototype.acts.AddVar,null,0xf4392d036ab2a,!1,[[11,"timer"],[7,[19,cr.system_object.prototype.exps.dt]]]]]],[0,null,!0,null,409260669981489,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xaab7b23ef3f5b,!1,[[4,32]]],[2,
cr.plugins_.Keyboard.prototype.cnds.OnKey,null,1,!1,!1,!1,8011354961017039,!1,[[9,38]]]],[[4,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",9513226050353920,!1,[[3,2]]],[62,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",0xb2c85ed7703f5,!1,[[3,2]]],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,null,9772971068006320,!1,[[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.StartAnim,null,5399853022208101,!1,[[3,1]]],[32,cr.plugins_.Sprite.prototype.acts.SetVisible,null,
8234168034798133,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,4906081054185958,!1,[[0,[1,0.2]]]],[32,cr.plugins_.Sprite.prototype.acts.SetVisible,null,5181668119887481,!1,[[3,1]]]]],[0,null,!0,null,6995341109731459,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x48c532839852a,!1,[[4,32]]],[2,cr.plugins_.Keyboard.prototype.cnds.OnKey,null,1,!1,!1,!1,0x480ff07d4562d,!1,[[9,38]]]],[[15,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",6089563391425084,
!1,[[3,2]]],[63,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",6761290273953168,!1,[[3,2]]]]],[0,null,!1,null,5956868847942493,[[4,cr.behaviors.Platform.prototype.cnds.IsJumping,"Platform",0,!1,!1,!1,0x4058355ac09b4,!1]],[[4,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x3f10eb550cb8d,!1,[[1,[2,"jump"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,0x778c38939fe2e,!1,[[0,[0,1]]]],[4,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xb078f6dc38a96,!1,[[1,[2,"run"]],[3,1]]],
[55,cr.plugins_.Sprite.prototype.acts.StopAnim,null,0x412bd0c134146,!1],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,null,4538163964230335,!1,[[3,0]]]]],[0,null,!1,null,5461666708125207,[[62,cr.behaviors.Platform.prototype.cnds.IsJumping,"Platform",0,!1,!1,!1,0x52091cfb76486,!1]],[[62,cr.plugins_.Sprite.prototype.acts.SetAnim,null,8869764001276743,!1,[[1,[2,"jump"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,871684602745909,!1,[[0,[0,1]]]],[62,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,9609981680583872,!1,[[1,[2,"run"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.StopAnim,null,0x5db0d92c2bb5a,!1],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x5063c71bca34b,!1,[[3,0]]]]],[0,null,!1,null,0xf63fd59117c35,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xd2df9db8252c8,!1,[[11,"timer"],[8,5],[7,[0,15]]]]],[],[[0,null,!1,null,6099747829995385,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,5533965581624003,!1,[[0,[0,14]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,
null,9445070502722948,!1,[[4,11],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,400],[0,200]]]]]]]]]],[0,null,!1,null,0xbb23f7fab7e0d,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x74bb3c86ad02b,!1,[[11,"timer"],[8,5],[7,[0,5]]]]],[[40,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7584863037064211,!1,[[3,0]]],[40,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xaf58e90627772,!1]]],[0,null,!1,null,4554027846378076,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,0xb88bf1a0d0428,!1,[[11,"timer"],[8,5],[7,[0,25]]]]],[],[[0,null,!1,null,6701069298620646,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x8e069eedb92a5,!1,[[0,[0,25]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,7976042600869112,!1,[[4,14],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,400],[0,250]]]]]]]]]],[0,null,!1,null,0xffd3b2a2940b6,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,392390683047631,!1,[[11,
"timer"],[8,5],[7,[0,1]]]]],[],[[0,null,!1,null,5974310009712356,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,8716486155380684,!1,[[0,[0,4]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,6966256685785244,!1,[[4,6],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,300],[0,250]]]]]]]],[0,null,!1,null,5688460015737473,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xbeca50921e0c4,!1,[[0,[0,6]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,
null,7862488546694569,!1,[[4,58],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,300],[0,250]]]]]]]],[0,null,!1,null,0xf82bedcf214ba,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,9896712826738442,!1,[[0,[0,9]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,6373876658318726,!1,[[4,59],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,300],[0,250]]]]]]]],[0,null,!1,null,0xcf20fb2c02fb1,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,0xf8fd86bf62ea9,!1,[[0,[0,11]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,9395379757066812,!1,[[4,60],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,300],[0,250]]]]]]]],[0,null,!1,null,7011684824925185,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,8024128081075577,!1,[[0,[0,13]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,4707706914440321,!1,[[4,61],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,
[[0,300],[0,250]]]]]]]]]],[0,null,!1,null,7002383564946534,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xe05fb6c5f8ed,!1,[[11,"timer"],[8,5],[7,[0,1]]]]],[],[[0,null,!1,null,7890405103077732,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xe9bf0622a8ebd,!1,[[0,[0,15]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x8c022d8049901,!1,[[4,6],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]],[0,null,!1,null,0xf241392810d17,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,5743701659751703,!1,[[0,[1,15.1]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x5ba1a8de9f8eb,!1,[[4,58],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]],[0,null,!1,null,5829527402666367,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,9793130893191300,!1,[[0,[1,15.2]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,6479376083476079,!1,[[4,59],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]],[0,null,!1,null,0xf5b920d5c5020,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,0xaa44ec3edbbd,!1,[[0,[1,15.3]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xefe77c01d5c45,!1,[[4,60],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]],[0,null,!1,null,7601568133506352,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,9491478465760368,!1,[[0,[1,15.4]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x750899dba118c,!1,[[4,61],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]]]],[0,null,!1,null,7916215744505431,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,0xce9d390a6f9f7,!1,[[4,33]]]],[],[[0,null,!1,null,7254637566611725,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,9928789753032184,!1,[[0,[1,0.6]]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xb9a77dbd14dd4,!1,[[4,31],[5,[0,0]],[7,[0,0]]]],[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xe6eaef1a8750d,!1,[[4,31],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0x579d852557ec3,!1,[[2,["2",!1]],[3,0],[0,[0,0]],[1,[2,"shoot"]]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,
null,0xb6f3ea67a79a0,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,4914650306461499,!1,[[0,[1,0.2]]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xde2cea8c7d7ad,!1,[[3,1]]]]]]],[0,null,!1,null,8341280173850269,[[2,cr.plugins_.Keyboard.prototype.cnds.OnKey,null,1,!1,!1,!1,9351821083931876,!1,[[9,32]]]],[],[[0,null,!1,null,7736259896409347,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x64b721cdd338,!1,[[0,[1,0.6]]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,
0x8382bca121392,!1,[[4,31],[5,[0,0]],[7,[0,0]]]],[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,7496414349916662,!1,[[4,31],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,6905183933174268,!1,[[2,["2",!1]],[3,0],[0,[0,0]],[1,[2,"shoot"]]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,9860414170917572,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,0x5323afda806e3,!1,[[0,[1,0.2]]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6724681548726536,!1,[[3,
1]]]]]]],[0,null,!1,null,7922251217218087,[[31,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8089766123959434,!1,[[4,9]]]],[[9,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,7276245298580548,!1,[[10,0],[7,[0,0]]]],[31,cr.plugins_.Sprite.prototype.acts.Destroy,null,7816819626058178,!1]]],[0,null,!1,null,0x975f8673b20dd,[[31,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8764514731948012,!1,[[4,10]]]],[[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x418f028f08b75,
!1,[[10,0],[7,[0,0]]]],[31,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xd07f9c3c8bf92,!1]]],[0,null,!1,null,687277608514373,[[31,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8833788754683094,!1,[[4,56]]]],[[56,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,9640357913164552,!1,[[10,0],[7,[0,0]]]],[31,cr.plugins_.Sprite.prototype.acts.Destroy,null,5495015612536236,!1]]],[0,null,!1,null,9320723040780772,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5828098250295025,
!1,[[4,11]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xbbe161ece0a57,!1]]],[0,null,!1,null,9608856166879434,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7195394900844315,!1,[[4,58]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb0da5a8608035,!1]]],[0,null,!1,null,8252275986499533,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,638318389974147,!1,[[4,59]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,8349114399137938,!1]]],[0,null,
!1,null,0x8ff672aff142e,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7094801681777884,!1,[[4,60]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x613a9424c02e0,!1]]],[0,null,!1,null,9649667844619740,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x9b759b7d7fd4f,!1,[[4,61]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xfa6ba4e3cf504,!1]]],[0,null,!1,null,8459996662651537,[[58,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8058833063230544,
!1,[[4,59]]]],[[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,8393391199750337,!1]]],[0,null,!1,null,0xa7dea4f4f8e23,[[58,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9367412254397384,!1,[[4,60]]]],[[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x3b2abca2b23fd,!1]]],[0,null,!1,null,9202770319789048,[[59,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x93d1cb8b83f9e,!1,[[4,60]]]],[[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,5735942515146085,!1]]],[0,
null,!1,null,0xc5ab16a36bd2d,[[60,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,716206360967085,!1,[[4,61]]]],[[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,81092560271802,!1]]],[0,null,!1,null,0x895a4c3241cf3,[[9,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xb7fa22ec4181b,!1,[[4,10]]]],[[10,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x50946e02fd37f,!1]]],[0,null,!1,null,506598745381235,[[56,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5051342865551474,
!1,[[4,10]]]],[[10,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x66047ebcd6105,!1]]],[0,null,!1,null,5464164178107311,[[56,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xd44da36539319,!1,[[4,9]]]],[[9,cr.plugins_.Sprite.prototype.acts.Destroy,null,7489990296908911,!1]]],[0,null,!1,null,6662365927380397,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6581998091481692,!1,[[11,"timer"],[8,5],[7,[0,5]]]]],[],[[0,null,!1,null,8818025533066987,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,0x7ea81564b8cf0,!1,[[0,[0,5]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x85d0b286248dc,!1,[[4,9],[5,[2,"Game"]],[0,[0,1260]],[0,[0,620]]]]]]]],[0,null,!1,null,0x9541eec59102b,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8349240974726493,!1,[[11,"timer"],[8,5],[7,[0,5]]]]],[],[[0,null,!1,null,801356964388833,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,8673113781701162,!1,[[0,[1,7.5]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,
null,0x6a03dd532d3e5,!1,[[4,10],[5,[2,"Game"]],[0,[0,1260]],[0,[0,570]]]]]]]],[0,null,!1,null,0x9c8bf23330d82,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x3e2bd241a226f,!1,[[11,"timer"],[8,5],[7,[0,5]]]]],[],[[0,null,!1,null,0x85d83b161ee09,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,7006414838187309,!1,[[0,[1,9.5]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,6037714502239746,!1,[[4,56],[5,[2,"Game"]],[0,[0,1260]],[0,[0,610]]]]]]]],[0,null,!1,null,
5661691544374529,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8910563379854364,!1,[[4,6]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,5476926550389079,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,9580200881485994,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x4e21d87ced102,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xd7431faca3f24,!1,[[0,
[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,6170677287555548,!1,[[0,[1,0.5]]]],[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,6814395707375458,!1],[-1,cr.system_object.prototype.acts.AddVar,null,7478203967163559,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,6427455153792301,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4639694786112513,!1,[[4,58]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,6647274109642199,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,
null,6317507756000217,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9077719383003E3,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x8038d8742348e,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,8618157432703758,!1,[[0,[1,0.5]]]],[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,6351012537866829,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0x42143f7ef20e3,!1,[[11,"Score"],[7,[0,
75]]]]]],[0,null,!1,null,0x69980f3ea9d0f,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4550750210107429,!1,[[4,59]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x78551a14f53be,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xc2cb5a01dddc8,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9926884826150794,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",
7202199851949486,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,5873862509521445,!1,[[0,[1,0.5]]]],[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,8502559581371651,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0xe07e58d626b59,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0xe68eb281627b6,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5111218811447401,!1,[[4,60]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,6962875578097667,!1,[[4,7],[5,[0,0]],[7,
[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0x59a9a02a6307f,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",4696677986284056,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7923624413733997,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,575221452551258,!1,[[0,[1,0.5]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x9b473509eceec,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,0x9b2016eb2d154,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,9021959232593064,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,927635526453869,!1,[[4,61]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,7764753490106203,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xa6e2a5ac4c533,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x5dc2cc0ecbb6f,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",9543559267491002,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x442b5f68359a7,!1,[[0,[1,0.5]]]],[61,cr.plugins_.Sprite.prototype.acts.Destroy,null,8769448453416566,!1],[-1,cr.system_object.prototype.acts.AddVar,null,5558527290248884,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0x4f77d9ea8fcc6,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xf31357825bf11,!1,[[4,6]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,6224973203937846,!1,[[4,7],[5,
[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,6538796004209146,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x3be6d12d774d1,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8203866538820243,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,6992659986297095,!1,[[0,[1,0.5]]]],[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,8675642811740488,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,0x73d69d2e89fd0,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0x896af8865b258,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6914321268570251,!1,[[4,58]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,4917014622184767,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xe99fa3cb12ded,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",5214329983252958,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",5344405548063124,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,9695976890812136,!1,[[0,[1,0.5]]]],[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,6114300013800215,!1],[-1,cr.system_object.prototype.acts.AddVar,null,5633981519308327,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0xfffa2d89f9efb,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x685e022087898,!1,[[4,59]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,5681554906904375,!1,[[4,7],[5,
[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xcb34f60ccda3d,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",5227853790942567,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x862a9fedc1af7,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x8fdb66e9e6abd,!1,[[0,[1,0.5]]]],[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,8677066966354971,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,0x7351aab4a9f99,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,5181099939452442,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9083519889664172,!1,[[4,60]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,8459679935229565,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,8075351186460684,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6475112654253522,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",6680640328629014,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,8590058848515429,!1,[[0,[1,0.5]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc0d5a4822e2ae,!1],[-1,cr.system_object.prototype.acts.AddVar,null,9225602151008416,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0x701cfbbc2bd7,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7954625780268485,!1,[[4,61]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x6f71ca5d1aa38,!1,[[4,7],[5,
[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xa7b6f188d0f3d,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9780858292297984,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7022723346137837,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,9190830102242196,!1,[[0,[1,0.5]]]],[61,cr.plugins_.Sprite.prototype.acts.Destroy,null,6505046997158796,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,0xb2a50caf6cb8d,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,9570862867511034,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,529971461025537,!1,[[4,6]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xbb54b7876b6a3,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,9064993839090756,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",78768738885385,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",8676864267965406,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xd5bc55145e33b,!1,[[0,[1,0.5]]]],[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,8352833920406926,!1],[-1,cr.system_object.prototype.acts.AddVar,null,7639195998479818,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,8808650085685752,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x7d1b0df6a2c6b,!1,[[4,58]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x90d9bdd35cf2c,!1,[[4,7],[5,
[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xea3cd870c64c6,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6892654566600628,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7801131472124214,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,879782566015968,!1,[[0,[1,0.5]]]],[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x44d715a808c82,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,9393829328589208,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,8312001757780104,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7315957040744317,!1,[[4,59]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,8716798970853868,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,8778422213952903,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6253394616314595,!1,[[0,[0,270]]]],[59,
cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xa460137e6449a,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,945540279031928,!1,[[0,[1,0.5]]]],[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,4933131007842925,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0xf7299c3e234ed,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,8704788884976654,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4973087598733042,!1,[[4,60]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,
null,0x5a29f2d5fddbb,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xac9cbd21854de,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xa0bb42301c233,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9633631452034360,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,5629243468345829,!1,[[0,[1,0.5]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,8977502909152637,
!1],[-1,cr.system_object.prototype.acts.AddVar,null,0x5ab6dfb1dc146,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,8976929360442345,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8475985179880525,!1,[[4,61]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,6573665947522522,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,8980562001179633,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",
4785141660185587,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9783988056833104,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xfb18733e80428,!1,[[0,[1,0.5]]]],[61,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc93703cf734b8,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0x7609a6f3b8930,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,8566496220752349,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4813153884965422,!1,[[4,6]]]],
[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,6384751644576164,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,5075326167603194,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xaed1eeaceed48,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9886458617904580,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,6331025355226722,!1,[[0,[1,0.5]]]],[6,cr.plugins_.Sprite.prototype.acts.Destroy,
null,9883146785039694,!1],[-1,cr.system_object.prototype.acts.AddVar,null,7794518758901639,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0x99e1555da73f8,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x83fee3712c406,!1,[[4,58]]]],[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x830f3bd17b46b,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,5440279101616006,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
"Bullet",0x7804c8df81924,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5303731926789224,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,6506805818226255,!1,[[0,[1,0.5]]]],[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,5853391418637421,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0xa1a265d96d056,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0xbbd60c13a5a23,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xe857db79f687f,!1,
[[4,59]]]],[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,4556007873345555,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,8664042506176593,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",8326449771350363,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xeeb352f6bee2a,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,9113378649424976,!1,[[0,[1,0.5]]]],[59,cr.plugins_.Sprite.prototype.acts.Destroy,
null,5354037720292345,!1],[-1,cr.system_object.prototype.acts.AddVar,null,5169748198786714,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,4662420894092164,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7428216490036605,!1,[[4,60]]]],[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,9864972230959062,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,958482562456359,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
"Bullet",396745352570472,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6477161549123658,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xec84a3d499001,!1,[[0,[1,0.5]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,8573955094425411,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0x464f819a88f68,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,5112053534581668,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8621220468114632,!1,
[[4,61]]]],[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xa86a63c603a87,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,5650834482486036,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6686239670503129,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",690034375710225,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x64224a150dc72,!1,[[0,[1,0.5]]]],[61,cr.plugins_.Sprite.prototype.acts.Destroy,
null,4574602695738877,!1],[-1,cr.system_object.prototype.acts.AddVar,null,5440222109921214,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0x6126a2913241f,[[7,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,0xf2d8997524d9b,!1]],[[7,cr.plugins_.Sprite.prototype.acts.Destroy,null,661866760758582,!1]]],[0,null,!1,null,0xf92a7864279a0,[[13,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,0xf3a51fc1fa37e,!1]],[[13,cr.plugins_.Sprite.prototype.acts.Destroy,null,304770003796954,
!1]]],[0,null,!1,null,319553940814457,[[12,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,6229042513663507,!1]],[[12,cr.plugins_.Sprite.prototype.acts.Destroy,null,4532421424445642,!1]]],[0,null,!1,null,0x91b2b8c3924c1,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,7668955841865131,!1]],[[3,cr.plugins_.Text.prototype.acts.SetText,null,0xf7ec3bb774401,!1,[[7,[10,[2,": "],[23,"Score"]]]]]]],[0,null,!1,null,7410023419253875,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,5867330705810153,!1,[[4,9]]]],[[4,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,0x70c7993734ee,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,625774384695493,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5133926515445652,!1,[[4,10]]]],[[4,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,0x3ead0c98d9005,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,0xe524923dae0a6,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x7b9521d6045c1,!1,[[4,56]]]],[[4,
cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,0x426f9a555d68f,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,0x9dcbf81338738,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8557758492786815,!1,[[4,9]]]],[[62,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,8816613961716849,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,9772084842648114,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5552536280566484,!1,[[4,10]]]],[[62,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
null,7044269257961743,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,0x587a852c4e3f6,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5055880968287575,!1,[[4,56]]]],[[62,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,8311553981904884,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,350805136621527,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x5a0a2d987b283,!1,[[4,11]]]],[[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xf4d5cf5808664,!1],[4,cr.plugins_.Sprite.prototype.acts.Spawn,
null,0x4abda453d6453,!1,[[4,13],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xaae62cdfc3958,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9024034549007518,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8464550933608452,!1,[[0,[0,800]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",777303555255211,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",
641763433005516,!1,[[0,[0,800]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",5630470470609609,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x832df18b23169,!1,[[0,[0,800]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",8914537707729408,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7859570538343209,!1,[[0,[0,800]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xa9b143d725bdf,!1,
[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4532189986837694,!1,[[0,[0,800]]]],[9,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,5198203108329366,!1,[[10,0],[7,[0,0]]]],[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x4dcc079b2cd1f,!1,[[10,0],[7,[0,0]]]],[56,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,8926163157562805,!1,[[10,0],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,9511789645462252,!1,[[11,"Score"],[7,[0,500]]]],[-1,cr.system_object.prototype.acts.Wait,
null,0x608e5d972eb4d,!1,[[0,[1,0.5]]]]]],[0,null,!1,null,946085976806955,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x977c9fde14401,!1,[[4,11]]]],[[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,6917451933486435,!1],[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,4522637814084756,!1,[[4,13],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0x810aa6055cd18,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
"Bullet",0xd33cd78ba41b7,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7135518653714256,!1,[[0,[0,800]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x4ce1fc157181a,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x80f24d1306b61,!1,[[0,[0,800]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",8985027755810261,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6452634638609162,!1,
[[0,[0,800]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",284440664479603,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9316796159187404,!1,[[0,[0,800]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6167154237036828,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5444115396645692,!1,[[0,[0,800]]]],[9,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,8184123667100377,!1,[[10,0],[7,[0,0]]]],[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
null,9387061871328344,!1,[[10,0],[7,[0,0]]]],[56,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x9188279a64e94,!1,[[10,0],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,8793808174567523,!1,[[11,"Score"],[7,[0,500]]]],[-1,cr.system_object.prototype.acts.Wait,null,7521031192958238,!1,[[0,[1,0.5]]]]]],[0,null,!1,null,9985370916137084,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5522380382816235,!1,[[4,11]]]],[[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,
9793143743051586,!1],[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,7983457530830901,!1,[[4,13],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,9807496301499394,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",8452297986193653,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5022754699689398,!1,[[0,[0,800]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6119495900744221,
!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6845403700864471,!1,[[0,[0,800]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x9eb967090e19a,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xe02e6311eaeb4,!1,[[0,[0,800]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x4bc5d47fe21e1,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6770135446117002,!1,[[0,[0,800]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
"Bullet",5297238107992854,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x96f6475c4bb24,!1,[[0,[0,800]]]],[9,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x8357470466b4c,!1,[[10,0],[7,[0,0]]]],[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xf2ffdb3ac077f,!1,[[10,0],[7,[0,0]]]],[56,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xafb1f6c60b391,!1,[[10,0],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,0x431e378895f73,!1,[[11,"Score"],
[7,[0,500]]]],[-1,cr.system_object.prototype.acts.Wait,null,812156458999376,!1,[[0,[1,0.5]]]]]],[0,null,!1,null,9462964479110200,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x93422fafd71e9,!1,[[4,11]]]],[[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xaa049a8a1ff91,!1],[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,6893351357089643,!1,[[4,13],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,8281939672505952,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],
[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xb83e2285a7b41,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x7e3c763c0c4a3,!1,[[0,[0,800]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",8278932029588926,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xe169a1fd31b59,!1,[[0,[0,800]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9327981801249616,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",5012778386309603,!1,[[0,[0,800]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6697526329538246,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",426408895569842,!1,[[0,[0,800]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6548740970847681,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xe7c9aef2b29ca,!1,[[0,[0,800]]]],[9,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x94364d01bec95,!1,
[[10,0],[7,[0,0]]]],[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,710963803350812,!1,[[10,0],[7,[0,0]]]],[56,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xe94166dddb7f4,!1,[[10,0],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,0xe0b0a3d01a0c2,!1,[[11,"Score"],[7,[0,500]]]],[-1,cr.system_object.prototype.acts.Wait,null,833510820948469,!1,[[0,[1,0.5]]]]]],[0,null,!1,null,9885227059771708,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6733734984985329,
!1,[[4,14]]]],[[14,cr.plugins_.Sprite.prototype.acts.Destroy,null,501644514676445,!1],[30,cr.plugins_.Audio.prototype.acts.Play,null,0x96d5400427abf,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,6596228876623965,!1,[[4,15],[5,[0,0]],[7,[0,0]]]],[15,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0xf4fb3f2cf474,!1,[[3,1]]],[15,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x5af9bbaee0c58,!1,[[3,1]]],[4,cr.plugins_.Sprite.prototype.acts.SetVisible,
null,8353012739769665,!1,[[3,0]]],[4,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,8224780213992645,!1,[[3,0]]]]],[0,null,!1,null,4807229732782624,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xaf4f8a8237ec3,!1,[[4,14]]]],[[14,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xe36ad7d3a9245,!1],[30,cr.plugins_.Audio.prototype.acts.Play,null,0x3c44db34b1032,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,8607954445196214,!1,
[[4,63],[5,[0,0]],[7,[0,0]]]],[63,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,6131764340847985,!1,[[3,1]]],[63,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6149048007399366,!1,[[3,1]]],[62,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x559524b41402a,!1,[[3,0]]],[62,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0x5241ebe33bfed,!1,[[3,0]]]]],[0,null,!1,null,4565295129934106,[[15,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,5375313258502752,!1]],[[55,cr.plugins_.Sprite.prototype.acts.StopAnim,
null,8792994914260089,!1],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7715003522503695,!1,[[3,0]]],[4,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6417785229289634,!1,[[3,0]]],[4,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0x51dbd1f0b48d7,!1,[[3,0]]],[4,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x7b2150704a0fa,!1],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xc9c4433a5fb18,!1,[[3,0]]],[36,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7668469615523176,!1,
[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0x7238a104cfea6,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,4856838763028404,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,0x86609aec4e693,!1,[[0,[0,10]]]],[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,8208545452598724,!1,[[4,4],[5,[0,0]],[7,[0,0]]]],[15,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xe2f8210bd4670,!1],[15,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,5502442351030168,!1,
[[3,0]]],[15,cr.plugins_.Sprite.prototype.acts.SetVisible,null,487619303432542,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,8445002557625564,!1,[[3,1]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6958897186112919,!1,[[3,1]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x702743abf9c42,!1,[[3,1]]],[36,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8345635736806752,!1,[[3,1]]]]],[0,null,!1,null,0xdc6f6471401c6,[[63,cr.plugins_.Sprite.prototype.cnds.IsVisible,
null,0,!1,!1,!1,0xe854a8c6d24f6,!1]],[[55,cr.plugins_.Sprite.prototype.acts.StopAnim,null,5293009532013873,!1],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,null,4849812527106143,!1,[[3,0]]],[62,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6081885728979904,!1,[[3,0]]],[62,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,7943230347007924,!1,[[3,0]]],[62,cr.plugins_.Sprite.prototype.acts.Destroy,null,6639231915808126,!1],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x5d5eba421aea5,
!1,[[3,0]]],[36,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8614188001701503,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0xb764936ebc727,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x6548d96f7f3ca,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,0x4c55ea5e304a2,!1,[[0,[0,10]]]],[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x81f28048f11f5,!1,[[4,62],[5,[0,0]],[7,[0,0]]]],[63,cr.plugins_.Sprite.prototype.acts.Destroy,null,8722347807157423,
!1],[63,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0x976f5c4e29f06,!1,[[3,0]]],[63,cr.plugins_.Sprite.prototype.acts.SetVisible,null,4710339553288442,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0x8ef63e30acdd9,!1,[[3,1]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,865699135985173,!1,[[3,1]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,364728014037569,!1,[[3,1]]],[36,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xf47db85efae0b,!1,[[3,1]]]]],
[0,null,!1,null,0x6b19fde8c7f21,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xdafe781ff828d,!1,[[4,9]]]],[[9,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,7164570277381546,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,995459259890152,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xda93932ca4215,!1,[[4,10]]]],[[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xe8b749c9f8b22,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,9179314042608800,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,7313035064300342,!1,[[4,56]]]],[[56,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,6757295465383161,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,5935905556286242,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,955354567073669,!1,[[4,9]]]],[[9,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xdcf80b817923,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,9866198285363E3,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6800700961696809,!1,[[4,10]]]],
[[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x479672a7b1fff,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,8985390385428267,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x6a594d315bd18,!1,[[4,56]]]],[[56,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,7969783855939326,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,7935020556242968,[[9,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,286555858625811,!1,[[10,0],[8,0],[7,[0,0]]]]],[[9,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0xbb6b656c426f9,!1],[30,cr.plugins_.Audio.prototype.acts.Play,null,8821201451758873,!1,[[2,["1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[9,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x778022ecafeeb,!1,[[4,27],[5,[0,0]],[7,[0,0]]]]]],[0,null,!1,null,0xac1e50f372bf6,[[10,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8169555931715788,!1,[[10,0],[8,0],[7,[0,0]]]]],[[10,cr.plugins_.Sprite.prototype.acts.Destroy,null,8061294491329272,!1],[30,cr.plugins_.Audio.prototype.acts.Play,
null,0xc7403f82da6a6,!1,[[2,["1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[10,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xab05805801429,!1,[[4,87],[5,[0,0]],[7,[0,0]]]]]],[0,null,!1,null,0xa2acbd5f5796b,[[56,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,9900693558896564,!1,[[10,0],[8,0],[7,[0,0]]]]],[[56,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x9e9e82ff844ed,!1],[30,cr.plugins_.Audio.prototype.acts.Play,null,0x7b94aea6ee281,!1,[[2,["1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],
[56,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x7e98d3c71e5a7,!1,[[4,88],[5,[0,0]],[7,[0,0]]]]]],[0,null,!1,null,4863162736285129,[[4,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8935037561885328,!1,[[10,0],[8,3],[7,[0,0]]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,339082565182073,!1,[[4,26],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,9316423431869894,!1,[[2,["1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[4,cr.plugins_.Sprite.prototype.acts.Destroy,
null,8994012594047523,!1],[-1,cr.system_object.prototype.acts.Wait,null,643664229706998,!1,[[0,[0,2]]]],[30,cr.plugins_.Audio.prototype.acts.Stop,null,967429469536548,!1,[[1,[2,"main"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5026618688020129,!1,[[11,"gamespeed"],[7,[0,0]]]],[17,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,0x52005dd63f6b5,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,0xb158f26d10e9d,!1,[[6,"menu"]]]]],[0,null,!1,null,5544229859950018,[[62,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
null,0,!1,!1,!1,500760922737905,!1,[[10,0],[8,3],[7,[0,0]]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,9539732525706896,!1,[[4,65],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,4834935971978812,!1,[[2,["1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[62,cr.plugins_.Sprite.prototype.acts.Destroy,null,6256764081169573,!1],[-1,cr.system_object.prototype.acts.Wait,null,6814634903431,!1,[[0,[0,2]]]],[30,cr.plugins_.Audio.prototype.acts.Stop,null,0x9c30989b02c66,!1,[[1,[2,"main"]]]],
[-1,cr.system_object.prototype.acts.SetVar,null,0xaeb0a08aa1410,!1,[[11,"gamespeed"],[7,[0,0]]]],[17,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,9681238003156548,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,0xe23591533050e,!1,[[6,"menu"]]]]],[0,null,!1,null,9405169674315852,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x6a2880976a4e0,!1,[[11,"Score"],[8,5],[7,[0,500]]]]],[],[[0,null,!1,null,6068648317538868,[[-1,cr.system_object.prototype.cnds.TriggerOnce,null,
0,!1,!1,!1,6980171501933811,!1]],[[-1,cr.system_object.prototype.acts.AddVar,null,0x7a02b4276e2f3,!1,[[11,"gamespeed"],[7,[0,1]]]]]]]],[0,null,!1,null,5278091273270498,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7468552058805687,!1,[[11,"gamespeed"],[8,0],[7,[0,1]]]]],[],[[0,null,!1,null,0x67a69059e47fe,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x8823e70cf7f3e,!1,[[0,[1,0.1]]]]],[[0,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8917193092371253,!1,[[0,[4,
[22,0,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[54,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x607947cce7c56,!1,[[0,[4,[22,54,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[39,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x83674f02cd71f,!1,[[0,[4,[22,39,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4875487989755736,!1,[[0,[4,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6811854001263722,!1,[[0,[4,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xd519446f937d2,!1,[[0,[4,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",799655306319892,!1,[[0,[4,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,
cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x66ebb8424b7c,!1,[[0,[4,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6111988446377378,!1,[[0,[4,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x874758f1ce8e7,!1,[[0,[4,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[9,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",5793773190412131,!1,[[0,[4,[22,9,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x9c58f1a16fda7,!1,[[0,[4,[22,10,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[56,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5950811143800516,!1,[[0,[4,[22,56,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,7434126388411246,!1,
[[1,[2,"main"]],[0,[0,-10]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x3cfb00e23b565,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xdc852bc23c75e,!1,[[11,"gamespeed"],[7,[0,2]]]]]]]],[0,null,!1,null,9290082107245442,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9588649410650448,!1,[[11,"gamespeed"],[8,0],[7,[0,2]]]]],[[0,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8506387003953334,!1,[[0,[0,400]]]],[54,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",4951470845938747,!1,[[0,[0,200]]]],[39,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8504691374587393,!1,[[0,[0,550]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7732418981769793,!1,[[0,[0,400]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xc9db78267c6eb,!1,[[0,[0,400]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7228695745922786,!1,[[0,[0,400]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6111806027432223,!1,[[0,[0,400]]]],
[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xef45dae858844,!1,[[0,[0,400]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",859341164215473,!1,[[0,[0,400]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9093157329766762,!1,[[0,[0,400]]]],[9,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6273689420249497,!1,[[0,[0,600]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x90b304af5842,!1,[[0,[0,600]]]],[56,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",4635627315954189,!1,[[0,[0,600]]]],[-1,cr.system_object.prototype.acts.Wait,null,577437549660445,!1,[[0,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8541603770331369,!1,[[11,"gamespeed"],[7,[0,3]]]]]],[0,null,!1,null,7327860504022233,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x5c1a0d63f70d5,!1,[[11,"gamespeed"],[8,0],[7,[0,3]]]]],[],[[0,null,!1,null,5886796202701176,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,1684830234492,!1,[[0,[1,0.1]]]]],
[[0,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x506b111b84321,!1,[[0,[4,[22,0,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[54,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",924080259495924,!1,[[0,[4,[22,54,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[39,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x6ad30c19ee572,!1,[[0,[4,[22,39,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0xf7c677957fc67,!1,[[0,[4,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9244288736426018,!1,[[0,[4,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6227773098319354,!1,[[0,[4,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7622159254843085,
!1,[[0,[4,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xa0025c9e2d765,!1,[[0,[4,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8543484816383411,!1,[[0,[4,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8950040037862349,!1,[[0,[4,[22,14,"Bullet",
cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[9,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xead2972fbbe9a,!1,[[0,[4,[22,9,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5257747112753041,!1,[[0,[4,[22,10,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[56,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4769925116977861,!1,[[0,[4,[22,56,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,6022705610809376,!1,[[1,[2,"main"]],[0,[0,-5]]]],[-1,cr.system_object.prototype.acts.Wait,null,8317498392428186,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xafb1f25cbb221,!1,[[11,"gamespeed"],[7,[0,4]]]]]]]],[0,null,!1,null,0xb5d38de866dda,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xe346a0c480abc,!1,[[11,"gamespeed"],[8,0],[7,[0,4]]]]],[[0,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",9430614705797128,!1,[[0,[0,500]]]],[54,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9891680767821786,!1,[[0,[0,300]]]],[39,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xa5fcaabca3621,!1,[[0,[0,650]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xf4b7975a07009,!1,[[0,[0,500]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7779977511011658,!1,[[0,[0,500]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x54a7bab395311,!1,[[0,[0,500]]]],[60,
cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x97b92ae56ad57,!1,[[0,[0,500]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x4d6897f60695f,!1,[[0,[0,500]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5469066680296513,!1,[[0,[0,500]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7474100995166997,!1,[[0,[0,500]]]],[9,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8821991708229644,!1,[[0,[0,700]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0x75afd26aa41f3,!1,[[0,[0,700]]]],[56,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x85de522e1ed01,!1,[[0,[0,700]]]],[-1,cr.system_object.prototype.acts.Wait,null,5790161817036201,!1,[[0,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xbecb3eca68e43,!1,[[11,"gamespeed"],[7,[0,5]]]]]],[0,null,!1,null,0xdd81e3356c425,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x980c466f4d677,!1,[[11,"gamespeed"],[8,0],[7,[0,5]]]]],[],[[0,null,!1,null,8039150000543199,
[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,4735928797061245,!1,[[0,[1,0.1]]]]],[[0,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xc2492812dc459,!1,[[0,[5,[22,0,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[54,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8364071787142658,!1,[[0,[5,[22,54,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[39,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6586520833735966,!1,[[0,[5,[22,
39,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xb70321ac72ac7,!1,[[0,[5,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xc458f7bc1804a,!1,[[0,[5,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x9539496c613d,!1,[[0,[5,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",943708922360442,!1,[[0,[5,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xc7979a8c02b4a,!1,[[0,[5,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xac7def3a1f22a,!1,[[0,[5,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",5651472319324298,!1,[[0,[5,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[9,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7884919117133857,!1,[[0,[5,[22,9,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",76465850776135,!1,[[0,[5,[22,10,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[56,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xea00236fd25f1,
!1,[[0,[5,[22,56,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,7963521930826293,!1,[[1,[2,"main"]],[0,[0,-10]]]],[-1,cr.system_object.prototype.acts.Wait,null,6912795747701073,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7250334231816929,!1,[[11,"gamespeed"],[7,[0,2]]]]]]]],[0,null,!1,null,8995502745537998,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9958730945661076,!1,[[11,"Score"],
[8,5],[7,[0,5E3]]]]],[],[[0,null,!1,null,0x38dd4e47ad22a,[[62,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x432ab3edb85d1,!1]],[[62,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",4876216867727788,!1,[[3,1]]],[62,cr.plugins_.Sprite.prototype.acts.AddInstanceVar,null,7493037258326241,!1,[[10,0],[7,[0,100]]]],[9,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc1b2890e3297a,!1],[10,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xe5a99f7cbf1ef,!1],[56,cr.plugins_.Sprite.prototype.acts.Destroy,
null,9454662951400740,!1],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,8676878773794522,!1,[[3,0]]],[55,cr.plugins_.Sprite.prototype.acts.Destroy,null,5331781595443127,!1],[-1,cr.system_object.prototype.acts.Wait,null,0xae02541d979b2,!1,[[0,[0,2]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,741437096997871,!1,[[2,["click4",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[66,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0x49fe3146b28c7,!1,[[3,0]]],[67,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,
"LiteTween",0x3916cf195a5c7,!1,[[3,0]]],[68,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0x6dc1149f943ac,!1,[[3,0]]],[69,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0xf4e94917bfc98,!1,[[3,0]]],[70,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",8795292973632626,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,370274259477512,!1,[[0,[1,0.7]]]],[66,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",6037083338896942,!1,
[[3,1]]],[67,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0xfcf315b466e65,!1,[[3,1]]],[68,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0x6524b04d04453,!1,[[3,1]]],[69,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",4743543066053574,!1,[[3,1]]],[70,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",4892915445271348,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x5155d64cf7e63,!1,[[11,"gamepause"],[7,[0,1]]]]]]]],[0,
null,!1,null,0xb3ebe025ea7a2,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xdc3417ab59aff,!1,[[11,"Score"],[8,5],[7,[0,5E3]]]]],[],[[0,null,!1,null,671101771668272,[[4,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x9b87935cb2556,!1]],[[4,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",8490144378689131,!1,[[3,1]]],[4,cr.plugins_.Sprite.prototype.acts.AddInstanceVar,null,6877943472599291,!1,[[10,0],[7,[0,100]]]],[9,cr.plugins_.Sprite.prototype.acts.Destroy,
null,297493875900952,!1],[10,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x7d17d1c02ea9,!1],[56,cr.plugins_.Sprite.prototype.acts.Destroy,null,8051931556747923,!1],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0x3f2d18e11a471,!1,[[3,0]]],[55,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xa4817780b0f6c,!1],[-1,cr.system_object.prototype.acts.Wait,null,6650657798229955,!1,[[0,[0,2]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xf858b7c3caa48,!1,[[2,["click4",!1]],[3,0],[0,[0,0]],
[1,[2,""]]]],[66,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0x58a36e8934e8c,!1,[[3,0]]],[67,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0xb15e0912fad83,!1,[[3,0]]],[68,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0xfbdc9462817bb,!1,[[3,0]]],[69,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",9542407124050068,!1,[[3,0]]],[70,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",7011507956609691,!1,[[3,0]]],[-1,
cr.system_object.prototype.acts.Wait,null,9726373150099680,!1,[[0,[1,0.7]]]],[66,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0xa16b7011e7fa9,!1,[[3,1]]],[67,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",8651021069331656,!1,[[3,1]]],[68,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",6495335130265554,!1,[[3,1]]],[69,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0x6a590a2ef2b1,!1,[[3,1]]],[70,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,
"LiteTween",5446301510738515,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetVar,null,6999181893940219,!1,[[11,"gamepause"],[7,[0,1]]]]]]]],[0,null,!1,null,6102563257859343,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7379083134695155,!1,[[11,"gamepause"],[8,0],[7,[0,1]]]]],[[30,cr.plugins_.Audio.prototype.acts.Stop,null,5053482228109375,!1,[[1,[2,"main"]]]],[0,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",8842178590893487,!1,[[3,0]]],[54,cr.behaviors.Bullet.prototype.acts.SetEnabled,
"Bullet",0xd21037f998079,!1,[[3,0]]],[39,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",7063430973792085,!1,[[3,0]]],[6,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0x87c53a7a83a1a,!1,[[3,0]]],[58,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",5022924518015989,!1,[[3,0]]],[59,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",415236698838796,!1,[[3,0]]],[60,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",942268588632402,!1,[[3,0]]],[61,cr.behaviors.Bullet.prototype.acts.SetEnabled,
"Bullet",9021847718789520,!1,[[3,0]]],[14,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",7845027912358156,!1,[[3,0]]],[11,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0x8099ef5e6ec80,!1,[[3,0]]],[56,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0x67ceabe32b3d9,!1,[[3,0]]],[10,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",7466969120446856,!1,[[3,0]]],[9,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0xf93c19f904d59,!1,[[3,0]]],[9,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0xdf8a04fb5e886,!1],[10,cr.plugins_.Sprite.prototype.acts.Destroy,null,5109423963419989,!1],[56,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x87d8872f9d6af,!1],[14,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x89ce244ffac51,!1],[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,7610269749672364,!1]]],[0,null,!1,null,857914978671125,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6934801786939773,!1,[[4,67]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,832724467630816,
!1,[[11,"levels"],[7,[0,2]]]],[17,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,328581359136539,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x5c1801b5bff36,!1,[[6,"Level2"]]]]],[0,null,!1,null,5847719493244111,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x5e68b60845f37,!1,[[4,68]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,null,9955101052852512,!1]]],[0,null,!1,null,4815424621002597,[[69,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,
!1,8015461501016826,!1]],[],[[1,"url3",1,"https://www.twitter.com/intent/tweet?text= Completed Another Level of Shoot Angry Zombies. Try this Awesome Game bit.ly/1KyXW9c",!1,!1,6717220294713229,!1],[0,null,!1,null,9393925004261016,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x7686ce62e7ea8,!1,[[4,69]]]],[[25,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,0xae42b07c4df83,!1,[[1,[23,"url3"]],[1,[2,"twitter"]]]]]]]],[0,null,!1,null,5849125814941699,[[70,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!1,!1,0x85b2cd700c945,!1]],[],[[1,"url4",1,"https://www.facebook.com/sharer/sharer.php?u=http://online-free-stuff.com/saz/share.php",!1,!1,422432062509531,!1],[0,null,!1,null,0xd28211efc8a20,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5625398034083522,!1,[[4,70]]]],[[25,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,0x524ae73537acf,!1,[[1,[23,"url4"]],[1,[2,"facebook"]]]]]]]],[0,null,!1,null,9194048587571772,[[27,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,
null,1,!1,!1,!1,948040509113297,!1]],[[27,cr.plugins_.Sprite.prototype.acts.Destroy,null,5179904552933767,!1]]],[0,null,!1,null,504044493692234,[[87,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,0x58ed86195de3e,!1]],[[87,cr.plugins_.Sprite.prototype.acts.Destroy,null,8759133954740141,!1]]],[0,null,!1,null,380067944587117,[[88,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,6484841378953024,!1]],[[88,cr.plugins_.Sprite.prototype.acts.Destroy,null,9679587786460108,
!1]]],[0,null,!1,null,4764083165555718,[[91,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,6228513097009535,!1]],[[91,cr.plugins_.Sprite.prototype.acts.Destroy,null,5253048592533525,!1]]]]],["splash",[[0,null,!1,null,950390189551325,[[-1,cr.system_object.prototype.cnds.CompareTime,null,0,!1,!1,!1,6315110275805334,!1,[[8,0],[0,[0,2]]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,9925769344785858,!1,[[6,"character-screen"]]]]],[0,null,!1,null,0x3bf4355bb5a5d,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,0xba7201c135e6c,!1]],[[17,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,0xba1217979b860,!1,[[3,1]]]]],[0,null,!1,null,5100036440199896,[[17,cr.plugins_.CJSAds.prototype.cnds.OnBannerShown,null,1,!1,!1,!1,0x55293f72156d3,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0x9da9e3d739967,!1,[[6,"character-screen"]]]]]]],["character-screen",[[0,null,!1,null,0x9cda2a0ae525a,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,4961106033692781,!1]],[[-1,cr.system_object.prototype.acts.SetVar,
null,6595248691271175,!1,[[11,"playerchoose"],[7,[0,1]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,4535564284564301,!1,[[2,["click4",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[42,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",6409361143887835,!1,[[3,0]]],[43,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",4597160046006903,!1,[[3,0]]],[41,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0xc8ca72d03c520,!1,[[3,0]]],[17,cr.plugins_.CJSAds.prototype.acts.ShowBanner,
null,9417604830410244,!1,[[3,1]]]]],[0,null,!1,null,576003377929093,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x76c53bcb71c37,!1,[[4,44]]]],[[30,cr.plugins_.Audio.prototype.acts.Play,null,8605923215558478,!1,[[2,["touch1",!1]],[3,0],[0,[0,0]],[1,[2,"shoot"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x899b82aa1308c,!1,[[11,"playerchoose"],[7,[0,1]]]],[44,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xe242ff809b9ed,!1,[[0,[0,530]],[0,[0,797]]]],[84,cr.plugins_.Sprite.prototype.acts.SetPos,
null,0xad66dbb8560ac,!1,[[0,[0,480]],[0,[0,504]]]],[-1,cr.system_object.prototype.acts.Wait,null,9153696890476512,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,9537871378602094,!1,[[6,"menu"]]]]],[0,null,!1,null,7133070650695197,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xd91e3188a8b09,!1,[[4,45]]]],[[30,cr.plugins_.Audio.prototype.acts.Play,null,0x7b938be56b2d7,!1,[[2,["touch1",!1]],[3,0],[0,[0,0]],[1,[2,"shoot"]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,6202998242939826,!1,[[11,"playerchoose"],[7,[0,2]]]],[45,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xac7ea04e7547e,!1,[[0,[0,827]],[0,[0,807]]]],[85,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xde08e134f8680,!1,[[0,[0,790]],[0,[0,504]]]],[-1,cr.system_object.prototype.acts.Wait,null,8832033950003427,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,8614101722545429,!1,[[6,"menu"]]]]]]],["menu",[[0,null,!1,null,0x77a6f36126e0e,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,0xcb55afa0cd563,!1]],[],[[0,null,!1,null,4720602903962205,[[82,cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,null,0,!1,!0,!1,6004620699312158,!1,[[1,[2,"saz"]]]]],[[82,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0xcc0d524d4203c,!1,[[1,[2,"saz"]],[7,[0,0]]]]]],[0,null,!1,null,0xcc0b528d56016,[[82,cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,null,0,!1,!1,!1,7944578489154498,!1,[[1,[2,"saz"]]]]],[[82,cr.plugins_.WebStorage.prototype.acts.JSONLoad,null,
0x62a9ec86caa2,!1,[[1,[2,"saz"]],[3,0]]],[-1,cr.system_object.prototype.acts.SetVar,null,9835164256876448,!1,[[11,"levels"],[7,[20,82,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"saz"]]]]]]]]]],[0,null,!1,null,8333398211932221,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,8054828344136677,!1]],[[30,cr.plugins_.Audio.prototype.acts.Play,null,4560727093881561,!1,[[2,["click4",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[46,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,
"LiteTween",9644366058131756,!1,[[3,0]]],[47,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",7552270422877491,!1,[[3,0]]],[48,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",9423563079392878,!1,[[3,0]]],[49,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",8273653750837267,!1,[[3,0]]],[17,cr.plugins_.CJSAds.prototype.acts.RefreshFullscreen,null,5566932145801261,!1],[17,cr.plugins_.CJSAds.prototype.acts.RefreshBanner,null,4622268855929685,!1],[17,cr.plugins_.CJSAds.prototype.acts.ShowBanner,
null,7981477099251762,!1,[[3,1]]]]],[0,null,!1,null,0x88332e4fa4df0,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xdeeb44418487e,!1,[[4,86]]]],[[30,cr.plugins_.Audio.prototype.acts.Play,null,379156143245431,!1,[[2,["touch1",!1]],[3,0],[0,[0,0]],[1,[2,"shoot"]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,679214073088962,!1,[[6,"character-screen"]]]]],[0,null,!1,null,4720480021035843,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xb60a89c98f6b4,!1,
[[4,47]]]],[[47,cr.plugins_.Sprite.prototype.acts.SetOpacity,null,0xc87b984ee6544,!1,[[0,[0,50]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0x84f2e955b49b5,!1,[[2,["touch1",!1]],[3,0],[0,[0,0]],[1,[2,"shoot"]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,7413592908183358,!1,[[6,"Level1"]]],[-1,cr.system_object.prototype.acts.Wait,null,0x956581d72399c,!1,[[0,[1,1]]]],[47,cr.plugins_.Sprite.prototype.acts.SetOpacity,null,9257924719443268,!1,[[0,[0,100]]]]]],[0,null,!1,null,0x43439827a9b45,
[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6353683124108049,!1,[[4,51]]]],[[51,cr.plugins_.Sprite.prototype.acts.SetOpacity,null,4607168382765506,!1,[[0,[0,50]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xa380cb81e5ac,!1,[[2,["touch1",!1]],[3,0],[0,[0,0]],[1,[2,"shoot"]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,9725830343984118,!1,[[6,"Level2"]]],[-1,cr.system_object.prototype.acts.Wait,null,726847666566623,!1,[[0,[1,1]]]],[51,cr.plugins_.Sprite.prototype.acts.SetOpacity,
null,9690053451896696,!1,[[0,[0,100]]]]]],[0,null,!1,null,6938161562369761,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9240743606098512,!1,[[4,52]]]],[[52,cr.plugins_.Sprite.prototype.acts.SetOpacity,null,7622147401282199,!1,[[0,[0,50]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,9793622185463852,!1,[[2,["touch1",!1]],[3,0],[0,[0,0]],[1,[2,"shoot"]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x7960f35f5381,!1,[[6,"Level3"]]],[-1,cr.system_object.prototype.acts.Wait,
null,8480496824604513,!1,[[0,[1,1]]]],[52,cr.plugins_.Sprite.prototype.acts.SetOpacity,null,9899339423195252,!1,[[0,[0,100]]]]]],[0,null,!1,null,0xb1045f32330fc,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9371933421330558,!1,[[11,"levels"],[8,5],[7,[0,2]]]]],[[51,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x475505cde5f85,!1,[[4,48],[7,[0,0]]]],[48,cr.plugins_.Sprite.prototype.acts.SetVisible,null,9277930583015784,!1,[[3,0]]]]],[0,null,!1,null,5880799209621007,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,0xa1a6233cd5a72,!1,[[11,"levels"],[8,5],[7,[0,3]]]]],[[52,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5272966673830808,!1,[[4,49],[7,[0,0]]]],[49,cr.plugins_.Sprite.prototype.acts.SetVisible,null,594819247066935,!1,[[3,0]]]]],[0,null,!1,null,6563502885692927,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x4aca85639e63e,!1,[[11,"levels"],[8,5],[7,[0,4]]]]],[[53,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,6317869589622294,!1,[[4,50],[7,[0,0]]]],
[50,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8931654115751409,!1,[[3,0]]]]]]],["Level2",[[0,null,!1,null,0x3aff66b900bfb,[[24,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,0x4e7c52da33055,!1,[[1,[2,"Spause"]]]]],[[23,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8586476662898242,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,8261230866177808,!1,[[0,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.SetPaused,null,0xe620ae78bbdb2,!1,[[1,[2,"main"]],[3,0]]]]],
[0,null,!1,null,6851155343752982,[[24,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,5643997680343012,!1,[[1,[2,"Splay"]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0xb6e360ab043e9,!1,[[0,[1,1]]]],[23,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x8a9d15b73bbfa,!1,[[3,0]]],[30,cr.plugins_.Audio.prototype.acts.SetPaused,null,5799058324979463,!1,[[1,[2,"main"]],[3,1]]]]],[0,null,!1,null,8358003793440836,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,
!1,0xe62c84ff6820a,!1]],[]],[0,null,!1,null,6941592920222531,[[25,cr.plugins_.Browser.prototype.cnds.OnPageHidden,null,1,!1,!1,!1,9603905468151908,!1]],[[24,cr.plugins_.Function.prototype.acts.CallFunction,null,7981253016687941,!1,[[1,[2,"Spause"]],[13]]]]],[0,null,!1,null,9930296325824102,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,8301830479987645,!1,[[4,23]]]],[[24,cr.plugins_.Function.prototype.acts.CallFunction,null,0xb3d36f9841ab7,!1,[[1,[2,"Splay"]],[13]]]]],[0,null,
!1,null,0xfd6d95cac60f,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5438514814000878,!1,[[4,21]]]],[[30,cr.plugins_.Audio.prototype.acts.Stop,null,9871388315735248,!1,[[1,[2,"main"]]]],[17,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,9137086924940888,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,8232413815700552,!1,[[6,"menu"]]]]],[0,null,!1,null,7838400084161123,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9961932086487628,!1,[[4,20]]]],
[[-1,cr.system_object.prototype.acts.SetTimescale,null,4786868447880377,!1,[[0,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.SetPaused,null,0x892df3bc1ec81,!1,[[1,[2,"main"]],[3,0]]],[22,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,8791109863997649,!1,[[3,1]]],[22,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xe9d93dc2dbf91,!1,[[3,1]]]]],[0,null,!1,null,7445966586570266,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5874071267979253,!1,[[4,22]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,
null,0xd41e09aec9f7e,!1,[[0,[0,1]]]],[30,cr.plugins_.Audio.prototype.acts.SetPaused,null,8451051370415675,!1,[[1,[2,"main"]],[3,1]]],[22,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,9711650624395420,!1,[[3,0]]],[22,cr.plugins_.Sprite.prototype.acts.SetVisible,null,756568517354267,!1,[[3,0]]]]],[0,null,!1,null,7579608599023624,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xc97bf0daa7f55,!1]],[[17,cr.plugins_.CJSAds.prototype.acts.PreloadFullscreen,null,5236546360170668,
!1],[71,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6264622788630195,!1,[[0,[0,180]]]],[73,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9954025346192956,!1,[[0,[0,180]]]],[72,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x52546828a8918,!1,[[0,[0,180]]]],[82,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0xe4b0c32b0316,!1,[[1,[2,"saz"]],[7,[23,"levels"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8646991762213885,!1,[[11,"Score"],[7,[0,
0]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xe3cdf802ae0b0,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x8d498efeb7068,!1,[[11,"gamepause"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x622b14b97b298,!1,[[11,"gamespeed"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,526472852835356,!1,[[0,[1,0.7]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,9438232158458560,!1,[[0,[0,0]]]]]],[0,null,!1,null,7630529835281908,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,7445729354975492,!1,[[4,90]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,989491355349555,!1,[[0,[1,1]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,6411970974250652,!1,[[2,["game-shoot",!1]],[3,1],[0,[0,-20]],[1,[2,"main"]]]],[90,cr.behaviors.lunarray_LiteTween.prototype.acts.Reverse,"LiteTween",8090763948004652,!1,[[3,0]]]]],[0,null,!1,null,0xe5b5c4e04fe5a,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6959830127064934,!1,[[11,"playerchoose"],[8,
0],[7,[0,1]]]]],[[62,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc206e1bbdfbbf,!1]]],[0,null,!1,null,0xc3484defea423,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xa04a385dc6d41,!1,[[11,"playerchoose"],[8,0],[7,[0,2]]]]],[[4,cr.plugins_.Sprite.prototype.acts.Destroy,null,4750725481083173,!1]]],[0,null,!1,null,541474978549202,[[72,cr.plugins_.TiledBg.prototype.cnds.CompareX,null,0,!1,!1,!1,0x4f3362d76aa62,!1,[[8,3],[0,[7,[3,[20,72,cr.plugins_.TiledBg.prototype.exps.Width,!1,
null]],[0,2]]]]]],[[72,cr.plugins_.TiledBg.prototype.acts.SetX,null,5359477882960687,!1,[[0,[4,[20,72,cr.plugins_.TiledBg.prototype.exps.X,!1,null],[7,[20,72,cr.plugins_.TiledBg.prototype.exps.Width,!1,null],[0,2]]]]]]]],[0,null,!1,null,0xa56487aaff361,[[71,cr.plugins_.TiledBg.prototype.cnds.CompareX,null,0,!1,!1,!1,0x50e6354bfe498,!1,[[8,3],[0,[7,[3,[20,71,cr.plugins_.TiledBg.prototype.exps.Width,!1,null]],[0,2]]]]]],[[71,cr.plugins_.TiledBg.prototype.acts.SetX,null,0xeab2a3036c8be,!1,[[0,[4,[20,
71,cr.plugins_.TiledBg.prototype.exps.X,!1,null],[7,[20,71,cr.plugins_.TiledBg.prototype.exps.Width,!1,null],[0,2]]]]]]]],[0,null,!1,null,0xba7d08a219af7,[[73,cr.plugins_.TiledBg.prototype.cnds.CompareX,null,0,!1,!1,!1,967473975399475,!1,[[8,3],[0,[7,[3,[20,73,cr.plugins_.TiledBg.prototype.exps.Width,!1,null]],[0,2]]]]]],[[73,cr.plugins_.TiledBg.prototype.acts.SetX,null,9166202984138064,!1,[[0,[4,[20,73,cr.plugins_.TiledBg.prototype.exps.X,!1,null],[7,[20,73,cr.plugins_.TiledBg.prototype.exps.Width,
!1,null],[0,2]]]]]]]],[0,null,!1,null,0xed965dc70bca,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x69b71f25158ae,!1]],[[-1,cr.system_object.prototype.acts.AddVar,null,5985580072117075,!1,[[11,"timer"],[7,[19,cr.system_object.prototype.exps.dt]]]]]],[0,null,!0,null,5574639819675093,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xc2651ee2c5139,!1,[[4,32]]],[2,cr.plugins_.Keyboard.prototype.cnds.OnKey,null,1,!1,!1,!1,0xc5da56e86223c,!1,[[9,38]]]],[[4,cr.behaviors.Platform.prototype.acts.SimulateControl,
"Platform",5725604595100538,!1,[[3,2]]],[62,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",7231064937420058,!1,[[3,2]]],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6852330011862308,!1,[[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.StartAnim,null,9116602411292800,!1,[[3,1]]],[32,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x3cddb8c7a2f59,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,6515381621748289,!1,[[0,[1,0.2]]]],[32,cr.plugins_.Sprite.prototype.acts.SetVisible,
null,289368329973642,!1,[[3,1]]]]],[0,null,!0,null,7368284850443256,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6575531248908949,!1,[[4,32]]],[2,cr.plugins_.Keyboard.prototype.cnds.OnKey,null,1,!1,!1,!1,0xf1e3ebf7d27d3,!1,[[9,38]]]],[[15,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",9899814841546176,!1,[[3,2]]],[63,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",0x7077c686ae579,!1,[[3,2]]]]],[0,null,!1,null,9412313399266492,[[4,cr.behaviors.Platform.prototype.cnds.IsJumping,
"Platform",0,!1,!1,!1,7613919122916759,!1]],[[4,cr.plugins_.Sprite.prototype.acts.SetAnim,null,5684726110437482,!1,[[1,[2,"jump"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,0x944685ea9a828,!1,[[0,[0,1]]]],[4,cr.plugins_.Sprite.prototype.acts.SetAnim,null,9760692373490596,!1,[[1,[2,"run"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.StopAnim,null,0x944e9eed7eeb9,!1],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,null,4852485448418142,!1,[[3,0]]]]],[0,null,!1,null,0x51cfaf91f38d5,[[62,
cr.behaviors.Platform.prototype.cnds.IsJumping,"Platform",0,!1,!1,!1,7162288986381823,!1]],[[62,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7313915451229335,!1,[[1,[2,"jump"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,9971696777416776,!1,[[0,[0,1]]]],[62,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x720c94a778cf0,!1,[[1,[2,"run"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.StopAnim,null,5088763514072848,!1],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7259097031947521,
!1,[[3,0]]]]],[0,null,!1,null,0x96774a109195,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x45f5f6170d307,!1,[[11,"timer"],[8,5],[7,[0,15]]]]],[],[[0,null,!1,null,889370933128367,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,9719976174966576,!1,[[0,[0,14]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x638962f58bdc3,!1,[[4,11],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,400],[0,200]]]]]]]]]],[0,null,!1,null,8020395330556348,
[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8446617909440068,!1,[[11,"timer"],[8,5],[7,[0,5]]]]],[[40,cr.plugins_.Sprite.prototype.acts.SetVisible,null,921840989180029,!1,[[3,0]]],[40,cr.plugins_.Sprite.prototype.acts.Destroy,null,7263196601653192,!1]]],[0,null,!1,null,7873490801931368,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x425fd3c25c58b,!1,[[11,"timer"],[8,5],[7,[0,25]]]]],[],[[0,null,!1,null,9722096773422580,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,9297061046079152,!1,[[0,[0,25]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,8886263436851332,!1,[[4,14],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,400],[0,250]]]]]]]]]],[0,null,!1,null,6691586149236626,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x74f630188e43f,!1,[[11,"timer"],[8,5],[7,[0,1]]]]],[],[[0,null,!1,null,9938754920450326,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,8081991729055794,!1,[[0,
[0,4]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x94ccd86476ea4,!1,[[4,6],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,300],[0,250]]]]]]]],[0,null,!1,null,0x79daf28d69b85,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xdc44457672313,!1,[[0,[0,6]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,570877139032076,!1,[[4,58],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,300],[0,250]]]]]]]],[0,null,
!1,null,0xc68299ec33cf6,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,5355350359242644,!1,[[0,[0,9]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xa05716e0418d2,!1,[[4,59],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,300],[0,250]]]]]]]],[0,null,!1,null,385147150999859,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,6920199287237301,!1,[[0,[0,11]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,9774362314289842,!1,[[4,
60],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,300],[0,250]]]]]]]],[0,null,!1,null,0x4eeb123543516,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xb87fcd6f32705,!1,[[0,[0,13]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x67e2e9f43973e,!1,[[4,61],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,300],[0,250]]]]]]]]]],[0,null,!1,null,0x4d7f8972206c1,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,
!1,4657991241840528,!1,[[11,"timer"],[8,5],[7,[0,1]]]]],[],[[0,null,!1,null,8539105379880638,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,5997980597927016,!1,[[0,[0,15]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xcb704807a135f,!1,[[4,6],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]],[0,null,!1,null,9291252368031324,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xaed7f47d9f769,!1,[[0,[1,15.1]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,9322984662252832,
!1,[[4,58],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]],[0,null,!1,null,0x5e283e8bd706d,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,5963208596879596,!1,[[0,[1,15.2]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,7901378683906011,!1,[[4,59],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]],[0,null,!1,null,9345780939924786,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xf0b539957cb9,!1,[[0,[1,15.3]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x5827551e16791,
!1,[[4,60],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]],[0,null,!1,null,8411913774177711,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,6571884221641048,!1,[[0,[1,15.4]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,6215302768923297,!1,[[4,61],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]]]],[0,null,!1,null,558050736129434,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x49d434b19ac7c,!1,[[4,33]]]],[],[[0,null,!1,null,5818208006223126,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,0x957baff44121c,!1,[[0,[1,0.6]]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,6354935589347583,!1,[[4,31],[5,[0,0]],[7,[0,0]]]],[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,6212034494616122,!1,[[4,31],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,8475060790844442,!1,[[2,["2",!1]],[3,0],[0,[0,0]],[1,[2,"shoot"]]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,4799266565828408,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,9894697965062012,
!1,[[0,[1,0.2]]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x46a534a22831b,!1,[[3,1]]]]]]],[0,null,!1,null,0x9e2ca6ebbfd7e,[[2,cr.plugins_.Keyboard.prototype.cnds.OnKey,null,1,!1,!1,!1,9562844360869128,!1,[[9,32]]]],[],[[0,null,!1,null,6041902423892318,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x815e37196e07c,!1,[[0,[1,0.6]]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x96903190aeafc,!1,[[4,31],[5,[0,0]],[7,[0,0]]]],[62,cr.plugins_.Sprite.prototype.acts.Spawn,
null,8346603588267063,!1,[[4,31],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,7223714581152531,!1,[[2,["2",!1]],[3,0],[0,[0,0]],[1,[2,"shoot"]]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,9538389386802012,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,8799685888480355,!1,[[0,[1,0.2]]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8911747023065464,!1,[[3,1]]]]]]],[0,null,!1,null,0xea32d3cdd6aaf,[[31,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,0x5f12079079f4f,!1,[[4,74]]]],[[74,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,6666359754472041,!1,[[10,0],[7,[0,0]]]],[31,cr.plugins_.Sprite.prototype.acts.Destroy,null,518259454083063,!1]]],[0,null,!1,null,0xc1b83e990989,[[31,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6189765738993219,!1,[[4,75]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,8519841198647859,!1,[[10,0],[7,[0,0]]]],[31,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xf1a79bd6c5322,
!1]]],[0,null,!1,null,6685726128049141,[[31,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4881112625958714,!1,[[4,76]]]],[[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,7399783006175133,!1,[[10,0],[7,[0,0]]]],[31,cr.plugins_.Sprite.prototype.acts.Destroy,null,5481389675678448,!1]]],[0,null,!1,null,0xbf35f951d401c,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9032119450957036,!1,[[4,11]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xf592b6fdedb0e,
!1]]],[0,null,!1,null,7845782048194832,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5305074421036007,!1,[[4,58]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x75b5adb7aef73,!1]]],[0,null,!1,null,704722946842574,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9673883515672818,!1,[[4,59]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xf1321b43a772a,!1]]],[0,null,!1,null,5045478292776201,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,
!1,!1,!0,7620123561630467,!1,[[4,60]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,9097532697287932,!1]]],[0,null,!1,null,9560935548793852,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x4d91ed546b362,!1,[[4,61]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,404475844420526,!1]]],[0,null,!1,null,0xd24ab04b6f42,[[58,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9157698404222562,!1,[[4,59]]]],[[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,5209698299094859,
!1]]],[0,null,!1,null,0x81269ecba9452,[[58,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6735310231562101,!1,[[4,60]]]],[[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,7602584408273052,!1]]],[0,null,!1,null,0xb0491b808cd13,[[59,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9321140957924420,!1,[[4,60]]]],[[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,4557231120679067,!1]]],[0,null,!1,null,0xd20fd4226f30d,[[60,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,
0,!1,!1,!0,7227247574867768,!1,[[4,61]]]],[[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xd912a969f28b6,!1]]],[0,null,!1,null,7083833175135233,[[74,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4693061764178137,!1,[[4,75]]]],[[75,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc09076d75a75a,!1]]],[0,null,!1,null,0xfaebf5e0f1a67,[[76,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5595393208254402,!1,[[4,75]]]],[[75,cr.plugins_.Sprite.prototype.acts.Destroy,null,
0x501b85eca5889,!1]]],[0,null,!1,null,5503625742987163,[[76,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4948770792852274,!1,[[4,74]]]],[[76,cr.plugins_.Sprite.prototype.acts.Destroy,null,653630206891406,!1]]],[0,null,!1,null,7566283475691819,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5633273110742692,!1,[[11,"timer"],[8,5],[7,[0,5]]]]],[],[[0,null,!1,null,6877745754204636,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xafa2e4d86fae1,!1,[[0,[0,5]]]]],
[[-1,cr.system_object.prototype.acts.CreateObject,null,7774486457903553,!1,[[4,74],[5,[2,"Game"]],[0,[0,1260]],[0,[0,550]]]]]]]],[0,null,!1,null,0x5e1d1389269a5,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7501054081292754,!1,[[11,"timer"],[8,5],[7,[0,5]]]]],[],[[0,null,!1,null,0x874b2d2d8475f,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xf09aa245ab4f,!1,[[0,[1,7.5]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,8457504384793041,!1,[[4,75],[5,[2,"Game"]],
[0,[0,1260]],[0,[0,550]]]]]]]],[0,null,!1,null,0x6c8538e0bc4c7,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6246428373648729,!1,[[11,"timer"],[8,5],[7,[0,5]]]]],[],[[0,null,!1,null,7057479378429235,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,4960153181515939,!1,[[0,[1,9.5]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,6343147733470616,!1,[[4,76],[5,[2,"Game"]],[0,[0,1260]],[0,[0,550]]]]]]]],[0,null,!1,null,7637564187082413,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,9894166917675856,!1,[[4,6]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,7455334883880073,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,9415849407167152,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",8713410922693153,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x90b1cf6763f11,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,6064512217955983,
!1,[[0,[1,0.5]]]],[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,9046134322306016,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0x8890c2ff552d5,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,9145224426250012,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xdc80bb34f6d10,!1,[[4,58]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,8747217929554034,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xab352420a4589,!1,[[2,["new3",!1]],[3,0],
[0,[0,0]],[1,[2,""]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",7869274204527828,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6264221000300316,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x76d710a24212b,!1,[[0,[1,0.5]]]],[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,7572150218048728,!1],[-1,cr.system_object.prototype.acts.AddVar,null,5166557019160147,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0xbc6505fb86ecb,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,0xdc90492b62de5,!1,[[4,59]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,7164335750735311,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,8138235857138824,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x8b4eb353d8e9,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9090975629297048,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,934254169259384,
!1,[[0,[1,0.5]]]],[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xd68d06d53163c,!1],[-1,cr.system_object.prototype.acts.AddVar,null,870940154532866,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,8724928973321031,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xd14d1afa7e7d1,!1,[[4,60]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xe336fb7ceff71,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,397566038772253,!1,[[2,["new3",!1]],[3,0],[0,
[0,0]],[1,[2,""]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",654738166123759,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x9d5396ea3e5a8,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x85d8330e8b457,!1,[[0,[1,0.5]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x79fbbcf173e9f,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0xd747a3eea4a60,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,9730594317036700,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,0x681e0feeff1e2,!1,[[4,61]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xb825386421b1e,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,7789635429719961,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9653031530314772,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7873217134657521,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,6717535936526885,
!1,[[0,[1,0.5]]]],[61,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xd25cf411f2817,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0xd27ab233be8e7,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0xd87d12da96f36,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8336773779540266,!1,[[4,6]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,8160994421980364,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,384524784207177,!1,[[2,["new3",!1]],[3,0],
[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xf08c2fe816d54,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xd57666470e3a1,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x6f10dca92644,!1,[[0,[1,0.5]]]],[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,8129592111337241,!1],[-1,cr.system_object.prototype.acts.AddVar,null,5043454992770753,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0x4d46b3169a723,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,7052516730463981,!1,[[4,58]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xd1cc4ef69e033,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,526387725556089,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xbcc2545ea9e47,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6319572899886063,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,9597207187704496,
!1,[[0,[1,0.5]]]],[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,8321571012715655,!1],[-1,cr.system_object.prototype.acts.AddVar,null,866205858568845,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,9361781654029042,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5740017683977709,!1,[[4,59]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,8166259886908063,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,6384861022626664,!1,[[2,["new3",!1]],[3,
0],[0,[0,0]],[1,[2,""]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",38413836483813,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6659113756872219,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,8646663474522847,!1,[[0,[1,0.5]]]],[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,4960837329999884,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0xd588db1dc8978,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0xb0014fcae7469,[[62,
cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5372368588417913,!1,[[4,60]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,432546802573535,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0x846c3dc1d0f4a,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x9592a86b40b33,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x3e48ac0b39d34,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,
null,0x7ae0a397e1591,!1,[[0,[1,0.5]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,8210917139232213,!1],[-1,cr.system_object.prototype.acts.AddVar,null,6106149945448927,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,5430865632003062,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x651f9bf016db7,!1,[[4,61]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,5668966977778657,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xf3910cb6d1fcf,!1,
[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9451927297786392,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x5c4db254d4230,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,865508862296056,!1,[[0,[1,0.5]]]],[61,cr.plugins_.Sprite.prototype.acts.Destroy,null,6819126215575588,!1],[-1,cr.system_object.prototype.acts.AddVar,null,7633683290890182,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,
0xc1e5b59e8d35c,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5290825632911448,!1,[[4,6]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,5677970664774278,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,8896805744269548,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9428587668178036,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",432582569110862,!1,[[0,
[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,9048218250018478,!1,[[0,[1,0.5]]]],[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xabe0058aa029d,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0x79311fd64dd91,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,9697192022191008,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x449e7a1364ecd,!1,[[4,58]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x9d73497f69a8d,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,
null,8649810394438457,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",7405162704180535,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x857992128dc52,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xd491673af24ed,!1,[[0,[1,0.5]]]],[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,8164736087870181,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0xf46380c43eb8a,!1,[[11,"Score"],[7,[0,
75]]]]]],[0,null,!1,null,8331922571066152,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xeb7b10455ce70,!1,[[4,59]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,7542085502383705,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,5251807523152557,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xc4cce1bc1ea76,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",
529643682270443,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xec6215753e6e4,!1,[[0,[1,0.5]]]],[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x439543d63cc78,!1],[-1,cr.system_object.prototype.acts.AddVar,null,97252903478489,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0x7bbd5bf493c97,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7606033460089403,!1,[[4,60]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,8961807665787303,!1,[[4,7],[5,[0,0]],[7,[0,
0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,5683179057327231,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xb159dfc1d360c,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",707460040008278,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,6511917447631131,!1,[[0,[1,0.5]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,9555291007700098,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,8985875013023314,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,5414293074179149,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8164761133603209,!1,[[4,61]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,6307800303752352,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xf6100dcec25e2,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",5893940893186067,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0x4fde170e79cde,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,7621853571396654,!1,[[0,[1,0.5]]]],[61,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xe6685adc5dda6,!1],[-1,cr.system_object.prototype.acts.AddVar,null,9454742888124604,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0xd78f6c68d482c,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9555077405806336,!1,[[4,6]]]],[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,354798934663754,!1,[[4,7],[5,[0,
0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,4938329856287798,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9933055630429494,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7617318627599231,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xb681ba955fabf,!1,[[0,[1,0.5]]]],[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,9303267673926580,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,0x96c87be227469,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,9029587790513678,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xcc405fee12fa5,!1,[[4,58]]]],[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xf32081368892f,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,5398852943306106,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xaecf768efa907,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0x4332538b73299,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,8046291245307153,!1,[[0,[1,0.5]]]],[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x66e10eb8003f7,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0x66eccbc8d74cf,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,8758132065952913,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xd1b1d6868903f,!1,[[4,59]]]],[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x5ff366d151bdf,!1,[[4,7],[5,[0,
0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,5063440667033162,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x7fc9d5cd19690,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xd4f876ad16307,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x56c13b44f7be4,!1,[[0,[1,0.5]]]],[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x55b03649790bc,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,0xab3edaaaabb54,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,9296391180800800,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6206993664077706,!1,[[4,60]]]],[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xee16996de4b87,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xf17e9b48d6537,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9337096955679958,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0x3920e41b55e01,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x3bddfd644ffba,!1,[[0,[1,0.5]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,9267974058587272,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0x8bee3b16a9585,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,607541714857304,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xc1b8f572b50e6,!1,[[4,61]]]],[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x8aeb26d59e1c4,!1,[[4,7],[5,[0,
0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xe63d1fd51dba3,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9322172645643124,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4700759652603402,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,9125147726929140,!1,[[0,[1,0.5]]]],[61,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x519f257d1cd65,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,0x9386ffcad6c49,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,9598606493035732,[[7,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,6836610163277199,!1]],[[7,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x427c324d22aaf,!1]]],[0,null,!1,null,5838830916742636,[[13,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,5748668258184329,!1]],[[13,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x6c1a98740724d,!1]]],[0,null,!1,null,9753524316836892,[[12,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,
null,1,!1,!1,!1,9596559425253580,!1]],[[12,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x5f959ae253df9,!1]]],[0,null,!1,null,7320373298765358,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x5eded0cfeb67b,!1]],[[3,cr.plugins_.Text.prototype.acts.SetText,null,0xe60ad1c2bfb76,!1,[[7,[10,[2,": "],[23,"Score"]]]]]]],[0,null,!1,null,0x4dc8b62309d37,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x4863993f75867,!1,[[4,74]]]],[[4,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
null,0x86eb0c79bcafb,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,6172006625474388,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5881375530338771,!1,[[4,75]]]],[[4,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,0xf3ba6207a8a48,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,6616297428964376,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x81af634f0fcda,!1,[[4,76]]]],[[4,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,9771338129663738,!1,[[10,0],[7,[0,1]]]]]],
[0,null,!1,null,0x530994e36fdf6,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8366213826677336,!1,[[4,74]]]],[[62,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,4954660979299832,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,0xd151ffd26990a,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x9d0f25fda09da,!1,[[4,75]]]],[[62,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,0xd8ce785d66a97,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,9845433682561866,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,0x6d186a96caa5d,!1,[[4,76]]]],[[62,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,0xc9f9cd6d157e2,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,0xb4fa58d6e07fd,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9270627825297122,!1,[[4,11]]]],[[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,4741089081735256,!1],[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xa35e44c22471b,!1,[[4,13],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,9530294058414268,
!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x5545755c9ffc9,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5787777464623959,!1,[[0,[0,800]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x97706b7889173,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x3af8448b0b3f9,!1,[[0,[0,800]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6322889945908651,
!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",601883878775047,!1,[[0,[0,800]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",462747038709548,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xb4a4df218f511,!1,[[0,[0,800]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x9cb2c33dd56ef,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6494631069839448,!1,[[0,[0,800]]]],[74,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
null,0x9bd209266128c,!1,[[10,0],[7,[0,0]]]],[75,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,7010881288900644,!1,[[10,0],[7,[0,0]]]],[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,5954065385836514,!1,[[10,0],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,0x6e3994fc59066,!1,[[11,"Score"],[7,[0,500]]]],[-1,cr.system_object.prototype.acts.Wait,null,7781566113556753,!1,[[0,[1,0.5]]]]]],[0,null,!1,null,507632978143618,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,6821941390892257,!1,[[4,11]]]],[[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,8901855112766694,!1],[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,9843767276213972,!1,[[4,13],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,8091625235372593,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",51067760105763,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",846825735417278,!1,
[[0,[0,800]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",74775981016371,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6678646209794477,!1,[[0,[0,800]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6030188645677722,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9543078659061984,!1,[[0,[0,800]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",7962396003858602,!1,[[0,[0,270]]]],[60,
cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x4815827052c78,!1,[[0,[0,800]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6661999495877797,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",559659952531677,!1,[[0,[0,800]]]],[74,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x39902bbcd4e74,!1,[[10,0],[7,[0,0]]]],[75,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,9934678308889300,!1,[[10,0],[7,[0,0]]]],[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
null,9256799007960748,!1,[[10,0],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,459935308570881,!1,[[11,"Score"],[7,[0,500]]]],[-1,cr.system_object.prototype.acts.Wait,null,9698314941999062,!1,[[0,[1,0.5]]]]]],[0,null,!1,null,417610669976137,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7218868889302673,!1,[[4,11]]]],[[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,9768176975749E3,!1],[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,8316135189169679,!1,[[4,13],
[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0x681410c95cf4d,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",8932557451178767,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7468326706853024,!1,[[0,[0,800]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6704514481499861,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5176836747932793,!1,[[0,
[0,800]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",7996836524577111,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9369392651642880,!1,[[0,[0,800]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xf4123a716404a,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9015311851760608,!1,[[0,[0,800]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",8979955126610734,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0xc9dbae3765f43,!1,[[0,[0,800]]]],[74,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,5253886658546505,!1,[[10,0],[7,[0,0]]]],[75,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,848481836719049,!1,[[10,0],[7,[0,0]]]],[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xfa4f6655e547d,!1,[[10,0],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,9003716123256318,!1,[[11,"Score"],[7,[0,500]]]],[-1,cr.system_object.prototype.acts.Wait,null,9588084129424076,!1,[[0,
[1,0.5]]]]]],[0,null,!1,null,7226950417493394,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5127963465389914,!1,[[4,11]]]],[[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,7508030963046191,!1],[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xd0b8b5b956c6b,!1,[[4,13],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,5822133389271955,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x444da96a87df4,
!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6980660286563705,!1,[[0,[0,800]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x88c3ae4171f6e,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x4b3e854e05cb7,!1,[[0,[0,800]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9055312229275972,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",879104204030254,!1,[[0,[0,800]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
"Bullet",6821537213646053,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",682624454318801,!1,[[0,[0,800]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xa0f2e7443794e,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8873900488167663,!1,[[0,[0,800]]]],[74,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,8410228413930144,!1,[[10,0],[7,[0,0]]]],[75,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x540f9e96e7497,!1,
[[10,0],[7,[0,0]]]],[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x9117008473d23,!1,[[10,0],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,6052432859772314,!1,[[11,"Score"],[7,[0,500]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x96862707ddab3,!1,[[0,[1,0.5]]]]]],[0,null,!1,null,0x56f71f950b77d,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xf99bc3fe59cd,!1,[[4,14]]]],[[14,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x60702ef65f573,!1],[30,cr.plugins_.Audio.prototype.acts.Play,
null,6585692449196531,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,5911967861313592,!1,[[4,15],[5,[0,0]],[7,[0,0]]]],[15,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,7534958036006523,!1,[[3,1]]],[15,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x5a854dc6beb8b,!1,[[3,1]]],[4,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7554232822332483,!1,[[3,0]]],[4,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0x76dadbe778a1a,!1,[[3,0]]]]],
[0,null,!1,null,0xe862def2b9d6b,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xbc4361de4a4c0,!1,[[4,14]]]],[[14,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x487d8f55030da,!1],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xa3c6a8a176182,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,764730540110582,!1,[[4,63],[5,[0,0]],[7,[0,0]]]],[63,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,7865003280828857,!1,[[3,1]]],[63,cr.plugins_.Sprite.prototype.acts.SetVisible,
null,5851146005993132,!1,[[3,1]]],[62,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8800107825172402,!1,[[3,0]]],[62,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0x70435828e8839,!1,[[3,0]]]]],[0,null,!1,null,997369219070251,[[15,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,8469647574213024,!1]],[[55,cr.plugins_.Sprite.prototype.acts.StopAnim,null,7874253442809014,!1],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7774035967615291,!1,[[3,0]]],[4,cr.plugins_.Sprite.prototype.acts.SetVisible,
null,0xfc2f713e4d14d,!1,[[3,0]]],[4,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0xa9382f10ea18f,!1,[[3,0]]],[4,cr.plugins_.Sprite.prototype.acts.Destroy,null,9495527656569376,!1],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8491040822926658,!1,[[3,0]]],[36,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xa0a77f799690,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,980326915211558,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x7b9a09e0d6e28,
!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,8358356543271824,!1,[[0,[0,10]]]],[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,5150928156631863,!1,[[4,4],[5,[0,0]],[7,[0,0]]]],[15,cr.plugins_.Sprite.prototype.acts.Destroy,null,650750926238963,!1],[15,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,727489548517109,!1,[[3,0]]],[15,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8045303545314196,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,8479355589555087,
!1,[[3,1]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6310398917758367,!1,[[3,1]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,5312490347411341,!1,[[3,1]]],[36,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xe929bbc9f6d39,!1,[[3,1]]]]],[0,null,!1,null,0xd3b56ebc80bfc,[[63,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,0xf8ddcca36adf2,!1]],[[55,cr.plugins_.Sprite.prototype.acts.StopAnim,null,0x48582a419eb8a,!1],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,
null,0xadf3017279af6,!1,[[3,0]]],[62,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x9996a25f1bb9f,!1,[[3,0]]],[62,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,5056031731422257,!1,[[3,0]]],[62,cr.plugins_.Sprite.prototype.acts.Destroy,null,840625001919922,!1],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8611507591528629,!1,[[3,0]]],[36,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7250881392280346,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0xdde085a02f569,
!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7210322947490231,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,0x8d4a3724bf46,!1,[[0,[0,10]]]],[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,867463730199947,!1,[[4,62],[5,[0,0]],[7,[0,0]]]],[63,cr.plugins_.Sprite.prototype.acts.Destroy,null,5377810441931704,!1],[63,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,9633311909321884,!1,[[3,0]]],[63,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x544b2811ccf60,!1,
[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,4772434889576384,!1,[[3,1]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x3cd11a761a175,!1,[[3,1]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6509065103446305,!1,[[3,1]]],[36,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x9c3011c41b1ad,!1,[[3,1]]]]],[0,null,!1,null,5634919065632533,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xc455c38cb2fe7,!1,[[4,74]]]],[[74,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
null,5629520179270519,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,7642079314081243,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xf10a3ff35b1c,!1,[[4,75]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,8580456825123928,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,6436581174180088,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7855819300356984,!1,[[4,76]]]],[[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,9508382269020084,!1,[[10,0],[7,[0,
0]]]]]],[0,null,!1,null,0xcf9e230957bfb,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7968561157213312,!1,[[4,74]]]],[[74,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,57210419549664,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,0xaf1ec338b60fd,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7956460735841834,!1,[[4,75]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xce976871056d,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,6462460039118626,[[63,
cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7513924041442051,!1,[[4,76]]]],[[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,9987015724830452,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,6984392986709141,[[74,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,5060117414426691,!1,[[10,0],[8,0],[7,[0,0]]]]],[[74,cr.plugins_.Sprite.prototype.acts.Destroy,null,5885222994240181,!1],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xbdae502af020,!1,[[2,["1",!1]],[3,
0],[0,[0,0]],[1,[2,""]]]],[74,cr.plugins_.Sprite.prototype.acts.Spawn,null,5302234129589958,!1,[[4,91],[5,[0,0]],[7,[0,0]]]]]],[0,null,!1,null,4674947808658403,[[75,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,9849344004646624,!1,[[10,0],[8,0],[7,[0,0]]]]],[[75,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x62321b3188909,!1],[30,cr.plugins_.Audio.prototype.acts.Play,null,7972485348598979,!1,[[2,["1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[75,cr.plugins_.Sprite.prototype.acts.Spawn,
null,5112205394444398,!1,[[4,88],[5,[0,0]],[7,[0,0]]]]]],[0,null,!1,null,5352139223262487,[[76,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,0x93f07cf0b6c9d,!1,[[10,0],[8,0],[7,[0,0]]]]],[[76,cr.plugins_.Sprite.prototype.acts.Destroy,null,4759355445506817,!1],[30,cr.plugins_.Audio.prototype.acts.Play,null,4848378537170416,!1,[[2,["1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[76,cr.plugins_.Sprite.prototype.acts.Spawn,null,9290185137801764,!1,[[4,27],[5,[0,0]],[7,[0,0]]]]]],[0,null,
!1,null,0x46cd385aa6279,[[27,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,0x751b5536d17d3,!1]],[[27,cr.plugins_.Sprite.prototype.acts.Destroy,null,6676571501477498,!1]]],[0,null,!1,null,0x4e9bd35d11644,[[88,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,4858267916517972,!1]],[[88,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xbfaffdc522256,!1]]],[0,null,!1,null,0xa1bb6fa102de0,[[91,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,0x6db80d8c6273f,
!1]],[[91,cr.plugins_.Sprite.prototype.acts.Destroy,null,398549390497172,!1]]],[0,null,!1,null,419378493427275,[[4,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,0x740f27b18bb11,!1,[[10,0],[8,3],[7,[0,0]]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xd2ad4e9dd9238,!1,[[4,26],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0x6c916e9277c61,!1,[[2,["1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[4,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xde1a09da59b27,
!1],[-1,cr.system_object.prototype.acts.Wait,null,656107457489782,!1,[[0,[0,2]]]],[30,cr.plugins_.Audio.prototype.acts.Stop,null,0xd5ea62f065931,!1,[[1,[2,"main"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9235541770168516,!1,[[11,"gamespeed"],[7,[0,0]]]],[17,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,5674904852685097,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x94dc55b1b146c,!1,[[6,"menu"]]]]],[0,null,!1,null,0x391ef0661e4ea,[[62,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
null,0,!1,!1,!1,4564483005249348,!1,[[10,0],[8,3],[7,[0,0]]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x919d4426bba4e,!1,[[4,65],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,6866110968572532,!1,[[2,["1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[62,cr.plugins_.Sprite.prototype.acts.Destroy,null,7263819571661383,!1],[-1,cr.system_object.prototype.acts.Wait,null,0x9b4dedb89ce44,!1,[[0,[0,2]]]],[30,cr.plugins_.Audio.prototype.acts.Stop,null,9391714110413718,!1,[[1,[2,"main"]]]],
[-1,cr.system_object.prototype.acts.SetVar,null,0xec43fa3f5687d,!1,[[11,"gamespeed"],[7,[0,0]]]],[17,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,0xa204fe8a9a142,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,7723976696237022,!1,[[6,"menu"]]]]],[0,null,!1,null,5824353684918966,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6255598513466018,!1,[[11,"Score"],[8,5],[7,[0,500]]]]],[],[[0,null,!1,null,8932056481166851,[[-1,cr.system_object.prototype.cnds.TriggerOnce,
null,0,!1,!1,!1,5649436493911204,!1]],[[-1,cr.system_object.prototype.acts.AddVar,null,5287475456308259,!1,[[11,"gamespeed"],[7,[0,1]]]]]]]],[0,null,!1,null,0xa8e749e0bd8a4,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7769141385379897,!1,[[11,"gamespeed"],[8,0],[7,[0,1]]]]],[],[[0,null,!1,null,5373155922602843,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,5972365128578101,!1,[[0,[1,0.1]]]]],[[72,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x7f18d67db5272,!1,
[[0,[4,[22,72,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[71,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xeabd88f8aaa4b,!1,[[0,[4,[22,71,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[73,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5267927477849594,!1,[[0,[4,[22,73,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",978978829446572,!1,[[0,[4,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",313718791126912,!1,[[0,[4,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x74c0b202b947,!1,[[0,[4,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x479e8b2c9bba6,!1,[[0,[4,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0x4535f9db5c0ca,!1,[[0,[4,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x9031c44c23ad8,!1,[[0,[4,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7525637524780189,!1,[[0,[4,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[74,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8616843059900481,
!1,[[0,[4,[22,74,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[75,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5405975805995066,!1,[[0,[4,[22,75,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x543fea54eb34f,!1,[[0,[4,[22,76,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,0xb39a529a6bf14,!1,[[1,[2,"main"]],[0,[0,-15]]]],
[-1,cr.system_object.prototype.acts.Wait,null,6818541601869055,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x64da9b81dbdf2,!1,[[11,"gamespeed"],[7,[0,2]]]]]]]],[0,null,!1,null,0x641406429fc0e,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x6cab22fca1859,!1,[[11,"gamespeed"],[8,0],[7,[0,2]]]]],[[72,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x5a3c99cfce872,!1,[[0,[0,400]]]],[71,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9983563969174880,!1,
[[0,[0,200]]]],[73,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5062962742730266,!1,[[0,[0,550]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9006401744831849,!1,[[0,[0,400]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8905853560929149,!1,[[0,[0,400]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7829772689509918,!1,[[0,[0,400]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8357503529910936,!1,[[0,[0,400]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0x5b5d7ab31ac27,!1,[[0,[0,400]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9847545522893248,!1,[[0,[0,400]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8186291601564707,!1,[[0,[0,400]]]],[74,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6002470876058269,!1,[[0,[0,600]]]],[75,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9980467845955156,!1,[[0,[0,600]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7068033121606445,!1,[[0,[0,600]]]],
[-1,cr.system_object.prototype.acts.SetVar,null,6318320177108488,!1,[[11,"gamespeed"],[7,[0,3]]]],[-1,cr.system_object.prototype.acts.Wait,null,9821637595925886,!1,[[0,[0,10]]]]]],[0,null,!1,null,8239811560397495,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xf3fae8579a7c5,!1,[[11,"gamespeed"],[8,0],[7,[0,3]]]]],[],[[0,null,!1,null,806921850610089,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xfd35a1906ed0f,!1,[[0,[1,0.1]]]]],[[72,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",5514239395977386,!1,[[0,[4,[22,72,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[71,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8041087720259913,!1,[[0,[4,[22,71,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[73,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7692057328933632,!1,[[0,[4,[22,73,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xd8195cb93c3fc,
!1,[[0,[4,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7722030848978019,!1,[[0,[4,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8734348112624556,!1,[[0,[4,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9384150555635180,!1,[[0,[4,[22,60,"Bullet",
cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4945423983836434,!1,[[0,[4,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5644644179864191,!1,[[0,[4,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9332993011182500,!1,[[0,[4,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[74,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x61673eca0b7b,!1,[[0,[4,[22,74,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[75,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",334862012279803,!1,[[0,[4,[22,75,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xf1a063a3ed791,!1,[[0,[4,[22,76,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,
null,4828050371428797,!1,[[1,[2,"main"]],[0,[0,-10]]]],[-1,cr.system_object.prototype.acts.Wait,null,428215743431508,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x929cd9b126d1e,!1,[[11,"gamespeed"],[7,[0,4]]]]]]]],[0,null,!1,null,0x4908e1fec8e8f,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5139161330004764,!1,[[11,"gamespeed"],[8,0],[7,[0,4]]]]],[[72,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7592976728500537,!1,[[0,[0,500]]]],[71,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0xca7cb97a81ccc,!1,[[0,[0,300]]]],[73,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7339168147967671,!1,[[0,[0,650]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6952957118425103,!1,[[0,[0,500]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9882905991429604,!1,[[0,[0,500]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7804674897242854,!1,[[0,[0,500]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x78662decb7564,!1,[[0,[0,500]]]],
[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xa0048db088ba0,!1,[[0,[0,500]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xada54db13b6a5,!1,[[0,[0,500]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9283321125587716,!1,[[0,[0,500]]]],[74,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",605444936050817,!1,[[0,[0,700]]]],[75,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x99273f08a97dd,!1,[[0,[0,700]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0xccc826dfd2c8e,!1,[[0,[0,700]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xef41366fa8b51,!1,[[0,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9812324735495662,!1,[[11,"gamespeed"],[7,[0,5]]]]]],[0,null,!1,null,4928918307942121,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8973970228003151,!1,[[11,"gamespeed"],[8,0],[7,[0,5]]]]],[],[[0,null,!1,null,0x60fdd33370d9f,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,6184068209258394,!1,[[0,[1,0.1]]]]],
[[72,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5796678418383873,!1,[[0,[4,[22,72,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[71,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xb7eaa59692398,!1,[[0,[4,[22,71,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[73,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xf6a5b9649e9e9,!1,[[0,[4,[22,73,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0xaa9d0a65d3198,!1,[[0,[4,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x7ac70fa728561,!1,[[0,[4,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x97725c05f5bf,!1,[[0,[4,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",945197848767255,!1,
[[0,[4,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5509463252192472,!1,[[0,[4,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9010560629459466,!1,[[0,[4,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6329047384210028,!1,[[0,[4,[22,14,"Bullet",
cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[74,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5849864189311646,!1,[[0,[4,[22,74,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[75,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8101480314709799,!1,[[0,[4,[22,75,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",484684698453118,!1,[[0,[4,[22,76,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,8095035444481928,!1,[[1,[2,"main"]],[0,[0,-5]]]],[-1,cr.system_object.prototype.acts.Wait,null,9181519375008192,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xf24d6de00bb5c,!1,[[11,"gamespeed"],[7,[0,6]]]]]]]],[0,null,!1,null,948724764754815,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6399162209223194,!1,[[11,"gamespeed"],[8,0],[7,[0,6]]]]],[[72,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",8222447540405682,!1,[[0,[0,600]]]],[71,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x6d5398b2a5b75,!1,[[0,[0,400]]]],[73,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xe9f6b4d5fc4ad,!1,[[0,[0,750]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x526a11a9e226b,!1,[[0,[0,600]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7315489726778925,!1,[[0,[0,600]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x73ece4d2dfa00,!1,[[0,[0,600]]]],[60,
cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8909064743166036,!1,[[0,[0,600]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8513506857102718,!1,[[0,[0,600]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x63c9cd143aaa,!1,[[0,[0,600]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x445fa3815912a,!1,[[0,[0,600]]]],[74,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9708914128240208,!1,[[0,[0,800]]]],[75,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",8288298922666406,!1,[[0,[0,800]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xbac32fde25854,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,6381340749112379,!1,[[0,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8003565527766515,!1,[[11,"gamespeed"],[7,[0,7]]]]]],[0,null,!1,null,9810219864970838,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6681123348811032,!1,[[11,"gamespeed"],[8,0],[7,[0,7]]]]],[],[[0,null,!1,null,8522953245674049,
[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,6791899805055723,!1,[[0,[1,0.1]]]]],[[72,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6381553493543472,!1,[[0,[4,[22,72,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[71,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xba45e920fbb38,!1,[[0,[4,[22,71,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[73,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x7f7f517f9148,!1,[[0,[4,[22,
73,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x836c7f36c3b31,!1,[[0,[4,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7878118471577104,!1,[[0,[4,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4750948208850385,!1,[[0,[4,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7358026629892127,!1,[[0,[4,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xa639e70e316b3,!1,[[0,[4,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xccea0fe8039b5,!1,[[0,[4,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,
cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5332476407469376,!1,[[0,[4,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[74,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9864326232895698,!1,[[0,[4,[22,74,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[75,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6317720697081266,!1,[[0,[4,[22,75,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",9894433381037988,!1,[[0,[4,[22,76,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,0x98c4aa7dfeea1,!1,[[1,[2,"main"]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,5445018065003937,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xffbf925575550,!1,[[11,"gamespeed"],[7,[0,8]]]]]]]],[0,null,!1,null,0x4f0b569080f33,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,304393085856268,
!1,[[11,"gamespeed"],[8,0],[7,[0,8]]]]],[[72,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xcaa357962dac8,!1,[[0,[0,700]]]],[71,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7894573683938989,!1,[[0,[0,500]]]],[73,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4980302898449902,!1,[[0,[0,850]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x4fa02fe118dea,!1,[[0,[0,700]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x5fc47c0511323,!1,[[0,[0,700]]]],[59,
cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5880732004886853,!1,[[0,[0,700]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6016271966698397,!1,[[0,[0,700]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6888667461572112,!1,[[0,[0,700]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5028048663238724,!1,[[0,[0,700]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xff1275b618e56,!1,[[0,[0,700]]]],[74,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0xa42d50bd46bfa,!1,[[0,[0,900]]]],[75,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6723481391170402,!1,[[0,[0,900]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x977ac5a5a79c9,!1,[[0,[0,900]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x73437aebdf1d,!1,[[0,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xd93863a31afbb,!1,[[11,"gamespeed"],[7,[0,9]]]]]],[0,null,!1,null,6113885823911873,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x801ea96a7653,
!1,[[11,"gamespeed"],[8,0],[7,[0,9]]]]],[],[[0,null,!1,null,9027524940148156,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,8537316520237093,!1,[[0,[1,0.1]]]]],[[72,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4518693693800712,!1,[[0,[5,[22,72,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[71,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4651785325063868,!1,[[0,[5,[22,71,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[73,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",8920384056198726,!1,[[0,[5,[22,73,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x44f7b3f2bc2da,!1,[[0,[5,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5802891221077304,!1,[[0,[5,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",981081148871204,
!1,[[0,[5,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5451183650400494,!1,[[0,[5,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5448764108758404,!1,[[0,[5,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xe058af6a252d2,!1,[[0,[5,[22,11,"Bullet",
cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7434241038025005,!1,[[0,[5,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[74,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8773935518101941,!1,[[0,[5,[22,74,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[75,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8857380622515967,!1,[[0,[5,[22,75,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x66b904330ca61,!1,[[0,[5,[22,76,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,9762011800294636,!1,[[1,[2,"main"]],[0,[0,-5]]]],[-1,cr.system_object.prototype.acts.Wait,null,533289987702763,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,976577502694663,!1,[[11,"gamespeed"],[7,[0,10]]]]]]]],[0,null,!1,null,6924722637397588,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,6789782465662042,!1,[[11,"gamespeed"],[8,0],[7,[0,10]]]]],[[72,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5621136392063823,!1,[[0,[0,600]]]],[71,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x8c3dcad7738c4,!1,[[0,[0,400]]]],[73,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x74334bdb94da3,!1,[[0,[0,750]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",962185643892674,!1,[[0,[0,600]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x78d42f88a0188,
!1,[[0,[0,600]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6303588114810535,!1,[[0,[0,600]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5246047322085278,!1,[[0,[0,600]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5538491902333276,!1,[[0,[0,600]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xee21aed76f6f2,!1,[[0,[0,600]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x92df90b12a979,!1,[[0,[0,600]]]],[74,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",6336363363430349,!1,[[0,[0,800]]]],[75,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9879175736781174,!1,[[0,[0,800]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8381276929319745,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xc9d05a5aac7cb,!1,[[0,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6781685837653743,!1,[[11,"gamespeed"],[7,[0,11]]]]]],[0,null,!1,null,0x6d95260dad305,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,
!1,0xe74732c07a3af,!1,[[11,"gamespeed"],[8,0],[7,[0,11]]]]],[],[[0,null,!1,null,6928193122338102,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,9326863428359718,!1,[[0,[1,0.1]]]]],[[72,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9531466256154454,!1,[[0,[5,[22,72,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[71,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xef6a82bb275b0,!1,[[0,[5,[22,71,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],
[0,4]]]]],[73,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xeb7124ad46027,!1,[[0,[5,[22,73,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4665686455572243,!1,[[0,[5,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9291512961312138,!1,[[0,[5,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0x3fcd68f3fd182,!1,[[0,[5,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xf1c0722d5402f,!1,[[0,[5,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5989513804989587,!1,[[0,[5,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x7db676f062b3a,
!1,[[0,[5,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8300969333973784,!1,[[0,[5,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[74,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x47fd975c03cbd,!1,[[0,[5,[22,74,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[75,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8774685006646616,!1,[[0,[5,[22,75,"Bullet",
cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xf99c444b854b1,!1,[[0,[5,[22,76,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,6314807513673215,!1,[[1,[2,"main"]],[0,[0,-10]]]],[-1,cr.system_object.prototype.acts.Wait,null,4667055446621441,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,887926368216598,!1,[[11,"gamespeed"],[7,[0,12]]]]]]]],
[0,null,!1,null,0xa7611092acec8,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,595176731011279,!1,[[11,"gamespeed"],[8,0],[7,[0,12]]]]],[[72,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7386814015137717,!1,[[0,[0,500]]]],[71,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7577706058613091,!1,[[0,[0,300]]]],[73,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x87ce2b217b99a,!1,[[0,[0,650]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8501998575706653,
!1,[[0,[0,500]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",481732361751847,!1,[[0,[0,500]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7409251078782398,!1,[[0,[0,500]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xc858c38faf06f,!1,[[0,[0,500]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",660228327026542,!1,[[0,[0,500]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xc3988b896414a,!1,[[0,[0,500]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",5726889832186571,!1,[[0,[0,500]]]],[74,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8923361612377706,!1,[[0,[0,700]]]],[75,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x43d927d6e041a,!1,[[0,[0,700]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xa2e2aa276529b,!1,[[0,[0,700]]]],[-1,cr.system_object.prototype.acts.Wait,null,8401698239107072,!1,[[0,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xec5f54256e88e,!1,[[11,"gamespeed"],[7,[0,13]]]]]],[0,
null,!1,null,5556420615536353,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8389841146020162,!1,[[11,"gamespeed"],[8,0],[7,[0,13]]]]],[],[[0,null,!1,null,50405097723162,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,9906289422165856,!1,[[0,[1,0.1]]]]],[[72,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7341439091658841,!1,[[0,[5,[22,72,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[71,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9314133111520252,
!1,[[0,[5,[22,71,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[73,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x8d91f9c19400,!1,[[0,[5,[22,73,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5330378379479113,!1,[[0,[5,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8820031735026829,!1,[[0,[5,[22,58,"Bullet",
cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x9f9fa589a160d,!1,[[0,[5,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",71742576760304,!1,[[0,[5,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xe7f36884bf739,!1,[[0,[5,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x3dc73fe1b6831,!1,[[0,[5,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5871528138816956,!1,[[0,[5,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[74,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9104298130474604,!1,[[0,[5,[22,74,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[75,
cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9618227688827436,!1,[[0,[5,[22,75,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xd91a454a67374,!1,[[0,[5,[22,76,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,0xad798e6c6f57e,!1,[[1,[2,"main"]],[0,[0,-15]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x9245ddb8a77ff,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,6863149791720047,!1,[[11,"gamespeed"],[7,[0,2]]]]]]]],[0,null,!1,null,6037435288176153,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7607122955143518,!1,[[11,"Score"],[8,5],[7,[0,1E4]]]]],[],[[0,null,!1,null,9826702318998104,[[62,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,8920265316755858,!1]],[[62,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0xfa32c319f4493,!1,[[3,1]]],[62,cr.plugins_.Sprite.prototype.acts.AddInstanceVar,null,6430740122908582,!1,
[[10,0],[7,[0,100]]]],[74,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x92999bfc0d2d7,!1],[75,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xa2163ca2008ab,!1],[76,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xa8f8eb025cc19,!1],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,4920341002901793,!1,[[3,0]]],[55,cr.plugins_.Sprite.prototype.acts.Destroy,null,9991073175163678,!1],[-1,cr.system_object.prototype.acts.Wait,null,9217735535216652,!1,[[0,[0,2]]]],[30,cr.plugins_.Audio.prototype.acts.Play,
null,0xd175501ccf9b8,!1,[[2,["click4",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[66,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0xf143792cddc1a,!1,[[3,0]]],[67,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0x6e40450a0d781,!1,[[3,0]]],[68,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0x9ecc5d4f8987d,!1,[[3,0]]],[69,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0x463bb508ad551,!1,[[3,0]]],[70,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,
"LiteTween",0x6dbf69ea4bc50,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,381704837597897,!1,[[0,[1,0.7]]]],[66,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",4689843683024127,!1,[[3,1]]],[67,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",6638529799711915,!1,[[3,1]]],[68,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",4554109956583771,!1,[[3,1]]],[69,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0x615607cf33d02,!1,
[[3,1]]],[70,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",5306835521887893,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x6a2f8a1ea0942,!1,[[11,"gamepause"],[7,[0,1]]]]]]]],[0,null,!1,null,927451949826382,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,4793968481522653,!1,[[11,"Score"],[8,5],[7,[0,1E4]]]]],[],[[0,null,!1,null,9680125810927888,[[4,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,567605592234693,!1]],[[4,cr.behaviors.Bullet.prototype.acts.SetEnabled,
"Bullet",6440945483227,!1,[[3,1]]],[4,cr.plugins_.Sprite.prototype.acts.AddInstanceVar,null,4640286464114712,!1,[[10,0],[7,[0,100]]]],[74,cr.plugins_.Sprite.prototype.acts.Destroy,null,689200274175545,!1],[75,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x666a9173efb1c,!1],[76,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xd196fe12da5f2,!1],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,8179857371069008,!1,[[3,0]]],[55,cr.plugins_.Sprite.prototype.acts.Destroy,null,9208112130817766,
!1],[-1,cr.system_object.prototype.acts.Wait,null,5794046121909706,!1,[[0,[0,2]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,7545607585406897,!1,[[2,["click4",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[66,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",7311914426784708,!1,[[3,0]]],[67,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",9739798413441556,!1,[[3,0]]],[68,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0xa04d3f7a86c11,!1,[[3,0]]],[69,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,
"LiteTween",8378171681973519,!1,[[3,0]]],[70,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",7095755419257956,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,501082985956974,!1,[[0,[1,0.7]]]],[66,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0xdd94643de0f4b,!1,[[3,1]]],[67,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0xc245d58052f5d,!1,[[3,1]]],[68,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",8744240161891291,!1,
[[3,1]]],[69,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0x88bfa3c3b89c4,!1,[[3,1]]],[70,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",9114873040502332,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetVar,null,5834350330690335,!1,[[11,"gamepause"],[7,[0,1]]]]]]]],[0,null,!1,null,7255176954466029,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6475384615101626,!1,[[11,"gamepause"],[8,0],[7,[0,1]]]]],[[30,cr.plugins_.Audio.prototype.acts.Stop,
null,9165935240633964,!1,[[1,[2,"main"]]]],[72,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0x480c8b0e6299e,!1,[[3,0]]],[71,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0xca17375e7c1ef,!1,[[3,0]]],[73,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",6362117002630691,!1,[[3,0]]],[6,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",7636093615563256,!1,[[3,0]]],[58,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",6472964946693644,!1,[[3,0]]],[59,cr.behaviors.Bullet.prototype.acts.SetEnabled,
"Bullet",0x98502d7aae7ef,!1,[[3,0]]],[60,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",9058120081041704,!1,[[3,0]]],[61,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",90043778210415,!1,[[3,0]]],[14,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0x56e99a1e910ef,!1,[[3,0]]],[11,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",4776481064205324,!1,[[3,0]]],[74,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",8444298871570377,!1,[[3,0]]],[75,cr.behaviors.Bullet.prototype.acts.SetEnabled,
"Bullet",0xa25a2606c7313,!1,[[3,0]]],[76,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0xed639a8c6c94,!1,[[3,0]]],[74,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc5ae20f81d48d,!1],[75,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x833f1918acb3c,!1],[76,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x3c123af104a49,!1],[14,cr.plugins_.Sprite.prototype.acts.Destroy,null,8804586488764105,!1],[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,6684422786293071,!1]]],[0,null,!1,null,6149278617261576,
[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9993341590508968,!1,[[4,67]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,944371504004685,!1,[[11,"levels"],[7,[0,1]]]],[17,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,9076606224599700,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,7969508913607274,!1,[[6,"Level3"]]]]],[0,null,!1,null,0x7a7bbf28a7869,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9735981908999914,!1,[[4,68]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,
null,5737501214794753,!1]]],[0,null,!1,null,6181600456874064,[[69,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0xa0aae335c6e21,!1]],[],[[1,"url3",1,"https://www.twitter.com/intent/tweet?text= Completed Another Level of Shoot Angry Zombies. Try this Awesome Game bit.ly/1KyXW9c",!1,!1,0xfa237a8253978,!1],[0,null,!1,null,9626420095277176,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6832348366340434,!1,[[4,69]]]],[[25,cr.plugins_.Browser.prototype.acts.GoToURLWindow,
null,9666393717425788,!1,[[1,[23,"url3"]],[1,[2,"twitter"]]]]]]]],[0,null,!1,null,0xf2f23b4a557d6,[[70,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,9638422401927874,!1]],[],[[1,"url4",1,"https://www.facebook.com/sharer/sharer.php?u=http://online-free-stuff.com/saz/share.php",!1,!1,6652900369901328,!1],[0,null,!1,null,4728654364090154,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x8a639ea367772,!1,[[4,70]]]],[[25,cr.plugins_.Browser.prototype.acts.GoToURLWindow,
null,0x4e99f08bfeb5f,!1,[[1,[23,"url4"]],[1,[2,"facebook"]]]]]]]],[0,null,!1,null,9215550171787746,[[27,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,8478254915350063,!1]],[[27,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x3eebc62413ad7,!1]]],[0,null,!1,null,8087268083105178,[[87,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,8402514358511891,!1]],[[87,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc4d95c9e4f51d,!1]]],[0,null,!1,null,0x5cea6d666739b,
[[88,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,6943399850222812,!1]],[[88,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc42a3c3f28a41,!1]]],[0,null,!1,null,0xfc03c3ba5bc70,[[91,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,0x847f2abc568b9,!1]],[[91,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x722c0a4368461,!1]]]]],["Level3",[[0,null,!1,null,0xc7043e192cefa,[[24,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,0xcbbe0b1758f54,!1,
[[1,[2,"Spause"]]]]],[[23,cr.plugins_.Sprite.prototype.acts.SetVisible,null,668266653720093,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xbe2402528d515,!1,[[0,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.SetPaused,null,0x4027dbac60dc5,!1,[[1,[2,"main"]],[3,0]]]]],[0,null,!1,null,0x7aee04fe51460,[[24,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,7222422391141108,!1,[[1,[2,"Splay"]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0x68d2876a375c2,!1,
[[0,[1,1]]]],[23,cr.plugins_.Sprite.prototype.acts.SetVisible,null,9763139432034372,!1,[[3,0]]],[30,cr.plugins_.Audio.prototype.acts.SetPaused,null,422219919861991,!1,[[1,[2,"main"]],[3,1]]]]],[0,null,!1,null,0xcb2230fdf8ee4,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,5488327587185827,!1]],[]],[0,null,!1,null,6601745956076776,[[25,cr.plugins_.Browser.prototype.cnds.OnPageHidden,null,1,!1,!1,!1,6179378415889406,!1]],[[24,cr.plugins_.Function.prototype.acts.CallFunction,null,5101593093864498,
!1,[[1,[2,"Spause"]],[13]]]]],[0,null,!1,null,7592838747398197,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,4680468629263973,!1,[[4,23]]]],[[24,cr.plugins_.Function.prototype.acts.CallFunction,null,9070972559968828,!1,[[1,[2,"Splay"]],[13]]]]],[0,null,!1,null,8077187268264356,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x503e98a101560,!1,[[4,21]]]],[[30,cr.plugins_.Audio.prototype.acts.Stop,null,0x52759d4e65c8e,!1,[[1,[2,"main"]]]],[17,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,
null,7631024647959791,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,0xf8e1bb508fa7e,!1,[[6,"menu"]]]]],[0,null,!1,null,5504513808120672,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xae98d44718fa8,!1,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0xd3b209c2f2ac3,!1,[[0,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.SetPaused,null,494527312947846,!1,[[1,[2,"main"]],[3,0]]],[22,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,8310739578682719,!1,
[[3,1]]],[22,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8093337693789148,!1,[[3,1]]]]],[0,null,!1,null,0xeb9bc255999a6,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xf1839eb7701b2,!1,[[4,22]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0x45952bd2dd895,!1,[[0,[0,1]]]],[30,cr.plugins_.Audio.prototype.acts.SetPaused,null,7180452126030282,!1,[[1,[2,"main"]],[3,1]]],[22,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,9363112935329580,!1,[[3,0]]],[22,cr.plugins_.Sprite.prototype.acts.SetVisible,
null,623646758846959,!1,[[3,0]]]]],[0,null,!1,null,8192523645147491,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,6211341937147602,!1]],[[17,cr.plugins_.CJSAds.prototype.acts.PreloadFullscreen,null,5826591547827528,!1],[78,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6512411092466082,!1,[[0,[0,180]]]],[80,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9057868282043212,!1,[[0,[0,180]]]],[79,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",
5350642032572641,!1,[[0,[0,180]]]],[82,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0xc988176539e87,!1,[[1,[2,"saz"]],[7,[23,"levels"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8093683782186257,!1,[[11,"Score"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,6835186022912325,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8358309353780181,!1,[[11,"gamepause"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xf1dc75c003664,!1,[[11,"gamespeed"],
[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,9372886163568394,!1,[[0,[1,0.7]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,4975307990711536,!1,[[0,[0,0]]]]]],[0,null,!1,null,0x974088ceba297,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,8545570111287216,!1,[[4,92]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0xc007b4b84665d,!1,[[0,[1,1]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,8093213157959161,!1,[[2,["game-shoot",!1]],[3,1],[0,[0,
-20]],[1,[2,"main"]]]],[92,cr.behaviors.lunarray_LiteTween.prototype.acts.Reverse,"LiteTween",8447912586416875,!1,[[3,0]]]]],[0,null,!1,null,7060239183906983,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5577438316024421,!1,[[11,"playerchoose"],[8,0],[7,[0,1]]]]],[[62,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x61dea178498bb,!1]]],[0,null,!1,null,8355244390347988,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xb1cc31fe66117,!1,[[11,"playerchoose"],[8,0],[7,
[0,2]]]]],[[4,cr.plugins_.Sprite.prototype.acts.Destroy,null,8288209493644041,!1]]],[0,null,!1,null,7354797373922771,[[79,cr.plugins_.TiledBg.prototype.cnds.CompareX,null,0,!1,!1,!1,566946934481167,!1,[[8,3],[0,[7,[3,[20,79,cr.plugins_.TiledBg.prototype.exps.Width,!1,null]],[0,2]]]]]],[[79,cr.plugins_.TiledBg.prototype.acts.SetX,null,863580354874168,!1,[[0,[4,[20,79,cr.plugins_.TiledBg.prototype.exps.X,!1,null],[7,[20,79,cr.plugins_.TiledBg.prototype.exps.Width,!1,null],[0,2]]]]]]]],[0,null,!1,null,
5828021273720821,[[78,cr.plugins_.TiledBg.prototype.cnds.CompareX,null,0,!1,!1,!1,0x7619dc1aeaae3,!1,[[8,3],[0,[7,[3,[20,78,cr.plugins_.TiledBg.prototype.exps.Width,!1,null]],[0,2]]]]]],[[78,cr.plugins_.TiledBg.prototype.acts.SetX,null,9775146275737884,!1,[[0,[4,[20,78,cr.plugins_.TiledBg.prototype.exps.X,!1,null],[7,[20,78,cr.plugins_.TiledBg.prototype.exps.Width,!1,null],[0,2]]]]]]]],[0,null,!1,null,0xf968b3353004b,[[80,cr.plugins_.TiledBg.prototype.cnds.CompareX,null,0,!1,!1,!1,7575818642198096,
!1,[[8,3],[0,[7,[3,[20,80,cr.plugins_.TiledBg.prototype.exps.Width,!1,null]],[0,2]]]]]],[[80,cr.plugins_.TiledBg.prototype.acts.SetX,null,0x920d05681b55e,!1,[[0,[4,[20,80,cr.plugins_.TiledBg.prototype.exps.X,!1,null],[7,[20,80,cr.plugins_.TiledBg.prototype.exps.Width,!1,null],[0,2]]]]]]]],[0,null,!1,null,0xbe6bd5f3ecdad,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0xee42e7e2511f,!1]],[[-1,cr.system_object.prototype.acts.AddVar,null,7519018712317652,!1,[[11,"timer"],[7,[19,cr.system_object.prototype.exps.dt]]]]]],
[0,null,!0,null,5270788544888611,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7214681518750812,!1,[[4,32]]],[2,cr.plugins_.Keyboard.prototype.cnds.OnKey,null,1,!1,!1,!1,907341315969098,!1,[[9,38]]]],[[4,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",0xc71db06aa98ff,!1,[[3,2]]],[62,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",5523184351361596,!1,[[3,2]]],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8415754134507171,!1,[[3,1]]],[55,
cr.plugins_.Sprite.prototype.acts.StartAnim,null,0x46bb1271135ff,!1,[[3,1]]],[32,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x80ab1dc3c4712,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,7891904221035157,!1,[[0,[1,0.2]]]],[32,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xe4ea5e1a2fa64,!1,[[3,1]]]]],[0,null,!0,null,7199152051241881,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x949ab54932de1,!1,[[4,32]]],[2,cr.plugins_.Keyboard.prototype.cnds.OnKey,null,
1,!1,!1,!1,0xf8f1477cd1b15,!1,[[9,38]]]],[[15,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",0xea1f8f82a0b75,!1,[[3,2]]],[63,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",8483685243882212,!1,[[3,2]]]]],[0,null,!1,null,821030563804892,[[4,cr.behaviors.Platform.prototype.cnds.IsJumping,"Platform",0,!1,!1,!1,0x4f5ad9a6be339,!1]],[[4,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x96c26e3992d21,!1,[[1,[2,"jump"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,
5574524646472012,!1,[[0,[0,1]]]],[4,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xcefeab1271c95,!1,[[1,[2,"run"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.StopAnim,null,6177597118166096,!1],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7594965361286205,!1,[[3,0]]]]],[0,null,!1,null,9298753093276336,[[62,cr.behaviors.Platform.prototype.cnds.IsJumping,"Platform",0,!1,!1,!1,302987715579025,!1]],[[62,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6821819412944872,!1,[[1,[2,"jump"]],[3,
1]]],[-1,cr.system_object.prototype.acts.Wait,null,0x6cd4e726dc306,!1,[[0,[0,1]]]],[62,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x859569da92327,!1,[[1,[2,"run"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.StopAnim,null,0xaab2f22f7ded4,!1],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,null,9762497244187828,!1,[[3,0]]]]],[0,null,!1,null,8755114464177842,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xe7722223369e5,!1,[[11,"timer"],[8,5],[7,[0,15]]]]],[],[[0,null,!1,null,
6298654584213291,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xcad172ba66e4a,!1,[[0,[0,14]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x5cbcf94be1627,!1,[[4,11],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,400],[0,200]]]]]]]]]],[0,null,!1,null,0xa29a785408cb9,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x502261cb88829,!1,[[11,"timer"],[8,5],[7,[0,5]]]]],[[40,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8084325184741494,
!1,[[3,0]]],[40,cr.plugins_.Sprite.prototype.acts.Destroy,null,9009350655977372,!1]]],[0,null,!1,null,0x98d3f47d9fa37,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9860623766666284,!1,[[11,"timer"],[8,5],[7,[0,25]]]]],[],[[0,null,!1,null,4621704832340994,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,7643278857041571,!1,[[0,[0,25]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x539780bc90313,!1,[[4,14],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,
[[0,400],[0,250]]]]]]]]]],[0,null,!1,null,7398957007300433,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x6e23c6f1fbf5,!1,[[11,"timer"],[8,5],[7,[0,1]]]]],[],[[0,null,!1,null,0x9938c08ec8d8d,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,32645314637442,!1,[[0,[0,4]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x8345f99deff1b,!1,[[4,6],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,300],[0,250]]]]]]]],[0,null,!1,null,8388460691178598,
[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,7043461689377283,!1,[[0,[0,6]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,7412358019832562,!1,[[4,58],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,300],[0,250]]]]]]]],[0,null,!1,null,0x67cc966d13453,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,4794045174627689,!1,[[0,[0,9]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,4847655784721107,!1,[[4,59],[5,[2,"Game"]],[0,[0,
1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,300],[0,250]]]]]]]],[0,null,!1,null,0xd2b7659c5be25,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,4661435814940504,!1,[[0,[0,11]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,6296516324955496,!1,[[4,60],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,300],[0,250]]]]]]]],[0,null,!1,null,0x86532c190a50b,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,6280240552025794,!1,[[0,[0,
13]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x86c147a1ebc1e,!1,[[4,61],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,300],[0,250]]]]]]]]]],[0,null,!1,null,9291838312246368,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x5570070ae9ba0,!1,[[11,"timer"],[8,5],[7,[0,1]]]]],[],[[0,null,!1,null,0xb90776625e1,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xd861d99051bdf,!1,[[0,[0,15]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,
null,9004664404816708,!1,[[4,6],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]],[0,null,!1,null,6359622382117172,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,6379073598507422,!1,[[0,[1,15.1]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,4512683444012469,!1,[[4,58],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]],[0,null,!1,null,559307312569392,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xce78fde62e381,!1,[[0,[1,15.2]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,
null,0x8bc03a05195a5,!1,[[4,59],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]],[0,null,!1,null,0x4007a01079111,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,6783999429598729,!1,[[0,[1,15.3]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,7691446104480314,!1,[[4,60],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]],[0,null,!1,null,9974477855908688,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x61403b46265a1,!1,[[0,[1,15.4]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,
null,0x3c705411bc520,!1,[[4,61],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]]]],[0,null,!1,null,9763497934151638,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7948348222973973,!1,[[4,33]]]],[],[[0,null,!1,null,8274833505832901,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,4614590935676933,!1,[[0,[1,0.6]]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,4641507874324472,!1,[[4,31],[5,[0,0]],[7,[0,0]]]],[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xcb41ca71ded8,
!1,[[4,31],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xe091529a9d9a8,!1,[[2,["2",!1]],[3,0],[0,[0,0]],[1,[2,"shoot"]]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,4535669579854653,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,4973439454017891,!1,[[0,[1,0.2]]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6821851249078525,!1,[[3,1]]]]]]],[0,null,!1,null,0x852c617510549,[[2,cr.plugins_.Keyboard.prototype.cnds.OnKey,null,1,!1,!1,!1,0xfa595609d7aa9,
!1,[[9,32]]]],[],[[0,null,!1,null,313837304032983,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,7502690686698017,!1,[[0,[1,0.6]]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x9eb9ccf87219e,!1,[[4,31],[5,[0,0]],[7,[0,0]]]],[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,569281068983146,!1,[[4,31],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,400856922138004,!1,[[2,["2",!1]],[3,0],[0,[0,0]],[1,[2,"shoot"]]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,
null,0xacf990f89f813,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,420736520611957,!1,[[0,[1,0.2]]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x43602a8fcedb4,!1,[[3,1]]]]]]],[0,null,!1,null,8122867352715464,[[31,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x6f7fdfdb4b53d,!1,[[4,81]]]],[[81,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,5916094953902668,!1,[[10,0],[7,[0,0]]]],[31,cr.plugins_.Sprite.prototype.acts.Destroy,null,9232670621649294,!1]]],
[0,null,!1,null,9807466453375292,[[31,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9622891524434682,!1,[[4,10]]]],[[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xb66c3c426adb3,!1,[[10,0],[7,[0,0]]]],[31,cr.plugins_.Sprite.prototype.acts.Destroy,null,316051262130521,!1]]],[0,null,!1,null,6247482810151745,[[31,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7226234100771351,!1,[[4,76]]]],[[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,5911914273422829,
!1,[[10,0],[7,[0,0]]]],[31,cr.plugins_.Sprite.prototype.acts.Destroy,null,9415678200824020,!1]]],[0,null,!1,null,0xb8b23cc895634,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xd976939b1fc40,!1,[[4,11]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xbf2ab5bb28c92,!1]]],[0,null,!1,null,5231412506759031,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xc37b16c0d3299,!1,[[4,58]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xbb0ff2467caaf,!1]]],[0,
null,!1,null,0x7634b17e3e5bc,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8814216152578712,!1,[[4,59]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x9d5b4b4306e41,!1]]],[0,null,!1,null,8512342012093081,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9734667159569598,!1,[[4,60]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x4edf216c88734,!1]]],[0,null,!1,null,8772313222080325,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,
7481782547862772,!1,[[4,61]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,8239082242896663,!1]]],[0,null,!1,null,0x3b43b97915134,[[58,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7998274779163102,!1,[[4,59]]]],[[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x9eb4a500f4d3f,!1]]],[0,null,!1,null,0xe44ce030a48a0,[[58,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4536485006415862,!1,[[4,60]]]],[[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xa9749469d0f59,
!1]]],[0,null,!1,null,0x6b1d202c119d5,[[59,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xaff3c419460f3,!1,[[4,60]]]],[[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,942781452934878,!1]]],[0,null,!1,null,6229700377098578,[[60,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9074041352499452,!1,[[4,61]]]],[[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x716770e380c86,!1]]],[0,null,!1,null,5836657657030027,[[81,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,
0,!1,!1,!0,0xea00bf658f6f7,!1,[[4,76]]]],[[76,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x4ba2be9691662,!1]]],[0,null,!1,null,0xf2f5d12ff8ca7,[[76,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8915703953952492,!1,[[4,10]]]],[[10,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x8783da389b943,!1]]],[0,null,!1,null,4834043215050476,[[81,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,331585919841105,!1,[[4,10]]]],[[81,cr.plugins_.Sprite.prototype.acts.Destroy,null,
6939833354220929,!1]]],[0,null,!1,null,804119018658167,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xb3fd573fa4a15,!1,[[11,"timer"],[8,5],[7,[0,5]]]]],[],[[0,null,!1,null,6461642758040616,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,6912358440804103,!1,[[0,[0,5]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,8248997629893196,!1,[[4,81],[5,[2,"Game"]],[0,[0,1260]],[0,[0,575]]]]]]]],[0,null,!1,null,320181289459869,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,7474794695025467,!1,[[11,"timer"],[8,5],[7,[0,5]]]]],[],[[0,null,!1,null,0xba98ba969055b,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xed9ab4ba4e42d,!1,[[0,[1,7.5]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xbbb2fcc3ace61,!1,[[4,10],[5,[2,"Game"]],[0,[0,1260]],[0,[0,550]]]]]]]],[0,null,!1,null,0x5bb9d3aa37745,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x6b99e6d84ae9b,!1,[[11,"timer"],[8,5],[7,[0,5]]]]],[],[[0,null,!1,null,0xae037a89ea558,
[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x47abb92788d10,!1,[[0,[1,9.5]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xdc90d2a2d65ed,!1,[[4,76],[5,[2,"Game"]],[0,[0,1260]],[0,[0,585]]]]]]]],[0,null,!1,null,6630061096913449,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8250903835629412,!1,[[4,6]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,5452990661246587,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,9930774185863172,
!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xc2525d929cee7,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9452567220480388,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x62e317064043f,!1,[[0,[1,0.5]]]],[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,5161133918212799,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0x652202cb610e,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0xfc883ad215bcb,
[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x4985f5e9aeef3,!1,[[4,58]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x57a3556a9e6a6,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xb2111937472c8,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",7727505937175179,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5060842134134507,!1,[[0,[0,800]]]],[-1,
cr.system_object.prototype.acts.Wait,null,4790279914590802,!1,[[0,[1,0.5]]]],[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,5436743446890249,!1],[-1,cr.system_object.prototype.acts.AddVar,null,718705153477512,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,421987267452697,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8532042660550873,!1,[[4,59]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x71c54463a46de,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,
null,5747047449655529,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",917883739200671,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6164067515996316,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xf4b8e209f2383,!1,[[0,[1,0.5]]]],[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x8996ecc84ef8c,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0x98ad0dc40e239,!1,[[11,"Score"],[7,[0,75]]]]]],
[0,null,!1,null,8116955551728308,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xa44e74ca844a3,!1,[[4,60]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,6740309232444786,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,888146724360271,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9373814664608108,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",798842342226942,
!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,7550584230390433,!1,[[0,[1,0.5]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,7986541630675341,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0xe4c2e08dc2674,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,8154686607882244,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xb928de01f335e,!1,[[4,61]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x6c9af3ae2f4ec,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,
null,0xdddbe42ec72e8,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9164503400375748,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xd7ad95ba00fff,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,5876961993442974,!1,[[0,[1,0.5]]]],[61,cr.plugins_.Sprite.prototype.acts.Destroy,null,7550908347034395,!1],[-1,cr.system_object.prototype.acts.AddVar,null,4874251459783364,!1,[[11,"Score"],[7,[0,
75]]]]]],[0,null,!1,null,0xc99f8d78e3c5,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8776201774399324,!1,[[4,6]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,721536575707356,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,9332964366067886,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",908024644019041,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",
0x7586fc5bf3049,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,5285116063215179,!1,[[0,[1,0.5]]]],[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,7726903646622448,!1],[-1,cr.system_object.prototype.acts.AddVar,null,642932831522957,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0xe734424a6f6a2,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6195267626245529,!1,[[4,58]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,6722139091496688,!1,[[4,7],[5,[0,0]],[7,
[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,9884079920550986,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9167867843753700,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x848f8356865f,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,8578853008033214,!1,[[0,[1,0.5]]]],[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xe875f4c6d050e,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,7249864208894863,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0x3d1f55a2c70d1,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,543439868426408,!1,[[4,59]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,5568019837078256,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,339270667276616,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",332622576481404,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",341531843944345,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xbf09e32b8fb58,!1,[[0,[1,0.5]]]],[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,6654759147264116,!1],[-1,cr.system_object.prototype.acts.AddVar,null,596162005343793,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,5704202592054548,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x439f060ee2047,!1,[[4,60]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xf26e1b17ef322,!1,[[4,7],[5,[0,
0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,7604252984607572,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",7996066012538544,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x5371a1c0b1bc4,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,8585848333416685,!1,[[0,[1,0.5]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,7676866009521853,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,679068267870544,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,8081902006281771,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6755625992095428,!1,[[4,61]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,8146500875751641,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,8973179763978939,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6173091519899284,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",6674881041452564,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,7368161625436111,!1,[[0,[1,0.5]]]],[61,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x563425d36a61f,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0x9e5bd59b8dc31,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,5109727672388769,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8366419803547638,!1,[[4,6]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xa25117479f4b,!1,[[4,7],[5,[0,
0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xbdfad2c4e295b,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9114596615867046,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8272556310668656,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,9074009837103948,!1,[[0,[1,0.5]]]],[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x6725b05818e4b,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,5350848053793921,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,8531019164495412,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7033090898240612,!1,[[4,58]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,421107634902059,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,6770872902034683,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xc7d53906ed2ac,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0xc5705322f5cb9,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xe122ee458fa66,!1,[[0,[1,0.5]]]],[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,5986263555275416,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0xfae323ed325c9,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0x9fa254b3a6daf,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4750647769817771,!1,[[4,59]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,5991117665372452,!1,[[4,7],[5,
[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,6564187561114718,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",8566138272318626,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9672335896639146,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xe4ad8f0e93c00,!1,[[0,[1,0.5]]]],[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x9c84b9628a89a,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,9565569108210178,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0x873e4999de2c1,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5455716640299672,!1,[[4,60]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,6311431362380664,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,8504155384432269,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xcce1397cd309e,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0x66176d5ea2b6a,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,8267439855197042,!1,[[0,[1,0.5]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xfe78db6e95b6e,!1],[-1,cr.system_object.prototype.acts.AddVar,null,8463616324619229,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,6459460005014368,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xa12deadc2021c,!1,[[4,61]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x7ddbc76effc22,!1,[[4,7],[5,
[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,6264133746354062,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x463195c6cff7f,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5396662389913043,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,5319685165447673,!1,[[0,[1,0.5]]]],[61,cr.plugins_.Sprite.prototype.acts.Destroy,null,7563241948358694,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,8283319735968741,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,5566409776687836,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8157112650608753,!1,[[4,6]]]],[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,6440763244842524,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,6239112332121586,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x845358439e87a,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0xef8ae0d6d084c,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,5529026440806021,!1,[[0,[1,0.5]]]],[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,5997310975484696,!1],[-1,cr.system_object.prototype.acts.AddVar,null,6225142031990298,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,6335219238715701,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xf5a98c0e00a25,!1,[[4,58]]]],[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xe63804e9b5d0e,!1,[[4,7],[5,
[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,8779306674394415,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x8350a1ac5b4f,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9349266762845632,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,4871570607401784,!1,[[0,[1,0.5]]]],[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,5400421490182699,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,6320405482561284,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0x3a70192a71b28,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5832328816849603,!1,[[4,59]]]],[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,7349870727616173,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,9201767675974248,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9128631810014574,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",9295027856914782,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xe9ed64bf3800e,!1,[[0,[1,0.5]]]],[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc8f9d831de611,!1],[-1,cr.system_object.prototype.acts.AddVar,null,5340514337751404,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,6268695855781453,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x4e527d38770bc,!1,[[4,60]]]],[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xe34b3a51f3ecd,!1,[[4,7],[5,
[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,5460730569806673,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9264071674803328,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5465681964385022,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x73c41c94f582,!1,[[0,[1,0.5]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,9938203274705976,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,7661028713857534,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,6673165493478056,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x705996cb4d247,!1,[[4,61]]]],[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,4576269738202774,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,5919269560678017,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x6c4b07a569d53,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0xc36fc8eecbe8b,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x45d65c126bce2,!1,[[0,[1,0.5]]]],[61,cr.plugins_.Sprite.prototype.acts.Destroy,null,916842890738094,!1],[-1,cr.system_object.prototype.acts.AddVar,null,9662398375096400,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0xe6980457ac7e,[[7,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,5333608171861925,!1]],[[7,cr.plugins_.Sprite.prototype.acts.Destroy,null,4577378491971336,!1]]],[0,null,!1,
null,352351167716502,[[13,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,0xc39ecdb7a27da,!1]],[[13,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb6fab5d588ab0,!1]]],[0,null,!1,null,6456823287221615,[[12,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,4848006896702161,!1]],[[12,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xa89731df1e01,!1]]],[0,null,!1,null,6363611105943827,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,375324117877509,
!1]],[[3,cr.plugins_.Text.prototype.acts.SetText,null,0xd0ce911711c66,!1,[[7,[10,[2,": "],[23,"Score"]]]]]]],[0,null,!1,null,5808808946255291,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7586327419653112,!1,[[4,81]]]],[[4,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,0xb0b1f7dc64929,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,9177259239941992,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xf22d9088d06a0,!1,[[4,10]]]],[[4,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
null,9069031395906348,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,6089400199723784,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xbb79f8ebc5683,!1,[[4,76]]]],[[4,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,9347043445622060,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,6205856957743473,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8068748161325445,!1,[[4,81]]]],[[62,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,6552756648497508,!1,[[10,0],[7,[0,1]]]]]],
[0,null,!1,null,0x96dc3d5ad693a,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xaa0556e81117f,!1,[[4,10]]]],[[62,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,0x3f00d1a44d401,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,0xbf9df37c9843f,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4704945842202303,!1,[[4,76]]]],[[62,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,8838134889208732,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,7307027608281255,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,0x70f36e14c5393,!1,[[4,11]]]],[[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,5872570496161823,!1],[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x59b37ccbd9678,!1,[[4,13],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,6717690844099135,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",354584285838153,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x7ac489cb775ea,!1,[[0,
[0,800]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",5151411158745824,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x7c3851a16e2ab,!1,[[0,[0,800]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x4acfa2f2d89ac,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9746953444295596,!1,[[0,[0,800]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",8851201811338293,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",5906828844223605,!1,[[0,[0,800]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6912358128562622,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x3a9626e3cfde6,!1,[[0,[0,800]]]],[81,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,9515402141083244,!1,[[10,0],[7,[0,0]]]],[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,4874305968890712,!1,[[10,0],[7,[0,0]]]],[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,5575121146589668,
!1,[[10,0],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,9221391264698848,!1,[[11,"Score"],[7,[0,500]]]],[-1,cr.system_object.prototype.acts.Wait,null,7681121867818024,!1,[[0,[1,0.5]]]]]],[0,null,!1,null,0x9603a2ecdf34c,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9245516167679286,!1,[[4,11]]]],[[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xf152167f02cc5,!1],[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xfbec310cf147e,!1,[[4,13],[5,[0,0]],[7,[0,0]]]],
[30,cr.plugins_.Audio.prototype.acts.Play,null,691487938123973,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x97193c52729ed,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x588d195cba474,!1,[[0,[0,800]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",7149666403282275,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4863724644654551,!1,[[0,[0,800]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
"Bullet",0xeb06046946dd5,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xf90ea788d835c,!1,[[0,[0,800]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x456de29dbfaf7,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6662070704942357,!1,[[0,[0,800]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6065720843668706,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9158142400495294,!1,
[[0,[0,800]]]],[81,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,8407151878593622,!1,[[10,0],[7,[0,0]]]],[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x3cd72c51066be,!1,[[10,0],[7,[0,0]]]],[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,7429277119142586,!1,[[10,0],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,401880038350103,!1,[[11,"Score"],[7,[0,500]]]],[-1,cr.system_object.prototype.acts.Wait,null,5213887302940572,!1,[[0,[1,0.5]]]]]],[0,null,!1,null,
0x5ff1d813ea8c2,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x64b1561383e4a,!1,[[4,11]]]],[[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x5fe279f4708d9,!1],[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xc34d6149dbd66,!1,[[4,13],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,6002182921970355,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",998470332289644,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",787967868579792,!1,[[0,[0,800]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x8283b4cba90e0,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8299200364778261,!1,[[0,[0,800]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xe0eea389c7043,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8173700969031396,!1,[[0,[0,800]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xcf2c3b12f122,
!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xb0a3b5b216606,!1,[[0,[0,800]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",5827094056037173,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x60eded6d089a5,!1,[[0,[0,800]]]],[81,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,5497290829851127,!1,[[10,0],[7,[0,0]]]],[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,937599135037576,!1,[[10,0],[7,[0,0]]]],[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
null,0xe6154b8f547e5,!1,[[10,0],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,805309276475065,!1,[[11,"Score"],[7,[0,500]]]],[-1,cr.system_object.prototype.acts.Wait,null,4785333411596034,!1,[[0,[1,0.5]]]]]],[0,null,!1,null,7382667410132225,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4940100227046949,!1,[[4,11]]]],[[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xefc67718f5bb4,!1],[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x739b442581ea0,!1,[[4,13],
[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0x694a6826f8656,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",8139843444220651,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7275656580402989,!1,[[0,[0,800]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",5871143901125222,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8265105274563533,!1,[[0,
[0,800]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x877be2d19685a,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x6517a697a77bb,!1,[[0,[0,800]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xca386bc6b23b1,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5009789691744312,!1,[[0,[0,800]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x74c7b20b43d4e,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",6070397879040166,!1,[[0,[0,800]]]],[81,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,9693453948266912,!1,[[10,0],[7,[0,0]]]],[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,5498743082247224,!1,[[10,0],[7,[0,0]]]],[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,9264309744221734,!1,[[10,0],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,839033463128012,!1,[[11,"Score"],[7,[0,500]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x5362f6039c08d,!1,[[0,
[1,0.5]]]]]],[0,null,!1,null,9980899016819908,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,692994337140299,!1,[[4,14]]]],[[14,cr.plugins_.Sprite.prototype.acts.Destroy,null,5408648334531507,!1],[30,cr.plugins_.Audio.prototype.acts.Play,null,6396319954989929,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,9370397322554066,!1,[[4,15],[5,[0,0]],[7,[0,0]]]],[15,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,524721436154856,!1,[[3,
1]]],[15,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x7101687718445,!1,[[3,1]]],[4,cr.plugins_.Sprite.prototype.acts.SetVisible,null,9960865101825560,!1,[[3,0]]],[4,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0x7204a47bbad32,!1,[[3,0]]]]],[0,null,!1,null,5318119416585273,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,537450927803993,!1,[[4,14]]]],[[14,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xa8541728c7725,!1],[30,cr.plugins_.Audio.prototype.acts.Play,null,
0x625785dba2982,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x6f864709596ce,!1,[[4,63],[5,[0,0]],[7,[0,0]]]],[63,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,5561718579218779,!1,[[3,1]]],[63,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6891374159889558,!1,[[3,1]]],[62,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x6e39206b5e421,!1,[[3,0]]],[62,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0xd398b97ba1461,!1,[[3,0]]]]],[0,
null,!1,null,0x3e87da3b41386,[[15,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,9824468943093,!1]],[[55,cr.plugins_.Sprite.prototype.acts.StopAnim,null,430209871027326,!1],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8394964329041424,!1,[[3,0]]],[4,cr.plugins_.Sprite.prototype.acts.SetVisible,null,9897771293250128,!1,[[3,0]]],[4,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0x48bd0aeb6f516,!1,[[3,0]]],[4,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x8e629a16c8cf4,
!1],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,531428289903395,!1,[[3,0]]],[36,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xd4d0a4ae0815d,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,6581373545837734,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7408735688469483,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,587569318436684,!1,[[0,[0,10]]]],[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,6098475813456454,!1,[[4,4],[5,[0,0]],
[7,[0,0]]]],[15,cr.plugins_.Sprite.prototype.acts.Destroy,null,7321926036486294,!1],[15,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0x43f201724b162,!1,[[3,0]]],[15,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8015001659510605,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0x825fe05126114,!1,[[3,1]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x867e91fb4d3fb,!1,[[3,1]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x5e191106d5c05,!1,[[3,1]]],
[36,cr.plugins_.Sprite.prototype.acts.SetVisible,null,752513399563571,!1,[[3,1]]]]],[0,null,!1,null,5461319951157736,[[63,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,310176173720797,!1]],[[55,cr.plugins_.Sprite.prototype.acts.StopAnim,null,8111810223229048,!1],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xc00b13f30f57d,!1,[[3,0]]],[62,cr.plugins_.Sprite.prototype.acts.SetVisible,null,996784702571393,!1,[[3,0]]],[62,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0xae5d155a11b3a,
!1,[[3,0]]],[62,cr.plugins_.Sprite.prototype.acts.Destroy,null,4963382571497316,!1],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,9748526342795564,!1,[[3,0]]],[36,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8277646020506796,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0xb68d97b758c9c,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xc6c534707af4c,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,0xee9fb95ddf484,!1,[[0,[0,10]]]],[63,cr.plugins_.Sprite.prototype.acts.Spawn,
null,8628181805035487,!1,[[4,62],[5,[0,0]],[7,[0,0]]]],[63,cr.plugins_.Sprite.prototype.acts.Destroy,null,9208955928920192,!1],[63,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0x9ed40d7f58bc3,!1,[[3,0]]],[63,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7239210129655841,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,8253308196800792,!1,[[3,1]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6636396262628415,!1,[[3,1]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,
null,577412869469046,!1,[[3,1]]],[36,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8494422844344018,!1,[[3,1]]]]],[0,null,!1,null,6180632766834238,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9704640932112620,!1,[[4,81]]]],[[81,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,7210215970934125,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,8953699767665947,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5896035719721358,!1,[[4,10]]]],[[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
null,0xe78c95b02447a,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,0xeb157d1483f3c,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xa19f037b72a9e,!1,[[4,76]]]],[[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x40e05b3c6e8d9,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,0xdddd098c03621,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8492795251042085,!1,[[4,81]]]],[[81,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,300828288561279,!1,[[10,0],[7,[0,0]]]]]],
[0,null,!1,null,6739565327364154,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8702626242999462,!1,[[4,10]]]],[[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xaeadda8db550c,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,8432869773107177,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5830332970341908,!1,[[4,76]]]],[[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,8231096943229447,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,9553269400065246,[[81,
cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,9866669746062812,!1,[[10,0],[8,0],[7,[0,0]]]]],[[81,cr.plugins_.Sprite.prototype.acts.Destroy,null,4511413802318697,!1],[30,cr.plugins_.Audio.prototype.acts.Play,null,0x7192c35bb0e4d,!1,[[2,["1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[81,cr.plugins_.Sprite.prototype.acts.Spawn,null,5995710180700184,!1,[[4,91],[5,[0,0]],[7,[0,0]]]]]],[0,null,!1,null,0xa6a2107c2922d,[[10,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,
!1,5248163540867243,!1,[[10,0],[8,0],[7,[0,0]]]]],[[10,cr.plugins_.Sprite.prototype.acts.Destroy,null,4633482934336846,!1],[30,cr.plugins_.Audio.prototype.acts.Play,null,471519373903463,!1,[[2,["1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[10,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xcdb45ca550dad,!1,[[4,87],[5,[0,0]],[7,[0,0]]]]]],[0,null,!1,null,0xb0e6d442fcad5,[[76,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,7727553863551266,!1,[[10,0],[8,0],[7,[0,0]]]]],[[76,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0x586593b52d024,!1],[30,cr.plugins_.Audio.prototype.acts.Play,null,9306078984682268,!1,[[2,["1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[76,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x9959c2a02d3d3,!1,[[4,27],[5,[0,0]],[7,[0,0]]]]]],[0,null,!1,null,408546250780486,[[4,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,0x6ac44f737e97a,!1,[[10,0],[8,3],[7,[0,0]]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,9851593635653642,!1,[[4,26],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,
null,5336896100933057,!1,[[2,["1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[4,cr.plugins_.Sprite.prototype.acts.Destroy,null,939070991190826,!1],[-1,cr.system_object.prototype.acts.Wait,null,4785643020589236,!1,[[0,[0,2]]]],[30,cr.plugins_.Audio.prototype.acts.Stop,null,0x74ce3962977df,!1,[[1,[2,"main"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7001162777113833,!1,[[11,"gamespeed"],[7,[0,0]]]],[17,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,0x8827fcd76e7b8,!1],[-1,cr.system_object.prototype.acts.GoToLayout,
null,6938674789623283,!1,[[6,"menu"]]]]],[0,null,!1,null,5704758790469478,[[62,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,6079515206650805,!1,[[10,0],[8,3],[7,[0,0]]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xf2612bff6d851,!1,[[4,65],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xc73da9f7a0642,!1,[[2,["1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[62,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xde1852f9fbbc1,!1],[-1,cr.system_object.prototype.acts.Wait,
null,6740548815721061,!1,[[0,[0,2]]]],[30,cr.plugins_.Audio.prototype.acts.Stop,null,4848892348013124,!1,[[1,[2,"main"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x62042987bb8e1,!1,[[11,"gamespeed"],[7,[0,0]]]],[17,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,0xd99e63356923,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x578f281e789be,!1,[[6,"menu"]]]]],[0,null,!1,null,4951043696857336,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,834429081679138,!1,[[11,
"Score"],[8,5],[7,[0,500]]]]],[],[[0,null,!1,null,8397719548384018,[[-1,cr.system_object.prototype.cnds.TriggerOnce,null,0,!1,!1,!1,9899302603656476,!1]],[[-1,cr.system_object.prototype.acts.AddVar,null,9505634548339216,!1,[[11,"gamespeed"],[7,[0,1]]]]]]]],[0,null,!1,null,0xe94a495ed9fb5,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xfaa4e72b1f2bc,!1,[[11,"gamespeed"],[8,0],[7,[0,1]]]]],[],[[0,null,!1,null,7243138318954318,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,
!1,5008394716641431,!1,[[0,[1,0.1]]]]],[[79,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",365314596210272,!1,[[0,[4,[22,79,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[78,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xcbaf5291c9297,!1,[[0,[4,[22,78,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[80,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x83921f0a82269,!1,[[0,[4,[22,80,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,
null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xe6649b074dabc,!1,[[0,[4,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6773675407039445,!1,[[0,[4,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7390168207899731,!1,[[0,[4,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0xbc8701004a0f9,!1,[[0,[4,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7909914959974673,!1,[[0,[4,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xefa3a361530a3,!1,[[0,[4,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7285908968601643,
!1,[[0,[4,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5399071121849025,!1,[[0,[4,[22,81,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9851966780168048,!1,[[0,[4,[22,10,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xef9cef22ef543,!1,[[0,[4,[22,76,"Bullet",
cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,6416297939594336,!1,[[1,[2,"main"]],[0,[0,-15]]]],[-1,cr.system_object.prototype.acts.Wait,null,9084314759742040,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xc32489ad0b3fe,!1,[[11,"gamespeed"],[7,[0,2]]]]]]]],[0,null,!1,null,5210810010692426,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,950214298873879,!1,[[11,"gamespeed"],[8,0],[7,[0,2]]]]],[[79,
cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5902019025810342,!1,[[0,[0,400]]]],[78,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x7a402f1fced2e,!1,[[0,[0,200]]]],[80,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9053830836675982,!1,[[0,[0,550]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x39c15f523cc17,!1,[[0,[0,400]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xf45f4d4f6cf6d,!1,[[0,[0,400]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",
9032620419612224,!1,[[0,[0,400]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xd97f04d94ac24,!1,[[0,[0,400]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xe1450bed973c7,!1,[[0,[0,400]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8941704927495598,!1,[[0,[0,400]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xa00d7e397f937,!1,[[0,[0,400]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4833257295463199,!1,[[0,[0,600]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",7786454957790341,!1,[[0,[0,600]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9895206217983336,!1,[[0,[0,600]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x9c8fe25e2cb4f,!1,[[11,"gamespeed"],[7,[0,3]]]],[-1,cr.system_object.prototype.acts.Wait,null,8569933662812626,!1,[[0,[0,10]]]]]],[0,null,!1,null,650760164034456,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,4916997478525038,!1,[[11,"gamespeed"],[8,0],[7,[0,3]]]]],[],[[0,null,!1,null,9601046038380180,
[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,6047251454680435,!1,[[0,[1,0.1]]]]],[[79,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xae9f2dfce48bd,!1,[[0,[4,[22,79,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[78,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xe063d66e27c92,!1,[[0,[4,[22,78,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[80,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xb6a06cc281ae5,!1,[[0,[4,[22,
80,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x8cd601e5d7a47,!1,[[0,[4,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9088281163169696,!1,[[0,[4,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xc11ca6e23d903,!1,[[0,[4,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",859548123782324,!1,[[0,[4,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",38452735153128,!1,[[0,[4,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8125013514432828,!1,[[0,[4,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0xc6bd2528758f9,!1,[[0,[4,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x39ffe9430b771,!1,[[0,[4,[22,81,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5863557164096654,!1,[[0,[4,[22,10,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8922452411569885,
!1,[[0,[4,[22,76,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,5795289715736349,!1,[[1,[2,"main"]],[0,[0,-10]]]],[-1,cr.system_object.prototype.acts.Wait,null,8034341029151531,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,4815379473119662,!1,[[11,"gamespeed"],[7,[0,4]]]]]]]],[0,null,!1,null,0xdf802641a87a8,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xd218992125d54,!1,[[11,"gamespeed"],
[8,0],[7,[0,4]]]]],[[79,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x5efd01cfedb9a,!1,[[0,[0,500]]]],[78,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xc62eb6e2dd977,!1,[[0,[0,300]]]],[80,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9245490081450752,!1,[[0,[0,650]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xcb236fe3775f2,!1,[[0,[0,500]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6164952294551048,!1,[[0,[0,500]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",9891380545513694,!1,[[0,[0,500]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7972084054315571,!1,[[0,[0,500]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7449339129693184,!1,[[0,[0,500]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7057391661351462,!1,[[0,[0,500]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9160329329406752,!1,[[0,[0,500]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",894526490962282,!1,[[0,[0,700]]]],
[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xa42d2449389a8,!1,[[0,[0,700]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8326882994557362,!1,[[0,[0,700]]]],[-1,cr.system_object.prototype.acts.Wait,null,9422502987808440,!1,[[0,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5826638484121547,!1,[[11,"gamespeed"],[7,[0,5]]]]]],[0,null,!1,null,7727805369638679,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x9576f6450b8d3,!1,[[11,"gamespeed"],[8,0],
[7,[0,5]]]]],[],[[0,null,!1,null,6875169110381415,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,8166126865958762,!1,[[0,[1,0.1]]]]],[[79,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xecbde54690092,!1,[[0,[4,[22,79,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[78,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4824469965852045,!1,[[0,[4,[22,78,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[80,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",625869245973296,!1,[[0,[4,[22,80,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xb69124374065a,!1,[[0,[4,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",929764865182918,!1,[[0,[4,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6357422173754921,
!1,[[0,[4,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x7969401458f6d,!1,[[0,[4,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5534063161639472,!1,[[0,[4,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x9b53352237f16,!1,[[0,[4,[22,11,"Bullet",
cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8425357642473056,!1,[[0,[4,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5098149084773934,!1,[[0,[4,[22,81,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xb14544af74efa,!1,[[0,[4,[22,10,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x96bb539a8f060,!1,[[0,[4,[22,76,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,8002830210051125,!1,[[1,[2,"main"]],[0,[0,-5]]]],[-1,cr.system_object.prototype.acts.Wait,null,9762809907386684,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9817075831480032,!1,[[11,"gamespeed"],[7,[0,6]]]]]]]],[0,null,!1,null,0xdcfde04f4c2f8,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,6675889040679263,!1,[[11,"gamespeed"],[8,0],[7,[0,6]]]]],[[79,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4975424762312512,!1,[[0,[0,600]]]],[78,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x450d42f3a884d,!1,[[0,[0,400]]]],[80,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xaefa09249d66d,!1,[[0,[0,750]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xf718951892baf,!1,[[0,[0,600]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6600002613401087,
!1,[[0,[0,600]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7732034743113,!1,[[0,[0,600]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xeae7aa283f4a5,!1,[[0,[0,600]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xaa9aebeaac185,!1,[[0,[0,600]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xc77bd0d0f8468,!1,[[0,[0,600]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xc8c20fb9ea223,!1,[[0,[0,600]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",6543694484732217,!1,[[0,[0,800]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5409692418010269,!1,[[0,[0,800]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xb5adb7a632a4f,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x4a80682d44774,!1,[[0,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8468841191087866,!1,[[11,"gamespeed"],[7,[0,7]]]]]],[0,null,!1,null,0xffbc09885ad50,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,
9313004966126792,!1,[[11,"gamespeed"],[8,0],[7,[0,7]]]]],[],[[0,null,!1,null,5993291286875334,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x7b8736698b1b6,!1,[[0,[1,0.1]]]]],[[79,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8512013133462706,!1,[[0,[4,[22,79,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[78,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xac2be779d6d3,!1,[[0,[4,[22,78,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],
[80,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xb820883e429c7,!1,[[0,[4,[22,80,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5807764624986148,!1,[[0,[4,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9426279410459592,!1,[[0,[4,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",6859579944233536,!1,[[0,[4,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xe1da0b24c9e3b,!1,[[0,[4,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x73bfae20f7302,!1,[[0,[4,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x8a6f282c9b6a1,
!1,[[0,[4,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xd7dd97f731a80,!1,[[0,[4,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x4c8991143e590,!1,[[0,[4,[22,81,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x772217f1593de,!1,[[0,[4,[22,10,"Bullet",
cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xb6af201a81b5d,!1,[[0,[4,[22,76,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,0x71b21289e2681,!1,[[1,[2,"main"]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,4504724406019595,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x57088dfb935e6,!1,[[11,"gamespeed"],[7,[0,8]]]]]]]],[0,
null,!1,null,0x763b9e6d8dc70,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x9eeca967e1323,!1,[[11,"gamespeed"],[8,0],[7,[0,8]]]]],[[79,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xf5961431f2d94,!1,[[0,[0,700]]]],[78,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5098901672437959,!1,[[0,[0,500]]]],[80,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x3f555e33a10b7,!1,[[0,[0,850]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9902093148180980,!1,[[0,
[0,700]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5932812613295965,!1,[[0,[0,700]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x9425bacd04509,!1,[[0,[0,700]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7095302392485664,!1,[[0,[0,700]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8690215083522319,!1,[[0,[0,700]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6185382941085457,!1,[[0,[0,700]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0xa1c3498a71778,!1,[[0,[0,700]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xd9b89f3a1d458,!1,[[0,[0,900]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4806681842013787,!1,[[0,[0,900]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x4974669a2b371,!1,[[0,[0,900]]]],[-1,cr.system_object.prototype.acts.Wait,null,7563989669902828,!1,[[0,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x670177ebee804,!1,[[11,"gamespeed"],[7,[0,9]]]]]],[0,null,
!1,null,5254218341527463,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5524651008915128,!1,[[11,"gamespeed"],[8,0],[7,[0,9]]]]],[],[[0,null,!1,null,6671314572638224,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,849028422522132,!1,[[0,[1,0.1]]]]],[[79,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8125932942205941,!1,[[0,[5,[22,79,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[78,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x8d9a14266ffa1,
!1,[[0,[5,[22,78,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[80,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8956456994369434,!1,[[0,[5,[22,80,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x651aa0de83cc9,!1,[[0,[5,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x4b43f5e4efd60,!1,[[0,[5,[22,58,"Bullet",
cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6035214694265549,!1,[[0,[5,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6676011169008918,!1,[[0,[5,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x9e99fdb800dff,!1,[[0,[5,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7246711726316466,!1,[[0,[5,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8291747294557225,!1,[[0,[5,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8728405634375596,!1,[[0,[5,[22,81,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[10,
cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xf8b2318405069,!1,[[0,[5,[22,10,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x8ecf5b36f7e54,!1,[[0,[5,[22,76,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,0x55dc6b3f0043d,!1,[[1,[2,"main"]],[0,[0,-5]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xb97fac28fe5c4,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,7754921428037131,!1,[[11,"gamespeed"],[7,[0,10]]]]]]]],[0,null,!1,null,7589509948806787,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7952458343719348,!1,[[11,"gamespeed"],[8,0],[7,[0,10]]]]],[[79,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4551793004228287,!1,[[0,[0,600]]]],[78,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",482272331639555,!1,[[0,[0,400]]]],[80,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7662323716181651,!1,[[0,[0,750]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",8859708664123256,!1,[[0,[0,600]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5186324349941,!1,[[0,[0,600]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6868900700662146,!1,[[0,[0,600]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7112460131744732,!1,[[0,[0,600]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9693509192294904,!1,[[0,[0,600]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x8a71df083b368,!1,[[0,[0,600]]]],[14,
cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8159954760066046,!1,[[0,[0,600]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4681147049374629,!1,[[0,[0,800]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9811480994558804,!1,[[0,[0,800]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xf430d12f8c67d,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,8405311488592449,!1,[[0,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5679956874396209,
!1,[[11,"gamespeed"],[7,[0,11]]]]]],[0,null,!1,null,9346768911153540,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5462471297910581,!1,[[11,"gamespeed"],[8,0],[7,[0,11]]]]],[],[[0,null,!1,null,0xd5ada26c13fad,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,6230069981191356,!1,[[0,[1,0.1]]]]],[[79,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x8555cfeb46d53,!1,[[0,[5,[22,79,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[78,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0x693d295756f29,!1,[[0,[5,[22,78,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[80,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6069472249483732,!1,[[0,[5,[22,80,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x528873d4e3a05,!1,[[0,[5,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5437179158899562,
!1,[[0,[5,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x96ed3826310fe,!1,[[0,[5,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5595567814705855,!1,[[0,[5,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7686126157066498,!1,[[0,[5,[22,61,"Bullet",
cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7849938272671626,!1,[[0,[5,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xfc31f21343cdb,!1,[[0,[5,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xf41a243490cff,!1,[[0,[5,[22,81,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8039569325747246,!1,[[0,[5,[22,10,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7523339270400803,!1,[[0,[5,[22,76,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,0x7a50e075ddd23,!1,[[1,[2,"main"]],[0,[0,-10]]]],[-1,cr.system_object.prototype.acts.Wait,null,23814609975316,
!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6020376859717801,!1,[[11,"gamespeed"],[7,[0,12]]]]]]]],[0,null,!1,null,7049383363961351,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7084219424827179,!1,[[11,"gamespeed"],[8,0],[7,[0,12]]]]],[[79,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5780025278257404,!1,[[0,[0,500]]]],[78,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x780f0e1646269,!1,[[0,[0,300]]]],[80,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",8747928351581183,!1,[[0,[0,650]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8128114946358162,!1,[[0,[0,500]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xf9fd6c6515f52,!1,[[0,[0,500]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x3fe3cfd0e3156,!1,[[0,[0,500]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xdd274a601a6cd,!1,[[0,[0,500]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x8e7b2b1dc2fcf,!1,[[0,[0,500]]]],[11,
cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8738785474382467,!1,[[0,[0,500]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x982e64a58713e,!1,[[0,[0,500]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9920259106574584,!1,[[0,[0,700]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xc39c8a65f9242,!1,[[0,[0,700]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x73e4ca31ff325,!1,[[0,[0,700]]]],[-1,cr.system_object.prototype.acts.Wait,null,9913161319899828,
!1,[[0,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,508725481119193,!1,[[11,"gamespeed"],[7,[0,13]]]]]],[0,null,!1,null,0x6d753f0e7e782,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7038205136825393,!1,[[11,"gamespeed"],[8,0],[7,[0,13]]]]],[],[[0,null,!1,null,9558071568186582,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x3b3e61d3e4106,!1,[[0,[1,0.1]]]]],[[79,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x40a4c6f875b9f,!1,[[0,[5,[22,79,"Bullet",
cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[78,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",958174694417935,!1,[[0,[5,[22,78,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[80,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",683168039653176,!1,[[0,[5,[22,80,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5616388956034495,!1,[[0,[5,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9181907469546284,!1,[[0,[5,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9510995200402622,!1,[[0,[5,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9780994982505140,!1,[[0,[5,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,
cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x5e527edcda8cf,!1,[[0,[5,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6090311346175344,!1,[[0,[5,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xc6a0abee5f9f6,!1,[[0,[5,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",9835254769450560,!1,[[0,[5,[22,81,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",737193687699069,!1,[[0,[5,[22,10,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5397716382511973,!1,[[0,[5,[22,76,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,0xe16b28ecc16c2,!1,
[[1,[2,"main"]],[0,[0,-15]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xf83e43e6e808d,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9038284940089024,!1,[[11,"gamespeed"],[7,[0,2]]]]]]]],[0,null,!1,null,0x6f07ce20e16bd,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x7cc1815e3d2eb,!1,[[11,"Score"],[8,5],[7,[0,15E3]]]]],[],[[0,null,!1,null,0x6ec8f866196bb,[[62,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,8143802213503619,!1]],[[62,cr.behaviors.Bullet.prototype.acts.SetEnabled,
"Bullet",0x61997f524eb64,!1,[[3,1]]],[62,cr.plugins_.Sprite.prototype.acts.AddInstanceVar,null,9526968976645172,!1,[[10,0],[7,[0,100]]]],[81,cr.plugins_.Sprite.prototype.acts.Destroy,null,9529728362935458,!1],[10,cr.plugins_.Sprite.prototype.acts.Destroy,null,5894120559678229,!1],[76,cr.plugins_.Sprite.prototype.acts.Destroy,null,9153541321400468,!1],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,5889000193575564,!1,[[3,0]]],[55,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x847c63ee8eb16,
!1],[-1,cr.system_object.prototype.acts.Wait,null,6286039243717677,!1,[[0,[0,2]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0x9a4a50bef6a86,!1,[[2,["click4",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[66,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0x5f32f919ff9bd,!1,[[3,0]]],[67,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0x8ddccafd37b69,!1,[[3,0]]],[68,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",8879475651834151,!1,[[3,0]]],[69,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,
"LiteTween",9211661682661302,!1,[[3,0]]],[70,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0x49529c1d78a7c,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,0x72514a7591230,!1,[[0,[1,0.7]]]],[66,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",4680274004504779,!1,[[3,1]]],[67,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0xc3547d6d8786b,!1,[[3,1]]],[68,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",5956018884793565,!1,
[[3,1]]],[69,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",7441594945385697,!1,[[3,1]]],[70,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0x39e4d09c96d42,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetVar,null,9281236377117776,!1,[[11,"gamepause"],[7,[0,1]]]]]]]],[0,null,!1,null,4590741118112199,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xd380896f0c041,!1,[[11,"Score"],[8,5],[7,[0,15E3]]]]],[],[[0,null,!1,null,604770554378374,[[4,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!1,!1,7897306497323657,!1]],[[4,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",9267867672434472,!1,[[3,1]]],[4,cr.plugins_.Sprite.prototype.acts.AddInstanceVar,null,0xb93f1a49dbc01,!1,[[10,0],[7,[0,100]]]],[81,cr.plugins_.Sprite.prototype.acts.Destroy,null,8364921106304808,!1],[10,cr.plugins_.Sprite.prototype.acts.Destroy,null,7867872508928094,!1],[76,cr.plugins_.Sprite.prototype.acts.Destroy,null,9892034544766316,!1],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0xa7f627ca20dc0,
!1,[[3,0]]],[55,cr.plugins_.Sprite.prototype.acts.Destroy,null,7922782555532837,!1],[-1,cr.system_object.prototype.acts.Wait,null,0xd7d9ead1f984a,!1,[[0,[0,2]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,9867575818128492,!1,[[2,["click4",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[66,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",8215653601662254,!1,[[3,0]]],[67,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",8919331825457775,!1,[[3,0]]],[68,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,
"LiteTween",0xe4d45ac82cdf1,!1,[[3,0]]],[69,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",9910859498787896,!1,[[3,0]]],[70,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",5936988823105704,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,6507668981801356,!1,[[0,[1,0.7]]]],[66,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0x4a4f4e227948f,!1,[[3,1]]],[67,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",9691658916171712,!1,
[[3,1]]],[68,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",5029337238440421,!1,[[3,1]]],[69,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",7591755167948341,!1,[[3,1]]],[70,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",6791442085717643,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x87a801b2ab979,!1,[[11,"gamepause"],[7,[0,1]]]]]]]],[0,null,!1,null,0x8f62d6b08b48f,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8790610425895575,
!1,[[11,"gamepause"],[8,0],[7,[0,1]]]]],[[30,cr.plugins_.Audio.prototype.acts.Stop,null,0x3c45af0e56751,!1,[[1,[2,"main"]]]],[79,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",6509952794365151,!1,[[3,0]]],[78,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0xbcaa547b29594,!1,[[3,0]]],[80,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0xb278b22ec04ce,!1,[[3,0]]],[6,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",335259672155427,!1,[[3,0]]],[58,cr.behaviors.Bullet.prototype.acts.SetEnabled,
"Bullet",0xbeb5be1309d9,!1,[[3,0]]],[59,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",6011509374276048,!1,[[3,0]]],[60,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",6453875197460563,!1,[[3,0]]],[61,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0xe0c32b18e0125,!1,[[3,0]]],[14,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",5467752457944592,!1,[[3,0]]],[11,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",4839690179446177,!1,[[3,0]]],[74,cr.behaviors.Bullet.prototype.acts.SetEnabled,
"Bullet",7924395791369249,!1,[[3,0]]],[75,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0x9e02482ee8339,!1,[[3,0]]],[76,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",4867038651373689,!1,[[3,0]]],[81,cr.plugins_.Sprite.prototype.acts.Destroy,null,7595292513504688,!1],[10,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc61db9cbbeafe,!1],[76,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb2829a8a64c1b,!1],[14,cr.plugins_.Sprite.prototype.acts.Destroy,null,9090833293609820,!1],[11,
cr.plugins_.Sprite.prototype.acts.Destroy,null,5216288282385727,!1]]],[0,null,!1,null,6312682701712417,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xd8f1cd914b22d,!1,[[4,67]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,7361056648315453,!1,[[11,"levels"],[7,[0,1]]]],[17,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,9671236791574728,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,924640354709735,!1,[[6,"Level4"]]]]],[0,null,!1,null,0xd159ef5b806e3,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,6172674525127659,!1,[[4,68]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,null,0x9471a053130b0,!1]]],[0,null,!1,null,8997212860870057,[[69,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x83b287815c25c,!1]],[],[[1,"url3",1,"https://www.twitter.com/intent/tweet?text= Completed Another Level of Shoot Angry Zombies. Try this Awesome Game bit.ly/1KyXW9c",!1,!1,5943699172845859,!1],[0,null,!1,null,7511669730263785,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,4903484207240153,!1,[[4,69]]]],[[25,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,0x4a5fbe6813775,!1,[[1,[23,"url3"]],[1,[2,"twitter"]]]]]]]],[0,null,!1,null,8333976184816902,[[70,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,9177598169533376,!1]],[],[[1,"url4",1,"https://www.facebook.com/sharer/sharer.php?u=http://online-free-stuff.com/saz/share.php",!1,!1,0xbf68c1dbab40b,!1],[0,null,!1,null,5185825964270366,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,9004566578679246,!1,[[4,70]]]],[[25,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,0x47b87b2c13467,!1,[[1,[23,"url4"]],[1,[2,"facebook"]]]]]]]],[0,null,!1,null,7163429873272288,[[27,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,4692491440613173,!1]],[[27,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc38090dff4563,!1]]],[0,null,!1,null,7765216761432414,[[87,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,5542232386334193,!1]],[[87,
cr.plugins_.Sprite.prototype.acts.Destroy,null,7959789338570801,!1]]],[0,null,!1,null,7737510506815325,[[88,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,949108282038125,!1]],[[88,cr.plugins_.Sprite.prototype.acts.Destroy,null,4990209937519685,!1]]],[0,null,!1,null,0x416ec2c298585,[[91,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,0xd5cd288e0ba10,!1]],[[91,cr.plugins_.Sprite.prototype.acts.Destroy,null,9881071810117380,!1]]]]],["Level4",[[0,null,!1,null,
0x9b9b6ff84a59,[[24,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,4778457069319745,!1,[[1,[2,"Spause"]]]]],[[23,cr.plugins_.Sprite.prototype.acts.SetVisible,null,5216788914509273,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,5653634217049624,!1,[[0,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.SetPaused,null,6274350632856397,!1,[[1,[2,"main"]],[3,0]]]]],[0,null,!1,null,0xa4ede44f0696b,[[24,cr.plugins_.Function.prototype.cnds.OnFunction,null,2,!1,!1,!1,9990333597773356,
!1,[[1,[2,"Splay"]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,5109241732658812,!1,[[0,[1,1]]]],[23,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x538f349cfc422,!1,[[3,0]]],[30,cr.plugins_.Audio.prototype.acts.SetPaused,null,0xc87b03c51245d,!1,[[1,[2,"main"]],[3,1]]]]],[0,null,!1,null,558061749420488,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,9748714126028620,!1]],[]],[0,null,!1,null,9476667759664382,[[25,cr.plugins_.Browser.prototype.cnds.OnPageHidden,null,
1,!1,!1,!1,0x430ad00fd559b,!1]],[[24,cr.plugins_.Function.prototype.acts.CallFunction,null,4519387011273815,!1,[[1,[2,"Spause"]],[13]]]]],[0,null,!1,null,6940408888909674,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xb298eaab5e74f,!1,[[4,23]]]],[[24,cr.plugins_.Function.prototype.acts.CallFunction,null,5889148525188394,!1,[[1,[2,"Splay"]],[13]]]]],[0,null,!1,null,8145254801088587,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9521304514926502,!1,[[4,21]]]],
[[30,cr.plugins_.Audio.prototype.acts.Stop,null,8344407229540173,!1,[[1,[2,"main"]]]],[17,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,0x63057731d4397,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,299036408186703,!1,[[6,"menu"]]]]],[0,null,!1,null,0x42202acb06c0b,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xb082839961298,!1,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,9345288157490040,!1,[[0,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.SetPaused,
null,5672359709489825,!1,[[1,[2,"main"]],[3,0]]],[22,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,4750901548048244,!1,[[3,1]]],[22,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x49c25e4aed2d6,!1,[[3,1]]]]],[0,null,!1,null,984473418767337,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xde335a683a673,!1,[[4,22]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0xc477daff5f8e8,!1,[[0,[0,1]]]],[30,cr.plugins_.Audio.prototype.acts.SetPaused,null,0xd74bb0b34bd12,
!1,[[1,[2,"main"]],[3,1]]],[22,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,866386269841509,!1,[[3,0]]],[22,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7303979546494228,!1,[[3,0]]]]],[0,null,!1,null,8823390737651728,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,5716860169350997,!1]],[[17,cr.plugins_.CJSAds.prototype.acts.PreloadFullscreen,null,0x50c81335319a4,!1],[93,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xfa3d73af5a52d,!1,[[0,[0,180]]]],[95,
cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xd70d9465e22de,!1,[[0,[0,180]]]],[94,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",7299197467363157,!1,[[0,[0,180]]]],[82,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0xd7a4e7572bcad,!1,[[1,[2,"saz"]],[7,[23,"levels"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9445331871851062,!1,[[11,"Score"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,972205306651914,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,0xc1edbe074adeb,!1,[[11,"gamepause"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8405335712765671,!1,[[11,"gamespeed"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x4c9ae0f9d721f,!1,[[0,[1,0.7]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x50af33800e4f0,!1,[[0,[0,0]]]]]],[0,null,!1,null,8185799921765818,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,931303522943391,!1,[[4,96]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,
0xa7b0ac6f9521a,!1,[[0,[1,1]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0x629da4874782e,!1,[[2,["game-shoot",!1]],[3,1],[0,[0,-20]],[1,[2,"main"]]]],[96,cr.behaviors.lunarray_LiteTween.prototype.acts.Reverse,"LiteTween",481764800045306,!1,[[3,0]]]]],[0,null,!1,null,8661771308594008,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6556803148618522,!1,[[11,"playerchoose"],[8,0],[7,[0,1]]]]],[[62,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xd86a79d81ce99,!1]]],[0,null,!1,null,
0xbb266e8f27e27,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,4884249207313053,!1,[[11,"playerchoose"],[8,0],[7,[0,2]]]]],[[4,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xae9f4fe1d0c6e,!1]]],[0,null,!1,null,0x6ffae33fb2661,[[94,cr.plugins_.TiledBg.prototype.cnds.CompareX,null,0,!1,!1,!1,6080591496865927,!1,[[8,3],[0,[7,[3,[20,94,cr.plugins_.TiledBg.prototype.exps.Width,!1,null]],[0,2]]]]]],[[94,cr.plugins_.TiledBg.prototype.acts.SetX,null,0x6788a9f2d4d42,!1,[[0,[4,[20,94,cr.plugins_.TiledBg.prototype.exps.X,
!1,null],[7,[20,94,cr.plugins_.TiledBg.prototype.exps.Width,!1,null],[0,2]]]]]]]],[0,null,!1,null,4739556696641265,[[93,cr.plugins_.TiledBg.prototype.cnds.CompareX,null,0,!1,!1,!1,0xa13f9c137fdf4,!1,[[8,3],[0,[7,[3,[20,93,cr.plugins_.TiledBg.prototype.exps.Width,!1,null]],[0,2]]]]]],[[93,cr.plugins_.TiledBg.prototype.acts.SetX,null,0x8c51cee7c03e3,!1,[[0,[4,[20,93,cr.plugins_.TiledBg.prototype.exps.X,!1,null],[7,[20,93,cr.plugins_.TiledBg.prototype.exps.Width,!1,null],[0,2]]]]]]]],[0,null,!1,null,
9532556899406334,[[95,cr.plugins_.TiledBg.prototype.cnds.CompareX,null,0,!1,!1,!1,0x5d6de7caf9fbd,!1,[[8,3],[0,[7,[3,[20,95,cr.plugins_.TiledBg.prototype.exps.Width,!1,null]],[0,2]]]]]],[[95,cr.plugins_.TiledBg.prototype.acts.SetX,null,4579762672654525,!1,[[0,[4,[20,95,cr.plugins_.TiledBg.prototype.exps.X,!1,null],[7,[20,95,cr.plugins_.TiledBg.prototype.exps.Width,!1,null],[0,2]]]]]]]],[0,null,!1,null,0xe223f07417c39,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x99e3a71208364,!1]],
[[-1,cr.system_object.prototype.acts.AddVar,null,435822302468929,!1,[[11,"timer"],[7,[19,cr.system_object.prototype.exps.dt]]]]]],[0,null,!0,null,0x9f859d18bfdc,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7283887368822905,!1,[[4,32]]],[2,cr.plugins_.Keyboard.prototype.cnds.OnKey,null,1,!1,!1,!1,7061475043083156,!1,[[9,38]]]],[[4,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",7777138450774022,!1,[[3,2]]],[62,cr.behaviors.Platform.prototype.acts.SimulateControl,
"Platform",933464406458125,!1,[[3,2]]],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xde75523dd9040,!1,[[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.StartAnim,null,5344273674095597,!1,[[3,1]]],[32,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xf2a464d3437df,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,0xecdc41715d155,!1,[[0,[1,0.2]]]],[32,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7402613958172601,!1,[[3,1]]]]],[0,null,!0,null,9344083285608792,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,7384494061987355,!1,[[4,32]]],[2,cr.plugins_.Keyboard.prototype.cnds.OnKey,null,1,!1,!1,!1,4843226109739072,!1,[[9,38]]]],[[15,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",882918933456516,!1,[[3,2]]],[63,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",0xf2bccae35881f,!1,[[3,2]]]]],[0,null,!1,null,5028737176280262,[[4,cr.behaviors.Platform.prototype.cnds.IsJumping,"Platform",0,!1,!1,!1,8424668284712696,!1]],[[4,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,6081382004294102,!1,[[1,[2,"jump"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,5879128753852715,!1,[[0,[0,1]]]],[4,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x56357a710ded5,!1,[[1,[2,"run"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.StopAnim,null,754231695696692,!1],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6971395325036089,!1,[[3,0]]]]],[0,null,!1,null,5126474172888648,[[62,cr.behaviors.Platform.prototype.cnds.IsJumping,"Platform",0,!1,!1,!1,4672727858677049,
!1]],[[62,cr.plugins_.Sprite.prototype.acts.SetAnim,null,8708670028441572,!1,[[1,[2,"jump"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,0xc0cac76f23a7d,!1,[[0,[0,1]]]],[62,cr.plugins_.Sprite.prototype.acts.SetAnim,null,8822991243193305,!1,[[1,[2,"run"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.StopAnim,null,0xe0a5b0f812a92,!1],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6583385988330309,!1,[[3,0]]]]],[0,null,!1,null,9502377679295832,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,9717062496519580,!1,[[11,"timer"],[8,5],[7,[0,15]]]]],[],[[0,null,!1,null,0xf74db0d80e327,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x8c02d8ac5ecbb,!1,[[0,[0,14]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,600235376459378,!1,[[4,11],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,400],[0,200]]]]]]]]]],[0,null,!1,null,9598416290816224,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x47a2f1fa630e7,!1,[[11,
"timer"],[8,5],[7,[0,5]]]]],[[40,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8328901201607705,!1,[[3,0]]],[40,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x96fab6d7f7094,!1]]],[0,null,!1,null,6572650835493051,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x6178f88f61e5f,!1,[[11,"timer"],[8,5],[7,[0,25]]]]],[],[[0,null,!1,null,0x8f33d582604e2,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,505358614849422,!1,[[0,[0,25]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,
null,0x56c80c955235e,!1,[[4,14],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,400],[0,250]]]]]]]]]],[0,null,!1,null,4806247762791869,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xdcd2bc3565686,!1,[[11,"timer"],[8,5],[7,[0,1]]]]],[],[[0,null,!1,null,4687593797966799,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xa84f7dacaa0c9,!1,[[0,[0,4]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,701293309597791,!1,[[4,6],[5,[2,"Game"]],
[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,300],[0,250]]]]]]]],[0,null,!1,null,8212719302828109,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,296936501881801,!1,[[0,[0,6]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xcd64b67803746,!1,[[4,58],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,300],[0,250]]]]]]]],[0,null,!1,null,5931160308586378,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,7869235925576456,!1,[[0,
[0,9]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,6759302224326771,!1,[[4,59],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,300],[0,250]]]]]]]],[0,null,!1,null,4587328892628795,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,9181501338110512,!1,[[0,[0,11]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,6343961937872937,!1,[[4,60],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,300],[0,250]]]]]]]],[0,
null,!1,null,482030215601343,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x56266ab701251,!1,[[0,[0,13]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,7170543184169049,!1,[[4,61],[5,[2,"Game"]],[0,[0,1260]],[0,[19,cr.system_object.prototype.exps.random,[[0,300],[0,250]]]]]]]]]],[0,null,!1,null,0x3ee324c39cd90,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x8ef2b402fc808,!1,[[11,"timer"],[8,5],[7,[0,1]]]]],[],[[0,null,!1,null,8036871529808214,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,0x74ba9e3b364ef,!1,[[0,[0,15]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,5928912067655652,!1,[[4,6],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]],[0,null,!1,null,8746736101759331,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,9992035213079772,!1,[[0,[1,15.1]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,8145887038399535,!1,[[4,58],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]],[0,null,!1,null,9817933765275764,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,0xb0e89d9eadfc1,!1,[[0,[1,15.2]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xe6da7027e4683,!1,[[4,59],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]],[0,null,!1,null,5724834190317626,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,739321111010532,!1,[[0,[1,15.3]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,7714576956964649,!1,[[4,60],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]],[0,null,!1,null,7569798001016209,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,0x94ae79db210ca,!1,[[0,[1,15.4]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x864c87fdb10e9,!1,[[4,61],[5,[2,"Game"]],[0,[0,1260]],[0,[0,350]]]]]]]],[0,null,!1,null,9740977133139596,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7683402260914161,!1,[[4,33]]]],[],[[0,null,!1,null,5001377245297683,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,8740232204671818,!1,[[0,[1,0.6]]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xe1e270af6d9ca,
!1,[[4,31],[5,[0,0]],[7,[0,0]]]],[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,6369008061106079,!1,[[4,31],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,4506227966420589,!1,[[2,["2",!1]],[3,0],[0,[0,0]],[1,[2,"shoot"]]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6516464238167155,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,573140598806528,!1,[[0,[1,0.2]]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,5348170722677842,!1,[[3,1]]]]]]],[0,null,
!1,null,0x39c31ae4c2313,[[2,cr.plugins_.Keyboard.prototype.cnds.OnKey,null,1,!1,!1,!1,7047992516710754,!1,[[9,32]]]],[],[[0,null,!1,null,682109900945653,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x9195494921efe,!1,[[0,[1,0.6]]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,9071995404130034,!1,[[4,31],[5,[0,0]],[7,[0,0]]]],[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,7038309742619742,!1,[[4,31],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,6265417997566069,
!1,[[2,["2",!1]],[3,0],[0,[0,0]],[1,[2,"shoot"]]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xc6af85150e6df,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,5580795411084192,!1,[[0,[1,0.2]]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6947415771074568,!1,[[3,1]]]]]]],[0,null,!1,null,616324436289562,[[31,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x490c0cfae3793,!1,[[4,81]]]],[[81,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x86a2f32b9034f,
!1,[[10,0],[7,[0,0]]]],[31,cr.plugins_.Sprite.prototype.acts.Destroy,null,8867031993151391,!1]]],[0,null,!1,null,0xf8a8083ddf88c,[[31,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xcdbf1a37c7e98,!1,[[4,10]]]],[[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x399338caff02a,!1,[[10,0],[7,[0,0]]]],[31,cr.plugins_.Sprite.prototype.acts.Destroy,null,5775722984530342,!1]]],[0,null,!1,null,7748866383692738,[[31,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6393151607245052,
!1,[[4,76]]]],[[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x7362781e9a824,!1,[[10,0],[7,[0,0]]]],[31,cr.plugins_.Sprite.prototype.acts.Destroy,null,754422121917884,!1]]],[0,null,!1,null,5027062340322785,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7822769840241996,!1,[[4,11]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,4603349267647591,!1]]],[0,null,!1,null,7880399767577467,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6170156145108447,
!1,[[4,58]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,9274943214737254,!1]]],[0,null,!1,null,8314001676925518,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9341642239798432,!1,[[4,59]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,933401640536786,!1]]],[0,null,!1,null,7858121771261743,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,495778346706415,!1,[[4,60]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,6959507634888687,!1]]],[0,null,
!1,null,5713287036944195,[[6,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6408134812977795,!1,[[4,61]]]],[[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,9083106176322244,!1]]],[0,null,!1,null,8015118542345752,[[58,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x568cbadae4ea6,!1,[[4,59]]]],[[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,4678130918249632,!1]]],[0,null,!1,null,0x52f303f28f877,[[58,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9013051804531444,
!1,[[4,60]]]],[[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,6833423446124901,!1]]],[0,null,!1,null,8506210477679054,[[59,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7445490378248737,!1,[[4,60]]]],[[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,7886721740127896,!1]]],[0,null,!1,null,0xf85f08f5be6e3,[[60,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9891416329971264,!1,[[4,61]]]],[[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,38503353516071,!1]]],[0,
null,!1,null,5108666142322572,[[81,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8349187611426496,!1,[[4,76]]]],[[76,cr.plugins_.Sprite.prototype.acts.Destroy,null,6239894072007721,!1]]],[0,null,!1,null,0xd10e85185d6b6,[[76,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x7ad85b6bb4621,!1,[[4,10]]]],[[10,cr.plugins_.Sprite.prototype.acts.Destroy,null,980821413995652,!1]]],[0,null,!1,null,0xb1200c1229ae0,[[81,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,
!0,0x9939bc2563575,!1,[[4,10]]]],[[81,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xdfb09fed681fd,!1]]],[0,null,!1,null,7305684143086514,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7994218432222617,!1,[[11,"timer"],[8,5],[7,[0,5]]]]],[],[[0,null,!1,null,0xd46eda8393ed,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,7198566310607964,!1,[[0,[0,5]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,4548692523456937,!1,[[4,81],[5,[2,"Game"]],[0,[0,1260]],[0,[0,
575]]]]]]]],[0,null,!1,null,963463205558959,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xa21f6b3ce5c47,!1,[[11,"timer"],[8,5],[7,[0,5]]]]],[],[[0,null,!1,null,0x418b2991b5bde,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,6098596998786274,!1,[[0,[1,7.5]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,6526475938808793,!1,[[4,10],[5,[2,"Game"]],[0,[0,1260]],[0,[0,550]]]]]]]],[0,null,!1,null,0x61ee05ac91cd4,[[-1,cr.system_object.prototype.cnds.CompareVar,null,
0,!1,!1,!1,0x7c606d898107f,!1,[[11,"timer"],[8,5],[7,[0,5]]]]],[],[[0,null,!1,null,0x44abcdb666c44,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x56fe2705078cb,!1,[[0,[1,9.5]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,4524360332559155,!1,[[4,76],[5,[2,"Game"]],[0,[0,1260]],[0,[0,585]]]]]]]],[0,null,!1,null,0x894dfcd2bc7b4,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x6071a68f07036,!1,[[4,6]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xf6b447d23c863,
!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xfa68393c4ab7,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",8347397110860815,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8192271717002172,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x6a5e44a4598d1,!1,[[0,[1,0.5]]]],[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,5600715087109328,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,0xcad38a2deeb07,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,9295544666954124,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xa27b912dee1cd,!1,[[4,58]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xffd9bafec27e6,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0x811608139b277,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",7690960615917291,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",6967372343110265,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,842644573051245,!1,[[0,[1,0.5]]]],[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,8589301564199743,!1],[-1,cr.system_object.prototype.acts.AddVar,null,8298028072838969,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0x56d268861336f,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8771105917189877,!1,[[4,59]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x656a5630aee28,!1,[[4,7],[5,[0,
0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,755609979108323,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x7ccd904881f9a,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x56089a5b1f446,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xfb5fbc0325bd8,!1,[[0,[1,0.5]]]],[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,4729785526758192,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,0x6bc5d89e4e19,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,6764118534472681,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5178196151123983,!1,[[4,60]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,7954171502259658,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,5720438955068394,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",3368610420089,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0xb9029f7155261,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,6730188696555501,!1,[[0,[1,0.5]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,7642837059943081,!1],[-1,cr.system_object.prototype.acts.AddVar,null,5625743363851142,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,5817500190998575,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5229384769849841,!1,[[4,61]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x70208500668d9,!1,[[4,7],[5,
[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,9505557796648468,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x574021874eaa5,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8539555005152286,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,5663744289411761,!1,[[0,[1,0.5]]]],[61,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xdcd4a108c9363,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,6798097790562368,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,4696778963443692,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8474512547662576,!1,[[4,6]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,8758541598863434,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xa96b1312badf0,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",881073156109858,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",8160587771618968,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x7666d4bbac905,!1,[[0,[1,0.5]]]],[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,5426051633018866,!1],[-1,cr.system_object.prototype.acts.AddVar,null,7418299604838275,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0xee60654c92c6b,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,414417512749167,!1,[[4,58]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xb0172c4434f64,!1,[[4,7],[5,[0,
0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,4504786558766837,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xc7b9ffeaa84b7,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x8ec1e61a32843,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,6234171415537042,!1,[[0,[1,0.5]]]],[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xdcc8aa76b10dd,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,6024678627512685,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,8314498469048459,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8700853798673664,!1,[[4,59]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xa2173d61aa42d,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0xba4a78b75d969,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x930fc92c34e7,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",6543679707690197,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x7d6857f6914c,!1,[[0,[1,0.5]]]],[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xcf6c90f90ee8,!1],[-1,cr.system_object.prototype.acts.AddVar,null,5060755972386982,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,9251943711456628,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xa6f1fe993ceb1,!1,[[4,60]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,5789009171668931,!1,[[4,7],[5,[0,
0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,9039819460833472,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9709761546233484,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6281650933401913,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xd78df3b8415d6,!1,[[0,[1,0.5]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,9919203032644336,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,7998202100160465,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,5952247786016909,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9054374868594592,!1,[[4,61]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,5611454015804051,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,7207961770394731,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x4ed7493101149,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0x642dc956b8ca0,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xadddd7daeede6,!1,[[0,[1,0.5]]]],[61,cr.plugins_.Sprite.prototype.acts.Destroy,null,9839524763379828,!1],[-1,cr.system_object.prototype.acts.AddVar,null,0xaf4e12584e8cc,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,9216679133197320,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7448150122125246,!1,[[4,6]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,5292623349505764,!1,[[4,7],[5,
[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,6134657759818227,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xf7e743080fb34,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6164244903118707,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,7952464885739925,!1,[[0,[1,0.5]]]],[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xe83e9dbfe6426,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,6396624335072867,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0xe5d41bf34790,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xd255d71cebe78,!1,[[4,58]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xa0f7a9af4e570,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,5698744992147311,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",7776355782335125,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",9479780763217124,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,5514762232525835,!1,[[0,[1,0.5]]]],[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x3c2a662fc902e,!1],[-1,cr.system_object.prototype.acts.AddVar,null,5122698745324197,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,8577956727984793,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8365490251081689,!1,[[4,59]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,9182383756725164,!1,[[4,7],
[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0x60f83e2de4608,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",7990889085048713,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9806463308663064,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xc3ada1f5cb75d,!1,[[0,[1,0.5]]]],[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x3b68b1baf6573,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,0x51deb57c75795,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,5754868236860069,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xb622f19af581b,!1,[[4,60]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,7260821644316833,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,8164409263313521,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x99c7ca653349,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0x53e26ef19d52c,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,7682035642541972,!1,[[0,[1,0.5]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x805e58acaca28,!1],[-1,cr.system_object.prototype.acts.AddVar,null,7029903690655452,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,581693195742972,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9979873259632532,!1,[[4,61]]]],[[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,7093369935960806,!1,[[4,7],[5,
[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,5832185631678512,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x3dea53f72ea45,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xc03e5648e7b17,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xc763e3c203f1d,!1,[[0,[1,0.5]]]],[61,cr.plugins_.Sprite.prototype.acts.Destroy,null,8739766736110021,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,6439371814276755,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,5081166307317045,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x75468f91a2a06,!1,[[4,6]]]],[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,9908823440681960,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,914660120715568,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xfb7aa98301a5f,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",6232381248425608,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x8291a1a0ca1b4,!1,[[0,[1,0.5]]]],[6,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xe8de4c31a4595,!1],[-1,cr.system_object.prototype.acts.AddVar,null,8717995201768551,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0x7ad1a7de135dc,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xa9af47f505d18,!1,[[4,58]]]],[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,6145155127589718,!1,[[4,7],[5,[0,
0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0x734166f1166fc,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",4949692897560361,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8194043922216003,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xccd06b97ed84f,!1,[[0,[1,0.5]]]],[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,8115681230601174,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,5024787617078426,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,562274794143424,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,875190178527997,!1,[[4,59]]]],[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x79a1ba49b7e28,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,0x59d12f02b6f5b,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",7344657239067,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0x4dedf08580fb0,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,5786830476541578,!1,[[0,[1,0.5]]]],[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,8876616302334545,!1],[-1,cr.system_object.prototype.acts.AddVar,null,5283932129254865,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0xb6ad7f66826ea,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4593316799754786,!1,[[4,60]]]],[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,9789621068841896,!1,[[4,7],[5,
[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,9812132712672040,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",4788032068781917,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x485e53983c859,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xc7be632c5bc0e,!1,[[0,[1,0.5]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,9692867232270482,!1],[-1,cr.system_object.prototype.acts.AddVar,
null,0xdcd349537796b,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,0xc1d66bf789126,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,56835020688816,!1,[[4,61]]]],[[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,426609145062725,!1,[[4,7],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,7134345133998914,!1,[[2,["new3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9786788998590988,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0x874e97c3b73e0,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x702c1bc5aad1d,!1,[[0,[1,0.5]]]],[61,cr.plugins_.Sprite.prototype.acts.Destroy,null,9537207121702576,!1],[-1,cr.system_object.prototype.acts.AddVar,null,8136769300075616,!1,[[11,"Score"],[7,[0,75]]]]]],[0,null,!1,null,8416136640459559,[[7,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,8122536534229578,!1]],[[7,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x7a2bf287f69fe,!1]]],[0,null,!1,
null,5712982177873727,[[13,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,0xb63640ad15d15,!1]],[[13,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xbe6581aff9e88,!1]]],[0,null,!1,null,8781818352136182,[[12,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,899244693603606,!1]],[[12,cr.plugins_.Sprite.prototype.acts.Destroy,null,7475515096041033,!1]]],[0,null,!1,null,8645395560814294,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,7212478560432465,
!1]],[[3,cr.plugins_.Text.prototype.acts.SetText,null,6214715112270963,!1,[[7,[10,[2,": "],[23,"Score"]]]]]]],[0,null,!1,null,6085141495813098,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8886538254733655,!1,[[4,81]]]],[[4,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,6042080863219242,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,8448107570580204,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x9e3f3f743e96c,!1,[[4,10]]]],[[4,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
null,0x4ae06187384bc,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,408260371308658,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,1863503508192,!1,[[4,76]]]],[[4,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,7604750980816027,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,6469198392891052,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9610856808053516,!1,[[4,81]]]],[[62,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,43919600760177,!1,[[10,0],[7,[0,1]]]]]],
[0,null,!1,null,8366853079502991,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6508220012835239,!1,[[4,10]]]],[[62,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,5758436523362022,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,0x6df1bdb20e0c0,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,726515962626666,!1,[[4,76]]]],[[62,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,5984739245323077,!1,[[10,0],[7,[0,1]]]]]],[0,null,!1,null,0xc400d80d1c24f,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,0x81633d59037b1,!1,[[4,11]]]],[[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,4744290011124036,!1],[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x7124373533e86,!1,[[4,13],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,8981605894160438,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",4854048442454951,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5322499650123533,!1,
[[0,[0,800]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xfb543e0bacb17,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9295040957483278,!1,[[0,[0,800]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",34335002448026,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6103390507559953,!1,[[0,[0,800]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",5594524828096599,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0x89e1191a0d941,!1,[[0,[0,800]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x67de1f12c2875,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6429202393521399,!1,[[0,[0,800]]]],[81,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xa3969dc592c41,!1,[[10,0],[7,[0,0]]]],[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,8568550034167569,!1,[[10,0],[7,[0,0]]]],[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,8633639241129221,
!1,[[10,0],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,5195580716026305,!1,[[11,"Score"],[7,[0,500]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xd13926e1fec75,!1,[[0,[1,0.5]]]]]],[0,null,!1,null,9510300396955236,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4852447770894384,!1,[[4,11]]]],[[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,5875003184981813,!1],[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,5981408233962676,!1,[[4,13],[5,[0,0]],[7,[0,0]]]],
[30,cr.plugins_.Audio.prototype.acts.Play,null,0xefb0412955ea5,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9016803507826520,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9410083001932308,!1,[[0,[0,800]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6725553287015111,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x82610cfdc2570,!1,[[0,[0,800]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
"Bullet",6811633256338356,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6824475558881215,!1,[[0,[0,800]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",8464008344922777,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5503807571892285,!1,[[0,[0,800]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x9dc6f42ae69e7,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xa0dcd977936b9,!1,
[[0,[0,800]]]],[81,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,5250365586187935,!1,[[10,0],[7,[0,0]]]],[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x54e4cb98e9105,!1,[[10,0],[7,[0,0]]]],[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,7543806899204021,!1,[[10,0],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,6658431530781044,!1,[[11,"Score"],[7,[0,500]]]],[-1,cr.system_object.prototype.acts.Wait,null,6588200055698988,!1,[[0,[1,0.5]]]]]],[0,null,!1,null,
9612876946078048,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xaaf40416b36f,!1,[[4,11]]]],[[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,316335722990179,!1],[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x5173a38b0a6e9,!1,[[4,13],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,6107664896147281,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6591169369951756,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",6248587785456752,!1,[[0,[0,800]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9889672896062264,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x8616154540d51,!1,[[0,[0,800]]]],[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6229898806330249,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8425017724342489,!1,[[0,[0,800]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",7325303664330206,
!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7870635384732663,!1,[[0,[0,800]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x7fe40b2c8263d,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",921366883236214,!1,[[0,[0,800]]]],[81,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,9486949245015972,!1,[[10,0],[7,[0,0]]]],[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,5311069018537225,!1,[[10,0],[7,[0,0]]]],[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
null,7741634135215369,!1,[[10,0],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,5361387211042618,!1,[[11,"Score"],[7,[0,500]]]],[-1,cr.system_object.prototype.acts.Wait,null,5578065524056172,!1,[[0,[1,0.5]]]]]],[0,null,!1,null,0x6ca1611432cf0,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xaf2f31c7bb612,!1,[[4,11]]]],[[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab7012467a5a,!1],[63,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xc8f6963cb1812,!1,[[4,13],[5,
[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,6045889108449418,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[6,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",5924758794436785,!1,[[0,[0,270]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",811433319732584,!1,[[0,[0,800]]]],[58,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xc60490cd24305,!1,[[0,[0,270]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x9e244a46a583a,!1,[[0,[0,800]]]],
[59,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6783607658634134,!1,[[0,[0,270]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7766143212034389,!1,[[0,[0,800]]]],[60,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",743719217226263,!1,[[0,[0,270]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x69b4e01bec193,!1,[[0,[0,800]]]],[61,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",4584792921293859,!1,[[0,[0,270]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",8476335587910642,!1,[[0,[0,800]]]],[81,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,9126995634408012,!1,[[10,0],[7,[0,0]]]],[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x875b222d82f54,!1,[[10,0],[7,[0,0]]]],[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,9006320975674514,!1,[[10,0],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,0x8bd8703be71ed,!1,[[11,"Score"],[7,[0,500]]]],[-1,cr.system_object.prototype.acts.Wait,null,5169595066352804,!1,[[0,
[1,0.5]]]]]],[0,null,!1,null,8391251662554555,[[4,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5534802734194291,!1,[[4,14]]]],[[14,cr.plugins_.Sprite.prototype.acts.Destroy,null,6212447013301667,!1],[30,cr.plugins_.Audio.prototype.acts.Play,null,0x6851a17fafde3,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,4734570229795534,!1,[[4,15],[5,[0,0]],[7,[0,0]]]],[15,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,8737220673976855,!1,[[3,
1]]],[15,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8148025548505527,!1,[[3,1]]],[4,cr.plugins_.Sprite.prototype.acts.SetVisible,null,5080898093074727,!1,[[3,0]]],[4,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,8662684637577276,!1,[[3,0]]]]],[0,null,!1,null,0x74995be96e645,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x7ee67e666cdac,!1,[[4,14]]]],[[14,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb3dc17b80140a,!1],[30,cr.plugins_.Audio.prototype.acts.Play,null,
0x5064d21a212a6,!1,[[2,["3",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xe281ccf47f561,!1,[[4,63],[5,[0,0]],[7,[0,0]]]],[63,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,6083676121708816,!1,[[3,1]]],[63,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x573ee2c6c5dba,!1,[[3,1]]],[62,cr.plugins_.Sprite.prototype.acts.SetVisible,null,9363868933704372,!1,[[3,0]]],[62,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,507008792521983,!1,[[3,0]]]]],[0,
null,!1,null,8637394535741125,[[15,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,0xdd82d56387130,!1]],[[55,cr.plugins_.Sprite.prototype.acts.StopAnim,null,6445786316894596,!1],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x5a2d0b79b6e9b,!1,[[3,0]]],[4,cr.plugins_.Sprite.prototype.acts.SetVisible,null,56178752289142,!1,[[3,0]]],[4,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,9520995000725628,!1,[[3,0]]],[4,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x9bafc80b6d607,
!1],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xf1b678ec0aa00,!1,[[3,0]]],[36,cr.plugins_.Sprite.prototype.acts.SetVisible,null,5511937797399568,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,6941091207483073,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xe9734bd4903a1,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,0x8728f0ceb8fd4,!1,[[0,[0,10]]]],[15,cr.plugins_.Sprite.prototype.acts.Spawn,null,9544264086363944,!1,[[4,4],[5,[0,0]],
[7,[0,0]]]],[15,cr.plugins_.Sprite.prototype.acts.Destroy,null,491082479101729,!1],[15,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0x39632da69aab3,!1,[[3,0]]],[15,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xde2e0ece0165f,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,380503444792907,!1,[[3,1]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xeb242a755048d,!1,[[3,1]]],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xea3ed8fa073b6,!1,[[3,1]]],[36,
cr.plugins_.Sprite.prototype.acts.SetVisible,null,21240157826272,!1,[[3,1]]]]],[0,null,!1,null,6913489579921412,[[63,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,5770770747618567,!1]],[[55,cr.plugins_.Sprite.prototype.acts.StopAnim,null,54359869699934,!1],[55,cr.plugins_.Sprite.prototype.acts.SetVisible,null,5176020641285679,!1,[[3,0]]],[62,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6497721702180486,!1,[[3,0]]],[62,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,7466445856953072,
!1,[[3,0]]],[62,cr.plugins_.Sprite.prototype.acts.Destroy,null,5669034512481793,!1],[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,9266917966149074,!1,[[3,0]]],[36,cr.plugins_.Sprite.prototype.acts.SetVisible,null,546515520768989,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,7818450351699007,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,662060801041982,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,7269424977275185,!1,[[0,[0,10]]]],[63,
cr.plugins_.Sprite.prototype.acts.Spawn,null,6560086023551605,!1,[[4,62],[5,[0,0]],[7,[0,0]]]],[63,cr.plugins_.Sprite.prototype.acts.Destroy,null,9423795197262400,!1],[63,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,5829075206888897,!1,[[3,0]]],[63,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x990c3f2a88b18,!1,[[3,0]]],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0xe1f8609a1120c,!1,[[3,1]]],[14,cr.plugins_.Sprite.prototype.acts.SetVisible,null,513376284291072,!1,[[3,1]]],
[33,cr.plugins_.Sprite.prototype.acts.SetVisible,null,4872595537816479,!1,[[3,1]]],[36,cr.plugins_.Sprite.prototype.acts.SetVisible,null,9292043088406344,!1,[[3,1]]]]],[0,null,!1,null,990314205679977,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5244483262357593,!1,[[4,81]]]],[[81,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x434b395d76a34,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,0xdf84b8332c249,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4844678339686164,
!1,[[4,10]]]],[[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,7435834370227233,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,8370748896178938,[[15,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,716387901091022,!1,[[4,76]]]],[[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,6034928234327272,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,0xc9d9b66894df5,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xa1a468e442b87,!1,[[4,81]]]],[[81,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
null,767992076402307,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,825591052603197,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xb2566e70fdcc,!1,[[4,10]]]],[[10,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,5620873939803298,!1,[[10,0],[7,[0,0]]]]]],[0,null,!1,null,7609120152300039,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9176427639815492,!1,[[4,76]]]],[[76,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,8847821125615612,!1,[[10,0],[7,[0,0]]]]]],
[0,null,!1,null,0xfcd169c6430bf,[[81,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,7098275396083431,!1,[[10,0],[8,0],[7,[0,0]]]]],[[81,cr.plugins_.Sprite.prototype.acts.Destroy,null,6804012781711987,!1],[30,cr.plugins_.Audio.prototype.acts.Play,null,6977004900968318,!1,[[2,["1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[81,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xcb3e27e3df96f,!1,[[4,91],[5,[0,0]],[7,[0,0]]]]]],[0,null,!1,null,6001067046694973,[[10,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
null,0,!1,!1,!1,6712058034687758,!1,[[10,0],[8,0],[7,[0,0]]]]],[[10,cr.plugins_.Sprite.prototype.acts.Destroy,null,7450812233680992,!1],[30,cr.plugins_.Audio.prototype.acts.Play,null,982497692295082,!1,[[2,["1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[10,cr.plugins_.Sprite.prototype.acts.Spawn,null,9270154225972864,!1,[[4,87],[5,[0,0]],[7,[0,0]]]]]],[0,null,!1,null,9519461130343884,[[76,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,5931174367818359,!1,[[10,0],[8,0],[7,[0,0]]]]],[[76,
cr.plugins_.Sprite.prototype.acts.Destroy,null,4736083544657752,!1],[30,cr.plugins_.Audio.prototype.acts.Play,null,5845081214285174,!1,[[2,["1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[76,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xf2363d6d866b1,!1,[[4,27],[5,[0,0]],[7,[0,0]]]]]],[0,null,!1,null,5757811645378835,[[4,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8106351119949133,!1,[[10,0],[8,3],[7,[0,0]]]]],[[4,cr.plugins_.Sprite.prototype.acts.Spawn,null,5833476407558639,!1,[[4,
26],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,6751076173145749,!1,[[2,["1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[4,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x4e26e64982857,!1],[-1,cr.system_object.prototype.acts.Wait,null,0x45f43b71082c4,!1,[[0,[0,2]]]],[30,cr.plugins_.Audio.prototype.acts.Stop,null,9073006113360100,!1,[[1,[2,"main"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9942896527994144,!1,[[11,"gamespeed"],[7,[0,0]]]],[17,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,
null,0xa27b242c1ee5,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,7766588899085023,!1,[[6,"menu"]]]]],[0,null,!1,null,0xa5c251902999a,[[62,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8409600358760733,!1,[[10,0],[8,3],[7,[0,0]]]]],[[62,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xbd8d564e4aad3,!1,[[4,65],[5,[0,0]],[7,[0,0]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,6607077596119711,!1,[[2,["1",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[62,cr.plugins_.Sprite.prototype.acts.Destroy,
null,6643136176674545,!1],[-1,cr.system_object.prototype.acts.Wait,null,8499611257206524,!1,[[0,[0,2]]]],[30,cr.plugins_.Audio.prototype.acts.Stop,null,9466046586352452,!1,[[1,[2,"main"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6865718548934022,!1,[[11,"gamespeed"],[7,[0,0]]]],[17,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,5717185659872543,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x57241e6ca0b9c,!1,[[6,"menu"]]]]],[0,null,!1,null,7729553395622999,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,9572081283854958,!1,[[11,"Score"],[8,5],[7,[0,500]]]]],[],[[0,null,!1,null,743274657174545,[[-1,cr.system_object.prototype.cnds.TriggerOnce,null,0,!1,!1,!1,9756920139295656,!1]],[[-1,cr.system_object.prototype.acts.AddVar,null,0x6610f208b2189,!1,[[11,"gamespeed"],[7,[0,1]]]]]]]],[0,null,!1,null,9536399805895632,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7123288644391025,!1,[[11,"gamespeed"],[8,0],[7,[0,1]]]]],[],[[0,null,!1,null,0xb37b1fe796fcd,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,6697665352354987,!1,[[0,[1,0.1]]]]],[[94,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xea0df7cdb6a95,!1,[[0,[4,[22,94,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[93,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xc16e7d776ac34,!1,[[0,[4,[22,93,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[95,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x5ac8c89cbfe1a,!1,[[0,[4,[22,95,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x8208c723e6250,!1,[[0,[4,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9799488898616324,!1,[[0,[4,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7962828570398827,!1,[[0,[4,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",8444838158099536,!1,[[0,[4,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x6763a09ba9cdb,!1,[[0,[4,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8120293485981736,!1,[[0,[4,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9078179464892640,
!1,[[0,[4,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xf93810cb1017e,!1,[[0,[4,[22,81,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5344275080344922,!1,[[0,[4,[22,10,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x63d6c63b2a603,!1,[[0,[4,[22,76,"Bullet",
cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,9085501013213982,!1,[[1,[2,"main"]],[0,[0,-15]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xb0db99a28aa01,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5067519800352067,!1,[[11,"gamespeed"],[7,[0,2]]]]]]]],[0,null,!1,null,5603622749941758,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8918643882689051,!1,[[11,"gamespeed"],[8,0],[7,[0,2]]]]],[[94,
cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8775708692048854,!1,[[0,[0,400]]]],[93,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xcb5a6b9a40335,!1,[[0,[0,200]]]],[95,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x50ba75b7df426,!1,[[0,[0,550]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",814046059560383,!1,[[0,[0,400]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x610c5a8792201,!1,[[0,[0,400]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",
7591380124017569,!1,[[0,[0,400]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9319456832199266,!1,[[0,[0,400]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8311005645580242,!1,[[0,[0,400]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xc0ac4dbce5114,!1,[[0,[0,400]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xaaa99871268c5,!1,[[0,[0,400]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xd4016576b0518,!1,[[0,[0,600]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",8392334643978563,!1,[[0,[0,600]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8627447826961617,!1,[[0,[0,600]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7578153869134616,!1,[[11,"gamespeed"],[7,[0,3]]]],[-1,cr.system_object.prototype.acts.Wait,null,7973057984429515,!1,[[0,[0,10]]]]]],[0,null,!1,null,9645494026991212,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xcbf3607509c01,!1,[[11,"gamespeed"],[8,0],[7,[0,3]]]]],[],[[0,null,!1,null,0xe36cc45011652,
[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,754573766868746,!1,[[0,[1,0.1]]]]],[[94,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5074146153931158,!1,[[0,[4,[22,94,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[93,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6877122373181576,!1,[[0,[4,[22,93,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[95,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xb85b633511309,!1,[[0,[4,[22,
95,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8748955217670166,!1,[[0,[4,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6874846930651086,!1,[[0,[4,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5572366924194531,!1,[[0,[4,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5115579489592906,!1,[[0,[4,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xcdd1201c21c8a,!1,[[0,[4,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5740254632987374,!1,[[0,[4,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,
cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5130441001172998,!1,[[0,[4,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7885740706989353,!1,[[0,[4,[22,81,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9894561318304558,!1,[[0,[4,[22,10,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0x4d8a55818ae06,!1,[[0,[4,[22,76,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,551854960177124,!1,[[1,[2,"main"]],[0,[0,-10]]]],[-1,cr.system_object.prototype.acts.Wait,null,6732378827785926,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,555060599225262,!1,[[11,"gamespeed"],[7,[0,4]]]]]]]],[0,null,!1,null,0x866fd856654d3,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,4799857658149534,
!1,[[11,"gamespeed"],[8,0],[7,[0,4]]]]],[[94,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6852297954565942,!1,[[0,[0,500]]]],[93,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x8130390819c13,!1,[[0,[0,300]]]],[95,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6664572381733391,!1,[[0,[0,650]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",665702134822676,!1,[[0,[0,500]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xa35c42371378f,!1,[[0,[0,500]]]],[59,
cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4763148991812816,!1,[[0,[0,500]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5578551219413677,!1,[[0,[0,500]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x5b644587b3589,!1,[[0,[0,500]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9219165985452368,!1,[[0,[0,500]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xfeb4a8c50eabd,!1,[[0,[0,500]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",8862466920873036,!1,[[0,[0,700]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8086057427025668,!1,[[0,[0,700]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6849056419115959,!1,[[0,[0,700]]]],[-1,cr.system_object.prototype.acts.Wait,null,6693367774185202,!1,[[0,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5872495569590404,!1,[[11,"gamespeed"],[7,[0,5]]]]]],[0,null,!1,null,5284990634009149,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,
!1,6193832431546667,!1,[[11,"gamespeed"],[8,0],[7,[0,5]]]]],[],[[0,null,!1,null,0xe0552084254f3,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xdd704c0f2dff1,!1,[[0,[1,0.1]]]]],[[94,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7775732165057427,!1,[[0,[4,[22,94,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[93,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x5605c33c1fd05,!1,[[0,[4,[22,93,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,
4]]]]],[95,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7715026470739186,!1,[[0,[4,[22,95,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x9625027d5f0eb,!1,[[0,[4,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7973258098270348,!1,[[0,[4,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0x8cfa71029ef67,!1,[[0,[4,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x53095bc31fc2e,!1,[[0,[4,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x60d7eebc8f62d,!1,[[0,[4,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",340993404120275,
!1,[[0,[4,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5131514234043798,!1,[[0,[4,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x921af170d82a8,!1,[[0,[4,[22,81,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",854030091693215,!1,[[0,[4,[22,10,"Bullet",
cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8970643690861093,!1,[[0,[4,[22,76,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,5491149924555818,!1,[[1,[2,"main"]],[0,[0,-5]]]],[-1,cr.system_object.prototype.acts.Wait,null,9033455987810088,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,900033660733318,!1,[[11,"gamespeed"],[7,[0,6]]]]]]]],
[0,null,!1,null,0x40adc4ecff4f4,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xf1e35517ee9cd,!1,[[11,"gamespeed"],[8,0],[7,[0,6]]]]],[[94,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8652350146109296,!1,[[0,[0,600]]]],[93,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x8edb2f9cf4445,!1,[[0,[0,400]]]],[95,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xfa7ef500b0183,!1,[[0,[0,750]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4852011612855585,!1,
[[0,[0,600]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9572089125199868,!1,[[0,[0,600]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x549d1054221b7,!1,[[0,[0,600]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x5e2922f7be114,!1,[[0,[0,600]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9642623858472152,!1,[[0,[0,600]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6841101800195488,!1,[[0,[0,600]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0x8563eca12128b,!1,[[0,[0,600]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5754914709355819,!1,[[0,[0,800]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",709318667874613,!1,[[0,[0,800]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8526191771150229,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,6238676502679072,!1,[[0,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9914219481184718,!1,[[11,"gamespeed"],[7,[0,7]]]]]],[0,
null,!1,null,5455797115042206,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5361212174844261,!1,[[11,"gamespeed"],[8,0],[7,[0,7]]]]],[],[[0,null,!1,null,9592410985230088,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,982815732524245,!1,[[0,[1,0.1]]]]],[[94,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5886646158939501,!1,[[0,[4,[22,94,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[93,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6311530439611702,
!1,[[0,[4,[22,93,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[95,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xb984906dcc187,!1,[[0,[4,[22,95,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7919100810511626,!1,[[0,[4,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x438cc8da352e5,!1,[[0,[4,[22,58,"Bullet",
cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7581293431014876,!1,[[0,[4,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x8660968f804b1,!1,[[0,[4,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",311621895828921,!1,[[0,[4,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",919239972828818,!1,[[0,[4,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7732663383020193,!1,[[0,[4,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8757384062376842,!1,[[0,[4,[22,81,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[10,
cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5297189646460198,!1,[[0,[4,[22,10,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8160829244257265,!1,[[0,[4,[22,76,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,0xa19f00256a46d,!1,[[1,[2,"main"]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,7252565863501193,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,8254939808819206,!1,[[11,"gamespeed"],[7,[0,8]]]]]]]],[0,null,!1,null,6456189611382592,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5234212858365619,!1,[[11,"gamespeed"],[8,0],[7,[0,8]]]]],[[94,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4504270672379303,!1,[[0,[0,700]]]],[93,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8768508962435667,!1,[[0,[0,500]]]],[95,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xb72f62118040e,!1,[[0,[0,850]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",9844527133991608,!1,[[0,[0,700]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7753766118463538,!1,[[0,[0,700]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8811963297903743,!1,[[0,[0,700]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5511006739065153,!1,[[0,[0,700]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6516462892604847,!1,[[0,[0,700]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9398133951774132,!1,[[0,[0,700]]]],
[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xb5d299c02b526,!1,[[0,[0,700]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6587924462170426,!1,[[0,[0,900]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5642542355194634,!1,[[0,[0,900]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",385366300043602,!1,[[0,[0,900]]]],[-1,cr.system_object.prototype.acts.Wait,null,8878700079551064,!1,[[0,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8042392124977221,
!1,[[11,"gamespeed"],[7,[0,9]]]]]],[0,null,!1,null,0x65a745f68f592,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x9518857857eae,!1,[[11,"gamespeed"],[8,0],[7,[0,9]]]]],[],[[0,null,!1,null,0x571684dee6677,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,4809773781645516,!1,[[0,[1,0.1]]]]],[[94,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7064586255365618,!1,[[0,[5,[22,94,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[93,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",6239293446040884,!1,[[0,[5,[22,93,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[95,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x5e64688c64005,!1,[[0,[5,[22,95,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8212477353420322,!1,[[0,[5,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xbefc82c929c2,
!1,[[0,[5,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8983822976930722,!1,[[0,[5,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9455290064940692,!1,[[0,[5,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6597065047622277,!1,[[0,[5,[22,61,"Bullet",
cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",859434330873696,!1,[[0,[5,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9898274030530546,!1,[[0,[5,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4792977008033812,!1,[[0,[5,[22,81,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x758e7f96d5054,!1,[[0,[5,[22,10,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x995b1bf4e6dae,!1,[[0,[5,[22,76,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,6242659341775316,!1,[[1,[2,"main"]],[0,[0,-5]]]],[-1,cr.system_object.prototype.acts.Wait,null,4507090803371778,
!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x67e8c0aeb7d41,!1,[[11,"gamespeed"],[7,[0,10]]]]]]]],[0,null,!1,null,0xa60969a378929,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,697602289712328,!1,[[11,"gamespeed"],[8,0],[7,[0,10]]]]],[[94,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9850596176348942,!1,[[0,[0,600]]]],[93,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x9f57714c0f355,!1,[[0,[0,400]]]],[95,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",6888971346160729,!1,[[0,[0,750]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5328069969740789,!1,[[0,[0,600]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4873186947994698,!1,[[0,[0,600]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9613129792929340,!1,[[0,[0,600]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9277485133280656,!1,[[0,[0,600]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5200492669259582,!1,[[0,[0,600]]]],
[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x693776a9ef9cd,!1,[[0,[0,600]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5478898882569239,!1,[[0,[0,600]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xbaa5945cd3a47,!1,[[0,[0,800]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5675967941788525,!1,[[0,[0,800]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xaddc933a86dd1,!1,[[0,[0,800]]]],[-1,cr.system_object.prototype.acts.Wait,null,
9617143650785772,!1,[[0,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8120855453180637,!1,[[11,"gamespeed"],[7,[0,11]]]]]],[0,null,!1,null,0x95cda7f056f81,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9070941105576548,!1,[[11,"gamespeed"],[8,0],[7,[0,11]]]]],[],[[0,null,!1,null,0xe6e448e33709a,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x7198eb09025b3,!1,[[0,[1,0.1]]]]],[[94,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",774963389154192,!1,[[0,[5,
[22,94,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[93,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9657466592834274,!1,[[0,[5,[22,93,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[95,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7524717444344317,!1,[[0,[5,[22,95,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7922029373508097,!1,[[0,[5,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7872977001079417,!1,[[0,[5,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9864442909312472,!1,[[0,[5,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xbcf95dd84c06b,!1,[[0,[5,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,
cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6942528905153661,!1,[[0,[5,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",781267829477866,!1,[[0,[5,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6685280013552698,!1,[[0,[5,[22,14,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",0x6538adf55c261,!1,[[0,[5,[22,81,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8275666446447935,!1,[[0,[5,[22,10,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7055965692555089,!1,[[0,[5,[22,76,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,0x7e832f430bf48,!1,
[[1,[2,"main"]],[0,[0,-10]]]],[-1,cr.system_object.prototype.acts.Wait,null,7655514837047874,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x86f48d5d81457,!1,[[11,"gamespeed"],[7,[0,12]]]]]]]],[0,null,!1,null,0xe9f6579789e76,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x68af9b286cebf,!1,[[11,"gamespeed"],[8,0],[7,[0,12]]]]],[[94,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8106991025508194,!1,[[0,[0,500]]]],[93,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",8628213293742262,!1,[[0,[0,300]]]],[95,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xad61ac208ef37,!1,[[0,[0,650]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7374100491379548,!1,[[0,[0,500]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7031144079094007,!1,[[0,[0,500]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7945326372983891,!1,[[0,[0,500]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",625944979183443,!1,[[0,[0,500]]]],
[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xa3335fb360257,!1,[[0,[0,500]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5889793235711611,!1,[[0,[0,500]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5165708663597216,!1,[[0,[0,500]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6371170376660886,!1,[[0,[0,700]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x5e8ee34192a5d,!1,[[0,[0,700]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",295912854459403,!1,[[0,[0,700]]]],[-1,cr.system_object.prototype.acts.Wait,null,7406383089087345,!1,[[0,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8847318438135602,!1,[[11,"gamespeed"],[7,[0,13]]]]]],[0,null,!1,null,6127705324397071,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xbafc217ce88a2,!1,[[11,"gamespeed"],[8,0],[7,[0,13]]]]],[],[[0,null,!1,null,6609345230649313,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,8676797644910011,!1,[[0,[1,
0.1]]]]],[[94,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4629420704013548,!1,[[0,[5,[22,94,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[93,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",7787199177219074,!1,[[0,[5,[22,93,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[95,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",8533141793649464,!1,[[0,[5,[22,95,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[6,cr.behaviors.Bullet.prototype.acts.SetSpeed,
"Bullet",7026257694784256,!1,[[0,[5,[22,6,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[58,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xe1bab491e8f6b,!1,[[0,[5,[22,58,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[59,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",6455429074975099,!1,[[0,[5,[22,59,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[60,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9163888947954652,
!1,[[0,[5,[22,60,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[61,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",4934643206588792,!1,[[0,[5,[22,61,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[11,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",5447707873446667,!1,[[0,[5,[22,11,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[14,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xb69852a0d5c09,!1,[[0,[5,[22,14,"Bullet",
cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[81,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",9632049537866388,!1,[[0,[5,[22,81,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[10,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0xd17d68afcc322,!1,[[0,[5,[22,10,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,!1,null],[0,4]]]]],[76,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",0x60b7d6f2d5bee,!1,[[0,[5,[22,76,"Bullet",cr.behaviors.Bullet.prototype.exps.Speed,
!1,null],[0,4]]]]],[30,cr.plugins_.Audio.prototype.acts.SetVolume,null,4925282417436958,!1,[[1,[2,"main"]],[0,[0,-15]]]],[-1,cr.system_object.prototype.acts.Wait,null,9065530935229176,!1,[[0,[1,2.5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9019871196874116,!1,[[11,"gamespeed"],[7,[0,2]]]]]]]],[0,null,!1,null,6006634524104793,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,311774011155781,!1,[[11,"Score"],[8,5],[7,[0,2E4]]]]],[],[[0,null,!1,null,832614014423244,[[62,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!1,!1,7735495745148717,!1]],[[62,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0x8a188cf816052,!1,[[3,1]]],[62,cr.plugins_.Sprite.prototype.acts.AddInstanceVar,null,771984329808174,!1,[[10,0],[7,[0,100]]]],[81,cr.plugins_.Sprite.prototype.acts.Destroy,null,6126865864133079,!1],[10,cr.plugins_.Sprite.prototype.acts.Destroy,null,4673885160146617,!1],[76,cr.plugins_.Sprite.prototype.acts.Destroy,null,8050900579536523,!1],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,5196985609910731,
!1,[[3,0]]],[55,cr.plugins_.Sprite.prototype.acts.Destroy,null,9714108435885772,!1],[-1,cr.system_object.prototype.acts.Wait,null,6341795333119929,!1,[[0,[0,2]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,5508772132801733,!1,[[2,["click4",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[66,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",9555144986899320,!1,[[3,0]]],[67,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0x5073bd8fef7f1,!1,[[3,0]]],[68,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,
"LiteTween",0x8aa44c966a1e8,!1,[[3,0]]],[69,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0x9dcd4090f5555,!1,[[3,0]]],[70,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",6796083194573305,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,8628495163976949,!1,[[0,[1,0.7]]]],[66,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0x8a81c5568f5bc,!1,[[3,1]]],[67,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",9647153135638848,!1,
[[3,1]]],[68,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0x879e736b7d4d7,!1,[[3,1]]],[69,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0xca07d88199dd3,!1,[[3,1]]],[70,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",8342555923583316,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetVar,null,5433679774571908,!1,[[11,"gamepause"],[7,[0,1]]]]]]]],[0,null,!1,null,9584889208612616,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xae4a3eeede751,
!1,[[11,"Score"],[8,5],[7,[0,2E4]]]]],[],[[0,null,!1,null,9447109149384096,[[4,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,9726412709258094,!1]],[[4,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",6017865606002446,!1,[[3,1]]],[4,cr.plugins_.Sprite.prototype.acts.AddInstanceVar,null,0x8291aef678f2f,!1,[[10,0],[7,[0,100]]]],[81,cr.plugins_.Sprite.prototype.acts.Destroy,null,386340486170003,!1],[10,cr.plugins_.Sprite.prototype.acts.Destroy,null,79385459932946,!1],[76,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0x440b4f8f52987,!1],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,7629431891171564,!1,[[3,0]]],[55,cr.plugins_.Sprite.prototype.acts.Destroy,null,8844089232538244,!1],[-1,cr.system_object.prototype.acts.Wait,null,9160403899011848,!1,[[0,[0,2]]]],[30,cr.plugins_.Audio.prototype.acts.Play,null,7676251745368956,!1,[[2,["click4",!1]],[3,0],[0,[0,0]],[1,[2,""]]]],[66,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",8572394852188706,!1,[[3,0]]],[67,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,
"LiteTween",6392027922686877,!1,[[3,0]]],[68,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",5895411329646523,!1,[[3,0]]],[69,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",8884737702908401,!1,[[3,0]]],[70,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",4601268963673412,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,9795320699830348,!1,[[0,[1,0.7]]]],[66,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",4880494748530043,
!1,[[3,1]]],[67,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",818958081983827,!1,[[3,1]]],[68,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",5837070597743833,!1,[[3,1]]],[69,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",0xa6e4c5b0bb028,!1,[[3,1]]],[70,cr.behaviors.lunarray_LiteTween.prototype.acts.Start,"LiteTween",8883779112058102,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetVar,null,8903880916766092,!1,[[11,"gamepause"],[7,[0,1]]]]]]]],
[0,null,!1,null,5526946794399906,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7355831984621568,!1,[[11,"gamepause"],[8,0],[7,[0,1]]]]],[[30,cr.plugins_.Audio.prototype.acts.Stop,null,9528112258762708,!1,[[1,[2,"main"]]]],[94,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",5381100024566095,!1,[[3,0]]],[93,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0x456d02d0321ae,!1,[[3,0]]],[95,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",9496133307384412,!1,[[3,0]]],
[6,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",8981919036489941,!1,[[3,0]]],[58,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",6008111399337186,!1,[[3,0]]],[59,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0xdf2e07af7d803,!1,[[3,0]]],[60,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",9095712900168476,!1,[[3,0]]],[61,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0xb14c75dff9e51,!1,[[3,0]]],[14,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0xb760486df4822,
!1,[[3,0]]],[11,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",9593136080119764,!1,[[3,0]]],[74,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0xf954345ef4c9c,!1,[[3,0]]],[75,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",7784534875993553,!1,[[3,0]]],[76,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",9893639309739360,!1,[[3,0]]],[81,cr.plugins_.Sprite.prototype.acts.Destroy,null,7540526846440521,!1],[10,cr.plugins_.Sprite.prototype.acts.Destroy,null,8399380650343823,
!1],[76,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xd273a38377c3e,!1],[14,cr.plugins_.Sprite.prototype.acts.Destroy,null,423674111671564,!1],[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,523589620839073,!1]]],[0,null,!1,null,0xc2529ec8ff76f,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x68b2172c8f397,!1,[[4,67]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,5353731887266795,!1,[[11,"levels"],[7,[0,1]]]],[17,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,
6252365621448183,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x613c001666902,!1,[[6,"menu"]]]]],[0,null,!1,null,9825646251433928,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7972574626706515,!1,[[4,68]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,null,5148103488857594,!1]]],[0,null,!1,null,9171558066909464,[[69,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,9545355824275140,!1]],[],[[1,"url3",1,"https://www.twitter.com/intent/tweet?text= Completed Another Level of Shoot Angry Zombies. Try this Awesome Game bit.ly/1KyXW9c",
!1,!1,0x9f58de434d8df,!1],[0,null,!1,null,0xfcf38bda2c369,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,660370404352705,!1,[[4,69]]]],[[25,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,314809827236692,!1,[[1,[23,"url3"]],[1,[2,"twitter"]]]]]]]],[0,null,!1,null,6222690685704046,[[70,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x55f2a3ab5cd5f,!1]],[],[[1,"url4",1,"https://www.facebook.com/sharer/sharer.php?u=http://online-free-stuff.com/saz/share.php",!1,
!1,327508921479877,!1],[0,null,!1,null,8053295661186515,[[1,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,4627301236312354,!1,[[4,70]]]],[[25,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,9341715870047016,!1,[[1,[23,"url4"]],[1,[2,"facebook"]]]]]]]],[0,null,!1,null,0xac3142ca0b2a,[[27,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,6979019045937443,!1]],[[27,cr.plugins_.Sprite.prototype.acts.Destroy,null,9962297101859792,!1]]],[0,null,!1,null,8697350015911933,
[[87,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,0xfa08e09138ad8,!1]],[[87,cr.plugins_.Sprite.prototype.acts.Destroy,null,8194570157421522,!1]]],[0,null,!1,null,6082193987202633,[[88,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,0x62b057404cf1e,!1]],[[88,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x79fcb1c45db3f,!1]]],[0,null,!1,null,0xdd02f77cab2f0,[[91,cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,null,1,!1,!1,!1,7725623359679351,!1]],[[91,
cr.plugins_.Sprite.prototype.acts.Destroy,null,0x99617d5a0f56f,!1]]]]]],[["new3.ogg",38548],["1.ogg",17133],["2.ogg",38289],["3.ogg",38037],["touch1.ogg",20279],["click4.ogg",24658],["game-shoot.ogg",437223]],"",!1,1260,720,4,!0,!0,!1,"1.0",!0,!1,0,0,215,!0,!0,1,!0,[]]};

createCocoonJSRuntime();

})();
